import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import styled, { css } from 'styled-components';
import { StyledButton, StyledLink } from '../Button/styled';
export var StyledAlert = styled.div.withConfig({
  displayName: "StyledAlert"
})(["", ""], function (props) {
  var $type = props.$type,
      $hasTitle = props.$hasTitle,
      $hasDesc = props.$hasDesc,
      $showIcon = props.$showIcon,
      $showClose = props.$showClose,
      $size = props.$size,
      $center = props.$center,
      theme = props.theme;
  var _theme$components$Ale = theme.components.Alert,
      typeBg = _theme$components$Ale.typeBg,
      typeBorder = _theme$components$Ale.typeBorder,
      borderRadius = _theme$components$Ale.borderRadius,
      padding = _theme$components$Ale.padding,
      hasIconPaddingLeft = _theme$components$Ale.hasIconPaddingLeft,
      hasIconAndDescPaddingLeft = _theme$components$Ale.hasIconAndDescPaddingLeft,
      hasCloseIconPaddingRight = _theme$components$Ale.hasCloseIconPaddingRight,
      hasTitleAndDescPaddingVertical = _theme$components$Ale.hasTitleAndDescPaddingVertical;

  var _padding$$size = _slicedToArray(padding[$size], 4),
      top = _padding$$size[0],
      right = _padding$$size[1],
      bottom = _padding$$size[2],
      left = _padding$$size[3];

  if ($showIcon) {
    left = $hasDesc ? hasIconAndDescPaddingLeft[$size] : hasIconPaddingLeft[$size];
  }

  if ($showClose) {
    right = hasCloseIconPaddingRight[$size];
  }

  if ($hasTitle && $hasDesc) {
    top = hasTitleAndDescPaddingVertical[$size];
    bottom = hasTitleAndDescPaddingVertical[$size];
  }

  return css(["position:relative;box-sizing:border-box;background-color:", ";border:", ";border-radius:", ";& ", ",& ", "{vertical-align:unset;}", "{padding:", "px ", "px ", "px ", "px;", ";}"], typeBg[$type], typeBorder[$type], borderRadius, StyledButton, StyledLink, StyledAlertContainer, top, right, bottom, left, $center && "width: fit-content");
});
export var StyledAlertContainer = styled.div.withConfig({
  displayName: "StyledAlertContainer"
})(["position:relative;margin:0 auto;"]);
export var StyledIcon = styled.div.withConfig({
  displayName: "StyledIcon"
})(["", ""], function (props) {
  var $type = props.$type,
      theme = props.theme,
      $hasTitleAndDesc = props.$hasTitleAndDesc,
      $size = props.$size;
  var _theme$components$Ale2 = theme.components.Alert.icon,
      iconLeft = _theme$components$Ale2.left,
      hasTitleAndDescLeft = _theme$components$Ale2.hasTitleAndDescLeft,
      iconTop = _theme$components$Ale2.top,
      hasTitleAndDescTop = _theme$components$Ale2.hasTitleAndDescTop;
  var left = $hasTitleAndDesc ? hasTitleAndDescLeft[$size] : iconLeft[$size];
  var top = $hasTitleAndDesc ? hasTitleAndDescTop[$size] : iconTop[$size];
  return css(["position:absolute;left:", "px;top:", "px;color:", ";font-size:0;line-height:1;"], left, top, theme.colors.pattern.feature[$type]);
});
export var StyledClose = styled.div.withConfig({
  displayName: "StyledClose"
})(["", ""], function (props) {
  var theme = props.theme,
      $hasTitleAndDesc = props.$hasTitleAndDesc,
      $size = props.$size,
      $type = props.$type;
  var _theme$components$Ale3 = theme.components.Alert,
      closeIconTop = _theme$components$Ale3.closeIconTop,
      closeIconRight = _theme$components$Ale3.closeIconRight,
      hasTitleAndDescCloseIconTop = _theme$components$Ale3.hasTitleAndDescCloseIconTop,
      closeIconColorFromType = _theme$components$Ale3.closeIconColorFromType;
  var finalTop = closeIconTop[$size];

  if ($hasTitleAndDesc) {
    finalTop = hasTitleAndDescCloseIconTop[$size];
  }

  return css(["position:absolute;right:", "px;top:", "px;line-height:0;", ""], closeIconRight[$size], finalTop, closeIconColorFromType && css(["", "{color:", ";}"], StyledButton, theme.colors.pattern.feature[$type]));
});
export var StyledTitle = styled.div.withConfig({
  displayName: "StyledTitle"
})(["", ""], function (props) {
  var theme = props.theme,
      $size = props.$size,
      $hasDesc = props.$hasDesc,
      $type = props.$type;
  var colors = theme.colors,
      fontWeight = theme.typography.spec.fontWeight;
  var _theme$components$Ale4 = theme.components.Alert.title,
      fontSize = _theme$components$Ale4.fontSize,
      lineHeight = _theme$components$Ale4.lineHeight,
      textFine = _theme$components$Ale4.textFine,
      hasDescTextFine = _theme$components$Ale4.hasDescTextFine,
      hasDescFontSize = _theme$components$Ale4.hasDescFontSize,
      hasDescLineHeight = _theme$components$Ale4.hasDescLineHeight,
      hasDescMarginBottom = _theme$components$Ale4.hasDescMarginBottom,
      typeColor = _theme$components$Ale4.typeColor;
  var finalTextFine = $hasDesc ? hasDescTextFine : textFine;
  var finalFontSize = $hasDesc ? hasDescFontSize : fontSize[$size];
  var finalLineHeight = $hasDesc ? hasDescLineHeight : lineHeight[$size];
  var finalMarginBottom = $hasDesc ? hasDescMarginBottom : 0;
  return css(["color:", ";font-size:", "px;line-height:", "px;font-weight:", ";margin-bottom:", "px;"], typeColor && typeColor[$type] || colors.pattern.text.title, finalFontSize, finalLineHeight, finalTextFine ? fontWeight.regular : fontWeight.semibold, finalMarginBottom);
});
export var StyledDesc = styled.span.withConfig({
  displayName: "StyledDesc"
})(["", ""], function (props) {
  var theme = props.theme,
      $type = props.$type;
  var colors = theme.colors;
  var _theme$components$Ale5 = theme.components.Alert.desc,
      fontSize = _theme$components$Ale5.fontSize,
      lineHeight = _theme$components$Ale5.lineHeight,
      typeColor = _theme$components$Ale5.typeColor;
  return css(["color:", ";font-size:", "px;line-height:", "px;"], typeColor && typeColor[$type] || colors.pattern.text.text, fontSize, lineHeight);
});