import _extends from "@babel/runtime/helpers/extends";
import React, { useMemo } from 'react';
import styled, { css } from 'styled-components';
import Tabs from '../Tabs';
import memoForwardRef from '../utils/memoForwardRef';
import mergeStyleItem from '../utils/mergeStyleItem';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import { useAnchorContext } from './context';
var LineIndicator = styled.div.withConfig({
  displayName: "LineIndicator"
})(["", ""], function (props) {
  var theme = props.theme,
      $height = props.$height,
      $top = props.$top;
  var token = theme.components.Tabs;
  var indicator = token.indicator;
  var _theme$transition$pat = theme.transition.pattern,
      duration = _theme$transition$pat.duration,
      easing = _theme$transition$pat.easing;
  return css(["position:absolute;left:0;top:0;bottom:0;height:100%;width:", "px;background:", ";z-index:2;&::before{content:'';display:block;position:absolute;left:0;width:", "px;top:", "px;height:", "px;background:", ";transition:all ", "ms ", ";}"], indicator.bgHeight, indicator.bgColor, indicator.activeHeight, $top, $height, indicator.activeColor, duration.status, easing.status);
});
var StyledVerticalTabs = styled.div.withConfig({
  displayName: "StyledVerticalTabs"
})(["position:relative;"]);
var defaultStyles = {
  wrapper: '',
  indicator: ''
};
export default memoForwardRef(function (props, ref) {
  var _useAnchorContext = useAnchorContext(),
      activeLink = _useAnchorContext.activeLink,
      direction = _useAnchorContext.direction,
      indicatorHeight = _useAnchorContext.indicatorHeight,
      indicatorTop = _useAnchorContext.indicatorTop;

  var theme = useTheme();
  var id = props.id,
      style = props.style,
      className = props.className,
      children = props.children,
      styles = props.styles;
  var innerStyles = useStyles('anchor-tabs', defaultStyles, styles);
  var wrapperStyleItem = useMemo(function () {
    return mergeStyleItem({
      className: className,
      style: style
    }, innerStyles.wrapper);
  }, [className, innerStyles.wrapper, style]);

  if (direction === 'vertical') {
    return /*#__PURE__*/React.createElement(StyledVerticalTabs, _extends({
      theme: theme,
      ref: ref
    }, wrapperStyleItem, {
      id: id
    }), children, /*#__PURE__*/React.createElement(LineIndicator, _extends({
      $top: indicatorTop,
      $height: indicatorHeight,
      theme: theme
    }, innerStyles.indicator)));
  }

  return /*#__PURE__*/React.createElement(Tabs, _extends({
    ref: ref,
    index: activeLink || ''
  }, props));
});