import _extends from "@babel/runtime/helpers/extends";
import { useForkRef as _useForkRef } from "@muya-ui/utils/es/hooks/useForkRef";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "makeStyles", "timeout", "easing", "style", "beforeEnter", "beforeExit"];
import React, { useCallback, useMemo } from 'react';
import Transition from 'react-transition-group/Transition';
import memoForwardRef from '../utils/memoForwardRef';
import useTheme from '../utils/useTheme';
// TODO: fix Transition function child props 透传问题
var BaseAnimation = memoForwardRef(function (props, ref) {
  var children = props.children,
      makeStyles = props.makeStyles,
      timeout = props.timeout,
      easing = props.easing,
      style = props.style,
      beforeEnter = props.beforeEnter,
      beforeExit = props.beforeExit,
      other = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  var timeoutWithDefault = timeout || theme.transition.spec.duration.normal;

  var handleRef = _useForkRef(children.ref, ref);

  var makeStyleProps = useMemo(function () {
    return {
      theme: theme,
      style: style,
      easing: easing,
      timeout: timeoutWithDefault
    };
  }, [easing, style, theme, timeoutWithDefault]);
  var onEnter = useCallback(function (node, isAppearing) {
    if (beforeEnter) {
      beforeEnter(node, makeStyleProps);
    }

    if (props.onEnter) {
      props.onEnter(node, isAppearing);
    }
  }, [beforeEnter, makeStyleProps, props]);
  var onExit = useCallback(function (node) {
    if (beforeExit) {
      beforeExit(node, makeStyleProps);
    }

    if (props.onExit) {
      props.onExit(node);
    }
  }, [beforeExit, makeStyleProps, props]);
  return /*#__PURE__*/React.createElement(Transition, _extends({
    appear: true
  }, other, {
    style: style,
    timeout: timeoutWithDefault,
    onEnter: onEnter,
    onExit: onExit
  }), function (state) {
    return /*#__PURE__*/React.cloneElement(children, _extends({}, children.props, {
      style: _extends({}, makeStyles(state, makeStyleProps), children.props.style),
      ref: handleRef
    }));
  });
});
export default BaseAnimation;