import _extends from "@babel/runtime/helpers/extends";
import reflow from '../utils/reflow';
import { withAnimation } from './withAnimation';

function makeStyles(state, props) {
  var transitionPattern = props.theme.transition.pattern,
      timeout = props.timeout,
      easing = props.easing;
  var defaultStyle = {
    opacity: 0,
    transitionProperty: 'opacity',
    transitionTimingFunction: easing || transitionPattern.easing.status,
    transitionDuration: "".concat(timeout, "ms")
  };
  var transitionStyles = {
    entering: {
      transitionTimingFunction: easing || transitionPattern.easing.enter,
      opacity: 1
    },
    entered: {
      opacity: 1
    },
    exiting: {
      transitionTimingFunction: easing || transitionPattern.easing.leave,
      opacity: 0
    },
    exited: {
      opacity: 0,
      visibility: 'hidden'
    }
  };
  return _extends({}, defaultStyle, transitionStyles[state]);
}

var beforeEnter = function beforeEnter(node) {
  reflow(node);
};

export default withAnimation(makeStyles, {
  beforeEnter: beforeEnter
});