import _typeof from "@babel/runtime/helpers/typeof";
import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["dataSource", "children", "size", "backfill", "filterOption", "defaultActiveFirstOption", "placeholder", "styles", "className", "style"];
import React, { useCallback, useMemo } from 'react';
import Input from '../Input';
import useLocale from '../Locale/useLocale';
import { Option, OptionDivider, OptionGroup, Select } from '../Select';
import { isSelectChildNode } from '../Select/utils';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import AutoCompleteItem from './AutoCompleteItem';
import InputElement from './InputElement';
var selectIconNode = /*#__PURE__*/React.createElement(React.Fragment, null);
var defaultStyles = {
  inputWrapper: 'inputWrapper'
};
var AutoComplete = memoForwardRef(function (props, ref) {
  var local = useLocale();

  var dataSource = props.dataSource,
      children = props.children,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      _props$backfill = props.backfill,
      backfill = _props$backfill === void 0 ? false : _props$backfill,
      _props$filterOption = props.filterOption,
      filterOption = _props$filterOption === void 0 ? true : _props$filterOption,
      _props$defaultActiveF = props.defaultActiveFirstOption,
      defaultActiveFirstOption = _props$defaultActiveF === void 0 ? true : _props$defaultActiveF,
      _props$placeholder = props.placeholder,
      placeholder = _props$placeholder === void 0 ? local['AutoComplete.placeholder'] : _props$placeholder,
      styles = props.styles,
      className = props.className,
      style = props.style,
      restProps = _objectWithoutProperties(props, _excluded);

  var innerStyles = useStyles('auto-complete', defaultStyles, styles);
  var getInputElement = useCallback(function () {
    var element = children && /*#__PURE__*/React.isValidElement(children) && children.type !== Option ? React.Children.only(children) : /*#__PURE__*/React.createElement(Input, null);

    var elementProps = _extends({}, element.props);

    delete elementProps.children;
    return /*#__PURE__*/React.createElement(InputElement, elementProps, element);
  }, [children]);
  var options = useMemo(function () {
    var childArray = React.Children.toArray(children);

    if (childArray.length && isSelectChildNode(childArray[0])) {
      return children;
    } else {
      return dataSource ? dataSource.map(function (item) {
        switch (_typeof(item)) {
          case 'string':
            return /*#__PURE__*/React.createElement(Option, {
              key: item,
              value: item
            }, item);

          case 'object':
            return /*#__PURE__*/React.createElement(Option, {
              key: item.value,
              value: item.value
            }, item.label);

          default:
            throw new Error('AutoComplete[dataSource] only supports type `string[] | Object[]`.');
        }
      }) : [];
    }
  }, [children, dataSource]);
  return /*#__PURE__*/React.createElement(Select, _extends({}, restProps, {
    className: [innerStyles.inputWrapper.className, className].join(' ').trim(),
    style: _extends({}, innerStyles.inputWrapper.style, style),
    size: size,
    backfill: backfill,
    filterOption: filterOption,
    defaultActiveFirstOption: defaultActiveFirstOption,
    placeholder: placeholder,
    ref: ref,
    mode: "default",
    showSearch: true,
    labelInValue: false,
    reservedSearchResult: false,
    hideExpandIcon: true,
    selectedIcon: selectIconNode,
    getInputElement: getInputElement,
    combobox: true
  }), options);
});
AutoComplete.__MUYA_AUTOCOMPLETE = true;
AutoComplete.Option = Option;
AutoComplete.OptionDivider = OptionDivider;
AutoComplete.OptionGroup = OptionGroup;
AutoComplete.Item = AutoCompleteItem;
export default AutoComplete;