import _extends from "@babel/runtime/helpers/extends";
import { devWarning as _devWarning } from "@muya-ui/utils/es/utils/devWarning";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import { colorUtils as _colorUtils } from "@muya-ui/theme-light/es/utils";
var _excluded = ["type", "component", "display", "backgroundColor", "width", "height", "color", "borderRadius"];
import React from 'react';
import styled, { css } from 'styled-components';
import addPx from '../utils/addPx';
import memoForwardRef from '../utils/memoForwardRef';
import useTheme from '../utils/useTheme';

function baseCSS(_ref) {
  var $display = _ref.$display,
      $width = _ref.$width,
      $backgroundColor = _ref.$backgroundColor,
      $color = _ref.$color,
      $height = _ref.$height,
      _ref$$type = _ref.$type,
      $type = _ref$$type === void 0 ? 'global' : _ref$$type,
      $borderRadius = _ref.$borderRadius,
      theme = _ref.theme;
  var backgroundColor;

  if ($backgroundColor) {
    backgroundColor = $backgroundColor;
  } else {
    if ($type === 'mask') {
      backgroundColor = _colorUtils.transparentize(theme.opacity.pattern.mask, theme.colors.pattern.background.mask);
    } else {
      backgroundColor = theme.colors.pattern.background[$type];
    }
  }

  var color = $color || theme.colors.pattern.text.text;
  return css({
    display: $display,
    backgroundColor: backgroundColor,
    color: color,
    width: addPx($width),
    height: addPx($height),
    borderRadius: addPx($borderRadius)
  });
}

var RootDiv = styled.div.withConfig({
  displayName: "RootDiv"
})(["", ""], baseCSS);
var RootSpan = styled.div.withConfig({
  displayName: "RootSpan"
})(["", ""], baseCSS);
var Background = memoForwardRef(function (props, ref) {
  var type = props.type,
      component = props.component,
      display = props.display,
      backgroundColor = props.backgroundColor,
      width = props.width,
      height = props.height,
      color = props.color,
      borderRadius = props.borderRadius,
      other = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  var Root = component === 'span' ? RootSpan : RootDiv;

  _devWarning('[Background]: type scrollBar and scrollBarHover is deprecated, will removed in 1.0.0', type === 'scrollBar' || type === 'scrollBarHover');

  return /*#__PURE__*/React.createElement(Root, _extends({}, other, {
    $type: type,
    $color: color,
    $display: display,
    $width: width,
    $height: height,
    $backgroundColor: backgroundColor,
    $borderRadius: borderRadius,
    theme: theme,
    ref: ref
  }));
});
export default Background;