import styled, { css } from 'styled-components';
import { StyledCheckboxLabel } from '../Checkbox/styled';
import { scrollBarStyle } from '../ScrollView/styled';
import ellipsisStyle from '../styled/mixins/ellipsis';
import { itemDisabledStyle, itemNormalStyle, itemSelectedStyle } from '../styled/mixins/item';
export var menuItemCss = function menuItemCss(props) {
  var $size = props.$size,
      $active = props.$active,
      $selected = props.$selected,
      $disabled = props.$disabled,
      $checkable = props.$checkable,
      _props$theme = props.theme,
      spacing = _props$theme.spacing,
      _props$theme$transiti = _props$theme.transition.pattern,
      duration = _props$theme$transiti.duration,
      easing = _props$theme$transiti.easing;
  var token = props.theme.components.BaseMenu.item;
  return css(["display:flex;justify-content:", ";align-items:center;flex:1;box-sizing:border-box;padding:0 ", "px;font-size:", "px;line-height:", "px;height:", "px;cursor:pointer;transition:background-color ", "ms ", ",color ", "ms ", ";", " span{", "}", "{margin-right:", "px;}", " ", " ", ""], $checkable ? 'flex-start' : 'space-between', token.paddingHorizontal, token.fontSize[$size], token.height[$size], token.height[$size], duration.status, easing.status, duration.status, easing.status, itemNormalStyle(token), ellipsisStyle, StyledCheckboxLabel, spacing.spec.s4, $active && css(["color:", ";background-color:", ";&:hover{color:", ";background-color:", ";}&:active{color:", ";background-color:", ";}"], token.color.hover, token.background.hover, token.color.hover, token.background.hover, token.color.hover, token.background.hover), $selected && itemSelectedStyle(token), $disabled && itemDisabledStyle(token));
};
export var StyledBaseMenuItem = styled.div.withConfig({
  displayName: "StyledBaseMenuItem"
})(["", ";"], menuItemCss);
export var StyledBaseMenuItemGroupLabel = styled.span.withConfig({
  displayName: "StyledBaseMenuItemGroupLabel"
})(["display:flex;justify-content:space-between;align-items:center;box-sizing:border-box;cursor:default;"]);
export var StyledBaseMenuItemGroup = styled.div.withConfig({
  displayName: "StyledBaseMenuItemGroup"
})([""]);
export var StyledBaseMenuItemDivider = styled.div.withConfig({
  displayName: "StyledBaseMenuItemDivider"
})(["height:1px;"]);
export var StyledBaseMenuWrapper = styled.div.withConfig({
  displayName: "StyledBaseMenuWrapper"
})(["overflow-y:auto;"]);
export var baseMenuCss = function baseMenuCss(props) {
  var $size = props.$size,
      $width = props.$width,
      $hasScrollBar = props.$hasScrollBar,
      $maxItemCountPerPage = props.$maxItemCountPerPage,
      $noShadow = props.$noShadow,
      _props$theme2 = props.theme,
      colors = _props$theme2.colors,
      shadows = _props$theme2.shadows;
  var token = props.theme.components.BaseMenu;
  var wrapperToken = token.wrapper,
      itemToken = token.item,
      dividerToken = token.divider,
      groupToken = token.group;
  return css(["background:", ";border-radius:", ";padding:", "px 0;overflow:hidden;", ";", ";", ";:focus{outline:none;}", "{", ";", "}", "{background:", ";margin:", "px ", "px ", "px ", "px;}", "{font-size:", "px;line-height:", "px;height:", "px;background:", ";color:", ";padding-left:", "px;margin-top:", "px;}"], colors.pattern.background.higher, wrapperToken.borderRadius, wrapperToken.paddingVertical, !$noShadow && "box-shadow: ".concat(shadows.pattern.popper.normal), $width && "width: ".concat($width, "px"), $hasScrollBar && "padding-right: ".concat(wrapperToken.paddingRight, "px"), StyledBaseMenuWrapper, $maxItemCountPerPage && "max-height: ".concat($maxItemCountPerPage * itemToken.height[$size], "px"), $hasScrollBar && css(["padding-right:", "px;", ";"], wrapperToken.innerPaddingRight, scrollBarStyle(props)), StyledBaseMenuItemDivider, colors.pattern.background.divider, dividerToken.paddingVertical, $hasScrollBar ? 0 : dividerToken.paddingRight, dividerToken.paddingVertical, dividerToken.paddingLeft[$size], StyledBaseMenuItemGroupLabel, groupToken.fontSize, groupToken.height, groupToken.height, groupToken.background, groupToken.color, groupToken.paddingLeft[$size], groupToken.marginTop);
};
export var StyledBaseMenu = styled.div.withConfig({
  displayName: "StyledBaseMenu"
})(["", ";"], baseMenuCss);