import React from 'react';
export var getChildType = function getChildType(child) {
  if (child.type && child.type.displayName) {
    return child.type.displayName;
  }

  return '';
};
export var isMenuItem = function isMenuItem(type) {
  return type === 'MenuItem';
};
/* eslint-disable no-param-reassign */

export var getMenuItemCountFromChildren = function getMenuItemCountFromChildren(children) {
  var count = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  React.Children.forEach(children, function (child) {
    if (!child) {
      return;
    }

    var type = getChildType(child);

    if (isMenuItem(type)) {
      count += 1;
    } else if (child && child.props && React.Children.count(child.props.children) > 0) {
      count += getMenuItemCountFromChildren(child.props.children);
    }
  });
  return count;
};