import { devWarning as _devWarning } from "@muya-ui/utils/es/utils/devWarning";
import { useEffectOnce as _useEffectOnce } from "@muya-ui/utils/es/hooks/useEffectOnce";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import { colorUtils as _colorUtils } from "@muya-ui/theme-light/es/utils";
import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["shape", "block"],
    _excluded2 = ["loading", "autoLoading", "onClick"];
import React from 'react';
import styled, { css } from 'styled-components';
import useTheme from '../utils/useTheme';
import { withThemeForStyled } from '../utils/withTheme';
import ButtonCore from './ButtonCore';
import { buttonSizeCSS, siblingCss } from './mixins';
import useBtnAutoLoading from './useBtnAutoLoading';
var MaskButtonPure = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var shape = props.shape,
      block = props.block,
      otherProps = _objectWithoutProperties(props, _excluded);

  return /*#__PURE__*/React.createElement(ButtonCore, _extends({
    ref: ref
  }, otherProps));
}); // 状态的样式

function maskButtonStatusCSS(props) {
  var theme = props.theme,
      busy = props.busy,
      disabled = props.disabled,
      loading = props.loading;
  var components = theme.components,
      opacity = theme.opacity;
  var _components$Button = components.Button,
      defaultColor = _components$Button.defaultColor,
      maskColor = _components$Button.maskColor;

  var bgColor = _colorUtils.transparentize(opacity.spec.s3, maskColor);

  var disabledColor = theme.colors.pattern.text.disabled;
  var interactive = !(busy || disabled || loading);
  var interactiveCSS;

  if (interactive) {
    var bgHoverColor = _colorUtils.transparentize(opacity.spec.s2, maskColor);

    interactiveCSS = css(["cursor:pointer;&:hover{background-color:", ";}"], bgHoverColor);
  } else {
    interactiveCSS = css(["cursor:not-allowed;"]);
  }

  if (disabled) {
    bgColor = disabledColor;
  }

  return css(["color:", ";user-select:none;background-color:", ";&:hover{color:", ";}", " ", ""], defaultColor, bgColor, defaultColor, !interactive && !disabled && "opacity: ".concat(opacity.pattern.disabled, ";"), interactiveCSS);
}

export var StyledMaskButton = styled(MaskButtonPure).withConfig({
  displayName: "StyledMaskButton"
})(["", ""], function (props) {
  var _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      theme = props.theme,
      _props$disableSibling = props.disableSiblingMargin,
      disableSiblingMargin = _props$disableSibling === void 0 ? false : _props$disableSibling,
      fontWeight = props.fontWeight,
      textFine = props.textFine;
  var innerFontWeight = fontWeight;

  if (!innerFontWeight && textFine) {
    innerFontWeight = 'lighter';
  }

  var newProps = _extends({}, props, {
    size: size,
    fontWeight: innerFontWeight
  });

  return css(["border:none;", " ", " ", ""], buttonSizeCSS(newProps), maskButtonStatusCSS(newProps), siblingCss({
    size: size,
    theme: theme,
    inGroup: false,
    disableSiblingMargin: disableSiblingMargin
  }));
});
var MaskButton = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var loading = props.loading,
      autoLoading = props.autoLoading,
      onClick = props.onClick,
      otherProps = _objectWithoutProperties(props, _excluded2);

  var _useBtnAutoLoading = useBtnAutoLoading(props),
      _useBtnAutoLoading2 = _slicedToArray(_useBtnAutoLoading, 2),
      realLoading = _useBtnAutoLoading2[0],
      handleClick = _useBtnAutoLoading2[1];

  var theme = useTheme();

  _useEffectOnce(function () {
    _devWarning('[Button]: `MaskButton` is deprecated, please use `type="mask"` instead.');
  });

  return /*#__PURE__*/React.createElement(StyledMaskButton, _extends({
    ref: ref,
    onClick: handleClick,
    loading: realLoading
  }, otherProps, {
    theme: theme
  }));
});
var WrapMaskButton = withThemeForStyled(styled(MaskButton).withConfig({
  displayName: "WrapMaskButton"
})([""]));
WrapMaskButton.__MUYA_BUTTON = true;
export default WrapMaskButton;