import styled, { css } from 'styled-components';
var baseCSS = css(["position:relative;display:inline-flex;align-items:center;justify-content:center;vertical-align:middle;"]);
export var StyledButton = styled.button.withConfig({
  displayName: "StyledButton"
})(["outline:0;margin:0;font-family:inherit;text-transform:none;overflow:visible;box-sizing:border-box;", ""], baseCSS);
export var StyledLink = styled.a.withConfig({
  displayName: "StyledLink"
})(["text-decoration:none;", ""], baseCSS);
export var StyledSide = styled.span.withConfig({
  displayName: "StyledSide"
})(["display:inline-flex;", ""], function (props) {
  var prefixNode = props.prefixNode,
      theme = props.theme,
      suffixNode = props.suffixNode,
      $isCircleOrSquare = props.$isCircleOrSquare;
  var btnToken = theme.components.Button;
  if ($isCircleOrSquare) return;

  if (prefixNode) {
    return css(["padding-right:", "px;"], btnToken.sidePadding);
  } else if (suffixNode) {
    return css(["padding-left:", "px;"], btnToken.sidePadding);
  }
});