import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["options", "styles", "type"];
import React, { useMemo } from 'react';
import styled, { css } from 'styled-components';
import InlineButton from '../InlineButton';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
var StyledButton = styled(InlineButton).withConfig({
  displayName: "StyledButton"
})([""]);
var Root = styled.div.withConfig({
  displayName: "Root"
})(["display:flex;", ""], function (_ref) {
  var theme = _ref.theme,
      _ref$$type = _ref.$type,
      $type = _ref$$type === void 0 ? 'date' : _ref$$type;
  var colors = theme.colors,
      footerToken = theme.components.Calendar.footer;

  if ($type === 'date-time') {
    return css(["flex:1;padding:0 12px;& ", "{margin:0 16px 0 0;}"], StyledButton);
  }

  return css(["width:100%;align-items:center;justify-content:center;height:", "px;border-top:1px solid ", ";& ", "{margin:", ";}"], footerToken.height, colors.pattern.border.normal, StyledButton, footerToken.optionMargin);
});
var defaultStyles = {
  footerOption: ''
};
var CalendarFooter = memoForwardRef(function (props, ref) {
  var options = props.options,
      styles = props.styles,
      type = props.type,
      otherProps = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  var pickStyles = useMemo(function () {
    if (styles) {
      var footerOption = styles.footerOption;
      return {
        footerOption: footerOption
      };
    }
  }, [styles]);
  var innerStyles = useStyles('calendar', defaultStyles, pickStyles);
  var optionsNode = useMemo(function () {
    if (!options || options.length < 1) {
      return;
    }

    return options.map(function (_ref2, index) {
      var label = _ref2.label,
          onClick = _ref2.onClick,
          disabled = _ref2.disabled;
      return /*#__PURE__*/React.createElement(StyledButton, _extends({}, innerStyles.footerOption, {
        key: index,
        type: "primary",
        size: "s",
        fontWeight: "lighter",
        disabled: disabled,
        onClick: onClick
      }), label);
    });
  }, [innerStyles.footerOption, options]);
  return /*#__PURE__*/React.createElement(Root, _extends({
    theme: theme,
    $type: type
  }, otherProps, {
    ref: ref
  }), optionsNode);
});
export default CalendarFooter;