import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import { NextYearIcon as _NextYearIcon } from "@muya-ui/theme-light/es/icons/NextYearIcon";
import { PrevYearIcon as _PrevYearIcon } from "@muya-ui/theme-light/es/icons/PrevYearIcon";
import { GuildRightIcon as _GuildRightIcon } from "@muya-ui/theme-light/es/icons/GuildRightIcon";
import { GuildLeftIcon as _GuildLeftIcon } from "@muya-ui/theme-light/es/icons/GuildLeftIcon";
import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["viewType", "viewDate", "onNextMonth", "onNextYear", "onPrevMonth", "onPrevYear", "onSwitch", "styles"];
import React, { useCallback, useMemo, useState } from 'react';
import styled, { css } from 'styled-components';
import IconButton from '../IconButton';
import InlineButton from '../InlineButton';
import useLocale from '../Locale/useLocale';
import Tooltip from '../Tooltip';
import Typography from '../Typography';
import forkHandler from '../utils/forkHandler';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import { getDecade } from './utils';
var StyledDecadeTitle = styled(Typography.Title).withConfig({
  displayName: "StyledDecadeTitle"
})([""]);
var PagerButton = styled(IconButton).withConfig({
  displayName: "PagerButton"
})([""]);
var pagerCss = css(["position:absolute;height:100%;display:flex;align-items:center;"]);
var PagerPrev = styled.div.withConfig({
  displayName: "PagerPrev"
})(["", " left:0;"], pagerCss);
var PagerNext = styled.div.withConfig({
  displayName: "PagerNext"
})(["", " right:0;"], pagerCss);
var SwitchButton = styled(InlineButton).withConfig({
  displayName: "SwitchButton"
})([""]);
var Root = styled.div.withConfig({
  displayName: "Root"
})(["display:flex;justify-content:center;align-items:center;position:relative;", "{margin-bottom:0;}", ""], StyledDecadeTitle, function (props) {
  var _props$theme = props.theme,
      colors = _props$theme.colors,
      token = _props$theme.components.Calendar;
  return css(["height:", "px;border-bottom:1px solid ", ";", "{margin:0;padding:", ";}", " ", ",", " ", "{margin:", ";}", " ", "{margin-right:0;}", " ", "{margin-left:0;}"], token.head.height, colors.pattern.border.normal, SwitchButton, token.headButton.padding, PagerPrev, PagerButton, PagerNext, PagerButton, token.pagerButton.margin, PagerPrev, PagerButton, PagerNext, PagerButton);
});
var defaultStyles = {
  pagerPrev: '',
  pagerPrevYear: '',
  pagerPrevMonth: '',
  pagerNext: '',
  pagerNextYear: '',
  pagerNextMonth: '',
  switchYear: '',
  switchMonth: ''
};
var CalendarHead = memoForwardRef(function (props, ref) {
  var _props$viewType = props.viewType,
      viewType = _props$viewType === void 0 ? 'month' : _props$viewType,
      viewDate = props.viewDate,
      onNextMonth = props.onNextMonth,
      onNextYear = props.onNextYear,
      onPrevMonth = props.onPrevMonth,
      onPrevYear = props.onPrevYear,
      onSwitch = props.onSwitch,
      styles = props.styles,
      otherProps = _objectWithoutProperties(props, _excluded);

  var pickStyles = useMemo(function () {
    if (styles) {
      var _pagerPrev = styles.pagerPrev,
          _pagerPrevYear = styles.pagerPrevYear,
          _pagerPrevMonth = styles.pagerPrevMonth,
          _pagerNext = styles.pagerNext,
          _pagerNextYear = styles.pagerNextYear,
          _pagerNextMonth = styles.pagerNextMonth,
          switchYear = styles.switchYear,
          switchMonth = styles.switchMonth;
      return {
        pagerPrev: _pagerPrev,
        pagerPrevYear: _pagerPrevYear,
        pagerPrevMonth: _pagerPrevMonth,
        pagerNext: _pagerNext,
        pagerNextYear: _pagerNextYear,
        pagerNextMonth: _pagerNextMonth,
        switchYear: switchYear,
        switchMonth: switchMonth
      };
    }
  }, [styles]);
  var innerStyles = useStyles('calendar', defaultStyles, pickStyles);
  var theme = useTheme();
  var _theme$components$Cal = theme.components.Calendar,
      pagerArrow = _theme$components$Cal.pagerArrow,
      pagerArrowTipDelay = _theme$components$Cal.pagerArrowTipDelay,
      defaultDecadeTitleLevel = _theme$components$Cal.head.defaultDecadeTitleLevel;

  var Arrow = _extends({
    monthPrev: _GuildLeftIcon,
    monthNext: _GuildRightIcon,
    yearPrev: _PrevYearIcon,
    yearNext: _NextYearIcon
  }, pagerArrow);

  var _useLocale = useLocale(),
      yearFormat = _useLocale['Calendar.yearFormat'],
      headOrder = _useLocale['Calendar.headOrder'],
      pagerNextMonth = _useLocale['Calendar.pagerNextMonth'],
      pagerNextYear = _useLocale['Calendar.pagerNextYear'],
      pagerNextDecade = _useLocale['Calendar.pagerNextDecade'],
      pagerPrevMonth = _useLocale['Calendar.pagerPrevMonth'],
      pagerPrevYear = _useLocale['Calendar.pagerPrevYear'],
      pagerPrevDecade = _useLocale['Calendar.pagerPrevDecade'];

  var handleSwitch = function handleSwitch(type) {
    return function () {
      onSwitch && onSwitch(type);
    };
  };

  var yearBtn = /*#__PURE__*/React.createElement(SwitchButton, _extends({}, innerStyles.switchYear, {
    type: "strong",
    onClick: handleSwitch('decade'),
    size: "s"
  }), viewDate.format(yearFormat));
  var monthBtn = /*#__PURE__*/React.createElement(SwitchButton, _extends({}, innerStyles.switchMonth, {
    type: "strong",
    onClick: handleSwitch('year'),
    size: "s"
  }), viewDate.format('MMM'));
  var headNode;

  if (viewType === 'year') {
    headNode = yearBtn;
  } else if (viewType === 'decade') {
    var _getDecade = getDecade(viewDate),
        _getDecade2 = _slicedToArray(_getDecade, 2),
        firstYear = _getDecade2[0],
        lastYear = _getDecade2[1];

    var title = "".concat(firstYear.format(yearFormat), "-").concat(lastYear.format(yearFormat));
    headNode = /*#__PURE__*/React.createElement(StyledDecadeTitle, {
      level: defaultDecadeTitleLevel
    }, title);
  } else if (headOrder === 'month') {
    headNode = /*#__PURE__*/React.createElement(React.Fragment, null, monthBtn, yearBtn);
  } else {
    headNode = /*#__PURE__*/React.createElement(React.Fragment, null, yearBtn, monthBtn);
  }

  var nextYearTip = viewType === 'decade' ? pagerNextDecade : pagerNextYear;
  var prevYearTip = viewType === 'decade' ? pagerPrevDecade : pagerPrevYear;

  var _useState = useState(true),
      _useState2 = _slicedToArray(_useState, 2),
      showTooltip = _useState2[0],
      setShowTooltip = _useState2[1];

  var renderPagerButton = useCallback(function (title, iconNode, styleItem, clickHandler) {
    var innerClickHandler = forkHandler(function () {
      setShowTooltip(false);
    }, clickHandler);
    var pagerNode = /*#__PURE__*/React.createElement(PagerButton, _extends({}, styleItem, {
      size: "s",
      fontWeight: "lighter",
      onClick: innerClickHandler
    }), iconNode);

    if (showTooltip) {
      return /*#__PURE__*/React.createElement(Tooltip, {
        title: title,
        enterDelay: pagerArrowTipDelay
      }, pagerNode);
    }

    return pagerNode;
  }, [pagerArrowTipDelay, showTooltip]);
  var pagerPrev = useMemo(function () {
    var monthPrevPagerBtn = viewType === 'month' ? renderPagerButton(pagerPrevMonth, /*#__PURE__*/React.createElement(Arrow.monthPrev, null), innerStyles.pagerPrevMonth, onPrevMonth) : null;
    return /*#__PURE__*/React.createElement(PagerPrev, innerStyles.pagerPrev, renderPagerButton(prevYearTip, /*#__PURE__*/React.createElement(Arrow.yearPrev, null), innerStyles.pagerPrevYear, onPrevYear), monthPrevPagerBtn);
  }, [innerStyles.pagerPrev, innerStyles.pagerPrevMonth, innerStyles.pagerPrevYear, onPrevMonth, onPrevYear, pagerPrevMonth, prevYearTip, renderPagerButton, viewType]);
  var pagerNext = useMemo(function () {
    var monthNextPagerBtn = viewType === 'month' ? renderPagerButton(pagerNextMonth, /*#__PURE__*/React.createElement(Arrow.monthNext, null), innerStyles.pagerNextMonth, onNextMonth) : null;
    return /*#__PURE__*/React.createElement(PagerNext, innerStyles.pagerNext, monthNextPagerBtn, renderPagerButton(nextYearTip, /*#__PURE__*/React.createElement(Arrow.yearNext, null), innerStyles.pagerNextYear, onNextYear));
  }, [innerStyles.pagerNext, innerStyles.pagerNextMonth, innerStyles.pagerNextYear, nextYearTip, onNextMonth, onNextYear, pagerNextMonth, renderPagerButton, viewType]);
  return /*#__PURE__*/React.createElement(Root, _extends({}, otherProps, {
    theme: theme,
    ref: ref
  }), pagerPrev, headNode, pagerNext);
});
export default CalendarHead;