import dayjs from 'dayjs';
import { useCallback, useMemo } from 'react';
import { getRangeInOrder, inRange } from './utils';
export default function useCalendarBase(props) {
  var disableRange = props.disableRange,
      disableDate = props.disableDate,
      todayDate = props.todayDate,
      selectType = props.selectType;
  var finalDisableRange = useMemo(function () {
    return getRangeInOrder(disableRange);
  }, [disableRange]);
  var finalTodayDate = useMemo(function () {
    return dayjs(todayDate);
  }, [todayDate]);
  var isDateDisabled = useCallback(function (date) {
    return finalDisableRange && inRange(date, finalDisableRange) || disableDate && disableDate(date, selectType || 'date');
  }, [disableDate, finalDisableRange, selectType]);
  return {
    finalDisableRange: finalDisableRange,
    finalTodayDate: finalTodayDate,
    isDateDisabled: isDateDisabled
  };
}