import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "extra", "styles", "shadowed", "hoverShadowed", "bordered", "loading"];
import React, { useMemo } from 'react';
import Skeleton from '../Skeleton';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import CardActions from './CardActions';
import CardContent from './CardContent';
import CardHeader from './CardHeader';
import CardMeta from './CardMeta';
import { StyleCardExtra, StyledCard } from './styled';
var Card = memoForwardRef(function (props, ref) {
  var children = props.children,
      extra = props.extra,
      styles = props.styles,
      _props$shadowed = props.shadowed,
      shadowed = _props$shadowed === void 0 ? true : _props$shadowed,
      _props$hoverShadowed = props.hoverShadowed,
      hoverShadowed = _props$hoverShadowed === void 0 ? true : _props$hoverShadowed,
      _props$bordered = props.bordered,
      bordered = _props$bordered === void 0 ? false : _props$bordered,
      _props$loading = props.loading,
      loading = _props$loading === void 0 ? false : _props$loading,
      others = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  var defaultStyles = useMemo(function () {
    return {
      extraWrapper: ''
    };
  }, []);
  var innerStyles = useStyles('card', defaultStyles, styles);
  var _theme$components$Car = theme.components.Card.skeleton,
      height = _theme$components$Car.height,
      width = _theme$components$Car.width;
  return /*#__PURE__*/React.createElement(StyledCard, _extends({
    ref: ref,
    theme: theme,
    $shadowed: shadowed,
    $hoverShadowed: hoverShadowed,
    $bordered: bordered
  }, others), /*#__PURE__*/React.createElement(Skeleton, {
    active: true,
    loading: loading,
    type: "card",
    style: {
      width: width,
      height: height
    }
  }, extra ? /*#__PURE__*/React.createElement(StyleCardExtra, _extends({
    theme: theme
  }, innerStyles.extraWrapper), extra) : null, children));
});
Card.Content = CardContent;
Card.Header = CardHeader;
Card.Actions = CardActions;
Card.Meta = CardMeta;
export default Card;