import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "padding", "bordered"];
import React from 'react';
import memoForwardRef from '../utils/memoForwardRef';
import useTheme from '../utils/useTheme';
import { StyledCardActions } from './styled';
var CardActions = memoForwardRef(function (props, ref) {
  var children = props.children,
      padding = props.padding,
      _props$bordered = props.bordered,
      bordered = _props$bordered === void 0 ? true : _props$bordered,
      others = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  return /*#__PURE__*/React.createElement(StyledCardActions, _extends({
    theme: theme,
    $padding: padding,
    $bordered: bordered,
    ref: ref
  }, others), children);
});
export default CardActions;