import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "padding"];
import React from 'react';
import memoForwardRef from '../utils/memoForwardRef';
import useTheme from '../utils/useTheme';
import { StyledCardContent } from './styled';
var CardContent = memoForwardRef(function (props, ref) {
  var children = props.children,
      padding = props.padding,
      others = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  return /*#__PURE__*/React.createElement(StyledCardContent, _extends({
    theme: theme,
    $padding: padding,
    ref: ref
  }, others), children);
});
export default CardContent;