import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["type", "title", "bordered", "action"];
import Img from '../Img';
import React from 'react';
import memoForwardRef from '../utils/memoForwardRef';
import { StyledCardHeaderContainer } from './styled';
import { Typography } from '../Typography';
import useTheme from '../utils/useTheme';
var CardHeader = memoForwardRef(function (props, ref) {
  var _props$type = props.type,
      type = _props$type === void 0 ? 'img' : _props$type,
      title = props.title,
      _props$bordered = props.bordered,
      bordered = _props$bordered === void 0 ? true : _props$bordered,
      action = props.action,
      others = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  return type === 'img' ? /*#__PURE__*/React.createElement(Img, _extends({
    ref: ref
  }, others)) : /*#__PURE__*/React.createElement(StyledCardHeaderContainer, {
    theme: theme,
    $bordered: bordered
  }, /*#__PURE__*/React.createElement(Typography.Title, {
    level: theme.components.Card.defaultMetaTitleLevel
  }, title), action);
});
export default CardHeader;