import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "title", "text", "space"];
import React from 'react';
import { Typography } from '../Typography';
import memoForwardRef from '../utils/memoForwardRef';
import useTheme from '../utils/useTheme';
import { StyleCardMeta } from './styled';
var CardMeta = memoForwardRef(function (props, ref) {
  var children = props.children,
      title = props.title,
      text = props.text,
      _props$space = props.space,
      space = _props$space === void 0 ? 4 : _props$space,
      others = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  return /*#__PURE__*/React.createElement(StyleCardMeta, _extends({
    ref: ref
  }, others), title ? /*#__PURE__*/React.createElement(Typography.Title, {
    level: theme.components.Card.defaultMetaTitleLevel,
    marginBottom: space
  }, title) : null, text ? /*#__PURE__*/React.createElement(Typography.Text, null, text) : null, children);
});
export default CardMeta;