import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "onChange", "checked", "defaultChecked", "styles", "showCheckbox", "size", "inputRef", "checkboxProps"];
import React from 'react';
import styled, { css } from 'styled-components';
import Checkbox from '../Checkbox';
import useCheckbox from '../Checkbox/useCheckbox';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import Card from './Card';
import { StyleCardCheckBox } from './styled';
var CheckBoxCardWrapper = styled(Card).withConfig({
  displayName: "CheckBoxCardWrapper"
})(["", ""], function (props) {
  var _props$theme$componen = props.theme.components.Card.checkbox,
      checkedBorder = _props$theme$componen.checkedBorder,
      normalBorder = _props$theme$componen.normalBorder;

  if (props.$checked) {
    return css(["border:", ";"], checkedBorder);
  } else {
    return css(["border:", ";"], normalBorder);
  }
});
var defaultStyles = {
  checkBoxWrapper: '',
  extraWrapper: ''
};
var CheckBoxCard = memoForwardRef(function (props, ref) {
  var children = props.children,
      onChange = props.onChange,
      checked = props.checked,
      defaultChecked = props.defaultChecked,
      styles = props.styles,
      _props$showCheckbox = props.showCheckbox,
      showCheckbox = _props$showCheckbox === void 0 ? true : _props$showCheckbox,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      inputRef = props.inputRef,
      checkboxProps = props.checkboxProps,
      others = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();

  var _useCheckbox = useCheckbox(props, 'checked' in props),
      checkedState = _useCheckbox.checkedState,
      handleChange = _useCheckbox.handleChange;

  var innerStyles = useStyles('card', defaultStyles, styles);
  return /*#__PURE__*/React.createElement(CheckBoxCardWrapper, _extends({
    $checked: checkedState,
    theme: theme,
    styles: styles,
    ref: ref
  }, others), showCheckbox ? /*#__PURE__*/React.createElement(StyleCardCheckBox, _extends({
    theme: theme
  }, innerStyles.checkBoxWrapper), /*#__PURE__*/React.createElement(Checkbox, _extends({}, checkboxProps, {
    checked: checkedState,
    onChange: handleChange,
    size: size,
    inputRef: inputRef
  }))) : null, children);
});
export default CheckBoxCard;