import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "imgHeight", "src", "space", "title", "text", "actions", "actionsPadding", "contentPadding", "styles", "headerProps"];
import React from 'react';
import styled from 'styled-components';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import Card from './Card';
import CardActions from './CardActions';
import CardContent from './CardContent';
import CardHeader from './CardHeader';
import CardMeta from './CardMeta';
var CommonCardWrapper = styled(Card).withConfig({
  displayName: "CommonCardWrapper"
})(["display:flex;flex-direction:column;"]);
var CardContentWrapper = styled(CardContent).withConfig({
  displayName: "CardContentWrapper"
})(["flex:1;"]);
var defaultStyles = {
  headerWrapper: '',
  contentWrapper: '',
  actionWrapper: '',
  metaWrapper: ''
};
var CommonCard = memoForwardRef(function (props, ref) {
  var children = props.children,
      imgHeight = props.imgHeight,
      src = props.src,
      _props$space = props.space,
      space = _props$space === void 0 ? 4 : _props$space,
      title = props.title,
      text = props.text,
      actions = props.actions,
      actionsPadding = props.actionsPadding,
      contentPadding = props.contentPadding,
      styles = props.styles,
      headerProps = props.headerProps,
      others = _objectWithoutProperties(props, _excluded);

  var innerStyles = useStyles('card', defaultStyles, styles);
  return /*#__PURE__*/React.createElement(CommonCardWrapper, _extends({
    ref: ref
  }, others), headerProps || src && imgHeight ? /*#__PURE__*/React.createElement(CardHeader, _extends({
    height: imgHeight,
    src: src
  }, headerProps, innerStyles.headerWrapper)) : null, title || text ? /*#__PURE__*/React.createElement(CardContentWrapper, _extends({
    padding: contentPadding
  }, innerStyles.contentWrapper), /*#__PURE__*/React.createElement(CardMeta, _extends({
    title: title,
    text: text,
    space: space
  }, innerStyles.metaWrapper))) : null, actions ? /*#__PURE__*/React.createElement(CardActions, _extends({
    padding: actionsPadding
  }, innerStyles.actionWrapper), actions) : null);
});
export default CommonCard;