import styled, { css } from 'styled-components';
import { isValidProps } from '../utils/props';
export var StyledCard = styled.div.withConfig({
  displayName: "StyledCard"
})(["", ""], function (props) {
  var theme = props.theme,
      $bordered = props.$bordered,
      $shadowed = props.$shadowed,
      $hoverShadowed = props.$hoverShadowed;
  var cardToken = theme.components.Card;
  var border = $bordered ? cardToken.border : '';
  var shadow = $shadowed ? cardToken.boxShadow.normal : '';
  return css(["position:relative;border-radius:", "px;box-shadow:", ";border:", ";overflow:hidden;&:hover{box-shadow:", ";}"], cardToken.borderRadius, shadow, border, $hoverShadowed ? cardToken.boxShadow.hover : '');
});
export var StyledCardHeader = styled.div.withConfig({
  displayName: "StyledCardHeader"
})([""]);
export var StyledCardHeaderContainer = styled.div.withConfig({
  displayName: "StyledCardHeaderContainer"
})(["", ""], function (props) {
  var theme = props.theme,
      $padding = props.$padding,
      $bordered = props.$bordered;
  var cardToken = theme.components.Card;
  var padding = isValidProps($padding) && String($padding);
  return css(["display:flex;align-items:center;justify-content:space-between;padding:", ";border-bottom:", ";"], padding ? padding : cardToken.header.padding, $bordered && cardToken.header.bottomBorder);
});
export var StyledCardContent = styled.div.withConfig({
  displayName: "StyledCardContent"
})(["", ""], function (props) {
  var theme = props.theme,
      $padding = props.$padding;
  var cardToken = theme.components.Card;
  var padding = isValidProps($padding) && String($padding);
  return css(["padding:", ";"], padding ? padding : cardToken.content.padding);
});
export var StyledCardActions = styled.div.withConfig({
  displayName: "StyledCardActions"
})(["", ""], function (props) {
  var theme = props.theme,
      $padding = props.$padding,
      $bordered = props.$bordered;
  var cardToken = theme.components.Card;
  var padding = isValidProps($padding) && String($padding);
  return css(["display:flex;padding:", ";border-top:", ";"], padding ? padding : cardToken.actions.padding, $bordered && cardToken.actions.topBorder);
});
export var StyleCardExtra = styled.div.withConfig({
  displayName: "StyleCardExtra"
})(["", ""], function (props) {
  var theme = props.theme;
  var cardToken = theme.components.Card;
  return css(["position:absolute;top:", "px;right:", "px;"], cardToken.extra.topPadding, cardToken.extra.rightPadding);
});
export var StyleCardMeta = styled.div.withConfig({
  displayName: "StyleCardMeta"
})([""]);
export var StyleCardCheckBox = styled.div.withConfig({
  displayName: "StyleCardCheckBox"
})(["", ""], function (props) {
  var theme = props.theme;
  var cardToken = theme.components.Card;
  return css(["position:absolute;top:", "px;right:", "px;z-index:1;"], cardToken.checkbox.topPadding, cardToken.checkbox.rightPadding);
});