import { colorUtils as _colorUtils } from "@muya-ui/theme-light/es/utils";
import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["selected", "color", "gutter"],
    _excluded2 = ["trigger", "index", "num", "color", "styles", "onChange"];
import React from 'react';
import styled, { css } from 'styled-components';
import memoForwardRef from '../utils/memoForwardRef';
import mergeStyleItem from '../utils/mergeStyleItem';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import { withThemeForStyled } from '../utils/withTheme';
var BaseNode = styled.div.withConfig({
  displayName: "BaseNode"
})([""]);
var IndexPure = memoForwardRef(function (props, ref) {
  var selected = props.selected,
      color = props.color,
      gutter = props.gutter,
      otherProps = _objectWithoutProperties(props, _excluded);

  return /*#__PURE__*/React.createElement(BaseNode, _extends({}, otherProps, {
    ref: ref
  }));
});
export var Index = styled(IndexPure).withConfig({
  displayName: "Index"
})(["display:inline-block;cursor:pointer;", ""], function (props) {
  var selected = props.selected,
      color = props.color,
      gutter = props.gutter,
      theme = props.theme;
  var _theme$transition$pat = theme.transition.pattern,
      easing = _theme$transition$pat.easing,
      duration = _theme$transition$pat.duration;
  var token = theme.components.Carousel.IndexIndicator;
  var innerColor = color || token.color;
  var width = selected ? token.selectedSize : token.size;
  var statusCss;

  if (selected) {
    statusCss = css(["&::before{background-color:", ";}"], innerColor);
  } else {
    statusCss = css(["&::before{background-color:", ";}&:hover{&::before{background-color:", ";}}"], _colorUtils.transparentize(token.opacity, innerColor), _colorUtils.transparentize(token.hoverOpacity, innerColor));
  }

  return css(["padding:", "px 0;", " &::before{box-sizing:content-box;content:'';display:block;height:", "px;width:", "px;border-radius:", ";transition:all ", "ms ", ";}", ""], token.borderWidth, gutter && "margin-right: ".concat(token.gutter, "px;"), token.borderWidth, width, token.borderRadius, duration.status, easing.status, statusCss);
});
var IndexIndicatorPure = memoForwardRef(function (props, ref) {
  var trigger = props.trigger,
      index = props.index,
      num = props.num,
      color = props.color,
      styles = props.styles,
      onChange = props.onChange,
      otherProps = _objectWithoutProperties(props, _excluded2);

  var theme = useTheme();
  var innerStyles = useStyles('carousel-indicator', {
    index: '',
    active: ''
  }, styles);
  var indexes = [];

  var _loop = function _loop(i) {
    var selected = index === i;

    var itemOnChange = function itemOnChange() {
      if (!selected) {
        onChange && onChange(i);
      }
    };

    var indexProps = {};

    if (trigger === 'hover') {
      indexProps.onMouseEnter = itemOnChange;
    } else {
      indexProps.onClick = itemOnChange;
    }

    var styleItem = selected ? mergeStyleItem(innerStyles.active, innerStyles.index) : innerStyles.index;
    indexes.push( /*#__PURE__*/React.createElement(Index, _extends({}, styleItem, {
      key: i,
      color: color,
      theme: theme,
      gutter: i !== num - 1,
      selected: selected
    }, indexProps)));
  };

  for (var i = 0; i < num; i++) {
    _loop(i);
  }

  return /*#__PURE__*/React.createElement(BaseNode, _extends({}, otherProps, {
    ref: ref
  }), indexes);
});
var IndexIndicator = styled(IndexIndicatorPure).withConfig({
  displayName: "IndexIndicator"
})(["white-space:nowrap;"]);
export default withThemeForStyled(IndexIndicator);