import { colorUtils as _colorUtils } from "@muya-ui/theme-light/es/utils";
import { useEventCallback as _useEventCallback } from "@muya-ui/utils/es/hooks/useEventCallback";
import { GuildRightIcon as _GuildRightIcon } from "@muya-ui/theme-light/es/icons/GuildRightIcon";
import { GuildLeftIcon as _GuildLeftIcon } from "@muya-ui/theme-light/es/icons/GuildLeftIcon";
import { GuildDownIcon as _GuildDownIcon } from "@muya-ui/theme-light/es/icons/GuildDownIcon";
import { GuildUpIcon as _GuildUpIcon } from "@muya-ui/theme-light/es/icons/GuildUpIcon";
import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["size", "disabled", "shape", "transparent", "arrow", "side", "icon", "onClick"];
import React from 'react';
import styled, { css } from 'styled-components';
import memoForwardRef from '../utils/memoForwardRef';
import useTheme from '../utils/useTheme';
import { withThemeForStyled } from '../utils/withTheme';
var BaseNode = styled.button.withConfig({
  displayName: "BaseNode"
})([""]);
var PagerButtonPure = memoForwardRef(function (props, ref) {
  var size = props.size,
      disabled = props.disabled,
      shape = props.shape,
      transparent = props.transparent,
      _props$arrow = props.arrow,
      arrow = _props$arrow === void 0 ? 'left' : _props$arrow,
      side = props.side,
      icon = props.icon,
      onClick = props.onClick,
      otherProps = _objectWithoutProperties(props, _excluded);

  var iconNode = icon;
  var theme = useTheme();

  if (!iconNode) {
    var arrowIcon = _extends({
      top: _GuildUpIcon,
      bottom: _GuildDownIcon,
      left: _GuildLeftIcon,
      right: _GuildRightIcon
    }, theme.components.Carousel.PagerButton.arrowIcon);

    var Icon = arrowIcon[arrow];
    iconNode = /*#__PURE__*/React.createElement(Icon, null);
  }

  var handleClick = _useEventCallback(function (e) {
    if (!disabled) {
      onClick && onClick(e);
    } else {
      e.preventDefault();
    }
  }, [disabled]);

  return /*#__PURE__*/React.createElement(BaseNode, _extends({}, otherProps, {
    disabled: disabled,
    onClick: handleClick,
    ref: ref
  }), iconNode);
});
var PagerButton = styled(PagerButtonPure).withConfig({
  displayName: "PagerButton"
})(["position:relative;display:inline-flex;align-items:center;justify-content:center;cursor:pointer;user-select:none;outline:0;margin:0;border:none;font-family:inherit;text-transform:none;overflow:visible;box-sizing:border-box;appearance:button;", ""], function (props) {
  var _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      _props$shape = props.shape,
      shape = _props$shape === void 0 ? 'rect' : _props$shape,
      transparent = props.transparent,
      disabled = props.disabled,
      _props$arrow2 = props.arrow,
      arrow = _props$arrow2 === void 0 ? 'left' : _props$arrow2,
      side = props.side,
      theme = props.theme;
  var innerSide = side || arrow;
  var opacity = theme.opacity;
  var token = theme.components.Carousel.PagerButton;
  var width = token.width[size];
  var height = token.height[size];
  var iconSize = token.iconSize[size];
  var shapeCss;

  if (shape === 'rect') {
    var isH = arrow === 'left' || arrow === 'right';
    var innerWidth = isH ? width : height;
    var innerHeight = isH ? height : width;
    var sideCss;

    if (innerSide === 'left') {
      sideCss = css(["border-top-left-radius:0;border-bottom-left-radius:0;"]);
    } else if (innerSide === 'right') {
      sideCss = css(["border-top-right-radius:0;border-bottom-right-radius:0;"]);
    } else if (innerSide === 'top') {
      sideCss = css(["border-top-right-radius:0;border-top-left-radius:0;"]);
    } else {
      sideCss = css(["border-bottom-right-radius:0;border-bottom-left-radius:0;"]);
    }

    shapeCss = css(["width:", "px;height:", "px;border-radius:", ";", ""], innerWidth, innerHeight, token.borderRadius, sideCss);
  } else {
    shapeCss = css(["width:", "px;height:", "px;border-radius:50%;"], height, height);
  }

  var statusCss;

  if (disabled) {
    var color = _colorUtils.transparentize(opacity.pattern.disabled, token.iconColor);

    statusCss = css(["color:", ";cursor:not-allowed;"], color);
  } else if (transparent) {
    statusCss = css(["color:", ";"], token.iconColor);
  } else {
    var bgAHColor = _colorUtils.transparentize(token.hoverOpacity, token.bgColor);

    statusCss = css(["color:", ";&:hover,&:active{background-color:", ";}"], token.iconColor, bgAHColor);
  }

  var bgCss;

  if (!transparent) {
    var bgColor = _colorUtils.transparentize(token.opacity, token.bgColor);

    bgCss = css(["background-color:", ";"], bgColor);
  } else {
    bgCss = css(["background-color:transparent;"]);
  }

  return css(["font-size:", "px;", " ", " ", ""], iconSize, shapeCss, bgCss, statusCss);
});
export default withThemeForStyled(PagerButton);