import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React from 'react';
export default function useMoveActive(returnDirectly) {
  var _React$useState = React.useState(true),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      moveActive = _React$useState2[0],
      setMoveActive = _React$useState2[1];

  var shouldActive = React.useCallback(function (fn) {
    var newFn = function newFn() {
      if (returnDirectly) {
        fn.apply(void 0, arguments);
        return;
      }

      if (!moveActive) {
        return;
      }

      setMoveActive(false);
      fn.apply(void 0, arguments);
    };

    return newFn;
  }, [moveActive, returnDirectly]);
  return {
    moveActive: moveActive,
    shouldActive: shouldActive,
    setMoveActive: setMoveActive
  };
}