import { useEventCallback as _useEventCallback } from "@muya-ui/utils/es/hooks/useEventCallback";
import { useAfterEffect as _useAfterEffect2 } from "@muya-ui/utils/es/hooks/useAfterEffect";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["imgs", "index", "defaultIndex", "duration", "autoplay", "arrow", "arrowEnabled", "arrowSize", "indicator", "indicatorTrigger", "onChange", "lazy", "animation", "styles", "indicatorStyles", "enableDiffChildren", "children", "onMouseEnter", "onMouseLeave"];
import { useCallback, useMemo, useState } from 'react';
import useMoveActive from './useMoveActive';
import { transformImgs } from './utils';
export default function useSwipeCarousel(props) {
  var imgs = props.imgs,
      index = props.index,
      _props$defaultIndex = props.defaultIndex,
      defaultIndex = _props$defaultIndex === void 0 ? 0 : _props$defaultIndex,
      duration = props.duration,
      _props$autoplay = props.autoplay,
      autoplay = _props$autoplay === void 0 ? 0 : _props$autoplay,
      _props$arrow = props.arrow,
      arrow = _props$arrow === void 0 ? 'always' : _props$arrow,
      _props$arrowEnabled = props.arrowEnabled,
      arrowEnabled = _props$arrowEnabled === void 0 ? 'always' : _props$arrowEnabled,
      _props$arrowSize = props.arrowSize,
      arrowSize = _props$arrowSize === void 0 ? 'm' : _props$arrowSize,
      _props$indicator = props.indicator,
      indicator = _props$indicator === void 0 ? 'center' : _props$indicator,
      indicatorTrigger = props.indicatorTrigger,
      onChange = props.onChange,
      lazy = props.lazy,
      animation = props.animation,
      styles = props.styles,
      indicatorStyles = props.indicatorStyles,
      enableDiffChildren = props.enableDiffChildren,
      children = props.children,
      onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave,
      otherProps = _objectWithoutProperties(props, _excluded);

  var _useMemo = useMemo(function () {
    return transformImgs(imgs);
  }, [imgs]),
      innerImgs = _useMemo.imgs,
      isItems = _useMemo.isItems,
      imgItems = _useMemo.imgItems;

  var _useMoveActive = useMoveActive(arrowEnabled === 'always'),
      shouldActive = _useMoveActive.shouldActive,
      setMoveActive = _useMoveActive.setMoveActive,
      moveActive = _useMoveActive.moveActive; // const onIndexChange = useMemo(() => shouldActive(onGoTo), [onGoTo, shouldActive]);


  var isControlled = ('index' in props);

  var _useState = useState(defaultIndex),
      _useState2 = _slicedToArray(_useState, 2),
      indexState = _useState2[0],
      setIndexState = _useState2[1];

  var finalIndex = isControlled ? index || 0 : indexState;
  var canSwipe = innerImgs.length > 1;
  var imgLength = innerImgs.length;
  var updateIndex = useCallback(function (i) {
    setIndexState(i);

    if (onChange) {
      onChange(innerImgs[i], i);
    }
  }, [innerImgs, onChange]);
  var handlePrev = useMemo(function () {
    return shouldActive(function () {
      var newIndex = finalIndex - 1;

      if (newIndex < 0) {
        newIndex = imgLength - 1;
      }

      updateIndex(newIndex);
    });
  }, [finalIndex, imgLength, shouldActive, updateIndex]);
  var handleNext = useMemo(function () {
    return shouldActive(function () {
      var newIndex = finalIndex + 1;

      if (newIndex > imgLength - 1) {
        newIndex = 0;
      }

      updateIndex(newIndex);
    });
  }, [finalIndex, imgLength, shouldActive, updateIndex]);
  var handleGoTo = useMemo(function () {
    return shouldActive(function (i) {
      if (i >= 0 && i < imgLength) {
        updateIndex(i);
      }
    });
  }, [imgLength, shouldActive, updateIndex]);

  var _useAfterEffect = _useAfterEffect2(handleNext, autoplay * 1000),
      onActive = _useAfterEffect.onActive,
      onDisable = _useAfterEffect.onDisable,
      autoplayActive = _useAfterEffect.active;

  var handleMouseEnter = _useEventCallback(function (e) {
    onDisable();
    onMouseEnter && onMouseEnter(e);
  }, []);

  var handleMouseLeave = _useEventCallback(function (e) {
    onActive();
    onMouseLeave && onMouseLeave(e);
  }, []);

  var handleTransitionEnd = _useEventCallback(function () {
    return setMoveActive(true);
  });

  return {
    canSwipe: canSwipe,
    isItems: isItems,
    imgItems: imgItems,
    innerImgs: innerImgs,
    currentIndex: finalIndex,
    imgLength: imgLength,
    autoplayActive: autoplayActive,
    moveActive: moveActive,
    // 处理函数
    handlePrev: handlePrev,
    handleNext: handleNext,
    handleGoTo: handleGoTo,
    handleMouseEnter: handleMouseEnter,
    handleMouseLeave: handleMouseLeave,
    handleTransitionEnd: handleTransitionEnd,
    // 直接往下传
    arrowSize: arrowSize,
    arrow: arrow,
    enableDiffChildren: enableDiffChildren,
    lazy: lazy,
    duration: duration,
    indicatorTrigger: indicatorTrigger,
    indicator: indicator,
    children: children,
    otherProps: otherProps,
    styles: styles,
    indicatorStyles: indicatorStyles
  };
}