import _isEmpty from "lodash/isEmpty";
import arrayTreeFilter from 'array-tree-filter';
import { useEffect, useMemo } from 'react';
export default function useCascaderPanel(props, activeOptionsRef) {
  var options = props.options,
      activeValue = props.activeValue,
      fieldNames = props.fieldNames,
      visible = props.visible;
  var activeOptions = useMemo(function () {
    return arrayTreeFilter(options, function (o, level) {
      return o[fieldNames.value] === activeValue[level];
    }, {
      childrenKeyName: fieldNames.children
    });
  }, [activeValue, fieldNames.children, fieldNames.value, options]);
  var showOptions = useMemo(function () {
    var result = activeOptions.map(function (activeOption) {
      return activeOption[fieldNames.children];
    }).filter(function (activeOption) {
      return !_isEmpty(activeOption);
    });
    result.unshift(options);
    return result;
  }, [activeOptions, fieldNames.children, options]);
  useEffect(function () {
    if (visible) {
      var optionsLength = showOptions.length;

      for (var i = 0; i < optionsLength; i++) {
        var option = activeOptionsRef.current[i];

        if (option && option.parentNode) {
          option.parentNode.scrollTop = option.offsetTop;
        }
      }
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [visible]);
  return {
    activeOptions: activeOptions,
    showOptions: showOptions
  };
}