import _extends from "@babel/runtime/helpers/extends";
import { useEventCallback as _useEventCallback } from "@muya-ui/utils/es/hooks/useEventCallback";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["shape", "size", "bordered", "disabled", "borderColor", "maxWidth", "checked", "onChange", "onClick"];
import React from 'react';
import styled from 'styled-components';
import memoForwardRef from '../utils/memoForwardRef';
import { withThemeForStyled } from '../utils/withTheme';
import { checkableTagCss } from './styled';
import { tagCss } from '../Tag/styled';
var BaseNode = styled.span.withConfig({
  displayName: "BaseNode"
})([""]);
var PureCheckableTag = memoForwardRef(function (props, ref) {
  var shape = props.shape,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      bordered = props.bordered,
      disabled = props.disabled,
      borderColor = props.borderColor,
      maxWidth = props.maxWidth,
      checked = props.checked,
      onChange = props.onChange,
      onClick = props.onClick,
      restProps = _objectWithoutProperties(props, _excluded);

  var handleClick = _useEventCallback(function (e) {
    if (!disabled) {
      /* istanbul ignore else */
      if (onClick) {
        onClick(e);
      }
      /* istanbul ignore else */


      if (onChange) {
        onChange(!checked);
      }
    } else {
      e.preventDefault();
    }
  }, [checked, onChange]);

  return /*#__PURE__*/React.createElement(BaseNode, _extends({
    ref: ref
  }, restProps, {
    onClick: handleClick
  }));
});
var CheckableTag = styled(PureCheckableTag).withConfig({
  displayName: "CheckableTag"
})(["", ";", ""], tagCss, checkableTagCss);
export default withThemeForStyled(CheckableTag);