/* stylelint-disable no-descending-specificity */
import { css } from 'styled-components';
export var checkableTagCss = function checkableTagCss(props) {
  var _props$theme = props.theme,
      token = _props$theme.components.Tag,
      colorsPattern = _props$theme.colors.pattern,
      opacityPattern = _props$theme.opacity.pattern,
      _props$checked = props.checked,
      checked = _props$checked === void 0 ? false : _props$checked,
      _props$inline = props.inline,
      inline = _props$inline === void 0 ? false : _props$inline,
      _props$activeStyle = props.activeStyle,
      activeStyle = _props$activeStyle === void 0 ? 'normal' : _props$activeStyle,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled;
  var normalStyle;
  var hoverStyle;
  var clickStyle;
  var disabledStyle; // 现在的checkableTag选中状态永远是primary

  var type = 'primary';

  if (!checked) {
    // 未选中时样式
    if (!inline) {
      normalStyle = css(["background:", ";color:", ";"], token.lightBg['normal'].normal, token.outlineColor.normal.normal);
      hoverStyle = css(["&:hover{background:", ";color:", ";}"], token.lightBg['normal'].hover, token.outlineColor.normal.hover);
    } else {
      normalStyle = css(["background:transparent;color:", ";"], token.outlineColor.normal.normal);
      hoverStyle = css(["&:hover{background:", ";color:", ";}"], token.lightBg['normal'].normal, token.outlineColor.normal.hover);
    }

    clickStyle = css(["&:active{background:", ";color:", ";}"], token.lightBg[type].normal, token.outlineColor[type].normal);
  } else {
    // 选中后的样式
    if (activeStyle === 'light') {
      normalStyle = css(["background:", ";color:", ";"], token.lightBg[type].normal, token.typeColor[type].normal);
      hoverStyle = css(["&:hover{background:", ";color:", ";}"], token.lightBg[type].hover, token.typeColor[type].normal);
      clickStyle = css(["&:active{background:", ";color:", ";}"], token.lightBg[type].click, token.typeColor[type].normal);
    } else {
      normalStyle = css(["background:", ";color:", ";"], token.typeColor[type].normal, colorsPattern.text.inverse);
      hoverStyle = css(["&:hover{background:", ";color:", ";}"], token.typeColor[type].hover, colorsPattern.text.inverse);
      clickStyle = css(["&:active{background:", ";color:", ";}"], token.typeColor[type].click, token.color.inverse);
    }
  }

  if (disabled) {
    disabledStyle = css(["opacity:", ";"], opacityPattern.disabled);
    clickStyle = css([""]);
    hoverStyle = css([""]);
  }

  return css(["", ";", ";", ";", ";"], normalStyle, hoverStyle, clickStyle, disabledStyle);
};