import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["checked", "children", "defaultChecked", "disabled", "indeterminate", "autoFocus", "readOnly", "onChange", "onMouseEnter", "onMouseLeave", "size", "styles", "style", "className", "inputRef", "ellipsis", "width"];
import React from 'react';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import { StyledCheckboxContent, StyledCheckboxIconWrap, StyledCheckboxInput, StyledCheckboxLabel, StyledCheckboxSpan } from './styled';
import useCheckbox from './useCheckbox';
var defaultStyles = {
  wrapper: '',
  icon: '',
  iconWrap: '',
  span: ''
};
var Checkbox = memoForwardRef(function (props, ref) {
  var checked = props.checked,
      children = props.children,
      _props$defaultChecked = props.defaultChecked,
      defaultChecked = _props$defaultChecked === void 0 ? false : _props$defaultChecked,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      _props$indeterminate = props.indeterminate,
      indeterminate = _props$indeterminate === void 0 ? false : _props$indeterminate,
      _props$autoFocus = props.autoFocus,
      autoFocus = _props$autoFocus === void 0 ? false : _props$autoFocus,
      _props$readOnly = props.readOnly,
      readOnly = _props$readOnly === void 0 ? false : _props$readOnly,
      onChange = props.onChange,
      onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      styles = props.styles,
      style = props.style,
      className = props.className,
      inputRef = props.inputRef,
      _props$ellipsis = props.ellipsis,
      ellipsis = _props$ellipsis === void 0 ? false : _props$ellipsis,
      width = props.width,
      restProps = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  var innerStyles = useStyles('checkbox', defaultStyles, styles);

  var _useCheckbox = useCheckbox(props, 'checked' in props),
      checkedState = _useCheckbox.checkedState,
      handleChange = _useCheckbox.handleChange;

  return /*#__PURE__*/React.createElement(StyledCheckboxLabel, {
    $disabled: disabled,
    $size: size,
    theme: theme,
    $width: width,
    $checked: checkedState,
    $indeterminate: indeterminate,
    ref: ref,
    className: [innerStyles.wrapper.className, className].join(' ').trim(),
    style: _extends({}, innerStyles.wrapper.style, style),
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave
  }, /*#__PURE__*/React.createElement(StyledCheckboxSpan, _extends({}, innerStyles.span, {
    onClick: function onClick(e) {
      return e.stopPropagation();
    }
  }), /*#__PURE__*/React.createElement(StyledCheckboxInput, _extends({}, restProps, {
    autoFocus: autoFocus,
    readOnly: readOnly,
    ref: inputRef,
    type: "checkbox",
    disabled: disabled,
    checked: checkedState,
    theme: theme,
    onChange: handleChange
  })), /*#__PURE__*/React.createElement(StyledCheckboxIconWrap, _extends({
    theme: theme
  }, innerStyles.iconWrap))), children ? /*#__PURE__*/React.createElement(StyledCheckboxContent, {
    $ellipsis: ellipsis,
    theme: theme
  }, children) : null);
});
Checkbox.useCheckbox = useCheckbox;
Checkbox.__MUYA_CHECKBOX = true;
export default Checkbox;