import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import { useCallback, useState } from 'react';
export function useCheckbox(props, isControlled) {
  var checked = props.checked,
      defaultChecked = props.defaultChecked,
      disabled = props.disabled,
      onChange = props.onChange,
      onClick = props.onClick;

  var _useState = useState((isControlled ? !!checked : defaultChecked) || false),
      _useState2 = _slicedToArray(_useState, 2),
      checkedState = _useState2[0],
      setChecked = _useState2[1];

  var handleChange = useCallback(function (e) {
    if (disabled) {
      return;
    }

    if (!isControlled) {
      setChecked(e.target.checked);
    }

    if (onChange) {
      onChange(e);
    }
  }, [disabled, isControlled, onChange]);
  var handleClick = useCallback(function (e) {
    if (disabled) {
      return;
    }

    if (!isControlled) {
      setChecked(!checkedState);
    }

    if (onClick) {
      onClick(e);
    }
  }, [checkedState, disabled, isControlled, onClick]);

  if (isControlled && !!checked !== checkedState) {
    setChecked(!!checked);
  }

  return {
    checkedState: checkedState,
    handleChange: handleChange,
    handleClick: handleClick,
    setChecked: setChecked
  };
}
export default useCheckbox;