import _extends from "@babel/runtime/helpers/extends";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _uniq from "lodash/uniq";
import _includes from "lodash/includes";
var _excluded = ["children", "activeKeys", "defaultActiveKeys", "accordion", "expandIconPosition", "expandIcon", "onChange"];
import React, { Children, useMemo, useState } from 'react';
import memoForwardRef from '../utils/memoForwardRef';
import useTheme from '../utils/useTheme';
import CollapsePanel from './CollapsePanel';
import { StyledCollapseWrapper } from './styled';
var Collapse = memoForwardRef(function (props, ref) {
  var theme = useTheme();

  var children = props.children,
      activeKeysProp = props.activeKeys,
      _props$defaultActiveK = props.defaultActiveKeys,
      defaultActiveKeysProp = _props$defaultActiveK === void 0 ? [] : _props$defaultActiveK,
      _props$accordion = props.accordion,
      accordion = _props$accordion === void 0 ? false : _props$accordion,
      _props$expandIconPosi = props.expandIconPosition,
      expandIconPosition = _props$expandIconPosi === void 0 ? 'left' : _props$expandIconPosi,
      expandIcon = props.expandIcon,
      onChange = props.onChange,
      other = _objectWithoutProperties(props, _excluded); // 手风琴模式，只取第一个值


  var activeKeys = accordion && activeKeysProp ? activeKeysProp.slice(0, 1) : activeKeysProp;
  var defaultActiveKeys = accordion ? defaultActiveKeysProp.slice(0, 1) : defaultActiveKeysProp;

  var _useState = useState(defaultActiveKeys),
      _useState2 = _slicedToArray(_useState, 2),
      activeKeysState = _useState2[0],
      setActiveKeysState = _useState2[1];

  var isControlled = ('activeKeys' in props);
  var finalActiveKeys = isControlled && activeKeys ? activeKeys : activeKeysState;
  var items = useMemo(function () {
    return Children.map(children, function (c, index) {
      if (! /*#__PURE__*/React.isValidElement(c)) {
        return;
      }

      var child = c;
      var childKey = child.key || index;

      var isActive = _includes(finalActiveKeys, childKey);

      var handleHeaderClick = function handleHeaderClick(e) {
        if (child.props.onHeaderClick) {
          child.props.onHeaderClick(e);
        }

        var newKeys = isActive ? finalActiveKeys.filter(function (k) {
          return childKey !== k;
        }) : _uniq([].concat(_toConsumableArray(finalActiveKeys), [childKey]));

        if (accordion) {
          newKeys = isActive ? [] : [childKey];
        }

        onChange && onChange(newKeys);
        setActiveKeysState(newKeys);
      };

      var childProps = _extends({
        isActive: isActive,
        expandIconPosition: expandIconPosition,
        expandIcon: expandIcon
      }, child.props, {
        onHeaderClick: function onHeaderClick(e) {
          return handleHeaderClick(e);
        }
      });

      return /*#__PURE__*/React.cloneElement(child, childProps);
    });
  }, [accordion, children, expandIcon, expandIconPosition, finalActiveKeys, onChange]);
  return /*#__PURE__*/React.createElement(StyledCollapseWrapper, _extends({
    theme: theme,
    ref: ref
  }, other), items);
});
Collapse.Panel = CollapsePanel;
export default Collapse;