import _extends from "@babel/runtime/helpers/extends";
import { FoldIcon as _FoldIcon } from "@muya-ui/theme-light/es/icons/FoldIcon";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["expandIconPosition", "isActive", "showArrow", "disabled", "header", "children", "extra", "expandIcon", "onHeaderClick", "styles", "appear", "mountOnEnter", "unmountOnExit", "addEndListener", "onEnter", "onEntering", "onEntered", "onExit", "onExited", "onExiting", "enter", "exit"];
import React, { useCallback, useMemo } from 'react';
import Animation from '../Animation';
import ExpandIcon from '../ExpandIcon';
import Space from '../Space';
import Typography from '../Typography';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import { StyledCollapseContent, StyledCollapseHeader, StyledCollapseItem, StyledExpandWrapper } from './styled';
var defaultStyles = {
  header: '',
  content: '',
  expandWrapper: '',
  prefixNodeWrapper: '',
  suffixNodeWrapper: ''
};
export default memoForwardRef(function (props, ref) {
  var theme = useTheme(); // TODO: 其他动画参数透传问题

  var _props$expandIconPosi = props.expandIconPosition,
      expandIconPosition = _props$expandIconPosi === void 0 ? 'left' : _props$expandIconPosi,
      _props$isActive = props.isActive,
      isActive = _props$isActive === void 0 ? false : _props$isActive,
      _props$showArrow = props.showArrow,
      showArrow = _props$showArrow === void 0 ? true : _props$showArrow,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      header = props.header,
      children = props.children,
      extra = props.extra,
      expandIcon = props.expandIcon,
      onHeaderClick = props.onHeaderClick,
      styles = props.styles,
      appear = props.appear,
      mountOnEnter = props.mountOnEnter,
      unmountOnExit = props.unmountOnExit,
      addEndListener = props.addEndListener,
      onEnter = props.onEnter,
      onEntering = props.onEntering,
      onEntered = props.onEntered,
      onExit = props.onExit,
      onExited = props.onExited,
      onExiting = props.onExiting,
      enter = props.enter,
      exit = props.exit,
      other = _objectWithoutProperties(props, _excluded);

  var transitionProps = {
    appear: appear,
    mountOnEnter: mountOnEnter,
    unmountOnExit: unmountOnExit,
    addEndListener: addEndListener,
    onEnter: onEnter,
    onEntering: onEntering,
    onEntered: onEntered,
    onExit: onExit,
    onExited: onExited,
    onExiting: onExiting,
    enter: enter,
    exit: exit
  };
  var innerStyles = useStyles('collapse-panel', defaultStyles, styles);
  var DefaultExpandIcon = theme.components.Collapse.expandIcon || _FoldIcon;
  var handleHeaderClick = useCallback(function (e) {
    if (onHeaderClick && !disabled) {
      onHeaderClick(e);
    }
  }, [disabled, onHeaderClick]);
  var stopPropagation = useCallback(function (e) {
    e.stopPropagation();
  }, []);
  var icon = useMemo(function () {
    if (!showArrow) {
      return null;
    }

    return /*#__PURE__*/React.createElement(StyledExpandWrapper, _extends({
      $expandIconPosition: expandIconPosition,
      theme: theme,
      $expanded: isActive,
      $rotate: -90,
      $expandRotate: 0
    }, innerStyles.expandWrapper), /*#__PURE__*/React.createElement(ExpandIcon, {
      icon: expandIcon,
      DefaultIcon: DefaultExpandIcon,
      disabled: disabled
    }));
  }, [DefaultExpandIcon, disabled, expandIcon, expandIconPosition, innerStyles.expandWrapper, isActive, showArrow, theme]);
  var prefixNode = useMemo(function () {
    var text = /*#__PURE__*/React.createElement(Typography.Text, {
      strong: true
    }, header);

    if (icon && expandIconPosition === 'left') {
      return /*#__PURE__*/React.createElement(Space, innerStyles.prefixNodeWrapper, icon, text);
    }

    return text;
  }, [expandIconPosition, header, icon, innerStyles.prefixNodeWrapper]);
  var suffixNode = useMemo(function () {
    if (icon && expandIconPosition === 'right') {
      return /*#__PURE__*/React.createElement(Space, innerStyles.suffixNodeWrapper, /*#__PURE__*/React.createElement("span", {
        onClick: stopPropagation
      }, extra), icon);
    }

    return /*#__PURE__*/React.createElement("span", {
      onClick: stopPropagation
    }, extra);
  }, [expandIconPosition, extra, icon, innerStyles.suffixNodeWrapper, stopPropagation]);
  return /*#__PURE__*/React.createElement(StyledCollapseItem, _extends({
    ref: ref
  }, other), /*#__PURE__*/React.createElement(StyledCollapseHeader, _extends({}, innerStyles.header, {
    $disabled: disabled,
    onClick: handleHeaderClick,
    theme: theme
  }), prefixNode, suffixNode), /*#__PURE__*/React.createElement(Animation.Collapse, _extends({}, transitionProps, {
    easing: "linear",
    "in": isActive && !disabled
  }), /*#__PURE__*/React.createElement(StyledCollapseContent, innerStyles.content, children)));
});