import _extends from "@babel/runtime/helpers/extends";
import React, { useMemo } from 'react';
import { MultiSelectCalendar } from '../Calendar';
import { StyledPopPanel } from '../styled/components/PopPanel';
import Trigger from '../Trigger';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import { StyledTagsInput } from './styled';
import useMultiSelectDatePicker from './useMultiSelectDatePicker';
import usePickerBase from '../DatePicker/usePickerBase';
var defaultStyles = {
  popPanel: ''
};
var MultiSelectDatePicker = memoForwardRef(function (props, ref) {
  var theme = useTheme();

  var _useMultiSelectDatePi = useMultiSelectDatePicker(props),
      finalUIState = _useMultiSelectDatePi.finalUIState,
      finalValue = _useMultiSelectDatePi.finalValue,
      finalSelectedDate = _useMultiSelectDatePi.finalSelectedDate,
      otherProps = _useMultiSelectDatePi.otherProps,
      handleFocus = _useMultiSelectDatePi.handleFocus,
      handleClear = _useMultiSelectDatePi.handleClear,
      handleCalendarChange = _useMultiSelectDatePi.handleCalendarChange,
      handleCalendarUIChange = _useMultiSelectDatePi.handleCalendarUIChange,
      handleClickAway = _useMultiSelectDatePi.handleClickAway,
      handleAddDate = _useMultiSelectDatePi.handleAddDate,
      handleRemoveDate = _useMultiSelectDatePi.handleRemoveDate,
      handleInputRef = _useMultiSelectDatePi.handleInputRef,
      styles = _useMultiSelectDatePi.styles,
      disabled = _useMultiSelectDatePi.disabled,
      readOnly = _useMultiSelectDatePi.readOnly,
      allowClear = _useMultiSelectDatePi.allowClear,
      calendarStyles = _useMultiSelectDatePi.calendarStyles,
      onSelect = _useMultiSelectDatePi.onSelect,
      container = _useMultiSelectDatePi.container,
      inputReadOnly = _useMultiSelectDatePi.inputReadOnly,
      selectType = _useMultiSelectDatePi.selectType,
      disableRange = _useMultiSelectDatePi.disableRange,
      disableDate = _useMultiSelectDatePi.disableDate,
      options = _useMultiSelectDatePi.options,
      todayDate = _useMultiSelectDatePi.todayDate,
      renderDecadeItem = _useMultiSelectDatePi.renderDecadeItem,
      renderMonthItem = _useMultiSelectDatePi.renderMonthItem,
      renderYearItem = _useMultiSelectDatePi.renderYearItem,
      renderMonthLabel = _useMultiSelectDatePi.renderMonthLabel,
      placement = _useMultiSelectDatePi.placement,
      popperProps = _useMultiSelectDatePi.popperProps,
      arrowPointAtCenter = _useMultiSelectDatePi.arrowPointAtCenter,
      triggerId = _useMultiSelectDatePi.triggerId,
      flip = _useMultiSelectDatePi.flip;

  var inputStyles = useMemo(function () {
    if (!styles) {
      return;
    }

    var inputWrapper = styles.inputWrapper,
        input = styles.input,
        nodeDivider = styles.nodeDivider,
        nodeWrapper = styles.nodeWrapper,
        clearWrapper = styles.clearWrapper,
        statusWrapper = styles.statusWrapper;
    return {
      inputWrapper: inputWrapper,
      input: input,
      nodeDivider: nodeDivider,
      nodeWrapper: nodeWrapper,
      clearWrapper: clearWrapper,
      statusWrapper: statusWrapper
    };
  }, [styles]);
  var currentStyles = useMemo(function () {
    if (!styles) {
      return;
    }

    var popPanel = styles.popPanel;
    return {
      popPanel: popPanel
    };
  }, [styles]);
  var innerStyles = useStyles('date-picker', defaultStyles, currentStyles);

  var _usePickerBase = usePickerBase(),
      innerSuffixNode = _usePickerBase.suffixNode;

  var realNode = /*#__PURE__*/React.createElement(StyledTagsInput, _extends({
    ref: ref,
    $popupVisible: finalUIState.popupOpen,
    $status: otherProps.status,
    inputRef: handleInputRef,
    value: finalValue,
    disabled: disabled,
    onFocus: handleFocus,
    onClear: handleClear,
    suffixNode: innerSuffixNode,
    allowClear: allowClear,
    focusWhenClear: false,
    theme: theme,
    onAddTag: handleAddDate,
    onRemoveTag: handleRemoveDate,
    styles: inputStyles,
    readOnly: readOnly || inputReadOnly,
    maxVerticalTagCount: 2,
    allowAdd: true
  }, otherProps));

  if (disabled || readOnly) {
    return realNode;
  }

  var calendarProps = {
    styles: calendarStyles,
    selectType: selectType,
    disableRange: disableRange,
    disableDate: disableDate,
    options: options,
    todayDate: todayDate,
    onSelect: onSelect,
    allowClear: allowClear,
    renderDecadeItem: renderDecadeItem,
    renderMonthItem: renderMonthItem,
    renderYearItem: renderYearItem,
    renderMonthLabel: renderMonthLabel
  };
  var calendarNode = /*#__PURE__*/React.createElement(StyledPopPanel, _extends({}, innerStyles.popPanel, {
    theme: theme
  }), /*#__PURE__*/React.createElement(MultiSelectCalendar, _extends({
    viewDate: finalUIState.viewDate,
    viewType: finalUIState.viewType,
    selectedDate: finalSelectedDate,
    onChange: handleCalendarChange,
    onUIChange: handleCalendarUIChange
  }, calendarProps)));
  var triggerProps = {
    placement: placement,
    popperProps: popperProps,
    arrowPointAtCenter: arrowPointAtCenter,
    triggerId: triggerId,
    flip: flip,
    hideArrow: true,
    container: container
  };
  return /*#__PURE__*/React.createElement(Trigger, _extends({
    popup: calendarNode,
    triggerAction: "click",
    open: finalUIState.popupOpen,
    onClickAway: handleClickAway
  }, triggerProps), realNode);
});
export default MultiSelectDatePicker;