import _extends from "@babel/runtime/helpers/extends";
import { useForkRef as _useForkRef } from "@muya-ui/utils/es/hooks/useForkRef";
import React, { useMemo, useRef } from 'react';
import { RangeCalendar } from '../Calendar';
import useLocale from '../Locale/useLocale';
import { StyledPopPanel } from '../styled/components/PopPanel';
import Trigger from '../Trigger';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import { StyledRangeInput } from './styled';
import usePickerBase from './usePickerBase';
import useRangeDatePicker from './useRangeDatePicker';
var defaultStyles = {
  popPanel: ''
};
var RangeDatePicker = memoForwardRef(function (props, ref) {
  var theme = useTheme();
  var rangeInputRef = useRef(null);

  var handleRef = _useForkRef(rangeInputRef, ref);

  var _useRangeDatePicker = useRangeDatePicker(props, rangeInputRef),
      finalUIState = _useRangeDatePicker.finalUIState,
      finalState = _useRangeDatePicker.finalState,
      finalValue = _useRangeDatePicker.finalValue,
      otherProps = _useRangeDatePicker.otherProps,
      editKey = _useRangeDatePicker.editKey,
      handleFocus = _useRangeDatePicker.handleFocus,
      handleClear = _useRangeDatePicker.handleClear,
      handleCalendarUIChange = _useRangeDatePicker.handleCalendarUIChange,
      handleInputChange = _useRangeDatePicker.handleInputChange,
      handleClickAway = _useRangeDatePicker.handleClickAway,
      handlePressEnter = _useRangeDatePicker.handlePressEnter,
      handleCalendarChange = _useRangeDatePicker.handleCalendarChange,
      styles = _useRangeDatePicker.styles,
      calendarStyles = _useRangeDatePicker.calendarStyles,
      allowClear = _useRangeDatePicker.allowClear,
      disabled = _useRangeDatePicker.disabled,
      readOnly = _useRangeDatePicker.readOnly,
      selectType = _useRangeDatePicker.selectType,
      disableRange = _useRangeDatePicker.disableRange,
      disableDate = _useRangeDatePicker.disableDate,
      options = _useRangeDatePicker.options,
      todayDate = _useRangeDatePicker.todayDate,
      minRangeLength = _useRangeDatePicker.minRangeLength,
      maxRangeLength = _useRangeDatePicker.maxRangeLength,
      fixedEndDate = _useRangeDatePicker.fixedEndDate,
      fixedStartDate = _useRangeDatePicker.fixedStartDate,
      container = _useRangeDatePicker.container,
      inputReadOnly = _useRangeDatePicker.inputReadOnly,
      renderDecadeItem = _useRangeDatePicker.renderDecadeItem,
      renderMonthItem = _useRangeDatePicker.renderMonthItem,
      renderYearItem = _useRangeDatePicker.renderYearItem,
      renderMonthLabel = _useRangeDatePicker.renderMonthLabel,
      onSelect = _useRangeDatePicker.onSelect,
      placement = _useRangeDatePicker.placement,
      popperProps = _useRangeDatePicker.popperProps,
      arrowPointAtCenter = _useRangeDatePicker.arrowPointAtCenter,
      triggerId = _useRangeDatePicker.triggerId,
      flip = _useRangeDatePicker.flip;

  var _useLocale = useLocale(),
      middleText = _useLocale['DatePicker.middleText'];

  var inputStyles = useMemo(function () {
    if (!styles) {
      return;
    }

    var inputWrapper = styles.inputWrapper,
        headInput = styles.headInput,
        tailInput = styles.tailInput,
        nodeDivider = styles.nodeDivider,
        nodeWrapper = styles.nodeWrapper,
        clearWrapper = styles.clearWrapper;
    return {
      inputWrapper: inputWrapper,
      headInput: headInput,
      tailInput: tailInput,
      nodeDivider: nodeDivider,
      nodeWrapper: nodeWrapper,
      clearWrapper: clearWrapper
    };
  }, [styles]);
  var currentStyles = useMemo(function () {
    if (!styles) {
      return;
    }

    var popPanel = styles.popPanel;
    return {
      popPanel: popPanel
    };
  }, [styles]);
  var innerStyles = useStyles('range-date-picker', defaultStyles, currentStyles);

  var _usePickerBase = usePickerBase(),
      innerSuffixNode = _usePickerBase.suffixNode;

  var realNode = /*#__PURE__*/React.createElement(StyledRangeInput, _extends({}, otherProps, {
    $popupVisible: finalUIState.popupOpen,
    $status: otherProps.status,
    ref: handleRef,
    value: finalValue,
    onChange: handleInputChange,
    onFocus: handleFocus,
    allowClear: allowClear,
    clearReplace: true,
    disabled: disabled,
    middleNode: middleText,
    focusWhenClear: false,
    suffixNode: innerSuffixNode,
    onPressEnter: handlePressEnter,
    onClear: handleClear,
    theme: theme,
    styles: inputStyles,
    readOnly: readOnly || inputReadOnly
  }));

  if (disabled || readOnly) {
    return realNode;
  }

  var rangeCalendarProps = {
    styles: calendarStyles,
    selectType: selectType,
    disableRange: disableRange,
    disableDate: disableDate,
    options: options,
    todayDate: todayDate,
    minRangeLength: minRangeLength,
    maxRangeLength: maxRangeLength,
    fixedEndDate: fixedEndDate,
    fixedStartDate: fixedStartDate,
    allowClear: false,
    renderDecadeItem: renderDecadeItem,
    renderMonthItem: renderMonthItem,
    renderYearItem: renderYearItem,
    renderMonthLabel: renderMonthLabel,
    onSelect: onSelect
  };
  var calendarNode = /*#__PURE__*/React.createElement(StyledPopPanel, _extends({}, innerStyles.popPanel, {
    theme: theme
  }), /*#__PURE__*/React.createElement(RangeCalendar, _extends({}, rangeCalendarProps, {
    onUIChange: handleCalendarUIChange,
    onChange: handleCalendarChange,
    range: finalState.range,
    start: finalState.start,
    end: finalState.end,
    viewDate: finalUIState.viewDate,
    viewType: finalUIState.viewType,
    editKey: editKey
  })));
  var triggerProps = {
    placement: placement,
    popperProps: popperProps,
    arrowPointAtCenter: arrowPointAtCenter,
    triggerId: triggerId,
    flip: flip,
    hideArrow: true,
    container: container
  };
  return /*#__PURE__*/React.createElement(Trigger, _extends({
    popup: calendarNode,
    triggerAction: "click",
    open: finalUIState.popupOpen,
    onClickAway: handleClickAway
  }, triggerProps), realNode);
});
RangeDatePicker.__MUYA_RANGEDATEPICKER = true;
export default RangeDatePicker;