import _extends from "@babel/runtime/helpers/extends";
import React, { useMemo } from 'react';
import { Calendar } from '../Calendar';
import { StyledPopPanel } from '../styled/components/PopPanel';
import Trigger from '../Trigger';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import { StyledInput } from './styled';
import useDatePicker from './useDatePicker';
import usePickerBase from './usePickerBase';
var defaultStyles = {
  popPanel: ''
};
var DatePicker = memoForwardRef(function (props, ref) {
  var theme = useTheme();

  var _useDatePicker = useDatePicker(props),
      finalUIState = _useDatePicker.finalUIState,
      finalValue = _useDatePicker.finalValue,
      finalSelectedDate = _useDatePicker.finalSelectedDate,
      otherProps = _useDatePicker.otherProps,
      handleFocus = _useDatePicker.handleFocus,
      handleClear = _useDatePicker.handleClear,
      handleCalendarChange = _useDatePicker.handleCalendarChange,
      handleCalendarUIChange = _useDatePicker.handleCalendarUIChange,
      handleInputChange = _useDatePicker.handleInputChange,
      handleClickAway = _useDatePicker.handleClickAway,
      handlePressEnter = _useDatePicker.handlePressEnter,
      handleInputRef = _useDatePicker.handleInputRef,
      styles = _useDatePicker.styles,
      disabled = _useDatePicker.disabled,
      readOnly = _useDatePicker.readOnly,
      allowClear = _useDatePicker.allowClear,
      calendarStyles = _useDatePicker.calendarStyles,
      onSelect = _useDatePicker.onSelect,
      container = _useDatePicker.container,
      inputReadOnly = _useDatePicker.inputReadOnly,
      selectType = _useDatePicker.selectType,
      disableRange = _useDatePicker.disableRange,
      disableDate = _useDatePicker.disableDate,
      options = _useDatePicker.options,
      todayDate = _useDatePicker.todayDate,
      renderDecadeItem = _useDatePicker.renderDecadeItem,
      renderMonthItem = _useDatePicker.renderMonthItem,
      renderYearItem = _useDatePicker.renderYearItem,
      renderMonthLabel = _useDatePicker.renderMonthLabel,
      placement = _useDatePicker.placement,
      popperProps = _useDatePicker.popperProps,
      arrowPointAtCenter = _useDatePicker.arrowPointAtCenter,
      triggerId = _useDatePicker.triggerId,
      flip = _useDatePicker.flip;

  var inputStyles = useMemo(function () {
    if (!styles) {
      return;
    }

    var inputWrapper = styles.inputWrapper,
        input = styles.input,
        nodeDivider = styles.nodeDivider,
        nodeWrapper = styles.nodeWrapper,
        clearWrapper = styles.clearWrapper,
        statusWrapper = styles.statusWrapper;
    return {
      inputWrapper: inputWrapper,
      input: input,
      nodeDivider: nodeDivider,
      nodeWrapper: nodeWrapper,
      clearWrapper: clearWrapper,
      statusWrapper: statusWrapper
    };
  }, [styles]);
  var currentStyles = useMemo(function () {
    if (!styles) {
      return;
    }

    var popPanel = styles.popPanel;
    return {
      popPanel: popPanel
    };
  }, [styles]);
  var innerStyles = useStyles('date-picker', defaultStyles, currentStyles);

  var _usePickerBase = usePickerBase(),
      innerSuffixNode = _usePickerBase.suffixNode;

  var realNode = /*#__PURE__*/React.createElement(StyledInput, _extends({
    ref: ref,
    $popupVisible: finalUIState.popupOpen,
    $status: otherProps.status,
    inputRef: handleInputRef,
    value: finalValue,
    disabled: disabled,
    onChange: handleInputChange,
    onFocus: handleFocus,
    onClear: handleClear,
    suffixNode: innerSuffixNode,
    allowClear: allowClear,
    clearReplace: true,
    focusWhenClear: false,
    theme: theme,
    onPressEnter: handlePressEnter,
    styles: inputStyles,
    readOnly: readOnly || inputReadOnly
  }, otherProps));

  if (disabled || readOnly) {
    return realNode;
  }

  var calendarProps = {
    styles: calendarStyles,
    selectType: selectType,
    disableRange: disableRange,
    disableDate: disableDate,
    options: options,
    todayDate: todayDate,
    onSelect: onSelect,
    allowClear: allowClear,
    renderDecadeItem: renderDecadeItem,
    renderMonthItem: renderMonthItem,
    renderYearItem: renderYearItem,
    renderMonthLabel: renderMonthLabel
  };
  var calendarNode = /*#__PURE__*/React.createElement(StyledPopPanel, _extends({}, innerStyles.popPanel, {
    theme: theme
  }), /*#__PURE__*/React.createElement(Calendar, _extends({
    viewDate: finalUIState.viewDate,
    viewType: finalUIState.viewType,
    selectedDate: finalSelectedDate,
    onChange: handleCalendarChange,
    onUIChange: handleCalendarUIChange
  }, calendarProps)));
  var triggerProps = {
    placement: placement,
    popperProps: popperProps,
    arrowPointAtCenter: arrowPointAtCenter,
    triggerId: triggerId,
    flip: flip,
    hideArrow: true,
    container: container
  };
  return /*#__PURE__*/React.createElement(Trigger, _extends({
    popup: calendarNode,
    triggerAction: "click",
    open: finalUIState.popupOpen,
    onClickAway: handleClickAway
  }, triggerProps), realNode);
});
export default DatePicker;