import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["tipAction", "children"];
import React, { forwardRef } from 'react';
import styled, { css } from 'styled-components';
import useTheme from '../utils/useTheme';
var StyledDialogActions = styled.div.withConfig({
  displayName: "StyledDialogActions"
})(["display:flex;flex-flow:row nowrap;align-items:center;box-sizing:border-box;flex:0 0 auto;justify-content:", ";", ""], function (props) {
  return props.tipAction ? 'space-between' : 'flex-end';
}, function (props) {
  if (props.fullWidth) {
    return css(["padding:", ";"], props.theme.components.Dialog.actions.fullWidthPadding);
  }

  return css(["padding:", ";"], props.theme.components.Dialog.actions.complexPadding);
});
var StyledChildrenWrapper = styled.span.withConfig({
  displayName: "StyledChildrenWrapper"
})(["&& > * + *{margin-left:", "px;}"], function (props) {
  return props.theme.components.Dialog.actions.childrenSpacing;
});
export default /*#__PURE__*/forwardRef(function (props, ref) {
  var tipAction = props.tipAction,
      children = props.children,
      other = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  var actions = tipAction ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("span", null, tipAction), /*#__PURE__*/React.createElement(StyledChildrenWrapper, {
    theme: theme
  }, children)) : /*#__PURE__*/React.createElement(StyledChildrenWrapper, {
    theme: theme
  }, children);
  return /*#__PURE__*/React.createElement(StyledDialogActions, _extends({
    ref: ref,
    theme: theme,
    tipAction: tipAction
  }, other), actions);
});