import styled, { css } from 'styled-components';

// 这里没有用min-width，因为容器需要限制宽度，如有需要外部可以禁用默认宽高
function makeContainerStyle(props) {
  var _props$$size = props.$size,
      $size = _props$$size === void 0 ? 'l' : _props$$size,
      $disableSize = props.$disableSize,
      $fullWidth = props.$fullWidth,
      $fullScreen = props.$fullScreen,
      $width = props.$width,
      $height = props.$height,
      $maxHeight = props.$maxHeight,
      theme = props.theme;
  var minSizeStyle;
  var fullWidthStyle;
  var fullScreenStyle;
  var customWidthStyle;
  var customHeightStyle;
  var customMaxHeightStyle; // disableSize为true，禁用默认样式

  if (!$disableSize) {
    var currentMinSize = theme.components.Dialog.size[$size];
    minSizeStyle = css(["width:", "px;min-height:", "px;"], currentMinSize.width, currentMinSize.height);
  }

  if ($fullWidth) {
    var _theme$components$Dia = theme.components.Dialog.fullWidth,
        marginTopAndBottom = _theme$components$Dia.marginTopAndBottom,
        widthPrecent = _theme$components$Dia.widthPrecent;
    fullWidthStyle = css(["left:50%;top:0;transform:translateX(-50%);margin:", "px 0;width:", "%;min-height:calc(100% - ", "px);max-height:calc(100% - ", "px);"], marginTopAndBottom, widthPrecent, 2 * marginTopAndBottom, 2 * marginTopAndBottom);
  }

  if ($fullScreen) {
    fullScreenStyle = css(["left:0;top:0;transform:none;margin:0;width:100%;min-height:100%;max-height:100%;max-width:100%;border-radius:0;"]);
  }

  if ($width) {
    customWidthStyle = css(["width:", ";"], $width);
  }

  if ($height) {
    customHeightStyle = css(["height:", ";"], $height);
  }

  if ($maxHeight) {
    customMaxHeightStyle = css(["max-height:", ";"], $maxHeight);
  }

  return css(["", " ", " ", " ", " ", " ", ""], minSizeStyle, fullWidthStyle, fullScreenStyle, customWidthStyle, customHeightStyle, customMaxHeightStyle);
}

export default styled.div(["", ""], function (props) {
  var _props$theme = props.theme,
      colors = _props$theme.colors,
      token = _props$theme.components.Dialog;
  return css(["display:flex;flex-flow:column nowrap;position:absolute;left:50%;box-sizing:border-box;pointer-events:auto;top:", "%;transform:", ";background:", ";border-radius:", ";box-shadow:", ";", ""], token.top, "translate(-50%, -".concat(token.top, "%)"), colors.pattern.background.higher, token.containerBorderRadius, token.shadow, makeContainerStyle);
});