import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import { CloseIcon as _CloseIcon } from "@muya-ui/theme-light/es/icons/CloseIcon";
var _excluded = ["children", "onClose", "hideClose", "disableTypography", "closeIcon", "closeButtonSize", "level"];
import React from 'react';
import styled, { css } from 'styled-components';
import IconButton from '../IconButton';
import Typography from '../Typography';
import { StyledTitle } from '../Typography/Title';
import memoForwardRef from '../utils/memoForwardRef';
import useTheme from '../utils/useTheme';
var StyledDialogTitle = styled.div.withConfig({
  displayName: "StyledDialogTitle"
})(["position:relative;display:flex;flex-flow:row nowrap;align-items:center;box-sizing:border-box;flex:0 0 auto;", " ", "{margin-bottom:0;}"], function (props) {
  var token = props.theme.components.Dialog.title;
  return css(["border-bottom:", ";padding:", "px ", "px;", ";"], token.borderBottom, token.paddingVertical, token.paddingHorizontal, props.fullWidth && "padding: ".concat(token.fullWidthPadding));
}, StyledTitle);
var StyledIconWrapper = styled(IconButton).withConfig({
  displayName: "StyledIconWrapper"
})(["&&{position:absolute;top:50%;transform:translateY(-50%);right:", "px;padding:0;}"], function (props) {
  return props.theme.components.Dialog.title.paddingHorizontal;
});
export default memoForwardRef(function (props, ref) {
  var theme = useTheme();
  var titleToken = theme.components.Dialog.title;
  var Close = titleToken.closeIcon || _CloseIcon;

  var children = props.children,
      onClose = props.onClose,
      hideClose = props.hideClose,
      disableTypography = props.disableTypography,
      closeIcon = props.closeIcon,
      closeButtonSize = props.closeButtonSize,
      _props$level = props.level,
      level = _props$level === void 0 ? titleToken.defaultTitleLevel : _props$level,
      other = _objectWithoutProperties(props, _excluded);

  return /*#__PURE__*/React.createElement(StyledDialogTitle, _extends({
    ref: ref,
    theme: theme
  }, other), disableTypography ? children : /*#__PURE__*/React.createElement(Typography.Title, {
    level: level
  }, children), !hideClose && /*#__PURE__*/React.createElement(StyledIconWrapper, {
    size: closeButtonSize,
    theme: theme,
    onClick: onClose
  }, closeIcon || /*#__PURE__*/React.createElement(Close, null)));
});