import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["direction", "width", "height", "slideProps", "children", "open", "styles"];
import React, { forwardRef, useMemo } from 'react';
import Animation from '../Animation';
import Dialog from '../Dialog';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import { StyledCustomDialogContainer } from './styled';
var defaultStyles = {
  container: ''
};
export default /*#__PURE__*/forwardRef(function Drawer(props, ref) {
  var _props$direction = props.direction,
      direction = _props$direction === void 0 ? 'left' : _props$direction,
      _props$width = props.width,
      width = _props$width === void 0 ? '30%' : _props$width,
      _props$height = props.height,
      height = _props$height === void 0 ? '40%' : _props$height,
      slideProps = props.slideProps,
      children = props.children,
      open = props.open,
      styles = props.styles,
      other = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  var innerStyles = useStyles('drawer', defaultStyles, styles);
  var customDialogContainer = useMemo(function () {
    return /*#__PURE__*/React.createElement(Animation.Slide, _extends({
      direction: direction,
      minScale: 0,
      timeout: theme.transition.spec.duration.fast,
      "in": open,
      ref: ref
    }, slideProps), /*#__PURE__*/React.createElement(StyledCustomDialogContainer, _extends({
      $direction: direction,
      $width: width,
      $height: height,
      theme: theme
    }, innerStyles.container), children));
  }, [children, direction, height, innerStyles, open, ref, slideProps, theme, width]);
  return /*#__PURE__*/React.createElement(Dialog.Base, _extends({
    customDialogContainer: customDialogContainer,
    open: open,
    ref: ref
  }, other));
});