import styled, { css } from 'styled-components';
export var StyledCustomDialogContainer = styled.div.withConfig({
  displayName: "StyledCustomDialogContainer"
})(["", ""], function (props) {
  var $direction = props.$direction,
      $width = props.$width,
      $height = props.$height,
      theme = props.theme;
  var width = typeof $width === 'number' ? "".concat($width, "px") : $width;
  var height = typeof $height === 'number' ? "".concat($height, "px") : $height;
  var widthStyle = "calc(100% - ".concat(width, ")");
  var heightStyle = "calc(100% - ".concat(height, ")");
  var positionStyle;

  if ($direction === 'up') {
    positionStyle = css(["top:0;bottom:", ";left:0;right:0;"], heightStyle);
  } else if ($direction === 'down') {
    positionStyle = css(["bottom:0;top:", ";left:0;right:0;"], heightStyle);
  } else if ($direction === 'right') {
    positionStyle = css(["top:0;bottom:0;left:", ";right:0;"], widthStyle);
  } else {
    positionStyle = css(["left:0;right:", ";top:0;bottom:0;"], widthStyle);
  }

  return css(["display:flex;flex-flow:column nowrap;position:absolute;box-sizing:border-box;background:", ";z-index:", ";overflow:auto;pointer-events:auto;box-shadow:", ";", ";"], theme.colors.pattern.background.higher, theme.zIndex.pattern.dialog, theme.shadows.spec.s1.normal, positionStyle);
});