import _extends from "@babel/runtime/helpers/extends";
import React from 'react';
import { Button } from '../Button';
import Trigger from '../Trigger';
import memoForwardRef from '../utils/memoForwardRef';
import { StyledDropdownButtonGroup } from './styled';
import useDropdownButton from './useDropdownButton';
var DropdownButton = memoForwardRef(function (props, ref) {
  var _props$group = props.group,
      group = _props$group === void 0 ? false : _props$group,
      _props$type = props.type,
      type = _props$type === void 0 ? 'primary' : _props$type,
      onClick = props.onClick,
      children = props.children;

  var _useDropdownButton = useDropdownButton(props, ref),
      triggerProps = _useDropdownButton.triggerProps,
      buttonProps = _useDropdownButton.buttonProps;

  if (group) {
    return /*#__PURE__*/React.createElement(StyledDropdownButtonGroup, null, /*#__PURE__*/React.createElement(Button, _extends({
      type: type,
      groupType: "head",
      onClick: onClick
    }, buttonProps), children), /*#__PURE__*/React.createElement(Trigger, triggerProps));
  } else {
    return /*#__PURE__*/React.createElement(Trigger, triggerProps);
  }
});
export default DropdownButton;