import _extends from "@babel/runtime/helpers/extends";
import { MoreIcon as _MoreIcon } from "@muya-ui/theme-light/es/icons/MoreIcon";
import { FoldIcon as _FoldIcon } from "@muya-ui/theme-light/es/icons/FoldIcon";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["id", "hideArrow", "group", "type", "children", "disabled", "placement", "overlay", "triggerAction", "triggerActions", "triggerId", "visible", "size", "TransitionComponent", "getPopupContainer", "onOverlayClick", "onVisibleChange", "leaveDelay", "enterDelay", "arrowStyle", "offset", "transitionProps", "outsideCloseable", "escapeKeyCloseable", "onClickAway", "onEscapeKeyDown", "popperNodeRef", "onClick", "dropdownRef"];
import React, { useCallback } from 'react';
import Button from '../Button';
import ExpandIcon from '../ExpandIcon';
import { useTheme } from '../utils/useTheme';
import useDropdown from './useDropdown';
export default function useDropdownButton(props, ref) {
  var id = props.id,
      _props$hideArrow = props.hideArrow,
      hideArrow = _props$hideArrow === void 0 ? true : _props$hideArrow,
      _props$group = props.group,
      group = _props$group === void 0 ? false : _props$group,
      _props$type = props.type,
      type = _props$type === void 0 ? 'primary' : _props$type,
      children = props.children,
      disabled = props.disabled,
      placement = props.placement,
      overlay = props.overlay,
      triggerAction = props.triggerAction,
      triggerActions = props.triggerActions,
      triggerId = props.triggerId,
      visible = props.visible,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      TransitionComponent = props.TransitionComponent,
      getPopupContainer = props.getPopupContainer,
      onOverlayClick = props.onOverlayClick,
      onVisibleChange = props.onVisibleChange,
      leaveDelay = props.leaveDelay,
      enterDelay = props.enterDelay,
      arrowStyle = props.arrowStyle,
      offset = props.offset,
      transitionProps = props.transitionProps,
      outsideCloseable = props.outsideCloseable,
      escapeKeyCloseable = props.escapeKeyCloseable,
      onClickAway = props.onClickAway,
      onEscapeKeyDown = props.onEscapeKeyDown,
      popperNodeRef = props.popperNodeRef,
      onClick = props.onClick,
      dropdownRef = props.dropdownRef,
      other = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  var _theme$components$Dro = theme.components.Dropdown,
      _theme$components$Dro2 = _theme$components$Dro.expandIcon,
      DefaultExpandIcon = _theme$components$Dro2 === void 0 ? _FoldIcon : _theme$components$Dro2,
      _theme$components$Dro3 = _theme$components$Dro.groupExpandIcon,
      GroupExpandIcon = _theme$components$Dro3 === void 0 ? _MoreIcon : _theme$components$Dro3;
  var handleDropdownRef = useCallback(function (refValue) {
    if (typeof dropdownRef === 'function') {
      dropdownRef(refValue);
    } else if (dropdownRef) {
      dropdownRef.current = refValue;
    }
  }, [dropdownRef]);

  var buttonProps = _extends({}, other, {
    size: size,
    disabled: disabled
  });

  var realChildren;

  if (group) {
    realChildren = /*#__PURE__*/React.createElement(Button, _extends({
      type: type
    }, buttonProps, {
      groupType: "tail",
      shape: "square"
    }), props.groupIcon || /*#__PURE__*/React.createElement(GroupExpandIcon, null));
  } else {
    realChildren = /*#__PURE__*/React.createElement(Button, _extends({
      type: type,
      ref: ref,
      onClick: onClick
    }, buttonProps, {
      suffixNode: /*#__PURE__*/React.createElement(ExpandIcon, {
        buttonType: type,
        color: "inherit",
        icon: props.expandIcon,
        DefaultIcon: DefaultExpandIcon,
        disabled: disabled
      })
    }), children);
  }

  var dropdownProps = {
    id: id,
    disabled: disabled,
    placement: placement,
    overlay: overlay,
    triggerAction: triggerAction,
    triggerActions: triggerActions,
    triggerId: triggerId,
    TransitionComponent: TransitionComponent,
    getPopupContainer: getPopupContainer,
    onOverlayClick: onOverlayClick,
    onVisibleChange: onVisibleChange,
    size: size,
    hideArrow: hideArrow,
    leaveDelay: leaveDelay,
    enterDelay: enterDelay,
    arrowStyle: arrowStyle,
    offset: offset,
    transitionProps: transitionProps,
    outsideCloseable: outsideCloseable,
    escapeKeyCloseable: escapeKeyCloseable,
    onClickAway: onClickAway,
    onEscapeKeyDown: onEscapeKeyDown,
    popperNodeRef: popperNodeRef,
    children: realChildren
  };

  if (!('placement' in props)) {
    dropdownProps.placement = group ? 'bottom-end' : 'bottom-start';
  }

  if ('visible' in props) {
    dropdownProps.visible = visible;
  }

  var triggerProps = useDropdown(dropdownProps, handleDropdownRef);
  return {
    buttonProps: buttonProps,
    triggerProps: triggerProps
  };
}