import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _isString from "lodash/isString";
import _isNumber from "lodash/isNumber";
import _get from "lodash/get";
var _excluded = ["enableTooltip", "enableTitle", "customContent", "placement", "children", "color", "fontSize", "lineHeight", "tooltipProps", "style", "ellipsis"];
import React, { useMemo, useRef } from 'react';
import Tooltip from '../Tooltip';
import Typography from '../Typography';
import useEllipsis from '../utils/useEllipsis';
import styled from 'styled-components';
var StyledContentCopy = styled.div.withConfig({
  displayName: "StyledContentCopy"
})(["position:absolute;visibility:hidden;height:0;overflow:hidden;"]);
export var EllipsisContent = /*#__PURE__*/React.memo(function (props) {
  var _props$enableTooltip = props.enableTooltip,
      enableTooltip = _props$enableTooltip === void 0 ? true : _props$enableTooltip,
      enableTitle = props.enableTitle,
      customContent = props.customContent,
      _props$placement = props.placement,
      placement = _props$placement === void 0 ? 'top' : _props$placement,
      children = props.children,
      color = props.color,
      fontSize = props.fontSize,
      lineHeight = props.lineHeight,
      tooltipProps = props.tooltipProps,
      style = props.style,
      _props$ellipsis = props.ellipsis,
      ellipsis = _props$ellipsis === void 0 ? true : _props$ellipsis,
      restProps = _objectWithoutProperties(props, _excluded);

  var paragraphRef = useRef(null);
  var contentCopyRef = useRef(null);
  var multiline = _get(ellipsis, 'rows', 1) > 1;
  var isEllipsis = useEllipsis(paragraphRef, contentCopyRef, multiline, children);
  var innerStyle = useMemo(function () {
    var innerStyle = style || {};

    if (!color && !innerStyle.color) {
      innerStyle.color = 'inherit';
    }

    if (!fontSize && !innerStyle.fontSize) {
      innerStyle.fontSize = 'inherit';
    }

    if (!lineHeight && !innerStyle.lineHeight) {
      innerStyle.lineHeight = 'inherit';
    }

    return innerStyle;
  }, [color, fontSize, lineHeight, style]);
  var ellipsisParagraph = useMemo(function () {
    var content = customContent || children;
    return /*#__PURE__*/React.createElement(Typography.Paragraph, _extends({
      ref: paragraphRef,
      as: "div",
      ellipsis: ellipsis,
      style: innerStyle,
      color: color,
      fontSize: fontSize,
      title: enableTitle && isEllipsis && (_isString(content) || _isNumber(content)) ? content : undefined
    }, restProps), children, !multiline && /*#__PURE__*/React.createElement(StyledContentCopy, {
      ref: contentCopyRef
    }, children));
  }, [children, color, customContent, ellipsis, enableTitle, fontSize, innerStyle, isEllipsis, multiline, restProps]);

  if (enableTooltip && !enableTitle && isEllipsis) {
    return /*#__PURE__*/React.createElement(Tooltip, _extends({}, tooltipProps, {
      title: customContent || children,
      placement: placement
    }), ellipsisParagraph);
  } else {
    return ellipsisParagraph;
  }
});
export default EllipsisContent;