import _extends from "@babel/runtime/helpers/extends";
import { RightIcon as _RightIcon } from "@muya-ui/theme-light/es/icons/RightIcon";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["icon", "DefaultIcon", "iconSize", "buttonType", "color"];
import React from 'react';
import IconButton from '../IconButton';
import addPx from '../utils/addPx';
import useTheme from '../utils/useTheme';
var ExpandIcon = /*#__PURE__*/React.memo(function (props) {
  var theme = useTheme();
  var token = theme.components.ExpandIcon;

  var _props$icon = props.icon,
      icon = _props$icon === void 0 ? token.expandIcon : _props$icon,
      _props$DefaultIcon = props.DefaultIcon,
      DefaultIcon = _props$DefaultIcon === void 0 ? _RightIcon : _props$DefaultIcon,
      _props$iconSize = props.iconSize,
      iconSize = _props$iconSize === void 0 ? token.size : _props$iconSize,
      _props$buttonType = props.buttonType,
      buttonType = _props$buttonType === void 0 ? 'weak' : _props$buttonType,
      color = props.color,
      resetProps = _objectWithoutProperties(props, _excluded);

  if (color === 'inherit') {
    return /*#__PURE__*/React.createElement(React.Fragment, null, icon || /*#__PURE__*/React.createElement(DefaultIcon, {
      color: color,
      fontSize: addPx(iconSize)
    }));
  }

  return /*#__PURE__*/React.createElement(IconButton, _extends({
    type: buttonType,
    tabIndex: -1
  }, resetProps), icon || /*#__PURE__*/React.createElement(DefaultIcon, {
    color: color,
    fontSize: addPx(iconSize)
  }));
});
export default ExpandIcon;