import styled, { css } from 'styled-components';
export var StyledLabel = styled.label.withConfig({
  displayName: "StyledLabel"
})([""]);
export var StyledInnerLabel = styled.span.withConfig({
  displayName: "StyledInnerLabel"
})([""]);
export var StyledInputWrapper = styled.div.withConfig({
  displayName: "StyledInputWrapper"
})([""]);
export var StyledRequiredWrapper = styled.div.withConfig({
  displayName: "StyledRequiredWrapper"
})([""]);
export var StyledError = styled.div.withConfig({
  displayName: "StyledError"
})([""]);
export var StyledExtra = styled.div.withConfig({
  displayName: "StyledExtra"
})([""]);
export var InstantEditingWrapper = styled.div.withConfig({
  displayName: "InstantEditingWrapper"
})(["", ""], function (props) {
  if (props.$isEditing) {
    return css(["&,& *{visibility:hidden;opacity:0;height:0;margin:0;}"]);
  }
});
export var InstantEditingContentWrapper = styled.div.withConfig({
  displayName: "InstantEditingContentWrapper"
})(["", ""], function (props) {
  var theme = props.theme,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size;
  var inputToken = theme.components.Input;
  return css(["display:flex;align-items:center;box-sizing:border-box;height:", " color:", ";height:", "px;font-size:", "px;line-height:", "px;border:1px solid transparent;padding:0 ", "px;&:hover{border-color:", ";}"], size, inputToken.color, inputToken.inputHeight[size], theme.typography.spec.fontSize[inputToken.fontLevel[size]], theme.typography.spec.lineHeight[inputToken.fontLevel[size]], inputToken.inputPadding[size], inputToken.borderColor.normal);
});
export var StyledFormItem = styled.div.withConfig({
  displayName: "StyledFormItem"
})(["", ""], function (props) {
  var $inline = props.$inline,
      $labelWidth = props.$labelWidth,
      $labelPosition = props.$labelPosition,
      $size = props.$size,
      $theme = props.$theme,
      $inlineAndNoLabel = props.$inlineAndNoLabel,
      $inlineSpacing = props.$inlineSpacing,
      $instantEditing = props.$instantEditing;
  var _$theme$components$Fo = $theme.components.Form,
      labelPaddingRight = _$theme$components$Fo.labelPaddingRight,
      labelHeight = _$theme$components$Fo.labelHeight,
      topLabelPaddingBottom = _$theme$components$Fo.topLabelPaddingBottom,
      requiredTipMarginRight = _$theme$components$Fo.requiredTipMarginRight,
      requiredFontLevel = _$theme$components$Fo.requiredFontLevel,
      labelFontSizeLevel = _$theme$components$Fo.labelFontSizeLevel,
      errorMinHeight = _$theme$components$Fo.errorMinHeight,
      errorPaddingBottom = _$theme$components$Fo.errorPaddingBottom,
      errorPaddingTop = _$theme$components$Fo.errorPaddingTop,
      labelColor = _$theme$components$Fo.labelColor,
      instantEditingLabelColor = _$theme$components$Fo.instantEditingLabelColor; // inline模式 & 没有传label，label容器是不渲染的，error也就不需要margin-left了

  var errorMarginStyle = css(["margin-left:", ";"], $inlineAndNoLabel ? 0 : $labelWidth); // label在上时要特殊处理

  var labelStyle = $labelPosition === 'top' ? css(["& > ", "{flex-flow:column nowrap;& > ", "{text-align:left;padding-bottom:", "px;}}"], StyledInputWrapper, StyledLabel, topLabelPaddingBottom[$size]) : css(["& > ", ",& > ", "{", "}& > ", "{align-items:center;& > ", "{display:flex;align-items:center;align-self:flex-start;width:", ";min-height:", "px;justify-content:", ";padding-right:", "px;}}"], StyledError, StyledExtra, errorMarginStyle, StyledInputWrapper, StyledLabel, $labelWidth, labelHeight[$size], $labelPosition === 'right' ? 'flex-end' : 'flex-start', labelPaddingRight[$size]);
  return css(["vertical-align:top;", " ", "{display:inline-block;position:relative;box-sizing:border-box;flex-shrink:0;font-size:", "px;line-height:", "px;color:", ";}", "{margin-right:", "px;color:", ";font-size:", "px;line-height:1;padding-top:2px;}", ",", "{box-sizing:border-box;padding-top:", "px;padding-bottom:", "px;min-height:", "px;}", "{display:inline-flex;position:relative;align-items:flex-start;}", "{display:flex;}", ""], $inline && css(["display:inline-block;margin-right:", "px;&:last-of-type{margin-right:0;}"], $inlineSpacing), StyledLabel, $theme.typography.spec.fontSize[labelFontSizeLevel[$size]], $theme.typography.spec.lineHeight[labelFontSizeLevel[$size]], $instantEditing ? instantEditingLabelColor : labelColor, StyledRequiredWrapper, requiredTipMarginRight, $theme.colors.spec.danger, $theme.typography.spec.fontSize[requiredFontLevel], StyledError, StyledExtra, errorPaddingTop, errorPaddingBottom, errorMinHeight[$size], StyledInnerLabel, StyledInputWrapper, labelStyle);
});