import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "span", "order", "offset", "push", "pull", "styles", "className", "style"];
import React, { useMemo } from 'react';
import useStyles from '../utils/useStyles';
import { useRow } from './RowContext';
import { StyledCol } from './styled';
import { getBreakpointProp, getResponsiveProp } from './utils';
var Col = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      span = props.span,
      order = props.order,
      offset = props.offset,
      push = props.push,
      pull = props.pull,
      styles = props.styles,
      className = props.className,
      style = props.style,
      restProps = _objectWithoutProperties(props, _excluded);

  var innerStyles = useStyles('col', {
    wrapper: ''
  }, styles);

  var _useRow = useRow(),
      gutter = _useRow.gutter,
      breakpoint = _useRow.breakpoint,
      equalNum = _useRow.equalNum;

  var sizeProps = useMemo(function () {
    return {
      span: getResponsiveProp(getBreakpointProp(props, 'span'), breakpoint),
      order: getResponsiveProp(getBreakpointProp(props, 'order'), breakpoint),
      pull: getResponsiveProp(getBreakpointProp(props, 'pull'), breakpoint),
      push: getResponsiveProp(getBreakpointProp(props, 'push'), breakpoint),
      offset: getResponsiveProp(getBreakpointProp(props, 'offset'), breakpoint)
    };
  }, [breakpoint, props]);
  return /*#__PURE__*/React.createElement(StyledCol, _extends({}, restProps, {
    className: [innerStyles.wrapper.className, className].join(' ').trim(),
    style: _extends({}, innerStyles.wrapper.style, style),
    ref: ref,
    $gutter: gutter,
    $equalNum: equalNum,
    $span: sizeProps.span,
    $order: sizeProps.order,
    $offset: sizeProps.offset,
    $push: sizeProps.push,
    $pull: sizeProps.pull
  }), children);
});
export default Col;