import _extends from "@babel/runtime/helpers/extends";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _typeof from "@babel/runtime/helpers/typeof";
import { useMedia as _useMedia } from "@muya-ui/utils/es/hooks/useMedia";
import { breakpointsUtils as _breakpointsUtils } from "@muya-ui/theme-light/es/utils";
import { breakpointKeys as _breakpointKeys } from "@muya-ui/theme-light/es/utils";

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

import React, { useMemo } from 'react';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import RowContext, { defaultBreakpoint } from './RowContext';
import { StyledRow } from './styled';
var defaultStyles = {
  wrapper: ''
};
var Row = memoForwardRef(function (props, ref) {
  var children = props.children,
      _props$align = props.align,
      align = _props$align === void 0 ? 'top' : _props$align,
      _props$justify = props.justify,
      justify = _props$justify === void 0 ? 'start' : _props$justify,
      _props$gutter = props.gutter,
      gutterProp = _props$gutter === void 0 ? 0 : _props$gutter,
      equalNumProp = props.equalNum,
      styles = props.styles,
      className = props.className,
      style = props.style;
  var innerStyles = useStyles('row', defaultStyles, styles);
  var theme = useTheme();
  var breakpointsMap = theme.breakpoints.spec.breakpointsMap;
  var responsiveMap = useMemo(function () {
    return _breakpointKeys.map(function (key) {
      return _breakpointsUtils.only({
        breakpointsMap: breakpointsMap
      }, key).replace('@media ', '');
    });
  }, [breakpointsMap]);

  var breakpoint = _useMedia(responsiveMap, _breakpointKeys, defaultBreakpoint);

  var gutter = useMemo(function () {
    if (gutterProp && _typeof(gutterProp) === 'object') {
      var flag = false;
      var latestNum;

      var _iterator = _createForOfIteratorHelper(_toConsumableArray(_breakpointKeys).reverse()),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var point = _step.value;

          if (breakpoint === point) {
            flag = true;
          }

          if (gutterProp[point]) {
            latestNum = gutterProp[point];
          }

          if (flag && gutterProp[point]) {
            return gutterProp[point];
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      return latestNum;
    }

    return gutterProp;
  }, [breakpoint, gutterProp]);
  var equalNum = useMemo(function () {
    if (equalNumProp && _typeof(equalNumProp) === 'object') {
      var flag = false;
      var latestNum;

      var _iterator2 = _createForOfIteratorHelper(_toConsumableArray(_breakpointKeys).reverse()),
          _step2;

      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var point = _step2.value;

          if (breakpoint === point) {
            flag = true;
          }

          if (equalNumProp[point]) {
            latestNum = equalNumProp[point];
          }

          if (flag && equalNumProp[point]) {
            return equalNumProp[point];
          }
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }

      return latestNum;
    }

    return equalNumProp;
  }, [breakpoint, equalNumProp]);
  return /*#__PURE__*/React.createElement(RowContext.Provider, {
    value: {
      gutter: gutter,
      breakpoint: breakpoint,
      equalNum: equalNum
    }
  }, /*#__PURE__*/React.createElement(StyledRow, _extends({}, props, {
    className: [innerStyles.wrapper.className, className].join(' ').trim(),
    style: _extends({}, innerStyles.wrapper.style, style),
    ref: ref,
    theme: theme,
    $align: align,
    $justify: justify,
    $gutter: gutter
  }), children));
});
export default Row;