import styled, { css } from 'styled-components';
var alignMap = {
  top: 'flex-start',
  middle: 'center',
  bottom: 'flex-end'
};
var justifyMap = {
  start: 'flex-start',
  end: 'flex-end',
  center: 'center',
  'space-around': 'space-around',
  'space-between': 'space-between'
};
export var StyledRow = styled.div.withConfig({
  displayName: "StyledRow"
})(["display:flex;flex-flow:row wrap;box-sizing:border-box;", " ", " ", " &::before,&::after{display:flex;}"], function (props) {
  return props.$align && "align-items: ".concat(alignMap[props.$align], ";");
}, function (props) {
  return props.$justify && "justify-content: ".concat(justifyMap[props.$justify], ";");
}, function (props) {
  return props.$gutter && "margin-left: ".concat(props.$gutter / -2, "px; margin-right: ").concat(props.$gutter / -2, "px;");
});
export var StyledCol = styled.div.withConfig({
  displayName: "StyledCol"
})(["position:relative;flex:0 0 auto;box-sizing:border-box;min-height:1px;", ""], function (props) {
  var $equalNum = props.$equalNum,
      $gutter = props.$gutter,
      $order = props.$order,
      $span = props.$span,
      $offset = props.$offset,
      $pull = props.$pull,
      $push = props.$push;
  var commonStyle = css(["", "};", ";"], $gutter && "padding-left: ".concat($gutter / 2, "px; padding-right: ").concat($gutter / 2, "px;"), $order && "order: ".concat(props.$order, ";"));

  if ($equalNum) {
    return css(["width:", ";", ";"], "".concat(1 / $equalNum * 100, "%"), commonStyle);
  } else {
    return css(["", " ", " ", ";", ";", ";"], $span && "width: ".concat($span / 24 * 100, "%;"), $offset && "margin-left: ".concat($offset / 24 * 100, "%;"), $push && "left: ".concat($push / 24 * 100, "%;"), $pull && "right: ".concat($pull / 24 * 100, "%;"), commonStyle);
  }
});