import { breakpointKeys as _breakpointKeys } from "@muya-ui/theme-light/es/utils";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _typeof from "@babel/runtime/helpers/typeof";

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

export var getPropFromBreakpoint = function getPropFromBreakpoint(breakpointData, prop) {
  if (breakpointData && _typeof(breakpointData) === 'object') {
    return breakpointData[prop];
  } else {
    if (prop === 'span') {
      return breakpointData;
    }
  }
};
export var getBreakpointProp = function getBreakpointProp(props, prop) {
  var currentProp = props[prop],
      _props$xs = props.xs,
      xs = _props$xs === void 0 ? {} : _props$xs,
      _props$sm = props.sm,
      sm = _props$sm === void 0 ? {} : _props$sm,
      _props$md = props.md,
      md = _props$md === void 0 ? {} : _props$md,
      _props$lg = props.lg,
      lg = _props$lg === void 0 ? {} : _props$lg,
      _props$xl = props.xl,
      xl = _props$xl === void 0 ? {} : _props$xl;
  return {
    xs: getPropFromBreakpoint(xs, prop) || currentProp,
    sm: getPropFromBreakpoint(sm, prop) || currentProp,
    md: getPropFromBreakpoint(md, prop) || currentProp,
    lg: getPropFromBreakpoint(lg, prop) || currentProp,
    xl: getPropFromBreakpoint(xl, prop) || currentProp
  };
};
/**
 * 获取响应式属性的最终值
 * @param prop 直接从 props 中读取的属性
 * @param propFromBreakpointProp 从 xs、sm、md、lg、xl 中解析出来的属性
 * @param breakpoint 当前的断点
 * @param breakpointKeys 断点的 key
 */

export var getResponsiveProp = function getResponsiveProp(prop, breakpoint) {
  var flag = false;

  var _iterator = _createForOfIteratorHelper(_toConsumableArray(_breakpointKeys).reverse()),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var point = _step.value;

      if (breakpoint === point) {
        flag = true;
      }

      if (flag && prop[point]) {
        return prop[point];
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
};