import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["steps", "onRequestClose"];
import React from 'react';
import Portal from '../Portal';
import memoForwardRef from '../utils/memoForwardRef';
import PopoverCard from './PopoverCard';
import SVGMask from './SvgMask';
import useGuide from './useGuide';
var Guide = memoForwardRef(function (props, ref) {
  var steps = props.steps,
      onRequestClose = props.onRequestClose,
      others = _objectWithoutProperties(props, _excluded);

  var _useGuide = useGuide(props),
      isOpen = _useGuide.isOpen,
      goTo = _useGuide.goTo,
      nextStep = _useGuide.nextStep,
      close = _useGuide.close,
      current = _useGuide.current;

  if (!isOpen) return null;
  return /*#__PURE__*/React.createElement(Portal, null, /*#__PURE__*/React.createElement(SVGMask, _extends({}, others, {
    steps: steps,
    nextStep: nextStep,
    currentIndex: current,
    close: close,
    goTo: goTo,
    ref: ref
  })));
});
Guide.PopoverCard = PopoverCard;
export default Guide;