import _extends from "@babel/runtime/helpers/extends";
import { CloseIcon as _CloseIcon } from "@muya-ui/theme-light/es/icons/CloseIcon";
import { InformIcon as _InformIcon } from "@muya-ui/theme-light/es/icons/InformIcon";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["showIcon", "customIcon", "title", "description", "actions", "showClose", "onClose", "placement"];
import React, { useMemo } from 'react';
import Typography from '../Typography';
import memoForwardRef from '../utils/memoForwardRef';
import useTheme from '../utils/useTheme';
import { StyledActions, StyledDesc, StyledGuidePopoverCard, StyledPopoverCardCloseIcon, StyledPopoverCardIcon } from './styled';
var GuidePopoverCard = memoForwardRef(function (props, ref) {
  var _props$showIcon = props.showIcon,
      showIcon = _props$showIcon === void 0 ? true : _props$showIcon,
      customIcon = props.customIcon,
      title = props.title,
      description = props.description,
      actions = props.actions,
      showClose = props.showClose,
      onClose = props.onClose,
      _props$placement = props.placement,
      placement = _props$placement === void 0 ? 'right' : _props$placement,
      restProps = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  var token = theme.components.Guide;
  var FinalInformIcon = token.informIcon.Icon || _InformIcon;
  var FinalCloseIcon = token.closeIcon.Icon || _CloseIcon;
  var arrowStyle = useMemo(function () {
    return {
      color: token.popoverCard.bgColor
    };
  }, [token.popoverCard.bgColor]);
  var titleStyle = useMemo(function () {
    return {
      color: token.popoverCard.titleColor
    };
  }, [token.popoverCard.titleColor]);
  var content = useMemo(function () {
    return /*#__PURE__*/React.createElement(React.Fragment, null, showIcon && /*#__PURE__*/React.createElement(StyledPopoverCardIcon, null, customIcon || /*#__PURE__*/React.createElement(FinalInformIcon, null)), /*#__PURE__*/React.createElement(Typography.Title, {
      level: token.popoverCard.titleLevel,
      style: titleStyle
    }, title), description && /*#__PURE__*/React.createElement(StyledDesc, null, description), actions && /*#__PURE__*/React.createElement(StyledActions, null, actions), showClose && /*#__PURE__*/React.createElement(StyledPopoverCardCloseIcon, {
      onClick: onClose
    }, /*#__PURE__*/React.createElement(FinalCloseIcon, null)));
  }, [actions, customIcon, description, onClose, showClose, showIcon, title, titleStyle, token.popoverCard.titleLevel]);
  return /*#__PURE__*/React.createElement(StyledGuidePopoverCard, _extends({
    ref: ref,
    theme: theme,
    content: content,
    arrowStyle: arrowStyle,
    placement: placement,
    $showIcon: showIcon,
    $showClose: !!showClose,
    $hasDesc: !!description,
    zIndex: token.popoverCard.zIndex
  }, restProps));
});
export default GuidePopoverCard;