import _extends from "@babel/runtime/helpers/extends";
import { CloseIcon as _CloseIcon } from "@muya-ui/theme-light/es/icons/CloseIcon";
import { InformIcon as _InformIcon } from "@muya-ui/theme-light/es/icons/InformIcon";
import { useLockScroll as _useLockScroll } from "@muya-ui/utils/es/hooks/useLockScroll";
import React, { useMemo } from 'react';
import memoForwardRef from '../utils/memoForwardRef';
import { safe } from './utils';
import { Typography } from '../Typography';
import { Button } from '../Button';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import { ButtonWrapper, CloseIconWrapper, SkipWrapper, StyledIcon, TextWrapper, TitleWrapper, ToolTipsContent, SvgMaskWrapper } from './styled';
import useLocale from '../Locale/useLocale';
import useSvgMask from './useSvgMask';
import Trigger from '../Trigger';
var defaultStyles = {
  content: '',
  text: '',
  next: '',
  close: '',
  skip: '',
  inform: '',
  title: '',
  subTitle: ''
};
export default memoForwardRef(function (props, ref) {
  var local = useLocale();
  var theme = useTheme();
  var _props$rounded = props.rounded,
      rounded = _props$rounded === void 0 ? 0 : _props$rounded,
      styles = props.styles,
      _props$showClose = props.showClose,
      showClose = _props$showClose === void 0 ? true : _props$showClose,
      _props$showSkip = props.showSkip,
      showSkip = _props$showSkip === void 0 ? true : _props$showSkip,
      currentIndex = props.currentIndex,
      nextStep = props.nextStep,
      _props$skipText = props.skipText,
      skipText = _props$skipText === void 0 ? local['Guide.skip'] : _props$skipText,
      _props$confirmText = props.confirmText,
      confirmText = _props$confirmText === void 0 ? local['Guide.confirm'] : _props$confirmText,
      _props$steps = props.steps,
      steps = _props$steps === void 0 ? [] : _props$steps,
      nextText = props.nextText,
      _props$offset = props.offset,
      offset = _props$offset === void 0 ? 10 : _props$offset,
      _props$maskClassName = props.maskClassName,
      maskClassName = _props$maskClassName === void 0 ? "".concat(theme.prefix, "-guide-mask") : _props$maskClassName,
      _props$disableInterac = props.disableInteraction,
      disableInteraction = _props$disableInterac === void 0 ? true : _props$disableInterac,
      _props$dashed = props.dashed,
      dashed = _props$dashed === void 0 ? false : _props$dashed,
      arrowStyle = props.arrowStyle,
      close = props.close,
      guidePopperProps = props.popperProps;
  var innerStyles = useStyles('guide', defaultStyles, styles);

  var _useSvgMask = useSvgMask(props),
      left = _useSvgMask.left,
      height = _useSvgMask.height,
      width = _useSvgMask.width,
      hasCustomContent = _useSvgMask.hasCustomContent,
      stepContent = _useSvgMask.stepContent,
      state = _useSvgMask.state,
      disabled = _useSvgMask.disabled,
      handleMaskClick = _useSvgMask.handleMaskClick,
      top = _useSvgMask.top,
      innerWidth = _useSvgMask.innerWidth,
      innerHeight = _useSvgMask.innerHeight;

  _useLockScroll(true);

  var dashedPadding = 8;
  var currentOffset = dashed ? offset + dashedPadding : offset;
  var _steps$currentIndex = steps[currentIndex],
      _steps$currentIndex$s = _steps$currentIndex.showNextButton,
      showNextButton = _steps$currentIndex$s === void 0 ? true : _steps$currentIndex$s,
      customTextWrapper = _steps$currentIndex.customTextWrapper,
      _steps$currentIndex$p = _steps$currentIndex.position,
      position = _steps$currentIndex$p === void 0 ? 'bottom' : _steps$currentIndex$p,
      subTitle = _steps$currentIndex.subTitle,
      popperProps = _steps$currentIndex.popperProps;
  var token = theme.components.Guide;
  var Inform = token.informIcon.Icon || _InformIcon;
  var Close = token.closeIcon.Icon || _CloseIcon;
  var buttonTitle = currentIndex === steps.length - 1 ? confirmText : nextText || "".concat(local['Guide.nextStep'], "(").concat(currentIndex + 1, "/").concat(steps.length, ")");
  var currentPopperProps = popperProps || guidePopperProps || {};
  var finalArrowStyle = useMemo(function () {
    return _extends({
      color: theme.colors.pattern.background.higher
    }, arrowStyle);
  }, [arrowStyle, theme.colors.pattern.background.higher]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, state.length ? /*#__PURE__*/React.createElement(SvgMaskWrapper, {
    onClick: handleMaskClick,
    theme: theme
  }, /*#__PURE__*/React.createElement("svg", {
    width: innerWidth,
    height: innerHeight,
    xmlns: "http://www.w3.org/2000/svg",
    className: maskClassName
  }, /*#__PURE__*/React.createElement("defs", null, /*#__PURE__*/React.createElement("mask", {
    id: "mask-main"
  }, /*#__PURE__*/React.createElement("rect", {
    x: 0,
    y: 0,
    width: innerWidth,
    height: innerHeight,
    fill: "white"
  }), /*#__PURE__*/React.createElement("rect", {
    x: left,
    y: top,
    width: width,
    height: height,
    fill: "black"
  }), /*#__PURE__*/React.createElement("rect", {
    x: left - 1,
    y: top - 1,
    width: rounded,
    height: rounded,
    fill: "white"
  }), /*#__PURE__*/React.createElement("circle", {
    cx: left + rounded,
    cy: top + rounded,
    r: rounded,
    fill: "black"
  }), /*#__PURE__*/React.createElement("rect", {
    x: left + width - rounded + 1,
    y: top - 1,
    width: rounded,
    height: rounded,
    fill: "white"
  }), /*#__PURE__*/React.createElement("circle", {
    cx: left + width - rounded,
    cy: top + rounded,
    r: rounded,
    fill: "black"
  }), /*#__PURE__*/React.createElement("rect", {
    x: left - 1,
    y: top + height - rounded + 1,
    width: rounded,
    height: rounded,
    fill: "white"
  }), /*#__PURE__*/React.createElement("circle", {
    cx: left + rounded,
    cy: top + height - rounded,
    r: rounded,
    fill: "black"
  }), /*#__PURE__*/React.createElement("rect", {
    x: left + width - rounded + 1,
    y: top + height - rounded + 1,
    width: rounded,
    height: rounded,
    fill: "white"
  }), /*#__PURE__*/React.createElement("circle", {
    cx: left + width - rounded,
    cy: top + height - rounded,
    r: rounded,
    fill: "black "
  })), /*#__PURE__*/React.createElement("clipPath", {
    id: "clip-path"
  }, /*#__PURE__*/React.createElement("rect", {
    x: 0,
    y: 0,
    width: innerWidth,
    height: top
  }), /*#__PURE__*/React.createElement("rect", {
    x: 0,
    y: top,
    width: left,
    height: height
  }), /*#__PURE__*/React.createElement("rect", {
    x: left + width,
    y: top,
    width: safe(innerWidth - width - left),
    height: height
  }), /*#__PURE__*/React.createElement("rect", {
    x: 0,
    y: top + height,
    width: innerWidth,
    height: safe(innerWidth - height - top)
  }))), /*#__PURE__*/React.createElement("rect", {
    x: 0,
    y: 0,
    width: innerWidth,
    height: innerHeight,
    fill: "currentColor",
    mask: "url(#mask-main)",
    pointerEvents: "auto"
  }), /*#__PURE__*/React.createElement(Trigger, {
    open: true,
    placement: position,
    offset: currentOffset,
    arrowStyle: finalArrowStyle,
    popperProps: currentPopperProps,
    popup: /*#__PURE__*/React.createElement(ToolTipsContent, _extends({
      theme: theme
    }, innerStyles.content, {
      $hasCustomContent: hasCustomContent,
      ref: ref
    }), hasCustomContent ? /*#__PURE__*/React.createElement(React.Fragment, null, stepContent) : /*#__PURE__*/React.createElement(React.Fragment, null, customTextWrapper ? customTextWrapper : /*#__PURE__*/React.createElement(TextWrapper, innerStyles.text, /*#__PURE__*/React.createElement(StyledIcon, _extends({
      theme: theme
    }, innerStyles.inform), /*#__PURE__*/React.createElement(Inform, null)), /*#__PURE__*/React.createElement(TitleWrapper, null, /*#__PURE__*/React.createElement(Typography.Title, _extends({
      level: token.titleLevel
    }, innerStyles.title), stepContent), subTitle ? /*#__PURE__*/React.createElement(Typography.Paragraph, _extends({
      color: "assistant",
      marginTop: token.subTitleMarginTop
    }, innerStyles.subTitle), subTitle) : null)), showNextButton ? /*#__PURE__*/React.createElement(ButtonWrapper, _extends({
      theme: theme
    }, innerStyles.next), /*#__PURE__*/React.createElement(Button, {
      onClick: function onClick(_) {
        return nextStep();
      },
      type: "primary",
      disabled: disabled
    }, buttonTitle)) : null, showClose ? /*#__PURE__*/React.createElement(CloseIconWrapper, _extends({
      type: "weak",
      theme: theme,
      onClick: close
    }, innerStyles.close), /*#__PURE__*/React.createElement(Close, {
      fontSize: token.closeIcon.fontSize
    })) : null, showSkip ? /*#__PURE__*/React.createElement(SkipWrapper, _extends({
      theme: theme,
      onClick: close
    }, innerStyles.skip), /*#__PURE__*/React.createElement(Typography.Text, {
      color: "disabled"
    }, skipText)) : null))
  }, /*#__PURE__*/React.createElement("rect", {
    x: left,
    y: top,
    width: width,
    height: height,
    pointerEvents: "auto",
    fill: "transparent",
    display: "block",
    visibility: !disableInteraction ? 'hidden' : 'none'
  })), dashed ? /*#__PURE__*/React.createElement("rect", {
    x: left - dashedPadding,
    y: top - dashedPadding,
    width: width + dashedPadding * 2,
    height: height + dashedPadding * 2,
    pointerEvents: "auto",
    stroke: "white",
    strokeDasharray: "4 4",
    fill: "transparent",
    display: "block",
    visibility: "none"
  }) : null)) : null);
});