import { colorUtils as _colorUtils } from "@muya-ui/theme-light/es/utils";
import styled, { css } from 'styled-components';
import IconButton from '../IconButton';
import PopoverCard from '../PopoverCard';
import Typography from '../Typography';
import { StyledTitle } from '../Typography/Title';
export var CloseIconWrapper = styled(IconButton).withConfig({
  displayName: "CloseIconWrapper"
})(["", ""], function (props) {
  var _props$theme$componen = props.theme.components.Guide.closeIcon,
      top = _props$theme$componen.top,
      right = _props$theme$componen.right;
  return css(["position:absolute;right:", "px;top:", "px;"], right, top);
});
export var ToolTipsContent = styled.div.withConfig({
  displayName: "ToolTipsContent"
})(["box-sizing:border-box;", ""], function (props) {
  var _props$theme = props.theme,
      colors = _props$theme.colors,
      shadows = _props$theme.shadows,
      components = _props$theme.components;
  var token = components.PopoverCard.card;
  var _components$Guide$too = components.Guide.toolTips,
      padding = _components$Guide$too.padding,
      minWidth = _components$Guide$too.minWidth;
  var currentPadding = props.$hasCustomContent ? 0 : padding;
  return css(["background:", ";box-shadow:", ";border-radius:", ";padding:", ";min-width:", "px;", "{margin-bottom:0;}"], colors.pattern.background.higher, shadows.pattern.popper.normal, token.borderRadius, currentPadding, minWidth, StyledTitle);
});
export var ButtonWrapper = styled.div.withConfig({
  displayName: "ButtonWrapper"
})(["", ""], function (props) {
  return css(["margin-top:", "px;display:flex;flex-direction:row-reverse;"], props.theme.components.Guide.nextButton.marginTop);
});
export var SvgMaskWrapper = styled.div.withConfig({
  displayName: "SvgMaskWrapper"
})(["", ""], function (props) {
  var _props$theme$componen2 = props.theme.components.Guide.mask,
      opacity = _props$theme$componen2.opacity,
      color = _props$theme$componen2.color;
  return css(["opacity:", ";width:100%;left:0;top:0;height:100%;position:fixed;z-index:", ";pointer-events:none;color:", ";"], opacity, props.theme.zIndex.pattern.dialog, color);
});
export var SkipWrapper = styled.div.withConfig({
  displayName: "SkipWrapper"
})(["", ""], function (props) {
  return css(["position:absolute;left:0;right:0;bottom:", "px;margin:0 auto;text-align:center;&:hover{cursor:pointer;}"], props.theme.components.Guide.skip.bottom);
});
export var TextWrapper = styled.div.withConfig({
  displayName: "TextWrapper"
})(["display:flex;align-items:baseline;"]);
export var StyledIcon = styled.span.withConfig({
  displayName: "StyledIcon"
})(["", ""], function (props) {
  var _props$theme$componen3 = props.theme.components.Guide.informIcon,
      marginRight = _props$theme$componen3.marginRight,
      color = _props$theme$componen3.color,
      fontSize = _props$theme$componen3.fontSize;
  return css(["margin-right:", "px;color:", ";font-size:", "px;line-height:0;"], marginRight, color, fontSize);
});
export var TitleWrapper = styled.div.withConfig({
  displayName: "TitleWrapper"
})([""]);
export var StyledPopoverCardIcon = styled.span.withConfig({
  displayName: "StyledPopoverCardIcon"
})([""]);
export var StyledPopoverCardCloseIcon = styled.span.withConfig({
  displayName: "StyledPopoverCardCloseIcon"
})([""]);
export var StyledDesc = styled(Typography.Paragraph).withConfig({
  displayName: "StyledDesc"
})([""]);
export var StyledActions = styled.div.withConfig({
  displayName: "StyledActions"
})([""]);
export var StyledGuidePopoverCard = styled(PopoverCard).withConfig({
  displayName: "StyledGuidePopoverCard"
})(["", ""], function (props) {
  var $showIcon = props.$showIcon,
      $showClose = props.$showClose,
      $hasDesc = props.$hasDesc,
      theme = props.theme;
  var token = theme.components.Guide.popoverCard;
  return css(["position:relative;background:", ";padding:", ";", ";", ";", "{position:absolute;left:", "px;top:", "px;color:", ";font-size:", "px;line-height:0;}", "{color:", ";font-size:", "px;line-height:", "px;margin-top:", "px;}", "{position:absolute;color:", ";font-size:", "px;line-height:0;top:", "px;right:", "px;cursor:pointer;}", "{display:flex;justify-content:flex-end;margin-top:", "px;}"], token.bgColor, $hasDesc ? token.hasDescPadding : token.padding, $showIcon && "padding-left: ".concat(token.hasIconPaddingLeft, "px"), $showClose && "padding-right: ".concat(token.hasCloseIconPaddingRight, "px"), StyledPopoverCardIcon, token.iconLeft, $hasDesc ? token.iconHasDescTop : token.iconTop, token.iconColor.inverse, token.iconFontSize, StyledDesc, _colorUtils.transparentize(token.descOpacity, token.descColor), token.descFontSize, token.descLineHeight, token.descMarginTop, StyledPopoverCardCloseIcon, _colorUtils.transparentize(token.closeIconOpacity, token.closeIconColor), token.closeIconFontSize, $hasDesc ? token.closeIconhasDescTop : token.closeIconTop, $hasDesc ? token.closeIconhasDescRight : token.closeIconRight, StyledActions, token.actionsMarginTop);
});