import { useEventCallback as _useEventCallback } from "@muya-ui/utils/es/hooks/useEventCallback";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import { useState } from 'react';
export default (function (props) {
  var onRequestClose = props.onRequestClose,
      steps = props.steps,
      onStepChange = props.onStepChange;

  var _useState = useState(0),
      _useState2 = _slicedToArray(_useState, 2),
      current = _useState2[0],
      setCurrent = _useState2[1];

  var _useState3 = useState(true),
      _useState4 = _slicedToArray(_useState3, 2),
      isOpen = _useState4[0],
      setIsOpen = _useState4[1];

  var close = _useEventCallback(function () {
    setIsOpen(false);
    onRequestClose && onRequestClose();
  });

  var nextStep = _useEventCallback(function () {
    setCurrent(function (prev) {
      if (prev === steps.length - 1) {
        close();
      }

      var step = prev < steps.length - 1 ? prev + 1 : prev;
      prev < steps.length - 1 && onStepChange && onStepChange(step);
      return step;
    });
  });

  var goTo = _useEventCallback(function (step) {
    onStepChange && onStepChange(step);
    setCurrent(step);
  });

  return {
    current: current,
    isOpen: isOpen,
    close: close,
    nextStep: nextStep,
    goTo: goTo
  };
});