import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "onScroll"],
    _excluded2 = ["settings", "poolName"];
import React, { useContext, useEffect } from 'react';
import styled from 'styled-components';
import memoForwardRef from '../utils/memoForwardRef';
import ImgPoolContext, { ImgPoolProvider } from './ImgPoolContext';
var BaseNode = styled.div.withConfig({
  displayName: "BaseNode"
})([""]);
var Container = memoForwardRef(function (props, ref) {
  var children = props.children,
      onScroll = props.onScroll,
      otherProps = _objectWithoutProperties(props, _excluded);

  var pool = useContext(ImgPoolContext);

  var innerOnScroll = function innerOnScroll(e) {
    onScroll && onScroll(e);
    pool.throttleCheck({
      type: 'scroll'
    });
  };

  useEffect(function () {
    pool.throttleCheck({
      type: 'scroll'
    });
  }, [children, pool]);
  return /*#__PURE__*/React.createElement(BaseNode, _extends({}, otherProps, {
    onScroll: innerOnScroll,
    ref: ref
  }), children);
});
export default memoForwardRef(function (props, ref) {
  var settings = props.settings,
      _props$poolName = props.poolName,
      poolName = _props$poolName === void 0 ? 'img_container' : _props$poolName,
      otherProps = _objectWithoutProperties(props, _excluded2);

  return /*#__PURE__*/React.createElement(ImgPoolProvider, {
    settings: settings,
    poolName: poolName
  }, /*#__PURE__*/React.createElement(Container, _extends({}, otherProps, {
    ref: ref
  })));
});