import React, { useEffect, useMemo } from 'react';
import ImgPool from './ImgPool';
export var imgPool = new ImgPool();
imgPool.setupSync();
var ImgPoolContext = /*#__PURE__*/React.createContext(imgPool);
var uid = 0;
export var ImgPoolProvider = /*#__PURE__*/React.memo(function (props) {
  var settings = props.settings,
      poolName = props.poolName,
      children = props.children;
  var name = poolName || 'img_provider';
  var pool = useMemo(function () {
    return new ImgPool("".concat(name, "_").concat(uid++));
  }, [name]);
  useEffect(function () {
    pool.setupSync(settings);
    return function () {
      pool.destroy();
    };
  }, [pool, settings]);
  return /*#__PURE__*/React.createElement(ImgPoolContext.Provider, {
    value: pool
  }, children);
});
export default ImgPoolContext;