import _extends from "@babel/runtime/helpers/extends";
import { useForkRef as _useForkRef } from "@muya-ui/utils/es/hooks/useForkRef";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import { ResetIcon as _ResetIcon } from "@muya-ui/theme-light/es/icons/ResetIcon";
import { ShrinkIcon as _ShrinkIcon } from "@muya-ui/theme-light/es/icons/ShrinkIcon";
import { MagnifyIcon as _MagnifyIcon } from "@muya-ui/theme-light/es/icons/MagnifyIcon";
import { RotateIcon as _RotateIcon } from "@muya-ui/theme-light/es/icons/RotateIcon";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["src", "size", "shape", "scaleMax", "scaleMin", "wheelScaleStep", "scaleStep", "defaultScale", "rotateable", "resetable", "backDelay", "styles", "boxPadding", "sliderStyles"];
import React, { forwardRef, useMemo, useRef } from 'react';
import InlineButton from '../InlineButton';
import { Slider } from '../Slider';
import { BaseDiv } from '../styled/base';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import { StyledContainer, StyledContent, StyledCropper, StyledImg, StyledMask, StyledRow, StyledSliderCol, StyledZoomCol, StyledActionCol } from './styled';
import useImgCropper from './useImgCropper';
var defaultStyles = {
  container: '',
  content: '',
  mask: '',
  img: '',
  row: '',
  zoom: '',
  zoomButton: '',
  zoomOut: '',
  sliderContainer: '',
  slider: '',
  rotateContainer: '',
  rotateButton: '',
  resetContainer: '',
  resetButton: ''
};
var ImgCropper = /*#__PURE__*/forwardRef(function (props, ref) {
  var src = props.src,
      size = props.size,
      shape = props.shape,
      scaleMax = props.scaleMax,
      scaleMin = props.scaleMin,
      wheelScaleStep = props.wheelScaleStep,
      _props$scaleStep = props.scaleStep,
      scaleStep = _props$scaleStep === void 0 ? 0.1 : _props$scaleStep,
      defaultScale = props.defaultScale,
      _props$rotateable = props.rotateable,
      rotateable = _props$rotateable === void 0 ? true : _props$rotateable,
      _props$resetable = props.resetable,
      resetable = _props$resetable === void 0 ? false : _props$resetable,
      backDelay = props.backDelay,
      styles = props.styles,
      boxPadding = props.boxPadding,
      sliderStyles = props.sliderStyles,
      otherProps = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  var _theme$components$Img = theme.components.ImgCropper,
      _theme$components$Img2 = _theme$components$Img.rotateIcon,
      RotateIcon = _theme$components$Img2 === void 0 ? _RotateIcon : _theme$components$Img2,
      _theme$components$Img3 = _theme$components$Img.zoomIcon,
      ZoomIcon = _theme$components$Img3 === void 0 ? _MagnifyIcon : _theme$components$Img3,
      _theme$components$Img4 = _theme$components$Img.zoomOutIcon,
      ZoomOutIcon = _theme$components$Img4 === void 0 ? _ShrinkIcon : _theme$components$Img4,
      _theme$components$Img5 = _theme$components$Img.resetIcon,
      ResetIcon = _theme$components$Img5 === void 0 ? _ResetIcon : _theme$components$Img5,
      defaultSize = _theme$components$Img.defaultSize;

  var _ref = size || defaultSize,
      _ref2 = _slicedToArray(_ref, 2),
      $width = _ref2[0],
      $height = _ref2[1];

  var maskRef = useRef(null);
  var imgRef = useRef(null);
  var rootRef = useRef(null);
  var innerStyles = useStyles('img-cropper', defaultStyles, styles);

  var _useImgCropper = useImgCropper(props, maskRef, imgRef),
      moving = _useImgCropper.moving,
      imgSrc = _useImgCropper.imgSrc,
      imgStyle = _useImgCropper.imgStyle,
      getImg = _useImgCropper.getImg,
      getInfo = _useImgCropper.getInfo,
      handleMouseDown = _useImgCropper.handleMouseDown,
      handleMouseMove = _useImgCropper.handleMouseMove,
      handleMouseUp = _useImgCropper.handleMouseUp,
      handleMouseEnter = _useImgCropper.handleMouseEnter,
      handleWheel = _useImgCropper.handleWheel,
      handleSliderChange = _useImgCropper.handleSliderChange,
      rotateImg = _useImgCropper.rotateImg,
      handleZoom = _useImgCropper.handleZoom,
      handleZoomOut = _useImgCropper.handleZoomOut,
      resetImg = _useImgCropper.resetImg,
      finalScaleMin = _useImgCropper.finalScaleMin,
      finalScaleMax = _useImgCropper.finalScaleMax,
      finalScale = _useImgCropper.finalScale;

  var handleRef = _useForkRef(ref, rootRef, {
    getImg: getImg,
    getInfo: getInfo
  });

  var finalImgStyle = useMemo(function () {
    return _extends({}, innerStyles.img.style, imgStyle);
  }, [imgStyle, innerStyles.img.style]);
  return /*#__PURE__*/React.createElement(BaseDiv, _extends({}, otherProps, {
    ref: handleRef
  }), /*#__PURE__*/React.createElement(StyledCropper, {
    $width: $width,
    $height: $height,
    $padding: boxPadding,
    theme: theme,
    onMouseDown: handleMouseDown,
    onMouseUp: handleMouseUp,
    onMouseLeave: handleMouseUp,
    onMouseEnter: handleMouseEnter,
    onMouseMove: handleMouseMove,
    onWheel: handleWheel
  }, /*#__PURE__*/React.createElement(StyledContainer, _extends({
    $moving: moving
  }, innerStyles.container), /*#__PURE__*/React.createElement(StyledMask, _extends({
    theme: theme,
    $moving: moving,
    $shape: shape,
    ref: maskRef
  }, innerStyles.mask)), /*#__PURE__*/React.createElement(StyledContent, innerStyles.content, imgSrc && /*#__PURE__*/React.createElement(StyledImg, {
    ref: imgRef,
    theme: theme,
    $transition: moving ? 'off' : 'on',
    style: finalImgStyle,
    className: innerStyles.img.className
  })))), /*#__PURE__*/React.createElement(StyledRow, innerStyles.row, /*#__PURE__*/React.createElement(StyledZoomCol, _extends({}, innerStyles.zoomOut, {
    theme: theme
  }), /*#__PURE__*/React.createElement(InlineButton, _extends({}, innerStyles.zoomButton, {
    type: "weak",
    onClick: handleZoomOut
  }), /*#__PURE__*/React.createElement(ZoomOutIcon, null))), /*#__PURE__*/React.createElement(StyledSliderCol, _extends({}, innerStyles.sliderContainer, {
    theme: theme
  }), /*#__PURE__*/React.createElement(Slider, _extends({}, innerStyles.slider, {
    styles: sliderStyles,
    min: finalScaleMin,
    max: finalScaleMax,
    step: scaleStep,
    value: finalScale,
    onChange: handleSliderChange
  }))), /*#__PURE__*/React.createElement(StyledZoomCol, _extends({}, innerStyles.zoom, {
    theme: theme
  }), /*#__PURE__*/React.createElement(InlineButton, _extends({}, innerStyles.zoomButton, {
    type: "weak",
    onClick: handleZoom
  }), /*#__PURE__*/React.createElement(ZoomIcon, null))), rotateable && /*#__PURE__*/React.createElement(StyledActionCol, _extends({}, innerStyles.rotateContainer, {
    theme: theme
  }), /*#__PURE__*/React.createElement(InlineButton, _extends({}, innerStyles.rotateButton, {
    type: "weak",
    onClick: rotateImg
  }), /*#__PURE__*/React.createElement(RotateIcon, null))), resetable && /*#__PURE__*/React.createElement(StyledActionCol, _extends({}, innerStyles.resetContainer, {
    theme: theme
  }), /*#__PURE__*/React.createElement(InlineButton, _extends({}, innerStyles.resetButton, {
    type: "weak",
    onClick: resetImg
  }), /*#__PURE__*/React.createElement(ResetIcon, null)))));
});
export default ImgCropper;