import React from 'react';
import styled, { css } from 'styled-components';

function layerCss() {
  return css(["position:absolute;top:0;left:0;width:100%;height:100%;box-sizing:border-box;"]);
}

var StyledMaskInner = styled.div.withConfig({
  displayName: "StyledMaskInner"
})(["", " ", ""], layerCss, function (props) {
  var $moving = props.$moving;
  var _props$$shape = props.$shape,
      $shape = _props$$shape === void 0 ? 'normal' : _props$$shape,
      theme = props.theme;
  var _theme$components$Img = theme.components.ImgCropper,
      maskColor = _theme$components$Img.maskColor,
      borderColor = _theme$components$Img.borderColor,
      borderRadius = _theme$components$Img.borderRadius;
  var cursorCss;

  if (!$moving) {
    cursorCss = css(["&:hover{cursor:grab;}"]);
  } else {
    cursorCss = css(["cursor:grabbing;"]);
  }

  return css(["", " border:1px solid ", ";border-radius:", ";box-shadow:0 0 0 10000px ", ";z-index:1;"], cursorCss, borderColor, borderRadius[$shape], maskColor);
});
export var StyledMask = /*#__PURE__*/React.memo(StyledMaskInner);
var StyledContentInner = styled.div.withConfig({
  displayName: "StyledContentInner"
})(["", ""], layerCss);
export var StyledContent = /*#__PURE__*/React.memo(StyledContentInner);
export var StyledContainer = styled.div.withConfig({
  displayName: "StyledContainer"
})(["position:relative;width:100%;height:100%;", ""], function (props) {
  var $moving = props.$moving;

  if (!$moving) {
    return;
  }

  return css(["cursor:grabbing;"]);
});
var StyledCropperInner = styled.div.withConfig({
  displayName: "StyledCropperInner"
})(["position:relative;overflow:hidden;box-sizing:content-box;", ""], function (props) {
  var $width = props.$width,
      $height = props.$height,
      $padding = props.$padding,
      theme = props.theme;
  var cropperMarginBottom = theme.components.ImgCropper.cropperMarginBottom;
  var cropperPadding = $padding;

  if (!$padding) {
    var paddingLeftRight = 3 / 14 * $width;
    var paddingTopBottom = 3 / 14 * $height;
    cropperPadding = "".concat(paddingTopBottom, "px ").concat(paddingLeftRight, "px");
  }

  return css(["width:", "px;height:", "px;padding:", ";margin-bottom:", "px;"], $width, $height, cropperPadding, cropperMarginBottom);
});
export var StyledCropper = /*#__PURE__*/React.memo(StyledCropperInner);
var RCol = styled.div.withConfig({
  displayName: "RCol"
})(["font-size:0;", ""], function (props) {
  return css(["padding-left:", "px;"], props.theme.components.ImgCropper.actionPaddingLeft);
});
export var StyledActionCol = /*#__PURE__*/React.memo(RCol);
var ZCol = styled.div.withConfig({
  displayName: "ZCol"
})(["font-size:0;"]);
export var StyledZoomCol = /*#__PURE__*/React.memo(ZCol);
var SCol = styled.div.withConfig({
  displayName: "SCol"
})(["flex:1;", ""], function (props) {
  return css(["padding:0 ", "px;"], props.theme.components.ImgCropper.sliderPadding);
});
export var StyledSliderCol = /*#__PURE__*/React.memo(SCol);
var StyledRowInner = styled.div.withConfig({
  displayName: "StyledRowInner"
})(["display:flex;justify-content:space-between;"]);
export var StyledRow = /*#__PURE__*/React.memo(StyledRowInner);
export var StyledImg = styled.div.withConfig({
  displayName: "StyledImg"
})(["background-size:cover;transform-origin:center;position:absolute;", ""], function (props) {
  var $transition = props.$transition,
      theme = props.theme;
  var _theme$transition$spe = theme.transition.spec,
      easing = _theme$transition$spe.easing,
      duration = _theme$transition$spe.duration;

  if ($transition !== 'on') {
    return false;
  }

  return css(["transition:transform ", "ms ", ";"], duration.fast, easing.easeInOut);
});