import styled, { css } from 'styled-components';
import { PagerButton } from '../Carousel';
import Img from '../Img';
import { scrollBarStyle } from '../ScrollView/styled';
import { StyleSubTitle } from '../Result/styled';
export var StyledImgWrapper = styled.div.withConfig({
  displayName: "StyledImgWrapper"
})(["position:relative;width:100%;height:100%;"]);
export var StyledImgContainer = styled.div.withConfig({
  displayName: "StyledImgContainer"
})(["", ""], function (props) {
  var _props$theme = props.theme,
      _props$theme$transiti = _props$theme.transition.pattern,
      duration = _props$theme$transiti.duration,
      easing = _props$theme$transiti.easing,
      imgWrapperToken = _props$theme.components.ImgPreview.imgWrapper,
      $width = props.$width,
      $height = props.$height,
      $imgOverflow = props.$imgOverflow,
      $showPagination = props.$showPagination;
  var scrollBarSize = $imgOverflow ? imgWrapperToken.scrollBarSize : 0;
  return css(["position:relative;margin:auto;width:", "px;height:", "px;margin-top:", "px;transition:height ", "ms ", ";", "{", ";", ";}"], $width + scrollBarSize, $height + scrollBarSize, imgWrapperToken.marginTop, duration.status, easing.status, StyledImgWrapper, $showPagination && 'overflow: auto', scrollBarStyle(props));
});
export var StyledImg = styled(Img).withConfig({
  displayName: "StyledImg"
})(["", ""], function (props) {
  var _props$theme2 = props.theme,
      _props$theme2$transit = _props$theme2.transition.pattern,
      duration = _props$theme2$transit.duration,
      easing = _props$theme2$transit.easing,
      imgWrapperToken = _props$theme2.components.ImgPreview.imgWrapper,
      $imgOverflow = props.$imgOverflow,
      $overflowOffset = props.$overflowOffset;
  return css(["position:absolute;left:50%;top:calc(50% - ", "px);transform:translate(-50%,-50%);background-size:contain;transform-origin:center center;transition:all ", "ms ", ";", ""], imgWrapperToken.marginTop / 2, duration.status, easing.status, $imgOverflow && css(["top:0;transform:", ";cursor:grab;"], $overflowOffset ? "translate(calc(-50% + ".concat($overflowOffset, "px), 0)") : 'translate(-50%, 0)'));
});
export var StyledImgPreviewContainer = styled.div.withConfig({
  displayName: "StyledImgPreviewContainer"
})(["position:absolute;top:0;bottom:0;right:0;left:0;box-sizing:border-box;height:100%;overflow:hidden;text-align:center;vertical-align:middle;"]);
export var StyledImgViewerLayer = styled.div.withConfig({
  displayName: "StyledImgViewerLayer"
})(["height:100%;"]);
export var StyledLoadStateLayer = styled.div.withConfig({
  displayName: "StyledLoadStateLayer"
})(["position:absolute;left:50%;top:50%;transform:translate(-50%,-50%);", " p{color:#fff;}"], StyleSubTitle);
export var StyledImgPreview = styled.div.withConfig({
  displayName: "StyledImgPreview"
})(["width:100%;height:100%;overflow:auto;white-space:nowrap;box-sizing:border-box;", ";"], scrollBarStyle);
export var StyledImgActions = styled.div.withConfig({
  displayName: "StyledImgActions"
})(["position:absolute;left:0;right:0;bottom:", "px;margin:auto;z-index:1;"], function (props) {
  return props.theme.components.ImgPreview.imgActions.bottom;
});
export var StyledCloseIconWrapper = styled.div.withConfig({
  displayName: "StyledCloseIconWrapper"
})(["", ""], function (props) {
  var closeIconToken = props.theme.components.ImgPreview.closeIcon;
  return css(["position:absolute;right:", "px;top:", "px;font-size:", "px;cursor:pointer;z-index:1;"], closeIconToken.right, closeIconToken.top, closeIconToken.fontSize);
});
export var StyledPageButton = styled.div.withConfig({
  displayName: "StyledPageButton"
})(["", ""], function (props) {
  var theme = props.theme,
      $disabled = props.$disabled,
      $direction = props.$direction,
      $height = props.$height,
      $imgOverflow = props.$imgOverflow;
  var opacity = theme.opacity;
  var _theme$components$Img = theme.components.ImgPreview,
      pageButtonToken = _theme$components$Img.pageButton,
      imgWrapperToken = _theme$components$Img.imgWrapper;
  return css(["position:absolute;top:", ";transform:translate(0,-50%);font-size:", "px;color:", ";cursor:pointer;&:hover{opacity:", ";}", " ", ";"], $imgOverflow ? "calc(".concat(imgWrapperToken.marginTop, "px + ").concat($height / 2, "px)") : "calc(".concat(imgWrapperToken.marginTop / 2, "px + ").concat($height / 2, "px)"), pageButtonToken.fontSize, pageButtonToken.color, pageButtonToken.opacity, $disabled && css(["opacity:", ";cursor:not-allowed;&:hover{opacity:", ";}"], opacity.pattern.disabled, opacity.pattern.disabled), "".concat($direction, ": ").concat(pageButtonToken.spacing, "px"));
});
export var StyledImgPaginationWrapper = styled.div.withConfig({
  displayName: "StyledImgPaginationWrapper"
})(["position:absolute;left:0;right:0;bottom:0;margin:auto;", ""], function (props) {
  var $width = props.$width,
      theme = props.theme;
  var paginationToken = theme.components.ImgPreview.imgPagination;
  return css(["box-sizing:border-box;width:", "px;height:", "px;padding:", "px 0;"], $width, paginationToken.height, paginationToken.paddingVertical);
});
export var StyledPaginationImg = styled(Img).withConfig({
  displayName: "StyledPaginationImg"
})(["", ""], function (props) {
  var _props$theme3 = props.theme,
      imgPaginationToken = _props$theme3.components.ImgPreview.imgPagination,
      _props$theme3$transit = _props$theme3.transition.pattern,
      duration = _props$theme3$transit.duration,
      easing = _props$theme3$transit.easing,
      $selected = props.$selected,
      $width = props.$width;
  return css(["position:relative;width:", "px;height:", "px;margin-right:", "px;cursor:pointer;opacity:", ";transition:opacity ", "ms ", ";&::after{position:absolute;left:0;right:0;top:0;bottom:0;content:'';}", ""], $width ? $width : imgPaginationToken.itemWidth, imgPaginationToken.itemHeight, imgPaginationToken.itemMrginRight, imgPaginationToken.itemOpacity, duration.status, easing.status, $selected && css(["opacity:1;&::after{border:", "px solid ", ";transition:border ", "ms ", ";}"], imgPaginationToken.itemActiveBorderSize, imgPaginationToken.borderActiveColor, duration.status, easing.status));
});
export var StyledPaginationButton = styled(PagerButton).withConfig({
  displayName: "StyledPaginationButton"
})(["", ""], function (props) {
  var imgPaginationToken = props.theme.components.ImgPreview.imgPagination,
      arrow = props.arrow;
  return css(["position:absolute;top:50%;transform:translate(0,-50%);width:", "px;height:", "px;font-size:", "px;", ";"], imgPaginationToken.buttonWidth, imgPaginationToken.buttonHeight, imgPaginationToken.buttonFontSize, "".concat(arrow, ": ").concat(imgPaginationToken.buttonOffset, "px"));
});
export var StyledPagination = styled.div.withConfig({
  displayName: "StyledPagination"
})(["display:flex;"]);