import _get from "lodash/get";
import React from 'react';
import styled from 'styled-components';
import memoForwardRef from '../utils/memoForwardRef';
import useTheme from '../utils/useTheme';
export var LimitWrapper = styled.span.withConfig({
  displayName: "LimitWrapper"
})(["font-weight:", ";color:", ";cursor:default;"], function (props) {
  return props.theme.typography.spec.fontWeight.semibold;
}, function (props) {
  return props.theme.colors.pattern.text.darktip;
});
export var LimitDanerWrapper = styled(LimitWrapper).withConfig({
  displayName: "LimitDanerWrapper"
})(["color:", ";"], function (props) {
  return props.theme.colors.pattern.feature.error;
});
export default memoForwardRef(function (props, ref) {
  var limit = props.limit,
      _props$value = props.value,
      value = _props$value === void 0 ? '' : _props$value;
  var theme = useTheme();
  if (!(limit && limit > 0)) return null;

  var length = _get(value, 'length', 0);

  return /*#__PURE__*/React.createElement(LimitWrapper, {
    ref: ref,
    theme: theme
  }, length > limit ? /*#__PURE__*/React.createElement(LimitDanerWrapper, {
    theme: theme
  }, length) : length, "/", limit);
});