import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import { useCallback, useMemo, useState } from 'react';
import forkHandler from '../utils/forkHandler';
export default function useInputBase(props) {
  var autoFocus = props.autoFocus,
      disabled = props.disabled,
      onFocus = props.onFocus,
      onBlur = props.onBlur,
      onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave;

  var _useState = useState(autoFocus),
      _useState2 = _slicedToArray(_useState, 2),
      focus = _useState2[0],
      setFocus = _useState2[1];

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      entered = _useState4[0],
      setEntered = _useState4[1];

  var beforeCheck = useCallback(function (e) {
    // Fix a bug with IE 11 where the focus/blur events are triggered
    // while the input is disabled.
    if (disabled) {
      e.stopPropagation();
      return false;
    }

    return true;
  }, [disabled]);
  var handleFocus = useMemo(function () {
    return forkHandler(function () {
      setFocus(true);
    }, onFocus, beforeCheck);
  }, [beforeCheck, onFocus]);
  var handleBlur = useMemo(function () {
    return forkHandler(function () {
      setFocus(false);
    }, onBlur, beforeCheck);
  }, [beforeCheck, onBlur]);
  var handleMouseEnter = useMemo(function () {
    return forkHandler(function () {
      setEntered(true);
    }, onMouseEnter);
  }, [onMouseEnter]);
  var handleMouseLeave = useMemo(function () {
    return forkHandler(function () {
      setEntered(false);
    }, onMouseLeave);
  }, [onMouseLeave]);
  return {
    focus: focus,
    entered: entered,
    handleFocus: handleFocus,
    handleBlur: handleBlur,
    handleMouseEnter: handleMouseEnter,
    handleMouseLeave: handleMouseLeave
  };
}