import { FoldIcon as _FoldIcon } from "@muya-ui/theme-light/es/icons/FoldIcon";
import { UnfoldIcon as _UnfoldIcon } from "@muya-ui/theme-light/es/icons/UnfoldIcon";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { useState } from 'react';
import useTheme from '../utils/useTheme';
import { StyledArrowSuffixNodeWrapper, StyledDownArrow, StyledUpArrow } from './styled';

var ArrowWrapper = function ArrowWrapper(props) {
  var size = props.size,
      arrowDisabled = props.arrowDisabled,
      changeStep = props.changeStep,
      iconSize = props.iconSize,
      showRightBorder = props.showRightBorder,
      showArrowBorder = props.showArrowBorder,
      onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave;
  var theme = useTheme();

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      upEntered = _useState2[0],
      setUpEntered = _useState2[1];

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      downEntered = _useState4[0],
      setDownEntered = _useState4[1];

  var UpIcon = theme.components.InputNumber.upArrowIcon || _UnfoldIcon;
  var DownIcon = theme.components.InputNumber.downArrowIcon || _FoldIcon;
  return /*#__PURE__*/React.createElement(StyledArrowSuffixNodeWrapper, {
    $needRightBorder: showRightBorder,
    $bordered: showArrowBorder,
    size: size,
    theme: theme,
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave
  }, /*#__PURE__*/React.createElement(StyledUpArrow, {
    $entered: upEntered,
    $arrowDisabled: arrowDisabled,
    $iconSize: iconSize,
    $bordered: showArrowBorder,
    onMouseEnter: function onMouseEnter() {
      return setUpEntered(true);
    },
    onMouseLeave: function onMouseLeave() {
      return setUpEntered(false);
    },
    size: size,
    theme: theme,
    onClick: function onClick() {
      return changeStep('up');
    }
  }, /*#__PURE__*/React.createElement(UpIcon, null)), /*#__PURE__*/React.createElement(StyledDownArrow, {
    $entered: downEntered,
    $arrowDisabled: arrowDisabled,
    $iconSize: iconSize,
    $bordered: showArrowBorder,
    onMouseEnter: function onMouseEnter() {
      return setDownEntered(true);
    },
    onMouseLeave: function onMouseLeave() {
      return setDownEntered(false);
    },
    size: size,
    theme: theme,
    onClick: function onClick() {
      return changeStep('down');
    }
  }, /*#__PURE__*/React.createElement(DownIcon, null)));
};

export default ArrowWrapper;