import getMiniDecimal, { toFixed } from './decimal';
import { isValidProps } from './utils';

var handleNumber = function handleNumber(props) {
  var min = props.min,
      max = props.max,
      precision = props.precision,
      fixPrecision = props.fixPrecision;

  var toNumber = function toNumber(value) {
    var val = toFixed(String(value), '.', precision);
    return fixPrecision ? val : getMiniDecimal(val).toString();
  };

  var getValidValue = function getValidValue(data) {
    if (!isValidProps(data)) return '';
    var val = getMiniDecimal(data);

    if (val.isNaN() || data === '') {
      return '';
    }

    if (min !== -Infinity && val.lessEquals(getMiniDecimal(min))) {
      val = getMiniDecimal(min);
    }

    if (max !== Infinity && getMiniDecimal(max).lessEquals(val)) {
      val = getMiniDecimal(max);
    }

    if (fixPrecision && isValidProps(precision) && precision >= 0) {
      return toFixed(val.toString(), '.', precision);
    }

    return val.toString();
  };

  return {
    toNumber: toNumber,
    getValidValue: getValidValue
  };
};

export default handleNumber;