import styled, { css } from 'styled-components';
export var StyledArrowSuffixNodeWrapper = styled.div.withConfig({
  displayName: "StyledArrowSuffixNodeWrapper"
})(["", ""], function (props) {
  var theme = props.theme,
      $needRightBorder = props.$needRightBorder,
      $bordered = props.$bordered;
  var InputNumberToken = theme.components.InputNumber;
  var borderStyle = $bordered && css(["border-left:", ";border-right:", ";"], InputNumberToken.arrowSuffixNodeWrapperBorder, $needRightBorder && InputNumberToken.arrowSuffixNodeWrapperBorder);
  return css(["width:20px;display:flex;flex-direction:column;", " text-align:center;height:100%;"], borderStyle);
});
export function styledArrowWrapper(props) {
  var theme = props.theme,
      size = props.size,
      $entered = props.$entered,
      $iconSize = props.$iconSize,
      $bordered = props.$bordered;
  var _theme$colors$pattern = theme.colors.pattern.icon,
      hover = _theme$colors$pattern.hover,
      normal = _theme$colors$pattern.normal;
  var InputNumberToken = theme.components.InputNumber;
  return css(["color:", ";display:flex;justify-content:center;align-items:center;padding:", ";flex:", ";flex-basis:auto;width:100%;&:hover{color:", ";height:100%;}&:active{color:", ";height:100%;background-color:", ";}&:not(:last-child){", "}& > svg{position:relative;width:", "px;height:", "px;}"], normal, InputNumberToken.iconMargin, !$entered ? 1 : 0, hover, hover, InputNumberToken.arrowClickBgColor, $bordered && css(["border-bottom:", ";"], InputNumberToken.arrowSuffixNodeWrapperBorder), !$iconSize ? InputNumberToken.arrowIconSize[size] : $iconSize, !$iconSize ? InputNumberToken.arrowIconSize[size] : $iconSize);
}
export function makeWrapperStyle(props) {
  var theme = props.theme,
      size = props.size,
      disabled = props.disabled,
      focus = props.focus,
      $width = props.$width,
      $height = props.$height,
      $bordered = props.$bordered,
      hasError = props.hasError;
  var colorsPattern = theme.colors.pattern,
      _theme$transition$pat = theme.transition.pattern,
      easing = _theme$transition$pat.easing,
      duration = _theme$transition$pat.duration,
      token = theme.components.Input; // 错误样式

  var errorStyle = css(["border-color:", ";box-shadow:", ";"], colorsPattern.feature.error, token.errorFocusShadow); // 聚焦样式

  var focusStyle = css(["border-color:", ";box-shadow:", ";"], token.borderColor.focused, token.focusShadow); // 禁用样式

  var disabledStyle = css(["background:", ";cursor:not-allowed;input,svg{cursor:not-allowed;}"], colorsPattern.background.disabled);
  var widthStyle = $width && css(["width:", ";"], $width);
  var heightStyle = $height && css(["height:", ";"], $height);
  var borderStyle = $bordered && css(["border:1px solid ", ";"], token.borderColor.normal);
  return css(["display:inline-flex;position:relative;box-sizing:border-box;justify-content:space-between;align-items:center;border-radius:", ";transition:border ", "ms ", ",width ", "ms ", ";vertical-align:middle;background-color:", ";&:hover{border-color:", ";}", " ", " ", " ", " ", " ", ""], token.borderRadius[size], duration.status, easing.status, duration.status, easing.status, token.bgColor, !(focus || disabled || hasError) && token.borderColor.hover, borderStyle, widthStyle, heightStyle, focus && focusStyle, hasError && errorStyle, disabled && disabledStyle);
}
export var StyledUpArrow = styled.div.withConfig({
  displayName: "StyledUpArrow"
})(["", ""], function (props) {
  var $arrowDisabled = props.$arrowDisabled,
      theme = props.theme;
  return css(["", " ", ""], styledArrowWrapper, $arrowDisabled.up && css(["cursor:not-allowed;background-color:", ";"], theme.colors.pattern.background.disabled));
});
export var StyledDownArrow = styled.div.withConfig({
  displayName: "StyledDownArrow"
})(["", ""], function (props) {
  var $arrowDisabled = props.$arrowDisabled,
      theme = props.theme;
  return css(["", " ", ""], styledArrowWrapper, $arrowDisabled.down && css(["cursor:not-allowed;background-color:", ";"], theme.colors.pattern.background.disabled));
});
export var StyledRangeInputNumberWrapper = styled.div.withConfig({
  displayName: "StyledRangeInputNumberWrapper"
})(["", ""], function () {
  return css(["", ""], makeWrapperStyle);
});
export var StyledMiddleNode = styled.div.withConfig({
  displayName: "StyledMiddleNode"
})(["", ""], function (props) {
  var theme = props.theme,
      $disabled = props.$disabled,
      $size = props.$size;
  var typography = theme.typography,
      token = theme.components.Input;
  var disabledStyle = $disabled && css(["color:", ";"], theme.colors.pattern.text.disabled);
  var fontLevel = token.fontLevel[$size];
  return css(["padding:4px;font-size:", ";", ";"], typography.spec.fontSize[fontLevel] + 'px', disabledStyle);
}); // 加减图标按钮样式

export var StyledNodeWrapper = styled.div.withConfig({
  displayName: "StyledNodeWrapper"
})(["", ""], function (props) {
  var theme = props.theme,
      size = props.size,
      $type = props.$type,
      $iconSize = props.$iconSize;
  var typography = theme.typography,
      _theme$components = theme.components,
      token = _theme$components.Input,
      InputNumberToken = _theme$components.InputNumber;
  var fontLevel = token.fontLevel[size];
  var borderStyle = $type === 'prefix' ? css(["border-right:", ";"], InputNumberToken.arrowSuffixNodeWrapperBorder) : css(["border-left:", ";"], InputNumberToken.arrowSuffixNodeWrapperBorder);
  return css(["display:flex;justify-content:center;align-items:center;width:20px;height:100%;font-size:", ";", " & svg{position:relative;width:", "px;height:", "px;}"], typography.spec.fontSize[fontLevel] + 'px', borderStyle, !$iconSize ? InputNumberToken.plusIconSize[size] : $iconSize, !$iconSize ? InputNumberToken.plusIconSize[size] : $iconSize);
});