import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["width", "height", "background"];
import React, { useState } from 'react';
import memoForwardRef from '../utils/memoForwardRef';
import { useTheme } from '../utils/useTheme';
import LayoutContent from './LayoutContent';
import { LayoutContext } from './LayoutContext';
import LayoutFooter from './LayoutFooter';
import LayoutHeader from './LayoutHeader';
import LayoutSider from './LayoutSider';
import LayoutSplitter from './LayoutSplitter';
import { StyledLayout } from './styled';
var Layout = memoForwardRef(function (props, ref) {
  var width = props.width,
      height = props.height,
      background = props.background,
      restProps = _objectWithoutProperties(props, _excluded);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      hasSider = _useState2[0],
      setHasSider = _useState2[1];

  var theme = useTheme();
  return /*#__PURE__*/React.createElement(LayoutContext.Provider, {
    value: {
      siderHook: {
        hasSider: hasSider,
        addSider: function addSider(hasSider) {
          setHasSider(hasSider);
        }
      }
    }
  }, /*#__PURE__*/React.createElement(StyledLayout, _extends({
    ref: ref,
    theme: theme,
    $hasSider: hasSider,
    $width: width,
    $height: height,
    $background: background
  }, restProps)));
});
Layout.Header = LayoutHeader;
Layout.Footer = LayoutFooter;
Layout.Content = LayoutContent;
Layout.Sider = LayoutSider;
Layout.Splitter = LayoutSplitter;
export default Layout;