import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["width", "height", "background"];
import React from 'react';
import memoForwardRef from '../utils/memoForwardRef';
import useTheme from '../utils/useTheme';
import { StyledLayoutContent } from './styled';
var LayoutContent = memoForwardRef(function (props, ref) {
  var width = props.width,
      height = props.height,
      background = props.background,
      restProps = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  return /*#__PURE__*/React.createElement(StyledLayoutContent, _extends({
    ref: ref,
    theme: theme,
    $width: width,
    $height: height,
    $background: background
  }, restProps));
});
export default LayoutContent;