import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["height", "background"];
import React from 'react';
import memoForwardRef from '../utils/memoForwardRef';
import useTheme from '../utils/useTheme';
import { StyledLayoutFooter } from './styled';
var LayoutFooter = memoForwardRef(function (props, ref) {
  var height = props.height,
      background = props.background,
      restProps = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  return /*#__PURE__*/React.createElement(StyledLayoutFooter, _extends({
    ref: ref,
    theme: theme,
    $height: height,
    $background: background
  }, restProps));
});
export default LayoutFooter;