import _extends from "@babel/runtime/helpers/extends";
import { SpeedLeftIcon as _SpeedLeftIcon } from "@muya-ui/theme-light/es/icons/SpeedLeftIcon";
import { SpeedIcon as _SpeedIcon } from "@muya-ui/theme-light/es/icons/SpeedIcon";
import { useEventCallback as _useEventCallback } from "@muya-ui/utils/es/hooks/useEventCallback";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["width", "height", "background", "collapsed", "defaultCollapsed", "collapsedWidth", "collapsible", "reverseArrow", "trigger", "onCollapse", "children"];
import React, { useEffect, useMemo, useState } from 'react';
import memoForwardRef from '../utils/memoForwardRef';
import useTheme from '../utils/useTheme';
import { useLayoutContext } from './LayoutContext';
import { StyledLayoutSider, StyledSiderCollapseTrigger } from './styled';
import LayoutSiderContext from './LayoutSiderContext';
var LayoutSider = memoForwardRef(function (props, ref) {
  var theme = useTheme();

  var width = props.width,
      height = props.height,
      background = props.background,
      collapsed = props.collapsed,
      _props$defaultCollaps = props.defaultCollapsed,
      defaultCollapsed = _props$defaultCollaps === void 0 ? false : _props$defaultCollaps,
      _props$collapsedWidth = props.collapsedWidth,
      collapsedWidth = _props$collapsedWidth === void 0 ? theme.components.Menu.wrapper.inlineCollapsedWidth : _props$collapsedWidth,
      _props$collapsible = props.collapsible,
      collapsible = _props$collapsible === void 0 ? false : _props$collapsible,
      _props$reverseArrow = props.reverseArrow,
      reverseArrow = _props$reverseArrow === void 0 ? false : _props$reverseArrow,
      trigger = props.trigger,
      onCollapse = props.onCollapse,
      children = props.children,
      restProps = _objectWithoutProperties(props, _excluded);

  var isControlled = ('collapsed' in props);

  var _useState = useState(isControlled ? collapsed : defaultCollapsed),
      _useState2 = _slicedToArray(_useState, 2),
      collapsedState = _useState2[0],
      setCollapsedState = _useState2[1];

  var _useLayoutContext = useLayoutContext(),
      siderHook = _useLayoutContext.siderHook;

  var handleCollapse = _useEventCallback(function () {
    if (!isControlled) {
      setCollapsedState(!collapsedState);
    }

    if (onCollapse) {
      onCollapse(!collapsedState);
    }
  });

  var triggerNode = useMemo(function () {
    if (collapsible) {
      if (trigger) {
        return trigger;
      } else {
        return /*#__PURE__*/React.createElement(StyledSiderCollapseTrigger, {
          onClick: handleCollapse
        }, reverseArrow && !collapsedState || !reverseArrow && collapsedState ? /*#__PURE__*/React.createElement(_SpeedIcon, null) : /*#__PURE__*/React.createElement(_SpeedLeftIcon, null));
      }
    }

    return null;
  }, [collapsedState, collapsible, handleCollapse, reverseArrow, trigger]);
  useEffect(function () {
    siderHook.addSider(true);
  }, [siderHook]);

  if (isControlled && collapsed !== collapsedState) {
    setCollapsedState(collapsed);
  }

  return /*#__PURE__*/React.createElement(LayoutSiderContext.Provider, {
    value: {
      siderCollapsed: collapsedState
    }
  }, /*#__PURE__*/React.createElement(StyledLayoutSider, _extends({
    ref: ref,
    theme: theme,
    $width: width,
    $height: height,
    $background: background,
    $reverseArrow: reverseArrow,
    $collapsed: !!collapsedState,
    $collapsedWidth: collapsedWidth
  }, restProps), children, triggerNode));
});
export default LayoutSider;