import { IconButton } from '../IconButton';
import styled, { css } from 'styled-components';
import addPx from '../utils/addPx';
export var StyledLayout = styled.div.withConfig({
  displayName: "StyledLayout"
})(["", ""], function (props) {
  var $hasSider = props.$hasSider,
      $width = props.$width,
      $height = props.$height,
      $background = props.$background,
      theme = props.theme;
  var $direction = $hasSider ? 'row' : 'column';
  return css(["box-sizing:border-box;display:flex;flex:auto;flex-direction:", ";", ";", ";background:", ";"], $direction, $width && "width: ".concat(addPx($width)), $height && "height: ".concat(addPx($height)), $background || theme.components.Layout.background);
});
export var StyledLayoutHeader = styled.div.withConfig({
  displayName: "StyledLayoutHeader"
})(["", ""], function (props) {
  var theme = props.theme,
      $height = props.$height,
      $background = props.$background;
  var layoutToken = theme.components.Layout;
  var height = addPx($height ? $height : layoutToken.header.height);
  return css(["box-sizing:border-box;flex:0 0 auto;height:", ";background:", ";"], height, $background || theme.components.Layout.header.background);
});
export var StyledLayoutFooter = styled.div.withConfig({
  displayName: "StyledLayoutFooter"
})(["", ""], function (props) {
  var theme = props.theme,
      $height = props.$height,
      $background = props.$background;
  var layoutToken = theme.components.Layout;
  var height = addPx($height ? $height : layoutToken.footer.height);
  return css(["box-sizing:border-box;flex:0 0 auto;height:", ";background:", ";"], height, $background || theme.components.Layout.footer.background);
});
export var StyledLayoutContent = styled.div.withConfig({
  displayName: "StyledLayoutContent"
})(["", ""], function (props) {
  var $height = props.$height,
      $width = props.$width,
      $background = props.$background,
      theme = props.theme;
  return css(["box-sizing:border-box;flex:auto;", ";", ";background:", ";"], $width && "width: ".concat(addPx($width)), $height && "height: ".concat(addPx($height)), $background || theme.components.Layout.content.background);
});
export var StyledSiderCollapseTrigger = styled(IconButton).withConfig({
  displayName: "StyledSiderCollapseTrigger"
})([""]);
export var StyledLayoutSider = styled.div.withConfig({
  displayName: "StyledLayoutSider"
})(["", ""], function (props) {
  var theme = props.theme,
      $height = props.$height,
      $width = props.$width,
      $background = props.$background,
      $reverseArrow = props.$reverseArrow,
      $collapsed = props.$collapsed,
      $collapsedWidth = props.$collapsedWidth;
  var layoutToken = theme.components.Layout;
  var width = addPx($collapsed ? $collapsedWidth : $width ? $width : layoutToken.sider.width);
  var triggerPositionCss;

  if ($collapsed) {
    triggerPositionCss = css(["bottom:12px;left:50%;transform:translateX(-50%);"]);
  } else if ($reverseArrow) {
    triggerPositionCss = css(["left:12px;bottom:12px;"]);
  } else {
    triggerPositionCss = css(["right:12px;bottom:12px;"]);
  }

  return css(["position:relative;box-sizing:border-box;flex:0 0 auto;width:", ";", ";background:", ";transition:width ", "ms ", ";", "{position:absolute;", ";transition:all ", "ms ", ";}"], width, $height && "height: ".concat(addPx($height)), $background || layoutToken.sider.background, theme.transition.pattern.duration.status, theme.transition.pattern.easing.status, StyledSiderCollapseTrigger, triggerPositionCss, theme.transition.pattern.duration.status, theme.transition.pattern.easing.status);
});
export var StyledLayoutSplitterContainer = styled.div.withConfig({
  displayName: "StyledLayoutSplitterContainer"
})(["height:100%;width:100%;display:flex;overflow:hidden;", ""], function (props) {
  var $direction = props.$direction;
  var isHorizontal = $direction === 'horizontal';
  return css(["flex-direction:", ";& > ", " > *{", ";}"], isHorizontal ? 'row' : 'column', StyledLayoutSplitterContent, isHorizontal ? 'width: auto' : 'height: 100%');
});
export var StyledLayoutSplitterContent = styled.div.withConfig({
  displayName: "StyledLayoutSplitterContent"
})(["overflow:hidden;"]);
export var StyledGutterContainer = styled.div.withConfig({
  displayName: "StyledGutterContainer"
})(["position:relative;z-index:1;", " ", ""], function (props) {
  var $direction = props.$direction,
      $gutterColor = props.$gutterColor;
  var gutterCss;

  if ($gutterColor) {
    gutterCss = css(["background:", ";"], $gutterColor);
  }

  if ($direction === 'horizontal') {
    return css(["height:100%;width:1px;", ";&::before{content:'';width:15px;transform:translateX(-7px);display:block;background:transparent;height:100%;}&:hover{cursor:col-resize;}"], gutterCss);
  } else {
    return css(["width:100%;height:1px;", ";&::before{content:'';height:15px;transform:translateY(-7px);display:block;background:transparent;width:100%;}&:hover{cursor:row-resize;}"], gutterCss);
  }
}, function (props) {
  var $draggable = props.$draggable,
      $direction = props.$direction,
      theme = props.theme;

  if ($draggable) {
    var bgCss = css(["background:", ";&:hover{background:", ";}"], theme.colors.pattern.icon.normal, theme.colors.pattern.icon.hover);
    return css(["", "{display:block;", ";}"], StyledGutterDragger, $direction === 'vertical' ? css(["&:before{top:-4px;left:50%;transform:translateX(-50%);width:16px;height:3px;", ";}&:after{top:2px;left:50%;transform:translateX(-50%);width:16px;height:3px;", ";}"], bgCss, bgCss) : css(["&:before{left:-4px;top:50%;transform:translateY(-50%);width:3px;height:16px;", ";}&:after{left:2px;top:50%;transform:translateY(-50%);width:3px;height:16px;", ";}"], bgCss, bgCss));
  }
});
export var StyledGutterDragger = styled.div.withConfig({
  displayName: "StyledGutterDragger"
})(["display:none;&:before{position:absolute;display:block;content:'';}&:after{position:absolute;display:block;content:'';}"]);