import { devWarning as _devWarning } from "@muya-ui/utils/es/utils/devWarning";
import dayjs from 'dayjs';
import React from 'react';
import Dialog from '../Dialog';
import LocaleContext from './LocaleContext';
import en_US from './resource/en_US';
export var LocaleProvider = function LocaleProvider(props) {
  var children = props.children,
      locale = props.locale;

  if (!locale) {
    _devWarning("[LocaleProvider]: invalid locale value [".concat(locale, "], give a fallback value: en_US"));

    locale = en_US;
  }

  dayjs.locale(locale.dayjsLocaleKey);
  Dialog.config({
    locale: locale
  });
  return /*#__PURE__*/React.createElement(LocaleContext.Provider, {
    value: locale
  }, children);
};
export default LocaleProvider;