import _extends from "@babel/runtime/helpers/extends";
import { StyledSvg as _StyledSvg2 } from "@muya-ui/icon-base/es/StyledSvg";
import { StyledSvg as _StyledSvg } from "@muya-ui/theme-light/es/components/SvgIcon";
import styled, { css } from 'styled-components';
import { scrollBarStyle } from '../ScrollView/styled';
import ExpandWrapper from '../styled/components/ExpandWrapper';
import ellipsisStyle from '../styled/mixins/ellipsis';
import { itemDisabledStyle, itemNormalStyle, itemSelectedStyle } from '../styled/mixins/item';
import Tooltip from '../Tooltip';
import addPx from '../utils/addPx';
/** styled component props */

var itemStatusStyle = function itemStatusStyle(status) {
  var $disabled = status.$disabled,
      $selected = status.$selected,
      $itemToken = status.$itemToken;
  return css(["", " ", " ", ""], !$disabled && !$selected && itemNormalStyle($itemToken), $selected && itemSelectedStyle($itemToken), $disabled && itemDisabledStyle($itemToken));
};

export var StyledMenuItemTooltip = styled(Tooltip).withConfig({
  displayName: "StyledMenuItemTooltip"
})(["a{color:inherit;text-decoration:none;}"]); // menu

/* stylelint-disable selector-type-case, selector-type-no-unknown */

var menuCss = function menuCss(props) {
  var _props$theme = props.theme,
      _props$theme$transiti = _props$theme.transition.pattern,
      easing = _props$theme$transiti.easing,
      duration = _props$theme$transiti.duration,
      colorsPattern = _props$theme.colors.pattern,
      shadows = _props$theme.shadows,
      _props$theme$typograp = _props$theme.typography.spec,
      fontSize = _props$theme$typograp.fontSize,
      lineHeight = _props$theme$typograp.lineHeight,
      _props$theme$componen = _props$theme.components,
      token = _props$theme$componen.Menu,
      expandIconToken = _props$theme$componen.ExpandIcon,
      $size = props.$size,
      $inlineMode = props.$inlineMode,
      $horizontalMode = props.$horizontalMode,
      $inlineCollapsed = props.$inlineCollapsed,
      $sub = props.$sub,
      $noSpacing = props.$noSpacing,
      $hideRootMenuSpacing = props.$hideRootMenuSpacing,
      $menuItemAlign = props.$menuItemAlign,
      $hasScrollBar = props.$hasScrollBar,
      $maxItemCountPerPage = props.$maxItemCountPerPage,
      $autoItemCountPerPage = props.$autoItemCountPerPage;
  var modeStyle;
  var spacingStyle;
  var alignStyle;

  if ($noSpacing || (!$inlineMode || $inlineCollapsed) && ($sub || $hideRootMenuSpacing)) {
    spacingStyle = css(["", " ", ",", ",", " ", ",", " ", " ", "{margin:0;padding:0 ", "px;}"], StyledMenuItem, StyledMenuItemContent, StyledSubMenuTitle, StyledMenuItemGroup, StyledMenuItemGroupLabel, StyledMenuItemGroup, StyledMenuItem, StyledMenuItemContent, token.item.verticalPaddingHorizontal);
  }
  /**
   * 1. 放在 dropdown 中的一级
   * 2. 弹出的子菜单
   */


  if ((!$inlineMode || $inlineCollapsed) && ($sub || $hideRootMenuSpacing)) {
    modeStyle = css(["box-shadow:", ";min-width:", "px;padding:", "px 0;background:", ";border-radius:", ";", ";", "{", ";", "}", "{margin-top:", "px;", "{height:", "px;line-height:", "px;}}", " ", ",", "{height:", "px;line-height:", "px;font-size:", "px;}", ",", "{font-size:", "px;}"], shadows.pattern.popper.normal, token.subMenu.verticalMinWidth, token.subMenu.verticalPaddingVertical, colorsPattern.background.higher, token.verticalBorderRadius, $hasScrollBar && "padding-right: ".concat(token.subMenu.scrollBarPadding, "px"), StyledMenuScrollWrapper, $autoItemCountPerPage ? "max-height: calc(100vh - ".concat(token.subMenu.preventOverflowPadding, "px)") : "max-height: ".concat($maxItemCountPerPage * token.verticalHeight[$size], "px"), $hasScrollBar && css(["padding-right:", "px;", ";"], token.subMenu.scrollBarPadding, scrollBarStyle(props)), StyledMenuItemGroup, token.group.vericalMarginTop, StyledMenuItemGroupLabel, token.group.verticalHeight, token.group.verticalHeight, StyledMenuItem, StyledMenuItemContent, StyledSubMenuTitle, token.verticalHeight[$size], token.verticalHeight[$size], fontSize[token.verticalFontLevel[$size]], _StyledSvg2, _StyledSvg, fontSize[token.verticalIconFontLevel[$size]]);
    /**
     * 水平的一级菜单
     */
  } else if ($horizontalMode && !$sub) {
    modeStyle = css(["white-space:nowrap;border-bottom:1px solid ", ";", " ", ",", ",", " ", ",", " ", " ", "{margin:0;padding:0 ", "px;}", "{position:relative;top:1px;margin-top:-1px;overflow-x:auto;}"], colorsPattern.border.normal, StyledMenuItem, StyledMenuItemContent, StyledSubMenuTitle, StyledMenuItemGroup, StyledMenuItemGroupLabel, StyledMenuItemGroup, StyledMenuItem, StyledMenuItemContent, token.item.horizontalPaddingHorizontal, StyledMenuScrollWrapper);
  } else if ($inlineMode) {
    modeStyle = css(["", "{border-radius:", ";}"], StyledMenuItemContent, token.item.inlineBorderRadius[$size]);
  }

  if ($menuItemAlign) {
    alignStyle = css(["", "{text-align:", ";}"], StyledMenuItemContent, $menuItemAlign);
  }

  return css(["position:relative;box-sizing:border-box;width:100%;font-size:", "px;line-height:", "px;font-variant:tabular-nums;font-feature-settings:'tnum';padding:0;color:", ";background:", ";outline:none;transition:all ", "ms ", ";zoom:1;", ",", "{margin-right:", "px;font-size:", "px;color:", ";transition:color ", "ms ", ";}", " ", " ", " ", " ", ",", " ", "{margin-right:0;font-size:", "px;}"], fontSize[token.fontLevel], lineHeight[token.fontLevel], colorsPattern.text.text, token.background, duration.status, easing.status, _StyledSvg2, _StyledSvg, token.iconMarginRight, fontSize[token.iconFontLevel], token.iconColor, duration.status, easing.status, modeStyle, spacingStyle, alignStyle, ExpandWrapper, _StyledSvg2, ExpandWrapper, _StyledSvg, expandIconToken.size);
};
/* stylelint-enable */


export var StyledMenu = styled.div.withConfig({
  displayName: "StyledMenu"
})(["", ";"], menuCss);
export var StyledMenuScrollWrapper = styled.div.withConfig({
  displayName: "StyledMenuScrollWrapper"
})(["overflow-x:hidden;overflow-y:auto;"]);

var subMenuTitleCss = function subMenuTitleCss(props) {
  var _props$theme2 = props.theme,
      token = _props$theme2.components.Menu,
      fontSize = _props$theme2.typography.spec.fontSize,
      _props$theme2$transit = _props$theme2.transition.pattern,
      easing = _props$theme2$transit.easing,
      duration = _props$theme2$transit.duration,
      $selected = props.$selected;
  return css(["position:relative;display:flex;box-sizing:border-box;justify-content:space-between;align-items:center;height:", "px;line-height:", "px;margin:", "px ", "px;padding:0 ", "px;font-size:", "px;transition:all ", "ms ", ";cursor:pointer;", "{display:block;margin-right:", "px;", ";}", ""], token.height, token.height, token.item.marginVertical, token.item.marginHorizontal, token.item.paddingHorizontal, fontSize[token.fontLevel], duration.status, easing.status, StyledSubMenuTitleAndIconWrapper, token.iconMarginRight, ellipsisStyle, $selected && css(["", ",", "{color:", ";}"], _StyledSvg2, _StyledSvg, token.highlightIconColor));
};

export var StyledSubMenuTitle = styled.div.withConfig({
  displayName: "StyledSubMenuTitle"
})(["", ""], subMenuTitleCss);
export var StyledSubMenuTitleAndIconWrapper = styled.div.withConfig({
  displayName: "StyledSubMenuTitleAndIconWrapper"
})(["& >:not(:only-child){vertical-align:middle;}"]);
export var StyledSubMenuTitleWrapper = styled.div.withConfig({
  displayName: "StyledSubMenuTitleWrapper"
})(["", ";"], ellipsisStyle); // submenu
// eslint-disable-next-line complexity

var subMenuCss = function subMenuCss(props) {
  var $disabled = props.$disabled,
      $menuHasIcon = props.$menuHasIcon,
      $level = props.$level,
      $inlineMode = props.$inlineMode,
      $horizontalMode = props.$horizontalMode,
      $inlineCollapsed = props.$inlineCollapsed,
      $selected = props.$selected,
      $isOpen = props.$isOpen,
      _props$theme3 = props.theme,
      colorsPattern = _props$theme3.colors.pattern,
      lineHeight = _props$theme3.typography.spec.lineHeight,
      _props$theme3$transit = _props$theme3.transition.pattern,
      easing = _props$theme3$transit.easing,
      duration = _props$theme3$transit.duration,
      token = _props$theme3.components.Menu;
  var $subMenuToken = token.subMenu;
  var disabledStyle;

  if ($disabled) {
    disabledStyle = css(["color:", ";cursor:not-allowed;> a{color:", ";pointer-events:none;}"], colorsPattern.text.disabled, colorsPattern.text.disabled);
  }

  var indentStyle;

  if ($level > 1 && $inlineMode && !$inlineCollapsed) {
    indentStyle = css(["padding-left:", "px;"], $menuHasIcon ? token.subMenu.indentWithIcon : token.subMenu.indent);
  }

  var inlineCollapsedStyle;

  if ($level === 1 && $inlineCollapsed) {
    inlineCollapsedStyle = css(["", "{margin-left:0;margin-right:0;}", "{margin-right:0;}", ",", "{margin-right:0;}"], StyledSubMenuTitle, StyledSubMenuTitleAndIconWrapper, _StyledSvg2, _StyledSvg);
  }

  var horizontalStyle;

  if ($horizontalMode && $level === 1) {
    $subMenuToken = _extends({}, $subMenuToken, {
      background: $subMenuToken.horizontalBackground,
      color: $subMenuToken.horizontalColor
    });
    horizontalStyle = css(["position:relative;display:inline-block;vertical-align:bottom;border-bottom:2px solid transparent;", " ", " & > ", "{& > ", "{align-items:flex-start;line-height:", "px;", " ", "}}"], ($selected || $isOpen) && css(["border-bottom:2px solid ", ";"], colorsPattern.text.highlight), !$disabled && css(["&:hover{border-bottom:2px solid ", ";}"], colorsPattern.text.highlight), StyledSubMenuTitleWrapper, StyledSubMenuTitle, lineHeight[token.fontLevel], !$disabled && css(["&:hover ", ",&:hover ", "{color:", ";transition:color ", "ms ", ";}"], _StyledSvg2, _StyledSvg, token.highlightIconColor, duration.status, easing.status), !$disabled && $isOpen && css(["", ",", "{color:", ";}"], _StyledSvg2, _StyledSvg, token.highlightIconColor));
  }

  var titleStatusStyle;

  if ((!$inlineMode || $inlineCollapsed) && $isOpen) {
    titleStatusStyle = css(["& > ", "{& > ", "{color:", ";background-color:", ";}}"], StyledSubMenuTitleWrapper, StyledSubMenuTitle, $subMenuToken.color.hover, $subMenuToken.background.hover);
  }

  return css(["position:relative;transition:all ", "ms ", ";& > ", "{& > ", "{", ";}}", ";", ";", ";", ";", ";"], duration.status, easing.status, StyledSubMenuTitleWrapper, StyledSubMenuTitle, itemStatusStyle({
    $disabled: $disabled,
    $selected: $selected,
    $itemToken: $subMenuToken
  }), !$disabled && !$selected && titleStatusStyle, indentStyle, disabledStyle, inlineCollapsedStyle, horizontalStyle);
};

export var StyledSubMenu = styled.div.withConfig({
  displayName: "StyledSubMenu"
})(["", ""], subMenuCss);
export var StyledMenuItemContent = styled.div.withConfig({
  displayName: "StyledMenuItemContent"
})(["& >:not(:only-child){vertical-align:middle;}"]);
export var StyledMenuItemText = styled.span.withConfig({
  displayName: "StyledMenuItemText"
})(["opacity:1;"]); // menuitem

var menuItemCss = function menuItemCss(props) {
  var $isSelected = props.$isSelected,
      $disabled = props.$disabled,
      $menuHasIcon = props.$menuHasIcon,
      $inlineMode = props.$inlineMode,
      $horizontalMode = props.$horizontalMode,
      $inlineCollapsed = props.$inlineCollapsed,
      $level = props.$level,
      _props$theme4 = props.theme,
      _props$theme4$transit = _props$theme4.transition.pattern,
      duration = _props$theme4$transit.duration,
      easing = _props$theme4$transit.easing,
      colorsPattern = _props$theme4.colors.pattern,
      _props$theme4$typogra = _props$theme4.typography.spec,
      fontSize = _props$theme4$typogra.fontSize,
      lineHeight = _props$theme4$typogra.lineHeight,
      token = _props$theme4.components.Menu;
  var $itemToken = token.item;
  var indentStyle;

  if ($level > 1 && $inlineMode && !$inlineCollapsed) {
    indentStyle = css(["padding-left:", "px;"], $menuHasIcon ? $itemToken.indentWithIcon : $itemToken.indent);
  }

  var inlineCollapsedStyle;

  if ($level === 1 && $inlineCollapsed) {
    inlineCollapsedStyle = css(["margin-left:0;margin-right:0;", ",", "{margin-right:0;}", "{display:inline-block;max-width:0;opacity:0;line-height:0;}"], _StyledSvg2, _StyledSvg, StyledMenuItemText);
  }

  var horizontalStyle;

  if ($level === 1 && $horizontalMode) {
    $itemToken = _extends({}, $itemToken, {
      background: $itemToken.horizontalBackground,
      color: $itemToken.horizontalColor
    });
    horizontalStyle = css(["position:relative;display:inline-block;vertical-align:bottom;border-bottom:2px solid transparent;", " ", "{line-height:", "px;}", ""], $isSelected && css(["border-bottom:2px solid ", ";"], colorsPattern.text.highlight), StyledMenuItemContent, lineHeight[token.fontLevel], !$disabled && css(["&:hover{border-bottom:2px solid ", ";}", "{&:hover ", ",&:hover ", "{color:", ";transition:color ", "ms ", ";}}"], colorsPattern.text.highlight, StyledMenuItemContent, _StyledSvg2, _StyledSvg, token.highlightIconColor, duration.status, easing.status));
  }

  return css(["position:relative;display:flex;", "{box-sizing:border-box;flex:1;height:", "px;line-height:", "px;margin:", "px ", "px;padding:0 ", "px;font-size:", "px;transition:all ", "ms ", ";cursor:pointer;", ";", ";", ";", " ", ";}", "{transition:opacity ", "ms ", ",width ", "ms ", ";&:only-child a{display:block;}}", ";a{color:inherit;text-decoration:none;", ";&::before{position:absolute;top:0;right:0;bottom:0;left:0;background-color:transparent;content:'';}}"], StyledMenuItemContent, token.height, token.height, token.item.marginVertical, token.item.marginHorizontal, token.item.paddingHorizontal, fontSize[token.fontLevel], duration.status, easing.status, ellipsisStyle, indentStyle, inlineCollapsedStyle, $isSelected && css(["", ",", "{color:", ";}"], _StyledSvg2, _StyledSvg, token.highlightIconColor), itemStatusStyle({
    $disabled: $disabled,
    $selected: $isSelected,
    $itemToken: $itemToken
  }), StyledMenuItemText, duration.status, easing.status, duration.status, easing.status, horizontalStyle, ellipsisStyle);
};

export var StyledMenuItem = styled.div.withConfig({
  displayName: "StyledMenuItem"
})(["", ";"], menuItemCss);
export var StyledMenuItemGroup = styled.div.withConfig({
  displayName: "StyledMenuItemGroup"
})(["", ""], function (props) {
  var $menuHasIcon = props.$menuHasIcon,
      $level = props.$level,
      $inlineMode = props.$inlineMode,
      $inlineCollapsed = props.$inlineCollapsed,
      _props$theme5 = props.theme,
      _props$theme5$typogra = _props$theme5.typography.spec,
      fontSize = _props$theme5$typogra.fontSize,
      lineHeight = _props$theme5$typogra.lineHeight,
      token = _props$theme5.components.Menu;
  var groupToken = token.group;
  var indentStyle;

  if ($level > 1 && $inlineMode && !$inlineCollapsed) {
    indentStyle = css(["padding-left:", "px;"], $menuHasIcon ? groupToken.indentWithIcon : groupToken.indent);
  }

  return css(["", ";", "{display:block;box-sizing:border-box;font-size:", "px;line-height:", "px;height:", "px;background:", ";color:", ";padding:", "px ", "px 0;", ";}& > ", " ", "{padding-left:", "px;}"], indentStyle, StyledMenuItemGroupLabel, fontSize[groupToken.fontLevel], lineHeight[groupToken.fontLevel], groupToken.height, groupToken.background, groupToken.color, groupToken.paddingTop, groupToken.paddingHorizontal, ellipsisStyle, StyledMenuItem, StyledMenuItemContent, groupToken.paddingHorizontal);
});
export var StyledMenuItemGroupLabel = styled.div.withConfig({
  displayName: "StyledMenuItemGroupLabel"
})(["user-select:none;"]);
export var StyledMenuDivider = styled.div.withConfig({
  displayName: "StyledMenuDivider"
})(["height:1px;"]);
export var StyledMenuWrapper = styled.div.withConfig({
  displayName: "StyledMenuWrapper"
})(["", ""], function (props) {
  var $width = props.$width,
      $height = props.$height,
      $inlineMode = props.$inlineMode,
      $verticalMode = props.$verticalMode,
      $inlineCollapsed = props.$inlineCollapsed,
      _props$theme6 = props.theme,
      colors = _props$theme6.colors,
      shadows = _props$theme6.shadows,
      _props$theme6$transit = _props$theme6.transition.pattern,
      easing = _props$theme6$transit.easing,
      duration = _props$theme6$transit.duration,
      _props$theme6$compone = _props$theme6.components.Menu,
      wrapperToken = _props$theme6$compone.wrapper,
      dividerToken = _props$theme6$compone.divider;
  return css(["height:100%;background:", ";border-radius:", ";padding:0;overflow:auto;transition:all ", "ms ", ";", ";", ";", ";", ";", ";", " ", "{background:", ";margin:", "px ", "px;}"], wrapperToken.background, wrapperToken.borderRadius, duration.status, easing.status, $inlineMode && "width: 100%", $width && "width: ".concat(addPx($width)), $height && "height: ".concat(addPx($height)), $verticalMode && "box-shadow: ".concat(shadows.pattern.popper.normal), $inlineCollapsed && "width: ".concat(wrapperToken.inlineCollapsedWidth, "px"), scrollBarStyle(_extends({}, props, {
    hidden: $inlineCollapsed
  })), StyledMenuDivider, colors.pattern.background.divider, dividerToken.paddingVertical, $inlineMode ? dividerToken.inlinePaddingHorizontal : dividerToken.paddingHorizontal);
});