import { muyaThemeLight as _muyaThemeLight } from "@muya-ui/theme-light/es/theme";
import _includes from "lodash/includes";
import React from 'react';
import ReactDOM from 'react-dom';
import { StyleSheetManager, ThemeProvider } from 'styled-components';
import ExpireQueue from './ExpireQueue';
import NotificationItem from './NotificationItem';
import NotificationList from './NotificationList';
var notification = {
  _expQueue: new ExpireQueue(),
  _autoInit: function _autoInit() {
    if (this._init) {
      return;
    }

    this._init = true;
    var opt = this._opt || {};
    var doc = window.document;
    this._mountEl = opt.container || doc.body;
    var containerElement = doc.createElement('div');

    this._mountEl.appendChild(containerElement);

    this._container = containerElement;
    var theme = opt.theme || _muyaThemeLight;
    var poolSettings = opt.setting || theme.components.Notification.notification.queueSetting;
    var expireQueue = new ExpireQueue();
    this._expQueue = expireQueue;
    expireQueue.reset(poolSettings);
    var position = opt.position || 'top-right';
    this._position = position;
    var children = /*#__PURE__*/React.createElement(ThemeProvider, {
      theme: theme
    }, /*#__PURE__*/React.createElement(NotificationList, {
      fullScreen: true,
      className: "".concat(theme.prefix, "-notification-list"),
      position: position,
      expireQueue: expireQueue,
      container: containerElement
    }, function (state, item) {
      var enterFrom = _includes(position, 'left') ? 'left' : 'right';
      return /*#__PURE__*/React.createElement(NotificationItem, {
        item: item,
        enterFrom: enterFrom,
        state: state,
        expireQueue: expireQueue,
        hoverStop: true,
        timeout: expireQueue.setting.timeout,
        onClose: function onClose() {
          return expireQueue.remove(item.id);
        }
      });
    }));

    if (opt.styleSheet) {
      ReactDOM.render( /*#__PURE__*/React.createElement(StyleSheetManager, {
        target: opt.styleSheet
      }, children), containerElement);
    } else {
      ReactDOM.render(children, containerElement);
    }
  },
  destroy: function destroy() {
    if (this._container) {
      ReactDOM.unmountComponentAtNode(this._container);

      if (this._mountEl) {
        this._mountEl.removeChild(this._container);
      }

      this._container = undefined;
    }

    this._init = false;
  },
  config: function config(opt) {
    this.destroy();
    this._opt = opt;

    this._autoInit();
  },
  _unshiftWithType: function _unshiftWithType(type, item) {
    item.type = type;
    return this.add(item);
  },
  success: function success(item) {
    return this._unshiftWithType('success', item);
  },
  error: function error(item) {
    return this._unshiftWithType('error', item);
  },
  info: function info(item) {
    return this._unshiftWithType('info', item);
  },
  warning: function warning(item) {
    return this._unshiftWithType('warning', item);
  },
  loading: function loading(item) {
    return this._unshiftWithType('loading', item);
  },
  close: function close(id) {
    this._expQueue.remove(id);
  },
  add: function add(item) {
    var opt = this._opt || {};
    var position = opt.position || 'top-right';

    if (position.includes('bottom')) {
      return this._expQueue.unshift(item);
    }

    return this._expQueue.push(item);
  }
}; // 保证第一次进入的时候动画效果

notification.config({});
export default notification;