import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["bgColor"];
import React from 'react';
import Background from '../Background';
import Button from '../Button';
import { useTheme } from '../utils/useTheme';
var OutlineButton = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var bgColor = props.bgColor,
      restProps = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();

  if (bgColor) {
    return /*#__PURE__*/React.createElement(Background, {
      display: "inline-block",
      borderRadius: theme.components.Button.borderRadius.normal,
      backgroundColor: bgColor
    }, /*#__PURE__*/React.createElement(Button, _extends({
      ref: ref
    }, restProps, {
      outline: true
    })));
  }

  return /*#__PURE__*/React.createElement(Button, _extends({
    ref: ref
  }, restProps, {
    outline: true
  }));
});
OutlineButton.__MUYA_BUTTON = true;
export default OutlineButton;