import { css } from 'styled-components';
import { mergeProps } from '../Tag/utils';
export var outlineTagCss = function outlineTagCss(originalProps) {
  var props = mergeProps(originalProps);
  var token = props.theme.components.Tag;
  var _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      type = props.type,
      _props$hoverable = props.hoverable,
      hoverable = _props$hoverable === void 0 ? true : _props$hoverable;
  var bgSchema = type === 'mask' ? token.maskBg.outline : token.outlineBg[type];
  var borderSchema = type === 'mask' ? token.maskColor.outline : token.outlineBorder[type];
  var colorSchema = type === 'mask' ? token.maskColor.outline : token.outlineColor[type];
  return css(["background:", ";border-width:1px;border-style:solid;border-color:", ";color:", ";", ""], bgSchema.normal, borderSchema.normal, colorSchema.normal, !disabled && hoverable ? css(["&:hover{background:", ";color:", ";border-color:", ";}"], bgSchema.hover, colorSchema.normal, borderSchema.hover) : '');
};