import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import { GuildRightIcon as _GuildRightIcon } from "@muya-ui/theme-light/es/icons/GuildRightIcon";
import { GuildLeftIcon as _GuildLeftIcon } from "@muya-ui/theme-light/es/icons/GuildLeftIcon";
var _excluded = ["type", "itemRender", "finalCurrent"];
import React from 'react';
import useLocale from '../Locale/useLocale';
import Tooltip from '../Tooltip';
import addPx from '../utils/addPx';
import useTheme from '../utils/useTheme';
import { StyledPageArrow } from './styled';
var pagerIconStyle = {
  verticalAlign: 'middle'
};
export default /*#__PURE__*/React.memo(function (props) {
  var theme = useTheme();
  var locale = useLocale();
  var _theme$components$Pag = theme.components.Pagination,
      _theme$components$Pag2 = _theme$components$Pag.PageForwardIcon,
      PageForwardIcon = _theme$components$Pag2 === void 0 ? _GuildLeftIcon : _theme$components$Pag2,
      _theme$components$Pag3 = _theme$components$Pag.PageBackwardIcon,
      PageBackwardIcon = _theme$components$Pag3 === void 0 ? _GuildRightIcon : _theme$components$Pag3,
      tooltipDelay = _theme$components$Pag.tooltipDelay,
      pageIconSize = _theme$components$Pag.pageIconSize;

  var type = props.type,
      itemRender = props.itemRender,
      finalCurrent = props.finalCurrent,
      other = _objectWithoutProperties(props, _excluded);

  var Icon = type === 'next' ? PageBackwardIcon : PageForwardIcon;
  var title = type === 'next' ? locale['Pagination.nextPage'] : locale['Pagination.prevPage'];
  var page = type === 'prev' ? finalCurrent - 1 : finalCurrent + 1;
  var iconNode = /*#__PURE__*/React.createElement(Icon, {
    fontSize: addPx(pageIconSize),
    style: pagerIconStyle
  });
  var children = itemRender ? itemRender(page, type, iconNode) : iconNode;
  return /*#__PURE__*/React.createElement(Tooltip, {
    title: title,
    placement: "top",
    enterDelay: tooltipDelay
  }, /*#__PURE__*/React.createElement(StyledPageArrow, _extends({
    theme: theme,
    itemRender: itemRender
  }, other), children));
});