import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import { SpeedIcon as _SpeedIcon } from "@muya-ui/theme-light/es/icons/SpeedIcon";
import { SpeedLeftIcon as _SpeedLeftIcon } from "@muya-ui/theme-light/es/icons/SpeedLeftIcon";
import { MoreIcon as _MoreIcon } from "@muya-ui/theme-light/es/icons/MoreIcon";
var _excluded = ["type", "itemRender", "page"];
import React from 'react';
import useLocale from '../Locale/useLocale';
import Tooltip from '../Tooltip';
import useTheme from '../utils/useTheme';
import { StyledJumpIcon, StyledMoreIcon, StyledPaginationEllipsis } from './styled';
export default /*#__PURE__*/React.memo(function (props) {
  var theme = useTheme();
  var locale = useLocale();
  var _theme$components$Pag = theme.components.Pagination,
      _theme$components$Pag2 = _theme$components$Pag.MoreIcon,
      MoreIcon = _theme$components$Pag2 === void 0 ? _MoreIcon : _theme$components$Pag2,
      _theme$components$Pag3 = _theme$components$Pag.FastBackwardIcon,
      FastBackwardIcon = _theme$components$Pag3 === void 0 ? _SpeedLeftIcon : _theme$components$Pag3,
      _theme$components$Pag4 = _theme$components$Pag.FastForwardIcon,
      FastForwardIcon = _theme$components$Pag4 === void 0 ? _SpeedIcon : _theme$components$Pag4,
      tooltipDelay = _theme$components$Pag.tooltipDelay;

  var type = props.type,
      itemRender = props.itemRender,
      page = props.page,
      other = _objectWithoutProperties(props, _excluded);

  var Icon = type === 'next' ? FastForwardIcon : FastBackwardIcon;
  var title = type === 'next' ? locale['Pagination.next5'] : locale['Pagination.prev5'];
  var iconNode = /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(StyledMoreIcon, {
    theme: theme
  }, /*#__PURE__*/React.createElement(MoreIcon, null)), /*#__PURE__*/React.createElement(StyledJumpIcon, {
    theme: theme
  }, /*#__PURE__*/React.createElement(Icon, null)));
  var itemType = "jump-".concat(type);
  var children = itemRender ? itemRender(page, itemType, iconNode) : iconNode;
  return /*#__PURE__*/React.createElement(Tooltip, {
    title: title,
    placement: "top",
    enterDelay: tooltipDelay
  }, /*#__PURE__*/React.createElement(StyledPaginationEllipsis, _extends({
    theme: theme
  }, other), children));
});