import styled, { css } from 'styled-components';
import InlineButton from '../InlineButton';

function makeIconWrapperStyle(props) {
  var _props$theme = props.theme,
      colors = _props$theme.colors,
      token = _props$theme.components.Popconfirm,
      $type = props.$type;
  var colorStyle = $type && css(["color:", ";"], colors.pattern.feature[$type]);
  return css(["position:absolute;right:100%;top:0;transform:translateX(", "px);", ""], token.translateX, colorStyle);
}

export var StyledTitleWrapper = styled.div.withConfig({
  displayName: "StyledTitleWrapper"
})(["position:relative;"]);
export var StyledIconWrapper = styled.span.withConfig({
  displayName: "StyledIconWrapper"
})(["", ""], makeIconWrapperStyle);
export var StyledInlineButton = styled(InlineButton).withConfig({
  displayName: "StyledInlineButton"
})(["&&{padding:0;}"]);