import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["className", "style", "title", "content", "actions", "arrowStyle", "styles", "disableTypography"];
import React, { useMemo } from 'react';
import Trigger from '../Trigger';
import Typography from '../Typography';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import { StyledActionsWrapper, StyledCardWrapper, StyledTitleWrapper } from './styled';
export default memoForwardRef(function (props, ref) {
  var className = props.className,
      style = props.style,
      title = props.title,
      content = props.content,
      actions = props.actions,
      _props$arrowStyle = props.arrowStyle,
      arrowStyle = _props$arrowStyle === void 0 ? {} : _props$arrowStyle,
      styles = props.styles,
      _props$disableTypogra = props.disableTypography,
      disableTypography = _props$disableTypogra === void 0 ? false : _props$disableTypogra,
      other = _objectWithoutProperties(props, _excluded);

  var defaultStyles = useMemo(function () {
    return {
      wrapper: '',
      actionsWrapper: '',
      titleWrapper: '',
      contentWrapper: ''
    };
  }, []);
  var innerStyles = useStyles('popovercard', defaultStyles, styles);
  var theme = useTheme();
  var popup = useMemo(function () {
    return /*#__PURE__*/React.createElement(StyledCardWrapper, {
      theme: theme,
      className: [innerStyles.wrapper.className, className].join(' ').trim(),
      style: _extends({}, innerStyles.wrapper.style, style)
    }, /*#__PURE__*/React.createElement(React.Fragment, null, title && /*#__PURE__*/React.createElement(StyledTitleWrapper, _extends({}, innerStyles.titleWrapper, {
      theme: theme
    }), /*#__PURE__*/React.createElement(Typography.Title, {
      level: theme.components.PopoverCard.title.level
    }, title)), content && !disableTypography ? /*#__PURE__*/React.createElement(Typography.Text, _extends({}, innerStyles.contentWrapper, {
      color: "assistant"
    }), content) : content, actions && /*#__PURE__*/React.createElement(StyledActionsWrapper, _extends({}, innerStyles.actionsWrapper, {
      theme: theme
    }), actions)));
  }, [actions, className, content, disableTypography, innerStyles.actionsWrapper, innerStyles.contentWrapper, innerStyles.titleWrapper, innerStyles.wrapper.className, innerStyles.wrapper.style, style, theme, title]);
  return /*#__PURE__*/React.createElement(Trigger, _extends({
    ref: ref,
    popup: popup,
    arrowStyle: _extends({
      color: theme.colors.pattern.background.higher
    }, arrowStyle)
  }, other));
});