import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["autoFocus", "disabled", "defaultChecked", "ellipsis", "width", "checked", "children", "size", "onChange", "onMouseEnter", "onMouseLeave", "styles", "inputRef", "className", "style", "checkedIcon", "unCheckedIcon"];
import React, { useMemo } from 'react';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import { StyledInlineButton, StyledRadioIcon, StyledRadioInner, StyledRadioInput, StyledRadioLabel, StyledRadioText } from './styled';
import useRadio from './useRadio';
import mergeStyleItem from '../utils/mergeStyleItem';
var defaultStyles = {
  wrapper: '',
  inputRadio: '',
  innerRadio: '',
  text: ''
};
var Radio = memoForwardRef(function (props, ref) {
  var _props$autoFocus = props.autoFocus,
      autoFocus = _props$autoFocus === void 0 ? false : _props$autoFocus,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      _props$defaultChecked = props.defaultChecked,
      defaultChecked = _props$defaultChecked === void 0 ? false : _props$defaultChecked,
      _props$ellipsis = props.ellipsis,
      ellipsis = _props$ellipsis === void 0 ? false : _props$ellipsis,
      width = props.width,
      checked = props.checked,
      children = props.children,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      onChange = props.onChange,
      onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave,
      styles = props.styles,
      inputRef = props.inputRef,
      className = props.className,
      style = props.style,
      checkedIcon = props.checkedIcon,
      unCheckedIcon = props.unCheckedIcon,
      restProps = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  var _theme$components$Rad = theme.components.Radio,
      iconSize = _theme$components$Rad.iconSize,
      CheckedIcon = _theme$components$Rad.CheckedIcon,
      UnCheckedIcon = _theme$components$Rad.UnCheckedIcon;
  var innerStyles = useStyles('radio', defaultStyles, styles);
  var wrapperStyleItem = useMemo(function () {
    return mergeStyleItem({
      className: className,
      style: style
    }, innerStyles.wrapper);
  }, [className, innerStyles.wrapper, style]);

  var _useRadio = useRadio(props, 'checked' in props),
      checkedState = _useRadio.checkedState,
      handleInputChange = _useRadio.handleInputChange,
      handleClick = _useRadio.handleClick,
      handleInputClick = _useRadio.handleInputClick,
      handleCustomClick = _useRadio.handleCustomClick;

  var checkedNode = useMemo(function () {
    return checkedIcon || (CheckedIcon ? /*#__PURE__*/React.createElement(CheckedIcon, {
      fontSize: iconSize[size]
    }) : null);
  }, [CheckedIcon, checkedIcon, iconSize, size]);
  var unCheckedNode = useMemo(function () {
    return unCheckedIcon || (UnCheckedIcon ? /*#__PURE__*/React.createElement(UnCheckedIcon, {
      fontSize: iconSize[size]
    }) : null);
  }, [UnCheckedIcon, iconSize, size, unCheckedIcon]);
  return checkedNode && unCheckedNode ? /*#__PURE__*/React.createElement(StyledInlineButton, _extends({
    theme: theme,
    $ellipsis: ellipsis,
    $checked: checkedState
  }, wrapperStyleItem, {
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave,
    onClick: handleCustomClick,
    disabled: disabled
  }), checkedState ? checkedNode : unCheckedNode, /*#__PURE__*/React.createElement(StyledRadioText, _extends({}, innerStyles.text, {
    theme: theme,
    $size: size
  }), children)) : /*#__PURE__*/React.createElement(StyledRadioLabel, _extends({
    ref: ref,
    theme: theme,
    $disabled: disabled,
    $width: width,
    $ellipsis: ellipsis,
    $checked: checkedState
  }, wrapperStyleItem, {
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave,
    onClick: handleClick
  }), /*#__PURE__*/React.createElement(StyledRadioIcon, null, /*#__PURE__*/React.createElement(StyledRadioInput, _extends({}, restProps, innerStyles.inputRadio, {
    ref: inputRef,
    type: "radio",
    autoFocus: autoFocus,
    checked: checkedState,
    onClick: handleInputClick,
    onChange: handleInputChange,
    disabled: disabled
  })), /*#__PURE__*/React.createElement(StyledRadioInner, _extends({}, innerStyles.innerRadio, {
    theme: theme,
    $checked: checkedState,
    $size: size
  }))), children ? /*#__PURE__*/React.createElement(StyledRadioText, _extends({}, innerStyles.text, {
    theme: theme,
    $size: size
  }), children) : null);
});
Radio.useRadio = useRadio;
Radio.__MUYA_RADIO = true;
export default Radio;