import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import { useCallback, useState } from 'react';
export function useRadio(props, isControlled) {
  var checked = props.checked,
      _props$defaultChecked = props.defaultChecked,
      defaultChecked = _props$defaultChecked === void 0 ? false : _props$defaultChecked,
      disabled = props.disabled,
      onChange = props.onChange,
      onClick = props.onClick;

  var _useState = useState(isControlled ? !!checked : defaultChecked),
      _useState2 = _slicedToArray(_useState, 2),
      checkedState = _useState2[0],
      setCheckedState = _useState2[1];

  var handleInputChange = useCallback(function (e) {
    if (disabled) {
      return;
    }

    var value = e.target.checked;

    if (!isControlled) {
      setCheckedState(value);
    }

    if (onChange) {
      onChange(e);
    }
  }, [disabled, isControlled, onChange]);
  var handleInputClick = useCallback(function (e) {
    e.preventDefault();
    e.stopPropagation();

    if (e.nativeEvent) {
      e.nativeEvent.stopImmediatePropagation();
    }
  }, []);
  var handleClick = useCallback(function (e) {
    if (disabled) {
      return;
    } // if (!isControlled) {
    //   setCheckedState(!checkedState);
    // }


    if (onClick) {
      onClick(e);
    }
  }, [disabled, onClick]);

  if (isControlled && checkedState !== !!checked) {
    setCheckedState(!!checked);
  }

  var handleCustomClick = useCallback(function (e) {
    if (disabled) {
      return;
    }

    if (!isControlled) {
      setCheckedState(!checkedState);
    }

    if (onClick) {
      onClick(e);
    }

    if (onChange) {
      var v = {
        target: {
          checked: !checkedState
        }
      };
      onChange(v);
    }
  }, [checkedState, disabled, isControlled, onChange, onClick]);
  return {
    checkedState: checkedState,
    handleInputChange: handleInputChange,
    handleInputClick: handleInputClick,
    handleClick: handleClick,
    setCheckedState: setCheckedState,
    handleCustomClick: handleCustomClick
  };
}
export default useRadio;