import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["defaultValue", "value", "options", "onChange", "children", "radioEllipsis", "radioWidth", "renderRadio"];
import { useCallback, useMemo, useState } from 'react';

var defaultRenderRadio = function defaultRenderRadio(radioNode) {
  return radioNode;
};

export function useRadioGroup(props) {
  var _props$defaultValue = props.defaultValue,
      defaultValue = _props$defaultValue === void 0 ? null : _props$defaultValue,
      valueProp = props.value,
      options = props.options,
      onChange = props.onChange,
      children = props.children,
      radioEllipsis = props.radioEllipsis,
      radioWidth = props.radioWidth,
      _props$renderRadio = props.renderRadio,
      renderRadio = _props$renderRadio === void 0 ? defaultRenderRadio : _props$renderRadio,
      restProps = _objectWithoutProperties(props, _excluded);

  var isControlled = ('value' in props);

  var _useState = useState(defaultValue),
      _useState2 = _slicedToArray(_useState, 2),
      innerValue = _useState2[0],
      setInnerValue = _useState2[1];

  var valueState = isControlled ? valueProp : innerValue;
  var opts = useMemo(function () {
    if (options && options.length) {
      return options.map(function (option) {
        if (typeof option === 'string') {
          return {
            label: option,
            value: option
          };
        }

        return option;
      });
    }

    return [];
  }, [options]);
  var handleChange = useCallback(function (option, e) {
    setInnerValue(option.value);

    if (option.onChange) {
      option.onChange(e);
    }

    if (onChange && option.value !== valueState) {
      onChange(option.value);
    }
  }, [onChange, valueState]);
  var handleClick = useCallback(function (option, e) {
    e.preventDefault();
    setInnerValue(option.value);

    if (option.onClick) {
      option.onClick(e);
    }

    if (onChange && option.value !== valueState) {
      onChange(option.value);
    }
  }, [onChange, valueState]);
  return {
    opts: opts,
    valueState: valueState,
    restProps: restProps,
    children: children,
    radioEllipsis: radioEllipsis,
    radioWidth: radioWidth,
    handleChange: handleChange,
    handleClick: handleClick,
    renderRadio: renderRadio
  };
}
export default useRadioGroup;