import _extends from "@babel/runtime/helpers/extends";
import { StarsIcon as _StarsIcon } from "@muya-ui/theme-light/es/icons/StarsIcon";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["finalIndex", "styles", "icon", "finalInfos", "showInfo", "showResult", "showTooltip", "readOnly", "style", "count", "color", "selectSingle", "handleChange", "handleMouseLeave", "handleMouseEnter"];
import React, { useMemo } from 'react';
import mergeStyleItem from '../utils/mergeStyleItem';
import useStyles from '../utils/useStyles';
import { StyledItem, StyledWrapper, StyledItemText, StyledItemTextInner } from './styled';
import useRate from './useRate';
import memoForwardRef from '../utils/memoForwardRef';
import { Tooltip } from '../Tooltip';
import useTheme from '../utils/useTheme';
var defaultStyles = {
  wrapper: '',
  item: ''
};
var Rate = memoForwardRef(function (props, ref) {
  var _useRate = useRate(props),
      finalIndex = _useRate.finalIndex,
      styles = _useRate.styles,
      _useRate$icon = _useRate.icon,
      icon = _useRate$icon === void 0 ? /*#__PURE__*/React.createElement(_StarsIcon, null) : _useRate$icon,
      finalInfos = _useRate.finalInfos,
      showInfo = _useRate.showInfo,
      showResult = _useRate.showResult,
      showTooltip = _useRate.showTooltip,
      readOnly = _useRate.readOnly,
      style = _useRate.style,
      _useRate$count = _useRate.count,
      count = _useRate$count === void 0 ? 5 : _useRate$count,
      color = _useRate.color,
      selectSingle = _useRate.selectSingle,
      handleChange = _useRate.handleChange,
      handleMouseLeave = _useRate.handleMouseLeave,
      handleMouseEnter = _useRate.handleMouseEnter,
      other = _objectWithoutProperties(_useRate, _excluded);

  var theme = useTheme();
  var innerStyles = useStyles('rate', defaultStyles, styles);
  var wrapperStyleItem = mergeStyleItem({
    style: style
  }, innerStyles.wrapper);
  var finalShowInfo = !showTooltip && showInfo;
  var items = useMemo(function () {
    return /*#__PURE__*/React.createElement(React.Fragment, null, finalInfos.map(function (text, index) {
      var content = /*#__PURE__*/React.createElement(React.Fragment, null, typeof icon === 'function' ? icon({
        index: index
      }) : icon, finalShowInfo && /*#__PURE__*/React.createElement(StyledItemTextInner, {
        theme: theme
      }, text));
      return /*#__PURE__*/React.createElement(StyledItem, {
        theme: theme,
        onClick: function onClick() {
          return handleChange(index);
        },
        onMouseEnter: function onMouseEnter() {
          return handleMouseEnter(index);
        },
        key: index,
        $color: color,
        style: style,
        $readOnly: readOnly,
        $active: selectSingle ? finalIndex === index : finalIndex >= index
      }, showTooltip ? /*#__PURE__*/React.createElement(Tooltip, {
        title: text
      }, /*#__PURE__*/React.createElement("span", null, content)) : content);
    }), showResult && /*#__PURE__*/React.createElement(StyledItemText, {
      theme: theme
    }, finalInfos[finalIndex] || "".concat(finalIndex + 1, "\u5206")));
  }, [color, finalIndex, finalInfos, finalShowInfo, handleChange, handleMouseEnter, icon, readOnly, selectSingle, showResult, showTooltip, style, theme]);
  return /*#__PURE__*/React.createElement(StyledWrapper, _extends({
    ref: ref
  }, wrapperStyleItem, other, {
    onMouseLeave: handleMouseLeave
  }), items);
});
Rate.__MUYA_RATE = true;
export default Rate;