import styled, { css } from 'styled-components';
export var StyledWrapper = styled.div.withConfig({
  displayName: "StyledWrapper"
})(["display:flex;align-items:center;"]);
export var StyledItem = styled.span.withConfig({
  displayName: "StyledItem"
})(["", ""], function (props) {
  var $readOnly = props.$readOnly,
      $color = props.$color,
      $active = props.$active,
      _props$theme = props.theme,
      transition = _props$theme.transition,
      token = _props$theme.components.Rate;
  var colorStyle = $active ? css(["color:", ";"], $color || token.color) : css(["color:", ";"], token.bgColor);
  var hoverStyle = !$readOnly && css(["&:hover svg{transform:scale(1.16);transform-origin:center;transition:all ", ";}"], transition.spec.duration.fast);
  var cursorStyle = !$readOnly && css(["cursor:pointer;"]);
  var fontSize = $readOnly ? token.displaySize : token.size;
  var marginRight = $readOnly ? token.displayMarginRight : token.marginRight;
  return css(["font-size:", "px;text-align:center;", ";", ";&:not(:last-child){margin-right:", "px;}", ""], fontSize, colorStyle, cursorStyle, marginRight, hoverStyle);
});
export function makeTextStyle(props) {
  var _props$theme2 = props.theme,
      fontSize = _props$theme2.typography.spec.fontSize,
      token = _props$theme2.components.Rate;
  return css(["font-size:", "px;line-height:normal;color:", ";"], fontSize.s1, token.textColor);
}
export var StyledItemText = styled.span.withConfig({
  displayName: "StyledItemText"
})(["", ";"], makeTextStyle);
export var StyledItemTextInner = styled.div.withConfig({
  displayName: "StyledItemTextInner"
})(["", ";padding-top:", "px;"], makeTextStyle, function (_ref) {
  var theme = _ref.theme;
  return theme.components.Rate.textPadding;
});