import _extends from "@babel/runtime/helpers/extends";
import { useEventCallback as _useEventCallback } from "@muya-ui/utils/es/hooks/useEventCallback";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["value", "defaultValue", "count", "infos", "onChange", "onHoverChange", "readOnly"];
import { useMemo, useState } from 'react';
export default function useRate(props) {
  var valueFromProps = props.value,
      defaultValue = props.defaultValue,
      _props$count = props.count,
      count = _props$count === void 0 ? 5 : _props$count,
      _props$infos = props.infos,
      infos = _props$infos === void 0 ? [] : _props$infos,
      onChange = props.onChange,
      onHoverChange = props.onHoverChange,
      readOnly = props.readOnly,
      rest = _objectWithoutProperties(props, _excluded);

  var isControlled = ('value' in props);

  var _useState = useState(defaultValue || 0),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  var _useState3 = useState(0),
      _useState4 = _slicedToArray(_useState3, 2),
      hoverValue = _useState4[0],
      setHoverValue = _useState4[1];

  var _useState5 = useState(false),
      _useState6 = _slicedToArray(_useState5, 2),
      isHover = _useState6[0],
      setIsHover = _useState6[1];

  var handleChange = _useEventCallback(function (value) {
    if (readOnly) return;
    setValue(value + 1);
    if (onChange) onChange(value + 1);
  });

  var handleMouseEnter = _useEventCallback(function (index) {
    if (readOnly) return;
    setIsHover(true);
    setHoverValue(index + 1);
    if (onHoverChange) onHoverChange(index + 1);
  });

  var handleMouseLeave = _useEventCallback(function () {
    if (readOnly) return;
    setHoverValue(-1);
    setIsHover(false);
  });

  var finalValue = isHover ? hoverValue : isControlled ? valueFromProps : value;
  var finalInfos = useMemo(function () {
    return Array(count).fill(1).map(function (item, index) {
      return infos[index] || "".concat(index + 1, "\u5206");
    });
  }, [infos, count]);
  return _extends({
    finalIndex: (finalValue || 0) - 1,
    readOnly: readOnly,
    handleChange: handleChange,
    handleMouseEnter: handleMouseEnter,
    handleMouseLeave: handleMouseLeave,
    finalInfos: finalInfos,
    count: count
  }, rest);
}