import { ClearIcon as _ClearIcon } from "@muya-ui/theme-light/es/icons/ClearIcon";
import { ReminderIcon as _ReminderIcon } from "@muya-ui/theme-light/es/icons/ReminderIcon";
import { InformIcon as _InformIcon } from "@muya-ui/theme-light/es/icons/InformIcon";
import { SuccessIcon as _SuccessIcon } from "@muya-ui/theme-light/es/icons/SuccessIcon";
import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _includes from "lodash/includes";
var _excluded = ["title", "subTitle", "icon", "type", "iconSize", "vertical", "extra", "reason", "styles", "imgProps"];
import React, { forwardRef } from 'react';
import { ImgImg } from '../Img';
import useLocale from '../Locale/useLocale';
import Typography from '../Typography';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import { StyleButton, StyledIcon, StyledResult, StyleReason, StyleSubTitle, StyleTitle } from './styled';
export var Icons = ['success', 'error', 'info', 'warning'];
export var ExceptionStatus = ['forbidden', 'empty', 'emptySmall'];
var defaultStyles = {
  content: '',
  icon: '',
  title: '',
  subTitle: '',
  reason: '',
  extra: ''
};
var Result = /*#__PURE__*/forwardRef(function (props, ref) {
  var theme = useTheme();
  var token = theme.components.Result;

  var title = props.title,
      subTitle = props.subTitle,
      icon = props.icon,
      _props$type = props.type,
      type = _props$type === void 0 ? 'info' : _props$type,
      _props$iconSize = props.iconSize,
      iconSize = _props$iconSize === void 0 ? token.defaultIconSize : _props$iconSize,
      _props$vertical = props.vertical,
      vertical = _props$vertical === void 0 ? true : _props$vertical,
      extra = props.extra,
      reason = props.reason,
      styles = props.styles,
      imgProps = props.imgProps,
      otherProps = _objectWithoutProperties(props, _excluded);

  var local = useLocale();
  var innerStyles = useStyles('result', defaultStyles, styles);
  var iconNode;

  var isStatusIcon = _includes(ExceptionStatus, type);

  var typeIcon = _extends({
    success: _SuccessIcon,
    info: _InformIcon,
    warning: _ReminderIcon,
    error: _ClearIcon,
    forbidden: '//qhstaticssl.kujiale.com/newt/100759/image/svgxml/1573020737658/62EC08BDA2CDEA69697790DCB6240015.svg',
    empty: '//qhstaticssl.kujiale.com/newt/100759/image/svgxml/1573020737659/28AD5A0CE2237E2987B3D751C4C5BA83.svg',
    emptySmall: '//qhstaticssl.kujiale.com/newt/100759/image/svgxml/1573020737281/D8307EB1E1C8C21BCE88D2D55B980DE5.svg'
  }, theme.components.Result.typeIcon);

  if (isStatusIcon) {
    var _icon = typeIcon[type];
    var _token$typeIconSize = token.typeIconSize[type],
        width = _token$typeIconSize.width,
        height = _token$typeIconSize.height;
    iconNode = /*#__PURE__*/React.createElement(StyledIcon, _extends({}, innerStyles.icon, {
      theme: theme,
      $vertical: vertical,
      $type: type,
      $iconSize: height
    }), /*#__PURE__*/React.createElement("img", {
      src: _icon,
      width: width,
      alt: ""
    }));
  } else {
    if ( /*#__PURE__*/React.isValidElement(icon)) {
      iconNode = icon;
    } else {
      var Icon = typeIcon[type];
      var iconBgColor = token.typeBg[type];
      iconNode = /*#__PURE__*/React.createElement(StyledIcon, _extends({}, innerStyles.icon, {
        theme: theme,
        $vertical: vertical,
        $type: type,
        $iconSize: iconSize
      }), typeof icon === 'string' ? /*#__PURE__*/React.createElement(ImgImg, _extends({
        src: icon,
        width: iconSize
      }, imgProps)) : /*#__PURE__*/React.createElement(Icon, {
        bgColor: iconBgColor,
        fontSize: iconSize
      }));
    }
  }

  var renderTitle = title;
  var renderSubTitle = subTitle;

  if (type === 'forbidden') {
    renderTitle = renderTitle || '403';
    renderSubTitle = renderSubTitle || local['Result.forbiddenSubTitle'];
  }

  if (_includes(type, 'empty')) {
    renderSubTitle = renderSubTitle || local['Result.emptyText'];
  }

  return /*#__PURE__*/React.createElement(StyledResult, _extends({
    ref: ref,
    theme: theme,
    $vertical: vertical
  }, otherProps), iconNode, /*#__PURE__*/React.createElement("div", innerStyles.content, renderTitle ? /*#__PURE__*/React.createElement(StyleTitle, _extends({}, innerStyles.title, {
    theme: theme,
    $vertical: vertical
  }), /*#__PURE__*/React.createElement(Typography.Title, {
    strong: true,
    level: token.defaultTitleLevel
  }, renderTitle)) : null, renderSubTitle ? /*#__PURE__*/React.createElement(StyleSubTitle, _extends({}, innerStyles.subTitle, {
    theme: theme,
    $title: renderTitle
  }), /*#__PURE__*/React.createElement(Typography.Paragraph, {
    fontSize: token.defaultSubTitleFontLevel,
    color: "assistant"
  }, renderSubTitle)) : null, reason ? /*#__PURE__*/React.createElement(StyleReason, _extends({}, innerStyles.reason, {
    theme: theme
  }), reason) : null, extra ? /*#__PURE__*/React.createElement(StyleButton, _extends({}, innerStyles.extra, {
    theme: theme
  }), extra) : null));
});
export default Result;