import _includes from "lodash/includes";
import styled, { css } from 'styled-components';
import { StyledTitle } from '../Typography/Title';
import { Icons } from './Result';
export var StyledResult = styled.div.withConfig({
  displayName: "StyledResult"
})(["", ""], function (props) {
  var $vertical = props.$vertical;

  if ($vertical) {
    return css(["text-align:center;"]);
  } else {
    return css(["display:flex;justify-content:center;"]);
  }
});
export var StyledIcon = styled.div.withConfig({
  displayName: "StyledIcon"
})(["", ""], function (props) {
  var theme = props.theme,
      $vertical = props.$vertical,
      $type = props.$type,
      $iconSize = props.$iconSize;
  var marginRight = $vertical ? 0 : theme.components.Result.iconMarginRight;

  if (_includes(Icons, $type)) {
    return css(["margin-right:", "px;color:", ";height:", "px;"], marginRight, theme.colors.pattern.feature[$type], $iconSize);
  } else {
    return css(["margin-right:", "px;height:", "px;"], marginRight, $iconSize);
  }
});
export var StyleTitle = styled.div.withConfig({
  displayName: "StyleTitle"
})(["", ""], function (props) {
  var theme = props.theme,
      $vertical = props.$vertical;
  var top = $vertical ? theme.components.Result.titleMarginTop : 0;
  return css(["margin-top:", "px;", "{margin-bottom:0;}"], top, StyledTitle);
});
export var StyleSubTitle = styled.div.withConfig({
  displayName: "StyleSubTitle"
})(["", ""], function (props) {
  var _props$theme$componen = props.theme.components.Result,
      titleMarginTop = _props$theme$componen.titleMarginTop,
      useTitleMarginTopWhenNoTitle = _props$theme$componen.useTitleMarginTopWhenNoTitle,
      subTitleMarginTop = _props$theme$componen.subTitleMarginTop;
  return css(["margin-top:", "px;"], !props.$title && useTitleMarginTopWhenNoTitle ? titleMarginTop : subTitleMarginTop);
});
export var StyleReason = styled.div.withConfig({
  displayName: "StyleReason"
})(["", ""], function (props) {
  var token = props.theme.components.Result;
  return css(["margin-top:", "px;margin-bottom:", "px;"], token.reasonMarginTop, token.reasonMarginBottom);
});
export var StyleButton = styled.div.withConfig({
  displayName: "StyleButton"
})(["", ""], function (props) {
  var theme = props.theme;
  return css(["margin-top:", "px;"], theme.components.Result.buttonMarginTop);
});