import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["scrollX", "scrollY", "width", "height", "maxWidth", "maxHeight", "size", "children", "styles", "onScroll", "contentRef"];
import React from 'react';
import styled, { css } from 'styled-components';
import { BaseDiv } from '../styled/base';
import addPx from '../utils/addPx';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import { withThemeForStyled } from '../utils/withTheme';
import { scrollBarStyle, scrollXStyle, scrollYStyle, StyledScrollViewContent } from './styled';
var defaultStyles = {
  content: ''
};
var ScrollViewPure = memoForwardRef(function (props, ref) {
  var scrollX = props.scrollX,
      scrollY = props.scrollY,
      width = props.width,
      height = props.height,
      maxWidth = props.maxWidth,
      maxHeight = props.maxHeight,
      size = props.size,
      children = props.children,
      styles = props.styles,
      onScroll = props.onScroll,
      contentRef = props.contentRef,
      restProps = _objectWithoutProperties(props, _excluded);

  var innerStyles = useStyles('scroll-view', defaultStyles, styles);
  return /*#__PURE__*/React.createElement(BaseDiv, _extends({}, restProps, {
    ref: ref
  }), /*#__PURE__*/React.createElement(StyledScrollViewContent, _extends({
    ref: contentRef,
    onScroll: onScroll
  }, innerStyles.content), children));
});
var ScrollView = styled(ScrollViewPure).withConfig({
  displayName: "ScrollView"
})(["", ""], function (props) {
  var width = props.width,
      height = props.height,
      maxWidth = props.maxWidth,
      maxHeight = props.maxHeight,
      scrollX = props.scrollX,
      _props$scrollY = props.scrollY,
      scrollY = _props$scrollY === void 0 ? true : _props$scrollY,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      theme = props.theme;
  var token = theme.components.ScrollView;
  return css(["", ";", ";", ";", ";", ";", ";", "{height:100%;", ";", ";", ";", ";", "}"], width && "width: ".concat(addPx(width)), height && "height: ".concat(addPx(height)), maxWidth && "max-width: ".concat(addPx(maxWidth)), maxHeight && "max-height: ".concat(addPx(maxHeight)), scrollX && "padding-bottom: ".concat(addPx(token.padding)), scrollY && "padding-right: ".concat(addPx(token.padding)), StyledScrollViewContent, maxWidth && "max-width: ".concat(addPx(maxWidth)), maxHeight && "max-height: ".concat(addPx(maxHeight)), scrollX && scrollXStyle(token.padding), scrollY && scrollYStyle(token.padding), scrollBarStyle({
    size: size,
    theme: theme
  }));
});
export default withThemeForStyled(ScrollView);