import styled, { css } from 'styled-components';
import addPx from '../utils/addPx';
export var scrollXStyle = function scrollXStyle(padding) {
  return css(["overflow-x:auto;padding-bottom:", ";"], addPx(padding));
};
export var scrollYStyle = function scrollYStyle(padding) {
  return css(["overflow-y:auto;padding-right:", ";"], addPx(padding));
};
export var scrollBarStyle = function scrollBarStyle(props) {
  var theme = props.theme,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      hidden = props.hidden,
      hideEndButton = props.hideEndButton;
  var token = theme.components.ScrollView.scrollBar;
  var finalSize = hidden ? 0 : token.size[size];
  return css(["&::-webkit-scrollbar{width:", "px;height:", "px;}&::-webkit-scrollbar-thumb{border-radius:", ";background-color:", ";&:hover{background-color:", ";}}&::-webkit-scrollbar-corner{background-color:transparent;}", ""], finalSize, finalSize, token.borderRadius, token.background, token.hoverBackground, hideEndButton && css(["&::-webkit-scrollbar-button:vertical:end:decrement{display:block;width:", "px;height:", "px;background-color:transparent;}"], finalSize, finalSize));
};
export var StyledScrollViewContent = styled.div.withConfig({
  displayName: "StyledScrollViewContent"
})([""]);