import _extends from "@babel/runtime/helpers/extends";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["loading", "active", "type", "children", "rows", "styles"];
import React from 'react';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import { StyledBlock, StyledCardContent, StyledCardDesc, StyledCardTitle, StyledCardWrapper, StyledNavigationHead, StyledNavigationNode, StyledNavigationSquare, StyledNavigationWrapper, StyledParagraph, StyledParagraphTitle, StyledParagraphWrapper, StyledTreeChild, StyledTreeContent, StyledTreeHead, StyledTreeSquare, StyledTreeWrapper } from './styled';
var defaultStyles = {
  cardContent: '',
  cardTitle: '',
  cardDesc: '',
  paragraphTitle: '',
  paragraph: '',
  treeHead: '',
  treeSquare: '',
  treeContent: '',
  treeChild: '',
  navigationHead: '',
  navigationSquare: '',
  navigationNode: ''
};
var Skeleton = /*#__PURE__*/React.memo(function Skeleton(props) {
  var theme = useTheme();

  var _props$loading = props.loading,
      loading = _props$loading === void 0 ? true : _props$loading,
      _props$active = props.active,
      active = _props$active === void 0 ? true : _props$active,
      _props$type = props.type,
      type = _props$type === void 0 ? 'block' : _props$type,
      children = props.children,
      _props$rows = props.rows,
      rows = _props$rows === void 0 ? 6 : _props$rows,
      styles = props.styles,
      other = _objectWithoutProperties(props, _excluded);

  var innerStyles = useStyles('skeleton', defaultStyles, styles);

  var rowArray = _toConsumableArray(Array(rows));

  if (!loading) {
    return /*#__PURE__*/React.createElement(React.Fragment, null, children);
  }

  if (type === 'card') {
    return /*#__PURE__*/React.createElement(StyledCardWrapper, other, /*#__PURE__*/React.createElement(StyledCardContent, _extends({}, innerStyles.cardContent, {
      active: active,
      theme: theme
    })), /*#__PURE__*/React.createElement(StyledCardTitle, _extends({}, innerStyles.cardTitle, {
      active: active,
      theme: theme
    })), /*#__PURE__*/React.createElement(StyledCardDesc, _extends({}, innerStyles.cardDesc, {
      active: active,
      theme: theme
    })));
  }

  if (type === 'paragraph') {
    return /*#__PURE__*/React.createElement(StyledParagraphWrapper, other, /*#__PURE__*/React.createElement(StyledParagraphTitle, _extends({}, innerStyles.paragraphTitle, {
      theme: theme,
      active: active
    })), rowArray.map(function (_v, index) {
      return /*#__PURE__*/React.createElement(StyledParagraph, _extends({}, innerStyles.paragraph, {
        key: index,
        theme: theme,
        active: active
      }));
    }));
  }

  if (type === 'tree') {
    return /*#__PURE__*/React.createElement(StyledTreeWrapper, _extends({
      theme: theme
    }, other), /*#__PURE__*/React.createElement(StyledTreeHead, _extends({}, innerStyles.treeHead, {
      theme: theme
    }), /*#__PURE__*/React.createElement(StyledTreeSquare, _extends({}, innerStyles.treeSquare, {
      theme: theme,
      active: active
    })), /*#__PURE__*/React.createElement(StyledTreeContent, _extends({}, innerStyles.treeContent, {
      theme: theme,
      active: active
    }))), rowArray.map(function (_v, index) {
      return /*#__PURE__*/React.createElement(StyledTreeChild, _extends({}, innerStyles.treeChild, {
        key: index,
        theme: theme
      }), /*#__PURE__*/React.createElement(StyledTreeSquare, _extends({}, innerStyles.treeSquare, {
        theme: theme,
        active: active
      })), /*#__PURE__*/React.createElement(StyledTreeContent, _extends({}, innerStyles.treeContent, {
        theme: theme,
        active: active
      })));
    }));
  }

  if (type === 'navigation') {
    return /*#__PURE__*/React.createElement(StyledNavigationWrapper, _extends({}, other, {
      theme: theme
    }), /*#__PURE__*/React.createElement(StyledNavigationHead, _extends({}, innerStyles.navigationHead, {
      theme: theme
    }), /*#__PURE__*/React.createElement(StyledNavigationSquare, _extends({}, innerStyles.navigationSquare, {
      theme: theme,
      active: active
    })), /*#__PURE__*/React.createElement(StyledNavigationNode, _extends({}, innerStyles.navigationNode, {
      theme: theme,
      active: active
    }))), rowArray.map(function (_v, index) {
      return /*#__PURE__*/React.createElement(StyledNavigationNode, _extends({}, innerStyles.navigationNode, {
        key: index,
        theme: theme,
        active: active
      }));
    }));
  }

  return /*#__PURE__*/React.createElement(StyledBlock, _extends({
    theme: theme,
    active: active
  }, other));
});
export default Skeleton;