import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["value", "defaultValue", "onChange", "onAfterChange", "min"];
import React from 'react';
import memoForwardRef from '../utils/memoForwardRef';
import BaseSlider from './BaseSlider';
export function useSlider(props) {
  var onChange = props.onChange,
      onAfterChange = props.onAfterChange;
  var handleChange = React.useCallback(function (val) {
    onChange && onChange(val[1]);
  }, [onChange]);
  var handleAfterChange = React.useCallback(function (val) {
    onAfterChange && onAfterChange(val[1]);
  }, [onAfterChange]);
  return {
    handleChange: handleChange,
    handleAfterChange: handleAfterChange
  };
}
var Slider = memoForwardRef(function (props, ref) {
  var value = props.value,
      defaultValue = props.defaultValue,
      onChange = props.onChange,
      onAfterChange = props.onAfterChange,
      _props$min = props.min,
      min = _props$min === void 0 ? 0 : _props$min,
      otherProps = _objectWithoutProperties(props, _excluded);

  var restProps = {};

  if ('value' in props) {
    restProps['value'] = [min, props.value || min];
  }

  if ('defaultValue' in props) {
    restProps['defaultValue'] = [min, props.defaultValue || min];
  }

  var _useSlider = useSlider(props),
      handleChange = _useSlider.handleChange,
      handleAfterChange = _useSlider.handleAfterChange;

  return /*#__PURE__*/React.createElement(BaseSlider, _extends({
    ref: ref,
    hideStart: true,
    onChange: handleChange,
    onAfterChange: handleAfterChange,
    min: min
  }, otherProps, restProps));
});
export var RangeSlider = memoForwardRef(function (props, ref) {
  return /*#__PURE__*/React.createElement(BaseSlider, _extends({}, props, {
    ref: ref
  }));
});
export default Slider;