import { colorUtils as _colorUtils } from "@muya-ui/theme-light/es/utils";
import _extends from "@babel/runtime/helpers/extends";
import { setRef as _setRef } from "@muya-ui/utils/es/hooks/useForkRef";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["fullscreen", "spinning", "container", "dialogProps", "size", "desc", "cancelText", "onCancel", "direction", "children", "color", "fontSize", "styles"];
import React, { cloneElement, useEffect, useState } from 'react';
import InlineButton from '../InlineButton';
import Dialog from '../Dialog';
import { getPortalContainer } from '../Portal/utils';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import SpinIcon from './SpinIcon';
import { StyledDescWrapper, StyledIconWrapper, StyledSpinContent } from './styled';
export default memoForwardRef(function (props, ref) {
  var fullscreen = props.fullscreen,
      _props$spinning = props.spinning,
      spinning = _props$spinning === void 0 ? true : _props$spinning,
      container = props.container,
      _props$dialogProps = props.dialogProps,
      dialogProps = _props$dialogProps === void 0 ? {} : _props$dialogProps,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      desc = props.desc,
      cancelText = props.cancelText,
      onCancel = props.onCancel,
      _props$direction = props.direction,
      direction = _props$direction === void 0 ? 'column' : _props$direction,
      children = props.children,
      color = props.color,
      fontSize = props.fontSize,
      styles = props.styles,
      other = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  var innerStyles = useStyles('spin', {
    desc: '',
    button: ''
  }, styles);
  var colors = theme.colors,
      token = theme.components.Spin;
  var mainColor = color || colors.spec.brand;

  var _useState = useState(null),
      _useState2 = _slicedToArray(_useState, 2),
      innerContainer = _useState2[0],
      setInnerContainer = _useState2[1];

  var handleRef = function handleRef(node) {
    _setRef(children.ref, node);

    setInnerContainer(node);
  };

  var content = /*#__PURE__*/React.createElement(React.Fragment, null, desc && /*#__PURE__*/React.createElement(StyledDescWrapper, _extends({}, innerStyles.desc, {
    size: size,
    theme: theme,
    cancelText: cancelText
  }), desc), cancelText && /*#__PURE__*/React.createElement(InlineButton, _extends({}, innerStyles.button, {
    size: size,
    type: "primary",
    onClick: onCancel
  }), cancelText));
  var Icon = /*#__PURE__*/React.createElement(StyledSpinContent, {
    theme: theme,
    direction: direction
  }, /*#__PURE__*/React.createElement(StyledIconWrapper, {
    size: !desc && !cancelText ? undefined : size,
    theme: theme
  }, /*#__PURE__*/React.createElement(SpinIcon, _extends({
    ref: ref,
    fontSize: fontSize,
    color: mainColor
  }, other))), direction === 'column' ? /*#__PURE__*/React.createElement("span", null, content) : content); // 传入container or children，开启区域加载功能

  var isBlockLoading = !!children || !!container; // fullscreen为true，开启全屏加载功能

  var isFullscreenLoading = fullscreen;
  useEffect(function () {
    var finalContainer = container ? getPortalContainer(container) : innerContainer; // 全屏模式不会使用finalContainer，因此无需设置样式

    if (!isFullscreenLoading && finalContainer) {
      var _window$getComputedSt = window.getComputedStyle(finalContainer),
          position = _window$getComputedSt.position; // position未设置 或者 position为static，组件为其设置默认的position，使区域加载生效


      if (!position || position === 'static') {
        finalContainer.style.position = 'relative';
      }
    }
  }, [container, innerContainer, isFullscreenLoading]); // 区域加载 / 全屏加载，使用Dialog.Base

  if (isFullscreenLoading || isBlockLoading) {
    return /*#__PURE__*/React.createElement(React.Fragment, null, children && /*#__PURE__*/cloneElement(children, {
      ref: handleRef
    }), /*#__PURE__*/React.createElement(Dialog.Base, _extends({
      open: spinning,
      container: isFullscreenLoading ? undefined : container || innerContainer,
      disableEscapeKeyDown: true,
      disableMaskClick: true,
      disableSize: true
    }, dialogProps, {
      style: _extends({
        background: _colorUtils.transparentize(token.maskOpacity, colors.pattern.background.higher)
      }, dialogProps.style),
      dialogContainerProps: _extends({
        style: {
          background: 'transparent',
          boxShadow: 'none',
          top: '50%'
        }
      }, dialogProps.dialogContainerProps)
    }), Icon));
  }

  if (!spinning) {
    return null;
  }

  return Icon;
});