import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import { SvgIcon as _SvgIcon } from "@muya-ui/icon-base/es/SvgIcon";
var _excluded = ["color"];
import React from 'react';
import styled, { keyframes } from 'styled-components';
import memoForwardRef from '../utils/memoForwardRef';
var rotate = keyframes(["0%{transform:rotate(0deg);}100%{transform:rotate(360deg);}"]);
var circleAnimate = keyframes(["0%{stroke-dasharray:28.274333882308138 254.46900494077323;}50%{stroke-dasharray:212.05750411731103 212.05750411731103;}100%{stroke-dasharray:28.274333882308138 254.46900494077323;}"]);
var StyledSpinIcon = styled(_SvgIcon).withConfig({
  displayName: "StyledSpinIcon"
})(["animation:", " 0.75s linear infinite,", " 1.5s linear infinite;"], rotate, circleAnimate);
export default memoForwardRef(function (_ref, ref) {
  var _ref$color = _ref.color,
      color = _ref$color === void 0 ? 'currentColor' : _ref$color,
      other = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/React.createElement(StyledSpinIcon, _extends({
    viewBox: "0 0 100 100",
    preserveAspectRatio: "xMidYMid",
    ref: ref
  }, other), /*#__PURE__*/React.createElement("circle", {
    cx: "50",
    cy: "50",
    r: "45",
    stroke: color,
    strokeWidth: "10",
    fill: "none",
    strokeLinecap: "round",
    transform: "rotate(144 50 50)"
  }));
});