import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["theme", "children"];
import React from 'react';
import memoForwardRef from '../utils/memoForwardRef';
import { Swipe, useSwipe } from '../Swipe';
import { StyledScrollStepsWarpper, StyledScrollStepsBtn } from './styled';
var ScrollContainer = memoForwardRef(function (props, ref) {
  var theme = props.theme,
      children = props.children,
      otherProps = _objectWithoutProperties(props, _excluded);

  var _useSwipe = useSwipe(),
      stepIndex = _useSwipe.stepIndex,
      hasNext = _useSwipe.hasNext,
      hasPrev = _useSwipe.hasPrev,
      onNext = _useSwipe.onNext,
      onPrev = _useSwipe.onPrev,
      onStepsChange = _useSwipe.onStepsChange,
      transitionStatus = _useSwipe.transitionStatus;

  return /*#__PURE__*/React.createElement(StyledScrollStepsWarpper, _extends({
    theme: theme,
    ref: ref
  }, otherProps), /*#__PURE__*/React.createElement(StyledScrollStepsBtn, {
    arrow: "left",
    onClick: onPrev,
    disabled: !hasPrev
  }), /*#__PURE__*/React.createElement(Swipe, {
    stepIndex: stepIndex,
    itemIndex: -1,
    onStepsChange: onStepsChange,
    transitionStatus: transitionStatus
  }, props.children), /*#__PURE__*/React.createElement(StyledScrollStepsBtn, {
    arrow: "right",
    onClick: onNext,
    disabled: !hasNext
  }));
});
export default ScrollContainer;