import _extends from "@babel/runtime/helpers/extends";
import { CloseIcon as _CloseIcon } from "@muya-ui/theme-light/es/icons/CloseIcon";
import { SelectIcon as _SelectIcon } from "@muya-ui/theme-light/es/icons/SelectIcon";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["onStepClick", "stepNumber", "status", "title", "description", "styles", "size", "icon"];
import React, { useMemo } from 'react';
import EllipsisContent from '../EllipsisContent';
import Typography from '../Typography';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import { StyledCircle, StyledDescriptionWrapper, StyledHorizontalProgressLine, StyledStepContent, StyledStepWrapper, StyledCircleContainer, StyledHorizontalProgressLineContainer, StyledTitleContainer, StyledVerticalProgressLineContainer, StyledVerticalProgressLine } from './styled';
var defaultStyles = {
  content: '',
  circle: '',
  title: '',
  progressLine: '',
  descriptionWrapper: '',
  text: ''
};
var ellipsisCfg = {
  rows: 2
};
export default memoForwardRef(function (props, ref) {
  var onStepClick = props.onStepClick,
      _props$stepNumber = props.stepNumber,
      stepNumber = _props$stepNumber === void 0 ? 0 : _props$stepNumber,
      status = props.status,
      title = props.title,
      description = props.description,
      styles = props.styles,
      size = props.size,
      icon = props.icon,
      other = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  var _theme$components$Ste = theme.components.Steps,
      _theme$components$Ste2 = _theme$components$Ste.finishIcon,
      FinishIcon = _theme$components$Ste2 === void 0 ? _SelectIcon : _theme$components$Ste2,
      _theme$components$Ste3 = _theme$components$Ste.errorIcon,
      ErrorIcon = _theme$components$Ste3 === void 0 ? _CloseIcon : _theme$components$Ste3;
  var innerStyles = useStyles('step', defaultStyles, styles);
  var innerIcon;

  if (status === 'finish') {
    innerIcon = /*#__PURE__*/React.createElement(FinishIcon, null);
  } else if (status === 'error') {
    innerIcon = /*#__PURE__*/React.createElement(ErrorIcon, null);
  } else {
    innerIcon = stepNumber + 1;
  }

  if (icon) {
    innerIcon = icon;
  }

  var handleClick = useMemo(function () {
    return onStepClick ? function () {
      onStepClick(stepNumber);
    } : undefined;
  }, [onStepClick, stepNumber]);
  return /*#__PURE__*/React.createElement(StyledStepWrapper, _extends({
    ref: ref,
    theme: theme
  }, other), /*#__PURE__*/React.createElement(StyledVerticalProgressLineContainer, {
    theme: theme,
    size: size
  }, /*#__PURE__*/React.createElement(StyledVerticalProgressLine, _extends({}, innerStyles.progressLine, {
    theme: theme,
    status: status,
    size: size
  }))), /*#__PURE__*/React.createElement(StyledStepContent, _extends({}, innerStyles.content, {
    onClick: handleClick,
    theme: theme,
    status: status,
    size: size
  }), /*#__PURE__*/React.createElement(StyledCircleContainer, null, /*#__PURE__*/React.createElement(StyledCircle, _extends({}, innerStyles.circle, {
    theme: theme,
    size: size,
    $bordered: !icon
  }), innerIcon)), /*#__PURE__*/React.createElement(StyledTitleContainer, innerStyles.title, /*#__PURE__*/React.createElement(EllipsisContent, {
    ellipsis: ellipsisCfg,
    enableTitle: true
  }, title)), /*#__PURE__*/React.createElement(StyledHorizontalProgressLineContainer, null, /*#__PURE__*/React.createElement(StyledHorizontalProgressLine, _extends({}, innerStyles.progressLine, {
    theme: theme,
    status: status
  })))), /*#__PURE__*/React.createElement(StyledDescriptionWrapper, _extends({}, innerStyles.descriptionWrapper, {
    theme: theme,
    size: size
  }), /*#__PURE__*/React.createElement(Typography.Text, _extends({
    type: status === 'error' ? 'error' : undefined
  }, innerStyles.text, {
    color: "assistant"
  }), description)));
});