import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["onChange", "current", "children", "status", "size", "swipe", "direction"];
import React, { Children, cloneElement, useCallback } from 'react';
import memoForwardRef from '../utils/memoForwardRef';
import useTheme from '../utils/useTheme';
import Step from './Step';
import { StyledStepsWrapper } from './styled';
import ScrollContainer from './ScrollContainer';
var Steps = memoForwardRef(function (props, ref) {
  var onChange = props.onChange,
      _props$current = props.current,
      current = _props$current === void 0 ? 0 : _props$current,
      children = props.children,
      currentStatus = props.status,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      _props$swipe = props.swipe,
      swipe = _props$swipe === void 0 ? false : _props$swipe,
      _props$direction = props.direction,
      direction = _props$direction === void 0 ? 'horizontal' : _props$direction,
      other = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  var Container = direction === 'horizontal' && swipe ? ScrollContainer : StyledStepsWrapper;
  var onStepClick = useCallback(function (next) {
    if (onChange && current !== next) {
      onChange(next);
    }
  }, [current, onChange]);
  return /*#__PURE__*/React.createElement(Container, _extends({
    direction: direction,
    size: size,
    theme: theme,
    ref: ref
  }, other), Children.map(children, function (child, index) {
    // 默认等待中
    var status = 'wait';

    if (index === current) {
      // 进行中
      status = currentStatus || 'process';
    }

    if (index < current) {
      // 已完成
      status = 'finish';
    }

    var childProps = _extends({
      status: status,
      stepNumber: index
    }, child.props, {
      size: size,
      onStepClick: onChange && onStepClick
    });

    return /*#__PURE__*/cloneElement(child, childProps);
  }));
});
Steps.Step = Step;
export default Steps;