import styled, { css } from 'styled-components';
import PagerButton from '../Carousel/PagerButton';
export var StyledCircleContainer = styled.div.withConfig({
  displayName: "StyledCircleContainer"
})([""]);
export var StyledTitleContainer = styled.div.withConfig({
  displayName: "StyledTitleContainer"
})([""]);
export var StyledHorizontalProgressLineContainer = styled.div.withConfig({
  displayName: "StyledHorizontalProgressLineContainer"
})([""]);
export var StyledVerticalProgressLineContainer = styled.div.withConfig({
  displayName: "StyledVerticalProgressLineContainer"
})(["width:1px;height:100%;transform:translateX(-50%);position:absolute;box-sizing:border-box;", ";"], function (props) {
  var theme = props.theme,
      size = props.size;
  var token = theme.components.Steps.progressLine.vertical;
  return css(["left:", "px;padding:", "px 0 0 0;"], token.left[size], token.top[size]);
});

function makeStepContentStyle(props) {
  var status = props.status,
      onClick = props.onClick,
      theme = props.theme,
      size = props.size;
  var _theme$components$Ste = theme.components.Steps.content,
      color = _theme$components$Ste.color,
      background = _theme$components$Ste.background,
      fontSize = _theme$components$Ste.fontSize,
      lineHeight = _theme$components$Ste.lineHeight,
      fontWeight = _theme$components$Ste.fontWeight;
  var _theme$components$Ste2 = theme.components.Steps.circle,
      tokenSize = _theme$components$Ste2.size,
      marginRight = _theme$components$Ste2.marginRight;
  var titleToken = theme.components.Steps.title;
  var lineToken = theme.components.Steps.progressLine;
  var titleColor = titleToken.color[status];
  var finalColor = color[status];
  var finalBgColor = background[status];
  var hasBg = finalBgColor !== 'transparent' && finalBgColor !== theme.colors.spec.light;
  var colorStyle = status !== 'wait' && css(["color:", ";& ", "{border-color:", ";background:", ";}& ", "{color:", ";}"], finalColor, StyledCircle, hasBg ? finalBgColor : finalColor, finalBgColor, StyledTitleContainer, titleColor);
  /**
   * 可点击状态
   * 1. 传入了onChange事件
   * 2. 当前不处于process状态
   * 3. 当前不处于error状态
   */

  var canClick = onClick && status !== 'process' && status !== 'error';
  var canClickStyle = canClick && css(["&:hover{color:", ";", "{border-color:", ";background:", ";}", "{color:", ";}}&:active{color:", ";", "{border-color:", ";background:", ";}", "{color:", ";}}cursor:pointer;"], color.hover, StyledCircle, hasBg ? background.hover : color.hover, background.hover, StyledTitleContainer, titleToken.color.hover, color.clicked, StyledCircle, hasBg ? background.clicked : color.clicked, background.clicked, StyledTitleContainer, titleToken.color.clicked); // 为解决 title 字数过多导致样式变形添加的样式

  /* stylelint-disable selector-type-case, selector-type-no-unknown */

  var balanceStyle = css(["", ",", ",", "{min-height:", "px;display:flex;align-items:center;}", "{flex:1;}", "{max-width:calc( 100% - ", "px - ", "px - ", "px );}"], StyledCircleContainer, StyledTitleContainer, StyledHorizontalProgressLineContainer, tokenSize[size], StyledHorizontalProgressLineContainer, StyledTitleContainer, tokenSize[size], lineToken.minWidth, marginRight[size]);
  /* stylelint-enable */

  return css(["display:flex;align-items:flex-start;position:relative;color:", ";font-size:", "px;line-height:", "px;font-weight:", ";cursor:default;", "{padding-right:", "px;}", " ", " ", " & > *{", "}"], color.wait, fontSize[size], lineHeight[size], fontWeight, StyledTitleContainer, titleToken.marginRight[size], colorStyle, canClickStyle, balanceStyle, function (props) {
    var transition = props.theme.transition;
    return css(["transition:all ", " ", "ms;"], transition.pattern.easing.status, transition.pattern.duration.status);
  });
}

export var StyledHorizontalProgressLine = styled.div.withConfig({
  displayName: "StyledHorizontalProgressLine"
})(["flex:1;height:1px;transform:translateY(-50%);background-color:", ";"], function (props) {
  var status = props.status,
      theme = props.theme;
  var token = theme.components.Steps.progressLine;
  return status === 'finish' ? token.finishBgColor : token.bgColor;
});
export var StyledVerticalProgressLine = styled.div.withConfig({
  displayName: "StyledVerticalProgressLine"
})(["width:100%;height:100%;background-color:", ";"], function (props) {
  var status = props.status,
      theme = props.theme;
  var token = theme.components.Steps.progressLine;
  return status === 'finish' ? token.finishBgColor : token.bgColor;
});
export var StyledStepWrapper = styled.div.withConfig({
  displayName: "StyledStepWrapper"
})(["overflow:hidden;flex:1;margin-right:", "px;&:last-child{flex:none;", "{max-width:none;}", "{display:none;}", "{display:none;}}"], function (props) {
  return props.theme.spacing.spec.s4;
}, StyledTitleContainer, StyledHorizontalProgressLineContainer, StyledVerticalProgressLineContainer);
export var StyledCircle = styled.span.withConfig({
  displayName: "StyledCircle"
})(["display:flex;justify-content:center;align-items:center;box-sizing:border-box;border-radius:50%;user-select:none;", ""], function (props) {
  var theme = props.theme,
      size = props.size,
      _props$$bordered = props.$bordered,
      $bordered = _props$$bordered === void 0 ? true : _props$$bordered;
  var borderStyle = $bordered && css(["border:1px solid ", ";"], theme.colors.pattern.background.divider);
  var token = theme.components.Steps.circle;
  return css(["margin-right:", "px;width:", "px;height:", "px;", ""], token.marginRight[size], token.size[size], token.size[size], borderStyle);
});
export var StyledStepContent = styled.div.withConfig({
  displayName: "StyledStepContent"
})(["", ""], makeStepContentStyle);
export var StyledDescriptionWrapper = styled.div.withConfig({
  displayName: "StyledDescriptionWrapper"
})(["", ""], function (props) {
  var token = props.theme.components.Steps.description;
  var size = props.size;
  return css(["margin-left:", "px;padding-left:", "px;margin-top:", "px;overflow:hidden;word-break:break-all;"], token.marginLeft[size], token.paddingLeft[size], token.marginTop[size]);
});
export var StyledStepsWrapper = styled.div.withConfig({
  displayName: "StyledStepsWrapper"
})(["display:flex;width:100%;margin:0;padding:0;font-size:0;", ""], function (_ref) {
  var direction = _ref.direction,
      theme = _ref.theme;
  var token = theme.components.Steps;

  if (direction === 'vertical') {
    return css(["flex-direction:column;", "{display:block;position:relative;padding-bottom:", "px;margin-bottom:", "px;}", "{display:none;}"], StyledStepWrapper, token.content.verticalPaddingBottom, token.content.verticalMarginBottom, StyledHorizontalProgressLineContainer);
  } else {
    return css(["", "{display:none;}", "{max-width:", "px;}"], StyledVerticalProgressLineContainer, StyledDescriptionWrapper, token.description.maxWidth);
  }
});
export var StyledScrollStepsWarpper = styled.div.withConfig({
  displayName: "StyledScrollStepsWarpper"
})(["display:flex;", "{width:", ";display:block;flex:none;}", "{display:none;}"], StyledStepWrapper, function (_ref2) {
  var size = _ref2.size,
      theme = _ref2.theme;
  return theme.components.Steps.content.width[size];
}, StyledVerticalProgressLineContainer);
export var StyledScrollStepsBtn = styled(PagerButton).withConfig({
  displayName: "StyledScrollStepsBtn"
})(["", ""], function (_ref3) {
  var theme = _ref3.theme,
      disabled = _ref3.disabled,
      arrow = _ref3.arrow;
  var token = theme.components.Steps;
  var btnToken = token.btn;
  var disabledStyle;
  var positionStyle;

  if (arrow === 'left') {
    positionStyle = css(["left:0;margin-right:", "px;"], token.content.btnSpacing);
  } else {
    positionStyle = css(["right:0;margin-left:", "px;"], token.content.btnSpacing);
  }

  if (disabled) {
    disabledStyle = css(["opacity:theme.opacity.pattern.disabled;"]);
  } else {
    disabledStyle = css(["&:hover{border:1px solid ", ";box-shadow:", ";}"], btnToken.borderColor.hover, btnToken.boxShadow.hover);
  }

  return css(["width:", ";height:", ";z-index:2;background:", ";border:1px solid ", ";box-shadow:", ";border-radius:", ";color:", ";transition:all ", " ", "ms;", ";", ";"], btnToken.width, btnToken.height, btnToken.background, btnToken.borderColor.normal, btnToken.boxShadow.normal, btnToken.radius, btnToken.color, theme.transition.pattern.easing.status, theme.transition.pattern.duration.status, disabledStyle, positionStyle);
});