import _extends from "@babel/runtime/helpers/extends";
import { useForkRef as _useForkRef } from "@muya-ui/utils/es/hooks/useForkRef";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "styles", "target", "onStatusChange"];
import React, { useRef } from 'react';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import { StyledContainer, StyledSticky } from './styled';
import useSticky from './useSticky';
var defaultStyles = {
  sticky: ''
};
export default memoForwardRef(function (props, ref) {
  var children = props.children,
      styles = props.styles,
      target = props.target,
      onStatusChange = props.onStatusChange,
      others = _objectWithoutProperties(props, _excluded);

  var innerStyles = useStyles('sticky', defaultStyles, styles);
  var divEl = useRef(null);

  var handleRef = _useForkRef(ref, divEl);

  var _useSticky = useSticky(props, divEl),
      style = _useSticky.style,
      fixed = _useSticky.fixed;

  var height = divEl.current && divEl.current.offsetHeight || 0;
  var innerStyle = fixed ? style : {};
  return /*#__PURE__*/React.createElement(StyledContainer, _extends({
    $height: fixed ? height : null,
    ref: handleRef
  }, others), /*#__PURE__*/React.createElement(StyledSticky, _extends({
    $fixed: fixed
  }, innerStyles.sticky, {
    style: _extends({}, innerStyles.sticky.style, innerStyle)
  }), children));
});