import { isScrollable } from '../utils/scrollIntoView';

function isWindow(val) {
  return val === window;
}

export function getScroller(el) {
  var root = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : window;
  var node = el;

  while (node && node.tagName !== 'HTML' && node.nodeType === 1 && node !== root) {
    if (isScrollable(node)) {
      if (node.tagName !== 'BODY') {
        return node;
      }

      if (isScrollable(node.parentNode)) {
        return node;
      }
    }

    node = node.parentNode;
  }

  return root;
}
export function isHidden(el) {
  var style = window.getComputedStyle(el);
  var hidden = style.display === 'none';
  var parentHidden = el.offsetParent === null && style.position !== 'fixed';
  return hidden || parentHidden;
}
export function getScrollTop(el) {
  return 'scrollTop' in el ? el.scrollTop : el.pageYOffset;
}
export function getRootScrollTop() {
  return window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop || 0;
}
export function getElementTop(el, scroller) {
  if (isWindow(el)) {
    return 0;
  }

  var scrollTop = scroller ? getScrollTop(scroller) : getRootScrollTop();
  return el.getBoundingClientRect().top + scrollTop;
}