import _extends from "@babel/runtime/helpers/extends";
import { useForkRef as _useForkRef } from "@muya-ui/utils/es/hooks/useForkRef";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["direction", "stepIndex", "itemIndex", "equalNum", "gutter", "duration", "onStepsChange", "children", "styles", "defaultIndex", "enableDiffChildren", "onTransitionEnd", "transitionStatus"];
import React, { useMemo, useRef } from 'react';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import SwipeContainer from './SwipeContainer';
import SwipePanel from './SwipePanel';
import useInnerLoopSwipe from './useInnerLoopSwipe';
import useLoopSwipe from './useLoopSwipe';
var defaultStyles = {
  panel: ''
};
var Swipe = memoForwardRef(function (props, ref) {
  var _props$direction = props.direction,
      direction = _props$direction === void 0 ? 'horizontal' : _props$direction,
      stepIndex = props.stepIndex,
      itemIndex = props.itemIndex,
      equalNum = props.equalNum,
      gutter = props.gutter,
      duration = props.duration,
      onStepsChange = props.onStepsChange,
      children = props.children,
      styles = props.styles,
      defaultIndex = props.defaultIndex,
      enableDiffChildren = props.enableDiffChildren,
      onTransitionEnd = props.onTransitionEnd,
      propsTransitionStatus = props.transitionStatus,
      otherProps = _objectWithoutProperties(props, _excluded);

  var innerStyles = useStyles('swipe', defaultStyles, styles);
  var containerRef = useRef(null);

  var handleRef = _useForkRef(containerRef, ref);

  var _useInnerLoopSwipe = useInnerLoopSwipe(props, containerRef),
      resultChildren = _useInnerLoopSwipe.nodes,
      panelStyle = _useInnerLoopSwipe.panelStyle,
      transitionStatus = _useInnerLoopSwipe.transitionStatus,
      finalDuration = _useInnerLoopSwipe.finalDuration;

  var innerPanelStyle = useMemo(function () {
    if (innerStyles.panel.style) {
      return _extends({}, innerStyles.panel.style, panelStyle);
    }

    return panelStyle;
  }, [innerStyles.panel.style, panelStyle]);
  return /*#__PURE__*/React.createElement(SwipeContainer, _extends({
    $direction: direction
  }, otherProps, {
    ref: handleRef
  }), /*#__PURE__*/React.createElement(SwipePanel, {
    className: innerStyles.panel.className,
    $duration: finalDuration,
    $transition: propsTransitionStatus || transitionStatus,
    style: innerPanelStyle,
    $direction: direction,
    onTransitionEnd: onTransitionEnd
  }, resultChildren));
});
Swipe.useLoopSwipe = useLoopSwipe;
export default Swipe;