import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["onTransitionEnd"];
import React, { useContext, useMemo } from 'react';
import styled, { css } from 'styled-components';
import ImgPoolContext from '../Img/ImgPoolContext';
import forkHandler from '../utils/forkHandler';
import memoForwardRef from '../utils/memoForwardRef';
import useTheme from '../utils/useTheme';
var BaseNode = styled.div.withConfig({
  displayName: "BaseNode"
})(["position:relative;", ""], function (props) {
  var theme = props.theme,
      $direction = props.$direction,
      _props$$transition = props.$transition,
      $transition = _props$$transition === void 0 ? 'on' : _props$$transition,
      propDuration = props.$duration;
  var easing = theme.transition.spec.easing;
  var panelCss;

  if ($direction === 'horizontal') {
    panelCss = css(["display:flex;width:100000px;height:100%;"]);
  }

  var transitionCss;

  if ($transition === 'on') {
    transitionCss = css(["transition:transform ", "ms ", ";"], propDuration, easing.easeInOut);
  }

  return css(["", " ", ""], transitionCss, panelCss);
});
export default memoForwardRef(function (props, ref) {
  var onTransitionEnd = props.onTransitionEnd,
      otherProps = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  var pool = useContext(ImgPoolContext);
  var handleTransitionEnd = useMemo(function () {
    return forkHandler(function () {
      pool.throttleCheck({
        type: 'scroll'
      });
    }, onTransitionEnd);
  }, [onTransitionEnd, pool]);
  return /*#__PURE__*/React.createElement(BaseNode, _extends({
    theme: theme
  }, otherProps, {
    onTransitionEnd: handleTransitionEnd,
    ref: ref
  }));
});