import _extends from "@babel/runtime/helpers/extends";
import { useEffectOnce as _useEffectOnce } from "@muya-ui/utils/es/hooks/useEffectOnce";
import { useForkRef as _useForkRef } from "@muya-ui/utils/es/hooks/useForkRef";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["autoFocus", "disabled", "checked", "defaultChecked", "checkedChildren", "unCheckedChildren", "loading", "loadingIcon", "onChange", "styles", "size", "tabIndex"];
import React, { useMemo, useRef } from 'react';
import Spin from '../Spin';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import memoForwardRef from '../utils/memoForwardRef';
import { StyledLoadingIconWrapper, StyledSwitch, StyledSwitchChildrenWrapper } from './styled';
import useSwitch from './useSwitch';
var defaultStyles = {
  loadingWrapper: '',
  childrenWrapper: ''
};
var Switch = memoForwardRef(function (props, ref) {
  var autoFocus = props.autoFocus,
      disabled = props.disabled,
      checked = props.checked,
      _props$defaultChecked = props.defaultChecked,
      defaultChecked = _props$defaultChecked === void 0 ? false : _props$defaultChecked,
      checkedChildren = props.checkedChildren,
      unCheckedChildren = props.unCheckedChildren,
      _props$loading = props.loading,
      loading = _props$loading === void 0 ? false : _props$loading,
      loadingIcon = props.loadingIcon,
      onChange = props.onChange,
      styles = props.styles,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      _props$tabIndex = props.tabIndex,
      tabIndex = _props$tabIndex === void 0 ? 0 : _props$tabIndex,
      restProps = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  var token = theme.components.Switch;
  var innerStyles = useStyles('switch', defaultStyles, styles);
  var nodeRef = useRef(null);

  var handleRef = _useForkRef(ref, nodeRef);

  var _useSwitch = useSwitch(props, nodeRef),
      checkedState = _useSwitch.checkedState,
      setCheckedState = _useSwitch.setCheckedState,
      onKeyDown = _useSwitch.onKeyDown,
      onClick = _useSwitch.onClick,
      onMouseUp = _useSwitch.onMouseUp,
      focus = _useSwitch.focus;

  _useEffectOnce(function () {
    if (autoFocus && !disabled) {
      focus();
    }
  });

  if ('checked' in props && checkedState !== checked) {
    setCheckedState(checked);
  }

  var loadingNode = useMemo(function () {
    return loadingIcon || /*#__PURE__*/React.createElement(Spin, {
      color: checkedState ? token.background.checked : token.background.unChecked
    });
  }, [checkedState, loadingIcon, token.background.checked, token.background.unChecked]);
  return /*#__PURE__*/React.createElement(StyledSwitch, _extends({}, restProps, {
    ref: handleRef,
    role: "switch",
    theme: theme,
    size: size,
    checked: checkedState,
    disabled: disabled || loading,
    "aria-checked": checked,
    onClick: onClick,
    onMouseUp: onMouseUp,
    onKeyDown: onKeyDown
  }), loading && /*#__PURE__*/React.createElement(StyledLoadingIconWrapper, innerStyles.loadingWrapper, loadingNode), /*#__PURE__*/React.createElement(StyledSwitchChildrenWrapper, innerStyles.childrenWrapper, checkedState ? checkedChildren : unCheckedChildren));
});
Switch.__MUYA_SWITCH = true;
export default Switch;