import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["type", "index", "size", "disabled", "busy", "onChange", "styles", "swipe", "tabBarExtraContent", "lineIndicatorMode", "children", "enableDiffChildren", "equalNum", "gutter", "duration", "enableBadge", "vertical"];
import React from 'react';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import { BaseNode, ExtraContentWrapper } from './styled';
import TabsContainer from './TabsContainer';
import useTabsBase from './useTabsBase';
import { defaultStyles } from './const';
var CapsuleTabs = memoForwardRef(function (props, ref) {
  var type = props.type,
      _props$index = props.index,
      index = _props$index === void 0 ? 0 : _props$index,
      size = props.size,
      disabled = props.disabled,
      busy = props.busy,
      onChange = props.onChange,
      styles = props.styles,
      swipe = props.swipe,
      tabBarExtraContent = props.tabBarExtraContent,
      lineIndicatorMode = props.lineIndicatorMode,
      children = props.children,
      enableDiffChildren = props.enableDiffChildren,
      equalNum = props.equalNum,
      gutter = props.gutter,
      duration = props.duration,
      enableBadge = props.enableBadge,
      vertical = props.vertical,
      otherProps = _objectWithoutProperties(props, _excluded);

  var innerStyles = useStyles('tabs', defaultStyles, styles);
  var swipeProps = {
    enableDiffChildren: enableDiffChildren,
    equalNum: equalNum,
    gutter: gutter,
    duration: duration
  };

  var _useTabsBase = useTabsBase(props),
      resultChildren = _useTabsBase.children;

  return /*#__PURE__*/React.createElement(BaseNode, _extends({}, otherProps, {
    ref: ref
  }), /*#__PURE__*/React.createElement(BaseNode, null, /*#__PURE__*/React.createElement(TabsContainer, _extends({}, innerStyles.container, swipeProps, {
    swipe: swipe,
    size: size,
    type: "capsule",
    enableBadge: enableBadge,
    vertical: vertical
  }), resultChildren), tabBarExtraContent && !vertical ? /*#__PURE__*/React.createElement(ExtraContentWrapper, innerStyles.extraContentWrapper, tabBarExtraContent) : null));
});
export default CapsuleTabs;