import styled, { css } from 'styled-components';
import { withThemeForStyled } from '../utils/withTheme';
var oppositionPosMap = {
  left: 'right',
  right: 'left',
  top: 'bottom',
  bottom: 'top'
};

function tabIndicatorCss(props) {
  var theme = props.theme,
      _props$$offset = props.$offset,
      $offset = _props$$offset === void 0 ? 0 : _props$$offset,
      _props$$size = props.$size,
      $size = _props$$size === void 0 ? 0 : _props$$size,
      _props$$transition = props.$transition,
      $transition = _props$$transition === void 0 ? 'off' : _props$$transition,
      _props$$hide = props.$hide,
      $hide = _props$$hide === void 0 ? false : _props$$hide,
      $vertical = props.$vertical,
      $tabPosition = props.$tabPosition;
  var token = theme.components.Tabs;
  var indicator = token.indicator;
  var _theme$transition$pat = theme.transition.pattern,
      duration = _theme$transition$pat.duration,
      easing = _theme$transition$pat.easing;
  var transitionCss;

  if ($transition === 'on') {
    transitionCss = css(["transition:all ", "ms ", ";"], duration.status, easing.status);
  }

  var indicatorCss;

  if (!$hide) {
    indicatorCss = css(["", ":0;", ":0;z-index:2;&::before{content:'';display:block;position:absolute;background:", ";", ":", "px;", ":", "px;", ":", "px;", ":0;", "}"], oppositionPosMap[$tabPosition], $vertical ? 'top' : 'left', indicator.activeColor, $vertical ? 'width' : 'height', indicator.activeHeight, $vertical ? 'height' : 'width', $size, $vertical ? 'top' : 'left', $offset, oppositionPosMap[$tabPosition], transitionCss);
  }

  return css(["width:", ";height:", ";background:", ";", ""], $vertical ? "".concat(indicator.bgHeight, "px") : '100%', $vertical ? '100%' : "".concat(indicator.bgHeight, "px"), indicator.bgColor, indicatorCss);
}

var LineIndicator = styled.div.withConfig({
  displayName: "LineIndicator"
})(["position:absolute;", ""], tabIndicatorCss);
export default withThemeForStyled(LineIndicator);