import _extends from "@babel/runtime/helpers/extends";
import { useForkRef as _useForkRef } from "@muya-ui/utils/es/hooks/useForkRef";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["type", "index", "size", "disabled", "busy", "onChange", "styles", "swipe", "children", "height", "tabBarExtraContent", "lineIndicatorMode", "enableDiffChildren", "equalNum", "gutter", "duration", "enableBadge", "vertical", "tabPosition"];
import React, { useRef } from 'react';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import LineIndicator from './LineIndicator';
import { BaseNode, ExtraContentWrapper } from './styled';
import TabsContainer from './TabsContainer';
import useLineTabs from './useLineTabs';
import { defaultStyles } from './const';
var LineTabs = memoForwardRef(function (props, ref) {
  var type = props.type,
      index = props.index,
      size = props.size,
      disabled = props.disabled,
      busy = props.busy,
      onChange = props.onChange,
      styles = props.styles,
      swipe = props.swipe,
      children = props.children,
      height = props.height,
      tabBarExtraContent = props.tabBarExtraContent,
      _props$lineIndicatorM = props.lineIndicatorMode,
      lineIndicatorMode = _props$lineIndicatorM === void 0 ? 'default' : _props$lineIndicatorM,
      enableDiffChildren = props.enableDiffChildren,
      equalNum = props.equalNum,
      gutter = props.gutter,
      duration = props.duration,
      enableBadge = props.enableBadge,
      vertical = props.vertical,
      tabPosition = props.tabPosition,
      otherProps = _objectWithoutProperties(props, _excluded);

  var innerStyles = useStyles('tabs', defaultStyles, styles);
  var containerRef = useRef(null);

  var handleRef = _useForkRef(containerRef, ref);

  var swipeProps = {
    enableDiffChildren: enableDiffChildren,
    equalNum: equalNum,
    gutter: gutter,
    duration: duration
  };

  var _useLineTabs = useLineTabs(props, containerRef),
      selectedIndex = _useLineTabs.selectedIndex,
      resultChildren = _useLineTabs.children,
      indicatorState = _useLineTabs.indicatorState,
      onContainerChange = _useLineTabs.onContainerChange,
      hideContainerIndicator = _useLineTabs.hideContainerIndicator;

  return /*#__PURE__*/React.createElement(BaseNode, _extends({}, otherProps, {
    ref: handleRef
  }), /*#__PURE__*/React.createElement(TabsContainer, _extends({}, innerStyles.container, swipeProps, {
    size: size,
    type: "line",
    swipe: swipe,
    height: height,
    selectedIndex: selectedIndex,
    onChange: onContainerChange,
    enableBadge: enableBadge,
    vertical: vertical
  }), resultChildren), tabBarExtraContent ? /*#__PURE__*/React.createElement(ExtraContentWrapper, innerStyles.extraContentWrapper, tabBarExtraContent) : null, /*#__PURE__*/React.createElement(LineIndicator, _extends({}, innerStyles.indicator, {
    $hide: hideContainerIndicator,
    $offset: indicatorState.offset,
    $size: indicatorState.size,
    $transition: indicatorState.transition,
    $vertical: vertical,
    $tabPosition: tabPosition
  })));
});
export default LineTabs;