/* stylelint-disable no-descending-specificity */
import styled, { css } from 'styled-components';
import ellipsisStyle from '../styled/mixins/ellipsis';
import { mergeProps } from './utils';
export var StyledTagText = styled.span.withConfig({
  displayName: "StyledTagText"
})([""]); // eslint-disable-next-line complexity

export var tagCss = function tagCss(originalProps) {
  var props = mergeProps(originalProps);
  var _props$theme = props.theme,
      colorsPattern = _props$theme.colors.pattern,
      transitionPattern = _props$theme.transition.pattern,
      token = _props$theme.components.Tag,
      opacityPattern = _props$theme.opacity.pattern;
  var _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      borderColor = props.borderColor,
      _props$bordered = props.bordered,
      bordered = _props$bordered === void 0 ? token.defaultBordered : _props$bordered,
      _props$closable = props.closable,
      closable = _props$closable === void 0 ? false : _props$closable,
      _props$shape = props.shape,
      shape = _props$shape === void 0 ? token.defaultShape : _props$shape,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      color = props.color,
      _props$colorInverse = props.colorInverse,
      colorInverse = _props$colorInverse === void 0 ? true : _props$colorInverse,
      maxWidth = props.maxWidth,
      _props$hoverable = props.hoverable,
      hoverable = _props$hoverable === void 0 ? true : _props$hoverable,
      type = props.type;
  var clickable = 'onClick' in props || 'onChange' in props;
  var fontSize = token.fontSize[size];
  var lineHeight = token.lineHeight[size];
  var inverseColor = color ? colorInverse : type !== 'normal';
  var colorSchema = type === 'mask' ? token.maskBg.base : token.typeColor[type];
  var borderStyle;
  var disabledStyle;
  var hoverStyle;
  var maskStyle;

  if (bordered) {
    borderStyle = css(["border:1px solid ", ";"], borderColor || colorsPattern.border.normal);
  }

  if (disabled) {
    disabledStyle = css(["cursor:default;opacity:", ";"], opacityPattern.disabled);
  } else if (hoverable) {
    hoverStyle = css(["&:hover{color:", ";background-color:", ";opacity:", ";}a:hover{color:", ";}"], inverseColor ? token.color.inverse : token.color.plain, color || colorSchema.hover, inverseColor ? token.inverseHoverOpacity : 1, token.color.hover);
  }

  if (type === 'mask') {
    var maskHoverStyle = css(["&:hover{color:", ";background-color:", ";}"], token.maskColor.base.hover, token.maskBg.base.hover);

    var _disabledStyle = css(["opacity:", ";"], opacityPattern.disabled);

    maskStyle = css(["color:", ";background-color:", ";", ";", ";"], token.maskColor.base.normal, token.maskBg.base.normal, !disabled && hoverable ? maskHoverStyle : '', disabled ? _disabledStyle : '');
  }

  return css(["box-sizing:border-box;display:inline-flex;align-items:center;max-width:", ";color:", ";background-color:", ";transition:all ", "ms ", ";padding:0 ", "px;margin-right:", "px;font-size:", "px;line-height:", "px;height:", "px;white-space:nowrap;border-radius:", ";cursor:", ";vertical-align:middle;", "{", ";}", ";", ";", ";", ";"], maxWidth ? "".concat(maxWidth, "px") : 'none', inverseColor ? token.color.inverse : token.color.plain, color || colorSchema.normal, transitionPattern.duration.status, transitionPattern.easing.status, token.paddingHorizontal[shape][size], token.marginRight, fontSize, lineHeight, token.height[size], shape === 'rect' && token.rectBorderRadius ? token.rectBorderRadius[size] : token.borderRadius[shape], clickable ? 'pointer' : 'default', StyledTagText, ellipsisStyle, borderStyle, !closable && hoverStyle, disabledStyle, maskStyle);
};

var closeIconCss = function closeIconCss(props) {
  var $size = props.$size,
      $color = props.$color,
      $colorInverse = props.$colorInverse,
      _props$theme2 = props.theme,
      colorsPattern = _props$theme2.colors.pattern,
      transitionPattern = _props$theme2.transition.pattern,
      token = _props$theme2.components.Tag;
  var inverseColor = !!$color && $colorInverse;
  var colorCss = css(["color:", ";&:hover{color:", ";}&:active{color:", ";}"], colorsPattern.icon.normal, colorsPattern.icon.hover, colorsPattern.icon.click);

  if (inverseColor) {
    colorCss = css(["color:", ";"], colorsPattern.icon.inverse);
  }

  return css(["margin-left:", "px;cursor:pointer;transition:all ", "ms ", ";flex-shrink:0;display:inline-flex;width:", "px;height:", "px;", ";svg{width:", "px;height:", "px;}"], token.iconSpacing[$size], transitionPattern.duration.status, transitionPattern.easing.status, token.iconSize[$size], token.iconSize[$size], colorCss, token.iconSize[$size], token.iconSize[$size]);
};

export var StyledCloseIcon = styled.span.withConfig({
  displayName: "StyledCloseIcon"
})(["", ";"], closeIconCss);