import _extends from "@babel/runtime/helpers/extends";

/**
 * Tag重构后新增props type，与之前的部分props不兼容，进行合并处理
 *
 * @export
 * @param {IAllTagProps} props
 * @return {IAllTagProps}
 */
export function mergeProps(props) {
  // 如果传入了 type 就无视 color、border props
  if (props.type) {
    return _extends({}, props, {
      color: undefined,
      bordered: undefined,
      borderColor: undefined
    });
  } else {
    return _extends({}, props, {
      type: 'normal'
    });
  }
}