import React, { useEffect } from 'react';
import { ThemeProvider } from 'styled-components';
import Dialog from '../Dialog';
import notification from '../Notification';
import toast from '../toast';
export default /*#__PURE__*/React.memo(function (props) {
  var theme = props.theme,
      children = props.children; // 更新主题

  useEffect(function () {
    toast.config({
      theme: theme
    });
    notification.config({
      theme: theme
    });
    Dialog.config({
      theme: theme
    });
  }, [theme]);
  return /*#__PURE__*/React.createElement(ThemeProvider, {
    theme: theme
  }, children);
});