import _extends from "@babel/runtime/helpers/extends";
import { ClockIcon as _ClockIcon } from "@muya-ui/theme-light/es/icons/ClockIcon";
import { useForkRef as _useForkRef } from "@muya-ui/utils/es/hooks/useForkRef";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["value", "defaultValue", "format", "onChange", "allowClear", "options", "styles", "defaultScrollBehavior", "hourStep", "minuteStep", "secondStep", "disabledHours", "disabledMinutes", "disabledSeconds", "hideDisabledOptions", "disableTimeAfter", "disableTimeBefore", "disabled", "onFocus", "onClear", "onPressEnter", "inputRef", "readOnly", "inputReadOnly", "popperProps", "flip", "arrowPointAtCenter", "placement", "triggerId"];
import React, { useMemo, useRef } from 'react';
import { StyledPopPanel } from '../styled/components/PopPanel';
import { StyledSuffixIcon } from '../styled/components/SuffixIcon';
import Trigger from '../Trigger';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import { StyledFooter, StyledInput } from './styled';
import TimePickerPanel from './TimePickerPanel';
import useTimePicker from './useTimePicker';
var triggerActions = ['click'];
var defaultStyles = {
  popPanel: '',
  footer: '',
  panel: ''
};
var TimePicker = memoForwardRef(function (props, ref) {
  var value = props.value,
      defaultValue = props.defaultValue,
      format = props.format,
      onChange = props.onChange,
      _props$allowClear = props.allowClear,
      allowClear = _props$allowClear === void 0 ? true : _props$allowClear,
      options = props.options,
      styles = props.styles,
      defaultScrollBehavior = props.defaultScrollBehavior,
      hourStep = props.hourStep,
      minuteStep = props.minuteStep,
      secondStep = props.secondStep,
      disabledHours = props.disabledHours,
      disabledMinutes = props.disabledMinutes,
      disabledSeconds = props.disabledSeconds,
      hideDisabledOptions = props.hideDisabledOptions,
      disableTimeAfter = props.disableTimeAfter,
      disableTimeBefore = props.disableTimeBefore,
      disabled = props.disabled,
      onFocus = props.onFocus,
      onClear = props.onClear,
      onPressEnter = props.onPressEnter,
      inputRef = props.inputRef,
      readOnly = props.readOnly,
      inputReadOnly = props.inputReadOnly,
      popperProps = props.popperProps,
      flip = props.flip,
      arrowPointAtCenter = props.arrowPointAtCenter,
      placement = props.placement,
      triggerId = props.triggerId,
      otherProps = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  var innerInputRef = useRef(null);

  var handleInputRef = _useForkRef(innerInputRef, inputRef);

  var InputIcon = theme.components.TimePicker.inputIcon || _ClockIcon;
  var innerSuffixNode = useMemo(function () {
    return /*#__PURE__*/React.createElement(StyledSuffixIcon, {
      theme: theme
    }, /*#__PURE__*/React.createElement(InputIcon, null));
  }, [theme]);

  var _useTimePicker = useTimePicker(props, innerInputRef),
      finalPopupOpen = _useTimePicker.finalPopupOpen,
      finalValue = _useTimePicker.finalValue,
      stateDate = _useTimePicker.stateDate,
      finalOptions = _useTimePicker.finalOptions,
      handleClear = _useTimePicker.handleClear,
      handleFocus = _useTimePicker.handleFocus,
      handleInputChange = _useTimePicker.handleInputChange,
      handleClickAway = _useTimePicker.handleClickAway,
      handlePressEnter = _useTimePicker.handlePressEnter,
      handlePanelChange = _useTimePicker.handlePanelChange;

  var inputProps = {
    allowClear: allowClear,
    disabled: disabled,
    theme: theme,
    ref: ref,
    clearReplace: true,
    focusWhenClear: false,
    readOnly: readOnly || inputReadOnly
  };
  var inputStyles = useMemo(function () {
    if (!styles) {
      return;
    }

    var inputWrapper = styles.inputWrapper,
        input = styles.input,
        nodeDivider = styles.nodeDivider,
        nodeWrapper = styles.nodeWrapper,
        clearWrapper = styles.clearWrapper,
        statusWrapper = styles.statusWrapper;
    return {
      inputWrapper: inputWrapper,
      input: input,
      nodeDivider: nodeDivider,
      nodeWrapper: nodeWrapper,
      clearWrapper: clearWrapper,
      statusWrapper: statusWrapper
    };
  }, [styles]);
  var realNode = /*#__PURE__*/React.createElement(StyledInput, _extends({
    inputRef: handleInputRef,
    value: finalValue,
    suffixNode: innerSuffixNode,
    onChange: handleInputChange,
    onFocus: handleFocus,
    onClear: handleClear,
    onPressEnter: handlePressEnter,
    styles: inputStyles
  }, inputProps, otherProps));
  var currentStyles = useMemo(function () {
    if (!styles) {
      return;
    }

    var popPanel = styles.popPanel,
        footer = styles.footer,
        panel = styles.panel;
    return {
      popPanel: popPanel,
      footer: footer,
      panel: panel
    };
  }, [styles]);
  var footerStyles = useMemo(function () {
    if (!styles) {
      return;
    }

    var footerOption = styles.footerOption;
    return {
      footerOption: footerOption
    };
  }, [styles]);
  var innerStyles = useStyles('time-picker', defaultStyles, currentStyles);

  if (disabled || readOnly) {
    return realNode;
  }

  var panelProps = {
    hourStep: hourStep,
    minuteStep: minuteStep,
    secondStep: secondStep,
    disabledHours: disabledHours,
    disabledMinutes: disabledMinutes,
    disabledSeconds: disabledSeconds,
    disableTimeAfter: disableTimeAfter,
    disableTimeBefore: disableTimeBefore,
    hideDisabledOptions: hideDisabledOptions,
    format: format,
    styles: styles,
    defaultScrollBehavior: defaultScrollBehavior
  };
  var panelNode = /*#__PURE__*/React.createElement(StyledPopPanel, _extends({
    theme: theme
  }, innerStyles.popPanel), /*#__PURE__*/React.createElement(TimePickerPanel, _extends({}, innerStyles.panel, {
    value: stateDate,
    onChange: handlePanelChange
  }, panelProps)), finalOptions && finalOptions.length && /*#__PURE__*/React.createElement(StyledFooter, _extends({}, innerStyles.footer, {
    options: finalOptions,
    styles: footerStyles
  })));
  var triggerProps = {
    placement: placement,
    triggerActions: triggerActions,
    popperProps: popperProps,
    arrowPointAtCenter: arrowPointAtCenter,
    triggerId: triggerId,
    flip: flip,
    hideArrow: true
  };
  return /*#__PURE__*/React.createElement(Trigger, _extends({
    popup: panelNode,
    open: finalPopupOpen,
    onClickAway: handleClickAway
  }, triggerProps), realNode);
});
TimePicker.__MUYA_TIMEPICKER = true;
export default TimePicker;