import dayjs from 'dayjs';
var dateFormat = 'YYYY-MM-DD';
var numReg = /\d/;
export function transformStr2Date(str, baseDate) {
  // 完全一个数字都没有，肯定不合法
  if (!numReg.test(str)) {
    return dayjs('');
  }

  var baseStr = '';

  if (baseDate.isValid()) {
    baseStr = baseDate.format(dateFormat);
  } else {
    baseStr = dayjs().format(dateFormat);
  }

  var newDate = dayjs("".concat(baseStr, " ").concat(str));
  return newDate;
}
export function transformConfigType2Time(str, baseDate) {
  var onlyTime = false;
  var date = dayjs(str);

  if (!date.isValid() && typeof str === 'string' && str.length > 0) {
    var innerBaseDate = baseDate || dayjs();
    date = transformStr2Date(str, innerBaseDate);
    onlyTime = date.isValid();
  }

  return [date, onlyTime];
}