import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["mode", "children", "styles", "className", "style"];
import React, { forwardRef, useMemo } from 'react';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import { StyledTimeline } from './styled';
import TimelineItem from './TimelineItem';
import TimelineContext from './TimelineContext';
import mergeStyleItem from '../utils/mergeStyleItem';
var defaultStyles = {
  wrapper: ''
};
var Timeline = /*#__PURE__*/forwardRef(function (props, ref) {
  var theme = useTheme();

  var _props$mode = props.mode,
      mode = _props$mode === void 0 ? 'left' : _props$mode,
      children = props.children,
      styles = props.styles,
      className = props.className,
      style = props.style,
      otherProps = _objectWithoutProperties(props, _excluded);

  var timelineStyles = useMemo(function () {
    if (styles) {
      var wrapper = styles.wrapper;
      return {
        wrapper: wrapper
      };
    }
  }, [styles]);
  var innerStyles = useStyles('timeline', defaultStyles, timelineStyles);
  var finalStyles = mergeStyleItem({
    className: className,
    style: style
  }, innerStyles.wrapper);
  return /*#__PURE__*/React.createElement(StyledTimeline, _extends({
    ref: ref,
    theme: theme,
    $mode: mode
  }, finalStyles, otherProps), /*#__PURE__*/React.createElement(TimelineContext.Provider, {
    value: {
      mode: mode
    }
  }, children));
});
Timeline.Item = TimelineItem;
export default Timeline;