import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["style", "className", "placement", "size", "title", "arrowStyle", "children"];
import React, { useMemo } from 'react';
import Trigger from '../Trigger';
import memoForwardRef from '../utils/memoForwardRef';
import useTheme from '../utils/useTheme';
import { StyledTooltipWrapper } from './styled';
export default memoForwardRef(function (props, ref) {
  var style = props.style,
      className = props.className,
      _props$placement = props.placement,
      placement = _props$placement === void 0 ? 'top' : _props$placement,
      _props$size = props.size,
      size = _props$size === void 0 ? 's' : _props$size,
      title = props.title,
      arrowStyle = props.arrowStyle,
      children = props.children,
      other = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  var _theme$components$Too = theme.components.Tooltip,
      arrowSize = _theme$components$Too.arrowSize,
      bgColor = _theme$components$Too.bgColor,
      fontWeight = _theme$components$Too.fontWeight;
  var popup = useMemo(function () {
    return /*#__PURE__*/React.createElement(StyledTooltipWrapper, {
      style: _extends({
        backgroundColor: bgColor,
        fontWeight: fontWeight
      }, style),
      className: className,
      theme: theme,
      $size: size
    }, title);
  }, [bgColor, className, fontWeight, size, style, theme, title]);

  if (!title) {
    return children;
  }

  return /*#__PURE__*/React.createElement(Trigger, _extends({
    ref: ref,
    popup: popup,
    placement: placement,
    arrowStyle: _extends({
      color: bgColor
    }, arrowSize[size], arrowStyle)
  }, other), children);
});