import styled, { css } from 'styled-components';
import Link from '../Link';
export function makeTooltipWrapperStyle(props) {
  var $size = props.$size,
      theme = props.theme;
  var _theme$typography$spe = theme.typography.spec,
      fontSize = _theme$typography$spe.fontSize,
      lineHeight = _theme$typography$spe.lineHeight;
  var _theme$components$Too = theme.components.Tooltip,
      color = _theme$components$Too.color,
      fontLevel = _theme$components$Too.fontLevel,
      padding = _theme$components$Too.padding,
      maxWidth = _theme$components$Too.maxWidth,
      boxShadow = _theme$components$Too.boxShadow,
      borderRadius = _theme$components$Too.borderRadius,
      linkColor = _theme$components$Too.linkColor;
  var level = fontLevel[$size];
  return css(["color:", ";font-size:", "px;line-height:", "px;padding:", ";border-radius:", ";max-width:", "px;box-sizing:border-box;overflow:hidden;word-wrap:break-word;", " ", "{vertical-align:unset;}", ",a{color:", ";&:hover,&:active{color:", ";}}"], color, fontSize[level], lineHeight[level], padding[$size].map(function (p) {
    return "".concat(p, "px ");
  }), borderRadius[$size], maxWidth, boxShadow && "box-shadow: ".concat(boxShadow, ";"), Link, Link, linkColor, linkColor);
}
export var StyledTooltipWrapper = styled.div.withConfig({
  displayName: "StyledTooltipWrapper"
})(["", ""], makeTooltipWrapperStyle);