import { DustbinIcon as _DustbinIcon } from "@muya-ui/theme-light/es/icons/DustbinIcon";
import styled, { css } from 'styled-components';
import Checkbox from '../Checkbox';
import { EllipsisContent } from '../EllipsisContent';
import Typography from '../Typography';
import ScrollView from '../ScrollView';
export var StyledTransfer = styled.div.withConfig({
  displayName: "StyledTransfer"
})(["", ""], function (_ref) {
  var theme = _ref.theme;
  var token = theme.components.Transfer;
  return css(["width:", "px;height:", "px;display:flex;> *{height:100%;}"], token.container.width, token.container.height);
});
export var StyledTransferPanel = styled.div.withConfig({
  displayName: "StyledTransferPanel"
})(["", ""], function (_ref2) {
  var theme = _ref2.theme;
  var token = theme.components.Transfer.panel;
  return css(["background-color:", ";border:1px solid ", ";height:100%;flex:1;display:flex;overflow:hidden;flex-direction:column;"], token.backgroundColor, token.borderColor);
});
export var StyledTransferPanelHeader = styled.div.withConfig({
  displayName: "StyledTransferPanelHeader"
})(["", ""], function (_ref3) {
  var theme = _ref3.theme;
  var token = theme.components.Transfer.panel;
  return css(["background-color:", ";padding:", "px ", "px;display:flex;align-items:center;"], token.header.backgroundColor, token.header.paddingTop, token.header.paddingLeft);
});
export var StyledTransferPanelTitle = styled.div.withConfig({
  displayName: "StyledTransferPanelTitle"
})(["", ""], function (_ref4) {
  var theme = _ref4.theme;
  var token = theme.components.Transfer.panel.header.title;
  return css(["flex:1;color:", ";font-weight:", ";font-size:", "px;"], token.color, token.weight, token.fontSize);
});
export var StyledTransferPanelCount = styled(Typography.Text).withConfig({
  displayName: "StyledTransferPanelCount"
})(["", ""], function (_ref5) {
  var theme = _ref5.theme;
  var token = theme.components.Transfer.panel;
  return css(["color:", ";"], token.header.countColor);
});
export var StyledTransferIconContainer = styled.div.withConfig({
  displayName: "StyledTransferIconContainer"
})(["", ""], function (_ref6) {
  var theme = _ref6.theme;
  var token = theme.components.Transfer;
  return css(["width:", "px;display:flex;justify-content:center;align-items:center;"], token.iconContainer.width);
});
export var StyledTransferIcon = styled.div.withConfig({
  displayName: "StyledTransferIcon"
})(["", ""], function (_ref7) {
  var theme = _ref7.theme;
  var token = theme.components.Transfer;
  return css(["font-size:", "px;color:", ";transform:rotate(90deg);"], token.icon.fontSize, token.icon.color);
});
export var StyledTransferPanelList = styled(ScrollView).withConfig({
  displayName: "StyledTransferPanelList"
})(["", ""], function (_ref8) {
  var theme = _ref8.theme;
  return css(["flex:1;overflow-y:auto;margin:", "px 0;"], theme.components.Transfer.panel.list.marginTop);
});
export var StyledTransferPanelItem = styled.div.withConfig({
  displayName: "StyledTransferPanelItem"
})(["", ""], function (_ref9) {
  var theme = _ref9.theme,
      $disabled = _ref9.$disabled;
  var token = theme.components.Transfer.panel;
  return css(["box-sizing:border-box;width:100%;padding:", "px ", "px;line-height:", "px;background-color:", ";display:flex;align-items:center;color:", ";cursor:", ";font-size:", "px;", ""], token.item.paddingTop, token.item.paddingLeft, token.item.lineHeight, token.item.background.normal, $disabled ? token.item.colorDisabled : token.item.color, $disabled ? 'not-allowed' : 'pointer', token.item.fontSize, !$disabled && css(["&:hover{background-color:", ";}&:active{background-color:", ";}"], token.item.background.hover, token.item.background.click));
});
export var StyledTransferPanelItemText = styled(EllipsisContent).withConfig({
  displayName: "StyledTransferPanelItemText"
})(["", ""], function (_ref10) {
  var theme = _ref10.theme;
  var token = theme.components.Transfer.panel;
  return css(["flex:1;font-size:", "px;"], token.item.fontSize);
});
export var StyledTransferPanelSearch = styled.div.withConfig({
  displayName: "StyledTransferPanelSearch"
})(["", ""], function (_ref11) {
  var theme = _ref11.theme;
  var token = theme.components.Transfer.panel.header.search;
  return css(["padding:", "px ", "px;display:flex;> *{flex:1;}"], token.paddingTop, token.paddingLeft);
});
export var StyledTransferCheckbox = styled(Checkbox).withConfig({
  displayName: "StyledTransferCheckbox"
})(["", ""], function (_ref12) {
  var theme = _ref12.theme;
  var token = theme.components.Transfer.panel;
  return css(["margin-right:", "px;"], token.checkboxMarginRight);
});
export var StyledTransferItemExtraIcon = styled(_DustbinIcon).withConfig({
  displayName: "StyledTransferItemExtraIcon"
})(["", ""], function (_ref13) {
  var theme = _ref13.theme;
  var token = theme.components.Transfer.panel.item;
  return css(["color:", ";"], token.extraColor);
});
export var StyledTransferPanelFooter = styled.div.withConfig({
  displayName: "StyledTransferPanelFooter"
})(["", ""], function (_ref14) {
  var theme = _ref14.theme;
  var token = theme.components.Transfer.panel.footer;
  return css(["background-color:", ";border-top:1px solid ", ";height:", "px;"], token.backgroundColor, token.borderColor, token.height);
});
export var StyledEmptyResultContainer = styled.div.withConfig({
  displayName: "StyledEmptyResultContainer"
})(["width:100%;height:100%;display:flex;align-items:center;justify-content:center;"]);