import React from 'react';

var flatten = function () {
  var transferDataSource = [];

  function _flatten() {
    var list = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    list.forEach(function (item) {
      transferDataSource.push(item);

      _flatten(item.children);
    });
  }

  return function deep(data) {
    transferDataSource = [];

    _flatten(data);

    return transferDataSource;
  };
}();
/**
 * 传入树形数据，返回Transfer所需dataSource和该树形数据本身
 */


var useTransferTree = function useTransferTree(treeData) {
  var mode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'move';
  var dataSource = React.useMemo(function () {
    return flatten(treeData);
  }, [treeData]);
  var treeDataSource = React.useMemo(function () {
    return treeData;
  }, [treeData]);
  return {
    transferDataSource: dataSource,
    treeDataSource: treeDataSource
  };
};

export default useTransferTree;