import styled, { css, keyframes } from 'styled-components';
import { StyledCheckboxLabel, StyledCheckboxSpan } from '../Checkbox/styled';
import { scrollBarStyle } from '../ScrollView/styled';
import ellipsisStyle from '../styled/mixins/ellipsis';
import { itemDisabledStyle, itemNormalStyle, itemSelectedStyle } from '../styled/mixins/item';
import listResetStyle from '../styled/mixins/listReset';
import Typography from '../Typography';
// expand 动画
export var expandedRotateKeyframes = keyframes(["to{transform:rotate(90deg);}"]);
export var notExpandedRotateKeyframes = keyframes(["from{transform:rotate(90deg);}to{transform:rotate(0deg);}"]);
export var StyledTitle = styled(Typography.Text).withConfig({
  displayName: "StyledTitle"
})([""]);
export var StyledTreeIconWrapper = styled.div.withConfig({
  displayName: "StyledTreeIconWrapper"
})([""]);
export var StyledIndicator = styled.div.withConfig({
  displayName: "StyledIndicator"
})(["", ""], function (props) {
  var token = props.theme.components.Tree;
  return css(["position:absolute;z-index:2;right:0;width:100%;height:1px;background:", ";&::after{content:'';position:absolute;width:5px;height:5px;border-radius:50%;border:1px solid ", ";top:-2px;inset-inline-start:-4px;}"], token.dragOverGapColor, token.dragOverGapColor);
}); // node content

export var StyledTreeNodeContent = styled.div.withConfig({
  displayName: "StyledTreeNodeContent"
})(["display:flex;justify-content:flex-start;align-items:center;"]);
export var StyledTreeNodeLabel = styled.span.withConfig({
  displayName: "StyledTreeNodeLabel"
})(["white-space:nowrap;text-overflow:ellipsis;overflow:hidden;"]);
export var StyledChildTree = styled.ul.withConfig({
  displayName: "StyledChildTree"
})(["", ";"], listResetStyle);
export var StyleExpandHotZone = styled.div.withConfig({
  displayName: "StyleExpandHotZone"
})([""]);
export var StyledExpandHotZoneLine = styled.div.withConfig({
  displayName: "StyledExpandHotZoneLine"
})([""]);
export var StyledTreeNodeSelectorWrapper = styled.div.withConfig({
  displayName: "StyledTreeNodeSelectorWrapper"
})(["display:inline-flex;width:100%;"]);
export var StyledTreeNodeSelector = styled.div.withConfig({
  displayName: "StyledTreeNodeSelector"
})(["display:inline-flex;justify-content:space-between;width:100%;"]);
export var StyledLine = styled.div.withConfig({
  displayName: "StyledLine"
})(["", ""], function (props) {
  var _props$theme = props.theme,
      colors = _props$theme.colors,
      token = _props$theme.components.Tree,
      $level = props.$level,
      $size = props.$size,
      $isLastChild = props.$isLastChild,
      $contentHeight = props.$contentHeight;
  return css(["position:absolute;top:0;bottom:", ";left:", "px;width:", "px;background:", ";content:' ';"], $isLastChild ? "".concat($contentHeight / 2 + 2, "px") : 0, token.lineVertical.firstLevelLeft[$size] + $level * token.childIndent, token.lineSize, colors.pattern.background.divider);
}); // node
// eslint-disable-next-line complexity

var treeNodeCss = function treeNodeCss(props) {
  var _props$theme2 = props.theme,
      colors = _props$theme2.colors,
      _props$theme2$transit = _props$theme2.transition.pattern,
      duration = _props$theme2$transit.duration,
      easing = _props$theme2$transit.easing,
      token = _props$theme2.components.Tree,
      $size = props.$size,
      $dragNodeHighlight = props.$dragNodeHighlight,
      $dragOver = props.$dragOver,
      $dragOverGapTop = props.$dragOverGapTop,
      $dragOverGapBottom = props.$dragOverGapBottom,
      $dropLevelOffset = props.$dropLevelOffset,
      $isLeaf = props.$isLeaf,
      $level = props.$level,
      $selected = props.$selected,
      $disabled = props.$disabled,
      $showLine = props.$showLine,
      $virtual = props.$virtual,
      $lineBottom = props.$lineBottom;
  return css(["position:relative;display:flex;flex-direction:column;", ";& > ", "{margin:", ";height:", "px;line-height:", "px;padding-left:", "px;padding-right:", "px;cursor:pointer;z-index:1;transition:background-color ", "ms ", ",color ", "ms ", ";", " ", ";& ", "{", " ", "}", " ", " ", " ", " ", " &:hover ", "{background:transparent;}}", "{font-size:", "px;margin-right:", "px;}", "{top:0;}", "{margin-right:", "px;}", "{position:relative;display:inline-flex;justify-content:center;align-items:center;flex-shrink:0;line-height:", "px;width:", "px;height:", "px;margin:0 ", "px;cursor:pointer;}", " ", " ", "{font-size:", "px;line-height:", "px;color:inherit;white-space:nowrap;}& > ", "{padding-left:", "px;}"], $virtual && $level > 0 && "padding-left: ".concat(token.childIndent * $level + token.firstNodePaddingLeft[$size], "px"), StyledTreeNodeContent, token.contentMargin, token.nodeHeight[$size], token.lineHeight[$size], $level === 0 ? token.firstNodePaddingLeft[$size] : 0, token.contentPaddingRight[$size], duration.status, easing.status, duration.status, easing.status, itemNormalStyle(token), $level === 0 && "color: ".concat(token.rootLevelColor), StyledIndicator, $dragOverGapTop && css(["top:-1px;left:", "px;"], $virtual && $level > 0 ? token.childIndent * ($level - $dropLevelOffset) + token.firstNodePaddingLeft[$size] + 10 : $level === 0 ? token.firstNodePaddingLeft[$size] + 10 : 10), $dragOverGapBottom && css(["bottom:0px;left:", "px;"], $virtual && $level > 0 ? token.childIndent * ($level - $dropLevelOffset) + token.firstNodePaddingLeft[$size] + 10 : $level === 0 ? token.firstNodePaddingLeft[$size] + 10 : 10), $dragOver && css(["background:", ";"], token.dragOverBgColor), $dragNodeHighlight && css(["opacity:", ";"], token.dragNodeHighlightOpacity), $selected && css(["", " ", "{background:transparent;}"], itemSelectedStyle(token), StyledExpandHotZoneLine), $disabled && itemDisabledStyle(token), $isLeaf && $level !== 0 && css(["margin-left:0;"]), StyledExpandHotZoneLine, StyledTreeIconWrapper, token.iconFontSize[$size], token.iconWrapperMarginRight, StyledCheckboxSpan, StyledCheckboxLabel, token.checkboxMarginRight, StyleExpandHotZone, token.nodeHeight[$size], token.expandIconWrapperWidth, token.nodeHeight[$size], token.expandIconWrapperMargin, $showLine && !$virtual && !$isLeaf && css(["&::before{position:absolute;top:", "px;bottom:", "px;left:", "px;width:", "px;background:", ";content:' ';}"], token.lineVertical.top, $lineBottom || token.lineVertical.bottom[$size], $level === 0 ? token.lineVertical.firstLevelLeft[$size] : token.lineVertical.otherLevelLeft[$size], token.lineSize, colors.pattern.background.divider), $showLine && $level > 0 && css(["", "{position:relative;width:100%;height:", "px;background:", ";left:", "px;}", "::before{position:absolute;top:", "px;left:", "px;height:", "px;width:", "px;background:", ";content:' ';}"], StyledExpandHotZoneLine, token.lineSize, colors.pattern.background.divider, token.lineHorizontal.left, StyleExpandHotZone, token.lineHorizontal.beforeTop[$size], token.lineHorizontal.beforeLeft[$size], token.lineSize, token.lineHorizontal.beforeWidth, colors.pattern.background.divider), StyledTitle, token.fontSize[$size], token.lineHeight[$size], StyledChildTree, $level === 0 ? token.childIndent + token.firstNodePaddingLeft[$size] : token.childIndent);
}; // tree


export var StyledTreeNode = styled.li.withConfig({
  displayName: "StyledTreeNode"
})(["", ";", ";"], listResetStyle, treeNodeCss);
var notScrollableCss = css(["overflow:hidden;", "{", ";", "{", ";}", "{overflow:hidden;}}"], StyledTreeNodeSelectorWrapper, ellipsisStyle, StyledTitle, ellipsisStyle, StyledTreeNodeSelector);

var treeCss = function treeCss(props) {
  var _props$theme3 = props.theme,
      colorsPattern = _props$theme3.colors.pattern,
      token = _props$theme3.components.Tree,
      $size = props.$size,
      $scrollable = props.$scrollable;
  return css(["box-sizing:border-box;font-size:", "px;color:", ";font-variant:tabular-nums;font-feature-settings:'tnum';", ";"], token.fontSize[$size], colorsPattern.text.text, !$scrollable && notScrollableCss);
};

export var StyledTree = styled.ul.withConfig({
  displayName: "StyledTree"
})(["", ";", ";", ";padding:3px 0;"], listResetStyle, treeCss, scrollBarStyle);
export var StyledTreeScrollWrapper = styled.div.withConfig({
  displayName: "StyledTreeScrollWrapper"
})(["box-sizing:border-box;overflow:auto;", ";"], scrollBarStyle);