import styled, { css } from 'styled-components';
export var defaultArrowWidth = 12;
export var defaultArrowHeight = 6;
export var defaultOffset = 6;
export var defaultArrowMargin = 16;
export function makeTriggerWrapperStyle(props) {
  var _props$placement = props.placement,
      placement = _props$placement === void 0 ? 'top' : _props$placement,
      _props$offset = props.offset,
      offset = _props$offset === void 0 ? defaultOffset : _props$offset,
      _props$arrowStyle = props.arrowStyle,
      arrowStyle = _props$arrowStyle === void 0 ? {} : _props$arrowStyle,
      hideArrow = props.hideArrow;
  var mainPlacement = placement.split('-')[0];
  var arrowHeight = arrowStyle.height || defaultArrowHeight;
  var margin = hideArrow ? offset : offset + arrowHeight;
  var placementStyles = {
    top: css(["margin-bottom:", "px;"], margin),
    right: css(["margin-left:", "px;"], margin),
    bottom: css(["margin-top:", "px;"], margin),
    left: css(["margin-right:", "px;"], margin)
  };
  return css(["position:relative;", ""], placementStyles[mainPlacement]);
}
export var StyledTriggerWrapper = styled.div.withConfig({
  displayName: "StyledTriggerWrapper"
})(["", ""], makeTriggerWrapperStyle);