import styled, { css } from 'styled-components';
import { withThemeForStyled } from '../utils/withTheme';
import { baseStyle, getFontStyle } from './mixin';
var Text = styled.span.withConfig({
  displayName: "Text"
})(["", ""], function (props) {
  var ellipsis = props.ellipsis,
      type = props.type,
      strong = props.strong,
      color = props.color,
      theme = props.theme;
  var colors = theme.colors,
      typography = theme.typography,
      token = theme.components.Typography;

  var _getFontStyle = getFontStyle(props, theme),
      lineHeight = _getFontStyle.lineHeight,
      fontSize = _getFontStyle.fontSize;

  return css(["", ";color:", ";font-weight:", ";font-size:", ";line-height:", ";", ""], ellipsis && 'display: inline-block', type ? colors.pattern.feature[type] : colors.pattern.text[color || token.defaultTextType], strong && typography.spec.fontWeight.semibold, fontSize, lineHeight, baseStyle);
});
export default withThemeForStyled(Text);