import _extends from "@babel/runtime/helpers/extends";
import React from 'react';
import styled, { css } from 'styled-components';
import useTheme from '../utils/useTheme';
import { baseStyle } from './mixin';
export var StyledTitle = styled.div.withConfig({
  displayName: "StyledTitle"
})(["", ""], function (props) {
  var _props$theme = props.theme,
      colors = _props$theme.colors,
      typography = _props$theme.typography,
      token = _props$theme.components.Typography,
      color = props.color,
      level = props.level,
      marginBottom = props.marginBottom,
      marginTop = props.marginTop;
  var fontLevel = token.titleFontLevelMap["h".concat(level)];
  return css(["", " color:", ";font-weight:", ";font-size:", "px;line-height:", "px;", " & + &{", "}"], baseStyle, colors.pattern.text[color || token.defaultTitleType], typography.spec.fontWeight.semibold, typography.spec.fontSize[fontLevel], typography.spec.lineHeight[fontLevel], typeof marginBottom === 'undefined' && "margin-bottom: ".concat(token.titleMarginBottom, ";"), typeof marginTop === 'undefined' && "margin-top: ".concat(token.titleMarginTop, ";"));
});
export default /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _props$level = props.level,
      level = _props$level === void 0 ? 1 : _props$level;
  var asProp = "h".concat(level);
  var theme = useTheme();
  return /*#__PURE__*/React.createElement(StyledTitle, _extends({
    theme: theme,
    as: asProp
  }, props, {
    level: level,
    ref: ref
  }));
});