import { css } from 'styled-components';
import { makeEllipsisStyle } from '../styled/mixins/ellipsis';
import addPx from '../utils/addPx';
export var baseStyle = css(["box-sizing:border-box;margin:0;", ""], function (props) {
  var deleteProp = props["delete"],
      underline = props.underline,
      ellipsis = props.ellipsis,
      marginTop = props.marginTop,
      marginBottom = props.marginBottom,
      vertialAlign = props.vertialAlign;
  return css(["", ";", ";", ";", ";", ";", ""], deleteProp && 'text-decoration: line-through', underline && 'text-decoration: underline', marginTop && "margin-top: ".concat(addPx(marginTop)), marginBottom && "margin-bottom: ".concat(addPx(marginBottom)), vertialAlign && "vertical-align: ".concat(vertialAlign), ellipsis && makeEllipsisStyle(ellipsis));
});
export var getFontStyle = function getFontStyle(props, theme) {
  var lineHeightProp = props.lineHeight,
      fontSizeProp = props.fontSize;
  var typography = theme.typography,
      token = theme.components.Typography;
  var fontSize;
  var lineHeight;

  if (typeof fontSizeProp === 'number') {
    fontSize = "".concat(fontSizeProp, "px");
  } else {
    fontSize = "".concat(typography.spec.fontSize[fontSizeProp || token.defaultFontLevel], "px");
  }

  if (lineHeightProp) {
    lineHeight = lineHeightProp;
  } else if (typeof fontSizeProp === 'number') {
    lineHeight = typography.spec.global.lineHeight;
  } else {
    lineHeight = "".concat(typography.spec.lineHeight[fontSizeProp || token.defaultFontLevel], "px");
  }

  return {
    fontSize: fontSize,
    lineHeight: lineHeight
  };
};