import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "render"];
import React from 'react';
import memoForwardRef from '../utils/memoForwardRef';
import UploadCard from './UploadCard';
import UploadResult from './UploadResult';
import useUpload from './useUpload';
var Upload = memoForwardRef(function (props, ref) {
  var children = props.children,
      render = props.render,
      uploadOption = _objectWithoutProperties(props, _excluded);

  var state = useUpload(uploadOption);
  React.useImperativeHandle(ref, function () {
    return {
      open: state.open
    };
  });

  if (render) {
    return render(state);
  }

  if (children) {
    return children(state);
  }

  return null;
});
Upload.Result = UploadResult;
Upload.Card = UploadCard;
Upload.useUpload = useUpload;
export default Upload;