import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["title", "subtitle", "icon", "children", "size", "disabled", "isDragActive", "width", "height", "styles"];
import React, { useMemo } from 'react';
import Typography from '../Typography';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import { StyledUploadCard, StyledUploadCardIcon } from './styled';
var defaultStyles = {
  titleWrapper: '',
  iconWrapper: '',
  subtitleWrapper: ''
};
export default memoForwardRef(function (props, ref) {
  var title = props.title,
      subtitle = props.subtitle,
      icon = props.icon,
      children = props.children,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      _props$isDragActive = props.isDragActive,
      isDragActive = _props$isDragActive === void 0 ? false : _props$isDragActive,
      width = props.width,
      height = props.height,
      styles = props.styles,
      other = _objectWithoutProperties(props, _excluded);

  var theme = useTheme();
  var innerStyles = useStyles('upload-card', defaultStyles, styles);
  var token = theme.components.Upload.card;
  var innerChildren = useMemo(function () {
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(StyledUploadCardIcon, innerStyles.iconWrapper, icon), title && /*#__PURE__*/React.createElement(Typography.Text, _extends({
      fontSize: token.titleFontLevel,
      color: "assistant",
      marginTop: token.titleMarginTop
    }, innerStyles.titleWrapper), title), subtitle && /*#__PURE__*/React.createElement(Typography.Text, _extends({
      fontSize: token.subTitleFontLevel,
      color: "secondary",
      marginTop: token.subTitleMarginTop
    }, innerStyles.subtitleWrapper), subtitle));
  }, [icon, innerStyles.iconWrapper, innerStyles.subtitleWrapper, innerStyles.titleWrapper, subtitle, title, token.subTitleFontLevel, token.subTitleMarginTop, token.titleFontLevel, token.titleMarginTop]);
  return /*#__PURE__*/React.createElement(StyledUploadCard, _extends({
    ref: ref,
    theme: theme,
    $disabled: disabled,
    $isDragActive: isDragActive,
    $width: width,
    $height: height,
    $size: size
  }, other), innerChildren, children);
});