import styled, { css } from 'styled-components';
import IconButton from '../IconButton';
import Img from '../Img';
import InlineButton from '../InlineButton';
import Progress from '../Progress';
import addPx from '../utils/addPx';
export var StyledImgWrapper = styled.div.withConfig({
  displayName: "StyledImgWrapper"
})([""]);
export var StyledContentWrapper = styled.div.withConfig({
  displayName: "StyledContentWrapper"
})(["display:flex;flex-flow:column nowrap;flex:1;overflow:hidden;"]);
export var StyledFilenameWrapper = styled.span.withConfig({
  displayName: "StyledFilenameWrapper"
})(["overflow:hidden;text-overflow:ellipsis;white-space:nowrap;padding-right:", ";"], function (props) {
  return "".concat(props.theme.components.Upload.card.titlePaddingRight, "px");
});
export var StyledProgress = styled(Progress).withConfig({
  displayName: "StyledProgress"
})([""]);
export var StyledButton = styled(InlineButton).withConfig({
  displayName: "StyledButton"
})(["&&{display:flex;align-items:center;justify-content:flex-start;width:100%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;opacity:1;cursor:", ";}"], function (props) {
  return props.href ? 'pointer' : 'default';
});
export var StyledResultCloseIconWrapper = styled(IconButton).withConfig({
  displayName: "StyledResultCloseIconWrapper"
})([""]);
export var StyledRetryButton = styled(InlineButton).withConfig({
  displayName: "StyledRetryButton"
})([""]);
export var StyledErrorWrapper = styled.span.withConfig({
  displayName: "StyledErrorWrapper"
})(["display:flex;"]);
export var StyledPictureCloseIconWrapper = styled.div.withConfig({
  displayName: "StyledPictureCloseIconWrapper"
})(["display:flex;justify-content:center;align-items:center;position:absolute;right:-10px;top:-10px;width:20px;height:20px;font-size:12px;border-radius:50%;z-index:1;color:", ";background:", ";cursor:pointer;&:hover{background:", ";}"], function (props) {
  return props.theme.colors.spec.light;
}, function (props) {
  return props.theme.colors.spec.neutral1.normal;
}, function (props) {
  return props.theme.colors.spec.neutral2.normal;
});
export var StyledUploadResult = styled.div.withConfig({
  displayName: "StyledUploadResult"
})(["", ""], function (props) {
  var _props$$type = props.$type,
      $type = _props$$type === void 0 ? 'picture-card' : _props$$type,
      theme = props.theme,
      _props$$size = props.$size,
      $size = _props$$size === void 0 ? 'm' : _props$$size,
      $status = props.$status,
      $url = props.$url;
  var token = theme.components.Upload;
  var _theme$components$Upl = theme.components.Upload,
      pictureWidth = _theme$components$Upl.pictureWidth,
      shadow = _theme$components$Upl.shadow,
      result = _theme$components$Upl.result,
      progress = _theme$components$Upl.progress,
      card = _theme$components$Upl.card,
      retryButton = _theme$components$Upl.retryButton,
      marginTop = _theme$components$Upl.marginTop;
  var _theme$colors = theme.colors,
      colorsSpec = _theme$colors.spec,
      colorsPattern = _theme$colors.pattern;
  var pictureStyle;
  var cardStyle;
  var pictureCardStyle;

  if ($type === 'picture') {
    pictureStyle = css(["display:inline-flex;width:", "px;height:", "px;flex-flow:column nowrap;justify-content:center;align-items:center;box-sizing:border-box;outline:none;border:1px solid ", ";font-size:", "px;", " ", " ", "{text-align:center;margin-top:0;}", "{margin-left:0;margin-top:", "px;}"], pictureWidth[$size], pictureWidth[$size], colorsPattern.border.normal, theme.typography.spec.fontSize.s3, $status === 'error' && css(["border-color:", ";"], colorsPattern.feature.error), $status === 'uploading' && css(["&:hover{background:", ";}"], colorsSpec.neutral10.normal), StyledErrorWrapper, StyledRetryButton, retryButton.marginInTypePicture[$size]);
  } else if ($type === 'card') {
    cardStyle = css(["flex-flow:column nowrap;justify-content:center;width:", "px;padding:", "px ", "px;&:hover{background:", ";}&:active{background:", ";}"], result.size[$size].width, result.cardPaddingHorizontal, result.cardPaddingVertial, $url ? card.hasUrlBackground.hover : card.background.hover, $url ? card.hasUrlBackground.clicked : card.background.clicked);
  } else if ($type === 'picture-card') {
    pictureCardStyle = css(["align-items:center;width:", "px;height:", "px;background:", ";padding:", "px;padding-right:", "px;box-shadow:", ";&:hover{box-shadow:", ";}", "{width:", "px;margin-right:", "px;}", "{top:", "px;}"], result.size[$size].width, result.size[$size].height, theme.colors.spec.light, theme.spacing.spec.s4, theme.spacing.spec.s6, shadow.normal, shadow.hover, StyledImgWrapper, result.size[$size].imgWidth, theme.spacing.spec.s6, StyledResultCloseIconWrapper, token.result.closeIconSpacing[$size]);
  }

  return css(["position:relative;display:flex;box-sizing:border-box;border-radius:", ";", "{width:100%;border-radius:", ";&:hover{opacity:", ";}}", "{position:absolute;font-size:", "px;right:", "px;}", "{margin-left:", "px;}", "{height:", "px;margin-top:", "px;}", "{margin-top:", "px;}", ";", ";", ";"], token.borderRadius, Img, token.img.borderRadius, token.img.hoverOpacity, StyledResultCloseIconWrapper, token.result.closeIconSize[$size], $type === 'card' ? 0 : token.result.closeIconSpacing[$size], StyledRetryButton, retryButton.marginInOtherType, StyledProgress, progress.height, marginTop[$size], StyledErrorWrapper, $status === 'error' ? marginTop[$size] : 0, pictureStyle, cardStyle, pictureCardStyle);
});
export var StyledUploadCardIcon = styled(IconButton).withConfig({
  displayName: "StyledUploadCardIcon"
})([""]);
export var StyledUploadCard = styled.div.withConfig({
  displayName: "StyledUploadCard"
})(["", ""], function (props) {
  var _props$theme = props.theme,
      borderRadius = _props$theme.size.spec.borderRadius,
      _props$theme$colors$p = _props$theme.colors.pattern,
      text = _props$theme$colors$p.text,
      border = _props$theme$colors$p.border,
      background = _props$theme$colors$p.background,
      $disabled = props.$disabled,
      $isDragActive = props.$isDragActive,
      $width = props.$width,
      $height = props.$height,
      $size = props.$size;
  var _props$theme$componen = props.theme.components.Upload,
      token = _props$theme$componen.card,
      marginTop = _props$theme$componen.marginTop,
      progress = _props$theme$componen.progress;
  var disabledStyle = css(["& > *{color:", ";}user-select:none;background:", ";cursor:not-allowed;"], text.disabled, background.disabled);
  var interactiveStyle = css(["&:hover{background:", ";}", ";&:active{background:", ";}"], token.background.hover, $isDragActive && "background: ".concat(token.background.hover), token.background.clicked);
  return css(["display:inline-flex;flex-flow:column nowrap;align-items:center;justify-content:center;box-sizing:border-box;outline:none;cursor:pointer;border:1px solid ", ";border-radius:", ";", ";width:", ";height:", ";", "{font-size:", "px;line-height:1;}", "{height:", "px;margin-top:", "px;}"], border.normal, borderRadius.s2, $disabled ? disabledStyle : interactiveStyle, addPx($width ? $width : token.size[$size]), addPx($height ? $height : token.size[$size]), StyledUploadCardIcon, token.iconFontLevel, StyledProgress, progress.height, marginTop[$size]);
});