import _extends from "@babel/runtime/helpers/extends";
import React, { useMemo } from 'react';
import usePickerBase from '../DatePicker/usePickerBase';
import { StyledPopPanel } from '../styled/components/PopPanel';
import Trigger from '../Trigger';
import memoForwardRef from '../utils/memoForwardRef';
import useStyles from '../utils/useStyles';
import useTheme from '../utils/useTheme';
import { StyledInput } from './styled';
import useWeekPicker from './useWeekPicker';
import WeekCalendar from './WeekCalendar';
var defaultStyles = {
  popPanel: ''
};
var WeekPicker = memoForwardRef(function (props, ref) {
  var theme = useTheme();

  var _useWeekPicker = useWeekPicker(props),
      finalUIState = _useWeekPicker.finalUIState,
      finalSelectedWeek = _useWeekPicker.finalSelectedWeek,
      finalValue = _useWeekPicker.finalValue,
      otherProps = _useWeekPicker.otherProps,
      handleFocus = _useWeekPicker.handleFocus,
      handleCalendarChange = _useWeekPicker.handleCalendarChange,
      handleCalendarUIChange = _useWeekPicker.handleCalendarUIChange,
      handleClickAway = _useWeekPicker.handleClickAway,
      handleClear = _useWeekPicker.handleClear,
      styles = _useWeekPicker.styles,
      disabled = _useWeekPicker.disabled,
      options = _useWeekPicker.options,
      todayDate = _useWeekPicker.todayDate,
      disableWeek = _useWeekPicker.disableWeek,
      allowClear = _useWeekPicker.allowClear,
      container = _useWeekPicker.container,
      renderDecadeItem = _useWeekPicker.renderDecadeItem,
      renderMonthItem = _useWeekPicker.renderMonthItem,
      renderYearItem = _useWeekPicker.renderYearItem,
      renderMonthLabel = _useWeekPicker.renderMonthLabel,
      onSelect = _useWeekPicker.onSelect,
      calendarStyles = _useWeekPicker.calendarStyles,
      placement = _useWeekPicker.placement,
      popperProps = _useWeekPicker.popperProps,
      arrowPointAtCenter = _useWeekPicker.arrowPointAtCenter,
      triggerId = _useWeekPicker.triggerId,
      flip = _useWeekPicker.flip; // input 的 styles 直接传个 input


  var inputStyles = useMemo(function () {
    if (!styles) {
      return;
    }

    var inputWrapper = styles.inputWrapper,
        input = styles.input,
        nodeDivider = styles.nodeDivider,
        nodeWrapper = styles.nodeWrapper,
        clearWrapper = styles.clearWrapper,
        statusWrapper = styles.statusWrapper;
    return {
      inputWrapper: inputWrapper,
      input: input,
      nodeDivider: nodeDivider,
      nodeWrapper: nodeWrapper,
      clearWrapper: clearWrapper,
      statusWrapper: statusWrapper
    };
  }, [styles]);
  var currentStyles = useMemo(function () {
    if (!styles) {
      return;
    }

    var popPanel = styles.popPanel;
    return {
      popPanel: popPanel
    };
  }, [styles]);
  var innerStyles = useStyles('week-picker', defaultStyles, currentStyles);

  var _usePickerBase = usePickerBase(),
      innerSuffixNode = _usePickerBase.suffixNode;

  var realNode = /*#__PURE__*/React.createElement(StyledInput, _extends({
    ref: ref,
    value: finalValue,
    suffixNode: innerSuffixNode,
    clearReplace: true,
    focusWhenClear: false,
    theme: theme,
    styles: inputStyles,
    disabled: disabled,
    allowClear: allowClear,
    onFocus: handleFocus,
    onClear: handleClear,
    readOnly: true
  }, otherProps));

  if (disabled) {
    return realNode;
  }

  var calendarProps = {
    styles: calendarStyles,
    disableWeek: disableWeek,
    options: options,
    todayDate: todayDate,
    onSelect: onSelect,
    allowClear: allowClear,
    renderDecadeItem: renderDecadeItem,
    renderMonthItem: renderMonthItem,
    renderYearItem: renderYearItem,
    renderMonthLabel: renderMonthLabel
  };
  var calendarNode = /*#__PURE__*/React.createElement(StyledPopPanel, _extends({}, innerStyles.popPanel, {
    theme: theme
  }), /*#__PURE__*/React.createElement(WeekCalendar, _extends({
    viewDate: finalUIState.viewDate,
    viewType: finalUIState.viewType,
    selectedWeek: finalSelectedWeek,
    onChange: handleCalendarChange,
    onUIChange: handleCalendarUIChange
  }, calendarProps)));
  var triggerProps = {
    placement: placement,
    popperProps: popperProps,
    arrowPointAtCenter: arrowPointAtCenter,
    triggerId: triggerId,
    flip: flip,
    hideArrow: true,
    container: container
  };
  return /*#__PURE__*/React.createElement(Trigger, _extends({
    popup: calendarNode,
    triggerAction: "click",
    open: finalUIState.popupOpen,
    onClickAway: handleClickAway
  }, triggerProps), realNode);
});
WeekPicker.__MUYA_WEEKPICKER = true;
export default WeekPicker;