import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import dayjs from 'dayjs';
import { getRangeInOrder, isSame } from '../Calendar/utils';
export function formatWeek(inputWeek) {
  if (!inputWeek) {
    return;
  }

  if (Array.isArray(inputWeek)) {
    var range = getRangeInOrder(inputWeek);

    if (!range) {
      return;
    }

    return [range[0].startOf('w'), range[0].endOf('w')];
  }

  var innerDate = dayjs(inputWeek);

  if (!innerDate.isValid()) {
    return;
  }

  return [innerDate.startOf('w'), innerDate.endOf('w')];
}
export function getViewDateByWeek(_ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      weekStart = _ref2[0],
      weekEnd = _ref2[1];

  if (isSame(weekStart, weekEnd, 'month')) {
    return weekStart;
  } // 都按 8点算吧


  var weekStartEndOfMonth = weekStart.endOf('month').hour(8);
  var weekEndStartOfMonth = weekEnd.startOf('month').hour(8);
  var startRemain = weekStartEndOfMonth.unix() - weekStart.unix();
  var endRemain = weekEnd.unix() - weekEndStartOfMonth.unix();
  return startRemain > endRemain ? weekStart : weekEnd;
}
export function isSameWeek(weekA, weekB) {
  if (!weekA || !weekB) {
    return false;
  }

  return weekA[0].isSame(weekB[0], 'd');
}