import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["width", "color", "height", "margin"];
import styled, { css } from 'styled-components';
export var defaultArrowWidth = 12;
export var defaultArrowHeight = 6;
export var defaultArrowMargin = 16;
export var StyledArrow = styled.div.withConfig({
  displayName: "StyledArrow"
})(["", ""], makeArrowStyle);
export function makeArrowStyle(props) {
  var _css;

  var _props$placement = props.placement,
      placement = _props$placement === void 0 ? 'top' : _props$placement,
      _props$arrowStyle = props.arrowStyle,
      arrowStyle = _props$arrowStyle === void 0 ? {} : _props$arrowStyle;

  var width = arrowStyle.width,
      color = arrowStyle.color,
      height = arrowStyle.height,
      margin = arrowStyle.margin,
      otherStyle = _objectWithoutProperties(arrowStyle, _excluded);

  var mainPlacement = placement.split('-')[0];
  var subPlacement = placement.split('-')[1];
  var arrowColor = color || '#fff';
  var arrowWidth = width || defaultArrowWidth;
  var arrowHeight = height || defaultArrowHeight;
  var arrowMargin = margin || defaultArrowMargin;
  var arrowMarginStyle;
  var arrowSizeStyle;

  if (mainPlacement === 'bottom' || mainPlacement === 'top') {
    arrowSizeStyle = css(["border-width:", "px ", "px;"], arrowHeight, arrowWidth / 2);

    if (subPlacement === 'start') {
      // top-start or bottom-start 靠左
      arrowMarginStyle = css(["left:", "px;"], arrowMargin);
    } else if (subPlacement === 'end') {
      // top-end or bottom-end 靠右
      arrowMarginStyle = css(["right:", "px;"], arrowMargin);
    } else {
      // 第二个位置不传，默认相对于Trigger内容居中
      arrowMarginStyle = css(["left:50%;transform:translateX(-50%);"]);
    }
  } else {
    arrowSizeStyle = css(["border-width:", "px ", "px;"], arrowWidth / 2, arrowHeight);

    if (subPlacement === 'start') {
      // left-start or right-start 靠左
      arrowMarginStyle = css(["top:", "px;"], arrowMargin);
    } else if (subPlacement === 'end') {
      // left-end or right-end 靠右
      arrowMarginStyle = css(["bottom:", "px;"], arrowMargin);
    } else {
      // 第二个位置不传，默认相对于Trigger内容居中
      arrowMarginStyle = css(["top:50%;transform:translateY(-50%);"]);
    }
  }

  return css(["position:absolute;width:0;height:0;border-style:solid;border-color:transparent;", ";", " ", " ", ""], (_css = {}, _defineProperty(_css, mainPlacement, '100%'), _defineProperty(_css, "border-".concat(mainPlacement, "-color"), arrowColor), _css), arrowMarginStyle, arrowSizeStyle, otherStyle);
}