import _typeof from "@babel/runtime/helpers/typeof";
import { css } from 'styled-components';
import addPx from '../../utils/addPx';
export function makeEllipsisStyle(ellipsis) {
  if (!ellipsis) return;

  if (_typeof(ellipsis) === 'object') {
    return css(["display:-webkit-box;-webkit-line-clamp:", ";-webkit-box-orient:vertical;overflow:hidden;overflow-wrap:break-word;"], ellipsis.rows || 3);
  }

  if (ellipsis) {
    return css(["overflow:hidden;white-space:nowrap;text-overflow:ellipsis;"]);
  }
}
var ellipsisStyle = makeEllipsisStyle(true);
export var ellipsisLeftStyle = css(["", ";text-align:left;direction:rtl;"], ellipsisStyle);
export function ellipsisWithWidth(ellipsis, width) {
  return css(["", " ", ""], width && css(["width:", ";"], addPx(width)), ellipsis && ellipsisStyle);
}
export default ellipsisStyle;