import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _isArray from "lodash/isArray";
export function arrayDel(list, value) {
  var clone = list.slice();
  var index = clone.indexOf(value);

  if (index >= 0) {
    clone.splice(index, 1);
  }

  return clone;
}
export function arrayAdd(list, value) {
  var clone = list.slice();

  if (clone.indexOf(value) === -1) {
    clone.push(value);
  }

  return clone;
}
/**
 * splice一个数组，通过传入fn对删除的item进行操作，并将返回值插入该数组
 *
 * @param {T[]} list 数据源数组
 * @param {number} start
 * @param {number} end
 * @param {((items: T[]) => T | T[])} fn 对删除掉的数据进行操作的函数
 * @returns 和 Array.prototype.splice 相同
 */

export function arraySpliceWithFn(list, start, end, fn) {
  var len = list.length;
  var delList = list.slice(start, len - end);
  var delListWithFn = fn(delList);
  var overResultArr;

  if (_isArray(delListWithFn)) {
    overResultArr = delListWithFn;
  } else {
    overResultArr = [delListWithFn];
  }

  var spliceResult = list.splice.apply(list, [start, len - start - end].concat(_toConsumableArray(overResultArr)));
  return spliceResult;
}