import _typeof from "@babel/runtime/helpers/typeof";
import _kebabCase from "lodash/kebabCase";
export default function transformStyles(themePrefix, componentName, map) {
  var keys = Object.keys(map);
  var resultMap = {};
  keys.forEach(function (key) {
    var classes = ["muya-".concat(componentName, "-").concat(_kebabCase(key)), "".concat(themePrefix, "-").concat(componentName, "-").concat(_kebabCase(key))];
    var config = map[key];
    var style;

    if (config && typeof config === 'string') {
      classes.push(config);
    } else if (config && _typeof(config) === 'object') {
      style = config;
    }

    resultMap[key] = {
      className: classes.join(' '),
      style: style
    };
  });
  return resultMap;
}