import { useEffect } from 'react';
import addPx from './addPx';
export function useAdjustMiniFont(textRef, fontSize) {
  var minFontSize = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 12;
  useEffect(function () {
    if (fontSize < minFontSize) {
      if (textRef && textRef.current) {
        var _getComputedStyle = getComputedStyle(textRef.current),
            _getComputedStyle$wid = _getComputedStyle.width,
            width = _getComputedStyle$wid === void 0 ? '0px' : _getComputedStyle$wid;

        textRef.current.style.transform = "scale(".concat(fontSize / minFontSize, ")");
        textRef.current.style.webkitTransform = "scale(".concat(fontSize / minFontSize, ")");
        textRef.current.style.marginRight = addPx(parseInt(width, fontSize) * (1 - fontSize / minFontSize) / -2);
        textRef.current.style.marginLeft = addPx(parseInt(width, fontSize) * (1 - fontSize / minFontSize) / -2);
      }
    } else {
      if (textRef && textRef.current) {
        textRef.current.style.transform = '';
        textRef.current.style.webkitTransform = '';
        textRef.current.style.marginRight = addPx(0);
        textRef.current.style.marginLeft = addPx(0);
      }
    }
  }, [fontSize, minFontSize, textRef]);
}
export default useAdjustMiniFont;