import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import { useEffect, useState } from 'react';

function useEllipsis(ref, contentCopyRef, multiline, children) {
  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      isEllipsis = _useState2[0],
      setIsEllipsis = _useState2[1];

  useEffect(function () {
    if (!ref.current) return;

    if (multiline) {
      var _ref$current = ref.current,
          clientHeight = _ref$current.clientHeight,
          scrollHeight = _ref$current.scrollHeight;

      if (clientHeight < scrollHeight && !isEllipsis) {
        setIsEllipsis(true);
      } else if (clientHeight >= scrollHeight && isEllipsis) {
        setIsEllipsis(false);
      }
    } else if (contentCopyRef.current) {
      if (ref.current.clientWidth < contentCopyRef.current.clientWidth && !isEllipsis) {
        setIsEllipsis(true);
      } else if (ref.current.clientWidth >= contentCopyRef.current.clientWidth && isEllipsis) {
        setIsEllipsis(false);
      }
    }
  }, [isEllipsis, children, ref, multiline, contentCopyRef]);
  return isEllipsis;
}

export { useEllipsis };
export default useEllipsis;