import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import { useCallback, useState } from 'react';
export default function useRealPlacement(placement) {
  var _useState = useState(placement),
      _useState2 = _slicedToArray(_useState, 2),
      realPlacement = _useState2[0],
      setRealPlacement = _useState2[1];

  var onPopperCreate = useCallback(function (data) {
    if (data.placement !== realPlacement) {
      setRealPlacement(data.placement);
    }
  }, [realPlacement]);
  var onPopperUpdate = useCallback(function (data) {
    if (data.placement !== realPlacement) {
      setRealPlacement(data.placement);
    }
  }, [realPlacement]);
  return {
    realPlacement: realPlacement,
    onPopperCreate: onPopperCreate,
    onPopperUpdate: onPopperUpdate
  };
}