import _extends from "@babel/runtime/helpers/extends";
import { useMemo } from 'react';
import transformStyles from './transformStyles';
import useTheme from './useTheme';
/**
 * 生成样式覆盖的配置
 * @param componentName 组件名
 * @param defaultStyles 默认配置
 * @param styles prop 输入，可以不填
 */

export function useStyles(componentName, defaultStyles, styles) {
  var theme = useTheme();
  var newStyles = useMemo(function () {
    return transformStyles(theme.prefix, componentName, styles ? _extends({}, defaultStyles, styles) : defaultStyles);
  }, [componentName, defaultStyles, styles, theme.prefix]);
  return newStyles;
}
export default useStyles;