import { muyaThemeLight as _muyaThemeLight } from "@muya-ui/theme-light/es/theme";
import { withTheme as withThemeWithoutDefault } from 'styled-components';

var withTheme = function withTheme(comp) {
  // add default theme to defaultProps
  if (!comp.defaultProps) {
    comp.defaultProps = {};
  }

  comp.defaultProps.theme = _muyaThemeLight; // 非styled-component组件需要withTheme包裹，使其获得从ThemeContext拿主题的能力

  return withThemeWithoutDefault(comp);
};

var withThemeForStyled = function withThemeForStyled(comp) {
  // add default theme to defaultProps
  if (!comp.defaultProps) {
    comp.defaultProps = {};
  }

  comp.defaultProps.theme = _muyaThemeLight; // 非styled-component组件需要withTheme包裹，使其获得从ThemeContext拿主题的能力

  return comp;
};

export { withTheme, withThemeForStyled };
export default withTheme;