"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _CloseIcon2 = require("@muya-ui/theme-light/lib/icons/CloseIcon");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _ClearIcon2 = require("@muya-ui/theme-light/lib/icons/ClearIcon");

var _ReminderIcon2 = require("@muya-ui/theme-light/lib/icons/ReminderIcon");

var _InformIcon2 = require("@muya-ui/theme-light/lib/icons/InformIcon");

var _SuccessIcon2 = require("@muya-ui/theme-light/lib/icons/SuccessIcon");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _Animation = _interopRequireDefault(require("../Animation"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _addPx = _interopRequireDefault(require("../utils/addPx"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _mergeStyleItem = _interopRequireDefault(require("../utils/mergeStyleItem"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _excluded = ["children", "type", "showClose", "title", "description", "showIcon", "onClose", "visible", "styles", "size", "className", "style", "appear", "center", "timeout", "childrenAsTitle", "TransitionComponent"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  wrapper: '',
  container: '',
  icon: '',
  title: '',
  desc: '',
  close: ''
};
var Alert = (0, _memoForwardRef["default"])(function (props, ref) {
  var theme = (0, _useTheme["default"])();
  var token = theme.components.Alert;
  var children = props.children,
      _props$type = props.type,
      type = _props$type === void 0 ? 'info' : _props$type,
      showClose = props.showClose,
      title = props.title,
      description = props.description,
      _props$showIcon = props.showIcon,
      showIcon = _props$showIcon === void 0 ? token.defaultShowIcon : _props$showIcon,
      onClose = props.onClose,
      _props$visible = props.visible,
      visible = _props$visible === void 0 ? true : _props$visible,
      styles = props.styles,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      className = props.className,
      style = props.style,
      _props$appear = props.appear,
      appear = _props$appear === void 0 ? true : _props$appear,
      _props$center = props.center,
      center = _props$center === void 0 ? !!token.defaultCenter && !props.showClose : _props$center,
      timeout = props.timeout,
      childrenAsTitle = props.childrenAsTitle,
      _props$TransitionComp = props.TransitionComponent,
      TransitionComponent = _props$TransitionComp === void 0 ? _Animation["default"].Collapse : _props$TransitionComp,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var innerStyles = (0, _useStyles["default"])('alert', defaultStyles, styles);
  var wrapperStyleItem = (0, _react.useMemo)(function () {
    return (0, _mergeStyleItem["default"])({
      className: className,
      style: style
    }, innerStyles.wrapper);
  }, [className, innerStyles.wrapper, style]);
  var isControlled = ('visible' in props);
  var innerTitle = title;

  if (!title && (typeof children === 'string' || children && childrenAsTitle)) {
    innerTitle = children;
  }

  var hasTitle = !!innerTitle;
  var hasDesc = !!description; // 同时存在 title 和 desc 是两种样式

  var hasTitleAndDesc = hasTitle && hasDesc;

  var _useState = (0, _react.useState)(true),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      state = _useState2[0],
      setState = _useState2[1];

  var finalVisible = isControlled ? visible : state;
  var iconNode = (0, _react.useMemo)(function () {
    if (showIcon) {
      var typeIcon = token.typeIcon || {
        success: _SuccessIcon2.SuccessIcon,
        info: _InformIcon2.InformIcon,
        warning: _ReminderIcon2.ReminderIcon,
        error: _ClearIcon2.ClearIcon
      };
      var Icon = typeIcon[type];
      var iconBgColor = token.icon.bgColor[type];
      var fontSize = hasTitleAndDesc ? token.icon.hasTitleAndDescSize[size] : token.icon.size[size];
      return /*#__PURE__*/_react["default"].createElement(_styled.StyledIcon, (0, _extends2["default"])({}, innerStyles.icon, {
        theme: theme,
        $type: type,
        $hasTitleAndDesc: hasTitleAndDesc,
        $size: size
      }), /*#__PURE__*/_react["default"].createElement(Icon, {
        bgColor: iconBgColor,
        fontSize: (0, _addPx["default"])(fontSize)
      }));
    }
  }, [hasTitleAndDesc, innerStyles.icon, showIcon, size, theme, token.icon.bgColor, token.icon.hasTitleAndDescSize, token.icon.size, token.typeIcon, type]);
  var titleNode = (0, _react.useMemo)(function () {
    if (hasTitle) {
      return /*#__PURE__*/_react["default"].createElement(_styled.StyledTitle, (0, _extends2["default"])({}, innerStyles.title, {
        theme: theme,
        $size: size,
        $hasDesc: hasDesc,
        $type: type
      }), innerTitle);
    } else if (children) {
      return children;
    }
  }, [children, hasDesc, hasTitle, innerStyles.title, innerTitle, size, theme, type]);
  var contentNode = (0, _react.useMemo)(function () {
    if (hasDesc) {
      return /*#__PURE__*/_react["default"].createElement(_styled.StyledDesc, (0, _extends2["default"])({
        theme: theme,
        $type: type
      }, innerStyles.desc), description);
    }
  }, [description, hasDesc, innerStyles.desc, theme, type]);
  var handleClose = (0, _react.useCallback)(function () {
    if (!isControlled) {
      setState(false);
    }

    onClose && onClose();
  }, [isControlled, onClose]);
  var closeNode = (0, _react.useMemo)(function () {
    if (showClose) {
      var Icon = theme.components.Alert.closeIcon || _CloseIcon2.CloseIcon;
      var closeIconButtonSize = theme.components.Alert.closeIconButtonSize;
      return /*#__PURE__*/_react["default"].createElement(_styled.StyledClose, (0, _extends2["default"])({
        theme: theme,
        $size: size,
        $type: type,
        $hasTitleAndDesc: hasTitleAndDesc
      }, innerStyles.close), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        size: closeIconButtonSize[size],
        onClick: handleClose
      }, /*#__PURE__*/_react["default"].createElement(Icon, null)));
    }
  }, [handleClose, hasTitleAndDesc, innerStyles.close, showClose, size, theme, type]);
  return /*#__PURE__*/_react["default"].createElement(TransitionComponent, {
    "in": finalVisible,
    appear: appear,
    timeout: timeout
  }, /*#__PURE__*/_react["default"].createElement(_styled.StyledAlert, (0, _extends2["default"])({
    theme: theme,
    ref: ref,
    $hasTitle: hasTitle,
    $hasDesc: hasDesc,
    $showIcon: showIcon,
    $showClose: showClose,
    $type: type,
    $size: size,
    $center: center
  }, otherProps, wrapperStyleItem), /*#__PURE__*/_react["default"].createElement(_styled.StyledAlertContainer, innerStyles.container, iconNode, titleNode, contentNode, closeNode)));
});
var _default = Alert;
exports["default"] = _default;