"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useForkRef = require("@muya-ui/utils/lib/hooks/useForkRef");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _InlineButton = _interopRequireDefault(require("../InlineButton"));

var _Tabs = require("../Tabs");

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _context = require("./context");

var _excluded = ["index", "href", "title", "styles", "children", "onClick"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledVerticalTab = (0, _styledComponents["default"])(_Tabs.Tab).withConfig({
  displayName: "StyledVerticalTab"
})(["margin:0;& ", "{padding:0;text-align:left;}"], _InlineButton["default"]);

var StyledVerticalTabWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledVerticalTabWrapper"
})(["padding-left:", "px;"], function (props) {
  return props.theme.spacing.spec.s5;
});

var _default = (0, _memoForwardRef["default"])(function (props, ref) {
  var index = props.index,
      href = props.href,
      title = props.title,
      styles = props.styles,
      children = props.children,
      onClick = props.onClick,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var tabRef = (0, _react.useRef)(null);
  var theme = (0, _useTheme["default"])();
  var handleRef = (0, _useForkRef.forkRef)(tabRef, ref);

  var _useAnchorContext = (0, _context.useAnchorContext)(),
      disableHash = _useAnchorContext.disableHash,
      direction = _useAnchorContext.direction,
      activeLink = _useAnchorContext.activeLink,
      registerLink = _useAnchorContext.registerLink,
      unregisterLink = _useAnchorContext.unregisterLink,
      handleScrollTo = _useAnchorContext.handleScrollTo,
      updateIndicator = _useAnchorContext.updateIndicator;

  var handleClick = (0, _react.useCallback)(function (e) {
    if (index) {
      handleScrollTo(index);
    }

    if (onClick) {
      onClick(e);
    }
  }, [handleScrollTo, index, onClick]);
  (0, _react.useEffect)(function () {
    if (index) {
      registerLink(index);
    }

    return function () {
      if (index) {
        unregisterLink(index);
      }
    };
  }, [index, registerLink, unregisterLink]);
  (0, _react.useEffect)(function () {
    if (direction === 'vertical' && activeLink === index && tabRef.current) {
      var height = tabRef.current.clientHeight / 2;
      var top = tabRef.current.offsetTop + height / 2;
      updateIndicator(top, height);
    }
  }, [activeLink, direction, index, updateIndicator]);

  if (direction === 'vertical') {
    var selected = index === activeLink;
    return /*#__PURE__*/_react["default"].createElement(StyledVerticalTabWrapper, {
      theme: theme
    }, /*#__PURE__*/_react["default"].createElement(StyledVerticalTab, (0, _extends2["default"])({
      ref: handleRef,
      theme: theme,
      selected: selected,
      buttonType: "normal",
      onClick: handleClick,
      index: index,
      href: disableHash ? undefined : index
    }, other), title), children);
  }

  return /*#__PURE__*/_react["default"].createElement(_Tabs.Tab, (0, _extends2["default"])({
    ref: ref,
    onClick: handleClick,
    index: index,
    styles: styles,
    href: disableHash ? undefined : index
  }, other), title || children);
});

exports["default"] = _default;