"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Tabs = _interopRequireDefault(require("../Tabs"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _mergeStyleItem = _interopRequireDefault(require("../utils/mergeStyleItem"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _context = require("./context");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var LineIndicator = _styledComponents["default"].div.withConfig({
  displayName: "LineIndicator"
})(["", ""], function (props) {
  var theme = props.theme,
      $height = props.$height,
      $top = props.$top;
  var token = theme.components.Tabs;
  var indicator = token.indicator;
  var _theme$transition$pat = theme.transition.pattern,
      duration = _theme$transition$pat.duration,
      easing = _theme$transition$pat.easing;
  return (0, _styledComponents.css)(["position:absolute;left:0;top:0;bottom:0;height:100%;width:", "px;background:", ";z-index:2;&::before{content:'';display:block;position:absolute;left:0;width:", "px;top:", "px;height:", "px;background:", ";transition:all ", "ms ", ";}"], indicator.bgHeight, indicator.bgColor, indicator.activeHeight, $top, $height, indicator.activeColor, duration.status, easing.status);
});

var StyledVerticalTabs = _styledComponents["default"].div.withConfig({
  displayName: "StyledVerticalTabs"
})(["position:relative;"]);

var defaultStyles = {
  wrapper: '',
  indicator: ''
};

var _default = (0, _memoForwardRef["default"])(function (props, ref) {
  var _useAnchorContext = (0, _context.useAnchorContext)(),
      activeLink = _useAnchorContext.activeLink,
      direction = _useAnchorContext.direction,
      indicatorHeight = _useAnchorContext.indicatorHeight,
      indicatorTop = _useAnchorContext.indicatorTop;

  var theme = (0, _useTheme["default"])();
  var id = props.id,
      style = props.style,
      className = props.className,
      children = props.children,
      styles = props.styles;
  var innerStyles = (0, _useStyles["default"])('anchor-tabs', defaultStyles, styles);
  var wrapperStyleItem = (0, _react.useMemo)(function () {
    return (0, _mergeStyleItem["default"])({
      className: className,
      style: style
    }, innerStyles.wrapper);
  }, [className, innerStyles.wrapper, style]);

  if (direction === 'vertical') {
    return /*#__PURE__*/_react["default"].createElement(StyledVerticalTabs, (0, _extends2["default"])({
      theme: theme,
      ref: ref
    }, wrapperStyleItem, {
      id: id
    }), children, /*#__PURE__*/_react["default"].createElement(LineIndicator, (0, _extends2["default"])({
      $top: indicatorTop,
      $height: indicatorHeight,
      theme: theme
    }, innerStyles.indicator)));
  }

  return /*#__PURE__*/_react["default"].createElement(_Tabs["default"], (0, _extends2["default"])({
    ref: ref,
    index: activeLink || ''
  }, props));
});

exports["default"] = _default;