"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _Transition = _interopRequireDefault(require("react-transition-group/Transition"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _excluded = ["children", "makeStyles", "timeout", "easing", "style", "beforeEnter", "beforeExit"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// TODO: fix Transition function child props 透传问题
var BaseAnimation = (0, _memoForwardRef["default"])(function (props, ref) {
  var children = props.children,
      makeStyles = props.makeStyles,
      timeout = props.timeout,
      easing = props.easing,
      style = props.style,
      beforeEnter = props.beforeEnter,
      beforeExit = props.beforeExit,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var timeoutWithDefault = timeout || theme.transition.spec.duration.normal;
  var handleRef = (0, _useForkRef2.useForkRef)(children.ref, ref);
  var makeStyleProps = (0, _react.useMemo)(function () {
    return {
      theme: theme,
      style: style,
      easing: easing,
      timeout: timeoutWithDefault
    };
  }, [easing, style, theme, timeoutWithDefault]);
  var onEnter = (0, _react.useCallback)(function (node, isAppearing) {
    if (beforeEnter) {
      beforeEnter(node, makeStyleProps);
    }

    if (props.onEnter) {
      props.onEnter(node, isAppearing);
    }
  }, [beforeEnter, makeStyleProps, props]);
  var onExit = (0, _react.useCallback)(function (node) {
    if (beforeExit) {
      beforeExit(node, makeStyleProps);
    }

    if (props.onExit) {
      props.onExit(node);
    }
  }, [beforeExit, makeStyleProps, props]);
  return /*#__PURE__*/_react["default"].createElement(_Transition["default"], (0, _extends2["default"])({
    appear: true
  }, other, {
    style: style,
    timeout: timeoutWithDefault,
    onEnter: onEnter,
    onExit: onExit
  }), function (state) {
    return /*#__PURE__*/_react["default"].cloneElement(children, (0, _extends2["default"])({}, children.props, {
      style: (0, _extends2["default"])({}, makeStyles(state, makeStyleProps), children.props.style),
      ref: handleRef
    }));
  });
});
var _default = BaseAnimation;
exports["default"] = _default;