"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _Transition = _interopRequireDefault(require("react-transition-group/Transition"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _excluded = ["children", "timeout", "easing", "style", "onEnter", "onExit", "minHeight", "appear"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledCollapse = _styledComponents["default"].div.withConfig({
  displayName: "StyledCollapse"
})(["", ""], function (props) {
  return (0, _styledComponents.css)(["height:", "px;overflow:hidden;> div{display:flex;> div{width:100%;}}"], props.minHeight);
});

function makeStyles(state, props, wrapperRef, minHeight) {
  var transitionPattern = props.theme.transition.pattern,
      timeout = props.timeout,
      easing = props.easing;
  var wrapperHeight = wrapperRef.current ? wrapperRef.current.clientHeight : minHeight;
  var defaultStyle = {
    height: "".concat(minHeight, "px"),
    transitionProperty: 'height',
    transitionTimingFunction: easing || transitionPattern.easing.status,
    transitionDuration: "".concat(timeout, "ms")
  };
  var transitionStyles = {
    entering: {
      transitionTimingFunction: easing || transitionPattern.easing.enter,
      height: "".concat(wrapperHeight, "px")
    },
    entered: {
      height: 'auto',
      overflow: 'visible'
    },
    exiting: {
      transitionTimingFunction: easing || transitionPattern.easing.leave
    },
    exited: {// visibility: 'hidden',
    }
  };
  return (0, _extends2["default"])({}, defaultStyle, transitionStyles[state]);
}

var Collapse = (0, _memoForwardRef["default"])(function (props, ref) {
  var children = props.children,
      timeout = props.timeout,
      easing = props.easing,
      style = props.style,
      onEnterProp = props.onEnter,
      onExitProp = props.onExit,
      _props$minHeight = props.minHeight,
      minHeight = _props$minHeight === void 0 ? 0 : _props$minHeight,
      _props$appear = props.appear,
      appear = _props$appear === void 0 ? true : _props$appear,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var timeoutWithDefault = timeout || theme.transition.spec.duration.normal;
  var wrapperRef = (0, _react.useRef)(null);

  var onEnter = function onEnter(node) {
    if (node && node.style) {
      node.style.height = "".concat(minHeight, "px");
    }
    /* istanbul ignore else */


    if (onEnterProp) {
      onEnterProp(node, true);
    }
  };

  var onExit = function onExit(node) {
    var wrapperHeight = wrapperRef.current ? wrapperRef.current.clientHeight : minHeight;

    if (node && node.style) {
      node.style.height = "".concat(wrapperHeight, "px");
    }
    /* istanbul ignore else */


    if (onExitProp) {
      onExitProp(node);
    }
  };

  return /*#__PURE__*/_react["default"].createElement(_Transition["default"], (0, _extends2["default"])({
    appear: appear,
    timeout: timeoutWithDefault,
    style: style,
    onEnter: onEnter,
    onExit: onExit
  }, other), function (state) {
    return /*#__PURE__*/_react["default"].createElement(StyledCollapse, {
      className: state,
      ref: ref,
      minHeight: minHeight,
      style: (0, _extends2["default"])({}, style, makeStyles(state, {
        theme: theme,
        timeout: timeoutWithDefault,
        easing: easing
      }, wrapperRef, minHeight))
    }, /*#__PURE__*/_react["default"].createElement("div", {
      ref: wrapperRef
    }, /*#__PURE__*/_react["default"].createElement("div", null, children)));
  });
});
var _default = Collapse;
exports["default"] = _default;