"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _reflow = _interopRequireDefault(require("../utils/reflow"));

var _withAnimation = require("./withAnimation");

function makeStyles(state, props) {
  var transitionPattern = props.theme.transition.pattern,
      timeout = props.timeout,
      easing = props.easing;
  var defaultStyle = {
    opacity: 0,
    transitionProperty: 'opacity',
    transitionTimingFunction: easing || transitionPattern.easing.status,
    transitionDuration: "".concat(timeout, "ms")
  };
  var transitionStyles = {
    entering: {
      transitionTimingFunction: easing || transitionPattern.easing.enter,
      opacity: 1
    },
    entered: {
      opacity: 1
    },
    exiting: {
      transitionTimingFunction: easing || transitionPattern.easing.leave,
      opacity: 0
    },
    exited: {
      opacity: 0,
      visibility: 'hidden'
    }
  };
  return (0, _extends2["default"])({}, defaultStyle, transitionStyles[state]);
}

var beforeEnter = function beforeEnter(node) {
  (0, _reflow["default"])(node);
};

var _default = (0, _withAnimation.withAnimation)(makeStyles, {
  beforeEnter: beforeEnter
});

exports["default"] = _default;