"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _Transition = _interopRequireDefault(require("react-transition-group/Transition"));

var _reflow = _interopRequireDefault(require("../utils/reflow"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _excluded = ["children", "timeout", "easing", "direction", "minScale"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Slide = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var children = props.children,
      timeout = props.timeout,
      easing = props.easing,
      _props$direction = props.direction,
      direction = _props$direction === void 0 ? 'up' : _props$direction,
      _props$minScale = props.minScale,
      minScale = _props$minScale === void 0 ? 0.8 : _props$minScale,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var timeoutWithDefault = timeout || theme.transition.spec.duration.normal;
  var handleRef = (0, _useForkRef2.useForkRef)(children.ref, ref);
  var transitionPattern = theme.transition.pattern;
  var styleWithDirectionMap = (0, _react.useMemo)(function () {
    return {
      up: {
        "default": {
          transformOrigin: '0% 0%',
          transform: "scaleY(".concat(minScale, ")")
        },
        entering: {
          transform: 'scaleY(1)'
        },
        exiting: {
          transform: "scaleY(".concat(minScale, ")")
        }
      },
      down: {
        "default": {
          transformOrigin: '100% 100%',
          transform: "scaleY(".concat(minScale, ")")
        },
        entering: {
          transform: 'scaleY(1)'
        },
        exiting: {
          transform: "scaleY(".concat(minScale, ")")
        }
      },
      left: {
        "default": {
          transformOrigin: '0% 0%',
          transform: "scaleX(".concat(minScale, ")")
        },
        entering: {
          transform: 'scaleX(1)'
        },
        exiting: {
          transform: "scaleX(".concat(minScale, ")")
        }
      },
      right: {
        "default": {
          transformOrigin: '100% 0%',
          transform: "scaleX(".concat(minScale, ")")
        },
        entering: {
          transform: 'scaleX(1)'
        },
        exiting: {
          transform: "scaleX(".concat(minScale, ")")
        }
      }
    };
  }, [minScale]);

  function makeStyles(state, direction) {
    var defaultStyle = (0, _extends2["default"])({
      opacity: 0
    }, styleWithDirectionMap[direction]["default"]);
    var transitionStyles = {
      entering: (0, _extends2["default"])({
        opacity: 1
      }, styleWithDirectionMap[direction].entering),
      entered: {
        opacity: 1,
        transform: 'none'
      },
      exited: {
        visibility: 'hidden'
      }
    };
    return (0, _extends2["default"])({}, defaultStyle, transitionStyles[state]);
  }

  var onEnter = function onEnter(node, isAppearing) {
    // 进入动画之前，重置当前direction对应的默认状态
    if (node.style) {
      node.style.transition = 'none';
      node.style.webkitTransition = 'none';
      node.style.transform = styleWithDirectionMap[direction]["default"].transform;
      node.style.webkitTransform = styleWithDirectionMap[direction]["default"].transform;
    }

    (0, _reflow["default"])(node);
    var innerEasing = easing || transitionPattern.easing.enter; // 设置transition

    if (node.style) {
      node.style.transition = "opacity ".concat(timeoutWithDefault, "ms ").concat(innerEasing, ", transform ").concat(timeoutWithDefault, "ms ").concat(innerEasing);
      node.style.webkitTransition = "opacity ".concat(timeoutWithDefault, "ms ").concat(innerEasing, ", transform ").concat(timeoutWithDefault, "ms ").concat(innerEasing);
    }

    if (props.onEnter) {
      props.onEnter(node, isAppearing);
    }
  };

  var onExit = function onExit(node) {
    node.style.opacity = '0';
    node.style.transform = styleWithDirectionMap[direction].exiting.transform;
    node.style.webkitTransform = styleWithDirectionMap[direction].exiting.transform;
    (0, _reflow["default"])(node);
    var innerEasing = easing || transitionPattern.easing.leave;
    node.style.transition = "opacity ".concat(timeoutWithDefault, "ms ").concat(innerEasing, ",transform ").concat(timeoutWithDefault, "ms ").concat(innerEasing);
    node.style.webkitTransition = "opacity ".concat(timeoutWithDefault, "ms ").concat(innerEasing, ",transform ").concat(timeoutWithDefault, "ms ").concat(innerEasing);

    if (props.onExit) {
      props.onExit(node);
    }
  };

  return /*#__PURE__*/_react["default"].createElement(_Transition["default"], (0, _extends2["default"])({
    appear: true
  }, other, {
    timeout: timeoutWithDefault,
    onEnter: onEnter,
    onExit: onExit
  }), function (state) {
    return /*#__PURE__*/_react["default"].cloneElement(children, (0, _extends2["default"])({}, children.props, {
      style: (0, _extends2["default"])({}, makeStyles(state, direction), children.props.style),
      ref: handleRef
    }));
  });
});

var _default = Slide;
exports["default"] = _default;