"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _Input = _interopRequireDefault(require("../Input"));

var _useLocale = _interopRequireDefault(require("../Locale/useLocale"));

var _Select = require("../Select");

var _utils = require("../Select/utils");

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _AutoCompleteItem = _interopRequireDefault(require("./AutoCompleteItem"));

var _InputElement = _interopRequireDefault(require("./InputElement"));

var _excluded = ["dataSource", "children", "size", "backfill", "filterOption", "defaultActiveFirstOption", "placeholder", "styles", "className", "style"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var selectIconNode = /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);

var defaultStyles = {
  inputWrapper: 'inputWrapper'
};
var AutoComplete = (0, _memoForwardRef["default"])(function (props, ref) {
  var local = (0, _useLocale["default"])();
  var dataSource = props.dataSource,
      children = props.children,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      _props$backfill = props.backfill,
      backfill = _props$backfill === void 0 ? false : _props$backfill,
      _props$filterOption = props.filterOption,
      filterOption = _props$filterOption === void 0 ? true : _props$filterOption,
      _props$defaultActiveF = props.defaultActiveFirstOption,
      defaultActiveFirstOption = _props$defaultActiveF === void 0 ? true : _props$defaultActiveF,
      _props$placeholder = props.placeholder,
      placeholder = _props$placeholder === void 0 ? local['AutoComplete.placeholder'] : _props$placeholder,
      styles = props.styles,
      className = props.className,
      style = props.style,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var innerStyles = (0, _useStyles["default"])('auto-complete', defaultStyles, styles);
  var getInputElement = (0, _react.useCallback)(function () {
    var element = children && /*#__PURE__*/_react["default"].isValidElement(children) && children.type !== _Select.Option ? _react["default"].Children.only(children) : /*#__PURE__*/_react["default"].createElement(_Input["default"], null);
    var elementProps = (0, _extends2["default"])({}, element.props);
    delete elementProps.children;
    return /*#__PURE__*/_react["default"].createElement(_InputElement["default"], elementProps, element);
  }, [children]);
  var options = (0, _react.useMemo)(function () {
    var childArray = _react["default"].Children.toArray(children);

    if (childArray.length && (0, _utils.isSelectChildNode)(childArray[0])) {
      return children;
    } else {
      return dataSource ? dataSource.map(function (item) {
        switch ((0, _typeof2["default"])(item)) {
          case 'string':
            return /*#__PURE__*/_react["default"].createElement(_Select.Option, {
              key: item,
              value: item
            }, item);

          case 'object':
            return /*#__PURE__*/_react["default"].createElement(_Select.Option, {
              key: item.value,
              value: item.value
            }, item.label);

          default:
            throw new Error('AutoComplete[dataSource] only supports type `string[] | Object[]`.');
        }
      }) : [];
    }
  }, [children, dataSource]);
  return /*#__PURE__*/_react["default"].createElement(_Select.Select, (0, _extends2["default"])({}, restProps, {
    className: [innerStyles.inputWrapper.className, className].join(' ').trim(),
    style: (0, _extends2["default"])({}, innerStyles.inputWrapper.style, style),
    size: size,
    backfill: backfill,
    filterOption: filterOption,
    defaultActiveFirstOption: defaultActiveFirstOption,
    placeholder: placeholder,
    ref: ref,
    mode: "default",
    showSearch: true,
    labelInValue: false,
    reservedSearchResult: false,
    hideExpandIcon: true,
    selectedIcon: selectIconNode,
    getInputElement: getInputElement,
    combobox: true
  }), options);
});
AutoComplete.__MUYA_AUTOCOMPLETE = true;
AutoComplete.Option = _Select.Option;
AutoComplete.OptionDivider = _Select.OptionDivider;
AutoComplete.OptionGroup = _Select.OptionGroup;
AutoComplete.Item = _AutoCompleteItem["default"];
var _default = AutoComplete;
exports["default"] = _default;