"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _devWarning2 = require("@muya-ui/utils/lib/utils/devWarning");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _utils = require("@muya-ui/theme-light/lib/utils");

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _addPx = _interopRequireDefault(require("../utils/addPx"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _excluded = ["type", "component", "display", "backgroundColor", "width", "height", "color", "borderRadius"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function baseCSS(_ref) {
  var $display = _ref.$display,
      $width = _ref.$width,
      $backgroundColor = _ref.$backgroundColor,
      $color = _ref.$color,
      $height = _ref.$height,
      _ref$$type = _ref.$type,
      $type = _ref$$type === void 0 ? 'global' : _ref$$type,
      $borderRadius = _ref.$borderRadius,
      theme = _ref.theme;
  var backgroundColor;

  if ($backgroundColor) {
    backgroundColor = $backgroundColor;
  } else {
    if ($type === 'mask') {
      backgroundColor = _utils.colorUtils.transparentize(theme.opacity.pattern.mask, theme.colors.pattern.background.mask);
    } else {
      backgroundColor = theme.colors.pattern.background[$type];
    }
  }

  var color = $color || theme.colors.pattern.text.text;
  return (0, _styledComponents.css)({
    display: $display,
    backgroundColor: backgroundColor,
    color: color,
    width: (0, _addPx["default"])($width),
    height: (0, _addPx["default"])($height),
    borderRadius: (0, _addPx["default"])($borderRadius)
  });
}

var RootDiv = _styledComponents["default"].div.withConfig({
  displayName: "RootDiv"
})(["", ""], baseCSS);

var RootSpan = _styledComponents["default"].div.withConfig({
  displayName: "RootSpan"
})(["", ""], baseCSS);

var Background = (0, _memoForwardRef["default"])(function (props, ref) {
  var type = props.type,
      component = props.component,
      display = props.display,
      backgroundColor = props.backgroundColor,
      width = props.width,
      height = props.height,
      color = props.color,
      borderRadius = props.borderRadius,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var Root = component === 'span' ? RootSpan : RootDiv;
  (0, _devWarning2.devWarning)('[Background]: type scrollBar and scrollBarHover is deprecated, will removed in 1.0.0', type === 'scrollBar' || type === 'scrollBarHover');
  return /*#__PURE__*/_react["default"].createElement(Root, (0, _extends2["default"])({}, other, {
    $type: type,
    $color: color,
    $display: display,
    $width: width,
    $height: height,
    $backgroundColor: backgroundColor,
    $borderRadius: borderRadius,
    theme: theme,
    ref: ref
  }));
});
var _default = Background;
exports["default"] = _default;