"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useAdjustMiniFont = _interopRequireDefault(require("../utils/useAdjustMiniFont"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _utils = require("./utils");

var _excluded = ["dot", "isStroke", "showZero", "detached", "value", "color", "size", "max", "styles", "children"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Badge = (0, _memoForwardRef["default"])(function (props, ref) {
  var _props$dot = props.dot,
      dot = _props$dot === void 0 ? false : _props$dot,
      _props$isStroke = props.isStroke,
      isStroke = _props$isStroke === void 0 ? false : _props$isStroke,
      _props$showZero = props.showZero,
      showZero = _props$showZero === void 0 ? false : _props$showZero,
      _props$detached = props.detached,
      detached = _props$detached === void 0 ? false : _props$detached,
      value = props.value,
      color = props.color,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      _props$max = props.max,
      max = _props$max === void 0 ? 99 : _props$max,
      styles = props.styles,
      children = props.children,
      rest = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var token = theme.components.Badge;
  var fontSize = token.fontSize[size];
  var textRef = (0, _react.useRef)(null);
  var defaultStyles = (0, _react.useMemo)(function () {
    return {
      container: '',
      badge: ''
    };
  }, []);
  var innerStyles = (0, _useStyles["default"])('badge', defaultStyles, styles);
  var styledBadgeProps = (0, _react.useMemo)(function () {
    return {
      theme: theme,
      $detached: detached,
      $isStroke: isStroke,
      $value: value,
      $showZero: showZero,
      $dot: dot,
      $size: size,
      $color: color,
      $text: ''
    };
  }, [color, detached, dot, isStroke, showZero, size, theme, value]);
  var innerText = (0, _react.useMemo)(function () {
    if (dot) {
      return '';
    }

    var displayText = (0, _utils.getDisplayText)(value, max); // 12px 以下的字需要 transform 一下

    if (fontSize < 12) {
      return /*#__PURE__*/_react["default"].createElement(_styled.StyledBadgeInnerText, {
        ref: textRef,
        theme: theme
      }, displayText);
    }

    return displayText;
  }, [dot, fontSize, max, theme, value]);
  (0, _useAdjustMiniFont["default"])(textRef, fontSize);
  var finalChildren = (0, _react.useMemo)(function () {
    return children ? /*#__PURE__*/_react["default"].createElement(_styled.StyledBadgeContainer, innerStyles.container, /*#__PURE__*/_react["default"].createElement(_styled.StyledBadge, (0, _extends2["default"])({
      ref: ref
    }, styledBadgeProps, innerStyles.badge, rest), innerText), children) : /*#__PURE__*/_react["default"].createElement(_styled.StyledIndependentBadge, (0, _extends2["default"])({
      ref: ref
    }, styledBadgeProps, innerStyles.badge, rest), innerText);
  }, [children, innerStyles.badge, innerStyles.container, innerText, ref, rest, styledBadgeProps]);
  return finalChildren;
});
var _default = Badge;
exports["default"] = _default;