"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledIndependentBadge = exports.StyledBadgeInnerText = exports.StyledBadgeContainer = exports.StyledBadge = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var badgePositionCSS = function badgePositionCSS(props) {
  var theme = props.theme,
      $detached = props.$detached,
      $value = props.$value,
      $showZero = props.$showZero,
      $dot = props.$dot;
  var _theme$components$Bad = theme.components.Badge,
      offset = _theme$components$Bad.offset,
      zIndex = _theme$components$Bad.zIndex;
  var visible = $value || $showZero || $dot;
  var scaleCSS = "scale(".concat(visible ? 1 : 0, ")");
  var positionCSS;

  if ($detached) {
    positionCSS = "\n      top: 50%;\n      left: 100%;\n      transform: translate(".concat(offset, "px, -50%) ").concat(scaleCSS, ";\n    ");
  } else {
    positionCSS = "\n      top: 0;\n      right: 0;\n      transform: translate(50%, -50%) ".concat(scaleCSS, ";\n    ");
  }

  return (0, _styledComponents.css)(["position:absolute;", " z-index:", ";"], positionCSS, zIndex);
};

var badgeCoreCSS = function badgeCoreCSS(props) {
  var theme = props.theme,
      $size = props.$size,
      $dot = props.$dot,
      $isStroke = props.$isStroke,
      $color = props.$color;
  var token = theme.components.Badge,
      _theme$transition$pat = theme.transition.pattern,
      duration = _theme$transition$pat.duration,
      easing = _theme$transition$pat.easing;
  var height;
  var padding;

  if ($dot) {
    height = token.height.dot[$size];
    padding = 0;
  } else {
    height = token.height.text[$size];
    padding = token.padding[$size];
  }

  var fontSize = token.fontSize[$size];
  var borderColor = token.borderColor;
  var lineHeight = $isStroke ? height - 2 : height;
  var color = $isStroke ? token.borderColor : token.color;
  var backgroundColor = $color || token.backgroundColor[$isStroke ? 'stroke' : 'fill'];
  return (0, _styledComponents.css)(["display:inline-block;height:", "px;line-height:", "px;text-align:center;padding:0 ", "px;color:", ";font-size:", "px;background-color:", ";border:", ";border-radius:", "px;white-space:nowrap;transform-origin:center center;transition:all ", "ms ", ";", ";"], height, lineHeight, padding, color, fontSize, backgroundColor, $isStroke ? "1px solid ".concat(borderColor) : 'none', height / 2, duration.status, easing.status, $dot && "width: ".concat(height, "px"));
};

var StyledBadge = _styledComponents["default"].span.withConfig({
  displayName: "StyledBadge"
})(["", " ", ""], badgePositionCSS, badgeCoreCSS);

exports.StyledBadge = StyledBadge;

var StyledIndependentBadge = _styledComponents["default"].span.withConfig({
  displayName: "StyledIndependentBadge"
})(["", ""], badgeCoreCSS); // used for mock font-size less than 12px in chrome


exports.StyledIndependentBadge = StyledIndependentBadge;

var StyledBadgeInnerText = _styledComponents["default"].span.withConfig({
  displayName: "StyledBadgeInnerText"
})(["display:inline-block;font-style:normal;vertical-align:top;transform-origin:center center;"]);

exports.StyledBadgeInnerText = StyledBadgeInnerText;

var StyledBadgeContainer = _styledComponents["default"].span.withConfig({
  displayName: "StyledBadgeContainer"
})(["display:inline-block;position:relative;"]);

exports.StyledBadgeContainer = StyledBadgeContainer;