"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _utils = require("./utils");

var _excluded = ["maxItemCountPerPage", "width", "size", "children", "onScroll", "noShadow"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Menu = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var maxItemCountPerPage = props.maxItemCountPerPage,
      width = props.width,
      size = props.size,
      children = props.children,
      onScroll = props.onScroll,
      noShadow = props.noShadow,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var hasScrollBar = (0, _react.useMemo)(function () {
    if (maxItemCountPerPage) {
      var count = (0, _utils.getMenuItemCountFromChildren)(children);
      return count > maxItemCountPerPage;
    } else {
      return false;
    }
  }, [children, maxItemCountPerPage]);
  var wrapperWidth = (0, _react.useMemo)(function () {
    if (width && (0, _typeof2["default"])(width) === 'object') {
      return width[size];
    } else {
      return width;
    }
  }, [size, width]);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledBaseMenu, (0, _extends2["default"])({
    ref: ref,
    theme: theme,
    $size: size,
    $width: wrapperWidth,
    $hasScrollBar: hasScrollBar,
    $maxItemCountPerPage: maxItemCountPerPage,
    $noShadow: noShadow
  }, restProps), /*#__PURE__*/_react["default"].createElement(_styled.StyledBaseMenuWrapper, {
    onScroll: onScroll
  }, children));
});

Menu.defaultProps = {
  size: 'm'
};

var _default = /*#__PURE__*/_react["default"].memo(Menu);

exports["default"] = _default;