"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _SelectIcon2 = require("@muya-ui/theme-light/lib/icons/SelectIcon");

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _reactIs = require("react-is");

var _Checkbox = require("../Checkbox");

var _Spin = _interopRequireDefault(require("../Spin"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _scrollIntoView = _interopRequireDefault(require("../utils/scrollIntoView"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _excluded = ["size", "children", "selected", "disabled", "active", "loading", "checkable", "loadingIcon", "selectedIcon", "onClick"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var MenuItem = (0, _memoForwardRef["default"])(function (props, ref) {
  var _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      children = props.children,
      _props$selected = props.selected,
      selected = _props$selected === void 0 ? false : _props$selected,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      _props$active = props.active,
      active = _props$active === void 0 ? false : _props$active,
      _props$loading = props.loading,
      loading = _props$loading === void 0 ? false : _props$loading,
      _props$checkable = props.checkable,
      checkable = _props$checkable === void 0 ? false : _props$checkable,
      loadingIcon = props.loadingIcon,
      selectedIcon = props.selectedIcon,
      onClick = props.onClick,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var itemRef = (0, _react.useRef)(null);
  var handleRef = (0, _useForkRef2.useForkRef)(ref, itemRef);
  var token = theme.components.BaseMenu;
  var suffixIconNode;
  var SuffixIcon;

  if (loading) {
    suffixIconNode = loadingIcon || /*#__PURE__*/_react["default"].createElement(_Spin["default"], {
      style: {
        flexShrink: 0,
        marginLeft: token.iconMarginLeft,
        color: token.iconColor
      }
    });
  } else if (selected && !checkable) {
    SuffixIcon = token.selectedIcon || _SelectIcon2.SelectIcon;
    suffixIconNode = selectedIcon || /*#__PURE__*/_react["default"].createElement(SuffixIcon, {
      style: {
        flexShrink: 0,
        marginLeft: token.iconMarginLeft,
        color: token.iconColor
      }
    });
  }

  var finalChildren = (0, _react.useMemo)(function () {
    return (0, _reactIs.isElement)(children) ? /*#__PURE__*/(0, _react.cloneElement)(children, {
      size: size,
      theme: theme
    }) : /*#__PURE__*/_react["default"].createElement("span", null, children);
  }, [children, size, theme]);
  (0, _react.useEffect)(function () {
    if (active && itemRef.current) {
      (0, _scrollIntoView["default"])(itemRef.current, {
        onlyFirstScrollableParent: true,
        behavior: 'auto',
        isScrollable: function isScrollable(element) {
          return getComputedStyle(element).overflowY === 'auto';
        },
        align: {
          top: 0.5
        }
      });
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [active]);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledBaseMenuItem, (0, _extends2["default"])({
    ref: handleRef,
    theme: theme,
    $size: size,
    $active: active,
    $selected: selected,
    $checkable: checkable,
    $disabled: disabled,
    onClick: onClick
  }, restProps), checkable ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Checkbox.Checkbox, {
    checked: selected,
    onClick: onClick,
    disabled: disabled
  }), finalChildren) : finalChildren, suffixIconNode);
});
MenuItem.displayName = 'MenuItem';
var _default = MenuItem;
exports["default"] = _default;