"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.menuItemCss = exports.baseMenuCss = exports.StyledBaseMenuWrapper = exports.StyledBaseMenuItemGroupLabel = exports.StyledBaseMenuItemGroup = exports.StyledBaseMenuItemDivider = exports.StyledBaseMenuItem = exports.StyledBaseMenu = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _styled = require("../Checkbox/styled");

var _styled2 = require("../ScrollView/styled");

var _ellipsis = _interopRequireDefault(require("../styled/mixins/ellipsis"));

var _item = require("../styled/mixins/item");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var menuItemCss = function menuItemCss(props) {
  var $size = props.$size,
      $active = props.$active,
      $selected = props.$selected,
      $disabled = props.$disabled,
      $checkable = props.$checkable,
      _props$theme = props.theme,
      spacing = _props$theme.spacing,
      _props$theme$transiti = _props$theme.transition.pattern,
      duration = _props$theme$transiti.duration,
      easing = _props$theme$transiti.easing;
  var token = props.theme.components.BaseMenu.item;
  return (0, _styledComponents.css)(["display:flex;justify-content:", ";align-items:center;flex:1;box-sizing:border-box;padding:0 ", "px;font-size:", "px;line-height:", "px;height:", "px;cursor:pointer;transition:background-color ", "ms ", ",color ", "ms ", ";", " span{", "}", "{margin-right:", "px;}", " ", " ", ""], $checkable ? 'flex-start' : 'space-between', token.paddingHorizontal, token.fontSize[$size], token.height[$size], token.height[$size], duration.status, easing.status, duration.status, easing.status, (0, _item.itemNormalStyle)(token), _ellipsis["default"], _styled.StyledCheckboxLabel, spacing.spec.s4, $active && (0, _styledComponents.css)(["color:", ";background-color:", ";&:hover{color:", ";background-color:", ";}&:active{color:", ";background-color:", ";}"], token.color.hover, token.background.hover, token.color.hover, token.background.hover, token.color.hover, token.background.hover), $selected && (0, _item.itemSelectedStyle)(token), $disabled && (0, _item.itemDisabledStyle)(token));
};

exports.menuItemCss = menuItemCss;

var StyledBaseMenuItem = _styledComponents["default"].div.withConfig({
  displayName: "StyledBaseMenuItem"
})(["", ";"], menuItemCss);

exports.StyledBaseMenuItem = StyledBaseMenuItem;

var StyledBaseMenuItemGroupLabel = _styledComponents["default"].span.withConfig({
  displayName: "StyledBaseMenuItemGroupLabel"
})(["display:flex;justify-content:space-between;align-items:center;box-sizing:border-box;cursor:default;"]);

exports.StyledBaseMenuItemGroupLabel = StyledBaseMenuItemGroupLabel;

var StyledBaseMenuItemGroup = _styledComponents["default"].div.withConfig({
  displayName: "StyledBaseMenuItemGroup"
})([""]);

exports.StyledBaseMenuItemGroup = StyledBaseMenuItemGroup;

var StyledBaseMenuItemDivider = _styledComponents["default"].div.withConfig({
  displayName: "StyledBaseMenuItemDivider"
})(["height:1px;"]);

exports.StyledBaseMenuItemDivider = StyledBaseMenuItemDivider;

var StyledBaseMenuWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledBaseMenuWrapper"
})(["overflow-y:auto;"]);

exports.StyledBaseMenuWrapper = StyledBaseMenuWrapper;

var baseMenuCss = function baseMenuCss(props) {
  var $size = props.$size,
      $width = props.$width,
      $hasScrollBar = props.$hasScrollBar,
      $maxItemCountPerPage = props.$maxItemCountPerPage,
      $noShadow = props.$noShadow,
      _props$theme2 = props.theme,
      colors = _props$theme2.colors,
      shadows = _props$theme2.shadows;
  var token = props.theme.components.BaseMenu;
  var wrapperToken = token.wrapper,
      itemToken = token.item,
      dividerToken = token.divider,
      groupToken = token.group;
  return (0, _styledComponents.css)(["background:", ";border-radius:", ";padding:", "px 0;overflow:hidden;", ";", ";", ";:focus{outline:none;}", "{", ";", "}", "{background:", ";margin:", "px ", "px ", "px ", "px;}", "{font-size:", "px;line-height:", "px;height:", "px;background:", ";color:", ";padding-left:", "px;margin-top:", "px;}"], colors.pattern.background.higher, wrapperToken.borderRadius, wrapperToken.paddingVertical, !$noShadow && "box-shadow: ".concat(shadows.pattern.popper.normal), $width && "width: ".concat($width, "px"), $hasScrollBar && "padding-right: ".concat(wrapperToken.paddingRight, "px"), StyledBaseMenuWrapper, $maxItemCountPerPage && "max-height: ".concat($maxItemCountPerPage * itemToken.height[$size], "px"), $hasScrollBar && (0, _styledComponents.css)(["padding-right:", "px;", ";"], wrapperToken.innerPaddingRight, (0, _styled2.scrollBarStyle)(props)), StyledBaseMenuItemDivider, colors.pattern.background.divider, dividerToken.paddingVertical, $hasScrollBar ? 0 : dividerToken.paddingRight, dividerToken.paddingVertical, dividerToken.paddingLeft[$size], StyledBaseMenuItemGroupLabel, groupToken.fontSize, groupToken.height, groupToken.height, groupToken.background, groupToken.color, groupToken.paddingLeft[$size], groupToken.marginTop);
};

exports.baseMenuCss = baseMenuCss;

var StyledBaseMenu = _styledComponents["default"].div.withConfig({
  displayName: "StyledBaseMenu"
})(["", ";"], baseMenuCss);

exports.StyledBaseMenu = StyledBaseMenu;