"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isMenuItem = exports.getMenuItemCountFromChildren = exports.getChildType = void 0;

var _react = _interopRequireDefault(require("react"));

var getChildType = function getChildType(child) {
  if (child.type && child.type.displayName) {
    return child.type.displayName;
  }

  return '';
};

exports.getChildType = getChildType;

var isMenuItem = function isMenuItem(type) {
  return type === 'MenuItem';
};
/* eslint-disable no-param-reassign */


exports.isMenuItem = isMenuItem;

var getMenuItemCountFromChildren = function getMenuItemCountFromChildren(children) {
  var count = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

  _react["default"].Children.forEach(children, function (child) {
    if (!child) {
      return;
    }

    var type = getChildType(child);

    if (isMenuItem(type)) {
      count += 1;
    } else if (child && child.props && _react["default"].Children.count(child.props.children) > 0) {
      count += getMenuItemCountFromChildren(child.props.children);
    }
  });

  return count;
};

exports.getMenuItemCountFromChildren = getMenuItemCountFromChildren;