"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _GuildRightIcon2 = require("@muya-ui/theme-light/lib/icons/GuildRightIcon");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Dropdown = _interopRequireDefault(require("../Dropdown"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _InlineButton = _interopRequireDefault(require("../InlineButton"));

var _Menu = require("../Menu");

var _array = require("../utils/array");

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _withTheme = require("../utils/withTheme");

var _styled = require("./styled");

var _excluded = ["key", "style"],
    _excluded2 = ["url", "label"],
    _excluded3 = ["size", "fontWeight", "separators", "children", "items", "headItem", "styles", "maxNode", "ellipsisRule"],
    _excluded4 = ["label", "url"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultPreCount = 1;
var defaultSuffixCount = 2;

var DropdownContainer = function DropdownContainer(_ref) {
  var children = _ref.children,
      size = _ref.size;
  return /*#__PURE__*/_react["default"].createElement(_Dropdown["default"], {
    size: size,
    overlay: /*#__PURE__*/_react["default"].createElement(_Menu.Menu, null, children)
  }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
    size: size
  }, /*#__PURE__*/_react["default"].createElement(_styled.StyledMoreIcon, null)));
};

var genEllipsisChildrenNode = function genEllipsisChildrenNode(size, children) {
  return /*#__PURE__*/_react["default"].createElement(DropdownContainer, {
    size: size
  }, children.map(function (child, index) {
    var props = child.props || {};
    var key = props.key,
        _props$style = props.style,
        style = _props$style === void 0 ? {} : _props$style,
        otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
    return /*#__PURE__*/_react["default"].createElement(_Menu.MenuItem, {
      key: key || index
    }, /*#__PURE__*/_react["default"].cloneElement(child, (0, _extends2["default"])({
      style: (0, _extends2["default"])({
        width: '100%',
        justifyContent: 'flex-start'
      }, style),
      size: size
    }, otherProps)));
  }));
};

var genEllipsisPropNode = function genEllipsisPropNode(size, items) {
  return /*#__PURE__*/_react["default"].createElement(DropdownContainer, {
    size: size
  }, items.map(function (item, index) {
    var url = item.url,
        label = item.label,
        otherProps = (0, _objectWithoutProperties2["default"])(item, _excluded2);
    return /*#__PURE__*/_react["default"].createElement(_Menu.MenuItem, {
      key: index
    }, /*#__PURE__*/_react["default"].createElement(_InlineButton["default"], (0, _extends2["default"])({}, otherProps, {
      fontWeight: "lighter",
      type: "secondary",
      href: item.url,
      size: size
    }), item.label));
  }));
};

var defaultStyles = {
  item: '',
  headSeparator: '',
  separator: ''
};
var BreadcrumbsPure = (0, _memoForwardRef["default"])(function (props, ref) {
  var _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      fontWeightProp = props.fontWeight,
      separators = props.separators,
      children = props.children,
      items = props.items,
      headItem = props.headItem,
      styles = props.styles,
      _props$maxNode = props.maxNode,
      maxNode = _props$maxNode === void 0 ? 4 : _props$maxNode,
      _props$ellipsisRule = props.ellipsisRule,
      ellipsisRule = _props$ellipsisRule === void 0 ? [defaultPreCount, defaultSuffixCount] : _props$ellipsisRule,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded3);
  var theme = (0, _useTheme["default"])();
  var token = theme.components.Breadcrumbs;
  var DefaultSeparator = token.separator || _GuildRightIcon2.GuildRightIcon;

  var childNum = _react["default"].Children.count(children);

  var separatorSize = token.separatorSize[size];
  var innerStyles = (0, _useStyles["default"])('breadcrumbs', defaultStyles, styles);
  var innerSeparators = (0, _react.useMemo)(function () {
    if (!separators && headItem) {
      return ['|', '>'];
    }

    return separators || ['>'];
  }, [headItem, separators]);
  var innerItems = (0, _react.useMemo)(function () {
    if (headItem && items) {
      items.unshift(headItem);
    }

    return items;
  }, [headItem, items]);
  var renderSeparator = (0, _react.useCallback)(function (key) {
    if (key === '|') {
      return /*#__PURE__*/_react["default"].createElement(_styled.SeparatorHeadWrapper, innerStyles.headSeparator, /*#__PURE__*/_react["default"].createElement(_styled.StyledHeadSeparator, null));
    } else if (key === '>') {
      return /*#__PURE__*/_react["default"].createElement(_styled.SeparatorWrapper, innerStyles.separator, /*#__PURE__*/_react["default"].createElement(DefaultSeparator, {
        style: {
          width: separatorSize,
          height: separatorSize
        }
      }));
    }

    return key;
  }, [innerStyles.headSeparator, innerStyles.separator, separatorSize]);
  var separatorLastIndex = innerSeparators.length - 1;
  var finalNode = (0, _react.useMemo)(function () {
    if (childNum) {
      var childrenArr = _react["default"].Children.toArray(children); // 省略的相关处理


      if (childrenArr.length > maxNode) {
        (0, _array.arraySpliceWithFn)(childrenArr, ellipsisRule[0] || defaultPreCount, ellipsisRule[1] || defaultSuffixCount, genEllipsisChildrenNode.bind(null, size));
      }

      return childrenArr.map(function (child, childIndex) {
        if (! /*#__PURE__*/_react["default"].isValidElement(child)) {
          return null;
        }

        var isLast = childIndex === childrenArr.length - 1;

        var cloneNode = /*#__PURE__*/_react["default"].cloneElement(child, (0, _extends2["default"])({
          size: size,
          fontWeight: isLast ? token.currentFontWeight : fontWeightProp || 'lighter'
        }, child.props));

        var innerNode;

        if (!isLast) {
          var separatorKey = innerSeparators[childIndex] || innerSeparators[separatorLastIndex];
          innerNode = renderSeparator(separatorKey);
        }

        return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
          key: childIndex
        }, cloneNode, innerNode);
      });
    } else if (innerItems && innerItems.length) {
      // 省略的相关处理
      if (innerItems.length > maxNode) {
        (0, _array.arraySpliceWithFn)(innerItems, ellipsisRule[0] || defaultPreCount, ellipsisRule[1] || defaultSuffixCount, genEllipsisPropNode.bind(null, size));
      }

      return innerItems.map(function (item, itemIndex) {
        var innerNode;
        var isLast = itemIndex === innerItems.length - 1;

        if (!isLast) {
          var separatorKey = innerSeparators[itemIndex] || innerSeparators[separatorLastIndex];
          innerNode = renderSeparator(separatorKey);
        } // 如果是React节点则是省略号节点, 只需要处理下separator


        if ( /*#__PURE__*/_react["default"].isValidElement(item)) {
          return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
            key: itemIndex
          }, item, innerNode);
        } else {
          var itemLabel = item.label,
              itemUrl = item.url,
              otherItemProps = (0, _objectWithoutProperties2["default"])(item, _excluded4);
          var href;
          var buttonType = 'strong';
          var fontWeight = fontWeightProp || token.currentFontWeight;
          var constant = isLast;

          if (!isLast) {
            href = itemUrl;
            buttonType = 'secondary';
            fontWeight = 'lighter';
          }

          return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
            key: itemIndex
          }, /*#__PURE__*/_react["default"].createElement(_InlineButton["default"], (0, _extends2["default"])({}, innerStyles.item, otherItemProps, {
            fontWeight: fontWeight,
            type: buttonType,
            constant: constant,
            size: size,
            href: href
          }), itemLabel), innerNode);
        }
      });
    }
  }, [childNum, children, ellipsisRule, fontWeightProp, innerItems, innerSeparators, innerStyles.item, maxNode, renderSeparator, separatorLastIndex, size, token.currentFontWeight]);
  return /*#__PURE__*/_react["default"].createElement(_styled.BaseNode, (0, _extends2["default"])({}, otherProps, {
    ref: ref
  }), finalNode);
});
var BreadcrumbsWithoutDefaultTheme = (0, _styledComponents["default"])(BreadcrumbsPure).withConfig({
  displayName: "BreadcrumbsWithoutDefaultTheme"
})(["position:relative;display:flex;align-items:center;", ""], function (props) {
  var size = props.size || 'm';
  var token = props.theme.components.Breadcrumbs;
  var btnToken = props.theme.components.Button;
  var separatorSize = token.separatorSize[size];
  return (0, _styledComponents.css)(["color:", ";& ", "{width:", "px;}& ", "{width:", "px;}& ", "{border-left:1px solid ", ";height:", "px;}& ", "{font-size:", "px;}"], token.separatorColor, _styled.SeparatorHeadWrapper, token.separatorHeadWidth, _styled.SeparatorWrapper, token.separatorWidth, _styled.StyledHeadSeparator, token.separatorColor, separatorSize, _styled.StyledMoreIcon, btnToken.fontSize[size]);
});
var Breadcrumbs = (0, _withTheme.withThemeForStyled)(BreadcrumbsWithoutDefaultTheme);
var _default = Breadcrumbs;
exports["default"] = _default;