"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.StyledButton = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _utils = require("@muya-ui/theme-light/lib/utils");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _withTheme = require("../utils/withTheme");

var _ButtonCore = _interopRequireDefault(require("./ButtonCore"));

var _mixins = require("./mixins");

var _useBtnAutoLoading3 = _interopRequireDefault(require("./useBtnAutoLoading"));

var _excluded = ["type", "block", "groupType", "offBorder", "plain", "selected", "outline", "lightShadow"],
    _excluded2 = ["loading", "autoLoading", "onClick"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var ButtonPure = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var type = props.type,
      block = props.block,
      groupType = props.groupType,
      offBorder = props.offBorder,
      plain = props.plain,
      selected = props.selected,
      outline = props.outline,
      lightShadow = props.lightShadow,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  return /*#__PURE__*/_react["default"].createElement(_ButtonCore["default"], (0, _extends2["default"])({
    ref: ref
  }, otherProps));
});

var buttonInGroupCss = function buttonInGroupCss(groupType) {
  return (0, _styledComponents.css)(["", " ", ""], groupType === 'head' && (0, _styledComponents.css)(["border-top-right-radius:0;border-bottom-right-radius:0;"]), groupType === 'tail' && (0, _styledComponents.css)(["border-top-left-radius:0;border-bottom-left-radius:0;margin-left:-1px;"]));
};

function mergeCSSConfig(a, b) {
  return {
    style: (0, _extends2["default"])({}, a.style, b.style),
    hoverStyle: (0, _extends2["default"])({}, a.hoverStyle, b.hoverStyle),
    clickStyle: (0, _extends2["default"])({}, a.clickStyle, b.clickStyle)
  };
}

var buttonBorderCSS = function buttonBorderCSS(props) {
  var outline = props.outline,
      groupType = props.groupType,
      offBorder = props.offBorder,
      busyOrLoading = props.busyOrLoading;
  var groupCSSObj = {}; // 面性的按钮在 ButtonGroup 中需要设置 border

  if (!outline && groupType) {
    if (groupType !== 'tail') {
      groupCSSObj.borderRightWidth = '1px';
      groupCSSObj.borderRightStyle = 'solid';
    }

    if (groupType !== 'head') {
      groupCSSObj.borderLeftWidth = '1px';
      groupCSSObj.borderLeftStyle = 'solid';
    }
  } // 在 busy 或者 loading 时整体会有透明度，导致中间的border颜色变深
  // 需要处理一下


  if (busyOrLoading) {
    if (offBorder === 'both' || offBorder === 'right') {
      groupCSSObj.borderRightColor = 'transparent';
    }

    if (offBorder === 'both' || offBorder === 'left') {
      groupCSSObj.borderLeftColor = 'transparent';
    }
  }

  var noBorderGroupCSS = (0, _styledComponents.css)(groupCSSObj);
  var borderCss;

  if (outline) {
    borderCss = (0, _styledComponents.css)(["border-style:solid;border-width:1px;"]);
  } else {
    borderCss = (0, _styledComponents.css)(["border-width:0;"]);
  }

  return (0, _styledComponents.css)(["", " ", ""], borderCss, noBorderGroupCSS);
};
/* eslint-disable complexity */


function getOneTypeOfButton(props) {
  var theme = props.theme,
      type = props.type,
      interactive = props.interactive,
      outline = props.outline,
      lightShadow = props.lightShadow;
  var _theme$components$But = theme.components.Button,
      typeColor = _theme$components$But.typeColor,
      defaultColor = _theme$components$But.defaultColor,
      typeBgImage = _theme$components$But.typeBgImage,
      statusOpacity = _theme$components$But.statusOpacity,
      textColor = _theme$components$But.textColor,
      lightTypeColor = _theme$components$But.lightTypeColor,
      plainColorHighlight = _theme$components$But.plainColorHighlight,
      typeBorderColor = _theme$components$But.borderColor,
      typeBgColor = _theme$components$But.typeBgColor,
      maskStatusOpacity = _theme$components$But.maskStatusOpacity,
      lightMaskColor = _theme$components$But.lightMaskColor;
  var plain = outline || lightShadow;
  var currentBgImage = typeBgImage[type];
  var currentColor = typeColor[type];
  var currentLightColor = lightTypeColor[type];
  var currentBgColor = typeBgColor[type];
  var currentTypeUseBgImage = !!currentBgImage;
  var borderColor; // 当是面性的按钮时，在 ButtonGroup 中是有 border 的
  // 需要设置 borderColor

  if (lightShadow) {
    borderColor = currentLightColor.hover;
  } else if (outline) {
    borderColor = typeBorderColor[type];
  } else {
    borderColor = currentColor.hover;
  }

  var color;

  if (plain) {
    color = currentColor.normal;
  } else if (textColor[type]) {
    color = textColor[type];
  } else {
    color = defaultColor;
  }

  var bgColor;

  if (lightShadow) {
    bgColor = currentLightColor.normal;
  } else if (outline) {
    bgColor = 'transparent';
  } else if (currentBgColor) {
    bgColor = currentBgColor.normal;
  } else {
    bgColor = currentColor.normal;
  }

  var hoverColor;
  var hoverBackgroundImage;
  var hoverBackgroundColor;
  var hoverBorderColor;
  var clickColor;
  var clickBackgroundImage;
  var clickBackgroundColor;
  var clickBorderColor;

  if (interactive) {
    if (lightShadow) {
      if (type === 'mask') {
        hoverBackgroundColor = _utils.colorUtils.transparentize(maskStatusOpacity.hover, color);
        clickBackgroundColor = _utils.colorUtils.transparentize(maskStatusOpacity.click, color);
      } else {
        bgColor = _utils.colorUtils.transparentize(statusOpacity.normal, color);
        hoverBackgroundColor = _utils.colorUtils.transparentize(statusOpacity.hover, color);
        clickBackgroundColor = _utils.colorUtils.transparentize(statusOpacity.click, color);
      }
    } else if (outline) {
      hoverBackgroundColor = currentLightColor.hover;
      clickBackgroundColor = currentLightColor.click;
    } else if (currentTypeUseBgImage) {
      hoverBackgroundImage = currentBgImage.hover;
      clickBackgroundImage = currentBgImage.click;
    } else if (currentBgColor) {
      hoverBackgroundColor = currentBgColor.hover;
      clickBackgroundColor = currentBgColor.click;
    } else {
      hoverBackgroundColor = currentColor.hover;
      clickBackgroundColor = currentColor.click;
    }

    if (plain && plainColorHighlight && (0, _mixins.highlightNeutralColorButtonType)(type)) {
      hoverColor = typeColor.primary.hover;
      clickColor = typeColor.primary.click;
      hoverBorderColor = typeColor.primary.hover;
      clickBorderColor = typeColor.primary.click;
    } else {
      hoverColor = color;
      clickColor = color;
    }
  }

  var backgroundImage;
  var backgroundColor; // 不是线框的按钮，同时使用背景

  if (!plain && currentTypeUseBgImage) {
    backgroundImage = currentBgImage.normal;
  } else {
    backgroundColor = bgColor;
  }

  if (lightShadow && type === 'mask') {
    color = lightMaskColor;
    hoverColor = lightMaskColor;
    clickColor = lightMaskColor;
  }

  var busyOpacity;

  if (!interactive) {
    busyOpacity = theme.opacity.pattern.disabled;
  }

  return {
    style: {
      color: color,
      backgroundImage: backgroundImage,
      backgroundColor: backgroundColor,
      opacity: busyOpacity,
      cursor: interactive ? 'pointer' : 'not-allowed',
      borderColor: borderColor
    },
    hoverStyle: {
      color: hoverColor,
      backgroundImage: hoverBackgroundImage,
      backgroundColor: hoverBackgroundColor,
      borderColor: hoverBorderColor || borderColor
    },
    clickStyle: {
      color: clickColor,
      backgroundImage: clickBackgroundImage,
      backgroundColor: clickBackgroundColor,
      borderColor: clickBorderColor || borderColor
    }
  };
}
/* eslint-enable complexity */


function getDisabledButtonConfig(props) {
  var theme = props.theme,
      outline = props.outline;
  var defaultColor = theme.components.Button.defaultColor;
  var disabledColor = theme.colors.pattern.text.disabled;
  var color = defaultColor;
  var borderColor;
  var backgroundColor; // 如果是线框的

  if (outline) {
    color = disabledColor;
    borderColor = disabledColor;
    backgroundColor = 'transparent';
  } else {
    borderColor = defaultColor;
    backgroundColor = disabledColor;
  }

  return {
    style: {
      cursor: 'not-allowed',
      color: color,
      backgroundColor: backgroundColor,
      borderColor: borderColor
    }
  };
}

function getButtonConfigInGroup(theme, type, selected) {
  var _theme$components$But2 = theme.components.Button,
      hoverZIndex = _theme$components$But2.hoverZIndex,
      selectedZIndex = _theme$components$But2.selectedZIndex,
      zIndexOrder = _theme$components$But2.zIndexOrder;
  var currentZIndex = zIndexOrder[type];
  var activeZIndex;

  if (selected) {
    activeZIndex = selectedZIndex;
  } else {
    activeZIndex = hoverZIndex;
  }

  var normalZIndex;

  if (currentZIndex && selected) {
    normalZIndex = selectedZIndex;
  } else if (currentZIndex) {
    normalZIndex = currentZIndex;
  }

  return {
    style: {
      zIndex: normalZIndex
    },
    clickStyle: {
      zIndex: activeZIndex
    },
    hoverStyle: {
      zIndex: activeZIndex
    }
  };
} // 状态的样式


function buttonCSS(props) {
  var _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      _props$type = props.type,
      type = _props$type === void 0 ? 'normal' : _props$type,
      theme = props.theme,
      busy = props.busy,
      disabled = props.disabled,
      loading = props.loading,
      groupType = props.groupType,
      offBorder = props.offBorder,
      selected = props.selected,
      _props$disableSibling = props.disableSiblingMargin,
      disableSiblingMargin = _props$disableSibling === void 0 ? false : _props$disableSibling,
      _props$outline = props.outline,
      outline = _props$outline === void 0 ? false : _props$outline,
      _props$lightShadow = props.lightShadow,
      lightShadow = _props$lightShadow === void 0 ? false : _props$lightShadow;
  var interactive = !(busy || disabled || loading);
  var baseConfig = disabled ? getDisabledButtonConfig({
    theme: theme,
    outline: outline
  }) : getOneTypeOfButton({
    theme: theme,
    type: type,
    interactive: interactive,
    outline: outline,
    lightShadow: lightShadow
  });
  var config;

  if (groupType) {
    var groupConfig = getButtonConfigInGroup(theme, type, selected);
    config = mergeCSSConfig(baseConfig, groupConfig);
  } else {
    config = baseConfig;
  }

  var normalCss = (0, _styledComponents.css)(config.style);
  var interactiveCss;

  if (interactive && config.hoverStyle && config.clickStyle) {
    interactiveCss = (0, _styledComponents.css)(["&:hover{", "}&:active{", "}"], (0, _styledComponents.css)(config.hoverStyle), (0, _styledComponents.css)(config.clickStyle));
  }

  var busyOrLoading = busy || loading;
  return (0, _styledComponents.css)(["", " ", " ", " ", ""], normalCss, interactiveCss, buttonBorderCSS({
    groupType: groupType,
    offBorder: offBorder,
    busyOrLoading: busyOrLoading,
    outline: outline
  }), (0, _mixins.siblingCss)({
    size: size,
    theme: theme,
    inGroup: !!groupType,
    disableSiblingMargin: disableSiblingMargin
  }));
}

var StyledButton = (0, _styledComponents["default"])(ButtonPure).withConfig({
  displayName: "StyledButton"
})(["", ""], function (props) {
  var plainIsLight = props.theme.components.Button.plainIsLight;
  var type = props.type,
      selected = props.selected,
      groupType = props.groupType,
      plain = props.plain,
      textFine = props.textFine,
      fontWeight = props.fontWeight,
      outline = props.outline,
      lightShadow = props.lightShadow;
  var innerPlain = plain;
  var innerType = type;
  var innerOutline = outline;
  var innerLightShadow = lightShadow;

  if (!innerType && selected === true) {
    innerType = 'primary';
  } else if (!innerType && selected === false) {
    innerType = 'secondary';
  } else if (!innerType) {
    innerType = 'normal';
  }

  if (innerType === 'normal' && typeof plain === 'undefined') {
    innerPlain = true;
  }

  if (typeof lightShadow === 'undefined' && typeof outline === 'undefined') {
    if (innerPlain && plainIsLight) {
      innerLightShadow = true;
    } else if (innerPlain && !plainIsLight) {
      innerOutline = true;
    }
  }

  var innerFontWeight = fontWeight;

  if (!innerFontWeight && textFine) {
    innerFontWeight = 'lighter';
  }

  var newProps = (0, _extends2["default"])({}, props, {
    type: innerType,
    plain: innerPlain,
    fontWeight: innerFontWeight,
    outline: innerOutline,
    lightShadow: innerLightShadow
  });
  return (0, _styledComponents.css)(["user-select:none;", " ", " ", ""], (0, _mixins.buttonSizeCSS)(newProps), buttonInGroupCss(groupType), buttonCSS(newProps));
});
exports.StyledButton = StyledButton;

var Button = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var loading = props.loading,
      autoLoading = props.autoLoading,
      onClick = props.onClick,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded2);

  var _useBtnAutoLoading = (0, _useBtnAutoLoading3["default"])(props),
      _useBtnAutoLoading2 = (0, _slicedToArray2["default"])(_useBtnAutoLoading, 2),
      realLoading = _useBtnAutoLoading2[0],
      handleClick = _useBtnAutoLoading2[1];

  var theme = (0, _useTheme["default"])();
  return /*#__PURE__*/_react["default"].createElement(StyledButton, (0, _extends2["default"])({
    ref: ref,
    onClick: handleClick,
    loading: realLoading
  }, otherProps, {
    theme: theme
  }));
});

var WrapButton = (0, _withTheme.withThemeForStyled)((0, _styledComponents["default"])(Button).withConfig({
  displayName: "WrapButton"
})([""]));
WrapButton.__MUYA_BUTTON = true;
var _default = WrapButton;
exports["default"] = _default;