"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _useEventCallback2 = require("@muya-ui/utils/lib/hooks/useEventCallback");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _devWarning2 = require("@muya-ui/utils/lib/utils/devWarning");

var _react = _interopRequireWildcard(require("react"));

var _SpinIcon = _interopRequireDefault(require("../Spin/SpinIcon"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _excluded = ["size", "htmlType", "disabled", "component", "children", "textFine", "fontWeight", "onClick", "type", "width", "loading", "busy", "suffixNode", "prefixNode", "styles", "disableSiblingMargin", "shape"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  prefix: '',
  suffix: ''
};
var ButtonCore = (0, _memoForwardRef["default"])(function (props, ref) {
  // @TODO remove next breaking change
  (0, _devWarning2.devWarning)('[Button]: prop `textFine` is deprecated, use `fontWeight="lighter" instead.`', 'textFine' in props);
  var _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      _props$htmlType = props.htmlType,
      htmlType = _props$htmlType === void 0 ? 'button' : _props$htmlType,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      _props$component = props.component,
      asProp = _props$component === void 0 ? 'button' : _props$component,
      children = props.children,
      textFine = props.textFine,
      fontWeight = props.fontWeight,
      onClick = props.onClick,
      type = props.type,
      width = props.width,
      _props$loading = props.loading,
      loading = _props$loading === void 0 ? false : _props$loading,
      _props$busy = props.busy,
      busy = _props$busy === void 0 ? false : _props$busy,
      suffixNode = props.suffixNode,
      prefixNode = props.prefixNode,
      styles = props.styles,
      disableSiblingMargin = props.disableSiblingMargin,
      shape = props.shape,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var innerStyles = (0, _useStyles["default"])('button', defaultStyles, styles);
  var buttonProps = (0, _react.useMemo)(function () {
    var buttonProps = {};

    if (asProp === 'button') {
      buttonProps = {
        disabled: disabled,
        type: htmlType
      };
    }

    return buttonProps;
  }, [asProp, disabled, htmlType]);
  var innerBusy = busy;

  if (loading) {
    innerBusy = true;
  }

  var childrenNode = (0, _react.useMemo)(function () {
    var innerSuffixNode = suffixNode;
    var innerPrefixNode = prefixNode;
    var isCircleOrSquare = shape === 'circle' || shape === 'square';
    var showChildren = !loading || !isCircleOrSquare;

    if (loading && theme.components.Button.loadingPosition === 'suffix') {
      innerSuffixNode = /*#__PURE__*/_react["default"].createElement(_SpinIcon["default"], {
        color: "currentColor"
      });
    } else if (loading) {
      innerPrefixNode = /*#__PURE__*/_react["default"].createElement(_SpinIcon["default"], {
        color: "currentColor"
      });
    }

    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, innerPrefixNode ? /*#__PURE__*/_react["default"].createElement(_styled.StyledSide, (0, _extends2["default"])({}, innerStyles.prefix, {
      $isCircleOrSquare: isCircleOrSquare,
      shape: shape,
      theme: theme,
      prefixNode: innerPrefixNode
    }), innerPrefixNode) : null, showChildren && children, innerSuffixNode ? /*#__PURE__*/_react["default"].createElement(_styled.StyledSide, (0, _extends2["default"])({}, innerStyles.suffix, {
      $isCircleOrSquare: isCircleOrSquare,
      shape: shape,
      theme: theme,
      suffixNode: innerSuffixNode
    }), innerSuffixNode) : null);
  }, [children, innerStyles.prefix, innerStyles.suffix, loading, prefixNode, shape, suffixNode, theme]);
  var handleClick = (0, _useEventCallback2.useEventCallback)(function (e) {
    if (!innerBusy && !disabled) {
      onClick && onClick(e);
    } else {
      e.preventDefault();
    }
  });

  if (otherProps.href || asProp === 'a') {
    return /*#__PURE__*/_react["default"].createElement(_styled.StyledLink, (0, _extends2["default"])({
      ref: ref,
      role: "button",
      "aria-disabled": disabled,
      theme: theme,
      onClick: handleClick
    }, otherProps), childrenNode);
  }

  return /*#__PURE__*/_react["default"].createElement(_styled.StyledButton, (0, _extends2["default"])({
    ref: ref,
    as: asProp,
    theme: theme,
    onClick: handleClick
  }, buttonProps, otherProps), childrenNode);
});
var _default = ButtonCore;
exports["default"] = _default;