"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.StyledInlineButton = void 0;

var _devWarning2 = require("@muya-ui/utils/lib/utils/devWarning");

var _useEffectOnce2 = require("@muya-ui/utils/lib/hooks/useEffectOnce");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _addPx = _interopRequireDefault(require("../utils/addPx"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _withTheme = require("../utils/withTheme");

var _ButtonCore = _interopRequireDefault(require("./ButtonCore"));

var _mixins = require("./mixins");

var _useBtnAutoLoading3 = _interopRequireDefault(require("./useBtnAutoLoading"));

var _excluded = ["type", "constant"],
    _excluded2 = ["loading", "autoLoading", "onClick"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var InlineButtonPure = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var type = props.type,
      constant = props.constant,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  return /*#__PURE__*/_react["default"].createElement(_ButtonCore["default"], (0, _extends2["default"])({
    ref: ref
  }, otherProps));
});

function buttonCSS(props) {
  var _props$type = props.type,
      type = _props$type === void 0 ? 'normal' : _props$type,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      theme = props.theme,
      busy = props.busy,
      disabled = props.disabled,
      innerFontWeight = props.fontWeight,
      constant = props.constant,
      width = props.width,
      loading = props.loading,
      _props$disableSibling = props.disableSiblingMargin,
      disableSiblingMargin = _props$disableSibling === void 0 ? false : _props$disableSibling;
  var btnToken = theme.components.Button;
  var fontSize = btnToken.fontSize,
      typeColor = btnToken.typeColor,
      inlineButtonTypeColor = btnToken.inlineButtonTypeColor;
  var fontWeight = btnToken.fontWeight[innerFontWeight || 'normal'];
  var colorToken = inlineButtonTypeColor[type] || typeColor[type];
  var cssObj = {};
  cssObj.color = colorToken.normal;

  if (disabled) {
    cssObj.color = theme.colors.pattern.text.disabled;
  }

  var interactive = !(busy || disabled || loading);
  var interactiveCSS;

  if (interactive && !constant) {
    var colorItem = colorToken;

    if ((0, _mixins.highlightNeutralColorButtonType)(type)) {
      colorItem = typeColor.primary;
    }

    interactiveCSS = (0, _styledComponents.css)(["cursor:pointer;&:hover{color:", ";}&:active{color:", ";}"], colorItem.hover, colorItem.click);
  } else if (!constant) {
    interactiveCSS = (0, _styledComponents.css)(["cursor:not-allowed;"]);
  } else {
    interactiveCSS = (0, _styledComponents.css)(["cursor:default;"]);
  }

  if (!disabled && (busy || loading)) {
    cssObj.opacity = theme.opacity.pattern.disabled;
  }

  if (width) {
    cssObj.width = (0, _addPx["default"])(width);
  }

  var baseCSS = (0, _styledComponents.css)(cssObj);
  return (0, _styledComponents.css)(["", " font-weight:", ";font-size:", "px;", " ", ""], baseCSS, fontWeight, fontSize[size], interactiveCSS, (0, _mixins.siblingCss)({
    size: size,
    theme: theme,
    inGroup: false,
    disableSiblingMargin: disableSiblingMargin
  }));
}

var StyledInlineButton = (0, _styledComponents["default"])(InlineButtonPure).withConfig({
  displayName: "StyledInlineButton"
})(["", ""], function (props) {
  var textFine = props.textFine,
      propFontWeight = props.fontWeight;
  var innerFontWeight = propFontWeight;

  if (!innerFontWeight && textFine) {
    innerFontWeight = 'lighter';
  }

  var newProps = (0, _extends2["default"])({}, props, {
    fontWeight: innerFontWeight
  });
  return (0, _styledComponents.css)(["background:transparent;border:none;padding:0;", ""], buttonCSS(newProps));
});
exports.StyledInlineButton = StyledInlineButton;

var InlineButton = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var loading = props.loading,
      autoLoading = props.autoLoading,
      onClick = props.onClick,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded2);

  var _useBtnAutoLoading = (0, _useBtnAutoLoading3["default"])(props),
      _useBtnAutoLoading2 = (0, _slicedToArray2["default"])(_useBtnAutoLoading, 2),
      realLoading = _useBtnAutoLoading2[0],
      handleClick = _useBtnAutoLoading2[1];

  var theme = (0, _useTheme["default"])();
  (0, _useEffectOnce2.useEffectOnce)(function () {
    (0, _devWarning2.devWarning)('[InlineButton]: prop `weakLevel` is deprecated.', 'weakLevel' in props);
  });
  return /*#__PURE__*/_react["default"].createElement(StyledInlineButton, (0, _extends2["default"])({
    ref: ref,
    onClick: handleClick,
    loading: realLoading
  }, otherProps, {
    theme: theme
  }));
});

var WrapInlineButton = (0, _withTheme.withThemeForStyled)((0, _styledComponents["default"])(InlineButton).withConfig({
  displayName: "WrapInlineButton"
})([""]));
WrapInlineButton.__MUYA_BUTTON = true;
var _default = WrapInlineButton;
exports["default"] = _default;