"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.StyledMaskButton = void 0;

var _devWarning2 = require("@muya-ui/utils/lib/utils/devWarning");

var _useEffectOnce2 = require("@muya-ui/utils/lib/hooks/useEffectOnce");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _utils = require("@muya-ui/theme-light/lib/utils");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _withTheme = require("../utils/withTheme");

var _ButtonCore = _interopRequireDefault(require("./ButtonCore"));

var _mixins = require("./mixins");

var _useBtnAutoLoading3 = _interopRequireDefault(require("./useBtnAutoLoading"));

var _excluded = ["shape", "block"],
    _excluded2 = ["loading", "autoLoading", "onClick"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var MaskButtonPure = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var shape = props.shape,
      block = props.block,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  return /*#__PURE__*/_react["default"].createElement(_ButtonCore["default"], (0, _extends2["default"])({
    ref: ref
  }, otherProps));
}); // 状态的样式


function maskButtonStatusCSS(props) {
  var theme = props.theme,
      busy = props.busy,
      disabled = props.disabled,
      loading = props.loading;
  var components = theme.components,
      opacity = theme.opacity;
  var _components$Button = components.Button,
      defaultColor = _components$Button.defaultColor,
      maskColor = _components$Button.maskColor;

  var bgColor = _utils.colorUtils.transparentize(opacity.spec.s3, maskColor);

  var disabledColor = theme.colors.pattern.text.disabled;
  var interactive = !(busy || disabled || loading);
  var interactiveCSS;

  if (interactive) {
    var bgHoverColor = _utils.colorUtils.transparentize(opacity.spec.s2, maskColor);

    interactiveCSS = (0, _styledComponents.css)(["cursor:pointer;&:hover{background-color:", ";}"], bgHoverColor);
  } else {
    interactiveCSS = (0, _styledComponents.css)(["cursor:not-allowed;"]);
  }

  if (disabled) {
    bgColor = disabledColor;
  }

  return (0, _styledComponents.css)(["color:", ";user-select:none;background-color:", ";&:hover{color:", ";}", " ", ""], defaultColor, bgColor, defaultColor, !interactive && !disabled && "opacity: ".concat(opacity.pattern.disabled, ";"), interactiveCSS);
}

var StyledMaskButton = (0, _styledComponents["default"])(MaskButtonPure).withConfig({
  displayName: "StyledMaskButton"
})(["", ""], function (props) {
  var _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      theme = props.theme,
      _props$disableSibling = props.disableSiblingMargin,
      disableSiblingMargin = _props$disableSibling === void 0 ? false : _props$disableSibling,
      fontWeight = props.fontWeight,
      textFine = props.textFine;
  var innerFontWeight = fontWeight;

  if (!innerFontWeight && textFine) {
    innerFontWeight = 'lighter';
  }

  var newProps = (0, _extends2["default"])({}, props, {
    size: size,
    fontWeight: innerFontWeight
  });
  return (0, _styledComponents.css)(["border:none;", " ", " ", ""], (0, _mixins.buttonSizeCSS)(newProps), maskButtonStatusCSS(newProps), (0, _mixins.siblingCss)({
    size: size,
    theme: theme,
    inGroup: false,
    disableSiblingMargin: disableSiblingMargin
  }));
});
exports.StyledMaskButton = StyledMaskButton;

var MaskButton = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var loading = props.loading,
      autoLoading = props.autoLoading,
      onClick = props.onClick,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded2);

  var _useBtnAutoLoading = (0, _useBtnAutoLoading3["default"])(props),
      _useBtnAutoLoading2 = (0, _slicedToArray2["default"])(_useBtnAutoLoading, 2),
      realLoading = _useBtnAutoLoading2[0],
      handleClick = _useBtnAutoLoading2[1];

  var theme = (0, _useTheme["default"])();
  (0, _useEffectOnce2.useEffectOnce)(function () {
    (0, _devWarning2.devWarning)('[Button]: `MaskButton` is deprecated, please use `type="mask"` instead.');
  });
  return /*#__PURE__*/_react["default"].createElement(StyledMaskButton, (0, _extends2["default"])({
    ref: ref,
    onClick: handleClick,
    loading: realLoading
  }, otherProps, {
    theme: theme
  }));
});

var WrapMaskButton = (0, _withTheme.withThemeForStyled)((0, _styledComponents["default"])(MaskButton).withConfig({
  displayName: "WrapMaskButton"
})([""]));
WrapMaskButton.__MUYA_BUTTON = true;
var _default = WrapMaskButton;
exports["default"] = _default;