"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledSide = exports.StyledLink = exports.StyledButton = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var baseCSS = (0, _styledComponents.css)(["position:relative;display:inline-flex;align-items:center;justify-content:center;vertical-align:middle;"]);

var StyledButton = _styledComponents["default"].button.withConfig({
  displayName: "StyledButton"
})(["outline:0;margin:0;font-family:inherit;text-transform:none;overflow:visible;box-sizing:border-box;", ""], baseCSS);

exports.StyledButton = StyledButton;

var StyledLink = _styledComponents["default"].a.withConfig({
  displayName: "StyledLink"
})(["text-decoration:none;", ""], baseCSS);

exports.StyledLink = StyledLink;

var StyledSide = _styledComponents["default"].span.withConfig({
  displayName: "StyledSide"
})(["display:inline-flex;", ""], function (props) {
  var prefixNode = props.prefixNode,
      theme = props.theme,
      suffixNode = props.suffixNode,
      $isCircleOrSquare = props.$isCircleOrSquare;
  var btnToken = theme.components.Button;
  if ($isCircleOrSquare) return;

  if (prefixNode) {
    return (0, _styledComponents.css)(["padding-right:", "px;"], btnToken.sidePadding);
  } else if (suffixNode) {
    return (0, _styledComponents.css)(["padding-left:", "px;"], btnToken.sidePadding);
  }
});

exports.StyledSide = StyledSide;