"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _CalendarFooter = _interopRequireDefault(require("./CalendarFooter"));

var _CalendarHead = _interopRequireDefault(require("./CalendarHead"));

var _CalendarPanel = _interopRequireDefault(require("./CalendarPanel"));

var _useCalendar2 = _interopRequireDefault(require("./useCalendar"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Root = _styledComponents["default"].div.withConfig({
  displayName: "Root"
})(["width:", "px;background-color:", ";"], function (props) {
  return props.theme.components.Calendar.defaultWidth;
}, function (props) {
  return props.theme.colors.pattern.background.higher;
});

var defaultStyles = {
  head: '',
  panel: '',
  footer: ''
};
var Calendar = (0, _memoForwardRef["default"])(function (props, ref) {
  var _useCalendar = (0, _useCalendar2["default"])(props),
      finalUIState = _useCalendar.finalUIState,
      finalSelectedDate = _useCalendar.finalSelectedDate,
      finalOptions = _useCalendar.finalOptions,
      handleItemClick = _useCalendar.handleItemClick,
      handlePrevMonth = _useCalendar.handlePrevMonth,
      handleNextMonth = _useCalendar.handleNextMonth,
      handlePrevYear = _useCalendar.handlePrevYear,
      handleNextYear = _useCalendar.handleNextYear,
      handleSwitch = _useCalendar.handleSwitch,
      finalDisableRange = _useCalendar.finalDisableRange,
      finalTodayDate = _useCalendar.finalTodayDate,
      readOnly = _useCalendar.readOnly,
      otherProps = _useCalendar.otherProps,
      styles = _useCalendar.styles,
      hideItemOutside = _useCalendar.hideItemOutside,
      renderDecadeItem = _useCalendar.renderDecadeItem,
      renderMonthItem = _useCalendar.renderMonthItem,
      renderYearItem = _useCalendar.renderYearItem,
      renderMonthLabel = _useCalendar.renderMonthLabel,
      disableDate = _useCalendar.disableDate;

  var theme = (0, _useTheme["default"])();
  var pickStyles = (0, _react.useMemo)(function () {
    if (styles) {
      var head = styles.head,
          panel = styles.panel,
          footer = styles.footer;
      return {
        head: head,
        panel: panel,
        footer: footer
      };
    }
  }, [styles]);
  var innerStyles = (0, _useStyles["default"])('calendar', defaultStyles, pickStyles); // CalendarFooter 本身就 memo了，单个节点不需要 memo 了

  var footerNode;

  if (finalOptions && finalOptions.length) {
    footerNode = /*#__PURE__*/_react["default"].createElement(_CalendarFooter["default"], (0, _extends2["default"])({}, innerStyles.footer, {
      styles: styles,
      options: finalOptions
    }));
  } // 本就是解构了传给 pure component，所以不需要 memo


  var panelProps = {
    styles: styles,
    todayDate: finalTodayDate,
    disableRange: finalDisableRange,
    disableDate: disableDate,
    hideItemOutside: hideItemOutside,
    renderDecadeItem: renderDecadeItem,
    renderMonthItem: renderMonthItem,
    renderYearItem: renderYearItem,
    renderMonthLabel: renderMonthLabel,
    readOnly: readOnly
  };
  return /*#__PURE__*/_react["default"].createElement(Root, (0, _extends2["default"])({}, otherProps, {
    theme: theme,
    ref: ref
  }), /*#__PURE__*/_react["default"].createElement(_CalendarHead["default"], (0, _extends2["default"])({}, innerStyles.head, {
    styles: styles,
    viewType: finalUIState.viewType,
    viewDate: finalUIState.viewDate,
    onPrevMonth: handlePrevMonth,
    onNextMonth: handleNextMonth,
    onPrevYear: handlePrevYear,
    onNextYear: handleNextYear,
    onSwitch: handleSwitch
  })), /*#__PURE__*/_react["default"].createElement(_CalendarPanel["default"], (0, _extends2["default"])({}, innerStyles.panel, {
    viewType: finalUIState.viewType,
    selected: finalSelectedDate,
    viewDate: finalUIState.viewDate,
    onItemClick: handleItemClick
  }, panelProps)), footerNode);
});
var _default = Calendar;
exports["default"] = _default;