"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _InlineButton = _interopRequireDefault(require("../InlineButton"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _excluded = ["options", "styles", "type"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledButton = (0, _styledComponents["default"])(_InlineButton["default"]).withConfig({
  displayName: "StyledButton"
})([""]);

var Root = _styledComponents["default"].div.withConfig({
  displayName: "Root"
})(["display:flex;", ""], function (_ref) {
  var theme = _ref.theme,
      _ref$$type = _ref.$type,
      $type = _ref$$type === void 0 ? 'date' : _ref$$type;
  var colors = theme.colors,
      footerToken = theme.components.Calendar.footer;

  if ($type === 'date-time') {
    return (0, _styledComponents.css)(["flex:1;padding:0 12px;& ", "{margin:0 16px 0 0;}"], StyledButton);
  }

  return (0, _styledComponents.css)(["width:100%;align-items:center;justify-content:center;height:", "px;border-top:1px solid ", ";& ", "{margin:", ";}"], footerToken.height, colors.pattern.border.normal, StyledButton, footerToken.optionMargin);
});

var defaultStyles = {
  footerOption: ''
};
var CalendarFooter = (0, _memoForwardRef["default"])(function (props, ref) {
  var options = props.options,
      styles = props.styles,
      type = props.type,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var pickStyles = (0, _react.useMemo)(function () {
    if (styles) {
      var footerOption = styles.footerOption;
      return {
        footerOption: footerOption
      };
    }
  }, [styles]);
  var innerStyles = (0, _useStyles["default"])('calendar', defaultStyles, pickStyles);
  var optionsNode = (0, _react.useMemo)(function () {
    if (!options || options.length < 1) {
      return;
    }

    return options.map(function (_ref2, index) {
      var label = _ref2.label,
          onClick = _ref2.onClick,
          disabled = _ref2.disabled;
      return /*#__PURE__*/_react["default"].createElement(StyledButton, (0, _extends2["default"])({}, innerStyles.footerOption, {
        key: index,
        type: "primary",
        size: "s",
        fontWeight: "lighter",
        disabled: disabled,
        onClick: onClick
      }), label);
    });
  }, [innerStyles.footerOption, options]);
  return /*#__PURE__*/_react["default"].createElement(Root, (0, _extends2["default"])({
    theme: theme,
    $type: type
  }, otherProps, {
    ref: ref
  }), optionsNode);
});
var _default = CalendarFooter;
exports["default"] = _default;