"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _NextYearIcon2 = require("@muya-ui/theme-light/lib/icons/NextYearIcon");

var _PrevYearIcon2 = require("@muya-ui/theme-light/lib/icons/PrevYearIcon");

var _GuildRightIcon2 = require("@muya-ui/theme-light/lib/icons/GuildRightIcon");

var _GuildLeftIcon2 = require("@muya-ui/theme-light/lib/icons/GuildLeftIcon");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _InlineButton = _interopRequireDefault(require("../InlineButton"));

var _useLocale2 = _interopRequireDefault(require("../Locale/useLocale"));

var _Tooltip = _interopRequireDefault(require("../Tooltip"));

var _Typography = _interopRequireDefault(require("../Typography"));

var _forkHandler = _interopRequireDefault(require("../utils/forkHandler"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _utils = require("./utils");

var _excluded = ["viewType", "viewDate", "onNextMonth", "onNextYear", "onPrevMonth", "onPrevYear", "onSwitch", "styles"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledDecadeTitle = (0, _styledComponents["default"])(_Typography["default"].Title).withConfig({
  displayName: "StyledDecadeTitle"
})([""]);
var PagerButton = (0, _styledComponents["default"])(_IconButton["default"]).withConfig({
  displayName: "PagerButton"
})([""]);
var pagerCss = (0, _styledComponents.css)(["position:absolute;height:100%;display:flex;align-items:center;"]);

var PagerPrev = _styledComponents["default"].div.withConfig({
  displayName: "PagerPrev"
})(["", " left:0;"], pagerCss);

var PagerNext = _styledComponents["default"].div.withConfig({
  displayName: "PagerNext"
})(["", " right:0;"], pagerCss);

var SwitchButton = (0, _styledComponents["default"])(_InlineButton["default"]).withConfig({
  displayName: "SwitchButton"
})([""]);

var Root = _styledComponents["default"].div.withConfig({
  displayName: "Root"
})(["display:flex;justify-content:center;align-items:center;position:relative;", "{margin-bottom:0;}", ""], StyledDecadeTitle, function (props) {
  var _props$theme = props.theme,
      colors = _props$theme.colors,
      token = _props$theme.components.Calendar;
  return (0, _styledComponents.css)(["height:", "px;border-bottom:1px solid ", ";", "{margin:0;padding:", ";}", " ", ",", " ", "{margin:", ";}", " ", "{margin-right:0;}", " ", "{margin-left:0;}"], token.head.height, colors.pattern.border.normal, SwitchButton, token.headButton.padding, PagerPrev, PagerButton, PagerNext, PagerButton, token.pagerButton.margin, PagerPrev, PagerButton, PagerNext, PagerButton);
});

var defaultStyles = {
  pagerPrev: '',
  pagerPrevYear: '',
  pagerPrevMonth: '',
  pagerNext: '',
  pagerNextYear: '',
  pagerNextMonth: '',
  switchYear: '',
  switchMonth: ''
};
var CalendarHead = (0, _memoForwardRef["default"])(function (props, ref) {
  var _props$viewType = props.viewType,
      viewType = _props$viewType === void 0 ? 'month' : _props$viewType,
      viewDate = props.viewDate,
      onNextMonth = props.onNextMonth,
      onNextYear = props.onNextYear,
      onPrevMonth = props.onPrevMonth,
      onPrevYear = props.onPrevYear,
      onSwitch = props.onSwitch,
      styles = props.styles,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var pickStyles = (0, _react.useMemo)(function () {
    if (styles) {
      var _pagerPrev = styles.pagerPrev,
          _pagerPrevYear = styles.pagerPrevYear,
          _pagerPrevMonth = styles.pagerPrevMonth,
          _pagerNext = styles.pagerNext,
          _pagerNextYear = styles.pagerNextYear,
          _pagerNextMonth = styles.pagerNextMonth,
          switchYear = styles.switchYear,
          switchMonth = styles.switchMonth;
      return {
        pagerPrev: _pagerPrev,
        pagerPrevYear: _pagerPrevYear,
        pagerPrevMonth: _pagerPrevMonth,
        pagerNext: _pagerNext,
        pagerNextYear: _pagerNextYear,
        pagerNextMonth: _pagerNextMonth,
        switchYear: switchYear,
        switchMonth: switchMonth
      };
    }
  }, [styles]);
  var innerStyles = (0, _useStyles["default"])('calendar', defaultStyles, pickStyles);
  var theme = (0, _useTheme["default"])();
  var _theme$components$Cal = theme.components.Calendar,
      pagerArrow = _theme$components$Cal.pagerArrow,
      pagerArrowTipDelay = _theme$components$Cal.pagerArrowTipDelay,
      defaultDecadeTitleLevel = _theme$components$Cal.head.defaultDecadeTitleLevel;
  var Arrow = (0, _extends2["default"])({
    monthPrev: _GuildLeftIcon2.GuildLeftIcon,
    monthNext: _GuildRightIcon2.GuildRightIcon,
    yearPrev: _PrevYearIcon2.PrevYearIcon,
    yearNext: _NextYearIcon2.NextYearIcon
  }, pagerArrow);

  var _useLocale = (0, _useLocale2["default"])(),
      yearFormat = _useLocale['Calendar.yearFormat'],
      headOrder = _useLocale['Calendar.headOrder'],
      pagerNextMonth = _useLocale['Calendar.pagerNextMonth'],
      pagerNextYear = _useLocale['Calendar.pagerNextYear'],
      pagerNextDecade = _useLocale['Calendar.pagerNextDecade'],
      pagerPrevMonth = _useLocale['Calendar.pagerPrevMonth'],
      pagerPrevYear = _useLocale['Calendar.pagerPrevYear'],
      pagerPrevDecade = _useLocale['Calendar.pagerPrevDecade'];

  var handleSwitch = function handleSwitch(type) {
    return function () {
      onSwitch && onSwitch(type);
    };
  };

  var yearBtn = /*#__PURE__*/_react["default"].createElement(SwitchButton, (0, _extends2["default"])({}, innerStyles.switchYear, {
    type: "strong",
    onClick: handleSwitch('decade'),
    size: "s"
  }), viewDate.format(yearFormat));

  var monthBtn = /*#__PURE__*/_react["default"].createElement(SwitchButton, (0, _extends2["default"])({}, innerStyles.switchMonth, {
    type: "strong",
    onClick: handleSwitch('year'),
    size: "s"
  }), viewDate.format('MMM'));

  var headNode;

  if (viewType === 'year') {
    headNode = yearBtn;
  } else if (viewType === 'decade') {
    var _getDecade = (0, _utils.getDecade)(viewDate),
        _getDecade2 = (0, _slicedToArray2["default"])(_getDecade, 2),
        firstYear = _getDecade2[0],
        lastYear = _getDecade2[1];

    var title = "".concat(firstYear.format(yearFormat), "-").concat(lastYear.format(yearFormat));
    headNode = /*#__PURE__*/_react["default"].createElement(StyledDecadeTitle, {
      level: defaultDecadeTitleLevel
    }, title);
  } else if (headOrder === 'month') {
    headNode = /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, monthBtn, yearBtn);
  } else {
    headNode = /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, yearBtn, monthBtn);
  }

  var nextYearTip = viewType === 'decade' ? pagerNextDecade : pagerNextYear;
  var prevYearTip = viewType === 'decade' ? pagerPrevDecade : pagerPrevYear;

  var _useState = (0, _react.useState)(true),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      showTooltip = _useState2[0],
      setShowTooltip = _useState2[1];

  var renderPagerButton = (0, _react.useCallback)(function (title, iconNode, styleItem, clickHandler) {
    var innerClickHandler = (0, _forkHandler["default"])(function () {
      setShowTooltip(false);
    }, clickHandler);

    var pagerNode = /*#__PURE__*/_react["default"].createElement(PagerButton, (0, _extends2["default"])({}, styleItem, {
      size: "s",
      fontWeight: "lighter",
      onClick: innerClickHandler
    }), iconNode);

    if (showTooltip) {
      return /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], {
        title: title,
        enterDelay: pagerArrowTipDelay
      }, pagerNode);
    }

    return pagerNode;
  }, [pagerArrowTipDelay, showTooltip]);
  var pagerPrev = (0, _react.useMemo)(function () {
    var monthPrevPagerBtn = viewType === 'month' ? renderPagerButton(pagerPrevMonth, /*#__PURE__*/_react["default"].createElement(Arrow.monthPrev, null), innerStyles.pagerPrevMonth, onPrevMonth) : null;
    return /*#__PURE__*/_react["default"].createElement(PagerPrev, innerStyles.pagerPrev, renderPagerButton(prevYearTip, /*#__PURE__*/_react["default"].createElement(Arrow.yearPrev, null), innerStyles.pagerPrevYear, onPrevYear), monthPrevPagerBtn);
  }, [innerStyles.pagerPrev, innerStyles.pagerPrevMonth, innerStyles.pagerPrevYear, onPrevMonth, onPrevYear, pagerPrevMonth, prevYearTip, renderPagerButton, viewType]);
  var pagerNext = (0, _react.useMemo)(function () {
    var monthNextPagerBtn = viewType === 'month' ? renderPagerButton(pagerNextMonth, /*#__PURE__*/_react["default"].createElement(Arrow.monthNext, null), innerStyles.pagerNextMonth, onNextMonth) : null;
    return /*#__PURE__*/_react["default"].createElement(PagerNext, innerStyles.pagerNext, monthNextPagerBtn, renderPagerButton(nextYearTip, /*#__PURE__*/_react["default"].createElement(Arrow.yearNext, null), innerStyles.pagerNextYear, onNextYear));
  }, [innerStyles.pagerNext, innerStyles.pagerNextMonth, innerStyles.pagerNextYear, nextYearTip, onNextMonth, onNextYear, pagerNextMonth, renderPagerButton, viewType]);
  return /*#__PURE__*/_react["default"].createElement(Root, (0, _extends2["default"])({}, otherProps, {
    theme: theme,
    ref: ref
  }), pagerPrev, headNode, pagerNext);
});
var _default = CalendarHead;
exports["default"] = _default;