"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _CalendarFooter = _interopRequireDefault(require("./CalendarFooter"));

var _CalendarHead = _interopRequireDefault(require("./CalendarHead"));

var _CalendarPanel = _interopRequireDefault(require("./CalendarPanel"));

var _useRangeCalendar2 = _interopRequireDefault(require("./useRangeCalendar"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var LeftCalendar = _styledComponents["default"].div.withConfig({
  displayName: "LeftCalendar"
})(["width:", "px;border-right:1px solid ", ";"], function (props) {
  return props.theme.components.Calendar.defaultWidth;
}, function (props) {
  return props.theme.colors.pattern.border.normal;
});

var RightCalendar = _styledComponents["default"].div.withConfig({
  displayName: "RightCalendar"
})(["width:", "px;"], function (props) {
  return props.theme.components.Calendar.defaultWidth;
});

var Container = _styledComponents["default"].div.withConfig({
  displayName: "Container"
})(["display:flex;"]);

var Root = _styledComponents["default"].div.withConfig({
  displayName: "Root"
})(["position:relative;background-color:", ";"], function (props) {
  return props.theme.colors.pattern.background.higher;
});

var defaultStyles = {
  head: '',
  panel: '',
  footer: '',
  container: '',
  leftCalendar: '',
  rightCalendar: ''
};
var RangeCalendar = (0, _memoForwardRef["default"])(function (props, ref) {
  var theme = (0, _useTheme["default"])();

  var _useRangeCalendar = (0, _useRangeCalendar2["default"])(props),
      finalState = _useRangeCalendar.finalState,
      finalUIState = _useRangeCalendar.finalUIState,
      finalFixedEnd = _useRangeCalendar.finalFixedEnd,
      finalFixedStart = _useRangeCalendar.finalFixedStart,
      finalOptions = _useRangeCalendar.finalOptions,
      readOnly = _useRangeCalendar.readOnly,
      otherProps = _useRangeCalendar.otherProps,
      handleItemHover = _useRangeCalendar.handleItemHover,
      handleLeftSwitch = _useRangeCalendar.handleLeftSwitch,
      handleLeftClick = _useRangeCalendar.handleLeftClick,
      handleLeftPrevMonth = _useRangeCalendar.handleLeftPrevMonth,
      handleLeftPrevYear = _useRangeCalendar.handleLeftPrevYear,
      handleLeftNextMonth = _useRangeCalendar.handleLeftNextMonth,
      handleLeftNextYear = _useRangeCalendar.handleLeftNextYear,
      handleRightSwitch = _useRangeCalendar.handleRightSwitch,
      handleRightClick = _useRangeCalendar.handleRightClick,
      handleRightPrevMonth = _useRangeCalendar.handleRightPrevMonth,
      handleRightPrevYear = _useRangeCalendar.handleRightPrevYear,
      handleRightNextMonth = _useRangeCalendar.handleRightNextMonth,
      handleRightNextYear = _useRangeCalendar.handleRightNextYear,
      finalDisableRange = _useRangeCalendar.finalDisableRange,
      finalTodayDate = _useRangeCalendar.finalTodayDate,
      styles = _useRangeCalendar.styles,
      renderDecadeItem = _useRangeCalendar.renderDecadeItem,
      renderMonthItem = _useRangeCalendar.renderMonthItem,
      renderYearItem = _useRangeCalendar.renderYearItem,
      renderMonthLabel = _useRangeCalendar.renderMonthLabel,
      hideItemOutside = _useRangeCalendar.hideItemOutside,
      disableDate = _useRangeCalendar.disableDate,
      minRangeLength = _useRangeCalendar.minRangeLength,
      maxRangeLength = _useRangeCalendar.maxRangeLength;

  var pickStyles = (0, _react.useMemo)(function () {
    if (styles) {
      var head = styles.head,
          panel = styles.panel,
          footer = styles.footer,
          container = styles.container,
          leftCalendar = styles.leftCalendar,
          rightCalendar = styles.rightCalendar;
      return {
        head: head,
        panel: panel,
        footer: footer,
        container: container,
        leftCalendar: leftCalendar,
        rightCalendar: rightCalendar
      };
    }
  }, [styles]);
  var innerStyles = (0, _useStyles["default"])('calendar', defaultStyles, pickStyles);

  var _finalUIState$viewTyp = (0, _slicedToArray2["default"])(finalUIState.viewType, 2),
      viewLeftType = _finalUIState$viewTyp[0],
      viewRightType = _finalUIState$viewTyp[1];

  var _finalUIState$viewDat = (0, _slicedToArray2["default"])(finalUIState.viewDate, 2),
      viewLeftDate = _finalUIState$viewDat[0],
      viewRightDate = _finalUIState$viewDat[1]; // CalendarFooter 本身就 memo了，单个节点不需要 memo 了


  var footerNode;

  if (finalOptions && finalOptions.length) {
    footerNode = /*#__PURE__*/_react["default"].createElement(_CalendarFooter["default"], (0, _extends2["default"])({}, innerStyles.footer, {
      styles: styles,
      options: finalOptions
    }));
  } // 本就是解构了传给 pure component，所以不需要 memo


  var basePanelProps = {
    renderDecadeItem: renderDecadeItem,
    renderMonthItem: renderMonthItem,
    renderYearItem: renderYearItem,
    renderMonthLabel: renderMonthLabel,
    disableDate: disableDate,
    fixedStart: finalFixedStart,
    fixedEnd: finalFixedEnd,
    disableRange: finalDisableRange,
    range: finalState.range,
    start: finalState.start,
    end: finalState.end,
    todayDate: finalTodayDate,
    isRange: true,
    onItemHover: handleItemHover,
    min: minRangeLength,
    max: maxRangeLength,
    hideItemOutside: hideItemOutside
  };
  return /*#__PURE__*/_react["default"].createElement(Root, (0, _extends2["default"])({
    theme: theme
  }, otherProps, {
    ref: ref
  }), /*#__PURE__*/_react["default"].createElement(Container, innerStyles.container, /*#__PURE__*/_react["default"].createElement(LeftCalendar, (0, _extends2["default"])({
    theme: theme
  }, innerStyles.leftCalendar), /*#__PURE__*/_react["default"].createElement(_CalendarHead["default"], (0, _extends2["default"])({}, innerStyles.head, {
    styles: styles,
    viewType: viewLeftType,
    viewDate: viewLeftDate,
    onSwitch: handleLeftSwitch,
    onPrevMonth: handleLeftPrevMonth,
    onPrevYear: handleLeftPrevYear,
    onNextMonth: handleLeftNextMonth,
    onNextYear: handleLeftNextYear
  })), /*#__PURE__*/_react["default"].createElement(_CalendarPanel["default"], (0, _extends2["default"])({}, innerStyles.panel, basePanelProps, {
    readOnly: readOnly,
    styles: styles,
    viewType: viewLeftType,
    viewDate: viewLeftDate,
    onItemClick: handleLeftClick
  }))), /*#__PURE__*/_react["default"].createElement(RightCalendar, (0, _extends2["default"])({
    theme: theme
  }, innerStyles.rightCalendar), /*#__PURE__*/_react["default"].createElement(_CalendarHead["default"], (0, _extends2["default"])({}, innerStyles.head, {
    styles: styles,
    viewType: viewRightType,
    viewDate: viewRightDate,
    onSwitch: handleRightSwitch,
    onPrevMonth: handleRightPrevMonth,
    onPrevYear: handleRightPrevYear,
    onNextMonth: handleRightNextMonth,
    onNextYear: handleRightNextYear
  })), /*#__PURE__*/_react["default"].createElement(_CalendarPanel["default"], (0, _extends2["default"])({}, innerStyles.panel, basePanelProps, {
    readOnly: readOnly,
    styles: styles,
    viewType: viewRightType,
    viewDate: viewRightDate,
    onItemClick: handleRightClick
  })))), footerNode);
});
var _default = RangeCalendar;
exports["default"] = _default;