"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useCalendarBase;

var _dayjs = _interopRequireDefault(require("dayjs"));

var _react = require("react");

var _utils = require("./utils");

function useCalendarBase(props) {
  var disableRange = props.disableRange,
      disableDate = props.disableDate,
      todayDate = props.todayDate,
      selectType = props.selectType;
  var finalDisableRange = (0, _react.useMemo)(function () {
    return (0, _utils.getRangeInOrder)(disableRange);
  }, [disableRange]);
  var finalTodayDate = (0, _react.useMemo)(function () {
    return (0, _dayjs["default"])(todayDate);
  }, [todayDate]);
  var isDateDisabled = (0, _react.useCallback)(function (date) {
    return finalDisableRange && (0, _utils.inRange)(date, finalDisableRange) || disableDate && disableDate(date, selectType || 'date');
  }, [disableDate, finalDisableRange, selectType]);
  return {
    finalDisableRange: finalDisableRange,
    finalTodayDate: finalTodayDate,
    isDateDisabled: isDateDisabled
  };
}