"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _Skeleton = _interopRequireDefault(require("../Skeleton"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _CardActions = _interopRequireDefault(require("./CardActions"));

var _CardContent = _interopRequireDefault(require("./CardContent"));

var _CardHeader = _interopRequireDefault(require("./CardHeader"));

var _CardMeta = _interopRequireDefault(require("./CardMeta"));

var _styled = require("./styled");

var _excluded = ["children", "extra", "styles", "shadowed", "hoverShadowed", "bordered", "loading"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Card = (0, _memoForwardRef["default"])(function (props, ref) {
  var children = props.children,
      extra = props.extra,
      styles = props.styles,
      _props$shadowed = props.shadowed,
      shadowed = _props$shadowed === void 0 ? true : _props$shadowed,
      _props$hoverShadowed = props.hoverShadowed,
      hoverShadowed = _props$hoverShadowed === void 0 ? true : _props$hoverShadowed,
      _props$bordered = props.bordered,
      bordered = _props$bordered === void 0 ? false : _props$bordered,
      _props$loading = props.loading,
      loading = _props$loading === void 0 ? false : _props$loading,
      others = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var defaultStyles = (0, _react.useMemo)(function () {
    return {
      extraWrapper: ''
    };
  }, []);
  var innerStyles = (0, _useStyles["default"])('card', defaultStyles, styles);
  var _theme$components$Car = theme.components.Card.skeleton,
      height = _theme$components$Car.height,
      width = _theme$components$Car.width;
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledCard, (0, _extends2["default"])({
    ref: ref,
    theme: theme,
    $shadowed: shadowed,
    $hoverShadowed: hoverShadowed,
    $bordered: bordered
  }, others), /*#__PURE__*/_react["default"].createElement(_Skeleton["default"], {
    active: true,
    loading: loading,
    type: "card",
    style: {
      width: width,
      height: height
    }
  }, extra ? /*#__PURE__*/_react["default"].createElement(_styled.StyleCardExtra, (0, _extends2["default"])({
    theme: theme
  }, innerStyles.extraWrapper), extra) : null, children));
});
Card.Content = _CardContent["default"];
Card.Header = _CardHeader["default"];
Card.Actions = _CardActions["default"];
Card.Meta = _CardMeta["default"];
var _default = Card;
exports["default"] = _default;