"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Checkbox = _interopRequireDefault(require("../Checkbox"));

var _useCheckbox2 = _interopRequireDefault(require("../Checkbox/useCheckbox"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _Card = _interopRequireDefault(require("./Card"));

var _styled = require("./styled");

var _excluded = ["children", "onChange", "checked", "defaultChecked", "styles", "showCheckbox", "size", "inputRef", "checkboxProps"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var CheckBoxCardWrapper = (0, _styledComponents["default"])(_Card["default"]).withConfig({
  displayName: "CheckBoxCardWrapper"
})(["", ""], function (props) {
  var _props$theme$componen = props.theme.components.Card.checkbox,
      checkedBorder = _props$theme$componen.checkedBorder,
      normalBorder = _props$theme$componen.normalBorder;

  if (props.$checked) {
    return (0, _styledComponents.css)(["border:", ";"], checkedBorder);
  } else {
    return (0, _styledComponents.css)(["border:", ";"], normalBorder);
  }
});
var defaultStyles = {
  checkBoxWrapper: '',
  extraWrapper: ''
};
var CheckBoxCard = (0, _memoForwardRef["default"])(function (props, ref) {
  var children = props.children,
      onChange = props.onChange,
      checked = props.checked,
      defaultChecked = props.defaultChecked,
      styles = props.styles,
      _props$showCheckbox = props.showCheckbox,
      showCheckbox = _props$showCheckbox === void 0 ? true : _props$showCheckbox,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      inputRef = props.inputRef,
      checkboxProps = props.checkboxProps,
      others = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();

  var _useCheckbox = (0, _useCheckbox2["default"])(props, 'checked' in props),
      checkedState = _useCheckbox.checkedState,
      handleChange = _useCheckbox.handleChange;

  var innerStyles = (0, _useStyles["default"])('card', defaultStyles, styles);
  return /*#__PURE__*/_react["default"].createElement(CheckBoxCardWrapper, (0, _extends2["default"])({
    $checked: checkedState,
    theme: theme,
    styles: styles,
    ref: ref
  }, others), showCheckbox ? /*#__PURE__*/_react["default"].createElement(_styled.StyleCardCheckBox, (0, _extends2["default"])({
    theme: theme
  }, innerStyles.checkBoxWrapper), /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], (0, _extends2["default"])({}, checkboxProps, {
    checked: checkedState,
    onChange: handleChange,
    size: size,
    inputRef: inputRef
  }))) : null, children);
});
var _default = CheckBoxCard;
exports["default"] = _default;