"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _Card = _interopRequireDefault(require("./Card"));

var _CardActions = _interopRequireDefault(require("./CardActions"));

var _CardContent = _interopRequireDefault(require("./CardContent"));

var _CardHeader = _interopRequireDefault(require("./CardHeader"));

var _CardMeta = _interopRequireDefault(require("./CardMeta"));

var _excluded = ["children", "imgHeight", "src", "space", "title", "text", "actions", "actionsPadding", "contentPadding", "styles", "headerProps"];
var CommonCardWrapper = (0, _styledComponents["default"])(_Card["default"]).withConfig({
  displayName: "CommonCardWrapper"
})(["display:flex;flex-direction:column;"]);
var CardContentWrapper = (0, _styledComponents["default"])(_CardContent["default"]).withConfig({
  displayName: "CardContentWrapper"
})(["flex:1;"]);
var defaultStyles = {
  headerWrapper: '',
  contentWrapper: '',
  actionWrapper: '',
  metaWrapper: ''
};
var CommonCard = (0, _memoForwardRef["default"])(function (props, ref) {
  var children = props.children,
      imgHeight = props.imgHeight,
      src = props.src,
      _props$space = props.space,
      space = _props$space === void 0 ? 4 : _props$space,
      title = props.title,
      text = props.text,
      actions = props.actions,
      actionsPadding = props.actionsPadding,
      contentPadding = props.contentPadding,
      styles = props.styles,
      headerProps = props.headerProps,
      others = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var innerStyles = (0, _useStyles["default"])('card', defaultStyles, styles);
  return /*#__PURE__*/_react["default"].createElement(CommonCardWrapper, (0, _extends2["default"])({
    ref: ref
  }, others), headerProps || src && imgHeight ? /*#__PURE__*/_react["default"].createElement(_CardHeader["default"], (0, _extends2["default"])({
    height: imgHeight,
    src: src
  }, headerProps, innerStyles.headerWrapper)) : null, title || text ? /*#__PURE__*/_react["default"].createElement(CardContentWrapper, (0, _extends2["default"])({
    padding: contentPadding
  }, innerStyles.contentWrapper), /*#__PURE__*/_react["default"].createElement(_CardMeta["default"], (0, _extends2["default"])({
    title: title,
    text: text,
    space: space
  }, innerStyles.metaWrapper))) : null, actions ? /*#__PURE__*/_react["default"].createElement(_CardActions["default"], (0, _extends2["default"])({
    padding: actionsPadding
  }, innerStyles.actionWrapper), actions) : null);
});
var _default = CommonCard;
exports["default"] = _default;