"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledCardHeaderContainer = exports.StyledCardHeader = exports.StyledCardContent = exports.StyledCardActions = exports.StyledCard = exports.StyleCardMeta = exports.StyleCardExtra = exports.StyleCardCheckBox = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _props = require("../utils/props");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledCard = _styledComponents["default"].div.withConfig({
  displayName: "StyledCard"
})(["", ""], function (props) {
  var theme = props.theme,
      $bordered = props.$bordered,
      $shadowed = props.$shadowed,
      $hoverShadowed = props.$hoverShadowed;
  var cardToken = theme.components.Card;
  var border = $bordered ? cardToken.border : '';
  var shadow = $shadowed ? cardToken.boxShadow.normal : '';
  return (0, _styledComponents.css)(["position:relative;border-radius:", "px;box-shadow:", ";border:", ";overflow:hidden;&:hover{box-shadow:", ";}"], cardToken.borderRadius, shadow, border, $hoverShadowed ? cardToken.boxShadow.hover : '');
});

exports.StyledCard = StyledCard;

var StyledCardHeader = _styledComponents["default"].div.withConfig({
  displayName: "StyledCardHeader"
})([""]);

exports.StyledCardHeader = StyledCardHeader;

var StyledCardHeaderContainer = _styledComponents["default"].div.withConfig({
  displayName: "StyledCardHeaderContainer"
})(["", ""], function (props) {
  var theme = props.theme,
      $padding = props.$padding,
      $bordered = props.$bordered;
  var cardToken = theme.components.Card;
  var padding = (0, _props.isValidProps)($padding) && String($padding);
  return (0, _styledComponents.css)(["display:flex;align-items:center;justify-content:space-between;padding:", ";border-bottom:", ";"], padding ? padding : cardToken.header.padding, $bordered && cardToken.header.bottomBorder);
});

exports.StyledCardHeaderContainer = StyledCardHeaderContainer;

var StyledCardContent = _styledComponents["default"].div.withConfig({
  displayName: "StyledCardContent"
})(["", ""], function (props) {
  var theme = props.theme,
      $padding = props.$padding;
  var cardToken = theme.components.Card;
  var padding = (0, _props.isValidProps)($padding) && String($padding);
  return (0, _styledComponents.css)(["padding:", ";"], padding ? padding : cardToken.content.padding);
});

exports.StyledCardContent = StyledCardContent;

var StyledCardActions = _styledComponents["default"].div.withConfig({
  displayName: "StyledCardActions"
})(["", ""], function (props) {
  var theme = props.theme,
      $padding = props.$padding,
      $bordered = props.$bordered;
  var cardToken = theme.components.Card;
  var padding = (0, _props.isValidProps)($padding) && String($padding);
  return (0, _styledComponents.css)(["display:flex;padding:", ";border-top:", ";"], padding ? padding : cardToken.actions.padding, $bordered && cardToken.actions.topBorder);
});

exports.StyledCardActions = StyledCardActions;

var StyleCardExtra = _styledComponents["default"].div.withConfig({
  displayName: "StyleCardExtra"
})(["", ""], function (props) {
  var theme = props.theme;
  var cardToken = theme.components.Card;
  return (0, _styledComponents.css)(["position:absolute;top:", "px;right:", "px;"], cardToken.extra.topPadding, cardToken.extra.rightPadding);
});

exports.StyleCardExtra = StyleCardExtra;

var StyleCardMeta = _styledComponents["default"].div.withConfig({
  displayName: "StyleCardMeta"
})([""]);

exports.StyleCardMeta = StyleCardMeta;

var StyleCardCheckBox = _styledComponents["default"].div.withConfig({
  displayName: "StyleCardCheckBox"
})(["", ""], function (props) {
  var theme = props.theme;
  var cardToken = theme.components.Card;
  return (0, _styledComponents.css)(["position:absolute;top:", "px;right:", "px;z-index:1;"], cardToken.checkbox.topPadding, cardToken.checkbox.rightPadding);
});

exports.StyleCardCheckBox = StyleCardCheckBox;