"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _useEventCallback2 = require("@muya-ui/utils/lib/hooks/useEventCallback");

var _useAfterEffect3 = require("@muya-ui/utils/lib/hooks/useAfterEffect");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Animation = _interopRequireDefault(require("../Animation"));

var _Img = _interopRequireWildcard(require("../Img"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _withTheme = require("../utils/withTheme");

var _PagerButton = _interopRequireDefault(require("./PagerButton"));

var _styled = require("./styled");

var _useMoveActive2 = _interopRequireDefault(require("./useMoveActive"));

var _utils = require("./utils");

var _excluded = ["imgs", "index", "defaultIndex", "autoplay", "arrow", "arrowEnabled", "arrowSize", "indicator", "indicatorTrigger", "duration", "onChange", "animation", "lazy", "styles", "indicatorStyles", "enableDiffChildren", "children", "onMouseEnter", "onMouseLeave"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledImg = (0, _styledComponents["default"])(_Img["default"]).withConfig({
  displayName: "StyledImg"
})(["width:100%;height:100%;position:absolute;top:0;left:0;"]);
var defaultStyles = {
  pagerPrev: '',
  pagerPrevBtn: '',
  pagerNext: '',
  pagerNextBtn: '',
  indicator: '',
  swipe: '',
  img: ''
};
var AnimCarouselPure = (0, _memoForwardRef["default"])(function (props, ref) {
  var imgs = props.imgs,
      index = props.index,
      _props$defaultIndex = props.defaultIndex,
      defaultIndex = _props$defaultIndex === void 0 ? 0 : _props$defaultIndex,
      _props$autoplay = props.autoplay,
      autoplay = _props$autoplay === void 0 ? 0 : _props$autoplay,
      _props$arrow = props.arrow,
      arrow = _props$arrow === void 0 ? 'always' : _props$arrow,
      _props$arrowEnabled = props.arrowEnabled,
      arrowEnabled = _props$arrowEnabled === void 0 ? 'always' : _props$arrowEnabled,
      _props$arrowSize = props.arrowSize,
      arrowSize = _props$arrowSize === void 0 ? 'm' : _props$arrowSize,
      _props$indicator = props.indicator,
      indicator = _props$indicator === void 0 ? 'center' : _props$indicator,
      indicatorTrigger = props.indicatorTrigger,
      _props$duration = props.duration,
      duration = _props$duration === void 0 ? 300 : _props$duration,
      onChange = props.onChange,
      _props$animation = props.animation,
      animation = _props$animation === void 0 ? 'fade' : _props$animation,
      lazy = props.lazy,
      styles = props.styles,
      indicatorStyles = props.indicatorStyles,
      enableDiffChildren = props.enableDiffChildren,
      children = props.children,
      onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);

  var _useMemo = (0, _react.useMemo)(function () {
    return (0, _utils.transformImgs)(imgs);
  }, [imgs]),
      innerImgs = _useMemo.imgs,
      isItems = _useMemo.isItems,
      imgItems = _useMemo.imgItems;

  var innerStyles = (0, _useStyles["default"])('carousel', defaultStyles, styles);
  var isControlled = ('index' in props);

  var _useState = (0, _react.useState)(defaultIndex),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      indexState = _useState2[0],
      setIndexState = _useState2[1];

  var finalIndex = isControlled ? index || 0 : indexState;
  var canSwipe = innerImgs.length > 1;

  var _useMoveActive = (0, _useMoveActive2["default"])(arrowEnabled === 'always'),
      shouldActive = _useMoveActive.shouldActive,
      setMoveActive = _useMoveActive.setMoveActive;

  var updateIndex = shouldActive(function (i) {
    setIndexState(i);
    onChange && onChange(innerImgs[i], i);
  });
  var onIndexChange = (0, _react.useCallback)(function (i) {
    updateIndex(i);
  }, [updateIndex]);
  var onPrev = (0, _react.useCallback)(function () {
    if (finalIndex === 0) {
      updateIndex(innerImgs.length - 1);
    } else {
      updateIndex(finalIndex - 1);
    }
  }, [finalIndex, innerImgs.length, updateIndex]);
  var onNext = (0, _react.useCallback)(function () {
    if (finalIndex === innerImgs.length - 1) {
      updateIndex(0);
    } else {
      updateIndex(finalIndex + 1);
    }
  }, [finalIndex, innerImgs.length, updateIndex]);
  var pagerNode = (0, _react.useMemo)(function () {
    return arrow !== 'none' && canSwipe ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_styled.StyledPagerPrev, innerStyles.pagerPrev, /*#__PURE__*/_react["default"].createElement(_PagerButton["default"], (0, _extends2["default"])({}, innerStyles.pagerPrevBtn, {
      arrow: "left",
      size: arrowSize,
      onClick: onPrev
    }))), /*#__PURE__*/_react["default"].createElement(_styled.StyledPagerNext, innerStyles.pagerNext, /*#__PURE__*/_react["default"].createElement(_PagerButton["default"], (0, _extends2["default"])({}, innerStyles.pagerNextBtn, {
      arrow: "right",
      size: arrowSize,
      onClick: onNext
    })))) : null;
  }, [arrow, arrowSize, canSwipe, innerStyles.pagerNext, innerStyles.pagerNextBtn, innerStyles.pagerPrev, innerStyles.pagerPrevBtn, onNext, onPrev]);
  var indicatorNode = (0, _react.useMemo)(function () {
    return indicator !== 'none' && canSwipe ? /*#__PURE__*/_react["default"].createElement(_styled.StyledIndexIndicator, (0, _extends2["default"])({}, innerStyles.indicator, {
      styles: indicatorStyles,
      trigger: indicatorTrigger,
      index: finalIndex,
      num: innerImgs.length,
      onChange: onIndexChange
    })) : null;
  }, [canSwipe, finalIndex, indicator, indicatorStyles, indicatorTrigger, innerImgs.length, innerStyles.indicator, onIndexChange]);

  var _useAfterEffect = (0, _useAfterEffect3.useAfterEffect)(onNext, autoplay * 1000),
      onActive = _useAfterEffect.onActive,
      onDisable = _useAfterEffect.onDisable;

  (0, _react.useEffect)(function () {
    if (finalIndex > innerImgs.length) {
      updateIndex(innerImgs.length - 1);
    }
  });
  var checkRegion = (0, _react.useRef)({
    top: -1,
    bottom: 1,
    left: -1,
    right: 1
  });
  var mouseEnterHandler = (0, _useEventCallback2.useEventCallback)(function (e) {
    onDisable();
    onMouseEnter && onMouseEnter(e);
  }, []);
  var mouseLeaveHandler = (0, _useEventCallback2.useEventCallback)(function (e) {
    onActive();
    onMouseLeave && onMouseLeave(e);
  }, []);
  var Anim;

  if (animation === 'grow') {
    Anim = _Animation["default"].Grow;
  } else {
    Anim = _Animation["default"].Fade;
  }

  var settings = (0, _react.useMemo)(function () {
    return {
      checkRegion: checkRegion.current
    };
  }, []);
  return /*#__PURE__*/_react["default"].createElement(_Img.ImgContainer, (0, _extends2["default"])({
    settings: settings
  }, otherProps, {
    ref: ref,
    onMouseEnter: mouseEnterHandler,
    onMouseLeave: mouseLeaveHandler
  }), innerImgs.map(function (imgSrc, i) {
    var selected = finalIndex === i;
    var imgNode;

    if (isItems) {
      var currentItem = imgItems[finalIndex];
      imgNode = /*#__PURE__*/_react["default"].createElement(StyledImg, (0, _extends2["default"])({}, innerStyles.img, {
        src: imgSrc,
        lazy: "off"
      }, currentItem.imgProps), currentItem.children);
    } else {
      imgNode = /*#__PURE__*/_react["default"].createElement(StyledImg, (0, _extends2["default"])({}, innerStyles.img, {
        src: imgSrc,
        lazy: "off"
      }));
    }

    return /*#__PURE__*/_react["default"].createElement(Anim, {
      key: i,
      timeout: duration,
      "in": selected,
      onEntered: function onEntered() {
        return setMoveActive(true);
      }
    }, imgNode);
  }), pagerNode, children, indicatorNode);
});
var AnimCarousel = (0, _styledComponents["default"])(AnimCarouselPure).withConfig({
  displayName: "AnimCarousel"
})(["", ""], _styled.carouselCss);

var _default = (0, _withTheme.withThemeForStyled)(AnimCarousel);

exports["default"] = _default;