"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Index = void 0;

var _utils = require("@muya-ui/theme-light/lib/utils");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _mergeStyleItem = _interopRequireDefault(require("../utils/mergeStyleItem"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _withTheme = require("../utils/withTheme");

var _excluded = ["selected", "color", "gutter"],
    _excluded2 = ["trigger", "index", "num", "color", "styles", "onChange"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var BaseNode = _styledComponents["default"].div.withConfig({
  displayName: "BaseNode"
})([""]);

var IndexPure = (0, _memoForwardRef["default"])(function (props, ref) {
  var selected = props.selected,
      color = props.color,
      gutter = props.gutter,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  return /*#__PURE__*/_react["default"].createElement(BaseNode, (0, _extends2["default"])({}, otherProps, {
    ref: ref
  }));
});
var Index = (0, _styledComponents["default"])(IndexPure).withConfig({
  displayName: "Index"
})(["display:inline-block;cursor:pointer;", ""], function (props) {
  var selected = props.selected,
      color = props.color,
      gutter = props.gutter,
      theme = props.theme;
  var _theme$transition$pat = theme.transition.pattern,
      easing = _theme$transition$pat.easing,
      duration = _theme$transition$pat.duration;
  var token = theme.components.Carousel.IndexIndicator;
  var innerColor = color || token.color;
  var width = selected ? token.selectedSize : token.size;
  var statusCss;

  if (selected) {
    statusCss = (0, _styledComponents.css)(["&::before{background-color:", ";}"], innerColor);
  } else {
    statusCss = (0, _styledComponents.css)(["&::before{background-color:", ";}&:hover{&::before{background-color:", ";}}"], _utils.colorUtils.transparentize(token.opacity, innerColor), _utils.colorUtils.transparentize(token.hoverOpacity, innerColor));
  }

  return (0, _styledComponents.css)(["padding:", "px 0;", " &::before{box-sizing:content-box;content:'';display:block;height:", "px;width:", "px;border-radius:", ";transition:all ", "ms ", ";}", ""], token.borderWidth, gutter && "margin-right: ".concat(token.gutter, "px;"), token.borderWidth, width, token.borderRadius, duration.status, easing.status, statusCss);
});
exports.Index = Index;
var IndexIndicatorPure = (0, _memoForwardRef["default"])(function (props, ref) {
  var trigger = props.trigger,
      index = props.index,
      num = props.num,
      color = props.color,
      styles = props.styles,
      onChange = props.onChange,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded2);
  var theme = (0, _useTheme["default"])();
  var innerStyles = (0, _useStyles["default"])('carousel-indicator', {
    index: '',
    active: ''
  }, styles);
  var indexes = [];

  var _loop = function _loop(i) {
    var selected = index === i;

    var itemOnChange = function itemOnChange() {
      if (!selected) {
        onChange && onChange(i);
      }
    };

    var indexProps = {};

    if (trigger === 'hover') {
      indexProps.onMouseEnter = itemOnChange;
    } else {
      indexProps.onClick = itemOnChange;
    }

    var styleItem = selected ? (0, _mergeStyleItem["default"])(innerStyles.active, innerStyles.index) : innerStyles.index;
    indexes.push( /*#__PURE__*/_react["default"].createElement(Index, (0, _extends2["default"])({}, styleItem, {
      key: i,
      color: color,
      theme: theme,
      gutter: i !== num - 1,
      selected: selected
    }, indexProps)));
  };

  for (var i = 0; i < num; i++) {
    _loop(i);
  }

  return /*#__PURE__*/_react["default"].createElement(BaseNode, (0, _extends2["default"])({}, otherProps, {
    ref: ref
  }), indexes);
});
var IndexIndicator = (0, _styledComponents["default"])(IndexIndicatorPure).withConfig({
  displayName: "IndexIndicator"
})(["white-space:nowrap;"]);

var _default = (0, _withTheme.withThemeForStyled)(IndexIndicator);

exports["default"] = _default;