"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _utils = require("@muya-ui/theme-light/lib/utils");

var _useEventCallback2 = require("@muya-ui/utils/lib/hooks/useEventCallback");

var _GuildRightIcon2 = require("@muya-ui/theme-light/lib/icons/GuildRightIcon");

var _GuildLeftIcon2 = require("@muya-ui/theme-light/lib/icons/GuildLeftIcon");

var _GuildDownIcon2 = require("@muya-ui/theme-light/lib/icons/GuildDownIcon");

var _GuildUpIcon2 = require("@muya-ui/theme-light/lib/icons/GuildUpIcon");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _withTheme = require("../utils/withTheme");

var _excluded = ["size", "disabled", "shape", "transparent", "arrow", "side", "icon", "onClick"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var BaseNode = _styledComponents["default"].button.withConfig({
  displayName: "BaseNode"
})([""]);

var PagerButtonPure = (0, _memoForwardRef["default"])(function (props, ref) {
  var size = props.size,
      disabled = props.disabled,
      shape = props.shape,
      transparent = props.transparent,
      _props$arrow = props.arrow,
      arrow = _props$arrow === void 0 ? 'left' : _props$arrow,
      side = props.side,
      icon = props.icon,
      onClick = props.onClick,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var iconNode = icon;
  var theme = (0, _useTheme["default"])();

  if (!iconNode) {
    var arrowIcon = (0, _extends2["default"])({
      top: _GuildUpIcon2.GuildUpIcon,
      bottom: _GuildDownIcon2.GuildDownIcon,
      left: _GuildLeftIcon2.GuildLeftIcon,
      right: _GuildRightIcon2.GuildRightIcon
    }, theme.components.Carousel.PagerButton.arrowIcon);
    var Icon = arrowIcon[arrow];
    iconNode = /*#__PURE__*/_react["default"].createElement(Icon, null);
  }

  var handleClick = (0, _useEventCallback2.useEventCallback)(function (e) {
    if (!disabled) {
      onClick && onClick(e);
    } else {
      e.preventDefault();
    }
  }, [disabled]);
  return /*#__PURE__*/_react["default"].createElement(BaseNode, (0, _extends2["default"])({}, otherProps, {
    disabled: disabled,
    onClick: handleClick,
    ref: ref
  }), iconNode);
});
var PagerButton = (0, _styledComponents["default"])(PagerButtonPure).withConfig({
  displayName: "PagerButton"
})(["position:relative;display:inline-flex;align-items:center;justify-content:center;cursor:pointer;user-select:none;outline:0;margin:0;border:none;font-family:inherit;text-transform:none;overflow:visible;box-sizing:border-box;appearance:button;", ""], function (props) {
  var _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      _props$shape = props.shape,
      shape = _props$shape === void 0 ? 'rect' : _props$shape,
      transparent = props.transparent,
      disabled = props.disabled,
      _props$arrow2 = props.arrow,
      arrow = _props$arrow2 === void 0 ? 'left' : _props$arrow2,
      side = props.side,
      theme = props.theme;
  var innerSide = side || arrow;
  var opacity = theme.opacity;
  var token = theme.components.Carousel.PagerButton;
  var width = token.width[size];
  var height = token.height[size];
  var iconSize = token.iconSize[size];
  var shapeCss;

  if (shape === 'rect') {
    var isH = arrow === 'left' || arrow === 'right';
    var innerWidth = isH ? width : height;
    var innerHeight = isH ? height : width;
    var sideCss;

    if (innerSide === 'left') {
      sideCss = (0, _styledComponents.css)(["border-top-left-radius:0;border-bottom-left-radius:0;"]);
    } else if (innerSide === 'right') {
      sideCss = (0, _styledComponents.css)(["border-top-right-radius:0;border-bottom-right-radius:0;"]);
    } else if (innerSide === 'top') {
      sideCss = (0, _styledComponents.css)(["border-top-right-radius:0;border-top-left-radius:0;"]);
    } else {
      sideCss = (0, _styledComponents.css)(["border-bottom-right-radius:0;border-bottom-left-radius:0;"]);
    }

    shapeCss = (0, _styledComponents.css)(["width:", "px;height:", "px;border-radius:", ";", ""], innerWidth, innerHeight, token.borderRadius, sideCss);
  } else {
    shapeCss = (0, _styledComponents.css)(["width:", "px;height:", "px;border-radius:50%;"], height, height);
  }

  var statusCss;

  if (disabled) {
    var color = _utils.colorUtils.transparentize(opacity.pattern.disabled, token.iconColor);

    statusCss = (0, _styledComponents.css)(["color:", ";cursor:not-allowed;"], color);
  } else if (transparent) {
    statusCss = (0, _styledComponents.css)(["color:", ";"], token.iconColor);
  } else {
    var bgAHColor = _utils.colorUtils.transparentize(token.hoverOpacity, token.bgColor);

    statusCss = (0, _styledComponents.css)(["color:", ";&:hover,&:active{background-color:", ";}"], token.iconColor, bgAHColor);
  }

  var bgCss;

  if (!transparent) {
    var bgColor = _utils.colorUtils.transparentize(token.opacity, token.bgColor);

    bgCss = (0, _styledComponents.css)(["background-color:", ";"], bgColor);
  } else {
    bgCss = (0, _styledComponents.css)(["background-color:transparent;"]);
  }

  return (0, _styledComponents.css)(["font-size:", "px;", " ", " ", ""], iconSize, shapeCss, bgCss, statusCss);
});

var _default = (0, _withTheme.withThemeForStyled)(PagerButton);

exports["default"] = _default;