"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Img = _interopRequireWildcard(require("../Img"));

var _Swipe = require("../Swipe");

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _withTheme = require("../utils/withTheme");

var _PagerButton = _interopRequireDefault(require("./PagerButton"));

var _styled = require("./styled");

var _useSwipeCarousel2 = _interopRequireDefault(require("./useSwipeCarousel"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledImg = (0, _styledComponents["default"])(_Img["default"]).withConfig({
  displayName: "StyledImg"
})(["height:100%;transform:translate3d(0,0,0);"]);
var StyledSwipe = (0, _styledComponents["default"])(_Swipe.LoopSwipe).withConfig({
  displayName: "StyledSwipe"
})(["height:100%;"]);
var defaultStyles = {
  pagerPrev: '',
  pagerPrevBtn: '',
  pagerNext: '',
  pagerNextBtn: '',
  indicator: '',
  swipe: '',
  img: ''
};
var imgContainerSettings = {
  checkRegion: {
    top: -1,
    bottom: 1,
    left: -1,
    right: 1
  }
};
var SwipeCarouselPure = (0, _memoForwardRef["default"])(function (props, ref) {
  var _useSwipeCarousel = (0, _useSwipeCarousel2["default"])(props),
      canSwipe = _useSwipeCarousel.canSwipe,
      isItems = _useSwipeCarousel.isItems,
      imgItems = _useSwipeCarousel.imgItems,
      innerImgs = _useSwipeCarousel.innerImgs,
      currentIndex = _useSwipeCarousel.currentIndex,
      imgLength = _useSwipeCarousel.imgLength,
      handlePrev = _useSwipeCarousel.handlePrev,
      handleNext = _useSwipeCarousel.handleNext,
      handleGoTo = _useSwipeCarousel.handleGoTo,
      handleMouseEnter = _useSwipeCarousel.handleMouseEnter,
      handleMouseLeave = _useSwipeCarousel.handleMouseLeave,
      handleTransitionEnd = _useSwipeCarousel.handleTransitionEnd,
      arrowSize = _useSwipeCarousel.arrowSize,
      arrow = _useSwipeCarousel.arrow,
      enableDiffChildren = _useSwipeCarousel.enableDiffChildren,
      lazy = _useSwipeCarousel.lazy,
      duration = _useSwipeCarousel.duration,
      indicatorTrigger = _useSwipeCarousel.indicatorTrigger,
      indicator = _useSwipeCarousel.indicator,
      children = _useSwipeCarousel.children,
      otherProps = _useSwipeCarousel.otherProps,
      styles = _useSwipeCarousel.styles,
      indicatorStyles = _useSwipeCarousel.indicatorStyles;

  var innerStyles = (0, _useStyles["default"])('carousel', defaultStyles, styles);
  var pagerNode = (0, _react.useMemo)(function () {
    return arrow !== 'none' && canSwipe ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_styled.StyledPagerPrev, innerStyles.pagerPrev, /*#__PURE__*/_react["default"].createElement(_PagerButton["default"], (0, _extends2["default"])({}, innerStyles.pagerPrevBtn, {
      arrow: "left",
      size: arrowSize,
      onClick: handlePrev
    }))), /*#__PURE__*/_react["default"].createElement(_styled.StyledPagerNext, innerStyles.pagerNext, /*#__PURE__*/_react["default"].createElement(_PagerButton["default"], (0, _extends2["default"])({}, innerStyles.pagerNextBtn, {
      arrow: "right",
      size: arrowSize,
      onClick: handleNext
    })))) : null;
  }, [arrow, arrowSize, canSwipe, handleNext, handlePrev, innerStyles.pagerNext, innerStyles.pagerNextBtn, innerStyles.pagerPrev, innerStyles.pagerPrevBtn]);
  var indicatorNode = (0, _react.useMemo)(function () {
    return indicator !== 'none' && canSwipe ? /*#__PURE__*/_react["default"].createElement(_styled.StyledIndexIndicator, (0, _extends2["default"])({}, innerStyles.indicator, {
      styles: indicatorStyles,
      trigger: indicatorTrigger,
      index: currentIndex,
      num: imgLength,
      onChange: handleGoTo
    })) : null;
  }, [canSwipe, currentIndex, handleGoTo, imgLength, indicator, indicatorStyles, indicatorTrigger, innerStyles.indicator]);
  var imgNodes = (0, _react.useMemo)(function () {
    if (innerImgs.length <= 0) {
      return;
    }

    return innerImgs.map(function (imgSrc, index) {
      if (isItems) {
        var currentItem = imgItems[index];
        return /*#__PURE__*/_react["default"].createElement(StyledImg, (0, _extends2["default"])({}, innerStyles.img, {
          key: index,
          src: imgSrc,
          lazy: lazy
        }, currentItem.imgProps), currentItem.children);
      }

      return /*#__PURE__*/_react["default"].createElement(StyledImg, (0, _extends2["default"])({}, innerStyles.img, {
        key: index,
        src: imgSrc,
        lazy: lazy
      }));
    });
  }, [imgItems, innerImgs, innerStyles.img, isItems, lazy]);
  var swipeNode = (0, _react.useMemo)(function () {
    if (innerImgs.length > 0) {
      return /*#__PURE__*/_react["default"].createElement(StyledSwipe, (0, _extends2["default"])({}, innerStyles.swipe, {
        equalNum: 1,
        duration: duration,
        stepIndex: currentIndex,
        onTransitionEnd: handleTransitionEnd,
        enableDiffChildren: enableDiffChildren
      }), imgNodes);
    }
  }, [currentIndex, duration, enableDiffChildren, handleTransitionEnd, imgNodes, innerImgs.length, innerStyles.swipe]);
  return /*#__PURE__*/_react["default"].createElement(_Img.ImgContainer, (0, _extends2["default"])({
    settings: imgContainerSettings,
    onMouseEnter: handleMouseEnter,
    onMouseLeave: handleMouseLeave
  }, otherProps, {
    ref: ref
  }), pagerNode, swipeNode, children, indicatorNode);
});
var SwipeCarousel = (0, _styledComponents["default"])(SwipeCarouselPure).withConfig({
  displayName: "SwipeCarousel"
})(["", ""], _styled.carouselCss);

var _default = (0, _withTheme.withThemeForStyled)(SwipeCarousel);

exports["default"] = _default;