"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useMoveActive;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireDefault(require("react"));

function useMoveActive(returnDirectly) {
  var _React$useState = _react["default"].useState(true),
      _React$useState2 = (0, _slicedToArray2["default"])(_React$useState, 2),
      moveActive = _React$useState2[0],
      setMoveActive = _React$useState2[1];

  var shouldActive = _react["default"].useCallback(function (fn) {
    var newFn = function newFn() {
      if (returnDirectly) {
        fn.apply(void 0, arguments);
        return;
      }

      if (!moveActive) {
        return;
      }

      setMoveActive(false);
      fn.apply(void 0, arguments);
    };

    return newFn;
  }, [moveActive, returnDirectly]);

  return {
    moveActive: moveActive,
    shouldActive: shouldActive,
    setMoveActive: setMoveActive
  };
}