"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useSwipeCarousel;

var _useEventCallback2 = require("@muya-ui/utils/lib/hooks/useEventCallback");

var _useAfterEffect3 = require("@muya-ui/utils/lib/hooks/useAfterEffect");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = require("react");

var _useMoveActive2 = _interopRequireDefault(require("./useMoveActive"));

var _utils = require("./utils");

var _excluded = ["imgs", "index", "defaultIndex", "duration", "autoplay", "arrow", "arrowEnabled", "arrowSize", "indicator", "indicatorTrigger", "onChange", "lazy", "animation", "styles", "indicatorStyles", "enableDiffChildren", "children", "onMouseEnter", "onMouseLeave"];

function useSwipeCarousel(props) {
  var imgs = props.imgs,
      index = props.index,
      _props$defaultIndex = props.defaultIndex,
      defaultIndex = _props$defaultIndex === void 0 ? 0 : _props$defaultIndex,
      duration = props.duration,
      _props$autoplay = props.autoplay,
      autoplay = _props$autoplay === void 0 ? 0 : _props$autoplay,
      _props$arrow = props.arrow,
      arrow = _props$arrow === void 0 ? 'always' : _props$arrow,
      _props$arrowEnabled = props.arrowEnabled,
      arrowEnabled = _props$arrowEnabled === void 0 ? 'always' : _props$arrowEnabled,
      _props$arrowSize = props.arrowSize,
      arrowSize = _props$arrowSize === void 0 ? 'm' : _props$arrowSize,
      _props$indicator = props.indicator,
      indicator = _props$indicator === void 0 ? 'center' : _props$indicator,
      indicatorTrigger = props.indicatorTrigger,
      onChange = props.onChange,
      lazy = props.lazy,
      animation = props.animation,
      styles = props.styles,
      indicatorStyles = props.indicatorStyles,
      enableDiffChildren = props.enableDiffChildren,
      children = props.children,
      onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);

  var _useMemo = (0, _react.useMemo)(function () {
    return (0, _utils.transformImgs)(imgs);
  }, [imgs]),
      innerImgs = _useMemo.imgs,
      isItems = _useMemo.isItems,
      imgItems = _useMemo.imgItems;

  var _useMoveActive = (0, _useMoveActive2["default"])(arrowEnabled === 'always'),
      shouldActive = _useMoveActive.shouldActive,
      setMoveActive = _useMoveActive.setMoveActive,
      moveActive = _useMoveActive.moveActive; // const onIndexChange = useMemo(() => shouldActive(onGoTo), [onGoTo, shouldActive]);


  var isControlled = ('index' in props);

  var _useState = (0, _react.useState)(defaultIndex),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      indexState = _useState2[0],
      setIndexState = _useState2[1];

  var finalIndex = isControlled ? index || 0 : indexState;
  var canSwipe = innerImgs.length > 1;
  var imgLength = innerImgs.length;
  var updateIndex = (0, _react.useCallback)(function (i) {
    setIndexState(i);

    if (onChange) {
      onChange(innerImgs[i], i);
    }
  }, [innerImgs, onChange]);
  var handlePrev = (0, _react.useMemo)(function () {
    return shouldActive(function () {
      var newIndex = finalIndex - 1;

      if (newIndex < 0) {
        newIndex = imgLength - 1;
      }

      updateIndex(newIndex);
    });
  }, [finalIndex, imgLength, shouldActive, updateIndex]);
  var handleNext = (0, _react.useMemo)(function () {
    return shouldActive(function () {
      var newIndex = finalIndex + 1;

      if (newIndex > imgLength - 1) {
        newIndex = 0;
      }

      updateIndex(newIndex);
    });
  }, [finalIndex, imgLength, shouldActive, updateIndex]);
  var handleGoTo = (0, _react.useMemo)(function () {
    return shouldActive(function (i) {
      if (i >= 0 && i < imgLength) {
        updateIndex(i);
      }
    });
  }, [imgLength, shouldActive, updateIndex]);

  var _useAfterEffect = (0, _useAfterEffect3.useAfterEffect)(handleNext, autoplay * 1000),
      onActive = _useAfterEffect.onActive,
      onDisable = _useAfterEffect.onDisable,
      autoplayActive = _useAfterEffect.active;

  var handleMouseEnter = (0, _useEventCallback2.useEventCallback)(function (e) {
    onDisable();
    onMouseEnter && onMouseEnter(e);
  }, []);
  var handleMouseLeave = (0, _useEventCallback2.useEventCallback)(function (e) {
    onActive();
    onMouseLeave && onMouseLeave(e);
  }, []);
  var handleTransitionEnd = (0, _useEventCallback2.useEventCallback)(function () {
    return setMoveActive(true);
  });
  return {
    canSwipe: canSwipe,
    isItems: isItems,
    imgItems: imgItems,
    innerImgs: innerImgs,
    currentIndex: finalIndex,
    imgLength: imgLength,
    autoplayActive: autoplayActive,
    moveActive: moveActive,
    // 处理函数
    handlePrev: handlePrev,
    handleNext: handleNext,
    handleGoTo: handleGoTo,
    handleMouseEnter: handleMouseEnter,
    handleMouseLeave: handleMouseLeave,
    handleTransitionEnd: handleTransitionEnd,
    // 直接往下传
    arrowSize: arrowSize,
    arrow: arrow,
    enableDiffChildren: enableDiffChildren,
    lazy: lazy,
    duration: duration,
    indicatorTrigger: indicatorTrigger,
    indicator: indicator,
    children: children,
    otherProps: otherProps,
    styles: styles,
    indicatorStyles: indicatorStyles
  };
}