"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _get2 = _interopRequireDefault(require("lodash/get"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _react = _interopRequireWildcard(require("react"));

var _BaseMenu = _interopRequireDefault(require("../BaseMenu"));

var _useLocale = _interopRequireDefault(require("../Locale/useLocale"));

var _Result = _interopRequireDefault(require("../Result"));

var _Trigger = _interopRequireDefault(require("../Trigger"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = require("../utils/useTheme");

var _CascaderInput = _interopRequireDefault(require("./CascaderInput"));

var _CascaderPanel = _interopRequireDefault(require("./CascaderPanel"));

var _PureCascaderPanel = _interopRequireDefault(require("./PureCascaderPanel"));

var _styled = require("./styled");

var _useCascader2 = _interopRequireDefault(require("./useCascader"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  inputWrapper: '',
  resultMenu: '',
  resultMenuItem: ''
};
var defaultMaxItemCountPerPage = 6.5;

var Cascader = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var locale = (0, _useLocale["default"])();
  var theme = (0, _useTheme.useTheme)();
  var styles = props.styles,
      inputRef = props.inputRef,
      className = props.className,
      style = props.style,
      children = props.children,
      showSearch = props.showSearch,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      notFoundContent = props.notFoundContent,
      _props$maxItemCountPe = props.maxItemCountPerPage,
      maxItemCountPerPage = _props$maxItemCountPe === void 0 ? defaultMaxItemCountPerPage : _props$maxItemCountPe;
  var pickStyles = (0, _react.useMemo)(function () {
    if (styles) {
      var inputWrapper = styles.inputWrapper,
          resultMenu = styles.resultMenu,
          resultMenuItem = styles.resultMenuItem;
      return {
        inputWrapper: inputWrapper,
        resultMenu: resultMenu,
        resultMenuItem: resultMenuItem
      };
    }
  }, [styles]);
  var innerStyles = (0, _useStyles["default"])('cascader', defaultStyles, pickStyles);
  var nodeRef = (0, _react.useRef)(null);
  var innerInputRef = (0, _react.useRef)(null);
  var handleRef = (0, _useForkRef2.useForkRef)(nodeRef, ref);
  var handleInputRef = (0, _useForkRef2.useForkRef)(inputRef, innerInputRef);
  var menuRef = (0, _react.useRef)(null);
  var firstSelectedItemRef = (0, _react.useRef)(null);

  var _useCascader = (0, _useCascader2["default"])(props, nodeRef, innerInputRef, menuRef, firstSelectedItemRef),
      inputProps = _useCascader.inputProps,
      panelProps = _useCascader.panelProps,
      triggerProps = _useCascader.triggerProps,
      searchResultProps = _useCascader.searchResultProps;

  var popupNode = (0, _react.useMemo)(function () {
    var searchValue = searchResultProps.searchValue,
        activeKey = searchResultProps.activeKey,
        fieldNames = searchResultProps.fieldNames,
        filterFieldName = searchResultProps.filterFieldName,
        firstSelectedOption = searchResultProps.firstSelectedOption,
        menuWidth = searchResultProps.menuWidth,
        filterOptions = searchResultProps.filterOptions,
        optionSelectedIndex = searchResultProps.optionSelectedIndex,
        handleOptionClick = searchResultProps.handleOptionClick,
        handleOptionMouseEnter = searchResultProps.handleOptionMouseEnter;
    var renderOption = panelProps.renderOption;

    if (showSearch && searchValue) {
      var menuContent;
      var noResult = (0, _isEmpty2["default"])(filterOptions);

      if (noResult) {
        if (notFoundContent) {
          menuContent = notFoundContent;
        } else {
          menuContent = /*#__PURE__*/_react["default"].createElement(_styled.StyledNotFoundContent, {
            theme: theme
          }, /*#__PURE__*/_react["default"].createElement(_Result["default"], {
            subTitle: locale['Cascader.noResultText'],
            type: "emptySmall"
          }));
        }
      } else {
        menuContent = filterOptions.map(function (option) {
          var refProps = {};

          if (firstSelectedOption && firstSelectedOption === option) {
            refProps.ref = firstSelectedItemRef;
          }

          var label = option[fieldNames.label] || option[filterFieldName];
          return /*#__PURE__*/_react["default"].createElement(_BaseMenu["default"].Item, (0, _extends2["default"])({}, refProps, {
            key: option[filterFieldName].toString(),
            disabled: option.disabled,
            selected: optionSelectedIndex(option) !== -1,
            active: activeKey === option[filterFieldName].toString(),
            onClick: function onClick(e) {
              return handleOptionClick(option, e);
            },
            onMouseEnter: handleOptionMouseEnter
          }, innerStyles.resultMenuItem), renderOption ? renderOption(option) : label);
        });
      }

      return /*#__PURE__*/_react["default"].createElement(_BaseMenu["default"].Menu, (0, _extends2["default"])({
        ref: menuRef,
        maxItemCountPerPage: maxItemCountPerPage,
        width: (0, _get2["default"])(showSearch, 'matchInputWidth', true) || noResult ? menuWidth : undefined,
        size: size,
        tabIndex: -1
      }, innerStyles.resultMenu), menuContent);
    }

    return /*#__PURE__*/_react["default"].createElement(_PureCascaderPanel["default"], (0, _extends2["default"])({
      styles: styles
    }, panelProps));
  }, [innerStyles.resultMenu, innerStyles.resultMenuItem, locale, maxItemCountPerPage, notFoundContent, panelProps, searchResultProps, showSearch, size, styles, theme]);
  return /*#__PURE__*/_react["default"].createElement(_Trigger["default"], (0, _extends2["default"])({}, triggerProps, {
    popup: popupNode
  }), /*#__PURE__*/_react["default"].isValidElement(children) ? children : /*#__PURE__*/_react["default"].createElement(_CascaderInput["default"], (0, _extends2["default"])({
    ref: handleRef,
    inputRef: handleInputRef,
    className: [innerStyles.inputWrapper.className, className].join(' ').trim(),
    style: (0, _extends2["default"])({}, innerStyles.inputWrapper.style, style)
  }, inputProps)));
});

Cascader.__MUYA_CASCADER = true;
Cascader.Panel = _CascaderPanel["default"];
var _default = Cascader;
exports["default"] = _default;