"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _FoldIcon2 = require("@muya-ui/theme-light/lib/icons/FoldIcon");

var _omit2 = _interopRequireDefault(require("lodash/omit"));

var _endsWith2 = _interopRequireDefault(require("lodash/endsWith"));

var _react = _interopRequireWildcard(require("react"));

var _ExpandIcon = _interopRequireDefault(require("../ExpandIcon"));

var _Input = _interopRequireWildcard(require("../Input"));

var _styled = require("../Input/styled");

var _ExpandWrapper = _interopRequireDefault(require("../styled/components/ExpandWrapper"));

var _addPx = _interopRequireDefault(require("../utils/addPx"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _const = require("./const");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var CascaderInput = (0, _memoForwardRef["default"])(function (props, ref) {
  var id = props.id,
      status = props.status,
      disabled = props.disabled,
      readOnly = props.readOnly,
      placeholder = props.placeholder,
      _props$value = props.value,
      value = _props$value === void 0 ? [] : _props$value,
      inputValue = props.inputValue,
      disabledValue = props.disabledValue,
      inputRef = props.inputRef,
      expandIcon = props.expandIcon,
      popupVisible = props.popupVisible,
      multiple = props.multiple,
      width = props.width,
      maxTagTextLength = props.maxTagTextLength,
      maxVerticalTagCount = props.maxVerticalTagCount,
      maxTagWidth = props.maxTagWidth,
      hasRelatedValue = props.hasRelatedValue,
      style = props.style,
      className = props.className,
      showSearch = props.showSearch,
      onRemoveTag = props.onRemoveTag,
      onClear = props.onClear,
      onInput = props.onInput,
      onKeyDown = props.onKeyDown,
      renderTag = props.renderTag;
  var theme = (0, _useTheme["default"])();
  var token = theme.components.Select;
  var inputRestProps = (0, _omit2["default"])(props, _const.allCascaderInputProps);
  var suffixNode = (0, _react.useMemo)(function () {
    var DefaultExpandIcon = token.expandIcon || _FoldIcon2.FoldIcon;
    return /*#__PURE__*/_react["default"].createElement(_ExpandWrapper["default"], {
      theme: theme,
      $expanded: popupVisible
    }, /*#__PURE__*/_react["default"].createElement(_ExpandIcon["default"], {
      icon: expandIcon,
      DefaultIcon: DefaultExpandIcon,
      disabled: disabled
    }));
  }, [disabled, expandIcon, popupVisible, theme, token.expandIcon]);
  var singleModeNode = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement(_Input["default"], (0, _extends2["default"])({}, inputRestProps, {
      ref: ref,
      inputRef: inputRef,
      suffixNode: suffixNode,
      type: "text",
      disabled: disabled,
      width: typeof width === 'string' && (0, _endsWith2["default"])(width, '%') ? '100%' : width,
      placeholder: placeholder,
      value: inputValue,
      hasRelatedValue: hasRelatedValue,
      clearReplace: true,
      readOnly: readOnly || showSearch && !popupVisible || !showSearch,
      onClear: onClear,
      onInput: onInput,
      onKeyDown: onKeyDown,
      focusWhenClear: false,
      title: inputValue
    }));
  }, [disabled, hasRelatedValue, inputRef, inputRestProps, inputValue, onClear, onInput, onKeyDown, placeholder, popupVisible, readOnly, ref, showSearch, suffixNode, width]); // 渲染 input 和 tag

  var multipleModeNode = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement(_Input.TagsInput, (0, _extends2["default"])({}, inputRestProps, {
      ref: ref,
      suffixNode: suffixNode,
      inputRef: inputRef,
      width: typeof width === 'string' && (0, _endsWith2["default"])(width, '%') ? '100%' : width,
      disabled: disabled,
      value: value,
      inputValue: inputValue,
      disabledValue: disabledValue,
      hasRelatedValue: hasRelatedValue,
      placeholder: value.length > 0 ? '' : placeholder,
      scrollTopAfterEffect: popupVisible,
      maxTagTextLength: maxTagTextLength,
      maxVerticalTagCount: maxVerticalTagCount,
      maxTagWidth: maxTagWidth,
      onRemoveTag: onRemoveTag,
      onClear: onClear,
      readOnly: readOnly || !showSearch,
      allowInput: !!onInput,
      onInputKeyDown: onKeyDown,
      onInput: onInput,
      focusWhenClear: false,
      renderTag: renderTag
    }));
  }, [disabled, disabledValue, hasRelatedValue, inputRef, inputRestProps, inputValue, maxTagTextLength, maxTagWidth, maxVerticalTagCount, onClear, onInput, onKeyDown, onRemoveTag, placeholder, popupVisible, readOnly, ref, renderTag, showSearch, suffixNode, value, width]);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledPopperInputWrapper, {
    id: id,
    role: "combobox",
    key: "selection",
    $pointer: !disabled || readOnly,
    $popupVisible: popupVisible,
    $width: (0, _addPx["default"])(width),
    $status: status,
    theme: theme,
    style: style,
    className: className
  }, multiple ? multipleModeNode : singleModeNode);
});
var _default = CascaderInput;
exports["default"] = _default;