"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _useThrottle2 = require("@muya-ui/utils/lib/hooks/useThrottle");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _CascaderMenuItem = _interopRequireDefault(require("./CascaderMenuItem"));

var _useVirtualList2 = _interopRequireDefault(require("../utils/useVirtualList"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _default = /*#__PURE__*/_react["default"].memo(function (props) {
  var size = props.size,
      menuReverse = props.menuReverse,
      expandTrigger = props.expandTrigger,
      checkedKeys = props.checkedKeys,
      fieldNames = props.fieldNames,
      multiple = props.multiple,
      placement = props.placement,
      expandIcon = props.expandIcon,
      loadingIcon = props.loadingIcon,
      loadingKeys = props.loadingKeys,
      loadedKeys = props.loadedKeys,
      onLoad = props.onLoad,
      onSelect = props.onSelect,
      onDeselect = props.onDeselect,
      renderOption = props.renderOption,
      virtual = props.virtual,
      options = props.options,
      menuIndex = props.menuIndex,
      menuWidth = props.menuWidth,
      activeOptions = props.activeOptions,
      activeOptionsRef = props.activeOptionsRef,
      styles = props.styles,
      onMenuScroll = props.onMenuScroll;
  var hasScrollBar = options.length > 6;
  var theme = (0, _useTheme["default"])();
  var token = theme.components.Cascader;
  var itemHeight = token.item.height[size];
  var activeValue = activeOptions[menuIndex] && activeOptions[menuIndex][fieldNames.value];

  var _useVirtualList = (0, _useVirtualList2["default"])(virtual ? options : [], {
    itemHeight: itemHeight,
    overscan: token.overscan
  }),
      list = _useVirtualList.list,
      containerProps = _useVirtualList.containerProps,
      wrapperProps = _useVirtualList.wrapperProps;

  var containerStyle = (0, _react.useMemo)(function () {
    var containerStyle = styles.menu.style;

    if (virtual) {
      return (0, _extends2["default"])({}, containerStyle, containerProps.style);
    }

    return containerStyle;
  }, [containerProps.style, styles.menu.style, virtual]);
  var handleScroll = (0, _useThrottle2.useThrottle)((0, _react.useCallback)(function (e) {
    /* istanbul ignore else */
    if (virtual) {
      containerProps.onScroll(e);
    }
    /* istanbul ignore else */


    if (onMenuScroll) {
      onMenuScroll(e, menuIndex, activeOptions);
    }
  }, [activeOptions, containerProps, menuIndex, onMenuScroll, virtual]), 50);
  var renderItem = (0, _react.useCallback)(function (option) {
    var value = option[fieldNames.value];
    return /*#__PURE__*/_react["default"].createElement(_CascaderMenuItem["default"], (0, _extends2["default"])({
      activeOptionsRef: activeOptionsRef,
      key: value,
      loading: loadingKeys.indexOf(value) > -1,
      loaded: loadedKeys.indexOf(value) > -1,
      menuIndex: menuIndex,
      size: size,
      option: option,
      active: activeValue === value,
      expandTrigger: expandTrigger,
      checkedKeys: checkedKeys,
      fieldNames: fieldNames,
      expandIcon: expandIcon,
      loadingIcon: loadingIcon,
      multiple: multiple,
      placement: placement,
      onLoad: onLoad,
      onSelect: onSelect,
      onDeselect: onDeselect,
      renderOption: renderOption
    }, styles.menuItem));
  }, [activeOptionsRef, activeValue, checkedKeys, expandIcon, expandTrigger, fieldNames, loadedKeys, loadingIcon, loadingKeys, menuIndex, multiple, onDeselect, onLoad, onSelect, placement, renderOption, size, styles.menuItem]);
  var virtualChildren = (0, _react.useMemo)(function () {
    if (virtual) {
      return /*#__PURE__*/_react["default"].createElement("div", wrapperProps, list.map(function (_ref) {
        var option = _ref.data;
        return renderItem(option);
      }));
    }

    return null;
  }, [list, renderItem, virtual, wrapperProps]);
  var children = (0, _react.useMemo)(function () {
    return options.map(renderItem);
  }, [options, renderItem]);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledCascaderMenuBorderBox, (0, _extends2["default"])({
    theme: theme,
    menuReverse: menuReverse,
    hasScrollBar: hasScrollBar,
    onScroll: function onScroll(e) {
      return e.stopPropagation();
    }
  }, styles.menuBox), /*#__PURE__*/_react["default"].createElement(_styled.StyledCascaderMenu, {
    ref: containerProps.ref,
    size: size,
    theme: theme,
    menuWidth: menuWidth,
    className: styles.menu.className,
    style: containerStyle,
    onScroll: handleScroll
  }, virtual ? virtualChildren : children));
});

exports["default"] = _default;