"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _RightIcon2 = require("@muya-ui/theme-light/lib/icons/RightIcon");

var _react = _interopRequireWildcard(require("react"));

var _Checkbox = _interopRequireDefault(require("../Checkbox"));

var _EllipsisContent = _interopRequireDefault(require("../EllipsisContent"));

var _ExpandIcon = _interopRequireDefault(require("../ExpandIcon"));

var _Spin = _interopRequireDefault(require("../Spin"));

var _useTheme = require("../utils/useTheme");

var _styled = require("./styled");

var _useCascaderMenuItem2 = _interopRequireDefault(require("./useCascaderMenuItem"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _default = /*#__PURE__*/_react["default"].memo(function (props) {
  var size = props.size,
      menuIndex = props.menuIndex,
      option = props.option,
      active = props.active,
      expandIcon = props.expandIcon,
      loadingIcon = props.loadingIcon,
      loading = props.loading,
      multiple = props.multiple,
      style = props.style,
      className = props.className,
      activeOptionsRef = props.activeOptionsRef,
      renderOption = props.renderOption;
  var theme = (0, _useTheme.useTheme)();
  var token = theme.components.Cascader;
  var disabled = option.disabled,
      loadingFromOption = option.loading;

  var _useCascaderMenuItem = (0, _useCascaderMenuItem2["default"])(props),
      label = _useCascaderMenuItem.label,
      checked = _useCascaderMenuItem.checked,
      isLeaf = _useCascaderMenuItem.isLeaf,
      halfChecked = _useCascaderMenuItem.halfChecked,
      hasChildren = _useCascaderMenuItem.hasChildren,
      handleSelect = _useCascaderMenuItem.handleSelect,
      handleCheck = _useCascaderMenuItem.handleCheck,
      handleMouseEvent = _useCascaderMenuItem.handleMouseEvent;

  var handleRef = (0, _react.useCallback)(function (el) {
    if (active) {
      activeOptionsRef.current[menuIndex] = el;
    }
  }, [active, activeOptionsRef, menuIndex]);
  var suffixIconNode = (0, _react.useMemo)(function () {
    var suffixIconNode = null;

    if (loadingFromOption || loading) {
      suffixIconNode = loadingIcon || /*#__PURE__*/_react["default"].createElement(_Spin["default"], null);
    } else if (hasChildren || isLeaf === false) {
      var DefaultExpandIcon = token.menuExpandIcon || _RightIcon2.RightIcon;
      suffixIconNode = expandIcon || /*#__PURE__*/_react["default"].createElement(_ExpandIcon["default"], {
        icon: expandIcon,
        DefaultIcon: DefaultExpandIcon,
        style: {
          margin: token.item.iconMargin
        },
        disabled: disabled,
        buttonType: active ? 'primary' : 'weak'
      });
    }

    return suffixIconNode;
  }, [active, disabled, expandIcon, hasChildren, isLeaf, loading, loadingFromOption, loadingIcon, token.item.iconMargin, token.menuExpandIcon]);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledCascaderMenuItem, {
    ref: handleRef,
    role: "menuitem",
    size: size,
    $disabled: !!disabled,
    $selected: active,
    $multiple: multiple,
    onClick: handleSelect,
    onMouseEnter: handleMouseEvent,
    onMouseLeave: handleMouseEvent,
    theme: theme,
    style: style,
    className: className,
    onMouseDown: function onMouseDown(e) {
      return e.preventDefault();
    }
  }, /*#__PURE__*/_react["default"].createElement(_styled.StyledCascaderMenuItemContent, null, multiple && /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
    key: "checkbox",
    size: size,
    indeterminate: !checked && halfChecked,
    checked: checked,
    onChange: handleCheck,
    disabled: disabled
  }), renderOption ? renderOption(option, menuIndex) : /*#__PURE__*/_react["default"].createElement(_EllipsisContent["default"], {
    key: "label",
    enableTitle: true
  }, label)), suffixIconNode);
});

exports["default"] = _default;