"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _CascaderMenu = _interopRequireDefault(require("./CascaderMenu"));

var _styled = require("./styled");

var _useCascaderPanel2 = _interopRequireDefault(require("./useCascaderPanel"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  panel: '',
  menuBox: '',
  menu: '',
  menuItem: ''
};
var PureCascaderPanel = (0, _memoForwardRef["default"])(function (props, ref) {
  var size = props.size,
      menusWidth = props.menusWidth,
      menuReverse = props.menuReverse,
      expandTrigger = props.expandTrigger,
      checkedKeys = props.checkedKeys,
      styles = props.styles,
      fieldNames = props.fieldNames,
      multiple = props.multiple,
      placement = props.placement,
      expandIcon = props.expandIcon,
      loadingIcon = props.loadingIcon,
      loadingKeys = props.loadingKeys,
      loadedKeys = props.loadedKeys,
      onLoad = props.onLoad,
      onSelect = props.onSelect,
      onDeselect = props.onDeselect,
      renderOption = props.renderOption,
      virtual = props.virtual,
      onMenuScroll = props.onMenuScroll,
      pure = props.pure;
  var theme = (0, _useTheme["default"])();
  var activeOptionsRef = (0, _react.useRef)([]);
  var pickStyles = (0, _react.useMemo)(function () {
    if (styles) {
      var panel = styles.panel,
          menuBox = styles.menuBox,
          menu = styles.menu,
          menuItem = styles.menuItem;
      return {
        panel: panel,
        menuBox: menuBox,
        menu: menu,
        menuItem: menuItem
      };
    }
  }, [styles]);
  var innerStyles = (0, _useStyles["default"])('cascader', defaultStyles, pickStyles);

  var _useCascaderPanel = (0, _useCascaderPanel2["default"])(props, activeOptionsRef),
      showOptions = _useCascaderPanel.showOptions,
      activeOptions = _useCascaderPanel.activeOptions;

  return /*#__PURE__*/_react["default"].createElement(_styled.StyledCascaderPanel, (0, _extends2["default"])({
    ref: ref,
    theme: theme,
    menuReverse: menuReverse,
    $pure: !!pure
  }, innerStyles.panel), showOptions.map(function (options, menuIndex) {
    var menuWidth = menusWidth;

    if (Array.isArray(menusWidth)) {
      menuWidth = menusWidth[menuIndex];
    }

    return /*#__PURE__*/_react["default"].createElement(_CascaderMenu["default"], {
      key: menuIndex,
      size: size,
      menuReverse: menuReverse,
      expandTrigger: expandTrigger,
      checkedKeys: checkedKeys,
      fieldNames: fieldNames,
      multiple: multiple,
      placement: placement,
      expandIcon: expandIcon,
      loadingIcon: loadingIcon,
      loadingKeys: loadingKeys,
      loadedKeys: loadedKeys,
      onLoad: onLoad,
      onSelect: onSelect,
      onDeselect: onDeselect,
      renderOption: renderOption,
      virtual: virtual,
      options: options,
      menuIndex: menuIndex,
      menuWidth: menuWidth,
      activeOptions: activeOptions,
      activeOptionsRef: activeOptionsRef,
      onMenuScroll: onMenuScroll,
      styles: innerStyles
    });
  }));
});
var _default = PureCascaderPanel;
exports["default"] = _default;