"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledNotFoundContent = exports.StyledCascaderPanel = exports.StyledCascaderMenuItemContent = exports.StyledCascaderMenuItem = exports.StyledCascaderMenuBorderBox = exports.StyledCascaderMenu = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _styled = require("../Checkbox/styled");

var _styled2 = require("../ScrollView/styled");

var _item = require("../styled/mixins/item");

var _listReset = _interopRequireDefault(require("../styled/mixins/listReset"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var menuItemCss = function menuItemCss(props) {
  var size = props.size,
      $selected = props.$selected,
      $disabled = props.$disabled,
      $multiple = props.$multiple,
      _props$theme = props.theme,
      fontSize = _props$theme.typography.spec.fontSize,
      _props$theme$transiti = _props$theme.transition.pattern,
      duration = _props$theme$transiti.duration,
      easing = _props$theme$transiti.easing;
  var token = props.theme.components.Cascader.item;
  var fontLevel = token.fontLevel[size];
  return (0, _styledComponents.css)(["display:flex;justify-content:space-between;align-items:center;flex:1;box-sizing:border-box;font-size:", "px;line-height:1;height:", "px;cursor:pointer;transition:background-color ", "ms ", ",color ", "ms ", ";", " ", " ", " ", " ", "{margin-right:", "px;}"], fontSize[fontLevel], token.height[size], duration.status, easing.status, duration.status, easing.status, (0, _item.itemNormalStyle)(token), $selected && (0, _item.itemSelectedStyle)(token), $selected && $multiple && (0, _styledComponents.css)(["font-weight:", ";"], token.multipleSelectFontWeight), $disabled && (0, _item.itemDisabledStyle)(token), _styled.StyledCheckboxLabel, token.checkboxMarginRight);
};

var StyledCascaderMenuItem = _styledComponents["default"].li.withConfig({
  displayName: "StyledCascaderMenuItem"
})(["", ";", ";"], _listReset["default"], menuItemCss);

exports.StyledCascaderMenuItem = StyledCascaderMenuItem;

var StyledCascaderMenuItemContent = _styledComponents["default"].div.withConfig({
  displayName: "StyledCascaderMenuItemContent"
})(["display:flex;justify-content:flex-start;align-items:center;overflow:hidden;"]);
/**
 * menu
 */


exports.StyledCascaderMenuItemContent = StyledCascaderMenuItemContent;

var menuCss = function menuCss(props) {
  var size = props.size,
      menuWidth = props.menuWidth,
      theme = props.theme;
  var token = theme.components.Cascader;
  return (0, _styledComponents.css)(["position:relative;max-height:", "px;margin:", "px 0;background:", ";overflow-y:auto;overflow-x:hidden;", ";", ";"], token.maxHeight[size], token.menuMarginVertical, token.background, menuWidth ? "width: ".concat(menuWidth, "px") : 'min-width: 111px', (0, _styled2.scrollBarStyle)({
    theme: theme
  }));
};

var StyledCascaderMenu = _styledComponents["default"].ul.withConfig({
  displayName: "StyledCascaderMenu"
})(["", ";", ";"], _listReset["default"], menuCss); // 滚动条和菜单反向的样式


exports.StyledCascaderMenu = StyledCascaderMenu;
var menuReverseCss = (0, _styledComponents.css)(["border-left:1px solid ", ";&:last-child{border-left:none;}"], function (props) {
  return props.theme.colors.pattern.border.normal;
});
var menuNoReverseCss = (0, _styledComponents.css)(["border-right:1px solid ", ";&:last-child{border-right:none;}"], function (props) {
  return props.theme.colors.pattern.border.normal;
});

var menuBoxCss = function menuBoxCss(props) {
  var hasScrollBar = props.hasScrollBar,
      menuReverse = props.menuReverse,
      token = props.theme.components.Cascader;
  var scrollBarCss;

  if (hasScrollBar) {
    scrollBarCss = (0, _styledComponents.css)(["", "{margin-right:", "px;}", "{padding-left:", "px;margin-right:", "px;}", ";"], StyledCascaderMenu, token.menuMarginRight - 1, StyledCascaderMenuItem, token.item.paddingHorizontal, token.item.marginRight, menuReverse ? (0, _styledComponents.css)(["&:first-child{", "{margin-right:", "px;}}"], StyledCascaderMenu, token.menuMarginRight) : (0, _styledComponents.css)(["&:last-child{", "{margin-right:", "px;}}"], StyledCascaderMenu, token.menuMarginRight));
  } else {
    scrollBarCss = (0, _styledComponents.css)(["", ";"], menuReverse ? (0, _styledComponents.css)(["", "{padding-left:", "px;padding-right:", "px;}&:last-child{", "{padding-left:", "px;}}"], StyledCascaderMenuItem, token.item.paddingHorizontal - 1, token.item.paddingHorizontal, StyledCascaderMenuItem, token.item.paddingHorizontal) : (0, _styledComponents.css)(["", "{padding-left:", "px;padding-right:", "px;}&:last-child{", "{padding-right:", "px;}}"], StyledCascaderMenuItem, token.item.paddingHorizontal, token.item.paddingHorizontal - 1, StyledCascaderMenuItem, token.item.paddingHorizontal));
  }

  return (0, _styledComponents.css)(["background:", ";&:first-child{border-top-left-radius:", ";border-bottom-left-radius:", ";}&:last-child{border-top-right-radius:", ";border-bottom-right-radius:", ";}", " ", ""], token.background, token.borderRadius, token.borderRadius, token.borderRadius, token.borderRadius, menuReverse ? menuReverseCss : menuNoReverseCss, scrollBarCss);
};

var StyledCascaderMenuBorderBox = _styledComponents["default"].div.withConfig({
  displayName: "StyledCascaderMenuBorderBox"
})(["", ";"], menuBoxCss);

exports.StyledCascaderMenuBorderBox = StyledCascaderMenuBorderBox;

var menuWrapperCss = function menuWrapperCss(props) {
  var menuReverse = props.menuReverse,
      _props$theme2 = props.theme,
      shadows = _props$theme2.shadows,
      colors = _props$theme2.colors,
      $pure = props.$pure;
  var pureCss;

  if ($pure) {
    pureCss = (0, _styledComponents.css)(["box-shadow:none;border:1px solid ", ";"], colors.pattern.border.normal);
  }

  return (0, _styledComponents.css)(["display:flex;flex-direction:", ";box-shadow:", ";", ";"], menuReverse ? 'row-reverse' : 'row', shadows.pattern.popper.normal, pureCss);
};

var StyledCascaderPanel = _styledComponents["default"].div.withConfig({
  displayName: "StyledCascaderPanel"
})(["", ";", ";"], _listReset["default"], menuWrapperCss);

exports.StyledCascaderPanel = StyledCascaderPanel;

var StyledNotFoundContent = _styledComponents["default"].div.withConfig({
  displayName: "StyledNotFoundContent"
})(["display:flex;justify-content:center;align-items:center;height:", "px;"], function (props) {
  return props.theme.components.Cascader.notFoundPanelHeight;
});

exports.StyledNotFoundContent = StyledNotFoundContent;