"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useCascader;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _useEventCallback2 = require("@muya-ui/utils/lib/hooks/useEventCallback");

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _last2 = _interopRequireDefault(require("lodash/last"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _flattenDeep2 = _interopRequireDefault(require("lodash/flattenDeep"));

var _first2 = _interopRequireDefault(require("lodash/first"));

var _findIndex2 = _interopRequireDefault(require("lodash/findIndex"));

var _find2 = _interopRequireDefault(require("lodash/find"));

var _arrayTreeFilter = _interopRequireDefault(require("array-tree-filter"));

var _react = _interopRequireDefault(require("react"));

var _shallowEqual = require("shallow-equal");

var _useLocale = require("../Locale/useLocale");

var _array = require("../utils/array");

var _keyCode = require("../utils/keyCode");

var _useRealPlacement2 = _interopRequireDefault(require("../utils/useRealPlacement"));

var _useTheme = require("../utils/useTheme");

var _utils = require("./utils");

var _excluded = ["size", "multiple", "fieldNames", "styles", "inputWidth", "allowClear", "placeholder", "disabled", "readOnly", "maxVerticalTagCount", "collapseTags", "displayRender", "onKeyDown", "inputExpandIcon", "showSearch", "renderTag", "menusWidth", "expandIcon", "loadingIcon", "loadedKeys", "defaultLoadedKeys", "onLoad", "renderOption", "virtual", "onMenuScroll", "expandTrigger", "placement", "popupVisible", "getPopupContainer", "onPopupVisibleChange", "flip", "popperProps", "options", "value", "controlLeaf", "defaultValue", "changeOnSelect", "checkStrictly", "onChange", "children", "loadData"];

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return exports; }; var exports = {}, Op = Object.prototype, hasOwn = Op.hasOwnProperty, $Symbol = "function" == typeof Symbol ? Symbol : {}, iteratorSymbol = $Symbol.iterator || "@@iterator", asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator", toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag"; function define(obj, key, value) { return Object.defineProperty(obj, key, { value: value, enumerable: !0, configurable: !0, writable: !0 }), obj[key]; } try { define({}, ""); } catch (err) { define = function define(obj, key, value) { return obj[key] = value; }; } function wrap(innerFn, outerFn, self, tryLocsList) { var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator, generator = Object.create(protoGenerator.prototype), context = new Context(tryLocsList || []); return generator._invoke = function (innerFn, self, context) { var state = "suspendedStart"; return function (method, arg) { if ("executing" === state) throw new Error("Generator is already running"); if ("completed" === state) { if ("throw" === method) throw arg; return doneResult(); } for (context.method = method, context.arg = arg;;) { var delegate = context.delegate; if (delegate) { var delegateResult = maybeInvokeDelegate(delegate, context); if (delegateResult) { if (delegateResult === ContinueSentinel) continue; return delegateResult; } } if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) { if ("suspendedStart" === state) throw state = "completed", context.arg; context.dispatchException(context.arg); } else "return" === context.method && context.abrupt("return", context.arg); state = "executing"; var record = tryCatch(innerFn, self, context); if ("normal" === record.type) { if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue; return { value: record.arg, done: context.done }; } "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg); } }; }(innerFn, self, context), generator; } function tryCatch(fn, obj, arg) { try { return { type: "normal", arg: fn.call(obj, arg) }; } catch (err) { return { type: "throw", arg: err }; } } exports.wrap = wrap; var ContinueSentinel = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var IteratorPrototype = {}; define(IteratorPrototype, iteratorSymbol, function () { return this; }); var getProto = Object.getPrototypeOf, NativeIteratorPrototype = getProto && getProto(getProto(values([]))); NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype); var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype); function defineIteratorMethods(prototype) { ["next", "throw", "return"].forEach(function (method) { define(prototype, method, function (arg) { return this._invoke(method, arg); }); }); } function AsyncIterator(generator, PromiseImpl) { function invoke(method, arg, resolve, reject) { var record = tryCatch(generator[method], generator, arg); if ("throw" !== record.type) { var result = record.arg, value = result.value; return value && "object" == _typeof(value) && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) { invoke("next", value, resolve, reject); }, function (err) { invoke("throw", err, resolve, reject); }) : PromiseImpl.resolve(value).then(function (unwrapped) { result.value = unwrapped, resolve(result); }, function (error) { return invoke("throw", error, resolve, reject); }); } reject(record.arg); } var previousPromise; this._invoke = function (method, arg) { function callInvokeWithMethodAndArg() { return new PromiseImpl(function (resolve, reject) { invoke(method, arg, resolve, reject); }); } return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); }; } function maybeInvokeDelegate(delegate, context) { var method = delegate.iterator[context.method]; if (undefined === method) { if (context.delegate = null, "throw" === context.method) { if (delegate.iterator["return"] && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel; context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method"); } return ContinueSentinel; } var record = tryCatch(method, delegate.iterator, context.arg); if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel; var info = record.arg; return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel); } function pushTryEntry(locs) { var entry = { tryLoc: locs[0] }; 1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry); } function resetTryEntry(entry) { var record = entry.completion || {}; record.type = "normal", delete record.arg, entry.completion = record; } function Context(tryLocsList) { this.tryEntries = [{ tryLoc: "root" }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0); } function values(iterable) { if (iterable) { var iteratorMethod = iterable[iteratorSymbol]; if (iteratorMethod) return iteratorMethod.call(iterable); if ("function" == typeof iterable.next) return iterable; if (!isNaN(iterable.length)) { var i = -1, next = function next() { for (; ++i < iterable.length;) { if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next; } return next.value = undefined, next.done = !0, next; }; return next.next = next; } } return { next: doneResult }; } function doneResult() { return { value: undefined, done: !0 }; } return GeneratorFunction.prototype = GeneratorFunctionPrototype, define(Gp, "constructor", GeneratorFunctionPrototype), define(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) { var ctor = "function" == typeof genFun && genFun.constructor; return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name)); }, exports.mark = function (genFun) { return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun; }, exports.awrap = function (arg) { return { __await: arg }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () { return this; }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) { void 0 === PromiseImpl && (PromiseImpl = Promise); var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl); return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) { return result.done ? result.value : iter.next(); }); }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () { return this; }), define(Gp, "toString", function () { return "[object Generator]"; }), exports.keys = function (object) { var keys = []; for (var key in object) { keys.push(key); } return keys.reverse(), function next() { for (; keys.length;) { var key = keys.pop(); if (key in object) return next.value = key, next.done = !1, next; } return next.done = !0, next; }; }, exports.values = values, Context.prototype = { constructor: Context, reset: function reset(skipTempReset) { if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) { "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined); } }, stop: function stop() { this.done = !0; var rootRecord = this.tryEntries[0].completion; if ("throw" === rootRecord.type) throw rootRecord.arg; return this.rval; }, dispatchException: function dispatchException(exception) { if (this.done) throw exception; var context = this; function handle(loc, caught) { return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught; } for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i], record = entry.completion; if ("root" === entry.tryLoc) return handle("end"); if (entry.tryLoc <= this.prev) { var hasCatch = hasOwn.call(entry, "catchLoc"), hasFinally = hasOwn.call(entry, "finallyLoc"); if (hasCatch && hasFinally) { if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0); if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc); } else if (hasCatch) { if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0); } else { if (!hasFinally) throw new Error("try statement without catch or finally"); if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc); } } } }, abrupt: function abrupt(type, arg) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) { var finallyEntry = entry; break; } } finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null); var record = finallyEntry ? finallyEntry.completion : {}; return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record); }, complete: function complete(record, afterLoc) { if ("throw" === record.type) throw record.arg; return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel; }, finish: function finish(finallyLoc) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel; } }, "catch": function _catch(tryLoc) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.tryLoc === tryLoc) { var record = entry.completion; if ("throw" === record.type) { var thrown = record.arg; resetTryEntry(entry); } return thrown; } } throw new Error("illegal catch attempt"); }, delegateYield: function delegateYield(iterable, resultName, nextLoc) { return this.delegate = { iterator: values(iterable), resultName: resultName, nextLoc: nextLoc }, "next" === this.method && (this.arg = undefined), ContinueSentinel; } }, exports; }

var defaultFlipSetting = {
  enabled: true,
  flipVariationsByContent: true
};
var defaultLimit = 50;
var keepFilteredValueField = '__KEEP_FILTERED_OPTION_VALUE'; // eslint-disable-next-line complexity

function useCascader(props, nodeRef, inputRef, menuRef, firstSelectedItemRef) {
  var locale = (0, _useLocale.useLocale)();
  var theme = (0, _useTheme.useTheme)();
  var token = theme.components.Cascader;
  var isControlled = ('value' in props);
  var isPopupVisibleControlled = ('popupVisible' in props);
  var isLoadedControlled = ('loadedKeys' in props);
  var _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      _props$multiple = props.multiple,
      multiple = _props$multiple === void 0 ? false : _props$multiple,
      fieldNamesProp = props.fieldNames,
      styles = props.styles,
      inputWidth = props.inputWidth,
      _props$allowClear = props.allowClear,
      allowClear = _props$allowClear === void 0 ? true : _props$allowClear,
      _props$placeholder = props.placeholder,
      placeholder = _props$placeholder === void 0 ? locale['Cascader.placeholder'] : _props$placeholder,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      _props$readOnly = props.readOnly,
      readOnly = _props$readOnly === void 0 ? false : _props$readOnly,
      _props$maxVerticalTag = props.maxVerticalTagCount,
      maxVerticalTagCount = _props$maxVerticalTag === void 0 ? 2.5 : _props$maxVerticalTag,
      _props$collapseTags = props.collapseTags,
      collapseTags = _props$collapseTags === void 0 ? false : _props$collapseTags,
      _props$displayRender = props.displayRender,
      displayRender = _props$displayRender === void 0 ? _utils.defaultDisplayRender : _props$displayRender,
      onKeyDown = props.onKeyDown,
      inputExpandIcon = props.inputExpandIcon,
      showSearch = props.showSearch,
      renderTag = props.renderTag,
      menusWidth = props.menusWidth,
      expandIcon = props.expandIcon,
      loadingIcon = props.loadingIcon,
      loadedKeysProp = props.loadedKeys,
      defaultLoadedKeys = props.defaultLoadedKeys,
      onLoad = props.onLoad,
      renderOption = props.renderOption,
      _props$virtual = props.virtual,
      virtual = _props$virtual === void 0 ? false : _props$virtual,
      onMenuScroll = props.onMenuScroll,
      _props$expandTrigger = props.expandTrigger,
      expandTrigger = _props$expandTrigger === void 0 ? 'click' : _props$expandTrigger,
      _props$placement = props.placement,
      placement = _props$placement === void 0 ? 'bottom-start' : _props$placement,
      popupVisible = props.popupVisible,
      getPopupContainer = props.getPopupContainer,
      onPopupVisibleChange = props.onPopupVisibleChange,
      _props$flip = props.flip,
      flip = _props$flip === void 0 ? defaultFlipSetting : _props$flip,
      popperProps = props.popperProps,
      options = props.options,
      value = props.value,
      _props$controlLeaf = props.controlLeaf,
      controlLeaf = _props$controlLeaf === void 0 ? false : _props$controlLeaf,
      _props$defaultValue = props.defaultValue,
      defaultValue = _props$defaultValue === void 0 ? [] : _props$defaultValue,
      _props$changeOnSelect = props.changeOnSelect,
      changeOnSelect = _props$changeOnSelect === void 0 ? false : _props$changeOnSelect,
      _props$checkStrictly = props.checkStrictly,
      checkStrictly = _props$checkStrictly === void 0 ? false : _props$checkStrictly,
      onChange = props.onChange,
      children = props.children,
      loadData = props.loadData,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);

  var fieldNames = _react["default"].useMemo(function () {
    var fieldNames = fieldNamesProp || {};
    var names = {
      children: fieldNames.children || 'children',
      label: fieldNames.label || 'label',
      value: fieldNames.value || 'value',
      isLeaf: fieldNames.isLeaf || 'isLeaf'
    };
    return names;
  }, [fieldNamesProp]);

  var finalAllowClear = allowClear && !disabled && !readOnly;
  var filterFieldName = fieldNames.value === fieldNames.label ? keepFilteredValueField : fieldNames.value;

  var menuWidthRef = _react["default"].useRef(0); // state


  var _useRealPlacement = (0, _useRealPlacement2["default"])(placement),
      realPlacement = _useRealPlacement.realPlacement,
      onPopperCreate = _useRealPlacement.onPopperCreate;

  var _React$useState = _react["default"].useState(popupVisible || false),
      _React$useState2 = (0, _slicedToArray2["default"])(_React$useState, 2),
      popupVisibleState = _React$useState2[0],
      setPopupVisibleState = _React$useState2[1];

  var _React$useState3 = _react["default"].useState({
    loaded: (isLoadedControlled ? loadedKeysProp : defaultLoadedKeys) || [],
    loading: []
  }),
      _React$useState4 = (0, _slicedToArray2["default"])(_React$useState3, 2),
      loadKeys = _React$useState4[0],
      setLoadKeys = _React$useState4[1];

  var _React$useState5 = _react["default"].useState(function () {
    return multiple || controlLeaf ? (0, _utils.getEntityDataFromOptions)(options, fieldNames) : {
      keyEntities: {},
      posEntities: {},
      keyPathEntities: {},
      keyPosMap: {}
    };
  }),
      _React$useState6 = (0, _slicedToArray2["default"])(_React$useState5, 2),
      entityData = _React$useState6[0],
      setEntityData = _React$useState6[1];

  var _React$useState7 = _react["default"].useState(function () {
    return (0, _utils.getValueStateFromProps)((isControlled ? value : defaultValue) || [], multiple, controlLeaf, entityData.keyEntities, entityData.keyPosMap);
  }),
      _React$useState8 = (0, _slicedToArray2["default"])(_React$useState7, 2),
      valueState = _React$useState8[0],
      setValueState = _React$useState8[1];

  var _React$useState9 = _react["default"].useState(function () {
    return (0, _utils.getActiveStateFromValue)(valueState, multiple);
  }),
      _React$useState10 = (0, _slicedToArray2["default"])(_React$useState9, 2),
      activeValueState = _React$useState10[0],
      setActiveValueState = _React$useState10[1];

  var _React$useState11 = _react["default"].useState(function () {
    return multiple ? (0, _utils.calcCheckedKeys)((0, _utils.calValueEntity)(valueState, entityData.keyPathEntities), checkStrictly, true, entityData.keyEntities) : {
      checked: [],
      halfChecked: []
    };
  }),
      _React$useState12 = (0, _slicedToArray2["default"])(_React$useState11, 2),
      checkedKeysState = _React$useState12[0],
      setCheckedKeysState = _React$useState12[1];

  var _React$useState13 = _react["default"].useState(function () {
    return showSearch ? (0, _utils.flattenTree)({
      options: options,
      changeOnSelect: changeOnSelect,
      names: fieldNames
    }) : [];
  }),
      _React$useState14 = (0, _slicedToArray2["default"])(_React$useState13, 2),
      flattenOptions = _React$useState14[0],
      setFlattenOptions = _React$useState14[1];

  var _React$useState15 = _react["default"].useState(''),
      _React$useState16 = (0, _slicedToArray2["default"])(_React$useState15, 2),
      searchValue = _React$useState16[0],
      setSearchValue = _React$useState16[1];

  var _React$useState17 = _react["default"].useState(''),
      _React$useState18 = (0, _slicedToArray2["default"])(_React$useState17, 2),
      activeKey = _React$useState18[0],
      setActiveKey = _React$useState18[1]; // computed


  var finalPopupVisible = disabled || readOnly ? false : popupVisibleState;
  var menuReverse = realPlacement.indexOf('end') > -1;

  var currentLevelOptions = _react["default"].useMemo(function () {
    var result = (0, _arrayTreeFilter["default"])(options, function (o, level) {
      return o[fieldNames.value] === activeValueState[level];
    }, {
      childrenKeyName: fieldNames.children
    });

    if (result[result.length - 2]) {
      return result[result.length - 2][fieldNames.children] || [];
    }

    return (0, _toConsumableArray2["default"])(options).filter(function (o) {
      return !o.disabled;
    });
  }, [activeValueState, fieldNames.children, fieldNames.value, options]);

  var filterOptions = _react["default"].useMemo(function () {
    if (showSearch) {
      var _ref = showSearch,
          _ref$filter = _ref.filter,
          filter = _ref$filter === void 0 ? _utils.defaultFilterOption : _ref$filter,
          _ref$render = _ref.render,
          render = _ref$render === void 0 ? _utils.defaultRenderFilteredOption : _ref$render,
          _ref$sort = _ref.sort,
          sort = _ref$sort === void 0 ? _utils.defaultSortFilteredOption : _ref$sort,
          _ref$limit = _ref.limit,
          limit = _ref$limit === void 0 ? defaultLimit : _ref$limit;
      var filtered;

      if (limit > 0) {
        filtered = [];
        var matchCount = 0;
        flattenOptions.some(function (path) {
          var match = filter(searchValue, path, fieldNames);

          if (match) {
            filtered.push(path);
            matchCount += 1;
          }

          return matchCount >= limit;
        });
      } else {
        filtered = flattenOptions.filter(function (path) {
          return filter(searchValue, path, fieldNames);
        });
      }

      filtered = filtered.sort(function (a, b) {
        return sort(a, b, searchValue, fieldNames);
      }); // 如果父子选中状态不关联，将筛选的选项展开，包含关键词，且不包含子项的选项

      var filteredParent = [];

      var addOption = function addOption(option) {
        return filteredParent.some(function (item) {
          return option.map(function (o) {
            return o.label;
          }).join('/') === item.map(function (i) {
            return i.label;
          }).join('/');
        }) ? null : filteredParent.push(option);
      };

      if (checkStrictly) {
        filtered.forEach(function (option) {
          option.forEach(function (item, index) {
            if (item[fieldNames.label].indexOf(searchValue) > -1) {
              for (var i = index + 1; i < option.length; i++) {
                addOption(option.slice(0, i));
              }
            }
          });
        });
      }

      return [].concat(filteredParent, (0, _toConsumableArray2["default"])(filtered)).map(function (path) {
        var _ref2;

        return _ref2 = {
          __IS_FILTERED_OPTION: true,
          path: path
        }, (0, _defineProperty2["default"])(_ref2, filterFieldName, path.map(function (o) {
          return o[fieldNames.value];
        })), (0, _defineProperty2["default"])(_ref2, fieldNames.label, render(searchValue, path, fieldNames)), (0, _defineProperty2["default"])(_ref2, "disabled", path.some(function (o) {
          return !!o.disabled;
        })), _ref2;
      });
    }

    return [];
  }, [fieldNames, filterFieldName, flattenOptions, searchValue, showSearch, checkStrictly]);

  var firstSelectedOption = _react["default"].useMemo(function () {
    var firstValue;

    if (multiple) {
      firstValue = (0, _first2["default"])(valueState);
    } else {
      firstValue = valueState;
    }

    if (firstValue) {
      return (0, _find2["default"])(filterOptions, function (option) {
        return option[filterFieldName].toString() === firstValue.toString();
      });
    }
  }, [filterFieldName, filterOptions, multiple, valueState]);

  var inputValueInfo = _react["default"].useMemo(function () {
    if (multiple) {
      var disabledValue = [];
      var tagValues = valueState.map(function (value) {
        return (0, _arrayTreeFilter["default"])(options, function (o, level) {
          return o[fieldNames.value] === value[level];
        }, {
          childrenKeyName: fieldNames.children
        });
      }).map(function (options) {
        var labels = options.map(function (o) {
          return o[fieldNames.label] || o[fieldNames.value];
        });
        var v = displayRender(labels, options);
        var lastOption = (0, _last2["default"])(options);

        if (lastOption && lastOption.disabled) {
          disabledValue.push(v);
        }

        return v;
      }); // 折叠 tags 的情况下进行过滤

      if (collapseTags && tagValues.length > 1) {
        return {
          inputValue: '',
          value: [tagValues[0], "".concat(tagValues.length - 1, "+")],
          disabledValue: disabledValue
        };
      } else {
        return {
          inputValue: '',
          value: tagValues,
          disabledValue: disabledValue
        };
      }
    } else {
      var selectedOptions = (0, _arrayTreeFilter["default"])(options, function (o, level) {
        return o[fieldNames.value] === valueState[level];
      }, {
        childrenKeyName: fieldNames.children
      });
      var labels = selectedOptions.map(function (o) {
        return o[fieldNames.label] || o[fieldNames.value];
      });
      return {
        inputValue: displayRender(labels, selectedOptions)
      };
    }
  }, [collapseTags, displayRender, fieldNames.children, fieldNames.label, fieldNames.value, multiple, options, valueState]); // utils
  // 当前选中的选项


  var getSelectedOptions = _react["default"].useCallback(function (selectedValue) {
    if (multiple) {
      return selectedValue.map(function (value) {
        return (0, _arrayTreeFilter["default"])(options, function (o, level) {
          return o[fieldNames.value] === value[level];
        }, {
          childrenKeyName: fieldNames.children
        });
      });
    } else {
      return (0, _arrayTreeFilter["default"])(options, function (o, level) {
        return o[fieldNames.value] === selectedValue[level];
      }, {
        childrenKeyName: fieldNames.children
      });
    }
  }, [fieldNames.children, fieldNames.value, multiple, options]); // 当前打开激活的选项


  var getActiveOptions = _react["default"].useCallback(function (activeValue) {
    return (0, _arrayTreeFilter["default"])(options, function (o, level) {
      return o[fieldNames.value] === activeValue[level];
    }, {
      childrenKeyName: fieldNames.children
    });
  }, [fieldNames.children, fieldNames.value, options]); // popup


  var handlePopupVisibleChange = (0, _useEventCallback2.useEventCallback)(function (popupVisible) {
    if (popupVisible && !popupVisibleState && !multiple) {
      setActiveValueState((0, _utils.getActiveStateFromValue)(valueState, multiple));
    } // 面板打开时，同步更新 check 状态


    if (popupVisible && !popupVisibleState && multiple) {
      var newCheckedKeys = (0, _utils.calcCheckedKeys)((0, _utils.calValueEntity)(valueState, entityData.keyPathEntities), true, checkStrictly, entityData.keyEntities);

      if (!(0, _shallowEqual.shallowEqualArrays)(newCheckedKeys.checked, checkedKeysState.checked) || !(0, _shallowEqual.shallowEqualArrays)(newCheckedKeys.halfChecked, checkedKeysState.halfChecked)) {
        setCheckedKeysState(newCheckedKeys);
      }
    }

    if (!isPopupVisibleControlled) {
      setPopupVisibleState(popupVisible);
    }

    if (onPopupVisibleChange) {
      onPopupVisibleChange(popupVisible);
    } // 动态调整下拉菜单的宽度


    if (nodeRef.current && nodeRef.current.offsetWidth !== menuWidthRef.current && popupVisible) {
      menuWidthRef.current = nodeRef.current.offsetWidth;
    }
  }); // change

  var assertChangeEvent = _react["default"].useCallback(function (e) {
    return e.type !== 'keydown' || e.keyCode === _keyCode.KeyCode.ENTER || e.keyCode === _keyCode.KeyCode.BACKSPACE;
  }, []);

  var handleChange = _react["default"].useCallback(function (value, options, visible, e) {
    if (assertChangeEvent(e)) {
      if (!isControlled) {
        setValueState(value);
      }

      if (onChange) {
        var finalValue = value;

        if (controlLeaf) {
          finalValue = (0, _utils.getLeafValues)(finalValue, multiple);
        }

        onChange(finalValue, options);
      }

      handlePopupVisibleChange(visible);
    }
  }, [assertChangeEvent, isControlled, onChange, handlePopupVisibleChange, controlLeaf, multiple]);

  var handleLoad = (0, _useEventCallback2.useEventCallback)( /*#__PURE__*/function () {
    var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(targetValue, activeOptions) {
      var loadPromise;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              loadPromise = new Promise(function (resolve, reject) {
                setLoadKeys(function (preLoadKeys) {
                  var loaded = preLoadKeys.loaded,
                      loading = preLoadKeys.loading;

                  if (!loadData || loaded.indexOf(targetValue) !== -1 || loading.indexOf(targetValue) !== -1) {
                    return preLoadKeys;
                  }

                  var innerActiveOptions = activeOptions || getActiveOptions(activeValueState);
                  var promise = Promise.resolve(loadData(innerActiveOptions));
                  promise.then(function () {
                    if (!isLoadedControlled) {
                      setLoadKeys(function (prev) {
                        var newLoadedKeys = (0, _array.arrayAdd)(prev.loaded, targetValue);

                        if (onLoad) {
                          onLoad(newLoadedKeys);
                        }

                        return {
                          loaded: newLoadedKeys,
                          loading: (0, _array.arrayDel)(prev.loading, targetValue)
                        };
                      });
                    } else {
                      setLoadKeys(function (prev) {
                        if (onLoad) {
                          onLoad((0, _array.arrayAdd)(prev.loaded, targetValue));
                        }

                        return (0, _extends2["default"])({}, prev, {
                          loading: (0, _array.arrayDel)(prev.loading, targetValue)
                        });
                      });
                    }

                    resolve();
                  })["catch"](function (e) {
                    setLoadKeys(function (prev) {
                      return (0, _extends2["default"])({}, prev, {
                        loading: (0, _array.arrayDel)(prev.loading, targetValue)
                      });
                    });
                    reject(e);
                  });
                  return {
                    loaded: loaded,
                    loading: (0, _array.arrayAdd)(loading, targetValue)
                  };
                });
              });
              loadPromise["catch"](function () {});
              return _context.abrupt("return", loadPromise);

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x, _x2) {
      return _ref3.apply(this, arguments);
    };
  }()); // 菜单项点击、键盘触发、Checkbox 点击触发

  var handleSelect = (0, _useEventCallback2.useEventCallback)(
  /*#__PURE__*/
  // eslint-disable-next-line complexity
  function () {
    var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(targetOption, menuIndex, e) {
      var targetValue, newActiveValueState, newValueState, newCheckedKeysState, selectedOptions, activeOptions, _selectedOptions;

      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              // 保持 input 的 focus 状态
              if (inputRef && inputRef.current) {
                inputRef.current.focus();
              }

              if (targetOption.__IS_FILTERED_OPTION) {
                targetValue = (0, _last2["default"])(targetOption[filterFieldName]);
                newActiveValueState = targetOption[filterFieldName];
              } else {
                targetValue = targetOption[fieldNames.value];
                newActiveValueState = activeValueState.slice(0, menuIndex + 1);
                newActiveValueState[menuIndex] = targetValue;
              }

              setActiveValueState(newActiveValueState); // 禁用情况

              if (!(!targetOption || targetOption.disabled)) {
                _context2.next = 5;
                break;
              }

              return _context2.abrupt("return");

            case 5:
              // 菜单选中状态更新
              newValueState = newActiveValueState;

              if (!multiple) {
                _context2.next = 10;
                break;
              }

              if (e.type === 'change' || targetOption.__IS_FILTERED_OPTION) {
                newCheckedKeysState = (0, _utils.calcCheckedKeys)([{
                  key: targetValue,
                  pos: targetOption.pos
                }], true, checkStrictly, entityData.keyEntities, checkedKeysState);
                setCheckedKeysState(newCheckedKeysState);
                newValueState = newCheckedKeysState.checked.filter(function (entity) {
                  return entity && (!entity.children || checkStrictly);
                }).map(function (entity) {
                  return entity.keyPath;
                });
                selectedOptions = getSelectedOptions(newValueState);
                handleChange(newValueState, selectedOptions, true, e);
                searchValue && setSearchValue('');
              }

              _context2.next = 20;
              break;

            case 10:
              if (!(targetOption[fieldNames.isLeaf] === false && loadKeys.loaded.indexOf(targetValue) === -1 && loadData)) {
                _context2.next = 18;
                break;
              }

              if (!(loadKeys.loading.indexOf(targetValue) > -1)) {
                _context2.next = 13;
                break;
              }

              return _context2.abrupt("return");

            case 13:
              activeOptions = getActiveOptions(newActiveValueState);

              if (changeOnSelect) {
                handleChange(newValueState, activeOptions, true, e);
              }

              _context2.next = 17;
              return handleLoad(targetValue, activeOptions);

            case 17:
              return _context2.abrupt("return");

            case 18:
              _selectedOptions = getSelectedOptions(newValueState);
              /**
               * 子节点：需要关闭选择面板并更新 value 状态
               */

              if (!targetOption[fieldNames.children] || !targetOption[fieldNames.children].length) {
                handleChange(newValueState, _selectedOptions, false, e);
                /**
                 * 非子节点：且选择即触发更新
                 */
              } else if (changeOnSelect && (e.type === 'click' || e.type === 'keydown')) {
                handleChange(newValueState, _selectedOptions, true, e);
              }

            case 20:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function (_x3, _x4, _x5) {
      return _ref4.apply(this, arguments);
    };
  }()); // 只有多选下 tag close 点击和 checkbox 点击会触发取消选中

  var handleDeselect = _react["default"].useCallback(function (targetOptions, menuIndex, e) {
    // 保持 input 的 focus 状态
    if (inputRef && inputRef.current) {
      inputRef.current.focus();
    }

    var allOptionsDisabled = targetOptions.every(function (option) {
      return option && option.disabled;
    });

    if (allOptionsDisabled || !multiple) {
      return;
    }

    if (multiple) {
      searchValue && setSearchValue('');
    }

    var newActiveValueState = [];

    if (targetOptions[0] && targetOptions[0].__IS_FILTERED_OPTION) {
      newActiveValueState = targetOptions[0][filterFieldName];
    } else if (menuIndex >= 0 && targetOptions[0]) {
      var targetValue = targetOptions[0][fieldNames.value];
      newActiveValueState = activeValueState.slice(0, menuIndex + 1);
      newActiveValueState[menuIndex] = targetValue;
    }

    setActiveValueState(newActiveValueState); // 计算新的 state

    var removedValue = targetOptions.map(function (option) {
      return {
        key: option[fieldNames.value],
        pos: option.pos
      };
    });
    var newCheckedKeysState = (0, _utils.calcCheckedKeys)(removedValue, false, checkStrictly, entityData.keyEntities, checkedKeysState);
    setCheckedKeysState(newCheckedKeysState);
    var newValueState = newCheckedKeysState.checked.filter(function (entity) {
      return entity && (!entity.children || checkStrictly);
    }).map(function (entity) {
      return entity.keyPath;
    });
    var selectedOptions = getSelectedOptions(newValueState);
    handleChange(newValueState, selectedOptions, true, e);
  }, [activeValueState, checkStrictly, checkedKeysState, entityData.keyEntities, fieldNames.value, filterFieldName, getSelectedOptions, handleChange, inputRef, multiple, searchValue]);

  var getNextAvailableKey = (0, _useEventCallback2.useEventCallback)(function (keyCode) {
    var flag = false;
    var len = filterOptions.length;

    if (keyCode === _keyCode.KeyCode.UP) {
      for (var i = len - 1; i >= 0; i--) {
        var option = filterOptions[i];
        var key = option[filterFieldName].toString();

        if (key === activeKey || flag) {
          flag = true;

          if (i === 0 && !filterOptions[len - 1].disabled) {
            return filterOptions[len - 1][filterFieldName].toString();
          } else if (i !== 0 && !filterOptions[i - 1].disabled) {
            return filterOptions[i - 1][filterFieldName].toString();
          }
        }
      }
    } else {
      for (var _i = 0; _i < len; _i++) {
        var _option = filterOptions[_i];

        var _key = _option[filterFieldName].toString();

        if (_key === "".concat(activeKey) || flag) {
          flag = true;

          if (_i === len - 1 && !filterOptions[0].disabled) {
            return filterOptions[0][filterFieldName].toString();
          } else if (_i !== len - 1 && !filterOptions[_i + 1].disabled) {
            return filterOptions[_i + 1][filterFieldName].toString();
          }
        }
      }
    }
  }); // input 事件

  var handleInputKeyDown = (0, _useEventCallback2.useEventCallback)( // eslint-disable-next-line complexity
  function (e) {
    e.stopPropagation(); // 多选不支持或者搜索时禁用键盘事件

    if (multiple && !showSearch) {
      return;
    }

    if (children && children.props.onKeyDown) {
      children.props.onKeyDown(e);
      return;
    } // 搜索时的键盘响应


    if (showSearch && searchValue) {
      if (e.keyCode !== _keyCode.KeyCode.DOWN && e.keyCode !== _keyCode.KeyCode.UP && e.keyCode !== _keyCode.KeyCode.ENTER && e.keyCode !== _keyCode.KeyCode.ESC) {
        return;
      }

      if (e.keyCode === _keyCode.KeyCode.ENTER) {
        if (finalPopupVisible && activeKey) {
          var option = (0, _find2["default"])(filterOptions, function (option) {
            return option[filterFieldName].toString() === activeKey;
          });

          if (option) {
            var selectedIndex = optionSelectedIndex(option);
            var entity = (0, _utils.calValueEntity)([option[fieldNames.value]], entityData.keyPathEntities);
            option.pos = entity[0].pos;

            if (selectedIndex === -1) {
              handleSelect(option, -1, e);
            } else {
              // eslint-disable-next-line max-depth
              if (multiple) {
                handleDeselect([option], selectedIndex, e);
              } else {
                handlePopupVisibleChange(false);
              }
            }
          } else {
            handlePopupVisibleChange(!popupVisibleState);
          }
        } else {
          if (multiple && searchValue) return;
          handlePopupVisibleChange(!popupVisibleState);
        }

        return;
      }

      if (e.keyCode === _keyCode.KeyCode.ESC && popupVisibleState) {
        handlePopupVisibleChange(false);
        return;
      }

      if (e.keyCode === _keyCode.KeyCode.DOWN || e.keyCode === _keyCode.KeyCode.UP) {
        if (activeKey) {
          var key = getNextAvailableKey(e.keyCode) || (0, _utils.getActiveKeyFromValue)(valueState);

          if (key) {
            setActiveKey(key);
            return;
          }
        }

        if (!(0, _isEmpty2["default"])(filterOptions)) {
          if (e.keyCode === _keyCode.KeyCode.UP) {
            setActiveKey((0, _last2["default"])(filterOptions)[filterFieldName].toString());
          } else {
            setActiveKey(filterOptions[0][filterFieldName].toString());
          }
        }
      } // 非搜索时的键盘响应

    } else {
      var newActiveValueState = (0, _toConsumableArray2["default"])(activeValueState);
      var currentLevel = newActiveValueState.length - 1 < 0 ? 0 : newActiveValueState.length - 1;
      var currentOptions = currentLevelOptions;
      var currentIndex = currentOptions.map(function (o) {
        return o[fieldNames.value];
      }).indexOf(newActiveValueState[currentLevel]);

      if (e.keyCode !== _keyCode.KeyCode.DOWN && e.keyCode !== _keyCode.KeyCode.UP && e.keyCode !== _keyCode.KeyCode.LEFT && e.keyCode !== _keyCode.KeyCode.RIGHT && e.keyCode !== _keyCode.KeyCode.ENTER && e.keyCode !== _keyCode.KeyCode.SPACE && e.keyCode !== _keyCode.KeyCode.BACKSPACE && e.keyCode !== _keyCode.KeyCode.ESC && e.keyCode !== _keyCode.KeyCode.TAB) {
        return;
      } // Press any keys above to reopen menu


      if (!popupVisibleState && e.keyCode !== _keyCode.KeyCode.BACKSPACE && e.keyCode !== _keyCode.KeyCode.LEFT && e.keyCode !== _keyCode.KeyCode.RIGHT && e.keyCode !== _keyCode.KeyCode.ESC && e.keyCode !== _keyCode.KeyCode.TAB) {
        handlePopupVisibleChange(true);
        return;
      }

      if (e.keyCode === _keyCode.KeyCode.DOWN || e.keyCode === _keyCode.KeyCode.UP) {
        e.preventDefault();
        var nextIndex = currentIndex;

        if (nextIndex !== -1) {
          if (e.keyCode === _keyCode.KeyCode.DOWN) {
            nextIndex += 1;
            nextIndex = nextIndex >= currentOptions.length ? 0 : nextIndex;
          } else {
            nextIndex -= 1;
            nextIndex = nextIndex < 0 ? currentOptions.length - 1 : nextIndex;
          }
        } else {
          nextIndex = 0;
        }

        newActiveValueState[currentLevel] = currentOptions[nextIndex][fieldNames.value];
      } else if (!menuReverse && (e.keyCode === _keyCode.KeyCode.LEFT || e.keyCode === _keyCode.KeyCode.BACKSPACE && (0, _isEmpty2["default"])(valueState)) || menuReverse && e.keyCode === _keyCode.KeyCode.RIGHT) {
        e.preventDefault();
        newActiveValueState.splice(newActiveValueState.length - 1, 1);
      } else if (!menuReverse && e.keyCode === _keyCode.KeyCode.RIGHT || menuReverse && (e.keyCode === _keyCode.KeyCode.LEFT || e.keyCode === _keyCode.KeyCode.BACKSPACE && (0, _isEmpty2["default"])(valueState))) {
        e.preventDefault();

        if (currentOptions[currentIndex] && currentOptions[currentIndex][fieldNames.children]) {
          newActiveValueState.push(currentOptions[currentIndex][fieldNames.children][0][fieldNames.value]);
        }
      } else if (e.keyCode === _keyCode.KeyCode.ESC || e.keyCode === _keyCode.KeyCode.TAB) {
        handlePopupVisibleChange(false);
        return;
      }

      if (!newActiveValueState || newActiveValueState.length === 0) {
        handlePopupVisibleChange(false);
      } else {
        var activeOptions = getActiveOptions(newActiveValueState);
        var targetOption = activeOptions[activeOptions.length - 1];
        handleSelect(targetOption, activeOptions.length - 1, e);
      }
    }

    if (onKeyDown) {
      onKeyDown(e);
    }
  });
  var handleInputClear = (0, _useEventCallback2.useEventCallback)(function (e) {
    if (showSearch && searchValue && finalPopupVisible) {
      setSearchValue('');
    } else {
      if (multiple) {
        setCheckedKeysState({
          checked: [],
          halfChecked: []
        });
      }

      if (showSearch && searchValue && !finalPopupVisible) {
        setSearchValue('');
      }

      handleChange([], [], false, e);
    }
  });

  var handleInputChange = _react["default"].useCallback(function (e) {
    setSearchValue(e.target.value);
    setActiveKey('');
  }, []);

  var handleTagRemove = _react["default"].useCallback(function (value, index, e) {
    var targetOptions;

    if (collapseTags && index === 1) {
      var removeValues = (0, _toConsumableArray2["default"])(valueState).slice(1);
      targetOptions = removeValues.map(function (value) {
        return (0, _utils.calValueEntity)(value, entityData.keyPathEntities)[0].node;
      });
    } else {
      var removeValue = valueState[index];
      targetOptions = [(0, _utils.calValueEntity)(removeValue, entityData.keyPathEntities)[0].node];
    }

    handleDeselect(targetOptions, -1, e);
  }, [collapseTags, entityData.keyPathEntities, handleDeselect, valueState]);

  var handlePopupEnter = (0, _useEventCallback2.useEventCallback)(function () {
    searchValue && setSearchValue('');
  });
  var handlePopupExited = (0, _useEventCallback2.useEventCallback)(function () {
    if (firstSelectedOption && firstSelectedOption[filterFieldName] && firstSelectedOption[filterFieldName] !== activeKey) {
      setActiveKey(firstSelectedOption[filterFieldName].toString());
    }

    if (menuRef && menuRef.current) {
      if (firstSelectedItemRef && firstSelectedItemRef.current) {
        menuRef.current.firstElementChild.scrollTop = firstSelectedItemRef.current.offsetTop;
      } else {
        menuRef.current.firstElementChild.scrollTop = 0;
      }
    }
  });

  var optionSelectedIndex = _react["default"].useCallback(function (option) {
    return (0, _findIndex2["default"])(valueState, function (v) {
      if (Array.isArray(v)) {
        return (0, _last2["default"])(v) === (0, _last2["default"])(option[filterFieldName]);
      } else {
        return v === (0, _last2["default"])(option[filterFieldName]);
      }
    });
  }, [filterFieldName, valueState]);

  var handleOptionClick = _react["default"].useCallback(function (option, e) {
    e.stopPropagation();
    var selectedIndex = optionSelectedIndex(option);

    if (selectedIndex === -1) {
      if (multiple) {
        var entity = (0, _utils.calValueEntity)([option[fieldNames.value]], entityData.keyPathEntities);
        option.pos = entity[0].pos;
      }

      handleSelect(option, -1, e);
    } else if (multiple) {
      handleDeselect([option], selectedIndex, e);
    }
  }, [entityData.keyPathEntities, handleDeselect, handleSelect, multiple, optionSelectedIndex]);

  var handleOptionMouseEnter = (0, _useEventCallback2.useEventCallback)(function () {
    if (activeKey) {
      setActiveKey('');
    }
  });

  var preLoadOptions = /*#__PURE__*/function () {
    var _ref5 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(values) {
      var _iterator, _step, _value, option, isLeaf, _children, hasChildren;

      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _iterator = _createForOfIteratorHelper(values);
              _context3.prev = 1;

              _iterator.s();

            case 3:
              if ((_step = _iterator.n()).done) {
                _context3.next = 15;
                break;
              }

              _value = _step.value;
              option = (0, _utils.findOption)(options, _value, fieldNames);

              if (!option) {
                _context3.next = 13;
                break;
              }

              isLeaf = option[fieldNames.isLeaf];
              _children = option[fieldNames.children];
              hasChildren = _children && _children.length > 0;

              if (!(isLeaf === false && loadKeys.loaded.indexOf(_value) === -1 && !hasChildren)) {
                _context3.next = 13;
                break;
              }

              _context3.next = 13;
              return handleLoad(_value);

            case 13:
              _context3.next = 3;
              break;

            case 15:
              _context3.next = 20;
              break;

            case 17:
              _context3.prev = 17;
              _context3.t0 = _context3["catch"](1);

              _iterator.e(_context3.t0);

            case 20:
              _context3.prev = 20;

              _iterator.f();

              return _context3.finish(20);

            case 23:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, null, [[1, 17, 20, 23]]);
    }));

    return function preLoadOptions(_x6) {
      return _ref5.apply(this, arguments);
    };
  }(); // props


  var inputProps = (0, _extends2["default"])({}, inputValueInfo, {
    allowClear: finalAllowClear,
    placeholder: placeholder,
    maxVerticalTagCount: maxVerticalTagCount,
    popupVisible: finalPopupVisible,
    multiple: multiple,
    onClear: handleInputClear,
    onKeyDown: handleInputKeyDown,
    onRemoveTag: handleTagRemove,
    width: inputWidth,
    inputRef: inputRef,
    fieldNames: fieldNames,
    expandIcon: inputExpandIcon,
    size: size,
    disabled: disabled,
    readOnly: readOnly,
    showSearch: !!showSearch,
    renderTag: renderTag
  });

  if (showSearch) {
    inputProps.hasRelatedValue = !(0, _isEmpty2["default"])(valueState);
    inputProps.onInput = handleInputChange;
    inputProps.placeholder = (0, _utils.getPlaceholder)(inputProps.inputValue, placeholder);

    if (finalPopupVisible) {
      inputProps.inputValue = searchValue;
    }
  } // 将每个节点的位置信息计算，出来附加到选项中


  (0, _utils.traverseOptions)(options, fieldNames, function (_ref6) {
    var pos = _ref6.pos,
        node = _ref6.node;
    node.pos = pos;
  });
  var panelProps = {
    menusWidth: menusWidth,
    placement: placement,
    menuReverse: menuReverse,
    size: size,
    options: options,
    renderOption: renderOption,
    activeValue: activeValueState,
    onSelect: handleSelect,
    onDeselect: handleDeselect,
    expandTrigger: expandTrigger,
    fieldNames: fieldNames,
    visible: finalPopupVisible,
    expandIcon: expandIcon,
    loadingIcon: loadingIcon,
    styles: styles,
    multiple: multiple,
    checkedKeys: checkedKeysState,
    loadingKeys: loadKeys.loading,
    loadedKeys: loadKeys.loaded,
    onLoad: handleLoad,
    virtual: virtual,
    onMenuScroll: onMenuScroll
  };
  var triggerProps = (0, _extends2["default"])({}, restProps, {
    container: getPopupContainer,
    placement: placement,
    flip: flip,
    triggerAction: 'click',
    open: finalPopupVisible,
    onVisibleChange: handlePopupVisibleChange,
    offset: token.offset[size],
    hideArrow: true,
    disabled: disabled || readOnly,
    popperProps: (0, _extends2["default"])({}, popperProps, {
      popperOptions: {
        onCreate: onPopperCreate
      }
    })
  });

  if (showSearch) {
    triggerProps.transitionProps = {
      onEnter: handlePopupEnter,
      onExit: handlePopupExited
    };

    if (multiple) {
      triggerProps.insideCloseable = false;
    }
  }

  var searchResultProps = {
    searchValue: searchValue,
    activeKey: activeKey,
    fieldNames: fieldNames,
    filterFieldName: filterFieldName,
    firstSelectedOption: firstSelectedOption,
    menuWidth: menuWidthRef.current,
    filterOptions: filterOptions,
    optionSelectedIndex: optionSelectedIndex,
    handleOptionClick: handleOptionClick,
    handleOptionMouseEnter: handleOptionMouseEnter
  }; // props 改变，更新状态

  var newValueState = (0, _utils.getValueStateFromProps)(value || [], multiple, controlLeaf, entityData.keyEntities, entityData.keyPosMap);

  if (isControlled && !(0, _utils.diffValue)(newValueState, valueState, multiple, controlLeaf)) {
    setValueState(newValueState);
  }

  _react["default"].useEffect(function () {
    // 搜索模式下 options 变了需要更新 flattenOptions
    if (showSearch) {
      setFlattenOptions((0, _utils.flattenTree)({
        options: options,
        changeOnSelect: changeOnSelect,
        names: fieldNames
      }));
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [options, showSearch]);

  if (isPopupVisibleControlled && popupVisible !== popupVisibleState) {
    setPopupVisibleState(popupVisible);
  }

  if (isLoadedControlled && typeof loadedKeysProp !== 'undefined' && !(0, _shallowEqual.shallowEqualArrays)(loadedKeysProp, loadKeys.loaded)) {
    setLoadKeys((0, _extends2["default"])({}, loadKeys, {
      loaded: loadedKeysProp
    }));
  }

  _react["default"].useEffect(function () {
    if (multiple || controlLeaf) {
      var newEntityData = (0, _utils.getEntityDataFromOptions)(options, fieldNames);
      setEntityData(newEntityData);
      setCheckedKeysState((0, _utils.calcCheckedKeys)((0, _utils.calValueEntity)(valueState, entityData.keyPathEntities), true, checkStrictly, newEntityData.keyEntities));
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [fieldNames, multiple, controlLeaf, options]); // 如果是异步加载的，那么第一次渲染的时候要预加载已经选中项的 options


  _react["default"].useEffect(function () {
    if (loadData) {
      var values = (0, _flattenDeep2["default"])(activeValueState);
      preLoadOptions(values);
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, []);

  return {
    panelProps: panelProps,
    triggerProps: triggerProps,
    inputProps: inputProps,
    searchResultProps: searchResultProps
  };
}