"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useCascaderPanel;

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _arrayTreeFilter = _interopRequireDefault(require("array-tree-filter"));

var _react = require("react");

function useCascaderPanel(props, activeOptionsRef) {
  var options = props.options,
      activeValue = props.activeValue,
      fieldNames = props.fieldNames,
      visible = props.visible;
  var activeOptions = (0, _react.useMemo)(function () {
    return (0, _arrayTreeFilter["default"])(options, function (o, level) {
      return o[fieldNames.value] === activeValue[level];
    }, {
      childrenKeyName: fieldNames.children
    });
  }, [activeValue, fieldNames.children, fieldNames.value, options]);
  var showOptions = (0, _react.useMemo)(function () {
    var result = activeOptions.map(function (activeOption) {
      return activeOption[fieldNames.children];
    }).filter(function (activeOption) {
      return !(0, _isEmpty2["default"])(activeOption);
    });
    result.unshift(options);
    return result;
  }, [activeOptions, fieldNames.children, options]);
  (0, _react.useEffect)(function () {
    if (visible) {
      var optionsLength = showOptions.length;

      for (var i = 0; i < optionsLength; i++) {
        var option = activeOptionsRef.current[i];

        if (option && option.parentNode) {
          option.parentNode.scrollTop = option.offsetTop;
        }
      }
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [visible]);
  return {
    activeOptions: activeOptions,
    showOptions: showOptions
  };
}