"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useEventCallback2 = require("@muya-ui/utils/lib/hooks/useEventCallback");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _withTheme = require("../utils/withTheme");

var _styled = require("./styled");

var _styled2 = require("../Tag/styled");

var _excluded = ["shape", "size", "bordered", "disabled", "borderColor", "maxWidth", "checked", "onChange", "onClick"];

var BaseNode = _styledComponents["default"].span.withConfig({
  displayName: "BaseNode"
})([""]);

var PureCheckableTag = (0, _memoForwardRef["default"])(function (props, ref) {
  var shape = props.shape,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      bordered = props.bordered,
      disabled = props.disabled,
      borderColor = props.borderColor,
      maxWidth = props.maxWidth,
      checked = props.checked,
      onChange = props.onChange,
      onClick = props.onClick,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var handleClick = (0, _useEventCallback2.useEventCallback)(function (e) {
    if (!disabled) {
      /* istanbul ignore else */
      if (onClick) {
        onClick(e);
      }
      /* istanbul ignore else */


      if (onChange) {
        onChange(!checked);
      }
    } else {
      e.preventDefault();
    }
  }, [checked, onChange]);
  return /*#__PURE__*/_react["default"].createElement(BaseNode, (0, _extends2["default"])({
    ref: ref
  }, restProps, {
    onClick: handleClick
  }));
});
var CheckableTag = (0, _styledComponents["default"])(PureCheckableTag).withConfig({
  displayName: "CheckableTag"
})(["", ";", ""], _styled2.tagCss, _styled.checkableTagCss);

var _default = (0, _withTheme.withThemeForStyled)(CheckableTag);

exports["default"] = _default;