"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.checkableTagCss = void 0;

var _styledComponents = require("styled-components");

/* stylelint-disable no-descending-specificity */
var checkableTagCss = function checkableTagCss(props) {
  var _props$theme = props.theme,
      token = _props$theme.components.Tag,
      colorsPattern = _props$theme.colors.pattern,
      opacityPattern = _props$theme.opacity.pattern,
      _props$checked = props.checked,
      checked = _props$checked === void 0 ? false : _props$checked,
      _props$inline = props.inline,
      inline = _props$inline === void 0 ? false : _props$inline,
      _props$activeStyle = props.activeStyle,
      activeStyle = _props$activeStyle === void 0 ? 'normal' : _props$activeStyle,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled;
  var normalStyle;
  var hoverStyle;
  var clickStyle;
  var disabledStyle; // 现在的checkableTag选中状态永远是primary

  var type = 'primary';

  if (!checked) {
    // 未选中时样式
    if (!inline) {
      normalStyle = (0, _styledComponents.css)(["background:", ";color:", ";"], token.lightBg['normal'].normal, token.outlineColor.normal.normal);
      hoverStyle = (0, _styledComponents.css)(["&:hover{background:", ";color:", ";}"], token.lightBg['normal'].hover, token.outlineColor.normal.hover);
    } else {
      normalStyle = (0, _styledComponents.css)(["background:transparent;color:", ";"], token.outlineColor.normal.normal);
      hoverStyle = (0, _styledComponents.css)(["&:hover{background:", ";color:", ";}"], token.lightBg['normal'].normal, token.outlineColor.normal.hover);
    }

    clickStyle = (0, _styledComponents.css)(["&:active{background:", ";color:", ";}"], token.lightBg[type].normal, token.outlineColor[type].normal);
  } else {
    // 选中后的样式
    if (activeStyle === 'light') {
      normalStyle = (0, _styledComponents.css)(["background:", ";color:", ";"], token.lightBg[type].normal, token.typeColor[type].normal);
      hoverStyle = (0, _styledComponents.css)(["&:hover{background:", ";color:", ";}"], token.lightBg[type].hover, token.typeColor[type].normal);
      clickStyle = (0, _styledComponents.css)(["&:active{background:", ";color:", ";}"], token.lightBg[type].click, token.typeColor[type].normal);
    } else {
      normalStyle = (0, _styledComponents.css)(["background:", ";color:", ";"], token.typeColor[type].normal, colorsPattern.text.inverse);
      hoverStyle = (0, _styledComponents.css)(["&:hover{background:", ";color:", ";}"], token.typeColor[type].hover, colorsPattern.text.inverse);
      clickStyle = (0, _styledComponents.css)(["&:active{background:", ";color:", ";}"], token.typeColor[type].click, token.color.inverse);
    }
  }

  if (disabled) {
    disabledStyle = (0, _styledComponents.css)(["opacity:", ";"], opacityPattern.disabled);
    clickStyle = (0, _styledComponents.css)([""]);
    hoverStyle = (0, _styledComponents.css)([""]);
  }

  return (0, _styledComponents.css)(["", ";", ";", ";", ";"], normalStyle, hoverStyle, clickStyle, disabledStyle);
};

exports.checkableTagCss = checkableTagCss;