"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _useCheckbox2 = _interopRequireDefault(require("./useCheckbox"));

var _excluded = ["checked", "children", "defaultChecked", "disabled", "indeterminate", "autoFocus", "readOnly", "onChange", "onMouseEnter", "onMouseLeave", "size", "styles", "style", "className", "inputRef", "ellipsis", "width"];
var defaultStyles = {
  wrapper: '',
  icon: '',
  iconWrap: '',
  span: ''
};
var Checkbox = (0, _memoForwardRef["default"])(function (props, ref) {
  var checked = props.checked,
      children = props.children,
      _props$defaultChecked = props.defaultChecked,
      defaultChecked = _props$defaultChecked === void 0 ? false : _props$defaultChecked,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      _props$indeterminate = props.indeterminate,
      indeterminate = _props$indeterminate === void 0 ? false : _props$indeterminate,
      _props$autoFocus = props.autoFocus,
      autoFocus = _props$autoFocus === void 0 ? false : _props$autoFocus,
      _props$readOnly = props.readOnly,
      readOnly = _props$readOnly === void 0 ? false : _props$readOnly,
      onChange = props.onChange,
      onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      styles = props.styles,
      style = props.style,
      className = props.className,
      inputRef = props.inputRef,
      _props$ellipsis = props.ellipsis,
      ellipsis = _props$ellipsis === void 0 ? false : _props$ellipsis,
      width = props.width,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var innerStyles = (0, _useStyles["default"])('checkbox', defaultStyles, styles);

  var _useCheckbox = (0, _useCheckbox2["default"])(props, 'checked' in props),
      checkedState = _useCheckbox.checkedState,
      handleChange = _useCheckbox.handleChange;

  return /*#__PURE__*/_react["default"].createElement(_styled.StyledCheckboxLabel, {
    $disabled: disabled,
    $size: size,
    theme: theme,
    $width: width,
    $checked: checkedState,
    $indeterminate: indeterminate,
    ref: ref,
    className: [innerStyles.wrapper.className, className].join(' ').trim(),
    style: (0, _extends2["default"])({}, innerStyles.wrapper.style, style),
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave
  }, /*#__PURE__*/_react["default"].createElement(_styled.StyledCheckboxSpan, (0, _extends2["default"])({}, innerStyles.span, {
    onClick: function onClick(e) {
      return e.stopPropagation();
    }
  }), /*#__PURE__*/_react["default"].createElement(_styled.StyledCheckboxInput, (0, _extends2["default"])({}, restProps, {
    autoFocus: autoFocus,
    readOnly: readOnly,
    ref: inputRef,
    type: "checkbox",
    disabled: disabled,
    checked: checkedState,
    theme: theme,
    onChange: handleChange
  })), /*#__PURE__*/_react["default"].createElement(_styled.StyledCheckboxIconWrap, (0, _extends2["default"])({
    theme: theme
  }, innerStyles.iconWrap))), children ? /*#__PURE__*/_react["default"].createElement(_styled.StyledCheckboxContent, {
    $ellipsis: ellipsis,
    theme: theme
  }, children) : null);
});
Checkbox.useCheckbox = _useCheckbox2["default"];
Checkbox.__MUYA_CHECKBOX = true;
var _default = Checkbox;
exports["default"] = _default;