"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _Checkbox = _interopRequireDefault(require("./Checkbox"));

var _styled = require("./styled");

var _useCheckboxGroup2 = _interopRequireDefault(require("./useCheckboxGroup"));

var _excluded = ["value", "disabled", "onChange", "ellipsis", "width", "children"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var CheckboxGroup = (0, _memoForwardRef["default"])(function (props, ref) {
  var _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      styles = props.styles;

  var _useCheckboxGroup = (0, _useCheckboxGroup2["default"])(props),
      opts = _useCheckboxGroup.opts,
      restProps = _useCheckboxGroup.restProps,
      valueState = _useCheckboxGroup.valueState,
      children = _useCheckboxGroup.children,
      renderCheckbox = _useCheckboxGroup.renderCheckbox,
      checkboxEllipsis = _useCheckboxGroup.checkboxEllipsis,
      checkboxWidth = _useCheckboxGroup.checkboxWidth,
      handleChange = _useCheckboxGroup.handleChange;

  var theme = (0, _useTheme["default"])();
  var checkboxList = (0, _react.useMemo)(function () {
    if (opts && opts.length) {
      return opts.map(function (option, optIndex) {
        var label = option.label,
            value = option.value,
            disabled = option.disabled,
            ellipsis = option.ellipsis,
            width = option.width;

        var checkboxNode = /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
          key: value.toString(),
          styles: styles,
          size: size,
          value: value,
          ellipsis: ellipsis === undefined ? checkboxEllipsis : ellipsis,
          width: width || checkboxWidth,
          disabled: props.disabled || disabled,
          checked: valueState.indexOf(value) > -1,
          onChange: handleChange.bind(null, option)
        }, label);

        return renderCheckbox(checkboxNode, option, optIndex);
      });
    }

    return _react["default"].Children.map(children, function (child, childIndex) {
      if (! /*#__PURE__*/_react["default"].isValidElement(child)) {
        return null;
      }

      var _child$props = child.props,
          value = _child$props.value,
          disabled = _child$props.disabled,
          onChange = _child$props.onChange,
          ellipsis = _child$props.ellipsis,
          width = _child$props.width,
          label = _child$props.children,
          otherChildProps = (0, _objectWithoutProperties2["default"])(_child$props, _excluded);
      var option = {
        value: value,
        disabled: disabled,
        onChange: onChange,
        label: label
      };

      var checkboxNode = /*#__PURE__*/_react["default"].cloneElement(child, (0, _extends2["default"])({}, otherChildProps, {
        children: label,
        value: value,
        ellipsis: ellipsis === undefined ? checkboxEllipsis : ellipsis,
        width: width || checkboxWidth,
        checked: valueState.indexOf(value) > -1,
        disabled: props.disabled || disabled,
        styles: styles,
        size: size,
        onChange: handleChange.bind(null, option)
      }));

      return renderCheckbox(checkboxNode, option, childIndex);
    });
  }, [checkboxEllipsis, checkboxWidth, children, handleChange, opts, props.disabled, renderCheckbox, size, styles, valueState]);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledCheckboxGroup, (0, _extends2["default"])({}, restProps, {
    ref: ref,
    theme: theme
  }), checkboxList);
});
CheckboxGroup.useCheckboxGroup = _useCheckboxGroup2["default"];
var _default = CheckboxGroup;
exports["default"] = _default;