"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledCheckboxSpan = exports.StyledCheckboxLabel = exports.StyledCheckboxInput = exports.StyledCheckboxIconWrap = exports.StyledCheckboxGroup = exports.StyledCheckboxContent = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _ellipsis = require("../styled/mixins/ellipsis");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledCheckboxInput = _styledComponents["default"].input.withConfig({
  displayName: "StyledCheckboxInput"
})(["position:absolute;top:0;right:0;bottom:0;left:0;z-index:1;width:100%;height:100%;cursor:pointer;opacity:0;"]);

exports.StyledCheckboxInput = StyledCheckboxInput;

var StyledCheckboxSpan = _styledComponents["default"].span.withConfig({
  displayName: "StyledCheckboxSpan"
})(["position:relative;display:inline-block;white-space:nowrap;vertical-align:middle;outline:none;cursor:pointer;"]);

exports.StyledCheckboxSpan = StyledCheckboxSpan;

var StyledCheckboxIconWrap = _styledComponents["default"].span.withConfig({
  displayName: "StyledCheckboxIconWrap"
})([""]);

exports.StyledCheckboxIconWrap = StyledCheckboxIconWrap;

var StyledCheckboxContent = _styledComponents["default"].span.withConfig({
  displayName: "StyledCheckboxContent"
})(["", ""], function (props) {
  return (0, _styledComponents.css)(["", ""], (0, _ellipsis.makeEllipsisStyle)(props.$ellipsis));
}); // 注意，在 Button 里会覆盖 这里的 line-height


exports.StyledCheckboxContent = StyledCheckboxContent;

var StyledCheckboxLabel = _styledComponents["default"].label.withConfig({
  displayName: "StyledCheckboxLabel"
})(["", ""], function (props) {
  var _props$theme = props.theme,
      opacity = _props$theme.opacity,
      colors = _props$theme.colors,
      transitionPattern = _props$theme.transition.pattern,
      _props$theme$typograp = _props$theme.typography.spec,
      fontSize = _props$theme$typograp.fontSize,
      lineHeight = _props$theme$typograp.lineHeight,
      token = _props$theme.components.Checkbox,
      $disabled = props.$disabled,
      $size = props.$size,
      $indeterminate = props.$indeterminate,
      $checked = props.$checked,
      $width = props.$width;
  var iconColor = token.iconColor,
      iconFontSize = token.iconFontSize,
      textIconSpacing = token.textIconSpacing,
      inner = token.inner,
      iconBgColor = token.iconBgColor;
  var fontLevel = token.fontLevel[$size];
  var size = iconFontSize[$size];
  var width = $width && (0, _styledComponents.css)(["width:", "px;"], $width);
  return (0, _styledComponents.css)(["", ";box-sizing:border-box;margin:0;padding:0;display:inline-flex;align-items:center;font-size:", "px;line-height:0;font-variant:tabular-nums;font-feature-settings:'tnum';color:", ";cursor:pointer;", "{padding:0 ", "px;line-height:", "px;}", "{position:relative;display:inline-block;font-size:", "px;background-color:", ";height:", "px;width:", "px;line-height:", "px;padding:0;border:", ";border-color:", ";border-radius:", ";transition:all ", " ", "ms;box-sizing:border-box;&::after{box-sizing:border-box;position:absolute;top:50%;left:22%;display:table;border:", ";transform:rotate(45deg) scale(0) translate(-50%,-50%);opacity:0;content:'';}}", " ", " ", " ", ""], width, fontSize[fontLevel], token.labelColor, StyledCheckboxContent, textIconSpacing[$size], lineHeight[fontLevel], StyledCheckboxIconWrap, size, iconBgColor, size, size, size, inner.border, $checked ? iconColor.checked.normal : iconColor.unChecked.normal, inner.borderRadius, transitionPattern.easing.status, transitionPattern.duration.status, inner.icon.border, $checked && (0, _styledComponents.css)(["", "{background-color:", ";&::after{border-top:0;border-left:0;width:", "px;height:", "px;transform:rotate(45deg) scale(1) translate(-50%,-50%);opacity:1;}}"], StyledCheckboxIconWrap, iconColor.checked.click, size / 14 * 5, size / 14 * 8), $disabled && (0, _styledComponents.css)(["cursor:not-allowed;opacity:", ";", ",", "{cursor:not-allowed;}"], opacity.pattern.disabled, StyledCheckboxInput, StyledCheckboxSpan), !$disabled && !$indeterminate && (0, _styledComponents.css)(["&:hover ", "{border-color:", ";}&:active ", "{border-color:", ";}"], StyledCheckboxIconWrap, $checked ? iconColor.checked.hover : iconColor.unChecked.hover, StyledCheckboxIconWrap, $checked ? iconColor.checked.click : iconColor.unChecked.click), $indeterminate && (0, _styledComponents.css)(["", "{border-color:", ";background-color:", ";&::after{border:0;opacity:1;width:", "px;height:", "px;transform:translate(-50%,-50%) scale(1);background:", ";left:50%;}}&:hover ", "{border-color:", ";}&:active ", "{border-color:", ";}"], StyledCheckboxIconWrap, iconColor.indeterminate.normal, iconColor.checked.click, inner.icon.indeterminate.width[$size], inner.icon.indeterminate.height[$size], colors.spec.light, StyledCheckboxIconWrap, iconColor.indeterminate.hover, StyledCheckboxIconWrap, iconColor.indeterminate.click));
});

exports.StyledCheckboxLabel = StyledCheckboxLabel;

var StyledCheckboxGroup = _styledComponents["default"].div.withConfig({
  displayName: "StyledCheckboxGroup"
})(["", "{margin-right:", "px;}"], StyledCheckboxLabel, function (props) {
  return props.theme.components.Checkbox.marginRightInGroup;
});

exports.StyledCheckboxGroup = StyledCheckboxGroup;