"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
exports.useCheckbox = useCheckbox;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = require("react");

function useCheckbox(props, isControlled) {
  var checked = props.checked,
      defaultChecked = props.defaultChecked,
      disabled = props.disabled,
      onChange = props.onChange,
      onClick = props.onClick;

  var _useState = (0, _react.useState)((isControlled ? !!checked : defaultChecked) || false),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      checkedState = _useState2[0],
      setChecked = _useState2[1];

  var handleChange = (0, _react.useCallback)(function (e) {
    if (disabled) {
      return;
    }

    if (!isControlled) {
      setChecked(e.target.checked);
    }

    if (onChange) {
      onChange(e);
    }
  }, [disabled, isControlled, onChange]);
  var handleClick = (0, _react.useCallback)(function (e) {
    if (disabled) {
      return;
    }

    if (!isControlled) {
      setChecked(!checkedState);
    }

    if (onClick) {
      onClick(e);
    }
  }, [checkedState, disabled, isControlled, onClick]);

  if (isControlled && !!checked !== checkedState) {
    setChecked(!!checked);
  }

  return {
    checkedState: checkedState,
    handleChange: handleChange,
    handleClick: handleClick,
    setChecked: setChecked
  };
}

var _default = useCheckbox;
exports["default"] = _default;