"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
exports.useCheckboxGroup = useCheckboxGroup;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = require("react");

var _shallowEqual = require("shallow-equal");

var _excluded = ["defaultValue", "disabled", "value", "options", "onChange", "onClick", "children", "renderCheckbox", "checkboxEllipsis", "checkboxWidth"];

var defaultRenderCheckbox = function defaultRenderCheckbox(checkboxNode) {
  return checkboxNode;
};

function useCheckboxGroup(props) {
  var _props$defaultValue = props.defaultValue,
      defaultValue = _props$defaultValue === void 0 ? [] : _props$defaultValue,
      disabled = props.disabled,
      value = props.value,
      options = props.options,
      onChange = props.onChange,
      onClick = props.onClick,
      children = props.children,
      _props$renderCheckbox = props.renderCheckbox,
      renderCheckbox = _props$renderCheckbox === void 0 ? defaultRenderCheckbox : _props$renderCheckbox,
      checkboxEllipsis = props.checkboxEllipsis,
      checkboxWidth = props.checkboxWidth,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var isControlled = ('value' in props);

  var _useState = (0, _react.useState)((isControlled ? value : defaultValue) || []),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      valueState = _useState2[0],
      setValueState = _useState2[1];

  var opts = (0, _react.useMemo)(function () {
    return (options || []).map(function (option) {
      if (typeof option === 'string') {
        return {
          label: option,
          value: option
        };
      }

      return option;
    });
  }, [options]);
  var handleLogic = (0, _react.useCallback)(function (checked, newValueState, option) {
    if (checked) {
      newValueState.push(option.value);
    } else {
      var index = newValueState.indexOf(option.value);
      newValueState.splice(index, 1);
    }

    if (!isControlled) {
      setValueState(newValueState);
    }

    if (onChange) {
      onChange(newValueState);
    }
  }, [isControlled, onChange]);
  var handleChange = (0, _react.useCallback)(function (option, e) {
    var checked = e.target.checked;
    var newValueState = (0, _toConsumableArray2["default"])(valueState);
    handleLogic(checked, newValueState, option);

    if (option.onChange) {
      option.onChange(e);
    }
  }, [handleLogic, valueState]);
  var handleClick = (0, _react.useCallback)(function (option, e) {
    var newValueState = (0, _toConsumableArray2["default"])(valueState);
    var checked = newValueState.indexOf(option.value) > -1;
    handleLogic(!checked, newValueState, option);

    if (option.onClick) {
      option.onClick(e);
    }
  }, [handleLogic, valueState]);

  if (isControlled && !(0, _shallowEqual.shallowEqualArrays)(props.value || [], valueState)) {
    setValueState(props.value || []);
  }

  return {
    opts: opts,
    valueState: valueState,
    handleChange: handleChange,
    handleClick: handleClick,
    restProps: restProps,
    children: children,
    renderCheckbox: renderCheckbox,
    checkboxEllipsis: checkboxEllipsis,
    checkboxWidth: checkboxWidth
  };
}

var _default = useCheckboxGroup;
exports["default"] = _default;