"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _uniq2 = _interopRequireDefault(require("lodash/uniq"));

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _react = _interopRequireWildcard(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _CollapsePanel = _interopRequireDefault(require("./CollapsePanel"));

var _styled = require("./styled");

var _excluded = ["children", "activeKeys", "defaultActiveKeys", "accordion", "expandIconPosition", "expandIcon", "onChange"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Collapse = (0, _memoForwardRef["default"])(function (props, ref) {
  var theme = (0, _useTheme["default"])();
  var children = props.children,
      activeKeysProp = props.activeKeys,
      _props$defaultActiveK = props.defaultActiveKeys,
      defaultActiveKeysProp = _props$defaultActiveK === void 0 ? [] : _props$defaultActiveK,
      _props$accordion = props.accordion,
      accordion = _props$accordion === void 0 ? false : _props$accordion,
      _props$expandIconPosi = props.expandIconPosition,
      expandIconPosition = _props$expandIconPosi === void 0 ? 'left' : _props$expandIconPosi,
      expandIcon = props.expandIcon,
      onChange = props.onChange,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded); // 手风琴模式，只取第一个值

  var activeKeys = accordion && activeKeysProp ? activeKeysProp.slice(0, 1) : activeKeysProp;
  var defaultActiveKeys = accordion ? defaultActiveKeysProp.slice(0, 1) : defaultActiveKeysProp;

  var _useState = (0, _react.useState)(defaultActiveKeys),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      activeKeysState = _useState2[0],
      setActiveKeysState = _useState2[1];

  var isControlled = ('activeKeys' in props);
  var finalActiveKeys = isControlled && activeKeys ? activeKeys : activeKeysState;
  var items = (0, _react.useMemo)(function () {
    return _react.Children.map(children, function (c, index) {
      if (! /*#__PURE__*/_react["default"].isValidElement(c)) {
        return;
      }

      var child = c;
      var childKey = child.key || index;
      var isActive = (0, _includes2["default"])(finalActiveKeys, childKey);

      var handleHeaderClick = function handleHeaderClick(e) {
        if (child.props.onHeaderClick) {
          child.props.onHeaderClick(e);
        }

        var newKeys = isActive ? finalActiveKeys.filter(function (k) {
          return childKey !== k;
        }) : (0, _uniq2["default"])([].concat((0, _toConsumableArray2["default"])(finalActiveKeys), [childKey]));

        if (accordion) {
          newKeys = isActive ? [] : [childKey];
        }

        onChange && onChange(newKeys);
        setActiveKeysState(newKeys);
      };

      var childProps = (0, _extends2["default"])({
        isActive: isActive,
        expandIconPosition: expandIconPosition,
        expandIcon: expandIcon
      }, child.props, {
        onHeaderClick: function onHeaderClick(e) {
          return handleHeaderClick(e);
        }
      });
      return /*#__PURE__*/_react["default"].cloneElement(child, childProps);
    });
  }, [accordion, children, expandIcon, expandIconPosition, finalActiveKeys, onChange]);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledCollapseWrapper, (0, _extends2["default"])({
    theme: theme,
    ref: ref
  }, other), items);
});
Collapse.Panel = _CollapsePanel["default"];
var _default = Collapse;
exports["default"] = _default;