"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _FoldIcon2 = require("@muya-ui/theme-light/lib/icons/FoldIcon");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _Animation = _interopRequireDefault(require("../Animation"));

var _ExpandIcon = _interopRequireDefault(require("../ExpandIcon"));

var _Space = _interopRequireDefault(require("../Space"));

var _Typography = _interopRequireDefault(require("../Typography"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _excluded = ["expandIconPosition", "isActive", "showArrow", "disabled", "header", "children", "extra", "expandIcon", "onHeaderClick", "styles", "appear", "mountOnEnter", "unmountOnExit", "addEndListener", "onEnter", "onEntering", "onEntered", "onExit", "onExited", "onExiting", "enter", "exit"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  header: '',
  content: '',
  expandWrapper: '',
  prefixNodeWrapper: '',
  suffixNodeWrapper: ''
};

var _default = (0, _memoForwardRef["default"])(function (props, ref) {
  var theme = (0, _useTheme["default"])(); // TODO: 其他动画参数透传问题

  var _props$expandIconPosi = props.expandIconPosition,
      expandIconPosition = _props$expandIconPosi === void 0 ? 'left' : _props$expandIconPosi,
      _props$isActive = props.isActive,
      isActive = _props$isActive === void 0 ? false : _props$isActive,
      _props$showArrow = props.showArrow,
      showArrow = _props$showArrow === void 0 ? true : _props$showArrow,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      header = props.header,
      children = props.children,
      extra = props.extra,
      expandIcon = props.expandIcon,
      onHeaderClick = props.onHeaderClick,
      styles = props.styles,
      appear = props.appear,
      mountOnEnter = props.mountOnEnter,
      unmountOnExit = props.unmountOnExit,
      addEndListener = props.addEndListener,
      onEnter = props.onEnter,
      onEntering = props.onEntering,
      onEntered = props.onEntered,
      onExit = props.onExit,
      onExited = props.onExited,
      onExiting = props.onExiting,
      enter = props.enter,
      exit = props.exit,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var transitionProps = {
    appear: appear,
    mountOnEnter: mountOnEnter,
    unmountOnExit: unmountOnExit,
    addEndListener: addEndListener,
    onEnter: onEnter,
    onEntering: onEntering,
    onEntered: onEntered,
    onExit: onExit,
    onExited: onExited,
    onExiting: onExiting,
    enter: enter,
    exit: exit
  };
  var innerStyles = (0, _useStyles["default"])('collapse-panel', defaultStyles, styles);
  var DefaultExpandIcon = theme.components.Collapse.expandIcon || _FoldIcon2.FoldIcon;
  var handleHeaderClick = (0, _react.useCallback)(function (e) {
    if (onHeaderClick && !disabled) {
      onHeaderClick(e);
    }
  }, [disabled, onHeaderClick]);
  var stopPropagation = (0, _react.useCallback)(function (e) {
    e.stopPropagation();
  }, []);
  var icon = (0, _react.useMemo)(function () {
    if (!showArrow) {
      return null;
    }

    return /*#__PURE__*/_react["default"].createElement(_styled.StyledExpandWrapper, (0, _extends2["default"])({
      $expandIconPosition: expandIconPosition,
      theme: theme,
      $expanded: isActive,
      $rotate: -90,
      $expandRotate: 0
    }, innerStyles.expandWrapper), /*#__PURE__*/_react["default"].createElement(_ExpandIcon["default"], {
      icon: expandIcon,
      DefaultIcon: DefaultExpandIcon,
      disabled: disabled
    }));
  }, [DefaultExpandIcon, disabled, expandIcon, expandIconPosition, innerStyles.expandWrapper, isActive, showArrow, theme]);
  var prefixNode = (0, _react.useMemo)(function () {
    var text = /*#__PURE__*/_react["default"].createElement(_Typography["default"].Text, {
      strong: true
    }, header);

    if (icon && expandIconPosition === 'left') {
      return /*#__PURE__*/_react["default"].createElement(_Space["default"], innerStyles.prefixNodeWrapper, icon, text);
    }

    return text;
  }, [expandIconPosition, header, icon, innerStyles.prefixNodeWrapper]);
  var suffixNode = (0, _react.useMemo)(function () {
    if (icon && expandIconPosition === 'right') {
      return /*#__PURE__*/_react["default"].createElement(_Space["default"], innerStyles.suffixNodeWrapper, /*#__PURE__*/_react["default"].createElement("span", {
        onClick: stopPropagation
      }, extra), icon);
    }

    return /*#__PURE__*/_react["default"].createElement("span", {
      onClick: stopPropagation
    }, extra);
  }, [expandIconPosition, extra, icon, innerStyles.suffixNodeWrapper, stopPropagation]);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledCollapseItem, (0, _extends2["default"])({
    ref: ref
  }, other), /*#__PURE__*/_react["default"].createElement(_styled.StyledCollapseHeader, (0, _extends2["default"])({}, innerStyles.header, {
    $disabled: disabled,
    onClick: handleHeaderClick,
    theme: theme
  }), prefixNode, suffixNode), /*#__PURE__*/_react["default"].createElement(_Animation["default"].Collapse, (0, _extends2["default"])({}, transitionProps, {
    easing: "linear",
    "in": isActive && !disabled
  }), /*#__PURE__*/_react["default"].createElement(_styled.StyledCollapseContent, innerStyles.content, children)));
});

exports["default"] = _default;