"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _Calendar = require("../Calendar");

var _PopPanel = require("../styled/components/PopPanel");

var _Trigger = _interopRequireDefault(require("../Trigger"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _useMultiSelectDatePicker = _interopRequireDefault(require("./useMultiSelectDatePicker"));

var _usePickerBase2 = _interopRequireDefault(require("../DatePicker/usePickerBase"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  popPanel: ''
};
var MultiSelectDatePicker = (0, _memoForwardRef["default"])(function (props, ref) {
  var theme = (0, _useTheme["default"])();

  var _useMultiSelectDatePi = (0, _useMultiSelectDatePicker["default"])(props),
      finalUIState = _useMultiSelectDatePi.finalUIState,
      finalValue = _useMultiSelectDatePi.finalValue,
      finalSelectedDate = _useMultiSelectDatePi.finalSelectedDate,
      otherProps = _useMultiSelectDatePi.otherProps,
      handleFocus = _useMultiSelectDatePi.handleFocus,
      handleClear = _useMultiSelectDatePi.handleClear,
      handleCalendarChange = _useMultiSelectDatePi.handleCalendarChange,
      handleCalendarUIChange = _useMultiSelectDatePi.handleCalendarUIChange,
      handleClickAway = _useMultiSelectDatePi.handleClickAway,
      handleAddDate = _useMultiSelectDatePi.handleAddDate,
      handleRemoveDate = _useMultiSelectDatePi.handleRemoveDate,
      handleInputRef = _useMultiSelectDatePi.handleInputRef,
      styles = _useMultiSelectDatePi.styles,
      disabled = _useMultiSelectDatePi.disabled,
      readOnly = _useMultiSelectDatePi.readOnly,
      allowClear = _useMultiSelectDatePi.allowClear,
      calendarStyles = _useMultiSelectDatePi.calendarStyles,
      onSelect = _useMultiSelectDatePi.onSelect,
      container = _useMultiSelectDatePi.container,
      inputReadOnly = _useMultiSelectDatePi.inputReadOnly,
      selectType = _useMultiSelectDatePi.selectType,
      disableRange = _useMultiSelectDatePi.disableRange,
      disableDate = _useMultiSelectDatePi.disableDate,
      options = _useMultiSelectDatePi.options,
      todayDate = _useMultiSelectDatePi.todayDate,
      renderDecadeItem = _useMultiSelectDatePi.renderDecadeItem,
      renderMonthItem = _useMultiSelectDatePi.renderMonthItem,
      renderYearItem = _useMultiSelectDatePi.renderYearItem,
      renderMonthLabel = _useMultiSelectDatePi.renderMonthLabel,
      placement = _useMultiSelectDatePi.placement,
      popperProps = _useMultiSelectDatePi.popperProps,
      arrowPointAtCenter = _useMultiSelectDatePi.arrowPointAtCenter,
      triggerId = _useMultiSelectDatePi.triggerId,
      flip = _useMultiSelectDatePi.flip;

  var inputStyles = (0, _react.useMemo)(function () {
    if (!styles) {
      return;
    }

    var inputWrapper = styles.inputWrapper,
        input = styles.input,
        nodeDivider = styles.nodeDivider,
        nodeWrapper = styles.nodeWrapper,
        clearWrapper = styles.clearWrapper,
        statusWrapper = styles.statusWrapper;
    return {
      inputWrapper: inputWrapper,
      input: input,
      nodeDivider: nodeDivider,
      nodeWrapper: nodeWrapper,
      clearWrapper: clearWrapper,
      statusWrapper: statusWrapper
    };
  }, [styles]);
  var currentStyles = (0, _react.useMemo)(function () {
    if (!styles) {
      return;
    }

    var popPanel = styles.popPanel;
    return {
      popPanel: popPanel
    };
  }, [styles]);
  var innerStyles = (0, _useStyles["default"])('date-picker', defaultStyles, currentStyles);

  var _usePickerBase = (0, _usePickerBase2["default"])(),
      innerSuffixNode = _usePickerBase.suffixNode;

  var realNode = /*#__PURE__*/_react["default"].createElement(_styled.StyledTagsInput, (0, _extends2["default"])({
    ref: ref,
    $popupVisible: finalUIState.popupOpen,
    $status: otherProps.status,
    inputRef: handleInputRef,
    value: finalValue,
    disabled: disabled,
    onFocus: handleFocus,
    onClear: handleClear,
    suffixNode: innerSuffixNode,
    allowClear: allowClear,
    focusWhenClear: false,
    theme: theme,
    onAddTag: handleAddDate,
    onRemoveTag: handleRemoveDate,
    styles: inputStyles,
    readOnly: readOnly || inputReadOnly,
    maxVerticalTagCount: 2,
    allowAdd: true
  }, otherProps));

  if (disabled || readOnly) {
    return realNode;
  }

  var calendarProps = {
    styles: calendarStyles,
    selectType: selectType,
    disableRange: disableRange,
    disableDate: disableDate,
    options: options,
    todayDate: todayDate,
    onSelect: onSelect,
    allowClear: allowClear,
    renderDecadeItem: renderDecadeItem,
    renderMonthItem: renderMonthItem,
    renderYearItem: renderYearItem,
    renderMonthLabel: renderMonthLabel
  };

  var calendarNode = /*#__PURE__*/_react["default"].createElement(_PopPanel.StyledPopPanel, (0, _extends2["default"])({}, innerStyles.popPanel, {
    theme: theme
  }), /*#__PURE__*/_react["default"].createElement(_Calendar.MultiSelectCalendar, (0, _extends2["default"])({
    viewDate: finalUIState.viewDate,
    viewType: finalUIState.viewType,
    selectedDate: finalSelectedDate,
    onChange: handleCalendarChange,
    onUIChange: handleCalendarUIChange
  }, calendarProps)));

  var triggerProps = {
    placement: placement,
    popperProps: popperProps,
    arrowPointAtCenter: arrowPointAtCenter,
    triggerId: triggerId,
    flip: flip,
    hideArrow: true,
    container: container
  };
  return /*#__PURE__*/_react["default"].createElement(_Trigger["default"], (0, _extends2["default"])({
    popup: calendarNode,
    triggerAction: "click",
    open: finalUIState.popupOpen,
    onClickAway: handleClickAway
  }, triggerProps), realNode);
});
var _default = MultiSelectDatePicker;
exports["default"] = _default;