"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _react = _interopRequireWildcard(require("react"));

var _Calendar = require("../Calendar");

var _useLocale2 = _interopRequireDefault(require("../Locale/useLocale"));

var _PopPanel = require("../styled/components/PopPanel");

var _Trigger = _interopRequireDefault(require("../Trigger"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _usePickerBase2 = _interopRequireDefault(require("./usePickerBase"));

var _useRangeDatePicker2 = _interopRequireDefault(require("./useRangeDatePicker"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  popPanel: ''
};
var RangeDatePicker = (0, _memoForwardRef["default"])(function (props, ref) {
  var theme = (0, _useTheme["default"])();
  var rangeInputRef = (0, _react.useRef)(null);
  var handleRef = (0, _useForkRef2.useForkRef)(rangeInputRef, ref);

  var _useRangeDatePicker = (0, _useRangeDatePicker2["default"])(props, rangeInputRef),
      finalUIState = _useRangeDatePicker.finalUIState,
      finalState = _useRangeDatePicker.finalState,
      finalValue = _useRangeDatePicker.finalValue,
      otherProps = _useRangeDatePicker.otherProps,
      editKey = _useRangeDatePicker.editKey,
      handleFocus = _useRangeDatePicker.handleFocus,
      handleClear = _useRangeDatePicker.handleClear,
      handleCalendarUIChange = _useRangeDatePicker.handleCalendarUIChange,
      handleInputChange = _useRangeDatePicker.handleInputChange,
      handleClickAway = _useRangeDatePicker.handleClickAway,
      handlePressEnter = _useRangeDatePicker.handlePressEnter,
      handleCalendarChange = _useRangeDatePicker.handleCalendarChange,
      styles = _useRangeDatePicker.styles,
      calendarStyles = _useRangeDatePicker.calendarStyles,
      allowClear = _useRangeDatePicker.allowClear,
      disabled = _useRangeDatePicker.disabled,
      readOnly = _useRangeDatePicker.readOnly,
      selectType = _useRangeDatePicker.selectType,
      disableRange = _useRangeDatePicker.disableRange,
      disableDate = _useRangeDatePicker.disableDate,
      options = _useRangeDatePicker.options,
      todayDate = _useRangeDatePicker.todayDate,
      minRangeLength = _useRangeDatePicker.minRangeLength,
      maxRangeLength = _useRangeDatePicker.maxRangeLength,
      fixedEndDate = _useRangeDatePicker.fixedEndDate,
      fixedStartDate = _useRangeDatePicker.fixedStartDate,
      container = _useRangeDatePicker.container,
      inputReadOnly = _useRangeDatePicker.inputReadOnly,
      renderDecadeItem = _useRangeDatePicker.renderDecadeItem,
      renderMonthItem = _useRangeDatePicker.renderMonthItem,
      renderYearItem = _useRangeDatePicker.renderYearItem,
      renderMonthLabel = _useRangeDatePicker.renderMonthLabel,
      onSelect = _useRangeDatePicker.onSelect,
      placement = _useRangeDatePicker.placement,
      popperProps = _useRangeDatePicker.popperProps,
      arrowPointAtCenter = _useRangeDatePicker.arrowPointAtCenter,
      triggerId = _useRangeDatePicker.triggerId,
      flip = _useRangeDatePicker.flip;

  var _useLocale = (0, _useLocale2["default"])(),
      middleText = _useLocale['DatePicker.middleText'];

  var inputStyles = (0, _react.useMemo)(function () {
    if (!styles) {
      return;
    }

    var inputWrapper = styles.inputWrapper,
        headInput = styles.headInput,
        tailInput = styles.tailInput,
        nodeDivider = styles.nodeDivider,
        nodeWrapper = styles.nodeWrapper,
        clearWrapper = styles.clearWrapper;
    return {
      inputWrapper: inputWrapper,
      headInput: headInput,
      tailInput: tailInput,
      nodeDivider: nodeDivider,
      nodeWrapper: nodeWrapper,
      clearWrapper: clearWrapper
    };
  }, [styles]);
  var currentStyles = (0, _react.useMemo)(function () {
    if (!styles) {
      return;
    }

    var popPanel = styles.popPanel;
    return {
      popPanel: popPanel
    };
  }, [styles]);
  var innerStyles = (0, _useStyles["default"])('range-date-picker', defaultStyles, currentStyles);

  var _usePickerBase = (0, _usePickerBase2["default"])(),
      innerSuffixNode = _usePickerBase.suffixNode;

  var realNode = /*#__PURE__*/_react["default"].createElement(_styled.StyledRangeInput, (0, _extends2["default"])({}, otherProps, {
    $popupVisible: finalUIState.popupOpen,
    $status: otherProps.status,
    ref: handleRef,
    value: finalValue,
    onChange: handleInputChange,
    onFocus: handleFocus,
    allowClear: allowClear,
    clearReplace: true,
    disabled: disabled,
    middleNode: middleText,
    focusWhenClear: false,
    suffixNode: innerSuffixNode,
    onPressEnter: handlePressEnter,
    onClear: handleClear,
    theme: theme,
    styles: inputStyles,
    readOnly: readOnly || inputReadOnly
  }));

  if (disabled || readOnly) {
    return realNode;
  }

  var rangeCalendarProps = {
    styles: calendarStyles,
    selectType: selectType,
    disableRange: disableRange,
    disableDate: disableDate,
    options: options,
    todayDate: todayDate,
    minRangeLength: minRangeLength,
    maxRangeLength: maxRangeLength,
    fixedEndDate: fixedEndDate,
    fixedStartDate: fixedStartDate,
    allowClear: false,
    renderDecadeItem: renderDecadeItem,
    renderMonthItem: renderMonthItem,
    renderYearItem: renderYearItem,
    renderMonthLabel: renderMonthLabel,
    onSelect: onSelect
  };

  var calendarNode = /*#__PURE__*/_react["default"].createElement(_PopPanel.StyledPopPanel, (0, _extends2["default"])({}, innerStyles.popPanel, {
    theme: theme
  }), /*#__PURE__*/_react["default"].createElement(_Calendar.RangeCalendar, (0, _extends2["default"])({}, rangeCalendarProps, {
    onUIChange: handleCalendarUIChange,
    onChange: handleCalendarChange,
    range: finalState.range,
    start: finalState.start,
    end: finalState.end,
    viewDate: finalUIState.viewDate,
    viewType: finalUIState.viewType,
    editKey: editKey
  })));

  var triggerProps = {
    placement: placement,
    popperProps: popperProps,
    arrowPointAtCenter: arrowPointAtCenter,
    triggerId: triggerId,
    flip: flip,
    hideArrow: true,
    container: container
  };
  return /*#__PURE__*/_react["default"].createElement(_Trigger["default"], (0, _extends2["default"])({
    popup: calendarNode,
    triggerAction: "click",
    open: finalUIState.popupOpen,
    onClickAway: handleClickAway
  }, triggerProps), realNode);
});
RangeDatePicker.__MUYA_RANGEDATEPICKER = true;
var _default = RangeDatePicker;
exports["default"] = _default;