"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _Calendar = require("../Calendar");

var _PopPanel = require("../styled/components/PopPanel");

var _Trigger = _interopRequireDefault(require("../Trigger"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _useDatePicker2 = _interopRequireDefault(require("./useDatePicker"));

var _usePickerBase2 = _interopRequireDefault(require("./usePickerBase"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  popPanel: ''
};
var DatePicker = (0, _memoForwardRef["default"])(function (props, ref) {
  var theme = (0, _useTheme["default"])();

  var _useDatePicker = (0, _useDatePicker2["default"])(props),
      finalUIState = _useDatePicker.finalUIState,
      finalValue = _useDatePicker.finalValue,
      finalSelectedDate = _useDatePicker.finalSelectedDate,
      otherProps = _useDatePicker.otherProps,
      handleFocus = _useDatePicker.handleFocus,
      handleClear = _useDatePicker.handleClear,
      handleCalendarChange = _useDatePicker.handleCalendarChange,
      handleCalendarUIChange = _useDatePicker.handleCalendarUIChange,
      handleInputChange = _useDatePicker.handleInputChange,
      handleClickAway = _useDatePicker.handleClickAway,
      handlePressEnter = _useDatePicker.handlePressEnter,
      handleInputRef = _useDatePicker.handleInputRef,
      styles = _useDatePicker.styles,
      disabled = _useDatePicker.disabled,
      readOnly = _useDatePicker.readOnly,
      allowClear = _useDatePicker.allowClear,
      calendarStyles = _useDatePicker.calendarStyles,
      onSelect = _useDatePicker.onSelect,
      container = _useDatePicker.container,
      inputReadOnly = _useDatePicker.inputReadOnly,
      selectType = _useDatePicker.selectType,
      disableRange = _useDatePicker.disableRange,
      disableDate = _useDatePicker.disableDate,
      options = _useDatePicker.options,
      todayDate = _useDatePicker.todayDate,
      renderDecadeItem = _useDatePicker.renderDecadeItem,
      renderMonthItem = _useDatePicker.renderMonthItem,
      renderYearItem = _useDatePicker.renderYearItem,
      renderMonthLabel = _useDatePicker.renderMonthLabel,
      placement = _useDatePicker.placement,
      popperProps = _useDatePicker.popperProps,
      arrowPointAtCenter = _useDatePicker.arrowPointAtCenter,
      triggerId = _useDatePicker.triggerId,
      flip = _useDatePicker.flip;

  var inputStyles = (0, _react.useMemo)(function () {
    if (!styles) {
      return;
    }

    var inputWrapper = styles.inputWrapper,
        input = styles.input,
        nodeDivider = styles.nodeDivider,
        nodeWrapper = styles.nodeWrapper,
        clearWrapper = styles.clearWrapper,
        statusWrapper = styles.statusWrapper;
    return {
      inputWrapper: inputWrapper,
      input: input,
      nodeDivider: nodeDivider,
      nodeWrapper: nodeWrapper,
      clearWrapper: clearWrapper,
      statusWrapper: statusWrapper
    };
  }, [styles]);
  var currentStyles = (0, _react.useMemo)(function () {
    if (!styles) {
      return;
    }

    var popPanel = styles.popPanel;
    return {
      popPanel: popPanel
    };
  }, [styles]);
  var innerStyles = (0, _useStyles["default"])('date-picker', defaultStyles, currentStyles);

  var _usePickerBase = (0, _usePickerBase2["default"])(),
      innerSuffixNode = _usePickerBase.suffixNode;

  var realNode = /*#__PURE__*/_react["default"].createElement(_styled.StyledInput, (0, _extends2["default"])({
    ref: ref,
    $popupVisible: finalUIState.popupOpen,
    $status: otherProps.status,
    inputRef: handleInputRef,
    value: finalValue,
    disabled: disabled,
    onChange: handleInputChange,
    onFocus: handleFocus,
    onClear: handleClear,
    suffixNode: innerSuffixNode,
    allowClear: allowClear,
    clearReplace: true,
    focusWhenClear: false,
    theme: theme,
    onPressEnter: handlePressEnter,
    styles: inputStyles,
    readOnly: readOnly || inputReadOnly
  }, otherProps));

  if (disabled || readOnly) {
    return realNode;
  }

  var calendarProps = {
    styles: calendarStyles,
    selectType: selectType,
    disableRange: disableRange,
    disableDate: disableDate,
    options: options,
    todayDate: todayDate,
    onSelect: onSelect,
    allowClear: allowClear,
    renderDecadeItem: renderDecadeItem,
    renderMonthItem: renderMonthItem,
    renderYearItem: renderYearItem,
    renderMonthLabel: renderMonthLabel
  };

  var calendarNode = /*#__PURE__*/_react["default"].createElement(_PopPanel.StyledPopPanel, (0, _extends2["default"])({}, innerStyles.popPanel, {
    theme: theme
  }), /*#__PURE__*/_react["default"].createElement(_Calendar.Calendar, (0, _extends2["default"])({
    viewDate: finalUIState.viewDate,
    viewType: finalUIState.viewType,
    selectedDate: finalSelectedDate,
    onChange: handleCalendarChange,
    onUIChange: handleCalendarUIChange
  }, calendarProps)));

  var triggerProps = {
    placement: placement,
    popperProps: popperProps,
    arrowPointAtCenter: arrowPointAtCenter,
    triggerId: triggerId,
    flip: flip,
    hideArrow: true,
    container: container
  };
  return /*#__PURE__*/_react["default"].createElement(_Trigger["default"], (0, _extends2["default"])({
    popup: calendarNode,
    triggerAction: "click",
    open: finalUIState.popupOpen,
    onClickAway: handleClickAway
  }, triggerProps), realNode);
});
var _default = DatePicker;
exports["default"] = _default;