"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Button = _interopRequireDefault(require("../Button"));

var _CalendarFooter = _interopRequireDefault(require("../Calendar/CalendarFooter"));

var _CalendarHead = _interopRequireDefault(require("../Calendar/CalendarHead"));

var _CalendarPanel = _interopRequireDefault(require("../Calendar/CalendarPanel"));

var _InlineButton = _interopRequireDefault(require("../InlineButton"));

var _Locale = require("../Locale");

var _TimePickerPanel = _interopRequireDefault(require("../TimePicker/TimePickerPanel"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _useDateTimeCalendar2 = _interopRequireDefault(require("./useDateTimeCalendar"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Root = _styledComponents["default"].div.withConfig({
  displayName: "Root"
})(["background-color:", ";"], function (props) {
  return props.theme.colors.pattern.background.higher;
});

var StyledPanel = _styledComponents["default"].div.withConfig({
  displayName: "StyledPanel"
})(["display:flex;"]);

var StyledFooter = _styledComponents["default"].div.withConfig({
  displayName: "StyledFooter"
})(["display:flex;justify-content:space-between;align-items:center;border-top:1px solid ", ";height:", "px;"], function (props) {
  return props.theme.colors.pattern.border.normal;
}, function (props) {
  return props.theme.components.Calendar.dateTimeCalendar.footerHeight;
});

var StyledDatePanel = _styledComponents["default"].div.withConfig({
  displayName: "StyledDatePanel"
})(["width:", "px;border-right:1px solid ", ";"], function (props) {
  return props.theme.components.Calendar.defaultWidth;
}, function (props) {
  return props.theme.colors.pattern.border.normal;
});

var StyledTimePanel = _styledComponents["default"].div.withConfig({
  displayName: "StyledTimePanel"
})([""]);

var StyledTimeHead = _styledComponents["default"].div.withConfig({
  displayName: "StyledTimeHead"
})(["border-bottom:1px solid ", ";height:", "px;display:flex;align-items:center;justify-content:center;margin-bottom:", "px;"], function (props) {
  return props.theme.colors.pattern.border.normal;
}, function (props) {
  return props.theme.components.Calendar.head.height;
}, function (props) {
  return props.theme.components.Calendar.dateTimeCalendar.timeHeadMarginBottom;
});

var StyledSpace = _styledComponents["default"].span.withConfig({
  displayName: "StyledSpace"
})(["display:inline-flex;width:", "px;"], function (props) {
  return props.theme.spacing.spec.s6;
});

var StyledButtonContainer = _styledComponents["default"].div.withConfig({
  displayName: "StyledButtonContainer"
})(["padding:0 ", "px;"], function (props) {
  return props.theme.spacing.spec.s3;
});

var defaultStyles = {
  head: '',
  panel: '',
  footer: '',
  dateTimePanel: '',
  dateCol: '',
  timeCol: '',
  timeHead: '',
  timeHeadText: '',
  timePanel: '',
  footerContainer: '',
  buttonContainer: '',
  clearButton: '',
  confirmButton: ''
};
var DateTimeCalendar = (0, _memoForwardRef["default"])(function (props, ref) {
  var _useDateTimeCalendar = (0, _useDateTimeCalendar2["default"])(props),
      timePickerPanelProps = _useDateTimeCalendar.timePickerPanelProps,
      timePanelTitle = _useDateTimeCalendar.timePanelTitle,
      finalValue = _useDateTimeCalendar.finalValue,
      otherProps = _useDateTimeCalendar.otherProps,
      calendarState = _useDateTimeCalendar.calendarState,
      finalOptions = _useDateTimeCalendar.finalOptions,
      timeRowNum = _useDateTimeCalendar.timeRowNum,
      handleClear = _useDateTimeCalendar.handleClear,
      handleConfirm = _useDateTimeCalendar.handleConfirm,
      styles = _useDateTimeCalendar.styles,
      allowClear = _useDateTimeCalendar.allowClear,
      hideItemOutside = _useDateTimeCalendar.hideItemOutside,
      renderDecadeItem = _useDateTimeCalendar.renderDecadeItem,
      renderMonthItem = _useDateTimeCalendar.renderMonthItem,
      renderYearItem = _useDateTimeCalendar.renderYearItem,
      renderMonthLabel = _useDateTimeCalendar.renderMonthLabel;

  var theme = (0, _useTheme["default"])();
  var locale = (0, _Locale.useLocale)();
  var pickStyles = (0, _react.useMemo)(function () {
    if (styles) {
      var head = styles.head,
          panel = styles.panel,
          footer = styles.footer,
          dateTimePanel = styles.dateTimePanel,
          dateCol = styles.dateCol,
          timeCol = styles.timeCol,
          timeHead = styles.timeHead,
          timeHeadText = styles.timeHeadText,
          timePanel = styles.timePanel,
          footerContainer = styles.footerContainer,
          buttonContainer = styles.buttonContainer,
          clearButton = styles.clearButton,
          confirmButton = styles.confirmButton;
      return {
        head: head,
        panel: panel,
        footer: footer,
        dateTimePanel: dateTimePanel,
        dateCol: dateCol,
        timeCol: timeCol,
        timeHead: timeHead,
        timeHeadText: timeHeadText,
        timePanel: timePanel,
        footerContainer: footerContainer,
        buttonContainer: buttonContainer,
        clearButton: clearButton,
        confirmButton: confirmButton
      };
    }
  }, [styles]);
  var innerStyles = (0, _useStyles["default"])('datetime-calendar', defaultStyles, pickStyles); // 本就是解构了传给 pure component，所以不需要 memo

  var panelProps = {
    styles: styles,
    todayDate: calendarState.finalTodayDate,
    disableRange: calendarState.finalDisableRange,
    disableDate: calendarState.disableDate,
    hideItemOutside: hideItemOutside,
    renderDecadeItem: renderDecadeItem,
    renderMonthItem: renderMonthItem,
    renderYearItem: renderYearItem,
    renderMonthLabel: renderMonthLabel
  };
  return /*#__PURE__*/_react["default"].createElement(Root, (0, _extends2["default"])({}, otherProps, {
    theme: theme,
    ref: ref
  }), /*#__PURE__*/_react["default"].createElement(StyledPanel, innerStyles.dateTimePanel, /*#__PURE__*/_react["default"].createElement(StyledDatePanel, (0, _extends2["default"])({
    theme: theme
  }, innerStyles.dateCol), /*#__PURE__*/_react["default"].createElement(_CalendarHead["default"], (0, _extends2["default"])({}, innerStyles.head, {
    styles: styles,
    viewType: calendarState.finalUIState.viewType,
    viewDate: calendarState.finalUIState.viewDate,
    onPrevMonth: calendarState.handlePrevMonth,
    onNextMonth: calendarState.handleNextMonth,
    onPrevYear: calendarState.handlePrevYear,
    onNextYear: calendarState.handleNextYear,
    onSwitch: calendarState.handleSwitch
  })), /*#__PURE__*/_react["default"].createElement(_CalendarPanel["default"], (0, _extends2["default"])({}, innerStyles.panel, {
    viewType: calendarState.finalUIState.viewType,
    selected: finalValue,
    viewDate: calendarState.finalUIState.viewDate,
    onItemClick: calendarState.handleItemClick
  }, panelProps))), /*#__PURE__*/_react["default"].createElement(StyledTimePanel, innerStyles.timeCol, /*#__PURE__*/_react["default"].createElement(StyledTimeHead, (0, _extends2["default"])({
    theme: theme
  }, innerStyles.timeHead), /*#__PURE__*/_react["default"].createElement(_InlineButton["default"], (0, _extends2["default"])({}, innerStyles.timeHeadText, {
    size: "s",
    component: "span",
    constant: true
  }), timePanelTitle)), /*#__PURE__*/_react["default"].createElement(_TimePickerPanel["default"], (0, _extends2["default"])({}, innerStyles.timePanel, {
    rowNum: timeRowNum || 5,
    defaultScrollBehavior: "smooth"
  }, timePickerPanelProps)))), /*#__PURE__*/_react["default"].createElement(StyledFooter, (0, _extends2["default"])({
    theme: theme
  }, innerStyles.footerContainer), /*#__PURE__*/_react["default"].createElement(_CalendarFooter["default"], (0, _extends2["default"])({}, innerStyles.footer, {
    type: "date-time",
    styles: styles,
    options: finalOptions
  })), /*#__PURE__*/_react["default"].createElement(StyledButtonContainer, (0, _extends2["default"])({
    theme: theme
  }, innerStyles.buttonContainer), allowClear && /*#__PURE__*/_react["default"].createElement(_InlineButton["default"], (0, _extends2["default"])({}, innerStyles.clearButton, {
    type: "primary",
    size: "s",
    onClick: handleClear,
    busy: !finalValue
  }), locale['Calendar.clearText']), allowClear && /*#__PURE__*/_react["default"].createElement(StyledSpace, {
    theme: theme
  }), /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({}, innerStyles.confirmButton, {
    onClick: handleConfirm,
    type: "primary",
    size: "s",
    busy: !finalValue
  }), locale['Calendar.confirmText']))));
});
var _default = DateTimeCalendar;
exports["default"] = _default;