"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _usePickerBase2 = _interopRequireDefault(require("../DatePicker/usePickerBase"));

var _PopPanel = require("../styled/components/PopPanel");

var _Trigger = _interopRequireDefault(require("../Trigger"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _DateTimeCalendar = _interopRequireDefault(require("./DateTimeCalendar"));

var _styled = require("./styled");

var _useDateTimePicker2 = _interopRequireDefault(require("./useDateTimePicker"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  popPanel: ''
};
var DateTimePicker = (0, _memoForwardRef["default"])(function (props, ref) {
  var theme = (0, _useTheme["default"])();

  var _useDateTimePicker = (0, _useDateTimePicker2["default"])(props),
      finalUIState = _useDateTimePicker.finalUIState,
      calendarState = _useDateTimePicker.calendarState,
      finalValue = _useDateTimePicker.finalValue,
      otherProps = _useDateTimePicker.otherProps,
      finalTimeFormat = _useDateTimePicker.finalTimeFormat,
      handleFocus = _useDateTimePicker.handleFocus,
      handleCalendarChange = _useDateTimePicker.handleCalendarChange,
      handleCalendarUIChange = _useDateTimePicker.handleCalendarUIChange,
      handleClickAway = _useDateTimePicker.handleClickAway,
      handleClear = _useDateTimePicker.handleClear,
      handleConfirm = _useDateTimePicker.handleConfirm,
      styles = _useDateTimePicker.styles,
      disabled = _useDateTimePicker.disabled,
      allowClear = _useDateTimePicker.allowClear,
      calendarStyles = _useDateTimePicker.calendarStyles,
      disableTimeAfter = _useDateTimePicker.disableTimeAfter,
      disableTimeBefore = _useDateTimePicker.disableTimeBefore,
      defaultTime = _useDateTimePicker.defaultTime,
      todayDate = _useDateTimePicker.todayDate,
      disableRange = _useDateTimePicker.disableRange,
      disableDate = _useDateTimePicker.disableDate,
      options = _useDateTimePicker.options,
      container = _useDateTimePicker.container,
      hideItemOutside = _useDateTimePicker.hideItemOutside,
      renderDecadeItem = _useDateTimePicker.renderDecadeItem,
      renderMonthItem = _useDateTimePicker.renderMonthItem,
      renderYearItem = _useDateTimePicker.renderYearItem,
      renderMonthLabel = _useDateTimePicker.renderMonthLabel,
      timeRowNum = _useDateTimePicker.timeRowNum,
      hourStep = _useDateTimePicker.hourStep,
      minuteStep = _useDateTimePicker.minuteStep,
      secondStep = _useDateTimePicker.secondStep,
      disabledHours = _useDateTimePicker.disabledHours,
      disabledMinutes = _useDateTimePicker.disabledMinutes,
      disabledSeconds = _useDateTimePicker.disabledSeconds,
      hideDisabledOptions = _useDateTimePicker.hideDisabledOptions,
      placement = _useDateTimePicker.placement,
      popperProps = _useDateTimePicker.popperProps,
      arrowPointAtCenter = _useDateTimePicker.arrowPointAtCenter,
      triggerId = _useDateTimePicker.triggerId,
      flip = _useDateTimePicker.flip; // input 的 styles 直接传个 input


  var inputStyles = (0, _react.useMemo)(function () {
    if (!styles) {
      return;
    }

    var inputWrapper = styles.inputWrapper,
        input = styles.input,
        nodeDivider = styles.nodeDivider,
        nodeWrapper = styles.nodeWrapper,
        clearWrapper = styles.clearWrapper,
        statusWrapper = styles.statusWrapper;
    return {
      inputWrapper: inputWrapper,
      input: input,
      nodeDivider: nodeDivider,
      nodeWrapper: nodeWrapper,
      clearWrapper: clearWrapper,
      statusWrapper: statusWrapper
    };
  }, [styles]);
  var currentStyles = (0, _react.useMemo)(function () {
    if (!styles) {
      return;
    }

    var popPanel = styles.popPanel;
    return {
      popPanel: popPanel
    };
  }, [styles]);
  var innerStyles = (0, _useStyles["default"])('datetime-picker', defaultStyles, currentStyles);

  var _usePickerBase = (0, _usePickerBase2["default"])(),
      innerSuffixNode = _usePickerBase.suffixNode;

  var realNode = /*#__PURE__*/_react["default"].createElement(_styled.StyledInput, (0, _extends2["default"])({
    ref: ref,
    value: finalValue,
    suffixNode: innerSuffixNode,
    clearReplace: true,
    focusWhenClear: false,
    theme: theme,
    styles: inputStyles,
    disabled: disabled,
    allowClear: allowClear,
    onFocus: handleFocus,
    onClear: handleClear,
    readOnly: true
  }, otherProps));

  if (disabled) {
    return realNode;
  }

  var calendarProps = {
    styles: calendarStyles,
    options: options,
    todayDate: todayDate,
    allowClear: allowClear,
    disableRange: disableRange,
    disableDate: disableDate,
    timeFormat: finalTimeFormat,
    defaultTime: defaultTime,
    disableTimeAfter: disableTimeAfter,
    disableTimeBefore: disableTimeBefore,
    hideItemOutside: hideItemOutside,
    renderDecadeItem: renderDecadeItem,
    renderMonthItem: renderMonthItem,
    renderYearItem: renderYearItem,
    renderMonthLabel: renderMonthLabel,
    // ---- timepicker panel props
    timeRowNum: timeRowNum,
    hourStep: hourStep,
    minuteStep: minuteStep,
    secondStep: secondStep,
    disabledHours: disabledHours,
    disabledMinutes: disabledMinutes,
    disabledSeconds: disabledSeconds,
    hideDisabledOptions: hideDisabledOptions
  };

  var calendarNode = /*#__PURE__*/_react["default"].createElement(_PopPanel.StyledPopPanel, (0, _extends2["default"])({}, innerStyles.popPanel, {
    theme: theme
  }), /*#__PURE__*/_react["default"].createElement(_DateTimeCalendar["default"], (0, _extends2["default"])({
    viewDate: finalUIState.viewDate,
    viewType: finalUIState.viewType,
    selectedDate: calendarState.finalValue,
    onChange: handleCalendarChange,
    onConfirm: handleConfirm,
    onUIChange: handleCalendarUIChange
  }, calendarProps)));

  var triggerProps = {
    placement: placement,
    popperProps: popperProps,
    arrowPointAtCenter: arrowPointAtCenter,
    triggerId: triggerId,
    flip: flip,
    hideArrow: true,
    container: container
  };
  return /*#__PURE__*/_react["default"].createElement(_Trigger["default"], (0, _extends2["default"])({
    popup: calendarNode,
    triggerAction: "click",
    open: finalUIState.popupOpen,
    onClickAway: handleClickAway
  }, triggerProps), realNode);
});
DateTimePicker.__MUYA_DATETIMEPICKER = true;
var _default = DateTimePicker;
exports["default"] = _default;