"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _excluded = ["tipAction", "children"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledDialogActions = _styledComponents["default"].div.withConfig({
  displayName: "StyledDialogActions"
})(["display:flex;flex-flow:row nowrap;align-items:center;box-sizing:border-box;flex:0 0 auto;justify-content:", ";", ""], function (props) {
  return props.tipAction ? 'space-between' : 'flex-end';
}, function (props) {
  if (props.fullWidth) {
    return (0, _styledComponents.css)(["padding:", ";"], props.theme.components.Dialog.actions.fullWidthPadding);
  }

  return (0, _styledComponents.css)(["padding:", ";"], props.theme.components.Dialog.actions.complexPadding);
});

var StyledChildrenWrapper = _styledComponents["default"].span.withConfig({
  displayName: "StyledChildrenWrapper"
})(["&& > * + *{margin-left:", "px;}"], function (props) {
  return props.theme.components.Dialog.actions.childrenSpacing;
});

var _default = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var tipAction = props.tipAction,
      children = props.children,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var actions = tipAction ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("span", null, tipAction), /*#__PURE__*/_react["default"].createElement(StyledChildrenWrapper, {
    theme: theme
  }, children)) : /*#__PURE__*/_react["default"].createElement(StyledChildrenWrapper, {
    theme: theme
  }, children);
  return /*#__PURE__*/_react["default"].createElement(StyledDialogActions, (0, _extends2["default"])({
    ref: ref,
    theme: theme,
    tipAction: tipAction
  }, other), actions);
});

exports["default"] = _default;