"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.warning = exports.success = exports.info = exports.error = exports["default"] = exports.config = exports.alert = void 0;

var _theme = require("@muya-ui/theme-light/lib/theme");

var _CloseIcon2 = require("@muya-ui/theme-light/lib/icons/CloseIcon");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _remove2 = _interopRequireDefault(require("lodash/remove"));

var _react = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _LocaleContext = _interopRequireDefault(require("../Locale/LocaleContext"));

var _useLocale = _interopRequireDefault(require("../Locale/useLocale"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _Actions = _interopRequireDefault(require("./Actions"));

var _AlertActionButton = require("./AlertActionButton");

var _Base = _interopRequireDefault(require("./Base"));

var _Content = _interopRequireDefault(require("./Content"));

var _excluded = ["confirmText", "cancelText", "confirmButtonType", "onConfirm", "onCancel", "title", "text", "icon", "type", "size", "open", "styles", "onClose", "closeIcon", "hideClose", "tipAction", "confirmButtonProps", "cancelButtonProps", "closeFn"],
    _excluded2 = ["theme", "locale", "styleSheet"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledActions = (0, _styledComponents["default"])(_Actions["default"]).withConfig({
  displayName: "StyledActions"
})(["", ""], function (props) {
  return (0, _styledComponents.css)(["padding:", ";"], props.theme.components.Dialog.actions.paddingForAlert);
});
var StyledIconWrapper = (0, _styledComponents["default"])(_AlertActionButton.AlertActionInlineButton).withConfig({
  displayName: "StyledIconWrapper"
})(["&&{position:absolute;right:", "px;top:", "px;padding:0;}"], function (props) {
  return props.theme.components.Dialog.title.closeIconRight;
}, function (props) {
  return props.theme.components.Dialog.title.closeIconTop;
});
var defaultStyles = {
  content: '',
  actions: ''
};
var Alert = (0, _memoForwardRef["default"])(function (props, ref) {
  var local = (0, _useLocale["default"])();
  var _props$confirmText = props.confirmText,
      confirmText = _props$confirmText === void 0 ? local['Modal.okText'] : _props$confirmText,
      cancelText = props.cancelText,
      _props$confirmButtonT = props.confirmButtonType,
      confirmButtonType = _props$confirmButtonT === void 0 ? 'primary' : _props$confirmButtonT,
      onConfirm = props.onConfirm,
      onCancel = props.onCancel,
      title = props.title,
      text = props.text,
      icon = props.icon,
      _props$type = props.type,
      type = _props$type === void 0 ? 'info' : _props$type,
      _props$size = props.size,
      size = _props$size === void 0 ? 's' : _props$size,
      open = props.open,
      styles = props.styles,
      onClose = props.onClose,
      closeIcon = props.closeIcon,
      _props$hideClose = props.hideClose,
      hideClose = _props$hideClose === void 0 ? true : _props$hideClose,
      tipAction = props.tipAction,
      confirmButtonProps = props.confirmButtonProps,
      cancelButtonProps = props.cancelButtonProps,
      closeFn = props.closeFn,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var innerStyles = (0, _useStyles["default"])('dialog-alert', defaultStyles, styles);
  var handleClose = (0, _react.useCallback)(function (e) {
    if (!onClose) {
      closeFn && closeFn();
      return;
    }

    var res = onClose(e);
    if (!res) return;

    if (res.then) {
      res.then(function () {
        if ((arguments.length <= 0 ? undefined : arguments[0]) !== false) {
          closeFn && closeFn();
        }
      }, function (e) {
        console.error(e);
      });
    } else {
      closeFn && closeFn();
    }
  }, [closeFn, onClose]);
  var confirmButton = confirmText ? /*#__PURE__*/_react["default"].createElement(_AlertActionButton.AlertActionButton, (0, _extends2["default"])({
    closeAlert: closeFn,
    type: confirmButtonType,
    actionFn: onConfirm,
    open: open
  }, confirmButtonProps), confirmText) : null;
  var cancelButton = cancelText ? /*#__PURE__*/_react["default"].createElement(_AlertActionButton.AlertActionButton, (0, _extends2["default"])({
    plain: true,
    closeAlert: closeFn,
    actionFn: onCancel,
    open: open
  }, cancelButtonProps), cancelText) : null;
  var Close = theme.components.Dialog.title.closeIcon || _CloseIcon2.CloseIcon;
  return /*#__PURE__*/_react["default"].createElement(_Base["default"], (0, _extends2["default"])({
    ref: ref,
    open: open,
    size: size,
    onClose: handleClose
  }, other), /*#__PURE__*/_react["default"].createElement(_Content["default"], (0, _extends2["default"])({}, innerStyles.content, {
    type: type,
    title: title,
    text: text,
    icon: icon,
    size: size
  })), /*#__PURE__*/_react["default"].createElement(StyledActions, (0, _extends2["default"])({}, innerStyles.actions, {
    theme: theme,
    tipAction: tipAction
  }), cancelButton, confirmButton), !hideClose && /*#__PURE__*/_react["default"].createElement(StyledIconWrapper, {
    closeAlert: closeFn,
    actionFn: onClose,
    size: size,
    theme: theme,
    open: open,
    type: "weak"
  }, closeIcon || /*#__PURE__*/_react["default"].createElement(Close, null)));
});
var dialogItemList = [];
var defaultConfig = {
  theme: _theme.muyaThemeLight
};

var alert = function alert(config) {
  var div = document.createElement('div');
  var mergedConfig = (0, _extends2["default"])({}, defaultConfig, config);
  var currentConfig = mergedConfig;

  function render(props) {
    var innerTheme = props.theme,
        locale = props.locale,
        styleSheet = props.styleSheet,
        other = (0, _objectWithoutProperties2["default"])(props, _excluded2);

    var children = /*#__PURE__*/_react["default"].createElement(_styledComponents.ThemeProvider, {
      theme: innerTheme
    }, /*#__PURE__*/_react["default"].createElement(Alert, (0, _extends2["default"])({
      open: true,
      closeFn: close,
      onExited: destroy
    }, other)));

    if (styleSheet) {
      children = /*#__PURE__*/_react["default"].createElement(_styledComponents.StyleSheetManager, {
        target: styleSheet
      }, /*#__PURE__*/_react["default"].createElement(_styledComponents.ThemeProvider, {
        theme: innerTheme
      }, /*#__PURE__*/_react["default"].createElement(Alert, (0, _extends2["default"])({
        open: true,
        closeFn: close,
        onExited: destroy
      }, other))));
    }

    if (locale) {
      _reactDom["default"].render( /*#__PURE__*/_react["default"].createElement(_LocaleContext["default"].Provider, {
        value: locale
      }, children), div);

      return;
    }

    _reactDom["default"].render(children, div);
  }

  function close() {
    currentConfig = (0, _extends2["default"])({}, currentConfig, {
      open: false
    });
    render(currentConfig);
  }

  function open() {
    currentConfig = (0, _extends2["default"])({}, currentConfig, {
      open: true
    });
    render(currentConfig);
  }

  function destroy() {
    var noCache = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

    if (noCache === true) {
      (0, _remove2["default"])(dialogItemList, item);
    } else {
      currentConfig = (0, _extends2["default"])({}, currentConfig, {
        open: false
      });
    }

    return _reactDom["default"].unmountComponentAtNode(div);
  }

  function update(newConfig) {
    currentConfig = (0, _extends2["default"])({}, currentConfig, newConfig);
    render(currentConfig);
  }

  render(currentConfig);
  var item = {
    update: update,
    close: close,
    open: open,
    destroy: destroy,
    getConfig: function getConfig() {
      return currentConfig;
    }
  };
  dialogItemList.push(item);
  return item;
};
/**
 *
 * 修改配置
 * @param {Partial<IDialogAlertProps>} newConfig
 */


exports.alert = alert;

var config = function config(newConfig) {
  // 首先修改默认配置，后续创建的实例都会使用新的默认配置
  defaultConfig = (0, _extends2["default"])({}, defaultConfig, newConfig); // 已经创建了的实例，也需要更新配置

  dialogItemList.forEach(function (item) {
    return item.update(newConfig);
  });
};

exports.config = config;

var success = function success(props) {
  return alert((0, _extends2["default"])({
    type: 'success'
  }, props));
};

exports.success = success;

var info = function info(props) {
  return alert((0, _extends2["default"])({
    type: 'info'
  }, props));
};

exports.info = info;

var warning = function warning(props) {
  return alert((0, _extends2["default"])({
    type: 'warning'
  }, props));
};

exports.warning = warning;

var error = function error(props) {
  return alert((0, _extends2["default"])({
    type: 'error'
  }, props));
};

exports.error = error;
var _default = Alert;
exports["default"] = _default;