"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AlertActionInlineButton = exports.AlertActionButton = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _Button = require("../Button");

var _excluded = ["actionFn", "closeAlert", "loading", "onClick", "open"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var useActionButton = function useActionButton(props) {
  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      loadingState = _useState2[0],
      setLoading = _useState2[1];

  var actionFn = props.actionFn,
      closeAlert = props.closeAlert,
      loadingProp = props.loading,
      onClick = props.onClick,
      open = props.open,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var loading = 'loading' in props ? loadingProp : loadingState;
  var handleClick = (0, _react.useCallback)(function (e) {
    // 防止重复点击，当弹窗被关闭，动画执行过程中，不执行以下动作
    if (!open) return; // 首先调用外部传入的onClick

    if (onClick) {
      onClick(e);
    } // 没有传入actionFn，关闭弹窗


    if (!actionFn) {
      closeAlert && closeAlert();
      return;
    }

    var res = actionFn(e); // 返回falsy不关闭

    if (!res) return; // Promise resolve后关闭

    if (res.then) {
      setLoading(true);
      res.then(function () {
        setLoading(false);

        if ((arguments.length <= 0 ? undefined : arguments[0]) !== false) {
          closeAlert && closeAlert.apply(void 0, arguments);
        }
      }, function (e) {
        // Emit error when catch promise reject
        console.error(e);
        setLoading(false);
      });
    } else {
      closeAlert && closeAlert(e);
    }
  }, [actionFn, closeAlert, onClick, open]);
  return (0, _extends2["default"])({}, other, {
    onClick: handleClick,
    loading: loading
  });
};

var AlertActionButton = /*#__PURE__*/_react["default"].memo(function (props) {
  var buttonProps = useActionButton(props);
  return /*#__PURE__*/_react["default"].createElement(_Button.Button, buttonProps);
});

exports.AlertActionButton = AlertActionButton;

var AlertActionInlineButton = /*#__PURE__*/_react["default"].memo(function (props) {
  var buttonProps = useActionButton(props);
  return /*#__PURE__*/_react["default"].createElement(_Button.InlineButton, buttonProps);
});

exports.AlertActionInlineButton = AlertActionInlineButton;