"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useLockScroll2 = require("@muya-ui/utils/lib/hooks/useLockScroll");

var _useEventCallback2 = require("@muya-ui/utils/lib/hooks/useEventCallback");

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _Animation = _interopRequireDefault(require("../Animation"));

var _Portal = _interopRequireWildcard(require("../Portal"));

var _addPx = _interopRequireDefault(require("../utils/addPx"));

var _forkHandler = _interopRequireDefault(require("../utils/forkHandler"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _StyledContainer = _interopRequireDefault(require("./StyledContainer"));

var _StyledRoot = _interopRequireDefault(require("./StyledRoot"));

var _excluded = ["disablePortal", "open", "container", "children", "onRendered", "disableEscapeKeyDown", "disableMaskClick", "onClose", "onMaskClick", "onEscapeKeyDown", "hideMask", "onEntered", "onExited", "lazyMount", "destroyOnClose", "size", "fullWidth", "fullScreen", "disableSize", "dialogContainerProps", "customDialogContainer", "width", "height", "maxHeight", "zIndex", "rootRef"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _default = (0, _memoForwardRef["default"])(function (props, ref) {
  var disablePortal = props.disablePortal,
      _props$open = props.open,
      open = _props$open === void 0 ? false : _props$open,
      container = props.container,
      children = props.children,
      onRendered = props.onRendered,
      disableEscapeKeyDown = props.disableEscapeKeyDown,
      disableMaskClick = props.disableMaskClick,
      onClose = props.onClose,
      onMaskClick = props.onMaskClick,
      onEscapeKeyDown = props.onEscapeKeyDown,
      hideMask = props.hideMask,
      onEntered = props.onEntered,
      onExited = props.onExited,
      _props$lazyMount = props.lazyMount,
      lazyMount = _props$lazyMount === void 0 ? false : _props$lazyMount,
      destroyOnClose = props.destroyOnClose,
      size = props.size,
      fullWidth = props.fullWidth,
      fullScreen = props.fullScreen,
      disableSize = props.disableSize,
      dialogContainerProps = props.dialogContainerProps,
      customDialogContainer = props.customDialogContainer,
      width = props.width,
      height = props.height,
      maxHeight = props.maxHeight,
      zIndex = props.zIndex,
      rootRef = props.rootRef,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();

  var _useState = (0, _react.useState)(!open),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      exited = _useState2[0],
      setExited = _useState2[1];

  var _useState3 = (0, _react.useState)(),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      mouseDownNode = _useState4[0],
      setMouseDownNode = _useState4[1];

  var dialogRef = (0, _react.useRef)(null);
  var handleRootRef = (0, _useForkRef2.useForkRef)(dialogRef, rootRef);
  var firstMountRef = (0, _react.useRef)(false);
  var handleMaskClick = (0, _useEventCallback2.useEventCallback)(function (event) {
    // 如果鼠标按下时的元素和当前元素不是一个东西，阻止弹窗关闭
    if (event.target !== mouseDownNode) {
      return;
    }

    if (event.target !== event.currentTarget) {
      return;
    } // 弹窗点击蒙层时的回调


    if (onMaskClick) {
      onMaskClick(event);
    }

    if (!disableMaskClick && onClose) {
      onClose(event, 'maskClick');
    }
  }, []);
  var handleKeyDown = (0, _useEventCallback2.useEventCallback)(function (event) {
    // We don't take event.defaultPrevented into account:
    //
    // event.preventDefault() is meant to stop default behaviours like
    // clicking a checkbox to check it, hitting a button to submit a form,
    // and hitting left arrow to move the cursor in a text input etc.
    // Only special HTML elements have these default behaviors.
    if (event.key !== 'Escape') {
      return;
    }

    event.stopPropagation(); // 按下ESC键触发的回调

    if (onEscapeKeyDown) {
      onEscapeKeyDown(event);
    }

    if (!disableEscapeKeyDown && onClose) {
      onClose(event, 'escapeKeyDown');
    }
  }, []);
  var handleEntered = (0, _react.useMemo)(function () {
    return (0, _forkHandler["default"])(function () {
      if (open && dialogRef.current) {
        // 禁用ESC键时，不需要focus
        !disableEscapeKeyDown && dialogRef.current.focus();
      }
    }, onEntered);
  }, [disableEscapeKeyDown, onEntered, open]);
  var handleExited = (0, _react.useMemo)(function () {
    return (0, _forkHandler["default"])(function () {
      setExited(true);
    }, onExited);
  }, [onExited]);
  var handleEnter = (0, _react.useCallback)(function () {
    setExited(false);
  }, []);
  var handleMouseDown = (0, _useEventCallback2.useEventCallback)(function (event) {
    setMouseDownNode(event.target);
  }, []);
  /**
   * effect: dialog出现时隐藏container的滚动条
   * 1. 当前动画处于非exited状态，隐藏container的滚动条
   * 2. 此处使用exited，是希望关闭弹窗时，弹窗动画执行完毕之后，再隐藏滚动条
   * 3. 如果不使用exited，直接使用open，弹窗动画未执行完毕时，滚动条就隐藏了，此时页面会有跳动的感觉
   */

  (0, _useLockScroll2.useLockScroll)(!exited, _Portal.portalUtils.getPortalContainer(container));
  var childrenWithProps = (0, _react.useMemo)(function () {
    return _react["default"].Children.map(children, function (child) {
      var props = /*#__PURE__*/_react["default"].isValidElement(child) && typeof child.type === 'string' ? {} : {
        fullWidth: fullWidth
      };
      return child && /*#__PURE__*/_react["default"].cloneElement(child, props);
    });
  }, [children, fullWidth]);
  var dialogContainer = (0, _react.useMemo)(function () {
    return customDialogContainer || /*#__PURE__*/_react["default"].createElement(_StyledContainer["default"], (0, _extends2["default"])({
      theme: theme,
      $size: size,
      $fullScreen: fullScreen,
      $fullWidth: fullWidth,
      $disableSize: disableSize,
      $width: (0, _addPx["default"])(width),
      $height: (0, _addPx["default"])(height),
      $maxHeight: (0, _addPx["default"])(maxHeight),
      ref: ref
    }, dialogContainerProps), typeof children === 'string' ? children : childrenWithProps);
  }, [children, childrenWithProps, customDialogContainer, dialogContainerProps, disableSize, fullScreen, fullWidth, height, maxHeight, ref, size, theme, width]);
  var rootChildren = (0, _react.useMemo)(function () {
    // destroyOnClose逻辑，在弹窗关闭并且动画执行完毕之后，才会渲染null
    if (destroyOnClose && !open && exited) {
      return null;
    } // lazyMount开启 && 初次渲染，执行懒加载，不渲染子节点


    if (lazyMount && !firstMountRef.current && !open && exited) {
      return null;
    }

    return dialogContainer;
  }, [destroyOnClose, dialogContainer, exited, lazyMount, open]); // 第一次渲染后，将firstMountRef设置为true

  if (!firstMountRef.current) {
    firstMountRef.current = true;
  }

  return /*#__PURE__*/_react["default"].createElement(_Portal["default"], {
    disablePortal: disablePortal,
    container: container,
    onRendered: onRendered
  }, /*#__PURE__*/_react["default"].createElement(_Animation["default"].Fade, {
    "in": open,
    onEntered: handleEntered,
    onExited: handleExited,
    onEnter: handleEnter
  }, /*#__PURE__*/_react["default"].createElement(_StyledRoot["default"], (0, _extends2["default"])({
    theme: theme,
    role: "presentation",
    ref: handleRootRef,
    onKeyDown: handleKeyDown,
    tabIndex: -1,
    onClick: handleMaskClick,
    onMouseDown: handleMouseDown,
    $hideMask: hideMask,
    $container: _Portal.portalUtils.getPortalContainer(container),
    $zIndex: zIndex
  }, other), rootChildren)));
});

exports["default"] = _default;