"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ClearIcon2 = require("@muya-ui/theme-light/lib/icons/ClearIcon");

var _ReminderIcon2 = require("@muya-ui/theme-light/lib/icons/ReminderIcon");

var _InformIcon2 = require("@muya-ui/theme-light/lib/icons/InformIcon");

var _SuccessIcon2 = require("@muya-ui/theme-light/lib/icons/SuccessIcon");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Typography = _interopRequireDefault(require("../Typography"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _excluded = ["children", "hideDividers", "title", "text", "type", "icon", "fullWidth", "size"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function makeContentStyle(props) {
  var token = props.theme.components.Dialog;
  var content = token.content;
  var borderStyle;
  var paddingStyle = (0, _styledComponents.css)(["padding:", " ", " ", ";"], content.paddingTop, content.paddingHorizontal, content.paddingBottom);

  if (!props.$hideDividers) {
    borderStyle = (0, _styledComponents.css)(["border-bottom:1px solid ", ";"], content.borderColor);
  }

  if (props.$type) {
    paddingStyle = (0, _styledComponents.css)(["padding:", ";"], content.paddingWithType);
  }

  if (props.$fullWidth) {
    paddingStyle = (0, _styledComponents.css)(["padding:", " ", " ", ";"], content.paddingTop, content.fullWidthPaddingHorizontal, content.paddingBottom);
  }

  return (0, _styledComponents.css)(["flex:1;overflow-y:auto;box-sizing:border-box;", " ", ""], borderStyle, paddingStyle);
}

var StyledDialogContent = _styledComponents["default"].div.withConfig({
  displayName: "StyledDialogContent"
})(["", ""], makeContentStyle);

var StyledContentTitleWrapper = (0, _styledComponents["default"])(_Typography["default"].Title).withConfig({
  displayName: "StyledContentTitleWrapper"
})(["position:relative;margin-bottom:", "px;"], function (props) {
  return props.theme.components.Dialog.content.titleMarginBottom;
});

var StyledIconWrapper = _styledComponents["default"].span.withConfig({
  displayName: "StyledIconWrapper"
})(["position:absolute;top:", "px;left:-", "px;transform:translateX(-100%);color:", ";"], function (props) {
  return props.theme.components.Dialog.content.iconMarginTop;
}, function (props) {
  return props.theme.components.Dialog.content.iconMarginLeft;
}, function (props) {
  return props.$type && props.theme.colors.pattern.feature[props.$type];
});

var _default = (0, _memoForwardRef["default"])(function (props, ref) {
  var children = props.children,
      hideDividers = props.hideDividers,
      title = props.title,
      text = props.text,
      type = props.type,
      icon = props.icon,
      fullWidth = props.fullWidth,
      size = props.size,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();

  if (!type) {
    return /*#__PURE__*/_react["default"].createElement(StyledDialogContent, (0, _extends2["default"])({
      ref: ref,
      theme: theme,
      $hideDividers: hideDividers,
      $type: type,
      $fullWidth: fullWidth
    }, other), children);
  }

  var typeIcon = (0, _extends2["default"])({
    success: _SuccessIcon2.SuccessIcon,
    info: _InformIcon2.InformIcon,
    warning: _ReminderIcon2.ReminderIcon,
    error: _ClearIcon2.ClearIcon
  }, theme.components.Dialog.content.typeIcon);
  var _theme$components$Dia = theme.components.Dialog.content,
      typeIconBgColor = _theme$components$Dia.typeIconBgColor,
      defaultTitleLevel = _theme$components$Dia.defaultTitleLevel;
  var Icon = typeIcon[type];
  var iconBgColor = typeIconBgColor[type];
  return /*#__PURE__*/_react["default"].createElement(StyledDialogContent, (0, _extends2["default"])({
    ref: ref,
    theme: theme,
    $type: type,
    $fullWidth: fullWidth,
    $hideDividers: true
  }, other), /*#__PURE__*/_react["default"].createElement(StyledContentTitleWrapper, {
    theme: theme,
    level: defaultTitleLevel
  }, /*#__PURE__*/_react["default"].createElement(StyledIconWrapper, {
    theme: theme,
    $type: type
  }, icon || /*#__PURE__*/_react["default"].createElement(Icon, {
    bgColor: iconBgColor
  })), title), /*#__PURE__*/_react["default"].createElement(_Typography["default"].Paragraph, {
    as: "div",
    fontSize: "s2",
    color: "assistant"
  }, text));
});

exports["default"] = _default;