"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// 这里没有用min-width，因为容器需要限制宽度，如有需要外部可以禁用默认宽高
function makeContainerStyle(props) {
  var _props$$size = props.$size,
      $size = _props$$size === void 0 ? 'l' : _props$$size,
      $disableSize = props.$disableSize,
      $fullWidth = props.$fullWidth,
      $fullScreen = props.$fullScreen,
      $width = props.$width,
      $height = props.$height,
      $maxHeight = props.$maxHeight,
      theme = props.theme;
  var minSizeStyle;
  var fullWidthStyle;
  var fullScreenStyle;
  var customWidthStyle;
  var customHeightStyle;
  var customMaxHeightStyle; // disableSize为true，禁用默认样式

  if (!$disableSize) {
    var currentMinSize = theme.components.Dialog.size[$size];
    minSizeStyle = (0, _styledComponents.css)(["width:", "px;min-height:", "px;"], currentMinSize.width, currentMinSize.height);
  }

  if ($fullWidth) {
    var _theme$components$Dia = theme.components.Dialog.fullWidth,
        marginTopAndBottom = _theme$components$Dia.marginTopAndBottom,
        widthPrecent = _theme$components$Dia.widthPrecent;
    fullWidthStyle = (0, _styledComponents.css)(["left:50%;top:0;transform:translateX(-50%);margin:", "px 0;width:", "%;min-height:calc(100% - ", "px);max-height:calc(100% - ", "px);"], marginTopAndBottom, widthPrecent, 2 * marginTopAndBottom, 2 * marginTopAndBottom);
  }

  if ($fullScreen) {
    fullScreenStyle = (0, _styledComponents.css)(["left:0;top:0;transform:none;margin:0;width:100%;min-height:100%;max-height:100%;max-width:100%;border-radius:0;"]);
  }

  if ($width) {
    customWidthStyle = (0, _styledComponents.css)(["width:", ";"], $width);
  }

  if ($height) {
    customHeightStyle = (0, _styledComponents.css)(["height:", ";"], $height);
  }

  if ($maxHeight) {
    customMaxHeightStyle = (0, _styledComponents.css)(["max-height:", ";"], $maxHeight);
  }

  return (0, _styledComponents.css)(["", " ", " ", " ", " ", " ", ""], minSizeStyle, fullWidthStyle, fullScreenStyle, customWidthStyle, customHeightStyle, customMaxHeightStyle);
}

var _default = _styledComponents["default"].div(["", ""], function (props) {
  var _props$theme = props.theme,
      colors = _props$theme.colors,
      token = _props$theme.components.Dialog;
  return (0, _styledComponents.css)(["display:flex;flex-flow:column nowrap;position:absolute;left:50%;box-sizing:border-box;pointer-events:auto;top:", "%;transform:", ";background:", ";border-radius:", ";box-shadow:", ";", ""], token.top, "translate(-50%, -".concat(token.top, "%)"), colors.pattern.background.higher, token.containerBorderRadius, token.shadow, makeContainerStyle);
});

exports["default"] = _default;