"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _CloseIcon2 = require("@muya-ui/theme-light/lib/icons/CloseIcon");

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _Typography = _interopRequireDefault(require("../Typography"));

var _Title = require("../Typography/Title");

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _excluded = ["children", "onClose", "hideClose", "disableTypography", "closeIcon", "closeButtonSize", "level"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledDialogTitle = _styledComponents["default"].div.withConfig({
  displayName: "StyledDialogTitle"
})(["position:relative;display:flex;flex-flow:row nowrap;align-items:center;box-sizing:border-box;flex:0 0 auto;", " ", "{margin-bottom:0;}"], function (props) {
  var token = props.theme.components.Dialog.title;
  return (0, _styledComponents.css)(["border-bottom:", ";padding:", "px ", "px;", ";"], token.borderBottom, token.paddingVertical, token.paddingHorizontal, props.fullWidth && "padding: ".concat(token.fullWidthPadding));
}, _Title.StyledTitle);

var StyledIconWrapper = (0, _styledComponents["default"])(_IconButton["default"]).withConfig({
  displayName: "StyledIconWrapper"
})(["&&{position:absolute;top:50%;transform:translateY(-50%);right:", "px;padding:0;}"], function (props) {
  return props.theme.components.Dialog.title.paddingHorizontal;
});

var _default = (0, _memoForwardRef["default"])(function (props, ref) {
  var theme = (0, _useTheme["default"])();
  var titleToken = theme.components.Dialog.title;
  var Close = titleToken.closeIcon || _CloseIcon2.CloseIcon;
  var children = props.children,
      onClose = props.onClose,
      hideClose = props.hideClose,
      disableTypography = props.disableTypography,
      closeIcon = props.closeIcon,
      closeButtonSize = props.closeButtonSize,
      _props$level = props.level,
      level = _props$level === void 0 ? titleToken.defaultTitleLevel : _props$level,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  return /*#__PURE__*/_react["default"].createElement(StyledDialogTitle, (0, _extends2["default"])({
    ref: ref,
    theme: theme
  }, other), disableTypography ? children : /*#__PURE__*/_react["default"].createElement(_Typography["default"].Title, {
    level: level
  }, children), !hideClose && /*#__PURE__*/_react["default"].createElement(StyledIconWrapper, {
    size: closeButtonSize,
    theme: theme,
    onClick: onClose
  }, closeIcon || /*#__PURE__*/_react["default"].createElement(Close, null)));
});

exports["default"] = _default;