"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _Animation = _interopRequireDefault(require("../Animation"));

var _Dialog = _interopRequireDefault(require("../Dialog"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _excluded = ["direction", "width", "height", "slideProps", "children", "open", "styles"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  container: ''
};

var _default = /*#__PURE__*/(0, _react.forwardRef)(function Drawer(props, ref) {
  var _props$direction = props.direction,
      direction = _props$direction === void 0 ? 'left' : _props$direction,
      _props$width = props.width,
      width = _props$width === void 0 ? '30%' : _props$width,
      _props$height = props.height,
      height = _props$height === void 0 ? '40%' : _props$height,
      slideProps = props.slideProps,
      children = props.children,
      open = props.open,
      styles = props.styles,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var innerStyles = (0, _useStyles["default"])('drawer', defaultStyles, styles);
  var customDialogContainer = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement(_Animation["default"].Slide, (0, _extends2["default"])({
      direction: direction,
      minScale: 0,
      timeout: theme.transition.spec.duration.fast,
      "in": open,
      ref: ref
    }, slideProps), /*#__PURE__*/_react["default"].createElement(_styled.StyledCustomDialogContainer, (0, _extends2["default"])({
      $direction: direction,
      $width: width,
      $height: height,
      theme: theme
    }, innerStyles.container), children));
  }, [children, direction, height, innerStyles, open, ref, slideProps, theme, width]);
  return /*#__PURE__*/_react["default"].createElement(_Dialog["default"].Base, (0, _extends2["default"])({
    customDialogContainer: customDialogContainer,
    open: open,
    ref: ref
  }, other));
});

exports["default"] = _default;