"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledCustomDialogContainer = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledCustomDialogContainer = _styledComponents["default"].div.withConfig({
  displayName: "StyledCustomDialogContainer"
})(["", ""], function (props) {
  var $direction = props.$direction,
      $width = props.$width,
      $height = props.$height,
      theme = props.theme;
  var width = typeof $width === 'number' ? "".concat($width, "px") : $width;
  var height = typeof $height === 'number' ? "".concat($height, "px") : $height;
  var widthStyle = "calc(100% - ".concat(width, ")");
  var heightStyle = "calc(100% - ".concat(height, ")");
  var positionStyle;

  if ($direction === 'up') {
    positionStyle = (0, _styledComponents.css)(["top:0;bottom:", ";left:0;right:0;"], heightStyle);
  } else if ($direction === 'down') {
    positionStyle = (0, _styledComponents.css)(["bottom:0;top:", ";left:0;right:0;"], heightStyle);
  } else if ($direction === 'right') {
    positionStyle = (0, _styledComponents.css)(["top:0;bottom:0;left:", ";right:0;"], widthStyle);
  } else {
    positionStyle = (0, _styledComponents.css)(["left:0;right:", ";top:0;bottom:0;"], widthStyle);
  }

  return (0, _styledComponents.css)(["display:flex;flex-flow:column nowrap;position:absolute;box-sizing:border-box;background:", ";z-index:", ";overflow:auto;pointer-events:auto;box-shadow:", ";", ";"], theme.colors.pattern.background.higher, theme.zIndex.pattern.dialog, theme.shadows.spec.s1.normal, positionStyle);
});

exports.StyledCustomDialogContainer = StyledCustomDialogContainer;