"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useDropdown;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useEventCallback2 = require("@muya-ui/utils/lib/hooks/useEventCallback");

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _Animation = _interopRequireDefault(require("../Animation"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _excluded = ["hideArrow", "placement", "visible", "defaultVisible", "disabled", "overlay", "size", "onOverlayClick", "TransitionComponent", "onVisibleChange", "children", "getPopupContainer"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function useDropdown(props, ref) {
  var _props$hideArrow = props.hideArrow,
      hideArrow = _props$hideArrow === void 0 ? true : _props$hideArrow,
      _props$placement = props.placement,
      placement = _props$placement === void 0 ? 'bottom-start' : _props$placement,
      visible = props.visible,
      _props$defaultVisible = props.defaultVisible,
      defaultVisible = _props$defaultVisible === void 0 ? false : _props$defaultVisible,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      overlay = props.overlay,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      onOverlayClick = props.onOverlayClick,
      _props$TransitionComp = props.TransitionComponent,
      TransitionComponent = _props$TransitionComp === void 0 ? _Animation["default"].Slide : _props$TransitionComp,
      onVisibleChangeProp = props.onVisibleChange,
      children = props.children,
      getPopupContainer = props.getPopupContainer,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var shadows = theme.shadows,
      DropdownToken = theme.components.Dropdown;

  var _useState = (0, _react.useState)(defaultVisible),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      openState = _useState2[0],
      setOpenState = _useState2[1];

  var child = (0, _react.useMemo)(function () {
    return _react["default"].Children.only(children);
  }, [children]);
  var triggerRef = (0, _react.useRef)(null);
  var handleRef = (0, _useForkRef2.useForkRef)(triggerRef, child.ref);

  var _useRef = (0, _react.useRef)('visible' in props),
      isControlled = _useRef.current;

  _react["default"].useImperativeHandle(ref, function () {
    return triggerRef.current;
  }, [triggerRef]);

  if (isControlled && openState !== visible) {
    setOpenState(visible);
  }

  var onVisibleChange = (0, _react.useCallback)(function (visible) {
    if (!isControlled) {
      setOpenState(visible);
    }

    if (onVisibleChangeProp) {
      onVisibleChangeProp(visible);
    }
  }, [isControlled, onVisibleChangeProp]);
  var getOverlayElement = (0, _react.useCallback)(function () {
    var overlayElement;

    if (typeof overlay === 'function') {
      overlayElement = overlay();
    } else {
      overlayElement = overlay;
    }

    overlayElement = _react["default"].Children.only(overlayElement);
    return overlayElement;
  }, [overlay]);
  var onClick = (0, _useEventCallback2.useEventCallback)(function (selectInfo) {
    var overlayProps = getOverlayElement().props;

    if (!isControlled) {
      setOpenState(false);
    }

    if (onOverlayClick) {
      onOverlayClick(selectInfo);
    }

    if (overlayProps.onClick) {
      overlayProps.onClick(selectInfo);
    }
  }, []);
  var menu = (0, _react.useMemo)(function () {
    var overlayElement = getOverlayElement();
    var extraOverlayProps = {
      size: size,
      hideRootMenuSpacing: true,
      onClick: onClick,
      style: (0, _extends2["default"])({}, overlayElement.props.style, {
        boxShadow: shadows.pattern.popper.normal
      })
    };

    if (DropdownToken.menuItemAlign) {
      extraOverlayProps.menuItemAlign = DropdownToken.menuItemAlign;
    }

    return /*#__PURE__*/_react["default"].cloneElement(overlayElement, extraOverlayProps);
  }, [DropdownToken.menuItemAlign, getOverlayElement, onClick, shadows.pattern.popper.normal, size]);
  var dropdownTrigger = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].cloneElement(child, {
      ref: handleRef,
      disabled: disabled
    });
  }, [child, disabled, handleRef]);
  var arrowStyle = (0, _react.useMemo)(function () {
    return {
      color: theme.colors.pattern.background.higher
    };
  }, [theme.colors.pattern.background.higher]);
  var open = isControlled ? visible : openState;
  return (0, _extends2["default"])({}, restProps, {
    container: getPopupContainer,
    onVisibleChange: onVisibleChange,
    TransitionComponent: TransitionComponent,
    placement: placement,
    hideArrow: hideArrow,
    popup: menu,
    children: dropdownTrigger,
    arrowStyle: arrowStyle,
    offset: DropdownToken.offset[size],
    open: disabled ? false : open
  });
}