"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useDropdownButton;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _MoreIcon2 = require("@muya-ui/theme-light/lib/icons/MoreIcon");

var _FoldIcon2 = require("@muya-ui/theme-light/lib/icons/FoldIcon");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _Button = _interopRequireDefault(require("../Button"));

var _ExpandIcon = _interopRequireDefault(require("../ExpandIcon"));

var _useTheme = require("../utils/useTheme");

var _useDropdown = _interopRequireDefault(require("./useDropdown"));

var _excluded = ["id", "hideArrow", "group", "type", "children", "disabled", "placement", "overlay", "triggerAction", "triggerActions", "triggerId", "visible", "size", "TransitionComponent", "getPopupContainer", "onOverlayClick", "onVisibleChange", "leaveDelay", "enterDelay", "arrowStyle", "offset", "transitionProps", "outsideCloseable", "escapeKeyCloseable", "onClickAway", "onEscapeKeyDown", "popperNodeRef", "onClick", "dropdownRef"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function useDropdownButton(props, ref) {
  var id = props.id,
      _props$hideArrow = props.hideArrow,
      hideArrow = _props$hideArrow === void 0 ? true : _props$hideArrow,
      _props$group = props.group,
      group = _props$group === void 0 ? false : _props$group,
      _props$type = props.type,
      type = _props$type === void 0 ? 'primary' : _props$type,
      children = props.children,
      disabled = props.disabled,
      placement = props.placement,
      overlay = props.overlay,
      triggerAction = props.triggerAction,
      triggerActions = props.triggerActions,
      triggerId = props.triggerId,
      visible = props.visible,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      TransitionComponent = props.TransitionComponent,
      getPopupContainer = props.getPopupContainer,
      onOverlayClick = props.onOverlayClick,
      onVisibleChange = props.onVisibleChange,
      leaveDelay = props.leaveDelay,
      enterDelay = props.enterDelay,
      arrowStyle = props.arrowStyle,
      offset = props.offset,
      transitionProps = props.transitionProps,
      outsideCloseable = props.outsideCloseable,
      escapeKeyCloseable = props.escapeKeyCloseable,
      onClickAway = props.onClickAway,
      onEscapeKeyDown = props.onEscapeKeyDown,
      popperNodeRef = props.popperNodeRef,
      onClick = props.onClick,
      dropdownRef = props.dropdownRef,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme.useTheme)();
  var _theme$components$Dro = theme.components.Dropdown,
      _theme$components$Dro2 = _theme$components$Dro.expandIcon,
      DefaultExpandIcon = _theme$components$Dro2 === void 0 ? _FoldIcon2.FoldIcon : _theme$components$Dro2,
      _theme$components$Dro3 = _theme$components$Dro.groupExpandIcon,
      GroupExpandIcon = _theme$components$Dro3 === void 0 ? _MoreIcon2.MoreIcon : _theme$components$Dro3;
  var handleDropdownRef = (0, _react.useCallback)(function (refValue) {
    if (typeof dropdownRef === 'function') {
      dropdownRef(refValue);
    } else if (dropdownRef) {
      dropdownRef.current = refValue;
    }
  }, [dropdownRef]);
  var buttonProps = (0, _extends2["default"])({}, other, {
    size: size,
    disabled: disabled
  });
  var realChildren;

  if (group) {
    realChildren = /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
      type: type
    }, buttonProps, {
      groupType: "tail",
      shape: "square"
    }), props.groupIcon || /*#__PURE__*/_react["default"].createElement(GroupExpandIcon, null));
  } else {
    realChildren = /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
      type: type,
      ref: ref,
      onClick: onClick
    }, buttonProps, {
      suffixNode: /*#__PURE__*/_react["default"].createElement(_ExpandIcon["default"], {
        buttonType: type,
        color: "inherit",
        icon: props.expandIcon,
        DefaultIcon: DefaultExpandIcon,
        disabled: disabled
      })
    }), children);
  }

  var dropdownProps = {
    id: id,
    disabled: disabled,
    placement: placement,
    overlay: overlay,
    triggerAction: triggerAction,
    triggerActions: triggerActions,
    triggerId: triggerId,
    TransitionComponent: TransitionComponent,
    getPopupContainer: getPopupContainer,
    onOverlayClick: onOverlayClick,
    onVisibleChange: onVisibleChange,
    size: size,
    hideArrow: hideArrow,
    leaveDelay: leaveDelay,
    enterDelay: enterDelay,
    arrowStyle: arrowStyle,
    offset: offset,
    transitionProps: transitionProps,
    outsideCloseable: outsideCloseable,
    escapeKeyCloseable: escapeKeyCloseable,
    onClickAway: onClickAway,
    onEscapeKeyDown: onEscapeKeyDown,
    popperNodeRef: popperNodeRef,
    children: realChildren
  };

  if (!('placement' in props)) {
    dropdownProps.placement = group ? 'bottom-end' : 'bottom-start';
  }

  if ('visible' in props) {
    dropdownProps.visible = visible;
  }

  var triggerProps = (0, _useDropdown["default"])(dropdownProps, handleDropdownRef);
  return {
    buttonProps: buttonProps,
    triggerProps: triggerProps
  };
}