"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.EllipsisContent = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _isString2 = _interopRequireDefault(require("lodash/isString"));

var _isNumber2 = _interopRequireDefault(require("lodash/isNumber"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireWildcard(require("react"));

var _Tooltip = _interopRequireDefault(require("../Tooltip"));

var _Typography = _interopRequireDefault(require("../Typography"));

var _useEllipsis = _interopRequireDefault(require("../utils/useEllipsis"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _excluded = ["enableTooltip", "enableTitle", "customContent", "placement", "children", "color", "fontSize", "lineHeight", "tooltipProps", "style", "ellipsis"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledContentCopy = _styledComponents["default"].div.withConfig({
  displayName: "StyledContentCopy"
})(["position:absolute;visibility:hidden;height:0;overflow:hidden;"]);

var EllipsisContent = /*#__PURE__*/_react["default"].memo(function (props) {
  var _props$enableTooltip = props.enableTooltip,
      enableTooltip = _props$enableTooltip === void 0 ? true : _props$enableTooltip,
      enableTitle = props.enableTitle,
      customContent = props.customContent,
      _props$placement = props.placement,
      placement = _props$placement === void 0 ? 'top' : _props$placement,
      children = props.children,
      color = props.color,
      fontSize = props.fontSize,
      lineHeight = props.lineHeight,
      tooltipProps = props.tooltipProps,
      style = props.style,
      _props$ellipsis = props.ellipsis,
      ellipsis = _props$ellipsis === void 0 ? true : _props$ellipsis,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var paragraphRef = (0, _react.useRef)(null);
  var contentCopyRef = (0, _react.useRef)(null);
  var multiline = (0, _get2["default"])(ellipsis, 'rows', 1) > 1;
  var isEllipsis = (0, _useEllipsis["default"])(paragraphRef, contentCopyRef, multiline, children);
  var innerStyle = (0, _react.useMemo)(function () {
    var innerStyle = style || {};

    if (!color && !innerStyle.color) {
      innerStyle.color = 'inherit';
    }

    if (!fontSize && !innerStyle.fontSize) {
      innerStyle.fontSize = 'inherit';
    }

    if (!lineHeight && !innerStyle.lineHeight) {
      innerStyle.lineHeight = 'inherit';
    }

    return innerStyle;
  }, [color, fontSize, lineHeight, style]);
  var ellipsisParagraph = (0, _react.useMemo)(function () {
    var content = customContent || children;
    return /*#__PURE__*/_react["default"].createElement(_Typography["default"].Paragraph, (0, _extends2["default"])({
      ref: paragraphRef,
      as: "div",
      ellipsis: ellipsis,
      style: innerStyle,
      color: color,
      fontSize: fontSize,
      title: enableTitle && isEllipsis && ((0, _isString2["default"])(content) || (0, _isNumber2["default"])(content)) ? content : undefined
    }, restProps), children, !multiline && /*#__PURE__*/_react["default"].createElement(StyledContentCopy, {
      ref: contentCopyRef
    }, children));
  }, [children, color, customContent, ellipsis, enableTitle, fontSize, innerStyle, isEllipsis, multiline, restProps]);

  if (enableTooltip && !enableTitle && isEllipsis) {
    return /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], (0, _extends2["default"])({}, tooltipProps, {
      title: customContent || children,
      placement: placement
    }), ellipsisParagraph);
  } else {
    return ellipsisParagraph;
  }
});

exports.EllipsisContent = EllipsisContent;
var _default = EllipsisContent;
exports["default"] = _default;