"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _FormContext = require("./FormContext");

var _FormItem = _interopRequireDefault(require("./FormItem"));

var _useForm = _interopRequireDefault(require("./useForm"));

function Form(props) {
  var children = props.children,
      formBagRef = props.formBagRef,
      _props$independent = props.independent,
      independent = _props$independent === void 0 ? false : _props$independent;
  var innerFormBag = (0, _useForm["default"])(props);
  var formBagFromContext = (0, _FormContext.useFormContext)(); // 如果Form被嵌套在另一个Form里面, 并且没有设置independent，此时使用外层Form的数据

  var isNestedForm = !!formBagFromContext && !independent;
  var formBag = isNestedForm ? formBagFromContext : innerFormBag;
  var finalChildren = typeof children === 'function' ? children(formBag) : children; // 通过Ref将formBag传递出去

  _react["default"].useImperativeHandle(formBagRef, function () {
    return formBag;
  }); // Form嵌套情况，不需要渲染Provider和form标签


  if (isNestedForm) {
    return finalChildren;
  }

  var handleReset = formBag.handleReset,
      handleSubmit = formBag.handleSubmit,
      formProps = formBag.formProps,
      style = formBag.style,
      className = formBag.className,
      _formBag$autoComplete = formBag.autoComplete,
      autoComplete = _formBag$autoComplete === void 0 ? 'off' : _formBag$autoComplete;
  return /*#__PURE__*/_react["default"].createElement(_FormContext.FormProvider, {
    value: formBag
  }, /*#__PURE__*/_react["default"].createElement("form", (0, _extends2["default"])({
    onSubmit: handleSubmit,
    onReset: handleReset,
    style: style,
    className: className,
    autoComplete: autoComplete
  }, formProps), finalChildren));
}

Form.Item = _FormItem["default"];
Form.useForm = _useForm["default"];
Form.Provider = _FormContext.FormProvider;
Form.Consumer = _FormContext.FormConsumer;
Form.useFormContext = _FormContext.useFormContext;
var _default = Form;
exports["default"] = _default;