"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = FormItem;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends3 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _usePrevious2 = require("@muya-ui/utils/lib/hooks/usePrevious");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _CloseIcon2 = require("@muya-ui/theme-light/lib/icons/CloseIcon");

var _SelectIcon2 = require("@muya-ui/theme-light/lib/icons/SelectIcon");

var _isNaN2 = _interopRequireDefault(require("lodash/isNaN"));

var _react = _interopRequireWildcard(require("react"));

var _Animation = _interopRequireDefault(require("../Animation"));

var _Button = _interopRequireDefault(require("../Button"));

var _utils = require("../InputNumber/utils");

var _Space = _interopRequireDefault(require("../Space"));

var _Spin = _interopRequireDefault(require("../Spin"));

var _Typography = _interopRequireDefault(require("../Typography"));

var _addPx = _interopRequireDefault(require("../utils/addPx"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _mergeStyleItem = _interopRequireDefault(require("../utils/mergeStyleItem"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _FormContext = require("./FormContext");

var _styled = require("./styled");

var _utils2 = require("./utils");

var _excluded = ["getValueFromEvent", "hideRequiredTip", "keepRequiredTip", "validateOnBlur", "validateOnChange", "validateFirst", "inline", "hasFeedback", "labelWidth", "size", "labelPosition", "children", "styles", "label", "rule", "name", "currentError", "currentValue", "instantEditing", "inlineSpacing", "pure", "extraTip", "setFieldTouched", "setFieldValue", "normalize", "id", "status", "requiredTipAlignLeft", "registerFieldRules", "unregisterFieldRules", "unregisterFieldProps", "registerFieldProps", "validateField", "setFieldError", "noError", "hideLabel", "disabled", "readOnly"],
    _excluded2 = ["id", "inline", "labelPosition", "labelWidth", "name", "noError", "instantEditing", "inlineSpacing"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function defaultGetValueFromEvent(e) {
  if (!e || !e.target) {
    return e;
  }

  var target = e.target; // @TODO: 1.0 移除

  if (target.type === 'range-input') {
    return e.value;
  }

  return target.type === 'checkbox' || target.type === 'radio' ? target.checked : target.value;
}

function defaultInstantEditingContentRender(value) {
  return String(value);
}

function defaultInstantEditingRender(props) {
  var layout = props.layout,
      inputNode = props.inputNode,
      validating = props.validating,
      isEditing = props.isEditing,
      value = props.value,
      size = props.size,
      actionAlign = props.actionAlign,
      confirm = props.confirm,
      cancel = props.cancel,
      edit = props.edit,
      renderContent = props.renderContent,
      theme = props.theme;
  var align = 'center';

  if (actionAlign === 'top') {
    align = 'flex-start';
  }

  if (actionAlign === 'bottom') {
    align = 'flex-end';
  }

  if (layout === 'vertical') {
    align = 'flex-end';
  }

  var inputWrapperStyle = {
    alignItems: align
  };
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_styled.InstantEditingWrapper, {
    $isEditing: !isEditing
  }, /*#__PURE__*/_react["default"].createElement(_Space["default"], {
    style: inputWrapperStyle,
    direction: layout
  }, inputNode, /*#__PURE__*/_react["default"].createElement(_Space["default"], null, validating ? /*#__PURE__*/_react["default"].createElement(_Spin["default"], null) : isEditing ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    onClick: confirm,
    size: size,
    shape: "square"
  }, /*#__PURE__*/_react["default"].createElement(_SelectIcon2.SelectIcon, null)), /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    onClick: cancel,
    size: size,
    shape: "square"
  }, /*#__PURE__*/_react["default"].createElement(_CloseIcon2.CloseIcon, null))) : null))), /*#__PURE__*/_react["default"].createElement(_styled.InstantEditingWrapper, {
    $isEditing: isEditing,
    onClick: edit
  }, /*#__PURE__*/_react["default"].createElement(_styled.InstantEditingContentWrapper, {
    size: size,
    theme: theme
  }, renderContent(value))));
}

var FormItemMemo = (0, _memoForwardRef["default"])(function FormItemPure(props, ref) {
  var theme = (0, _useTheme["default"])();
  var _theme$components$For = theme.components.Form,
      requiredTip = _theme$components$For.requiredTip,
      defaultLabelWidth = _theme$components$For.defaultLabelWidth;
  var _props$valuePropName = props.valuePropName,
      valuePropName = _props$valuePropName === void 0 ? 'value' : _props$valuePropName,
      _props$trigger = props.trigger,
      trigger = _props$trigger === void 0 ? 'onChange' : _props$trigger;
  var getValueFromEventProp = props.getValueFromEvent,
      _props$hideRequiredTi = props.hideRequiredTip,
      hideRequiredTip = _props$hideRequiredTi === void 0 ? false : _props$hideRequiredTi,
      _props$keepRequiredTi = props.keepRequiredTip,
      keepRequiredTip = _props$keepRequiredTi === void 0 ? false : _props$keepRequiredTi,
      _props$validateOnBlur = props.validateOnBlur,
      validateOnBlur = _props$validateOnBlur === void 0 ? true : _props$validateOnBlur,
      _props$validateOnChan = props.validateOnChange,
      validateOnChange = _props$validateOnChan === void 0 ? true : _props$validateOnChan,
      validateFirst = props.validateFirst,
      _props$inline = props.inline,
      inline = _props$inline === void 0 ? false : _props$inline,
      _props$hasFeedback = props.hasFeedback,
      hasFeedback = _props$hasFeedback === void 0 ? false : _props$hasFeedback,
      _props$labelWidth = props.labelWidth,
      labelWidth = _props$labelWidth === void 0 ? defaultLabelWidth : _props$labelWidth,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      _props$labelPosition = props.labelPosition,
      labelPosition = _props$labelPosition === void 0 ? 'right' : _props$labelPosition,
      children = props.children,
      styles = props.styles,
      label = props.label,
      rule = props.rule,
      name = props.name,
      currentError = props.currentError,
      currentValue = props.currentValue,
      instantEditing = props.instantEditing,
      _props$inlineSpacing = props.inlineSpacing,
      inlineSpacing = _props$inlineSpacing === void 0 ? theme.components.Form.inlineFormItemMarginRight[size] : _props$inlineSpacing,
      pure = props.pure,
      extraTip = props.extraTip,
      setFieldTouched = props.setFieldTouched,
      setFieldValue = props.setFieldValue,
      normalize = props.normalize,
      id = props.id,
      status = props.status,
      requiredTipAlignLeft = props.requiredTipAlignLeft,
      registerFieldRules = props.registerFieldRules,
      unregisterFieldRules = props.unregisterFieldRules,
      unregisterFieldProps = props.unregisterFieldProps,
      registerFieldProps = props.registerFieldProps,
      validateField = props.validateField,
      setFieldError = props.setFieldError,
      noError = props.noError,
      _props$hideLabel = props.hideLabel,
      hideLabel = _props$hideLabel === void 0 ? false : _props$hideLabel,
      disabled = props.disabled,
      readOnly = props.readOnly,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var prevError = (0, _usePrevious2.usePrevious)(currentError);

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      isEditing = _useState2[0],
      setIsEditing = _useState2[1];

  var _useState3 = (0, _react.useState)(currentValue),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      instantEditingValue = _useState4[0],
      setInstantEditingValue = _useState4[1];

  var _useState5 = (0, _react.useState)(false),
      _useState6 = (0, _slicedToArray2["default"])(_useState5, 2),
      instantValidating = _useState6[0],
      setInstantValidating = _useState6[1];

  var instantEditingWrapperRef = (0, _react.useRef)(null);
  var finalError = currentError || prevError;
  var inputRef = (0, _react.useRef)();
  var handleRef = (0, _useForkRef2.useForkRef)(inputRef, children.ref);

  if (children.type && (children.type.__MUYA_CHECKBOX || children.type.__MUYA_SWITCH || children.type.__MUYA_RADIO)) {
    valuePropName = 'checked';
  } else if (children.type && children.type.__MUYA_TRANSFER) {
    valuePropName = 'targetSource';
  } else if (children.type && children.type.__MUYA_RANGEDATETIMEPICKER) {
    trigger = 'onDateChange';
  } // 某些自定义的组件，原生label的点击行为无法与之联动，此处手动调用它的click、focus方法


  var handleLabelClick = (0, _react.useCallback)(function () {
    if (!inputRef.current) return;

    if (typeof inputRef.current.focus === 'function') {
      inputRef.current.focus();
    } // else if (typeof inputRef.current.click === 'function') {
    //   inputRef.current.click();
    // }

  }, []);
  var handleInstantEditingConfirm = (0, _react.useCallback)(function () {
    if (!name) return;
    setInstantValidating(true);
    validateField(name, instantEditingValue).then(function () {
      setFieldValue(name, instantEditingValue, false);
      setIsEditing(false);
      setInstantValidating(false);

      if (instantEditing && instantEditing.onConfirm) {
        instantEditing.onConfirm(name, instantEditingValue);
      }
    })["catch"](function () {
      setInstantValidating(false);
    });
  }, [name, instantEditing, validateField, instantEditingValue, setFieldValue]);
  var handleEdit = (0, _react.useCallback)(function () {
    // 切换编辑态的时候同步下当前值
    setInstantEditingValue(currentValue);
    setIsEditing(true);
  }, [currentValue]);
  var handleInstantEditingCancel = (0, _react.useCallback)(function () {
    if (!name || instantValidating) return;

    if (instantEditing && instantEditing.onCancel) {
      instantEditing.onCancel(name);
    }

    setIsEditing(false);
    setInstantEditingValue(currentValue);
    setFieldError(name);
  }, [currentValue, instantEditing, instantValidating, name, setFieldError]);
  var defaultStyles = (0, _react.useMemo)(function () {
    return {
      error: '',
      errorParagraph: '',
      extra: '',
      extraParagraph: '',
      label: '',
      innerLabel: '',
      inputWrapper: '',
      requiredWrapper: ''
    };
  }, []);
  var getValueFromEvent = (0, _react.useMemo)(function () {
    if (getValueFromEventProp) {
      // 优先使用传入的方法
      return getValueFromEventProp;
    }

    if (children && children.type && children.type.__MUYA_INPUTNUMBER) {
      // InputNumber
      return _utils.getValueFromInputNumberEvent;
    }

    return defaultGetValueFromEvent;
  }, [children, getValueFromEventProp]);
  var innerStyles = (0, _useStyles["default"])('formitem', defaultStyles, styles); // inline模式下 & 外部没有传label，则不渲染label容器
  // 非inline模式下，总是渲染label容器，因为垂直方向需要保持左对齐

  var inlineAndNoLabel = inline && !label; // 结合两个值来判断是否要隐藏label

  var finalHideLabel = inlineAndNoLabel || hideLabel;

  var _ref = children.props || {},
      onChange = _ref.onChange,
      onBlur = _ref.onBlur;

  var handleBlur = (0, _react.useCallback)(function (e) {
    if (name) {
      if (instantEditing) {
        setFieldTouched(name, true, false);

        if (validateOnBlur) {
          validateField(name, instantEditingValue);
        }
      } else {
        setFieldTouched(name, true, validateOnBlur);
      }
    }

    if (onBlur) {
      onBlur(e);
    }
  }, [name, instantEditing, validateOnBlur, instantEditingValue, onBlur, setFieldTouched, validateField]);
  var handleChange = (0, _react.useCallback)(function () {
    var value = getValueFromEvent.apply(void 0, arguments);

    if (normalize) {
      value = normalize(value, currentValue);
    }

    if ((0, _isNaN2["default"])(value)) {
      value = '';
    }

    if (instantEditing) {
      setInstantEditingValue(value);

      if (validateOnChange) {
        validateField(name, value);
      }
    } else if (name) {
      setFieldValue(name, value, validateOnChange);
    }

    if (onChange) {
      onChange.apply(void 0, arguments);
    }
  }, [currentValue, getValueFromEvent, instantEditing, name, normalize, onChange, setFieldValue, validateField, validateOnChange]); // EXTRA设置

  var extraTipNode = (0, _react.useMemo)(function () {
    var extraNode = null;

    if (!currentError) {
      if (typeof extraTip === 'string' || typeof extraTip === 'number') {
        extraNode = /*#__PURE__*/_react["default"].createElement(_Typography["default"].Paragraph, (0, _extends3["default"])({}, innerStyles.extraParagraph, {
          ellipsis: {
            rows: 2
          },
          color: "assistant"
        }), extraTip);
      } else {
        extraNode = extraTip;
      }
    }

    return /*#__PURE__*/_react["default"].createElement(_styled.StyledExtra, innerStyles.extra, /*#__PURE__*/_react["default"].createElement(_Animation["default"].Slide, {
      "in": !currentError
    }, /*#__PURE__*/_react["default"].createElement("div", null, extraNode)));
  }, [currentError, extraTip, innerStyles.extra, innerStyles.extraParagraph]);
  var isRequire = rule ? Array.isArray(rule) ? rule.some(function (r) {
    return r.required;
  }) : rule.required || false : false;
  var requiredTipNode = (0, _react.useMemo)(function () {
    var styleItem = (0, _mergeStyleItem["default"])({
      style: {
        visibility: 'hidden'
      }
    }, innerStyles.requiredWrapper);

    var hiddenTipNode = /*#__PURE__*/_react["default"].createElement(_styled.StyledRequiredWrapper, styleItem, requiredTip);

    var tipNode = /*#__PURE__*/_react["default"].createElement(_styled.StyledRequiredWrapper, innerStyles.requiredWrapper, requiredTip);

    if (!isRequire || hideRequiredTip || !name) {
      // 不需要展示tip的情况
      if (keepRequiredTip) {
        // tip常驻的情况
        return tipNode;
      }

      if (requiredTipAlignLeft) {
        // tip需要左侧对齐，渲染透明且占位的tip
        return hiddenTipNode;
      }

      return null;
    }

    return tipNode;
  }, [hideRequiredTip, innerStyles.requiredWrapper, isRequire, keepRequiredTip, name, requiredTip, requiredTipAlignLeft]);
  var labelWithoutName = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement(_styled.StyledLabel, innerStyles.label, requiredTipNode, label);
  }, [innerStyles.label, label, requiredTipNode]);
  var labelWithName = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement(_styled.StyledLabel, (0, _extends3["default"])({}, innerStyles.label, {
      htmlFor: id,
      onClick: handleLabelClick
    }), /*#__PURE__*/_react["default"].createElement(_styled.StyledInnerLabel, innerStyles.innerLabel, requiredTipNode, label));
  }, [handleLabelClick, id, innerStyles.innerLabel, innerStyles.label, label, requiredTipNode]);
  var memoErrorNode = (0, _react.useMemo)(function () {
    var errorNode = null;

    if (finalError) {
      if (validateFirst && finalError[0]) {
        errorNode = /*#__PURE__*/_react["default"].createElement(_Typography["default"].Paragraph, (0, _extends3["default"])({}, innerStyles.errorParagraph, {
          type: "error"
        }), finalError[0].message);
      } else {
        errorNode = finalError.map(function (e) {
          return /*#__PURE__*/_react["default"].createElement(_Typography["default"].Paragraph, (0, _extends3["default"])({}, innerStyles.errorParagraph, {
            type: "error",
            key: e.message
          }), e.message);
        });
      }
    }

    return /*#__PURE__*/_react["default"].createElement(_styled.StyledError, innerStyles.error, /*#__PURE__*/_react["default"].createElement(_Animation["default"].Slide, {
      "in": !!currentError
    }, /*#__PURE__*/_react["default"].createElement("div", null, errorNode)));
  }, [currentError, finalError, innerStyles.error, innerStyles.errorParagraph, validateFirst]); // eslint-disable-next-line complexity

  var inputChildren = (0, _react.useMemo)(function () {
    var childProps = (0, _extends3["default"])({
      size: size
    }, children.props);

    if (name) {
      var _extends2;

      childProps = (0, _extends3["default"])({
        id: id,
        status: status || currentError ? 'error' : undefined
      }, childProps, (_extends2 = {}, (0, _defineProperty2["default"])(_extends2, trigger, handleChange), (0, _defineProperty2["default"])(_extends2, valuePropName, currentValue), (0, _defineProperty2["default"])(_extends2, "onBlur", handleBlur), _extends2));

      if (disabled) {
        childProps.disabled = true;
      }

      if (readOnly) {
        childProps.readOnly = true;
      }

      if (children.type && (children.type.__MUYA_INPUT || children.type.__MUYA_INPUTNUMBER || children.type.__MUYA_SELECT || children.type.__MUYA_AUTOCOMPLETE || children.type.__MUYA_CASCADER || children.type.__MUYA_TREESELECT || children.type.__MUYA_DATEPICKER || children.type.__MUYA_TIMEPICKER)) {
        childProps.hasFeedback = hasFeedback;
      }

      if (children.type && (children.type.__MUYA_SELECT || children.type.__MUYA_AUTOCOMPLETE || children.type.__MUYA_CASCADER || children.type.__MUYA_TREESELECT)) {
        childProps.inputRef = handleRef;
      } else {
        childProps.ref = handleRef;
      }

      if (pure) {
        return /*#__PURE__*/(0, _react.cloneElement)(children, childProps);
      }

      if (instantEditing) {
        var _instantEditing$rende = instantEditing.renderContent,
            renderContent = _instantEditing$rende === void 0 ? defaultInstantEditingContentRender : _instantEditing$rende,
            _instantEditing$rende2 = instantEditing.render,
            render = _instantEditing$rende2 === void 0 ? defaultInstantEditingRender : _instantEditing$rende2,
            _instantEditing$layou = instantEditing.layout,
            layout = _instantEditing$layou === void 0 ? 'horizontal' : _instantEditing$layou,
            _instantEditing$actio = instantEditing.actionAlign,
            actionAlign = _instantEditing$actio === void 0 ? 'middle' : _instantEditing$actio;
        childProps[valuePropName] = instantEditingValue;
        var inputNode = /*#__PURE__*/(0, _react.cloneElement)(children, childProps);
        return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_styled.StyledInputWrapper, innerStyles.inputWrapper, finalHideLabel ? null : labelWithName, /*#__PURE__*/_react["default"].createElement("div", {
          ref: instantEditingWrapperRef
        }, render({
          inputNode: inputNode,
          validating: instantValidating,
          value: currentValue,
          isEditing: isEditing,
          layout: layout,
          actionAlign: actionAlign,
          size: size,
          renderContent: renderContent,
          cancel: handleInstantEditingCancel,
          confirm: handleInstantEditingConfirm,
          edit: handleEdit,
          theme: theme,
          name: name,
          childProps: childProps
        }))), noError ? null : currentError ? memoErrorNode : extraTipNode);
      }

      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_styled.StyledInputWrapper, innerStyles.inputWrapper, finalHideLabel ? null : labelWithName, /*#__PURE__*/(0, _react.cloneElement)(children, childProps)), noError ? null : currentError ? memoErrorNode : extraTipNode);
    }

    return /*#__PURE__*/_react["default"].createElement(_styled.StyledInputWrapper, innerStyles.inputWrapper, finalHideLabel ? null : labelWithoutName, /*#__PURE__*/(0, _react.isValidElement)(children) ? /*#__PURE__*/(0, _react.cloneElement)(children, childProps) : children);
  }, [name, innerStyles.inputWrapper, finalHideLabel, labelWithoutName, children, size, id, status, currentError, disabled, readOnly, trigger, handleChange, valuePropName, currentValue, handleBlur, pure, instantEditing, labelWithName, noError, memoErrorNode, extraTipNode, hasFeedback, handleRef, instantEditingValue, instantValidating, isEditing, handleInstantEditingCancel, handleInstantEditingConfirm, handleEdit, theme]); // 注册校验规则

  (0, _react.useEffect)(function () {
    if (rule && name) {
      registerFieldRules(name, rule);
      registerFieldProps(name, props);
    }

    return function () {
      if (rule && name) {
        unregisterFieldRules(name);
        unregisterFieldProps(name);
      }
    };
  }, [name, props, registerFieldProps, registerFieldRules, rule, unregisterFieldProps, unregisterFieldRules]);
  (0, _react.useEffect)(function () {
    var handleClickAway = function handleClickAway(e) {
      if (document.documentElement && document.documentElement.contains(e.target) && instantEditingWrapperRef.current && !instantEditingWrapperRef.current.contains(e.target)) {
        handleInstantEditingCancel();
      }
    };

    if (instantEditing && !instantEditing.disableClickAway) {
      document.addEventListener('click', handleClickAway);
    }

    return function () {
      if (instantEditing && !instantEditing.disableClickAway) {
        document.removeEventListener('click', handleClickAway);
      }
    };
  }, [handleInstantEditingCancel, instantEditing]);

  if (pure) {
    return inputChildren;
  }

  return /*#__PURE__*/_react["default"].createElement(_styled.StyledFormItem, (0, _extends3["default"])({
    ref: ref,
    $inline: inline,
    $labelPosition: labelPosition,
    $labelWidth: (0, _addPx["default"])(labelWidth),
    $size: size,
    $theme: theme,
    $inlineAndNoLabel: finalHideLabel,
    $inlineSpacing: inlineSpacing,
    $instantEditing: instantEditing
  }, other), inputChildren);
});

function FormItem(props) {
  var formBag = (0, _FormContext.useFormContext)();
  var idProp = props.id,
      inlineProp = props.inline,
      labelPosition = props.labelPosition,
      labelWidth = props.labelWidth,
      name = props.name,
      noErrorProp = props.noError,
      instantEditingProp = props.instantEditing,
      inlineSpacingProp = props.inlineSpacing,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded2);
  var setFieldTouched = formBag.setFieldTouched,
      setFieldValue = formBag.setFieldValue,
      registerFieldRules = formBag.registerFieldRules,
      unregisterFieldRules = formBag.unregisterFieldRules,
      registerFieldProps = formBag.registerFieldProps,
      unregisterFieldProps = formBag.unregisterFieldProps,
      validateField = formBag.validateField,
      setFieldError = formBag.setFieldError,
      hasFeedback = formBag.hasFeedback,
      size = formBag.size,
      status = formBag.status,
      values = formBag.values,
      errors = formBag.errors,
      outerLabelPosition = formBag.labelPosition,
      hideLabel = formBag.hideLabel,
      pureItem = formBag.pureItem,
      disabled = formBag.disabled,
      readOnly = formBag.readOnly,
      _formBag$requiredTipA = formBag.requiredTipAlignLeft,
      requiredTipAlignLeft = _formBag$requiredTipA === void 0 ? false : _formBag$requiredTipA,
      outerLabelWidth = formBag.labelWidth,
      outerInline = formBag.inline,
      outerInstantEditing = formBag.instantEditing,
      outerInlineSpacing = formBag.inlineSpacing,
      noError = formBag.noError,
      enableNestedErrors = formBag.enableNestedErrors;
  var getInstantEditingConfig = (0, _react.useCallback)(function (instantEditing) {
    if (typeof instantEditing === 'boolean') {
      if (instantEditing) {
        return {};
      }

      return undefined;
    }

    return instantEditing;
  }, []);
  var finalLabelWidth = typeof labelWidth === 'number' ? labelWidth : labelWidth || outerLabelWidth;
  var inlineSpacing = typeof inlineSpacingProp === 'number' ? inlineSpacingProp : outerInlineSpacing;
  var finalLabelPosition = labelPosition || outerLabelPosition;
  var inline = inlineProp || outerInline;
  var id = idProp || name;
  var finalNoError = noErrorProp || noError;
  var currentError = (0, _react.useMemo)(function () {
    if (!name) {
      return;
    }

    if (enableNestedErrors) {
      return (0, _utils2.getIn)(errors, name);
    }

    return errors[name];
  }, [enableNestedErrors, errors, name]);
  var finalInstantEditing = (0, _react.useMemo)(function () {
    var outerInstantEditingConfig = getInstantEditingConfig(outerInstantEditing);
    var instantEditingPropConfig = getInstantEditingConfig(instantEditingProp);

    if (outerInstantEditingConfig || instantEditingPropConfig) {
      return (0, _extends3["default"])({}, outerInstantEditingConfig, instantEditingPropConfig);
    }

    return;
  }, [getInstantEditingConfig, instantEditingProp, outerInstantEditing]);
  var handleRef = (0, _react.useCallback)(function (ref) {
    name && formBag.handleFormItemRef(name, ref);
  }, [formBag, name]);
  return /*#__PURE__*/_react["default"].createElement(FormItemMemo, (0, _extends3["default"])({
    id: id,
    ref: handleRef,
    name: name,
    currentValue: name && (0, _utils2.getIn)(values, name),
    currentError: currentError,
    labelWidth: finalLabelWidth,
    labelPosition: finalLabelPosition,
    inline: inline,
    hideLabel: hideLabel,
    pure: pureItem,
    setFieldTouched: setFieldTouched,
    setFieldValue: setFieldValue,
    registerFieldRules: registerFieldRules,
    unregisterFieldRules: unregisterFieldRules,
    registerFieldProps: registerFieldProps,
    unregisterFieldProps: unregisterFieldProps,
    validateField: validateField,
    setFieldError: setFieldError,
    requiredTipAlignLeft: requiredTipAlignLeft,
    instantEditing: finalInstantEditing,
    size: size,
    hasFeedback: hasFeedback,
    status: status,
    noError: finalNoError,
    inlineSpacing: inlineSpacing,
    disabled: disabled,
    readOnly: readOnly
  }, other));
}