"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledRequiredWrapper = exports.StyledLabel = exports.StyledInputWrapper = exports.StyledInnerLabel = exports.StyledFormItem = exports.StyledExtra = exports.StyledError = exports.InstantEditingWrapper = exports.InstantEditingContentWrapper = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledLabel = _styledComponents["default"].label.withConfig({
  displayName: "StyledLabel"
})([""]);

exports.StyledLabel = StyledLabel;

var StyledInnerLabel = _styledComponents["default"].span.withConfig({
  displayName: "StyledInnerLabel"
})([""]);

exports.StyledInnerLabel = StyledInnerLabel;

var StyledInputWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledInputWrapper"
})([""]);

exports.StyledInputWrapper = StyledInputWrapper;

var StyledRequiredWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledRequiredWrapper"
})([""]);

exports.StyledRequiredWrapper = StyledRequiredWrapper;

var StyledError = _styledComponents["default"].div.withConfig({
  displayName: "StyledError"
})([""]);

exports.StyledError = StyledError;

var StyledExtra = _styledComponents["default"].div.withConfig({
  displayName: "StyledExtra"
})([""]);

exports.StyledExtra = StyledExtra;

var InstantEditingWrapper = _styledComponents["default"].div.withConfig({
  displayName: "InstantEditingWrapper"
})(["", ""], function (props) {
  if (props.$isEditing) {
    return (0, _styledComponents.css)(["&,& *{visibility:hidden;opacity:0;height:0;margin:0;}"]);
  }
});

exports.InstantEditingWrapper = InstantEditingWrapper;

var InstantEditingContentWrapper = _styledComponents["default"].div.withConfig({
  displayName: "InstantEditingContentWrapper"
})(["", ""], function (props) {
  var theme = props.theme,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size;
  var inputToken = theme.components.Input;
  return (0, _styledComponents.css)(["display:flex;align-items:center;box-sizing:border-box;height:", " color:", ";height:", "px;font-size:", "px;line-height:", "px;border:1px solid transparent;padding:0 ", "px;&:hover{border-color:", ";}"], size, inputToken.color, inputToken.inputHeight[size], theme.typography.spec.fontSize[inputToken.fontLevel[size]], theme.typography.spec.lineHeight[inputToken.fontLevel[size]], inputToken.inputPadding[size], inputToken.borderColor.normal);
});

exports.InstantEditingContentWrapper = InstantEditingContentWrapper;

var StyledFormItem = _styledComponents["default"].div.withConfig({
  displayName: "StyledFormItem"
})(["", ""], function (props) {
  var $inline = props.$inline,
      $labelWidth = props.$labelWidth,
      $labelPosition = props.$labelPosition,
      $size = props.$size,
      $theme = props.$theme,
      $inlineAndNoLabel = props.$inlineAndNoLabel,
      $inlineSpacing = props.$inlineSpacing,
      $instantEditing = props.$instantEditing;
  var _$theme$components$Fo = $theme.components.Form,
      labelPaddingRight = _$theme$components$Fo.labelPaddingRight,
      labelHeight = _$theme$components$Fo.labelHeight,
      topLabelPaddingBottom = _$theme$components$Fo.topLabelPaddingBottom,
      requiredTipMarginRight = _$theme$components$Fo.requiredTipMarginRight,
      requiredFontLevel = _$theme$components$Fo.requiredFontLevel,
      labelFontSizeLevel = _$theme$components$Fo.labelFontSizeLevel,
      errorMinHeight = _$theme$components$Fo.errorMinHeight,
      errorPaddingBottom = _$theme$components$Fo.errorPaddingBottom,
      errorPaddingTop = _$theme$components$Fo.errorPaddingTop,
      labelColor = _$theme$components$Fo.labelColor,
      instantEditingLabelColor = _$theme$components$Fo.instantEditingLabelColor; // inline模式 & 没有传label，label容器是不渲染的，error也就不需要margin-left了

  var errorMarginStyle = (0, _styledComponents.css)(["margin-left:", ";"], $inlineAndNoLabel ? 0 : $labelWidth); // label在上时要特殊处理

  var labelStyle = $labelPosition === 'top' ? (0, _styledComponents.css)(["& > ", "{flex-flow:column nowrap;& > ", "{text-align:left;padding-bottom:", "px;}}"], StyledInputWrapper, StyledLabel, topLabelPaddingBottom[$size]) : (0, _styledComponents.css)(["& > ", ",& > ", "{", "}& > ", "{align-items:center;& > ", "{display:flex;align-items:center;align-self:flex-start;width:", ";min-height:", "px;justify-content:", ";padding-right:", "px;}}"], StyledError, StyledExtra, errorMarginStyle, StyledInputWrapper, StyledLabel, $labelWidth, labelHeight[$size], $labelPosition === 'right' ? 'flex-end' : 'flex-start', labelPaddingRight[$size]);
  return (0, _styledComponents.css)(["vertical-align:top;", " ", "{display:inline-block;position:relative;box-sizing:border-box;flex-shrink:0;font-size:", "px;line-height:", "px;color:", ";}", "{margin-right:", "px;color:", ";font-size:", "px;line-height:1;padding-top:2px;}", ",", "{box-sizing:border-box;padding-top:", "px;padding-bottom:", "px;min-height:", "px;}", "{display:inline-flex;position:relative;align-items:flex-start;}", "{display:flex;}", ""], $inline && (0, _styledComponents.css)(["display:inline-block;margin-right:", "px;&:last-of-type{margin-right:0;}"], $inlineSpacing), StyledLabel, $theme.typography.spec.fontSize[labelFontSizeLevel[$size]], $theme.typography.spec.lineHeight[labelFontSizeLevel[$size]], $instantEditing ? instantEditingLabelColor : labelColor, StyledRequiredWrapper, requiredTipMarginRight, $theme.colors.spec.danger, $theme.typography.spec.fontSize[requiredFontLevel], StyledError, StyledExtra, errorPaddingTop, errorPaddingBottom, errorMinHeight[$size], StyledInnerLabel, StyledInputWrapper, labelStyle);
});

exports.StyledFormItem = StyledFormItem;