"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _RowContext = require("./RowContext");

var _styled = require("./styled");

var _utils = require("./utils");

var _excluded = ["children", "span", "order", "offset", "push", "pull", "styles", "className", "style"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Col = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var children = props.children,
      span = props.span,
      order = props.order,
      offset = props.offset,
      push = props.push,
      pull = props.pull,
      styles = props.styles,
      className = props.className,
      style = props.style,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var innerStyles = (0, _useStyles["default"])('col', {
    wrapper: ''
  }, styles);

  var _useRow = (0, _RowContext.useRow)(),
      gutter = _useRow.gutter,
      breakpoint = _useRow.breakpoint,
      equalNum = _useRow.equalNum;

  var sizeProps = (0, _react.useMemo)(function () {
    return {
      span: (0, _utils.getResponsiveProp)((0, _utils.getBreakpointProp)(props, 'span'), breakpoint),
      order: (0, _utils.getResponsiveProp)((0, _utils.getBreakpointProp)(props, 'order'), breakpoint),
      pull: (0, _utils.getResponsiveProp)((0, _utils.getBreakpointProp)(props, 'pull'), breakpoint),
      push: (0, _utils.getResponsiveProp)((0, _utils.getBreakpointProp)(props, 'push'), breakpoint),
      offset: (0, _utils.getResponsiveProp)((0, _utils.getBreakpointProp)(props, 'offset'), breakpoint)
    };
  }, [breakpoint, props]);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledCol, (0, _extends2["default"])({}, restProps, {
    className: [innerStyles.wrapper.className, className].join(' ').trim(),
    style: (0, _extends2["default"])({}, innerStyles.wrapper.style, style),
    ref: ref,
    $gutter: gutter,
    $equalNum: equalNum,
    $span: sizeProps.span,
    $order: sizeProps.order,
    $offset: sizeProps.offset,
    $push: sizeProps.push,
    $pull: sizeProps.pull
  }), children);
});

var _default = Col;
exports["default"] = _default;