"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _useMedia2 = require("@muya-ui/utils/lib/hooks/useMedia");

var _utils = require("@muya-ui/theme-light/lib/utils");

var _react = _interopRequireWildcard(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _RowContext = _interopRequireWildcard(require("./RowContext"));

var _styled = require("./styled");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var defaultStyles = {
  wrapper: ''
};
var Row = (0, _memoForwardRef["default"])(function (props, ref) {
  var children = props.children,
      _props$align = props.align,
      align = _props$align === void 0 ? 'top' : _props$align,
      _props$justify = props.justify,
      justify = _props$justify === void 0 ? 'start' : _props$justify,
      _props$gutter = props.gutter,
      gutterProp = _props$gutter === void 0 ? 0 : _props$gutter,
      equalNumProp = props.equalNum,
      styles = props.styles,
      className = props.className,
      style = props.style;
  var innerStyles = (0, _useStyles["default"])('row', defaultStyles, styles);
  var theme = (0, _useTheme["default"])();
  var breakpointsMap = theme.breakpoints.spec.breakpointsMap;
  var responsiveMap = (0, _react.useMemo)(function () {
    return _utils.breakpointKeys.map(function (key) {
      return _utils.breakpointsUtils.only({
        breakpointsMap: breakpointsMap
      }, key).replace('@media ', '');
    });
  }, [breakpointsMap]);
  var breakpoint = (0, _useMedia2.useMedia)(responsiveMap, _utils.breakpointKeys, _RowContext.defaultBreakpoint);
  var gutter = (0, _react.useMemo)(function () {
    if (gutterProp && (0, _typeof2["default"])(gutterProp) === 'object') {
      var flag = false;
      var latestNum;

      var _iterator = _createForOfIteratorHelper((0, _toConsumableArray2["default"])(_utils.breakpointKeys).reverse()),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var point = _step.value;

          if (breakpoint === point) {
            flag = true;
          }

          if (gutterProp[point]) {
            latestNum = gutterProp[point];
          }

          if (flag && gutterProp[point]) {
            return gutterProp[point];
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      return latestNum;
    }

    return gutterProp;
  }, [breakpoint, gutterProp]);
  var equalNum = (0, _react.useMemo)(function () {
    if (equalNumProp && (0, _typeof2["default"])(equalNumProp) === 'object') {
      var flag = false;
      var latestNum;

      var _iterator2 = _createForOfIteratorHelper((0, _toConsumableArray2["default"])(_utils.breakpointKeys).reverse()),
          _step2;

      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var point = _step2.value;

          if (breakpoint === point) {
            flag = true;
          }

          if (equalNumProp[point]) {
            latestNum = equalNumProp[point];
          }

          if (flag && equalNumProp[point]) {
            return equalNumProp[point];
          }
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }

      return latestNum;
    }

    return equalNumProp;
  }, [breakpoint, equalNumProp]);
  return /*#__PURE__*/_react["default"].createElement(_RowContext["default"].Provider, {
    value: {
      gutter: gutter,
      breakpoint: breakpoint,
      equalNum: equalNum
    }
  }, /*#__PURE__*/_react["default"].createElement(_styled.StyledRow, (0, _extends2["default"])({}, props, {
    className: [innerStyles.wrapper.className, className].join(' ').trim(),
    style: (0, _extends2["default"])({}, innerStyles.wrapper.style, style),
    ref: ref,
    theme: theme,
    $align: align,
    $justify: justify,
    $gutter: gutter
  }), children));
});
var _default = Row;
exports["default"] = _default;