"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledRow = exports.StyledCol = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var alignMap = {
  top: 'flex-start',
  middle: 'center',
  bottom: 'flex-end'
};
var justifyMap = {
  start: 'flex-start',
  end: 'flex-end',
  center: 'center',
  'space-around': 'space-around',
  'space-between': 'space-between'
};

var StyledRow = _styledComponents["default"].div.withConfig({
  displayName: "StyledRow"
})(["display:flex;flex-flow:row wrap;box-sizing:border-box;", " ", " ", " &::before,&::after{display:flex;}"], function (props) {
  return props.$align && "align-items: ".concat(alignMap[props.$align], ";");
}, function (props) {
  return props.$justify && "justify-content: ".concat(justifyMap[props.$justify], ";");
}, function (props) {
  return props.$gutter && "margin-left: ".concat(props.$gutter / -2, "px; margin-right: ").concat(props.$gutter / -2, "px;");
});

exports.StyledRow = StyledRow;

var StyledCol = _styledComponents["default"].div.withConfig({
  displayName: "StyledCol"
})(["position:relative;flex:0 0 auto;box-sizing:border-box;min-height:1px;", ""], function (props) {
  var $equalNum = props.$equalNum,
      $gutter = props.$gutter,
      $order = props.$order,
      $span = props.$span,
      $offset = props.$offset,
      $pull = props.$pull,
      $push = props.$push;
  var commonStyle = (0, _styledComponents.css)(["", "};", ";"], $gutter && "padding-left: ".concat($gutter / 2, "px; padding-right: ").concat($gutter / 2, "px;"), $order && "order: ".concat(props.$order, ";"));

  if ($equalNum) {
    return (0, _styledComponents.css)(["width:", ";", ";"], "".concat(1 / $equalNum * 100, "%"), commonStyle);
  } else {
    return (0, _styledComponents.css)(["", " ", " ", ";", ";", ";"], $span && "width: ".concat($span / 24 * 100, "%;"), $offset && "margin-left: ".concat($offset / 24 * 100, "%;"), $push && "left: ".concat($push / 24 * 100, "%;"), $pull && "right: ".concat($pull / 24 * 100, "%;"), commonStyle);
  }
});

exports.StyledCol = StyledCol;