"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _CloseIcon2 = require("@muya-ui/theme-light/lib/icons/CloseIcon");

var _InformIcon2 = require("@muya-ui/theme-light/lib/icons/InformIcon");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _Typography = _interopRequireDefault(require("../Typography"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _excluded = ["showIcon", "customIcon", "title", "description", "actions", "showClose", "onClose", "placement"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var GuidePopoverCard = (0, _memoForwardRef["default"])(function (props, ref) {
  var _props$showIcon = props.showIcon,
      showIcon = _props$showIcon === void 0 ? true : _props$showIcon,
      customIcon = props.customIcon,
      title = props.title,
      description = props.description,
      actions = props.actions,
      showClose = props.showClose,
      onClose = props.onClose,
      _props$placement = props.placement,
      placement = _props$placement === void 0 ? 'right' : _props$placement,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var token = theme.components.Guide;
  var FinalInformIcon = token.informIcon.Icon || _InformIcon2.InformIcon;
  var FinalCloseIcon = token.closeIcon.Icon || _CloseIcon2.CloseIcon;
  var arrowStyle = (0, _react.useMemo)(function () {
    return {
      color: token.popoverCard.bgColor
    };
  }, [token.popoverCard.bgColor]);
  var titleStyle = (0, _react.useMemo)(function () {
    return {
      color: token.popoverCard.titleColor
    };
  }, [token.popoverCard.titleColor]);
  var content = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, showIcon && /*#__PURE__*/_react["default"].createElement(_styled.StyledPopoverCardIcon, null, customIcon || /*#__PURE__*/_react["default"].createElement(FinalInformIcon, null)), /*#__PURE__*/_react["default"].createElement(_Typography["default"].Title, {
      level: token.popoverCard.titleLevel,
      style: titleStyle
    }, title), description && /*#__PURE__*/_react["default"].createElement(_styled.StyledDesc, null, description), actions && /*#__PURE__*/_react["default"].createElement(_styled.StyledActions, null, actions), showClose && /*#__PURE__*/_react["default"].createElement(_styled.StyledPopoverCardCloseIcon, {
      onClick: onClose
    }, /*#__PURE__*/_react["default"].createElement(FinalCloseIcon, null)));
  }, [actions, customIcon, description, onClose, showClose, showIcon, title, titleStyle, token.popoverCard.titleLevel]);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledGuidePopoverCard, (0, _extends2["default"])({
    ref: ref,
    theme: theme,
    content: content,
    arrowStyle: arrowStyle,
    placement: placement,
    $showIcon: showIcon,
    $showClose: !!showClose,
    $hasDesc: !!description,
    zIndex: token.popoverCard.zIndex
  }, restProps));
});
var _default = GuidePopoverCard;
exports["default"] = _default;