"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _CloseIcon2 = require("@muya-ui/theme-light/lib/icons/CloseIcon");

var _InformIcon2 = require("@muya-ui/theme-light/lib/icons/InformIcon");

var _useLockScroll2 = require("@muya-ui/utils/lib/hooks/useLockScroll");

var _react = _interopRequireWildcard(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _utils = require("./utils");

var _Typography = require("../Typography");

var _Button = require("../Button");

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _useLocale = _interopRequireDefault(require("../Locale/useLocale"));

var _useSvgMask2 = _interopRequireDefault(require("./useSvgMask"));

var _Trigger = _interopRequireDefault(require("../Trigger"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  content: '',
  text: '',
  next: '',
  close: '',
  skip: '',
  inform: '',
  title: '',
  subTitle: ''
};

var _default = (0, _memoForwardRef["default"])(function (props, ref) {
  var local = (0, _useLocale["default"])();
  var theme = (0, _useTheme["default"])();
  var _props$rounded = props.rounded,
      rounded = _props$rounded === void 0 ? 0 : _props$rounded,
      styles = props.styles,
      _props$showClose = props.showClose,
      showClose = _props$showClose === void 0 ? true : _props$showClose,
      _props$showSkip = props.showSkip,
      showSkip = _props$showSkip === void 0 ? true : _props$showSkip,
      currentIndex = props.currentIndex,
      nextStep = props.nextStep,
      _props$skipText = props.skipText,
      skipText = _props$skipText === void 0 ? local['Guide.skip'] : _props$skipText,
      _props$confirmText = props.confirmText,
      confirmText = _props$confirmText === void 0 ? local['Guide.confirm'] : _props$confirmText,
      _props$steps = props.steps,
      steps = _props$steps === void 0 ? [] : _props$steps,
      nextText = props.nextText,
      _props$offset = props.offset,
      offset = _props$offset === void 0 ? 10 : _props$offset,
      _props$maskClassName = props.maskClassName,
      maskClassName = _props$maskClassName === void 0 ? "".concat(theme.prefix, "-guide-mask") : _props$maskClassName,
      _props$disableInterac = props.disableInteraction,
      disableInteraction = _props$disableInterac === void 0 ? true : _props$disableInterac,
      _props$dashed = props.dashed,
      dashed = _props$dashed === void 0 ? false : _props$dashed,
      arrowStyle = props.arrowStyle,
      close = props.close,
      guidePopperProps = props.popperProps;
  var innerStyles = (0, _useStyles["default"])('guide', defaultStyles, styles);

  var _useSvgMask = (0, _useSvgMask2["default"])(props),
      left = _useSvgMask.left,
      height = _useSvgMask.height,
      width = _useSvgMask.width,
      hasCustomContent = _useSvgMask.hasCustomContent,
      stepContent = _useSvgMask.stepContent,
      state = _useSvgMask.state,
      disabled = _useSvgMask.disabled,
      handleMaskClick = _useSvgMask.handleMaskClick,
      top = _useSvgMask.top,
      innerWidth = _useSvgMask.innerWidth,
      innerHeight = _useSvgMask.innerHeight;

  (0, _useLockScroll2.useLockScroll)(true);
  var dashedPadding = 8;
  var currentOffset = dashed ? offset + dashedPadding : offset;
  var _steps$currentIndex = steps[currentIndex],
      _steps$currentIndex$s = _steps$currentIndex.showNextButton,
      showNextButton = _steps$currentIndex$s === void 0 ? true : _steps$currentIndex$s,
      customTextWrapper = _steps$currentIndex.customTextWrapper,
      _steps$currentIndex$p = _steps$currentIndex.position,
      position = _steps$currentIndex$p === void 0 ? 'bottom' : _steps$currentIndex$p,
      subTitle = _steps$currentIndex.subTitle,
      popperProps = _steps$currentIndex.popperProps;
  var token = theme.components.Guide;
  var Inform = token.informIcon.Icon || _InformIcon2.InformIcon;
  var Close = token.closeIcon.Icon || _CloseIcon2.CloseIcon;
  var buttonTitle = currentIndex === steps.length - 1 ? confirmText : nextText || "".concat(local['Guide.nextStep'], "(").concat(currentIndex + 1, "/").concat(steps.length, ")");
  var currentPopperProps = popperProps || guidePopperProps || {};
  var finalArrowStyle = (0, _react.useMemo)(function () {
    return (0, _extends2["default"])({
      color: theme.colors.pattern.background.higher
    }, arrowStyle);
  }, [arrowStyle, theme.colors.pattern.background.higher]);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, state.length ? /*#__PURE__*/_react["default"].createElement(_styled.SvgMaskWrapper, {
    onClick: handleMaskClick,
    theme: theme
  }, /*#__PURE__*/_react["default"].createElement("svg", {
    width: innerWidth,
    height: innerHeight,
    xmlns: "http://www.w3.org/2000/svg",
    className: maskClassName
  }, /*#__PURE__*/_react["default"].createElement("defs", null, /*#__PURE__*/_react["default"].createElement("mask", {
    id: "mask-main"
  }, /*#__PURE__*/_react["default"].createElement("rect", {
    x: 0,
    y: 0,
    width: innerWidth,
    height: innerHeight,
    fill: "white"
  }), /*#__PURE__*/_react["default"].createElement("rect", {
    x: left,
    y: top,
    width: width,
    height: height,
    fill: "black"
  }), /*#__PURE__*/_react["default"].createElement("rect", {
    x: left - 1,
    y: top - 1,
    width: rounded,
    height: rounded,
    fill: "white"
  }), /*#__PURE__*/_react["default"].createElement("circle", {
    cx: left + rounded,
    cy: top + rounded,
    r: rounded,
    fill: "black"
  }), /*#__PURE__*/_react["default"].createElement("rect", {
    x: left + width - rounded + 1,
    y: top - 1,
    width: rounded,
    height: rounded,
    fill: "white"
  }), /*#__PURE__*/_react["default"].createElement("circle", {
    cx: left + width - rounded,
    cy: top + rounded,
    r: rounded,
    fill: "black"
  }), /*#__PURE__*/_react["default"].createElement("rect", {
    x: left - 1,
    y: top + height - rounded + 1,
    width: rounded,
    height: rounded,
    fill: "white"
  }), /*#__PURE__*/_react["default"].createElement("circle", {
    cx: left + rounded,
    cy: top + height - rounded,
    r: rounded,
    fill: "black"
  }), /*#__PURE__*/_react["default"].createElement("rect", {
    x: left + width - rounded + 1,
    y: top + height - rounded + 1,
    width: rounded,
    height: rounded,
    fill: "white"
  }), /*#__PURE__*/_react["default"].createElement("circle", {
    cx: left + width - rounded,
    cy: top + height - rounded,
    r: rounded,
    fill: "black "
  })), /*#__PURE__*/_react["default"].createElement("clipPath", {
    id: "clip-path"
  }, /*#__PURE__*/_react["default"].createElement("rect", {
    x: 0,
    y: 0,
    width: innerWidth,
    height: top
  }), /*#__PURE__*/_react["default"].createElement("rect", {
    x: 0,
    y: top,
    width: left,
    height: height
  }), /*#__PURE__*/_react["default"].createElement("rect", {
    x: left + width,
    y: top,
    width: (0, _utils.safe)(innerWidth - width - left),
    height: height
  }), /*#__PURE__*/_react["default"].createElement("rect", {
    x: 0,
    y: top + height,
    width: innerWidth,
    height: (0, _utils.safe)(innerWidth - height - top)
  }))), /*#__PURE__*/_react["default"].createElement("rect", {
    x: 0,
    y: 0,
    width: innerWidth,
    height: innerHeight,
    fill: "currentColor",
    mask: "url(#mask-main)",
    pointerEvents: "auto"
  }), /*#__PURE__*/_react["default"].createElement(_Trigger["default"], {
    open: true,
    placement: position,
    offset: currentOffset,
    arrowStyle: finalArrowStyle,
    popperProps: currentPopperProps,
    popup: /*#__PURE__*/_react["default"].createElement(_styled.ToolTipsContent, (0, _extends2["default"])({
      theme: theme
    }, innerStyles.content, {
      $hasCustomContent: hasCustomContent,
      ref: ref
    }), hasCustomContent ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, stepContent) : /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, customTextWrapper ? customTextWrapper : /*#__PURE__*/_react["default"].createElement(_styled.TextWrapper, innerStyles.text, /*#__PURE__*/_react["default"].createElement(_styled.StyledIcon, (0, _extends2["default"])({
      theme: theme
    }, innerStyles.inform), /*#__PURE__*/_react["default"].createElement(Inform, null)), /*#__PURE__*/_react["default"].createElement(_styled.TitleWrapper, null, /*#__PURE__*/_react["default"].createElement(_Typography.Typography.Title, (0, _extends2["default"])({
      level: token.titleLevel
    }, innerStyles.title), stepContent), subTitle ? /*#__PURE__*/_react["default"].createElement(_Typography.Typography.Paragraph, (0, _extends2["default"])({
      color: "assistant",
      marginTop: token.subTitleMarginTop
    }, innerStyles.subTitle), subTitle) : null)), showNextButton ? /*#__PURE__*/_react["default"].createElement(_styled.ButtonWrapper, (0, _extends2["default"])({
      theme: theme
    }, innerStyles.next), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
      onClick: function onClick(_) {
        return nextStep();
      },
      type: "primary",
      disabled: disabled
    }, buttonTitle)) : null, showClose ? /*#__PURE__*/_react["default"].createElement(_styled.CloseIconWrapper, (0, _extends2["default"])({
      type: "weak",
      theme: theme,
      onClick: close
    }, innerStyles.close), /*#__PURE__*/_react["default"].createElement(Close, {
      fontSize: token.closeIcon.fontSize
    })) : null, showSkip ? /*#__PURE__*/_react["default"].createElement(_styled.SkipWrapper, (0, _extends2["default"])({
      theme: theme,
      onClick: close
    }, innerStyles.skip), /*#__PURE__*/_react["default"].createElement(_Typography.Typography.Text, {
      color: "disabled"
    }, skipText)) : null))
  }, /*#__PURE__*/_react["default"].createElement("rect", {
    x: left,
    y: top,
    width: width,
    height: height,
    pointerEvents: "auto",
    fill: "transparent",
    display: "block",
    visibility: !disableInteraction ? 'hidden' : 'none'
  })), dashed ? /*#__PURE__*/_react["default"].createElement("rect", {
    x: left - dashedPadding,
    y: top - dashedPadding,
    width: width + dashedPadding * 2,
    height: height + dashedPadding * 2,
    pointerEvents: "auto",
    stroke: "white",
    strokeDasharray: "4 4",
    fill: "transparent",
    display: "block",
    visibility: "none"
  }) : null)) : null);
});

exports["default"] = _default;