"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ToolTipsContent = exports.TitleWrapper = exports.TextWrapper = exports.SvgMaskWrapper = exports.StyledPopoverCardIcon = exports.StyledPopoverCardCloseIcon = exports.StyledIcon = exports.StyledGuidePopoverCard = exports.StyledDesc = exports.StyledActions = exports.SkipWrapper = exports.CloseIconWrapper = exports.ButtonWrapper = void 0;

var _utils = require("@muya-ui/theme-light/lib/utils");

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _PopoverCard = _interopRequireDefault(require("../PopoverCard"));

var _Typography = _interopRequireDefault(require("../Typography"));

var _Title = require("../Typography/Title");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var CloseIconWrapper = (0, _styledComponents["default"])(_IconButton["default"]).withConfig({
  displayName: "CloseIconWrapper"
})(["", ""], function (props) {
  var _props$theme$componen = props.theme.components.Guide.closeIcon,
      top = _props$theme$componen.top,
      right = _props$theme$componen.right;
  return (0, _styledComponents.css)(["position:absolute;right:", "px;top:", "px;"], right, top);
});
exports.CloseIconWrapper = CloseIconWrapper;

var ToolTipsContent = _styledComponents["default"].div.withConfig({
  displayName: "ToolTipsContent"
})(["box-sizing:border-box;", ""], function (props) {
  var _props$theme = props.theme,
      colors = _props$theme.colors,
      shadows = _props$theme.shadows,
      components = _props$theme.components;
  var token = components.PopoverCard.card;
  var _components$Guide$too = components.Guide.toolTips,
      padding = _components$Guide$too.padding,
      minWidth = _components$Guide$too.minWidth;
  var currentPadding = props.$hasCustomContent ? 0 : padding;
  return (0, _styledComponents.css)(["background:", ";box-shadow:", ";border-radius:", ";padding:", ";min-width:", "px;", "{margin-bottom:0;}"], colors.pattern.background.higher, shadows.pattern.popper.normal, token.borderRadius, currentPadding, minWidth, _Title.StyledTitle);
});

exports.ToolTipsContent = ToolTipsContent;

var ButtonWrapper = _styledComponents["default"].div.withConfig({
  displayName: "ButtonWrapper"
})(["", ""], function (props) {
  return (0, _styledComponents.css)(["margin-top:", "px;display:flex;flex-direction:row-reverse;"], props.theme.components.Guide.nextButton.marginTop);
});

exports.ButtonWrapper = ButtonWrapper;

var SvgMaskWrapper = _styledComponents["default"].div.withConfig({
  displayName: "SvgMaskWrapper"
})(["", ""], function (props) {
  var _props$theme$componen2 = props.theme.components.Guide.mask,
      opacity = _props$theme$componen2.opacity,
      color = _props$theme$componen2.color;
  return (0, _styledComponents.css)(["opacity:", ";width:100%;left:0;top:0;height:100%;position:fixed;z-index:", ";pointer-events:none;color:", ";"], opacity, props.theme.zIndex.pattern.dialog, color);
});

exports.SvgMaskWrapper = SvgMaskWrapper;

var SkipWrapper = _styledComponents["default"].div.withConfig({
  displayName: "SkipWrapper"
})(["", ""], function (props) {
  return (0, _styledComponents.css)(["position:absolute;left:0;right:0;bottom:", "px;margin:0 auto;text-align:center;&:hover{cursor:pointer;}"], props.theme.components.Guide.skip.bottom);
});

exports.SkipWrapper = SkipWrapper;

var TextWrapper = _styledComponents["default"].div.withConfig({
  displayName: "TextWrapper"
})(["display:flex;align-items:baseline;"]);

exports.TextWrapper = TextWrapper;

var StyledIcon = _styledComponents["default"].span.withConfig({
  displayName: "StyledIcon"
})(["", ""], function (props) {
  var _props$theme$componen3 = props.theme.components.Guide.informIcon,
      marginRight = _props$theme$componen3.marginRight,
      color = _props$theme$componen3.color,
      fontSize = _props$theme$componen3.fontSize;
  return (0, _styledComponents.css)(["margin-right:", "px;color:", ";font-size:", "px;line-height:0;"], marginRight, color, fontSize);
});

exports.StyledIcon = StyledIcon;

var TitleWrapper = _styledComponents["default"].div.withConfig({
  displayName: "TitleWrapper"
})([""]);

exports.TitleWrapper = TitleWrapper;

var StyledPopoverCardIcon = _styledComponents["default"].span.withConfig({
  displayName: "StyledPopoverCardIcon"
})([""]);

exports.StyledPopoverCardIcon = StyledPopoverCardIcon;

var StyledPopoverCardCloseIcon = _styledComponents["default"].span.withConfig({
  displayName: "StyledPopoverCardCloseIcon"
})([""]);

exports.StyledPopoverCardCloseIcon = StyledPopoverCardCloseIcon;
var StyledDesc = (0, _styledComponents["default"])(_Typography["default"].Paragraph).withConfig({
  displayName: "StyledDesc"
})([""]);
exports.StyledDesc = StyledDesc;

var StyledActions = _styledComponents["default"].div.withConfig({
  displayName: "StyledActions"
})([""]);

exports.StyledActions = StyledActions;
var StyledGuidePopoverCard = (0, _styledComponents["default"])(_PopoverCard["default"]).withConfig({
  displayName: "StyledGuidePopoverCard"
})(["", ""], function (props) {
  var $showIcon = props.$showIcon,
      $showClose = props.$showClose,
      $hasDesc = props.$hasDesc,
      theme = props.theme;
  var token = theme.components.Guide.popoverCard;
  return (0, _styledComponents.css)(["position:relative;background:", ";padding:", ";", ";", ";", "{position:absolute;left:", "px;top:", "px;color:", ";font-size:", "px;line-height:0;}", "{color:", ";font-size:", "px;line-height:", "px;margin-top:", "px;}", "{position:absolute;color:", ";font-size:", "px;line-height:0;top:", "px;right:", "px;cursor:pointer;}", "{display:flex;justify-content:flex-end;margin-top:", "px;}"], token.bgColor, $hasDesc ? token.hasDescPadding : token.padding, $showIcon && "padding-left: ".concat(token.hasIconPaddingLeft, "px"), $showClose && "padding-right: ".concat(token.hasCloseIconPaddingRight, "px"), StyledPopoverCardIcon, token.iconLeft, $hasDesc ? token.iconHasDescTop : token.iconTop, token.iconColor.inverse, token.iconFontSize, StyledDesc, _utils.colorUtils.transparentize(token.descOpacity, token.descColor), token.descFontSize, token.descLineHeight, token.descMarginTop, StyledPopoverCardCloseIcon, _utils.colorUtils.transparentize(token.closeIconOpacity, token.closeIconColor), token.closeIconFontSize, $hasDesc ? token.closeIconhasDescTop : token.closeIconTop, $hasDesc ? token.closeIconhasDescRight : token.closeIconRight, StyledActions, token.actionsMarginTop);
});
exports.StyledGuidePopoverCard = StyledGuidePopoverCard;