"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getCalculationsData = void 0;
exports.getNodeRect = getNodeRect;
exports.getWindow = getWindow;
exports.inView = inView;
exports.isBody = isBody;
exports.safe = void 0;

function getNodeRect(node) {
  var _node$getBoundingClie = node.getBoundingClientRect(),
      top = _node$getBoundingClie.top,
      right = _node$getBoundingClie.right,
      bottom = _node$getBoundingClie.bottom,
      left = _node$getBoundingClie.left,
      width = _node$getBoundingClie.width,
      height = _node$getBoundingClie.height;

  return {
    top: top,
    right: right,
    bottom: bottom,
    left: left,
    width: width,
    height: height
  };
}

var safe = function safe(sum) {
  return sum < 0 ? 0 : sum;
};

exports.safe = safe;

function inView(_ref) {
  var top = _ref.top,
      bottom = _ref.bottom,
      left = _ref.left,
      height = _ref.height;
  return top >= 0 && left >= 0 && bottom <= height;
}

function getWindow() {
  var width = Math.max(document.documentElement.clientWidth, window.innerWidth || 0);
  var height = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
  return {
    width: width,
    height: height
  };
}

function isBody(node) {
  return node === document.querySelector('body') || node === document.querySelector('html');
}

var getCalculationsData = function getCalculationsData(node, padding) {
  if (!node) {
    var _getWindow = getWindow(),
        width = _getWindow.width,
        height = _getWindow.height;

    return {
      left: width / 2 - 10,
      top: height / 2 - 10,
      width: 0,
      height: 0,
      right: width / 2 + 10,
      bottom: height / 2 + 10
    };
  }

  var rect = getNodeRect(node);
  return {
    left: safe(rect.left - padding),
    top: rect.top - padding,
    width: safe(rect.width + padding * 2),
    height: safe(rect.height + padding * 2),
    right: safe(rect.right + padding),
    bottom: safe(rect.bottom + padding)
  };
};

exports.getCalculationsData = getCalculationsData;