"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Picture = exports.ImgSpan = exports.ImgPure = exports.ImgImg = exports.ImgDiv = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _SpinIcon = _interopRequireDefault(require("../Spin/SpinIcon"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _mergeStyle = _interopRequireDefault(require("../utils/mergeStyle"));

var _typeHelper = require("../utils/type-helper");

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _withTheme = require("../utils/withTheme");

var _ImgContainer = _interopRequireDefault(require("./ImgContainer"));

var _styled = require("./styled");

var _useImg2 = _interopRequireDefault(require("./useImg"));

var _excluded = ["width", "height", "suffixHeight", "suffixWidth", "webp", "format", "resizeMode", "ratio", "blur", "q", "Q", "external", "wait", "resize", "clean", "oss", "suffix", "lazy", "src", "aspectRatio", "onLoaded", "onError", "defaultImg", "component", "defaultImgStyle", "loadingType", "loadingDelay", "children", "style", "styles", "className"],
    _excluded2 = ["component"],
    _excluded3 = ["component"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  loading: '',
  error: '',
  blank: '',
  loaded: ''
};
var ImgPure = (0, _memoForwardRef["default"])(function (props, ref) {
  var width = props.width,
      height = props.height,
      suffixHeight = props.suffixHeight,
      suffixWidth = props.suffixWidth,
      webp = props.webp,
      format = props.format,
      resizeMode = props.resizeMode,
      ratio = props.ratio,
      blur = props.blur,
      q = props.q,
      Q = props.Q,
      external = props.external,
      wait = props.wait,
      resize = props.resize,
      clean = props.clean,
      oss = props.oss,
      suffix = props.suffix,
      lazy = props.lazy,
      src = props.src,
      aspectRatio = props.aspectRatio,
      onLoaded = props.onLoaded,
      onError = props.onError,
      defaultImg = props.defaultImg,
      component = props.component,
      defaultImgStyle = props.defaultImgStyle,
      loadingType = props.loadingType,
      loadingDelay = props.loadingDelay,
      children = props.children,
      style = props.style,
      styles = props.styles,
      className = props.className,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var imgRef = (0, _react.useRef)(null);
  var handleRef = (0, _useForkRef2.useForkRef)(imgRef, ref);
  var theme = (0, _useTheme["default"])();

  var _useImg = (0, _useImg2["default"])({
    imgRef: imgRef,
    suffixs: {
      width: suffixWidth,
      height: suffixHeight,
      webp: webp,
      format: format,
      resizeMode: resizeMode,
      ratio: ratio,
      blur: blur,
      q: q,
      Q: Q,
      external: external
    },
    options: {
      wait: wait,
      resize: resize,
      clean: clean,
      oss: oss,
      suffix: suffix,
      lazy: lazy
    },
    src: src,
    onError: onError,
    onLoaded: onLoaded,
    loadingDelay: loadingDelay
  }),
      imgState = _useImg.imgState,
      imgPool = _useImg.imgPool;

  var imgSrc = imgState.imgSrc,
      loadStatus = imgState.loadStatus;
  var innerStyles = (0, _useStyles["default"])('img', defaultStyles, styles);
  var loading = loadStatus === 'none';
  var finalDefaultImg = defaultImg || imgPool.settings.defaultImg || theme.components.Img.errorImg;
  var useDefaultImgAndIsFromTheme = false;
  var innerImgSrc = imgSrc;

  if (loading && loadingType === 'default-img' && finalDefaultImg || loadStatus === 'error' && finalDefaultImg) {
    innerImgSrc = finalDefaultImg;
    useDefaultImgAndIsFromTheme = finalDefaultImg === theme.components.Img.errorImg;
  }

  var styleItem;

  if (loading) {
    styleItem = innerStyles.loading;
  } else if (loadStatus === 'blank') {
    styleItem = innerStyles.blank;
  } else if (loadStatus === 'error') {
    styleItem = innerStyles.error;
  } else if (loadStatus === 'loaded') {
    styleItem = innerStyles.loaded;
  }

  var innerStyle = (0, _react.useMemo)(function () {
    var moreStyle;

    if (defaultImg && defaultImgStyle) {
      moreStyle = defaultImgStyle;
    } else if (finalDefaultImg === imgPool.settings.defaultImg && imgPool.settings.defaultImgStyle) {
      moreStyle = imgPool.settings.defaultImgStyle;
    }

    var styleItemStyle = styleItem ? styleItem.style : undefined;
    return (0, _mergeStyle["default"])(moreStyle, styleItemStyle, style);
  }, [defaultImg, defaultImgStyle, finalDefaultImg, imgPool.settings.defaultImg, imgPool.settings.defaultImgStyle, style, styleItem]);
  var imgStyle = (0, _react.useMemo)(function () {
    if (innerImgSrc) {
      return (0, _extends2["default"])({}, innerStyle, {
        backgroundImage: "url('".concat(innerImgSrc, "')")
      });
    }

    return innerStyle;
  }, [innerImgSrc, innerStyle]);
  var innerClassName = (0, _react.useMemo)(function () {
    var classnames = [];

    if (className) {
      classnames.push(className);
    }

    if (styleItem) {
      classnames.push(styleItem.className);
    }

    return classnames.length > 0 ? classnames.join(' ') : undefined;
  }, [className, styleItem]);
  var finalChildren = (0, _react.useMemo)(function () {
    if (loading && loadingType === 'skeleton') {
      return /*#__PURE__*/_react["default"].createElement(_styled.StyledSkeleton, null, children);
    } else if (loading && loadingType === 'spin') {
      return /*#__PURE__*/_react["default"].createElement(_SpinIcon["default"], {
        color: "currentColor"
      });
    }

    return children;
  }, [children, loading, loadingType]);

  if (component === 'img') {
    return /*#__PURE__*/_react["default"].createElement(_styled.BaseImg, (0, _extends2["default"])({}, otherProps, {
      className: innerClassName,
      theme: theme,
      $width: width,
      $height: height,
      style: innerStyle,
      "data-src": src,
      src: innerImgSrc,
      ref: handleRef
    }));
  }

  if (component === 'span') {
    return /*#__PURE__*/_react["default"].createElement(_styled.BaseSpan, (0, _extends2["default"])({}, otherProps, {
      className: innerClassName,
      theme: theme,
      $width: width,
      $height: height,
      $aspectRatio: aspectRatio,
      $loadingType: loadingType,
      $useDefaultImgAndIsFromTheme: useDefaultImgAndIsFromTheme,
      $status: loadStatus,
      style: imgStyle,
      ref: handleRef
    }), finalChildren);
  }

  return /*#__PURE__*/_react["default"].createElement(_styled.BaseDiv, (0, _extends2["default"])({}, otherProps, {
    className: innerClassName,
    theme: theme,
    $width: width,
    $height: height,
    $aspectRatio: aspectRatio,
    $loadingType: loadingType,
    $status: loadStatus,
    $useDefaultImgAndIsFromTheme: useDefaultImgAndIsFromTheme,
    style: imgStyle,
    ref: handleRef
  }), finalChildren);
});
exports.ImgPure = ImgPure;
var ImgNoTheme = (0, _styledComponents["default"])(ImgPure).withConfig({
  displayName: "ImgNoTheme"
})([""]);
var Img = (0, _withTheme.withThemeForStyled)(ImgNoTheme);
var ImgDiv = Img;
exports.ImgDiv = ImgDiv;
var Picture = Img;
exports.Picture = Picture;

var ImgSpan = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var component = props.component,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded2);
  return /*#__PURE__*/_react["default"].createElement(Img, (0, _extends2["default"])({}, otherProps, {
    ref: ref,
    component: "span"
  }));
});

exports.ImgSpan = ImgSpan;

var ImgImg = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var component = props.component,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded3);
  return /*#__PURE__*/_react["default"].createElement(Img, (0, _extends2["default"])({}, otherProps, {
    ref: ref,
    component: "img"
  }));
});

exports.ImgImg = ImgImg;

var _default = (0, _typeHelper.withProperties)(Img, {
  Span: ImgSpan,
  Img: ImgImg,
  Container: _ImgContainer["default"],
  useImg: _useImg2["default"]
});

exports["default"] = _default;