"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _ImgPoolContext = _interopRequireWildcard(require("./ImgPoolContext"));

var _excluded = ["children", "onScroll"],
    _excluded2 = ["settings", "poolName"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var BaseNode = _styledComponents["default"].div.withConfig({
  displayName: "BaseNode"
})([""]);

var Container = (0, _memoForwardRef["default"])(function (props, ref) {
  var children = props.children,
      onScroll = props.onScroll,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var pool = (0, _react.useContext)(_ImgPoolContext["default"]);

  var innerOnScroll = function innerOnScroll(e) {
    onScroll && onScroll(e);
    pool.throttleCheck({
      type: 'scroll'
    });
  };

  (0, _react.useEffect)(function () {
    pool.throttleCheck({
      type: 'scroll'
    });
  }, [children, pool]);
  return /*#__PURE__*/_react["default"].createElement(BaseNode, (0, _extends2["default"])({}, otherProps, {
    onScroll: innerOnScroll,
    ref: ref
  }), children);
});

var _default = (0, _memoForwardRef["default"])(function (props, ref) {
  var settings = props.settings,
      _props$poolName = props.poolName,
      poolName = _props$poolName === void 0 ? 'img_container' : _props$poolName,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded2);
  return /*#__PURE__*/_react["default"].createElement(_ImgPoolContext.ImgPoolProvider, {
    settings: settings,
    poolName: poolName
  }, /*#__PURE__*/_react["default"].createElement(Container, (0, _extends2["default"])({}, otherProps, {
    ref: ref
  })));
});

exports["default"] = _default;