"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.imgPool = exports["default"] = exports.ImgPoolProvider = void 0;

var _react = _interopRequireWildcard(require("react"));

var _ImgPool = _interopRequireDefault(require("./ImgPool"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var imgPool = new _ImgPool["default"]();
exports.imgPool = imgPool;
imgPool.setupSync();

var ImgPoolContext = /*#__PURE__*/_react["default"].createContext(imgPool);

var uid = 0;

var ImgPoolProvider = /*#__PURE__*/_react["default"].memo(function (props) {
  var settings = props.settings,
      poolName = props.poolName,
      children = props.children;
  var name = poolName || 'img_provider';
  var pool = (0, _react.useMemo)(function () {
    return new _ImgPool["default"]("".concat(name, "_").concat(uid++));
  }, [name]);
  (0, _react.useEffect)(function () {
    pool.setupSync(settings);
    return function () {
      pool.destroy();
    };
  }, [pool, settings]);
  return /*#__PURE__*/_react["default"].createElement(ImgPoolContext.Provider, {
    value: pool
  }, children);
});

exports.ImgPoolProvider = ImgPoolProvider;
var _default = ImgPoolContext;
exports["default"] = _default;