"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _ResetIcon2 = require("@muya-ui/theme-light/lib/icons/ResetIcon");

var _ShrinkIcon2 = require("@muya-ui/theme-light/lib/icons/ShrinkIcon");

var _MagnifyIcon2 = require("@muya-ui/theme-light/lib/icons/MagnifyIcon");

var _RotateIcon2 = require("@muya-ui/theme-light/lib/icons/RotateIcon");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _InlineButton = _interopRequireDefault(require("../InlineButton"));

var _Slider = require("../Slider");

var _base = require("../styled/base");

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _useImgCropper2 = _interopRequireDefault(require("./useImgCropper"));

var _excluded = ["src", "size", "shape", "scaleMax", "scaleMin", "wheelScaleStep", "scaleStep", "defaultScale", "rotateable", "resetable", "backDelay", "styles", "boxPadding", "sliderStyles"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  container: '',
  content: '',
  mask: '',
  img: '',
  row: '',
  zoom: '',
  zoomButton: '',
  zoomOut: '',
  sliderContainer: '',
  slider: '',
  rotateContainer: '',
  rotateButton: '',
  resetContainer: '',
  resetButton: ''
};
var ImgCropper = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var src = props.src,
      size = props.size,
      shape = props.shape,
      scaleMax = props.scaleMax,
      scaleMin = props.scaleMin,
      wheelScaleStep = props.wheelScaleStep,
      _props$scaleStep = props.scaleStep,
      scaleStep = _props$scaleStep === void 0 ? 0.1 : _props$scaleStep,
      defaultScale = props.defaultScale,
      _props$rotateable = props.rotateable,
      rotateable = _props$rotateable === void 0 ? true : _props$rotateable,
      _props$resetable = props.resetable,
      resetable = _props$resetable === void 0 ? false : _props$resetable,
      backDelay = props.backDelay,
      styles = props.styles,
      boxPadding = props.boxPadding,
      sliderStyles = props.sliderStyles,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var _theme$components$Img = theme.components.ImgCropper,
      _theme$components$Img2 = _theme$components$Img.rotateIcon,
      RotateIcon = _theme$components$Img2 === void 0 ? _RotateIcon2.RotateIcon : _theme$components$Img2,
      _theme$components$Img3 = _theme$components$Img.zoomIcon,
      ZoomIcon = _theme$components$Img3 === void 0 ? _MagnifyIcon2.MagnifyIcon : _theme$components$Img3,
      _theme$components$Img4 = _theme$components$Img.zoomOutIcon,
      ZoomOutIcon = _theme$components$Img4 === void 0 ? _ShrinkIcon2.ShrinkIcon : _theme$components$Img4,
      _theme$components$Img5 = _theme$components$Img.resetIcon,
      ResetIcon = _theme$components$Img5 === void 0 ? _ResetIcon2.ResetIcon : _theme$components$Img5,
      defaultSize = _theme$components$Img.defaultSize;

  var _ref = size || defaultSize,
      _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
      $width = _ref2[0],
      $height = _ref2[1];

  var maskRef = (0, _react.useRef)(null);
  var imgRef = (0, _react.useRef)(null);
  var rootRef = (0, _react.useRef)(null);
  var innerStyles = (0, _useStyles["default"])('img-cropper', defaultStyles, styles);

  var _useImgCropper = (0, _useImgCropper2["default"])(props, maskRef, imgRef),
      moving = _useImgCropper.moving,
      imgSrc = _useImgCropper.imgSrc,
      imgStyle = _useImgCropper.imgStyle,
      getImg = _useImgCropper.getImg,
      getInfo = _useImgCropper.getInfo,
      handleMouseDown = _useImgCropper.handleMouseDown,
      handleMouseMove = _useImgCropper.handleMouseMove,
      handleMouseUp = _useImgCropper.handleMouseUp,
      handleMouseEnter = _useImgCropper.handleMouseEnter,
      handleWheel = _useImgCropper.handleWheel,
      handleSliderChange = _useImgCropper.handleSliderChange,
      rotateImg = _useImgCropper.rotateImg,
      handleZoom = _useImgCropper.handleZoom,
      handleZoomOut = _useImgCropper.handleZoomOut,
      resetImg = _useImgCropper.resetImg,
      finalScaleMin = _useImgCropper.finalScaleMin,
      finalScaleMax = _useImgCropper.finalScaleMax,
      finalScale = _useImgCropper.finalScale;

  var handleRef = (0, _useForkRef2.useForkRef)(ref, rootRef, {
    getImg: getImg,
    getInfo: getInfo
  });
  var finalImgStyle = (0, _react.useMemo)(function () {
    return (0, _extends2["default"])({}, innerStyles.img.style, imgStyle);
  }, [imgStyle, innerStyles.img.style]);
  return /*#__PURE__*/_react["default"].createElement(_base.BaseDiv, (0, _extends2["default"])({}, otherProps, {
    ref: handleRef
  }), /*#__PURE__*/_react["default"].createElement(_styled.StyledCropper, {
    $width: $width,
    $height: $height,
    $padding: boxPadding,
    theme: theme,
    onMouseDown: handleMouseDown,
    onMouseUp: handleMouseUp,
    onMouseLeave: handleMouseUp,
    onMouseEnter: handleMouseEnter,
    onMouseMove: handleMouseMove,
    onWheel: handleWheel
  }, /*#__PURE__*/_react["default"].createElement(_styled.StyledContainer, (0, _extends2["default"])({
    $moving: moving
  }, innerStyles.container), /*#__PURE__*/_react["default"].createElement(_styled.StyledMask, (0, _extends2["default"])({
    theme: theme,
    $moving: moving,
    $shape: shape,
    ref: maskRef
  }, innerStyles.mask)), /*#__PURE__*/_react["default"].createElement(_styled.StyledContent, innerStyles.content, imgSrc && /*#__PURE__*/_react["default"].createElement(_styled.StyledImg, {
    ref: imgRef,
    theme: theme,
    $transition: moving ? 'off' : 'on',
    style: finalImgStyle,
    className: innerStyles.img.className
  })))), /*#__PURE__*/_react["default"].createElement(_styled.StyledRow, innerStyles.row, /*#__PURE__*/_react["default"].createElement(_styled.StyledZoomCol, (0, _extends2["default"])({}, innerStyles.zoomOut, {
    theme: theme
  }), /*#__PURE__*/_react["default"].createElement(_InlineButton["default"], (0, _extends2["default"])({}, innerStyles.zoomButton, {
    type: "weak",
    onClick: handleZoomOut
  }), /*#__PURE__*/_react["default"].createElement(ZoomOutIcon, null))), /*#__PURE__*/_react["default"].createElement(_styled.StyledSliderCol, (0, _extends2["default"])({}, innerStyles.sliderContainer, {
    theme: theme
  }), /*#__PURE__*/_react["default"].createElement(_Slider.Slider, (0, _extends2["default"])({}, innerStyles.slider, {
    styles: sliderStyles,
    min: finalScaleMin,
    max: finalScaleMax,
    step: scaleStep,
    value: finalScale,
    onChange: handleSliderChange
  }))), /*#__PURE__*/_react["default"].createElement(_styled.StyledZoomCol, (0, _extends2["default"])({}, innerStyles.zoom, {
    theme: theme
  }), /*#__PURE__*/_react["default"].createElement(_InlineButton["default"], (0, _extends2["default"])({}, innerStyles.zoomButton, {
    type: "weak",
    onClick: handleZoom
  }), /*#__PURE__*/_react["default"].createElement(ZoomIcon, null))), rotateable && /*#__PURE__*/_react["default"].createElement(_styled.StyledActionCol, (0, _extends2["default"])({}, innerStyles.rotateContainer, {
    theme: theme
  }), /*#__PURE__*/_react["default"].createElement(_InlineButton["default"], (0, _extends2["default"])({}, innerStyles.rotateButton, {
    type: "weak",
    onClick: rotateImg
  }), /*#__PURE__*/_react["default"].createElement(RotateIcon, null))), resetable && /*#__PURE__*/_react["default"].createElement(_styled.StyledActionCol, (0, _extends2["default"])({}, innerStyles.resetContainer, {
    theme: theme
  }), /*#__PURE__*/_react["default"].createElement(_InlineButton["default"], (0, _extends2["default"])({}, innerStyles.resetButton, {
    type: "weak",
    onClick: resetImg
  }), /*#__PURE__*/_react["default"].createElement(ResetIcon, null)))));
});
var _default = ImgCropper;
exports["default"] = _default;