"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledZoomCol = exports.StyledSliderCol = exports.StyledRow = exports.StyledMask = exports.StyledImg = exports.StyledCropper = exports.StyledContent = exports.StyledContainer = exports.StyledActionCol = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function layerCss() {
  return (0, _styledComponents.css)(["position:absolute;top:0;left:0;width:100%;height:100%;box-sizing:border-box;"]);
}

var StyledMaskInner = _styledComponents["default"].div.withConfig({
  displayName: "StyledMaskInner"
})(["", " ", ""], layerCss, function (props) {
  var $moving = props.$moving;
  var _props$$shape = props.$shape,
      $shape = _props$$shape === void 0 ? 'normal' : _props$$shape,
      theme = props.theme;
  var _theme$components$Img = theme.components.ImgCropper,
      maskColor = _theme$components$Img.maskColor,
      borderColor = _theme$components$Img.borderColor,
      borderRadius = _theme$components$Img.borderRadius;
  var cursorCss;

  if (!$moving) {
    cursorCss = (0, _styledComponents.css)(["&:hover{cursor:grab;}"]);
  } else {
    cursorCss = (0, _styledComponents.css)(["cursor:grabbing;"]);
  }

  return (0, _styledComponents.css)(["", " border:1px solid ", ";border-radius:", ";box-shadow:0 0 0 10000px ", ";z-index:1;"], cursorCss, borderColor, borderRadius[$shape], maskColor);
});

var StyledMask = /*#__PURE__*/_react["default"].memo(StyledMaskInner);

exports.StyledMask = StyledMask;

var StyledContentInner = _styledComponents["default"].div.withConfig({
  displayName: "StyledContentInner"
})(["", ""], layerCss);

var StyledContent = /*#__PURE__*/_react["default"].memo(StyledContentInner);

exports.StyledContent = StyledContent;

var StyledContainer = _styledComponents["default"].div.withConfig({
  displayName: "StyledContainer"
})(["position:relative;width:100%;height:100%;", ""], function (props) {
  var $moving = props.$moving;

  if (!$moving) {
    return;
  }

  return (0, _styledComponents.css)(["cursor:grabbing;"]);
});

exports.StyledContainer = StyledContainer;

var StyledCropperInner = _styledComponents["default"].div.withConfig({
  displayName: "StyledCropperInner"
})(["position:relative;overflow:hidden;box-sizing:content-box;", ""], function (props) {
  var $width = props.$width,
      $height = props.$height,
      $padding = props.$padding,
      theme = props.theme;
  var cropperMarginBottom = theme.components.ImgCropper.cropperMarginBottom;
  var cropperPadding = $padding;

  if (!$padding) {
    var paddingLeftRight = 3 / 14 * $width;
    var paddingTopBottom = 3 / 14 * $height;
    cropperPadding = "".concat(paddingTopBottom, "px ").concat(paddingLeftRight, "px");
  }

  return (0, _styledComponents.css)(["width:", "px;height:", "px;padding:", ";margin-bottom:", "px;"], $width, $height, cropperPadding, cropperMarginBottom);
});

var StyledCropper = /*#__PURE__*/_react["default"].memo(StyledCropperInner);

exports.StyledCropper = StyledCropper;

var RCol = _styledComponents["default"].div.withConfig({
  displayName: "RCol"
})(["font-size:0;", ""], function (props) {
  return (0, _styledComponents.css)(["padding-left:", "px;"], props.theme.components.ImgCropper.actionPaddingLeft);
});

var StyledActionCol = /*#__PURE__*/_react["default"].memo(RCol);

exports.StyledActionCol = StyledActionCol;

var ZCol = _styledComponents["default"].div.withConfig({
  displayName: "ZCol"
})(["font-size:0;"]);

var StyledZoomCol = /*#__PURE__*/_react["default"].memo(ZCol);

exports.StyledZoomCol = StyledZoomCol;

var SCol = _styledComponents["default"].div.withConfig({
  displayName: "SCol"
})(["flex:1;", ""], function (props) {
  return (0, _styledComponents.css)(["padding:0 ", "px;"], props.theme.components.ImgCropper.sliderPadding);
});

var StyledSliderCol = /*#__PURE__*/_react["default"].memo(SCol);

exports.StyledSliderCol = StyledSliderCol;

var StyledRowInner = _styledComponents["default"].div.withConfig({
  displayName: "StyledRowInner"
})(["display:flex;justify-content:space-between;"]);

var StyledRow = /*#__PURE__*/_react["default"].memo(StyledRowInner);

exports.StyledRow = StyledRow;

var StyledImg = _styledComponents["default"].div.withConfig({
  displayName: "StyledImg"
})(["background-size:cover;transform-origin:center;position:absolute;", ""], function (props) {
  var $transition = props.$transition,
      theme = props.theme;
  var _theme$transition$spe = theme.transition.spec,
      easing = _theme$transition$spe.easing,
      duration = _theme$transition$spe.duration;

  if ($transition !== 'on') {
    return false;
  }

  return (0, _styledComponents.css)(["transition:transform ", "ms ", ";"], duration.fast, easing.easeInOut);
});

exports.StyledImg = StyledImg;