"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useImgCropper;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _wait2 = require("@muya-ui/utils/lib/utils/wait");

var _useLockScroll2 = require("@muya-ui/utils/lib/hooks/useLockScroll");

var _useAfterEffect2 = require("@muya-ui/utils/lib/hooks/useAfterEffect");

var _useThrottle2 = require("@muya-ui/utils/lib/hooks/useThrottle");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = require("react");

var _forkHandler = _interopRequireDefault(require("../utils/forkHandler"));

var _useTheme2 = require("../utils/useTheme");

var _utils = require("./utils");

function useImgCropper(props, maskRef, imgRef) {
  var _useTheme = (0, _useTheme2.useTheme)(),
      defaultSize = _useTheme.components.ImgCropper.defaultSize;

  var _props$size = props.size,
      size = _props$size === void 0 ? defaultSize : _props$size,
      defaultScale = props.defaultScale,
      _props$src = props.src,
      src = _props$src === void 0 ? '' : _props$src,
      _props$wheelScaleStep = props.wheelScaleStep,
      wheelScaleStep = _props$wheelScaleStep === void 0 ? 0.01 : _props$wheelScaleStep,
      _props$scaleStep = props.scaleStep,
      scaleStep = _props$scaleStep === void 0 ? 0.1 : _props$scaleStep,
      disableWheel = props.disableWheel,
      _props$scaleMax = props.scaleMax,
      scaleMax = _props$scaleMax === void 0 ? 4 : _props$scaleMax,
      _props$scaleMin = props.scaleMin,
      scaleMin = _props$scaleMin === void 0 ? 1 : _props$scaleMin,
      _props$backDelay = props.backDelay,
      backDelay = _props$backDelay === void 0 ? 200 : _props$backDelay;
  var innerWheelScaleStep = wheelScaleStep < 0 || wheelScaleStep > 1 ? 0.1 : wheelScaleStep;
  var finalScaleMin = scaleMin < 1 ? 1 : scaleMin;
  var finalScaleMax = scaleMax < 1 ? 1 : scaleMax;

  var _useState = (0, _react.useState)(defaultScale || finalScaleMin),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      stateScale = _useState2[0],
      setScale = _useState2[1];

  var finalScale = Math.max(stateScale, 0.01);

  var _useState3 = (0, _react.useState)([0, 0]),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      finalTranslate = _useState4[0],
      setTranslate = _useState4[1];

  var _useState5 = (0, _react.useState)(0),
      _useState6 = (0, _slicedToArray2["default"])(_useState5, 2),
      finalRotate = _useState6[0],
      setRotate = _useState6[1];

  var _useState7 = (0, _react.useState)({
    src: src,
    status: 'none'
  }),
      _useState8 = (0, _slicedToArray2["default"])(_useState7, 2),
      state = _useState8[0],
      setState = _useState8[1];

  var _useState9 = (0, _react.useState)(false),
      _useState10 = (0, _slicedToArray2["default"])(_useState9, 2),
      moving = _useState10[0],
      setMoving = _useState10[1];

  var _useState11 = (0, _react.useState)(false),
      _useState12 = (0, _slicedToArray2["default"])(_useState11, 2),
      enter = _useState12[0],
      setEnter = _useState12[1];

  if (src !== state.src) {
    setState({
      src: src,
      status: 'none'
    });
    setScale(finalScaleMin);
    setTranslate([0, 0]);
    setRotate(0);
  }

  var imgStyle = (0, _react.useMemo)(function () {
    var innerImgStyle = (0, _utils.getImgStyle)(size, finalRotate, state.img);

    if (state.src) {
      innerImgStyle.backgroundImage = "url(".concat(state.src, ")");
    }

    innerImgStyle.transform = ["translate(".concat(finalTranslate[0], "px, ").concat(finalTranslate[1], "px)"), "rotate(".concat(finalRotate, "deg)"), "scale(".concat(finalScale, ")"), 'translateZ(0)'].join(' ');
    return innerImgStyle;
  }, [finalRotate, finalScale, finalTranslate, size, state.img, state.src]); // 滚轮停止 或者 鼠标结束时，校验位置是否正确的
  // 不用包 memo 永远 debounce 使用了， 用了 useAfterEffect

  var backToRightTransform = function backToRightTransform() {
    if (moving) {
      return;
    }

    if (finalScale < finalScaleMin) {
      setScale(finalScaleMin);
      setTranslate([0, 0]);
      return;
    }

    if (finalScale > finalScaleMax) {
      setScale(finalScaleMax);
      return;
    }
    /* istanbul ignore if */


    if (!(maskRef.current && imgRef.current)) {
      return;
    }

    var newTranslate = (0, _utils.getNewTranslate)(maskRef.current.getBoundingClientRect(), imgRef.current.getBoundingClientRect(), finalTranslate);

    if (newTranslate) {
      setTranslate(newTranslate);
    }
  };

  var getImg = function getImg() {
    var radio = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;

    /* istanbul ignore if */
    if (!(maskRef.current && imgRef.current && state.img)) {
      return null;
    }

    var maskRect = maskRef.current.getBoundingClientRect();
    var imgRect = imgRef.current.getBoundingClientRect();
    return (0, _utils.cropImg)(state.img, imgRect, maskRect, finalRotate, radio);
  };

  var getInfo = function getInfo() {
    /* istanbul ignore if */
    if (!(maskRef.current && imgRef.current && state.img)) {
      return null;
    }

    var maskRect = maskRef.current.getBoundingClientRect();
    var imgRect = imgRef.current.getBoundingClientRect();
    return {
      maskRect: maskRect,
      imgRect: imgRect,
      rotate: finalRotate,
      scale: finalScale
    };
  };

  var beforeFn = (0, _react.useCallback)(function () {
    return state.status === 'loaded';
  }, [state.status]);
  var tmp = (0, _react.useRef)({
    originX: 0,
    originY: 0,
    lastX: 0,
    lastY: 0
  });
  var moveStart = (0, _react.useCallback)(function (e) {
    setMoving(true);
    tmp.current.originX = e.clientX;
    tmp.current.originY = e.clientY;
    tmp.current.lastX = finalTranslate[0];
    tmp.current.lastY = finalTranslate[1];
  }, [finalTranslate]);
  var moveEnd = (0, _react.useCallback)(function () {
    setMoving(false);
    setEnter(false);
  }, []);
  var move = (0, _react.useCallback)(function (e) {
    if (!moving) {
      return;
    }

    var _tmp$current = tmp.current,
        lastX = _tmp$current.lastX,
        lastY = _tmp$current.lastY,
        originX = _tmp$current.originX,
        originY = _tmp$current.originY;
    var x = lastX + (e.clientX - originX);
    var y = lastY + (e.clientY - originY);
    setTranslate([x, y]);
  }, [moving]);
  var zoom = (0, _react.useCallback)(function (e) {
    if (disableWheel || !enter) {
      return;
    }

    var diff = e.deltaY;

    if (diff < 0.1 && diff > -0.1) {
      return;
    }

    var diffScale = e.deltaY * innerWheelScaleStep;
    var newScale = finalScale + diffScale;
    setScale(newScale);
  }, [disableWheel, enter, finalScale, innerWheelScaleStep]);
  var zoomFn = (0, _useThrottle2.useThrottle)(zoom, 50);
  var rotateImg = (0, _react.useCallback)(function () {
    setRotate(finalRotate - 90);
  }, [finalRotate]);
  var handleMouseDown = (0, _react.useMemo)(function () {
    return (0, _forkHandler["default"])(moveStart, undefined, beforeFn);
  }, [beforeFn, moveStart]);
  var handleMouseUp = (0, _react.useMemo)(function () {
    return (0, _forkHandler["default"])(moveEnd, undefined, beforeFn);
  }, [beforeFn, moveEnd]);
  var handleMouseMove = (0, _react.useMemo)(function () {
    return (0, _forkHandler["default"])(move, undefined, beforeFn);
  }, [beforeFn, move]);
  var handleWheel = (0, _react.useMemo)(function () {
    return (0, _forkHandler["default"])(zoomFn, undefined, beforeFn);
  }, [beforeFn, zoomFn]);
  var handleMouseEnter = (0, _react.useCallback)(function () {
    setEnter(true);
  }, []);
  var handleSliderChange = setScale;
  var handleZoom = (0, _react.useCallback)(function () {
    setScale(finalScale + scaleStep);
  }, [finalScale, scaleStep]);
  var handleZoomOut = (0, _react.useCallback)(function () {
    setScale(finalScale - scaleStep);
  }, [finalScale, scaleStep]);
  var resetImg = (0, _react.useCallback)(function () {
    setScale(defaultScale || finalScaleMin);
    setRotate(0);
  }, [defaultScale, finalScaleMin]);
  (0, _useAfterEffect2.useAfterEffect)(backToRightTransform, backDelay);
  (0, _useLockScroll2.useLockScroll)(enter && !disableWheel);
  (0, _react.useEffect)(function () {
    if (state.src && state.status === 'none') {
      _wait2.wait.imgLoaded(state.src, 'Anonymous').then(function (img) {
        setState(function (prev) {
          return (0, _extends2["default"])({}, prev, {
            status: 'loaded',
            img: img
          });
        });
      });
    }
  }, [state.src, state.status]);
  return {
    moving: moving,
    handleMouseDown: handleMouseDown,
    handleMouseUp: handleMouseUp,
    handleMouseEnter: handleMouseEnter,
    handleMouseMove: handleMouseMove,
    handleWheel: handleWheel,
    handleSliderChange: handleSliderChange,
    handleZoom: handleZoom,
    handleZoomOut: handleZoomOut,
    rotateImg: rotateImg,
    resetImg: resetImg,
    imgStyle: imgStyle,
    finalTranslate: finalTranslate,
    finalScale: finalScale,
    finalScaleMin: finalScaleMin,
    finalScaleMax: finalScaleMax,
    finalRotate: finalRotate,
    imgSrc: state.src,
    getImg: getImg,
    getInfo: getInfo,
    backToRightTransform: backToRightTransform,
    moveStart: moveStart,
    moveEnd: moveEnd,
    move: move,
    zoom: zoom,
    enter: enter
  };
}