"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _GuildRightIcon2 = require("@muya-ui/theme-light/lib/icons/GuildRightIcon");

var _GuildLeftIcon2 = require("@muya-ui/theme-light/lib/icons/GuildLeftIcon");

var _CloseIcon2 = require("@muya-ui/theme-light/lib/icons/CloseIcon");

var _FullscreenIcon2 = require("@muya-ui/theme-light/lib/icons/FullscreenIcon");

var _ShrinkIcon2 = require("@muya-ui/theme-light/lib/icons/ShrinkIcon");

var _MagnifyIcon2 = require("@muya-ui/theme-light/lib/icons/MagnifyIcon");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _Button = _interopRequireDefault(require("../Button"));

var _ButtonGroup = _interopRequireDefault(require("../ButtonGroup"));

var _Dialog = _interopRequireDefault(require("../Dialog"));

var _Result = _interopRequireDefault(require("../Result"));

var _Spin = _interopRequireDefault(require("../Spin"));

var _Swipe = _interopRequireDefault(require("../Swipe"));

var _Tooltip = _interopRequireDefault(require("../Tooltip"));

var _mergeStyleItem = _interopRequireDefault(require("../utils/mergeStyleItem"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _useImgPreview2 = _interopRequireDefault(require("./useImgPreview"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _excluded = ["mode", "open", "loading", "zoomInIcon", "zoomOutIcon", "resetZoomIcon", "hideActions", "paginationImgWidth", "disableMaskClick", "renderInImgNode", "renderInImgContainer", "renderCustomPageButton", "renderCustomPagination", "renderCustomActionsNode", "onClose", "onExited", "styles", "style", "className", "suffix", "zIndex"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  wrapper: '',
  closeIconWrapper: '',
  imgLayer: '',
  imgWrapper: '',
  imgContainer: '',
  img: '',
  paginationWrapper: '',
  paginationButton: '',
  paginationImg: ''
};
var ImgPreview = (0, _memoForwardRef["default"])(function (props, ref) {
  var theme = (0, _useTheme["default"])();
  var _props$mode = props.mode,
      mode = _props$mode === void 0 ? 'single' : _props$mode,
      open = props.open,
      loading = props.loading,
      zoomInIcon = props.zoomInIcon,
      zoomOutIcon = props.zoomOutIcon,
      resetZoomIcon = props.resetZoomIcon,
      _props$hideActions = props.hideActions,
      hideActions = _props$hideActions === void 0 ? false : _props$hideActions,
      paginationImgWidth = props.paginationImgWidth,
      _props$disableMaskCli = props.disableMaskClick,
      disableMaskClick = _props$disableMaskCli === void 0 ? false : _props$disableMaskCli,
      renderInImgNode = props.renderInImgNode,
      renderInImgContainer = props.renderInImgContainer,
      renderCustomPageButton = props.renderCustomPageButton,
      renderCustomPagination = props.renderCustomPagination,
      renderCustomActionsNode = props.renderCustomActionsNode,
      onClose = props.onClose,
      onExited = props.onExited,
      styles = props.styles,
      style = props.style,
      className = props.className,
      suffix = props.suffix,
      zIndex = props.zIndex,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var imgRef = (0, _react.useRef)(null);
  var imgScrollWrapperRef = (0, _react.useRef)(null);
  var imgWrapperRef = (0, _react.useRef)(null);
  var paginationRef = (0, _react.useRef)();
  var innerStyles = (0, _useStyles["default"])('img-preview', defaultStyles, styles);
  var wrapperStyleItem = (0, _react.useMemo)(function () {
    return (0, _mergeStyleItem["default"])({
      className: className,
      style: style
    }, innerStyles.wrapper);
  }, [className, innerStyles.wrapper, style]);

  var _useImgPreview = (0, _useImgPreview2["default"])(props, theme, imgScrollWrapperRef, imgWrapperRef, imgRef),
      imgUrl = _useImgPreview.imgUrl,
      imgs = _useImgPreview.imgs,
      imgIndex = _useImgPreview.imgIndex,
      onStepsChange = _useImgPreview.onStepsChange,
      imgOverflow = _useImgPreview.imgOverflow,
      imgLoading = _useImgPreview.imgLoading,
      imgLoadError = _useImgPreview.imgLoadError,
      imgLoaded = _useImgPreview.imgLoaded,
      loadingText = _useImgPreview.loadingText,
      loadErrorText = _useImgPreview.loadErrorText,
      zoomInText = _useImgPreview.zoomInText,
      zoomOutText = _useImgPreview.zoomOutText,
      resetZoomText = _useImgPreview.resetZoomText,
      overflowOffset = _useImgPreview.overflowOffset,
      stepIndex = _useImgPreview.stepIndex,
      hasPrevStep = _useImgPreview.hasPrevStep,
      hasNextStep = _useImgPreview.hasNextStep,
      toPrevStep = _useImgPreview.toPrevStep,
      toNextStep = _useImgPreview.toNextStep,
      hasPrevImg = _useImgPreview.hasPrevImg,
      hasNextImg = _useImgPreview.hasNextImg,
      showPaginationButton = _useImgPreview.showPaginationButton,
      containerSize = _useImgPreview.containerSize,
      updateOccupyHeight = _useImgPreview.updateOccupyHeight,
      showPagination = _useImgPreview.showPagination,
      handleImgClick = _useImgPreview.handleImgClick,
      handleImgLoaded = _useImgPreview.handleImgLoaded,
      handleImgError = _useImgPreview.handleImgError,
      handleImgMouseDown = _useImgPreview.handleImgMouseDown,
      handleImgMouseMove = _useImgPreview.handleImgMouseMove,
      handleImgMouseUp = _useImgPreview.handleImgMouseUp,
      handleZoomIn = _useImgPreview.handleZoomIn,
      handleZoomOut = _useImgPreview.handleZoomOut,
      handleResetZoom = _useImgPreview.handleResetZoom,
      handleExited = _useImgPreview.handleExited,
      toImgIndex = _useImgPreview.toImgIndex,
      toPrevImg = _useImgPreview.toPrevImg,
      toNextImg = _useImgPreview.toNextImg,
      handleMaskClick = _useImgPreview.handleMaskClick,
      handleCloseIconClick = _useImgPreview.handleCloseIconClick;

  var _theme$components$Img = theme.components.ImgPreview,
      spinColor = _theme$components$Img.spinColor,
      _theme$components$Img2 = _theme$components$Img.imgActions,
      _theme$components$Img3 = _theme$components$Img2.zoomInIcon,
      ZoomInIcon = _theme$components$Img3 === void 0 ? _MagnifyIcon2.MagnifyIcon : _theme$components$Img3,
      _theme$components$Img4 = _theme$components$Img2.zoomOutIcon,
      ZoomOutIcon = _theme$components$Img4 === void 0 ? _ShrinkIcon2.ShrinkIcon : _theme$components$Img4,
      _theme$components$Img5 = _theme$components$Img2.resetZoomIcon,
      ResetZoomIcon = _theme$components$Img5 === void 0 ? _FullscreenIcon2.FullscreenIcon : _theme$components$Img5,
      _theme$components$Img6 = _theme$components$Img.closeIcon.icon,
      CloseIcon = _theme$components$Img6 === void 0 ? _CloseIcon2.CloseIcon : _theme$components$Img6,
      _theme$components$Img7 = _theme$components$Img.pageButton,
      _theme$components$Img8 = _theme$components$Img7.leftIcon,
      PageLeftIcon = _theme$components$Img8 === void 0 ? _GuildLeftIcon2.GuildLeftIcon : _theme$components$Img8,
      _theme$components$Img9 = _theme$components$Img7.rightIcon,
      PageRightIcon = _theme$components$Img9 === void 0 ? _GuildRightIcon2.GuildRightIcon : _theme$components$Img9;
  var zoomInIconNode = (0, _react.useMemo)(function () {
    return zoomInIcon || /*#__PURE__*/_react["default"].createElement(ZoomInIcon, null);
  }, [zoomInIcon]);
  var zoomOutIconNode = (0, _react.useMemo)(function () {
    return zoomOutIcon || /*#__PURE__*/_react["default"].createElement(ZoomOutIcon, null);
  }, [zoomOutIcon]);
  var resetZoomNode = (0, _react.useMemo)(function () {
    return resetZoomIcon || /*#__PURE__*/_react["default"].createElement(ResetZoomIcon, null);
  }, [resetZoomIcon]);

  var handelPaginationRef = _react["default"].useCallback(function (instance) {
    paginationRef.current = instance;

    if (instance) {
      updateOccupyHeight(parseInt(getComputedStyle(instance).height, 10) || 0);
    }
  }, [updateOccupyHeight]);

  var actionsNode = (0, _react.useMemo)(function () {
    if (typeof renderCustomActionsNode === 'function') {
      return renderCustomActionsNode({
        zoomInText: zoomInText,
        handleZoomIn: handleZoomIn,
        zoomOutText: zoomOutText,
        handleZoomOut: handleZoomOut,
        resetZoomText: resetZoomText,
        handleResetZoom: handleResetZoom
      });
    }

    return /*#__PURE__*/_react["default"].createElement(_styled.StyledImgActions, {
      theme: theme
    }, /*#__PURE__*/_react["default"].createElement(_ButtonGroup["default"], null, /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], {
      title: zoomInText,
      placement: "top"
    }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      type: "strong",
      onClick: handleZoomIn
    }, zoomInIconNode)), /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], {
      title: zoomOutText,
      placement: "top"
    }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      type: "strong",
      onClick: handleZoomOut
    }, zoomOutIconNode)), /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], {
      title: resetZoomText,
      placement: "top"
    }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      type: "strong",
      onClick: handleResetZoom
    }, resetZoomNode))));
  }, [handleResetZoom, handleZoomIn, handleZoomOut, renderCustomActionsNode, resetZoomNode, resetZoomText, theme, zoomInIconNode, zoomInText, zoomOutIconNode, zoomOutText]);
  var pageButtonNode = (0, _react.useMemo)(function () {
    if (typeof renderCustomPageButton === 'function') {
      return renderCustomPageButton({
        hasPrev: hasPrevImg,
        hasNext: hasNextImg,
        toPrevImg: toPrevImg,
        toNextImg: toNextImg
      });
    } else {
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_styled.StyledPageButton, {
        theme: theme,
        onClick: toPrevImg,
        $disabled: !hasPrevImg,
        $direction: "left",
        $height: containerSize.height,
        $imgOverflow: imgOverflow
      }, /*#__PURE__*/_react["default"].createElement(PageLeftIcon, null)), /*#__PURE__*/_react["default"].createElement(_styled.StyledPageButton, {
        theme: theme,
        onClick: toNextImg,
        $disabled: !hasNextImg,
        $direction: "right",
        $height: containerSize.height,
        $imgOverflow: imgOverflow
      }, /*#__PURE__*/_react["default"].createElement(PageRightIcon, null)));
    }
  }, [containerSize.height, hasNextImg, hasPrevImg, imgOverflow, renderCustomPageButton, theme, toNextImg, toPrevImg]);
  var paginationNode = (0, _react.useMemo)(function () {
    if (typeof renderCustomPagination === 'function') {
      var pagination = renderCustomPagination({
        imgIndex: imgIndex,
        toImgIndex: toImgIndex
      });
      return /*#__PURE__*/(0, _react.cloneElement)(pagination, {
        ref: handelPaginationRef
      });
    } else {
      return /*#__PURE__*/_react["default"].createElement(_styled.StyledImgPaginationWrapper, (0, _extends2["default"])({
        ref: handelPaginationRef
      }, innerStyles.paginationWrapper, {
        theme: theme,
        $width: containerSize.width
      }), showPaginationButton && /*#__PURE__*/_react["default"].createElement(_styled.StyledPaginationButton, (0, _extends2["default"])({}, innerStyles.paginationButton, {
        theme: theme,
        onClick: toPrevStep,
        disabled: !hasPrevStep,
        arrow: "left",
        side: "right"
      }), /*#__PURE__*/_react["default"].createElement(PageLeftIcon, null)), /*#__PURE__*/_react["default"].createElement(_Swipe["default"], {
        stepIndex: stepIndex,
        onStepsChange: onStepsChange
      }, imgs.map(function (imgSrc, i) {
        return /*#__PURE__*/_react["default"].createElement(_styled.StyledPaginationImg, (0, _extends2["default"])({}, innerStyles.paginationImg, {
          key: i,
          "data-i": i,
          theme: theme,
          $selected: imgIndex === i,
          $width: paginationImgWidth,
          onClick: function onClick() {
            return toImgIndex(i);
          },
          src: imgSrc,
          suffix: suffix
        }));
      })), showPaginationButton && /*#__PURE__*/_react["default"].createElement(_styled.StyledPaginationButton, (0, _extends2["default"])({}, innerStyles.paginationButton, {
        theme: theme,
        onClick: toNextStep,
        disabled: !hasNextStep,
        arrow: "right",
        side: "left"
      }), /*#__PURE__*/_react["default"].createElement(PageRightIcon, null)));
    }
  }, [containerSize.width, handelPaginationRef, hasNextStep, hasPrevStep, imgIndex, imgs, innerStyles.paginationButton, innerStyles.paginationImg, innerStyles.paginationWrapper, onStepsChange, paginationImgWidth, renderCustomPagination, showPaginationButton, stepIndex, suffix, theme, toImgIndex, toNextStep, toPrevStep]);
  return /*#__PURE__*/_react["default"].createElement(_Dialog["default"].Base, {
    ref: ref,
    open: open,
    disableSize: true,
    lazyMount: true,
    disableMaskClick: disableMaskClick,
    onClose: onClose,
    onExited: handleExited,
    zIndex: zIndex,
    customDialogContainer: /*#__PURE__*/_react["default"].createElement(_styled.StyledImgPreviewContainer, (0, _extends2["default"])({}, wrapperStyleItem, {
      ref: ref
    }), /*#__PURE__*/_react["default"].createElement(_styled.StyledCloseIconWrapper, (0, _extends2["default"])({
      theme: theme,
      onClick: handleCloseIconClick
    }, innerStyles.closeIconWrapper), /*#__PURE__*/_react["default"].createElement(CloseIcon, {
      color: theme.components.ImgPreview.closeIcon.color
    })), !imgLoadError && /*#__PURE__*/_react["default"].createElement(_styled.StyledImgViewerLayer, (0, _extends2["default"])({}, innerStyles.imgLayer, {
      onClick: handleMaskClick
    }), /*#__PURE__*/_react["default"].createElement(_styled.StyledImgPreview, {
      ref: imgScrollWrapperRef,
      theme: theme
    }, /*#__PURE__*/_react["default"].createElement(_styled.StyledImgContainer, (0, _extends2["default"])({
      theme: theme,
      ref: imgWrapperRef,
      $imgOverflow: imgOverflow,
      $showPagination: showPagination,
      $width: containerSize.width,
      $height: containerSize.height
    }, innerStyles.imgContainer), /*#__PURE__*/_react["default"].createElement(_styled.StyledImgWrapper, innerStyles.imgWrapper, /*#__PURE__*/_react["default"].createElement(_styled.StyledImg, (0, _extends2["default"])({}, restProps, innerStyles.img, {
      ref: imgRef,
      $imgOverflow: imgOverflow,
      $overflowOffset: overflowOffset,
      resizeMode: "lfit",
      suffixWidth: containerSize.width,
      suffixHeight: "auto",
      suffix: suffix,
      wait: "on",
      theme: theme,
      src: imgUrl,
      onMouseDown: handleImgMouseDown,
      onMouseMove: handleImgMouseMove,
      onMouseUp: handleImgMouseUp,
      onClick: handleImgClick,
      onLoaded: handleImgLoaded,
      onError: handleImgError
    }), imgLoaded && renderInImgNode && renderInImgNode(imgUrl))), renderInImgContainer && renderInImgContainer(imgUrl)))), /*#__PURE__*/_react["default"].createElement(_styled.StyledLoadStateLayer, null, /*#__PURE__*/_react["default"].createElement(_Spin["default"], {
      spinning: imgLoading || !!loading,
      color: spinColor,
      desc: loadingText,
      styles: {
        desc: {
          color: spinColor
        }
      }
    }), imgLoadError && !loading && /*#__PURE__*/_react["default"].createElement(_Result["default"], {
      type: "empty",
      subTitle: loadErrorText
    })), !hideActions && !showPagination && imgLoaded && actionsNode, mode === 'multiple' && pageButtonNode, showPagination && paginationNode)
  });
});
var _default = ImgPreview;
exports["default"] = _default;