"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledPaginationImg = exports.StyledPaginationButton = exports.StyledPagination = exports.StyledPageButton = exports.StyledLoadStateLayer = exports.StyledImgWrapper = exports.StyledImgViewerLayer = exports.StyledImgPreviewContainer = exports.StyledImgPreview = exports.StyledImgPaginationWrapper = exports.StyledImgContainer = exports.StyledImgActions = exports.StyledImg = exports.StyledCloseIconWrapper = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Carousel = require("../Carousel");

var _Img = _interopRequireDefault(require("../Img"));

var _styled = require("../ScrollView/styled");

var _styled2 = require("../Result/styled");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledImgWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledImgWrapper"
})(["position:relative;width:100%;height:100%;"]);

exports.StyledImgWrapper = StyledImgWrapper;

var StyledImgContainer = _styledComponents["default"].div.withConfig({
  displayName: "StyledImgContainer"
})(["", ""], function (props) {
  var _props$theme = props.theme,
      _props$theme$transiti = _props$theme.transition.pattern,
      duration = _props$theme$transiti.duration,
      easing = _props$theme$transiti.easing,
      imgWrapperToken = _props$theme.components.ImgPreview.imgWrapper,
      $width = props.$width,
      $height = props.$height,
      $imgOverflow = props.$imgOverflow,
      $showPagination = props.$showPagination;
  var scrollBarSize = $imgOverflow ? imgWrapperToken.scrollBarSize : 0;
  return (0, _styledComponents.css)(["position:relative;margin:auto;width:", "px;height:", "px;margin-top:", "px;transition:height ", "ms ", ";", "{", ";", ";}"], $width + scrollBarSize, $height + scrollBarSize, imgWrapperToken.marginTop, duration.status, easing.status, StyledImgWrapper, $showPagination && 'overflow: auto', (0, _styled.scrollBarStyle)(props));
});

exports.StyledImgContainer = StyledImgContainer;
var StyledImg = (0, _styledComponents["default"])(_Img["default"]).withConfig({
  displayName: "StyledImg"
})(["", ""], function (props) {
  var _props$theme2 = props.theme,
      _props$theme2$transit = _props$theme2.transition.pattern,
      duration = _props$theme2$transit.duration,
      easing = _props$theme2$transit.easing,
      imgWrapperToken = _props$theme2.components.ImgPreview.imgWrapper,
      $imgOverflow = props.$imgOverflow,
      $overflowOffset = props.$overflowOffset;
  return (0, _styledComponents.css)(["position:absolute;left:50%;top:calc(50% - ", "px);transform:translate(-50%,-50%);background-size:contain;transform-origin:center center;transition:all ", "ms ", ";", ""], imgWrapperToken.marginTop / 2, duration.status, easing.status, $imgOverflow && (0, _styledComponents.css)(["top:0;transform:", ";cursor:grab;"], $overflowOffset ? "translate(calc(-50% + ".concat($overflowOffset, "px), 0)") : 'translate(-50%, 0)'));
});
exports.StyledImg = StyledImg;

var StyledImgPreviewContainer = _styledComponents["default"].div.withConfig({
  displayName: "StyledImgPreviewContainer"
})(["position:absolute;top:0;bottom:0;right:0;left:0;box-sizing:border-box;height:100%;overflow:hidden;text-align:center;vertical-align:middle;"]);

exports.StyledImgPreviewContainer = StyledImgPreviewContainer;

var StyledImgViewerLayer = _styledComponents["default"].div.withConfig({
  displayName: "StyledImgViewerLayer"
})(["height:100%;"]);

exports.StyledImgViewerLayer = StyledImgViewerLayer;

var StyledLoadStateLayer = _styledComponents["default"].div.withConfig({
  displayName: "StyledLoadStateLayer"
})(["position:absolute;left:50%;top:50%;transform:translate(-50%,-50%);", " p{color:#fff;}"], _styled2.StyleSubTitle);

exports.StyledLoadStateLayer = StyledLoadStateLayer;

var StyledImgPreview = _styledComponents["default"].div.withConfig({
  displayName: "StyledImgPreview"
})(["width:100%;height:100%;overflow:auto;white-space:nowrap;box-sizing:border-box;", ";"], _styled.scrollBarStyle);

exports.StyledImgPreview = StyledImgPreview;

var StyledImgActions = _styledComponents["default"].div.withConfig({
  displayName: "StyledImgActions"
})(["position:absolute;left:0;right:0;bottom:", "px;margin:auto;z-index:1;"], function (props) {
  return props.theme.components.ImgPreview.imgActions.bottom;
});

exports.StyledImgActions = StyledImgActions;

var StyledCloseIconWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledCloseIconWrapper"
})(["", ""], function (props) {
  var closeIconToken = props.theme.components.ImgPreview.closeIcon;
  return (0, _styledComponents.css)(["position:absolute;right:", "px;top:", "px;font-size:", "px;cursor:pointer;z-index:1;"], closeIconToken.right, closeIconToken.top, closeIconToken.fontSize);
});

exports.StyledCloseIconWrapper = StyledCloseIconWrapper;

var StyledPageButton = _styledComponents["default"].div.withConfig({
  displayName: "StyledPageButton"
})(["", ""], function (props) {
  var theme = props.theme,
      $disabled = props.$disabled,
      $direction = props.$direction,
      $height = props.$height,
      $imgOverflow = props.$imgOverflow;
  var opacity = theme.opacity;
  var _theme$components$Img = theme.components.ImgPreview,
      pageButtonToken = _theme$components$Img.pageButton,
      imgWrapperToken = _theme$components$Img.imgWrapper;
  return (0, _styledComponents.css)(["position:absolute;top:", ";transform:translate(0,-50%);font-size:", "px;color:", ";cursor:pointer;&:hover{opacity:", ";}", " ", ";"], $imgOverflow ? "calc(".concat(imgWrapperToken.marginTop, "px + ").concat($height / 2, "px)") : "calc(".concat(imgWrapperToken.marginTop / 2, "px + ").concat($height / 2, "px)"), pageButtonToken.fontSize, pageButtonToken.color, pageButtonToken.opacity, $disabled && (0, _styledComponents.css)(["opacity:", ";cursor:not-allowed;&:hover{opacity:", ";}"], opacity.pattern.disabled, opacity.pattern.disabled), "".concat($direction, ": ").concat(pageButtonToken.spacing, "px"));
});

exports.StyledPageButton = StyledPageButton;

var StyledImgPaginationWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledImgPaginationWrapper"
})(["position:absolute;left:0;right:0;bottom:0;margin:auto;", ""], function (props) {
  var $width = props.$width,
      theme = props.theme;
  var paginationToken = theme.components.ImgPreview.imgPagination;
  return (0, _styledComponents.css)(["box-sizing:border-box;width:", "px;height:", "px;padding:", "px 0;"], $width, paginationToken.height, paginationToken.paddingVertical);
});

exports.StyledImgPaginationWrapper = StyledImgPaginationWrapper;
var StyledPaginationImg = (0, _styledComponents["default"])(_Img["default"]).withConfig({
  displayName: "StyledPaginationImg"
})(["", ""], function (props) {
  var _props$theme3 = props.theme,
      imgPaginationToken = _props$theme3.components.ImgPreview.imgPagination,
      _props$theme3$transit = _props$theme3.transition.pattern,
      duration = _props$theme3$transit.duration,
      easing = _props$theme3$transit.easing,
      $selected = props.$selected,
      $width = props.$width;
  return (0, _styledComponents.css)(["position:relative;width:", "px;height:", "px;margin-right:", "px;cursor:pointer;opacity:", ";transition:opacity ", "ms ", ";&::after{position:absolute;left:0;right:0;top:0;bottom:0;content:'';}", ""], $width ? $width : imgPaginationToken.itemWidth, imgPaginationToken.itemHeight, imgPaginationToken.itemMrginRight, imgPaginationToken.itemOpacity, duration.status, easing.status, $selected && (0, _styledComponents.css)(["opacity:1;&::after{border:", "px solid ", ";transition:border ", "ms ", ";}"], imgPaginationToken.itemActiveBorderSize, imgPaginationToken.borderActiveColor, duration.status, easing.status));
});
exports.StyledPaginationImg = StyledPaginationImg;
var StyledPaginationButton = (0, _styledComponents["default"])(_Carousel.PagerButton).withConfig({
  displayName: "StyledPaginationButton"
})(["", ""], function (props) {
  var imgPaginationToken = props.theme.components.ImgPreview.imgPagination,
      arrow = props.arrow;
  return (0, _styledComponents.css)(["position:absolute;top:50%;transform:translate(0,-50%);width:", "px;height:", "px;font-size:", "px;", ";"], imgPaginationToken.buttonWidth, imgPaginationToken.buttonHeight, imgPaginationToken.buttonFontSize, "".concat(arrow, ": ").concat(imgPaginationToken.buttonOffset, "px"));
});
exports.StyledPaginationButton = StyledPaginationButton;

var StyledPagination = _styledComponents["default"].div.withConfig({
  displayName: "StyledPagination"
})(["display:flex;"]);

exports.StyledPagination = StyledPagination;