"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getValidDefaultIndex = exports.getContainerSize = void 0;

var _devWarning2 = require("@muya-ui/utils/lib/utils/devWarning");

var getValidDefaultIndex = function getValidDefaultIndex(index, size) {
  if (size === 0) {
    return 0;
  }

  if (index < 0) {
    (0, _devWarning2.devWarning)('[ImgPreview]: defaultIndex must greater than or equal to 0');
    return 0;
  }

  if (index >= size) {
    (0, _devWarning2.devWarning)("[ImgPreview]: defaultIndex must Less than ".concat(size));
    return index % size;
  }

  return index;
};

exports.getValidDefaultIndex = getValidDefaultIndex;

var getContainerSize = function getContainerSize(width, occupyHeight) {
  return {
    width: width,
    height: window.innerHeight - occupyHeight
  };
};

exports.getContainerSize = getContainerSize;