"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ClearIcon2 = require("@muya-ui/theme-light/lib/icons/ClearIcon");

var _SuccessIcon2 = require("@muya-ui/theme-light/lib/icons/SuccessIcon");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _endsWith2 = _interopRequireDefault(require("lodash/endsWith"));

var _react = _interopRequireWildcard(require("react"));

var _Spin = _interopRequireDefault(require("../Spin"));

var _ClearIconWrapper = _interopRequireDefault(require("../styled/components/ClearIconWrapper"));

var _addPx = _interopRequireDefault(require("../utils/addPx"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _mergeStyleItem = _interopRequireDefault(require("../utils/mergeStyleItem"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _TextLimit = _interopRequireDefault(require("./TextLimit"));

var _useInput2 = _interopRequireDefault(require("./useInput"));

var _excluded = ["size", "disabled", "status", "allowClear", "clearReplace", "limit", "prefixNode", "suffixNode", "width", "height", "onMouseEnter", "onMouseLeave", "className", "style", "inputRef", "replacedInputNode", "multiline", "autosize", "minRows", "maxRows", "defaultValue", "value", "autoFocus", "onClear", "onFocus", "onBlur", "onClick", "onChange", "onPressEnter", "onKeyDown", "hasFeedback", "hasRelatedValue", "focusWhenClear", "styles", "clearIcon", "bordered", "formatter", "parser"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  inputWrapper: '',
  textareaWrapper: '',
  statusWrapper: '',
  clearWrapper: '',
  textarea: '',
  textLimitWrapper: '',
  textLimit: '',
  nodeWrapper: '',
  nodeDivider: '',
  input: ''
};
var Input = (0, _memoForwardRef["default"])(function Input(props, ref) {
  var _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      status = props.status,
      allowClear = props.allowClear,
      clearReplace = props.clearReplace,
      _props$limit = props.limit,
      limit = _props$limit === void 0 ? 0 : _props$limit,
      prefixNode = props.prefixNode,
      suffixNode = props.suffixNode,
      width = props.width,
      height = props.height,
      onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave,
      className = props.className,
      style = props.style,
      inputRef = props.inputRef,
      replacedInputNode = props.replacedInputNode,
      multiline = props.multiline,
      autosize = props.autosize,
      minRows = props.minRows,
      maxRows = props.maxRows,
      defaultValue = props.defaultValue,
      value = props.value,
      autoFocus = props.autoFocus,
      onClear = props.onClear,
      onFocus = props.onFocus,
      onBlur = props.onBlur,
      onClick = props.onClick,
      onChange = props.onChange,
      onPressEnter = props.onPressEnter,
      onKeyDown = props.onKeyDown,
      _props$hasFeedback = props.hasFeedback,
      hasFeedback = _props$hasFeedback === void 0 ? true : _props$hasFeedback,
      hasRelatedValue = props.hasRelatedValue,
      _props$focusWhenClear = props.focusWhenClear,
      focusWhenClear = _props$focusWhenClear === void 0 ? true : _props$focusWhenClear,
      styles = props.styles,
      customClearIcon = props.clearIcon,
      _props$bordered = props.bordered,
      bordered = _props$bordered === void 0 ? true : _props$bordered,
      formatter = props.formatter,
      parser = props.parser,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var innerStyles = (0, _useStyles["default"])('input', defaultStyles, styles);
  var inputWrapperStyleItem = (0, _react.useMemo)(function () {
    return (0, _mergeStyleItem["default"])({
      className: className,
      style: style
    }, innerStyles.inputWrapper);
  }, [className, innerStyles.inputWrapper, style]);
  var textareaWrapperStyleItem = (0, _react.useMemo)(function () {
    return (0, _mergeStyleItem["default"])({
      className: className,
      style: style
    }, innerStyles.textareaWrapper);
  }, [className, innerStyles.textareaWrapper, style]); // 受控模式使用内部state

  var isControlled = ('value' in props);

  var _useInput = (0, _useInput2["default"])({
    defaultValue: defaultValue,
    value: value,
    autoFocus: autoFocus,
    disabled: disabled,
    formatter: formatter,
    parser: parser,
    onClear: onClear,
    onChange: onChange,
    onClick: onClick,
    onFocus: onFocus,
    onBlur: onBlur,
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave,
    onKeyDown: onKeyDown,
    onPressEnter: onPressEnter,
    focusWhenClear: focusWhenClear,
    inputRef: inputRef,
    autosize: autosize,
    multiline: multiline,
    minRows: minRows,
    maxRows: maxRows
  }, isControlled),
      finalValue = _useInput.finalValue,
      handleInputRef = _useInput.handleInputRef,
      handleClick = _useInput.handleClick,
      handleChange = _useInput.handleChange,
      handleClear = _useInput.handleClear,
      focus = _useInput.focus,
      entered = _useInput.entered,
      handleFocus = _useInput.handleFocus,
      handleBlur = _useInput.handleBlur,
      handleMouseEnter = _useInput.handleMouseEnter,
      handleMouseLeave = _useInput.handleMouseLeave,
      handleKeyDown = _useInput.handleKeyDown,
      autosizeStyles = _useInput.autosizeStyles;

  var textareaStyleItem = (0, _react.useMemo)(function () {
    return (0, _mergeStyleItem["default"])({
      style: autosize ? autosizeStyles : {}
    }, innerStyles.textarea);
  }, [autosize, autosizeStyles, innerStyles.textarea]);
  var exceedLimit = limit > 0 && (0, _get2["default"])(finalValue, 'length', 0) > limit; // 文字超出limit

  var hasError = exceedLimit || status === 'error';
  var innerSuffixNodeList = (0, _react.useMemo)(function () {
    var innerSuffixNode = [];

    _react.Children.forEach(suffixNode, function (child) {
      innerSuffixNode.push(child);
    }); // 字数限制


    if (limit) {
      innerSuffixNode.unshift( /*#__PURE__*/_react["default"].createElement(_TextLimit["default"], {
        value: finalValue,
        limit: limit
      }));
    } // 状态反馈


    if (status && hasFeedback) {
      if (status === 'loading') {
        innerSuffixNode.unshift( /*#__PURE__*/_react["default"].createElement(_styled.StyledStatusWrapper, (0, _extends2["default"])({
          theme: theme,
          status: status,
          key: "status"
        }, innerStyles.statusWrapper), /*#__PURE__*/_react["default"].createElement(_Spin["default"], null)));
      } else {
        var statusIcon = (0, _extends2["default"])({
          success: _SuccessIcon2.SuccessIcon,
          error: _ClearIcon2.ClearIcon
        }, theme.components.Input.statusIcon);
        var StatusIcon = statusIcon[status];
        innerSuffixNode.unshift( /*#__PURE__*/_react["default"].createElement(_styled.StyledStatusWrapper, (0, _extends2["default"])({
          theme: theme,
          status: status,
          key: "status"
        }, innerStyles.statusWrapper), /*#__PURE__*/_react["default"].createElement(StatusIcon, null)));
      }
    } // 清除输入框功能


    if (allowClear && (finalValue || hasRelatedValue || replacedInputNode) && entered && !disabled) {
      var token = theme.components.Input;
      var ClearIcon = token.clearIcon || _ClearIcon2.ClearIcon;
      var fontSize = theme.typography.spec.fontSize;

      var clearNode = /*#__PURE__*/_react["default"].createElement(_ClearIconWrapper["default"], (0, _extends2["default"])({
        key: "clear",
        $fontSize: fontSize[token.fontLevel[size]],
        onClick: handleClear
      }, innerStyles.clearWrapper), customClearIcon || /*#__PURE__*/_react["default"].createElement(ClearIcon, null));

      if (clearReplace) {
        innerSuffixNode.shift();
      }

      innerSuffixNode.unshift(clearNode);
    }

    return innerSuffixNode;
  }, [allowClear, clearReplace, customClearIcon, disabled, entered, finalValue, handleClear, hasFeedback, hasRelatedValue, innerStyles.clearWrapper, innerStyles.statusWrapper, limit, replacedInputNode, size, status, suffixNode, theme]);
  var finalChildren = (0, _react.useMemo)(function () {
    if (multiline) {
      return /*#__PURE__*/_react["default"].createElement(_styled.StyledTextareaWrapper, (0, _extends2["default"])({
        theme: theme,
        disabled: disabled,
        hasError: hasError,
        focus: focus,
        $width: (0, _addPx["default"])(width),
        $bordered: bordered,
        size: size,
        onClick: handleClick,
        ref: ref
      }, textareaWrapperStyleItem), /*#__PURE__*/_react["default"].createElement(_styled.StyledTextarea, (0, _extends2["default"])({
        ref: handleInputRef,
        value: finalValue,
        disabled: disabled,
        theme: theme,
        $bordered: bordered,
        $width: typeof width === 'string' && (0, _endsWith2["default"])(width, '%') ? '100%' : (0, _addPx["default"])(width),
        onFocus: handleFocus,
        onBlur: handleBlur,
        onChange: handleChange,
        limit: limit,
        size: size,
        autoFocus: autoFocus,
        onKeyDown: handleKeyDown,
        autosize: autosize,
        $height: (0, _addPx["default"])(height)
      }, textareaStyleItem, other)), /*#__PURE__*/_react["default"].createElement(_styled.StyledTextareaLimitWrapper, (0, _extends2["default"])({
        theme: theme,
        size: size
      }, innerStyles.textLimitWrapper), /*#__PURE__*/_react["default"].createElement(_TextLimit["default"], (0, _extends2["default"])({
        value: finalValue,
        limit: limit
      }, innerStyles.textLimit))));
    }

    return /*#__PURE__*/_react["default"].createElement(_styled.StyledInputWrapper, (0, _extends2["default"])({
      theme: theme,
      disabled: disabled,
      hasError: hasError,
      focus: focus,
      $bordered: bordered,
      $width: (0, _addPx["default"])(width),
      $height: (0, _addPx["default"])(height),
      size: size,
      onClick: handleClick,
      onMouseEnter: handleMouseEnter,
      onMouseLeave: handleMouseLeave,
      ref: ref
    }, inputWrapperStyleItem), /*#__PURE__*/_react["default"].createElement(_styled.ExtraNodes, {
      $type: "prefix",
      theme: theme,
      size: size,
      nodes: prefixNode,
      $nodeStyleItem: innerStyles.nodeWrapper,
      $dividerStyleItem: innerStyles.nodeDivider,
      $disabled: disabled
    }), replacedInputNode ? replacedInputNode : /*#__PURE__*/_react["default"].createElement(_styled.StyledInput, (0, _extends2["default"])({
      ref: handleInputRef,
      value: finalValue,
      disabled: disabled,
      theme: theme,
      size: size,
      onFocus: handleFocus,
      onBlur: handleBlur,
      onChange: handleChange,
      onKeyDown: handleKeyDown,
      autoFocus: autoFocus
    }, innerStyles.input, other)), /*#__PURE__*/_react["default"].createElement(_styled.ExtraNodes, {
      $type: "suffix",
      theme: theme,
      size: size,
      nodes: innerSuffixNodeList,
      $nodeStyleItem: innerStyles.nodeWrapper,
      $dividerStyleItem: innerStyles.nodeDivider,
      $disabled: disabled
    }));
  }, [autoFocus, autosize, bordered, disabled, finalValue, focus, handleBlur, handleChange, handleClick, handleFocus, handleInputRef, handleKeyDown, handleMouseEnter, handleMouseLeave, hasError, height, innerStyles.input, innerStyles.nodeDivider, innerStyles.nodeWrapper, innerStyles.textLimit, innerStyles.textLimitWrapper, innerSuffixNodeList, inputWrapperStyleItem, limit, multiline, other, prefixNode, ref, replacedInputNode, size, textareaStyleItem, textareaWrapperStyleItem, theme, width]);
  return finalChildren;
});
Input.__MUYA_INPUT = true;
var _default = Input;
exports["default"] = _default;