"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _ClearIcon2 = require("@muya-ui/theme-light/lib/icons/ClearIcon");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _ClearIconWrapper = _interopRequireDefault(require("../styled/components/ClearIconWrapper"));

var _addPx = _interopRequireDefault(require("../utils/addPx"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _mergeStyleItem = _interopRequireDefault(require("../utils/mergeStyleItem"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _useRangeInput2 = _interopRequireDefault(require("./useRangeInput"));

var _excluded = ["size", "disabled", "readOnly", "status", "prefixNode", "suffixNode", "middleNode", "allowClear", "clearReplace", "width", "height", "onMouseEnter", "onMouseLeave", "className", "style", "styles", "value", "defaultValue", "placeholder", "autoFocus", "onFocus", "onBlur", "onClear", "onClick", "onChange", "onKeyDown", "onPressEnter", "hasRelatedValue", "focusWhenClear", "inputProps", "clearIcon", "bordered"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  inputWrapper: '',
  headInput: '',
  tailInput: '',
  clearWrapper: '',
  nodeWrapper: '',
  nodeDivider: ''
};
var RangeInput = (0, _memoForwardRef["default"])(function (props, ref) {
  var _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      readOnly = props.readOnly,
      status = props.status,
      prefixNode = props.prefixNode,
      suffixNode = props.suffixNode,
      middleNode = props.middleNode,
      allowClear = props.allowClear,
      clearReplace = props.clearReplace,
      width = props.width,
      height = props.height,
      onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave,
      className = props.className,
      style = props.style,
      styles = props.styles,
      value = props.value,
      defaultValue = props.defaultValue,
      _props$placeholder = props.placeholder,
      placeholder = _props$placeholder === void 0 ? [] : _props$placeholder,
      _props$autoFocus = props.autoFocus,
      autoFocus = _props$autoFocus === void 0 ? false : _props$autoFocus,
      onFocus = props.onFocus,
      onBlur = props.onBlur,
      onClear = props.onClear,
      onClick = props.onClick,
      onChange = props.onChange,
      onKeyDown = props.onKeyDown,
      onPressEnter = props.onPressEnter,
      hasRelatedValue = props.hasRelatedValue,
      _props$focusWhenClear = props.focusWhenClear,
      focusWhenClear = _props$focusWhenClear === void 0 ? true : _props$focusWhenClear,
      inputProps = props.inputProps,
      customClearIcon = props.clearIcon,
      _props$bordered = props.bordered,
      bordered = _props$bordered === void 0 ? true : _props$bordered,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var innerStyles = (0, _useStyles["default"])('range-input', defaultStyles, styles);
  var inputWrapperStyleItem = (0, _react.useMemo)(function () {
    return (0, _mergeStyleItem["default"])({
      className: className,
      style: style
    }, innerStyles.inputWrapper);
  }, [className, innerStyles.inputWrapper, style]);

  var _useRangeInput = (0, _useRangeInput2["default"])(props),
      finalValue = _useRangeInput.finalValue,
      focus = _useRangeInput.focus,
      entered = _useRangeInput.entered,
      leftInputRef = _useRangeInput.leftInputRef,
      rightInputRef = _useRangeInput.rightInputRef,
      handleLeftFocus = _useRangeInput.handleLeftFocus,
      handleRightFocus = _useRangeInput.handleRightFocus,
      handleBlur = _useRangeInput.handleBlur,
      handleClick = _useRangeInput.handleClick,
      handleLeftChange = _useRangeInput.handleLeftChange,
      handleRightChange = _useRangeInput.handleRightChange,
      handleClear = _useRangeInput.handleClear,
      handleMouseEnter = _useRangeInput.handleMouseEnter,
      handleMouseLeave = _useRangeInput.handleMouseLeave,
      handleKeyDown = _useRangeInput.handleKeyDown;

  var innerRef = (0, _react.useRef)(null);
  var more = (0, _react.useRef)({
    focus: function focus() {
      var position = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var option = arguments.length > 1 ? arguments[1] : undefined;

      if (position === 1) {
        rightInputRef.current.focus(option);
      } else {
        leftInputRef.current.focus(option);
      }
    },
    blur: function blur() {
      var position = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;

      if (position === 1) {
        rightInputRef.current.blur();
      } else {
        leftInputRef.current.blur();
      }
    }
  });
  var handleRef = (0, _useForkRef2.useForkRef)(ref, innerRef, more.current);
  var innerSuffixNode = [];

  _react.Children.forEach(suffixNode, function (child) {
    innerSuffixNode.push(child);
  });

  var _finalValue = (0, _slicedToArray2["default"])(finalValue, 2),
      leftValue = _finalValue[0],
      rightValue = _finalValue[1]; // 清除输入框功能


  if (allowClear && (leftValue || rightValue || hasRelatedValue) && entered && !disabled) {
    var fontSize = theme.typography.spec.fontSize,
        token = theme.components.Input;
    var ClearIcon = token.clearIcon || _ClearIcon2.ClearIcon;

    var clearNode = /*#__PURE__*/_react["default"].createElement(_ClearIconWrapper["default"], (0, _extends2["default"])({
      key: "clear",
      $fontSize: fontSize[token.fontLevel[size]],
      onClick: handleClear
    }, innerStyles.clearWrapper), customClearIcon || /*#__PURE__*/_react["default"].createElement(ClearIcon, null));

    if (clearReplace) {
      innerSuffixNode.shift();
    }

    innerSuffixNode.unshift(clearNode);
  }

  var inputWidth = width !== undefined ? width : theme.components.Input.rangeInputWidth[size];
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledInputWrapper, (0, _extends2["default"])({
    theme: theme,
    disabled: disabled,
    focus: focus,
    $bordered: bordered,
    $width: (0, _addPx["default"])(inputWidth),
    $height: (0, _addPx["default"])(height),
    size: size,
    onClick: handleClick,
    onMouseEnter: handleMouseEnter,
    onMouseLeave: handleMouseLeave,
    hasError: status === 'error',
    ref: handleRef
  }, inputWrapperStyleItem, other), /*#__PURE__*/_react["default"].createElement(_styled.ExtraNodes, {
    $type: "prefix",
    theme: theme,
    size: size,
    nodes: prefixNode,
    $nodeStyleItem: innerStyles.nodeWrapper,
    $dividerStyleItem: innerStyles.nodeDivider,
    $disabled: disabled
  }), /*#__PURE__*/_react["default"].createElement(_styled.StyledInput, (0, _extends2["default"])({
    value: leftValue,
    disabled: disabled,
    theme: theme,
    onFocus: handleLeftFocus,
    onBlur: handleBlur,
    onChange: handleLeftChange,
    onKeyDown: handleKeyDown,
    autoFocus: autoFocus,
    placeholder: placeholder[0],
    size: size,
    ref: leftInputRef,
    readOnly: readOnly
  }, inputProps)), /*#__PURE__*/_react["default"].createElement(_styled.ExtraNodes, {
    $type: "suffix",
    theme: theme,
    size: size,
    nodes: middleNode,
    full: true,
    $nodeStyleItem: innerStyles.nodeWrapper,
    $dividerStyleItem: innerStyles.nodeDivider,
    $disabled: disabled
  }), /*#__PURE__*/_react["default"].createElement(_styled.StyledInput, (0, _extends2["default"])({
    value: rightValue,
    disabled: disabled,
    theme: theme,
    onFocus: handleRightFocus,
    onBlur: handleBlur,
    onChange: handleRightChange,
    onKeyDown: handleKeyDown,
    autoFocus: autoFocus,
    size: size,
    placeholder: placeholder[1],
    ref: rightInputRef,
    readOnly: readOnly
  }, inputProps)), /*#__PURE__*/_react["default"].createElement(_styled.ExtraNodes, {
    $type: "suffix",
    theme: theme,
    size: size,
    nodes: innerSuffixNode,
    $nodeStyleItem: innerStyles.nodeWrapper,
    $dividerStyleItem: innerStyles.nodeDivider,
    $disabled: disabled
  }));
});
RangeInput.__MUYA_RANGEINPUT = true;
var _default = RangeInput;
exports["default"] = _default;