"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _ClearIcon2 = require("@muya-ui/theme-light/lib/icons/ClearIcon");

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _omit2 = _interopRequireDefault(require("lodash/omit"));

var _react = _interopRequireWildcard(require("react"));

var _ClearIconWrapper = _interopRequireDefault(require("../styled/components/ClearIconWrapper"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _mergeStyleItem = _interopRequireDefault(require("../utils/mergeStyleItem"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _InputTag = _interopRequireDefault(require("./InputTag"));

var _styled = require("./styled");

var _useTagsInput2 = _interopRequireWildcard(require("./useTagsInput"));

var _excluded = ["size", "width", "disabled", "readOnly", "allowClear", "hasRelatedValue", "autoFocus", "scrollTopAfterEffect", "maxTagWidth", "maxVerticalTagCount", "disabledValue", "readOnlyValue", "suffixNode", "clearIcon", "className", "style", "styles", "inputRef", "status", "getTagText", "renderTag", "horizontalScroll", "inputReadOnly", "bordered"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var noop = function noop() {};

var defaultGetTagText = function defaultGetTagText(value) {
  return value && (0, _typeof2["default"])(value) === 'object' ? value.label || value.value : value;
};

var defaultStyles = {
  inputWrapper: '',
  contentWrapper: '',
  tagsWrapper: '',
  input: '',
  tag: ''
};
var TagsInput = (0, _memoForwardRef["default"])(function (props, ref) {
  var _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      width = props.width,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      _props$readOnly = props.readOnly,
      readOnly = _props$readOnly === void 0 ? false : _props$readOnly,
      _props$allowClear = props.allowClear,
      allowClear = _props$allowClear === void 0 ? false : _props$allowClear,
      hasRelatedValue = props.hasRelatedValue,
      _props$autoFocus = props.autoFocus,
      autoFocus = _props$autoFocus === void 0 ? false : _props$autoFocus,
      _props$scrollTopAfter = props.scrollTopAfterEffect,
      scrollTopAfterEffect = _props$scrollTopAfter === void 0 ? false : _props$scrollTopAfter,
      maxTagWidth = props.maxTagWidth,
      _props$maxVerticalTag = props.maxVerticalTagCount,
      maxVerticalTagCount = _props$maxVerticalTag === void 0 ? 2.5 : _props$maxVerticalTag,
      _props$disabledValue = props.disabledValue,
      disabledValue = _props$disabledValue === void 0 ? [] : _props$disabledValue,
      _props$readOnlyValue = props.readOnlyValue,
      readOnlyValue = _props$readOnlyValue === void 0 ? [] : _props$readOnlyValue,
      suffixNode = props.suffixNode,
      clearIcon = props.clearIcon,
      className = props.className,
      style = props.style,
      styles = props.styles,
      inputRef = props.inputRef,
      status = props.status,
      _props$getTagText = props.getTagText,
      getTagText = _props$getTagText === void 0 ? defaultGetTagText : _props$getTagText,
      renderTag = props.renderTag,
      _props$horizontalScro = props.horizontalScroll,
      horizontalScroll = _props$horizontalScro === void 0 ? false : _props$horizontalScro,
      _props$inputReadOnly = props.inputReadOnly,
      inputReadOnly = _props$inputReadOnly === void 0 ? false : _props$inputReadOnly,
      _props$bordered = props.bordered,
      bordered = _props$bordered === void 0 ? true : _props$bordered,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var innerStyles = (0, _useStyles["default"])('tags-input', defaultStyles, styles);
  var inputWrapperStyleItem = (0, _react.useMemo)(function () {
    return (0, _mergeStyleItem["default"])({
      className: className,
      style: style
    }, innerStyles.inputWrapper);
  }, [className, innerStyles.inputWrapper, style]);
  var fontSize = theme.typography.spec.fontSize,
      token = theme.components.Input;
  var sizerRef = (0, _react.useRef)(null);
  var contentRef = (0, _react.useRef)(null);
  var innerInputRef = (0, _react.useRef)(null);
  var handleInputRef = (0, _useForkRef2.useForkRef)(inputRef, innerInputRef);

  var _useTagsInput = (0, _useTagsInput2["default"])(props, contentRef, sizerRef, innerInputRef),
      focus = _useTagsInput.focus,
      entered = _useTagsInput.entered,
      value = _useTagsInput.value,
      inputValue = _useTagsInput.inputValue,
      placeholder = _useTagsInput.placeholder,
      hasValue = _useTagsInput.hasValue,
      hasError = _useTagsInput.hasError,
      handleFocus = _useTagsInput.handleFocus,
      handleBlur = _useTagsInput.handleBlur,
      handleMouseEnter = _useTagsInput.handleMouseEnter,
      handleMouseLeave = _useTagsInput.handleMouseLeave,
      handleClick = _useTagsInput.handleClick,
      handleClear = _useTagsInput.handleClear,
      handleRemoveTag = _useTagsInput.handleRemoveTag,
      handleInputKeyDown = _useTagsInput.handleInputKeyDown,
      handleInput = _useTagsInput.handleInput;

  var renderSuffixNode = function renderSuffixNode() {
    var clearNode = null;

    if (allowClear && (hasValue || hasRelatedValue) && !disabled && entered) {
      var SuffixIcon = token.clearIcon || _ClearIcon2.ClearIcon;
      clearNode = /*#__PURE__*/_react["default"].createElement(_ClearIconWrapper["default"], {
        key: "clear",
        $fontSize: fontSize[token.fontLevel[size]],
        onClick: handleClear
      }, clearIcon || /*#__PURE__*/_react["default"].createElement(SuffixIcon, null));
    }

    if (clearNode) {
      return /*#__PURE__*/_react["default"].createElement(_styled.StyledTagsInputSuffixNodeWrapper, null, clearNode);
    }

    if (suffixNode) {
      return /*#__PURE__*/_react["default"].createElement(_styled.StyledTagsInputSuffixNodeWrapper, null, suffixNode);
    }
  };

  var inputProps = (0, _omit2["default"])(restProps, ['value', 'defaultValue', 'placeholder', 'inputValue', 'allowInput', 'focusWhenClear', 'defaultInputValue', 'onAddTag', 'onRemoveTag', 'onFocus', 'onBlur', 'onInputKeyDown', 'onKeyDown', 'onClear', 'onInput', 'onInputChange', 'onClick', 'onMouseEnter', 'onMouseLeave']);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledTagsInputWrapper, (0, _extends2["default"])({
    theme: theme,
    ref: ref,
    $disabled: disabled,
    $focus: focus,
    $width: width,
    $maxTagWidth: maxTagWidth,
    $maxVerticalTagCount: maxVerticalTagCount,
    $size: size,
    $hasValue: hasValue,
    $hasError: hasError,
    $horizontalScroll: horizontalScroll,
    $bordered: bordered,
    onClick: handleClick,
    onMouseEnter: handleMouseEnter,
    onMouseLeave: handleMouseLeave
  }, inputWrapperStyleItem), /*#__PURE__*/_react["default"].createElement(_styled.StyledTagsInputContentWrapper, (0, _extends2["default"])({}, innerStyles.contentWrapper, {
    ref: contentRef
  }), /*#__PURE__*/_react["default"].createElement(_styled.StyledTagsWrapper, innerStyles.tagsWrapper, value.map(function (value, index) {
    var tagDisabled = disabled || (0, _useTagsInput2.isTagDisabled)(disabledValue, value);
    var tagReadOnly = readOnly || (0, _useTagsInput2.isTagDisabled)(readOnlyValue, value);
    var tagProps = {
      size: size,
      onClose: function onClose(e) {
        return handleRemoveTag(index, e);
      },
      closable: !tagDisabled && !tagReadOnly,
      disabled: tagDisabled,
      readOnly: tagReadOnly
    };

    if (typeof renderTag === 'function') {
      return renderTag((0, _extends2["default"])({
        value: value,
        tagText: getTagText(value)
      }, tagProps, innerStyles.tag));
    }

    return /*#__PURE__*/_react["default"].createElement(_InputTag["default"], (0, _extends2["default"])({
      key: value && (0, _typeof2["default"])(value) === 'object' ? value.value : value,
      theme: theme,
      shape: "rect"
    }, tagProps, innerStyles.tag), getTagText(value));
  }), /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_styled.StyledTagsInput, (0, _extends2["default"])({}, inputProps, {
    ref: handleInputRef,
    type: "text",
    placeholder: placeholder,
    value: inputValue,
    onChange: noop,
    onFocus: handleFocus,
    onBlur: handleBlur,
    onInput: handleInput,
    onKeyDown: handleInputKeyDown,
    autoFocus: autoFocus,
    disabled: disabled,
    readOnly: readOnly || inputReadOnly
  }, innerStyles.input)), /*#__PURE__*/_react["default"].createElement(_styled.StyledInputSizer, {
    ref: sizerRef
  }, inputValue || placeholder)))), renderSuffixNode());
});
TagsInput.__MUYA_TAGSINPUT = true;
var _default = TagsInput;
exports["default"] = _default;