"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.LimitWrapper = exports.LimitDanerWrapper = void 0;

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var LimitWrapper = _styledComponents["default"].span.withConfig({
  displayName: "LimitWrapper"
})(["font-weight:", ";color:", ";cursor:default;"], function (props) {
  return props.theme.typography.spec.fontWeight.semibold;
}, function (props) {
  return props.theme.colors.pattern.text.darktip;
});

exports.LimitWrapper = LimitWrapper;
var LimitDanerWrapper = (0, _styledComponents["default"])(LimitWrapper).withConfig({
  displayName: "LimitDanerWrapper"
})(["color:", ";"], function (props) {
  return props.theme.colors.pattern.feature.error;
});
exports.LimitDanerWrapper = LimitDanerWrapper;

var _default = (0, _memoForwardRef["default"])(function (props, ref) {
  var limit = props.limit,
      _props$value = props.value,
      value = _props$value === void 0 ? '' : _props$value;
  var theme = (0, _useTheme["default"])();
  if (!(limit && limit > 0)) return null;
  var length = (0, _get2["default"])(value, 'length', 0);
  return /*#__PURE__*/_react["default"].createElement(LimitWrapper, {
    ref: ref,
    theme: theme
  }, length > limit ? /*#__PURE__*/_react["default"].createElement(LimitDanerWrapper, {
    theme: theme
  }, length) : length, "/", limit);
});

exports["default"] = _default;