"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useInputBase;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = require("react");

var _forkHandler = _interopRequireDefault(require("../utils/forkHandler"));

function useInputBase(props) {
  var autoFocus = props.autoFocus,
      disabled = props.disabled,
      onFocus = props.onFocus,
      onBlur = props.onBlur,
      onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave;

  var _useState = (0, _react.useState)(autoFocus),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      focus = _useState2[0],
      setFocus = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      entered = _useState4[0],
      setEntered = _useState4[1];

  var beforeCheck = (0, _react.useCallback)(function (e) {
    // Fix a bug with IE 11 where the focus/blur events are triggered
    // while the input is disabled.
    if (disabled) {
      e.stopPropagation();
      return false;
    }

    return true;
  }, [disabled]);
  var handleFocus = (0, _react.useMemo)(function () {
    return (0, _forkHandler["default"])(function () {
      setFocus(true);
    }, onFocus, beforeCheck);
  }, [beforeCheck, onFocus]);
  var handleBlur = (0, _react.useMemo)(function () {
    return (0, _forkHandler["default"])(function () {
      setFocus(false);
    }, onBlur, beforeCheck);
  }, [beforeCheck, onBlur]);
  var handleMouseEnter = (0, _react.useMemo)(function () {
    return (0, _forkHandler["default"])(function () {
      setEntered(true);
    }, onMouseEnter);
  }, [onMouseEnter]);
  var handleMouseLeave = (0, _react.useMemo)(function () {
    return (0, _forkHandler["default"])(function () {
      setEntered(false);
    }, onMouseLeave);
  }, [onMouseLeave]);
  return {
    focus: focus,
    entered: entered,
    handleFocus: handleFocus,
    handleBlur: handleBlur,
    handleMouseEnter: handleMouseEnter,
    handleMouseLeave: handleMouseLeave
  };
}