"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _styled = require("../Input/styled");

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _excluded = ["children", "size", "disabled"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ZIndexHoc(props) {
  var children = props.children,
      size = props.size;
  var childProps = children.props;
  var childType = children.type;

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      focus = _useState2[0],
      setFocus = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      popupVisible = _useState4[0],
      setPopupVisible = _useState4[1];

  var theme = (0, _useTheme["default"])();
  var handleFocus = (0, _react.useCallback)(function (e) {
    if (childProps.onFocus) {
      childProps.onFocus(e);
    }

    setFocus(true);
  }, [childProps]);
  var handleBlur = (0, _react.useCallback)(function (e) {
    if (childProps.onBlur) {
      childProps.onBlur(e);
    }

    setFocus(false);
  }, [childProps]);
  var handlePopupVisibleChange = (0, _react.useCallback)(function (open) {
    if (childProps.onPopupVisibleChange) {
      childProps.onPopupVisibleChange(open);
    }

    setPopupVisible(open);
  }, [childProps]); // 组件处于focus或者popupVisible状态，提升zIndex层级

  var shouldAddZIndex = focus || popupVisible;
  var childStyle = (0, _react.useMemo)(function () {
    return {
      zIndex: shouldAddZIndex ? 1 : undefined
    };
  }, [shouldAddZIndex]);
  var finalChildProps = (0, _react.useMemo)(function () {
    return {
      onFocus: handleFocus,
      onBlur: handleBlur,
      size: childProps.size || size
    };
  }, [childProps.size, handleBlur, handleFocus, size]); // 只针对Select相关组件添加此事件，否则会出现warning
  // Select相关组件blur后实际上还处于聚焦状态，需要特殊处理保证zIndex正确

  if (childType.__MUYA_TREESELECT || childType.__MUYA_SELECT || childType.__MUYA_CASCADER || childType.__MUYA_AUTOCOMPLETE) {
    finalChildProps.onPopupVisibleChange = handlePopupVisibleChange;
  } // 设置plain为true，即为线性按钮，带有border
  // type为normal的情况下，默认也是为线性按钮


  var isPlainButton = !theme.components.Button.plainIsLight && (childProps.plain || !childProps.type || childProps.type === 'normal') || childProps.outline; // 非线性按钮，不需要向右移动

  if (childType.__MUYA_BUTTON && !isPlainButton) {
    childStyle.marginRight = 0;
  }

  finalChildProps.style = (0, _extends2["default"])({}, childStyle, childProps.style);
  return /*#__PURE__*/_react["default"].cloneElement(children, finalChildProps);
}

var StyledInputGroup = _styledComponents["default"].div.withConfig({
  displayName: "StyledInputGroup"
})(["", ""], function (props) {
  var compactStyle = props.disabled ? undefined : (0, _styledComponents.css)(["& > *{position:relative;float:none;vertical-align:top;&:focus{z-index:1;}&:not(:first-child):not(:last-child){&,& ", ",& ", "{border-radius:0;}}&:first-child{&,& ", ",& ", "{border-top-right-radius:0;border-bottom-right-radius:0;}}&:last-child{&,& ", ",& ", "{border-top-left-radius:0;border-bottom-left-radius:0;}}&:not(:last-child){margin-right:-1px;border-right-width:1px;}}"], _styled.StyledInputWrapper, _styled.StyledTagsInputWrapper, _styled.StyledInputWrapper, _styled.StyledTagsInputWrapper, _styled.StyledInputWrapper, _styled.StyledTagsInputWrapper);
  return (0, _styledComponents.css)(["position:relative;display:block;width:100%;", ""], compactStyle);
});

var InputGroup = /*#__PURE__*/_react["default"].memo(function (props) {
  var children = props.children,
      size = props.size,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  return /*#__PURE__*/_react["default"].createElement(StyledInputGroup, (0, _extends2["default"])({
    disabled: disabled
  }, other), _react["default"].Children.map(children, function (child, index) {
    if (! /*#__PURE__*/_react["default"].isValidElement(child)) {
      return null;
    } // 第一个 select 或者 autoComplete 自适应宽


    if (index === 0 && (child.type.__MUYA_SELECT || child.type.__MUYA_AUTOCOMPLETE) && typeof (0, _get2["default"])(child, 'props.autoResize') === 'undefined') {
      return /*#__PURE__*/_react["default"].createElement(ZIndexHoc, {
        size: size
      }, /*#__PURE__*/_react["default"].cloneElement(child, {
        autoResize: true
      }));
    }

    return /*#__PURE__*/_react["default"].createElement(ZIndexHoc, {
      size: size
    }, child);
  }));
});

var _default = InputGroup;
exports["default"] = _default;