"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _FoldIcon2 = require("@muya-ui/theme-light/lib/icons/FoldIcon");

var _UnfoldIcon2 = require("@muya-ui/theme-light/lib/icons/UnfoldIcon");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var ArrowWrapper = function ArrowWrapper(props) {
  var size = props.size,
      arrowDisabled = props.arrowDisabled,
      changeStep = props.changeStep,
      iconSize = props.iconSize,
      showRightBorder = props.showRightBorder,
      showArrowBorder = props.showArrowBorder,
      onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave;
  var theme = (0, _useTheme["default"])();

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      upEntered = _useState2[0],
      setUpEntered = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      downEntered = _useState4[0],
      setDownEntered = _useState4[1];

  var UpIcon = theme.components.InputNumber.upArrowIcon || _UnfoldIcon2.UnfoldIcon;
  var DownIcon = theme.components.InputNumber.downArrowIcon || _FoldIcon2.FoldIcon;
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledArrowSuffixNodeWrapper, {
    $needRightBorder: showRightBorder,
    $bordered: showArrowBorder,
    size: size,
    theme: theme,
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave
  }, /*#__PURE__*/_react["default"].createElement(_styled.StyledUpArrow, {
    $entered: upEntered,
    $arrowDisabled: arrowDisabled,
    $iconSize: iconSize,
    $bordered: showArrowBorder,
    onMouseEnter: function onMouseEnter() {
      return setUpEntered(true);
    },
    onMouseLeave: function onMouseLeave() {
      return setUpEntered(false);
    },
    size: size,
    theme: theme,
    onClick: function onClick() {
      return changeStep('up');
    }
  }, /*#__PURE__*/_react["default"].createElement(UpIcon, null)), /*#__PURE__*/_react["default"].createElement(_styled.StyledDownArrow, {
    $entered: downEntered,
    $arrowDisabled: arrowDisabled,
    $iconSize: iconSize,
    $bordered: showArrowBorder,
    onMouseEnter: function onMouseEnter() {
      return setDownEntered(true);
    },
    onMouseLeave: function onMouseLeave() {
      return setDownEntered(false);
    },
    size: size,
    theme: theme,
    onClick: function onClick() {
      return changeStep('down');
    }
  }, /*#__PURE__*/_react["default"].createElement(DownIcon, null)));
};

var _default = ArrowWrapper;
exports["default"] = _default;