"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _MinusIcon2 = require("@muya-ui/theme-light/lib/icons/MinusIcon");

var _AddIcon2 = require("@muya-ui/theme-light/lib/icons/AddIcon");

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Input = require("../Input");

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _ArrowWrapper = _interopRequireDefault(require("./ArrowWrapper"));

var _styled = require("./styled");

var _useInputNumber2 = _interopRequireDefault(require("./useInputNumber"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _excluded = ["prefixNode", "suffixNode", "onMouseEnter", "onMouseLeave", "disabled", "size", "hiddenArrow", "disableBlurFormat", "mode", "fixPrecision", "min", "max", "precision", "step", "iconSize", "width", "defaultValue", "value", "onBlur", "onChange", "onKeyDown", "onFocus", "formatter", "parser", "inputRef", "readOnly", "showRightBorder", "hasFeedback", "bordered", "arrowBordered"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var InputNumberWrapper = (0, _styledComponents["default"])(_Input.Input).withConfig({
  displayName: "InputNumberWrapper"
})(["", ""], function (props) {
  var $entered = props.$entered,
      $hiddenArrow = props.$hiddenArrow,
      $mode = props.$mode,
      size = props.size,
      theme = props.theme;
  var spacing = theme.components.Input.inputPadding[size];
  var left = theme.components.Input.inputAddonNodeMargin[size];
  var defaultStyle = $mode === 'default' && $entered && !$hiddenArrow && (0, _styledComponents.css)(["padding-right:0;"]);
  var plusMinusStyle = $mode === 'plus-minus' && (0, _styledComponents.css)(["padding-right:0;padding-left:0;& input{padding-left:", "px;text-align:center;}"], spacing - left);
  return (0, _styledComponents.css)(["", " ", ""], defaultStyle, plusMinusStyle);
});
var InputNumber = (0, _memoForwardRef["default"])(function (props, ref) {
  var theme = (0, _useTheme["default"])();
  var prefixNode = props.prefixNode,
      suffixNode = props.suffixNode,
      onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave,
      disabled = props.disabled,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      _props$hiddenArrow = props.hiddenArrow,
      hiddenArrow = _props$hiddenArrow === void 0 ? false : _props$hiddenArrow,
      disableBlurFormat = props.disableBlurFormat,
      _props$mode = props.mode,
      mode = _props$mode === void 0 ? 'default' : _props$mode,
      fixPrecision = props.fixPrecision,
      _props$min = props.min,
      min = _props$min === void 0 ? -Infinity : _props$min,
      _props$max = props.max,
      max = _props$max === void 0 ? Infinity : _props$max,
      _props$precision = props.precision,
      precision = _props$precision === void 0 ? 1 : _props$precision,
      _props$step = props.step,
      step = _props$step === void 0 ? 1 : _props$step,
      iconSize = props.iconSize,
      width = props.width,
      defaultValue = props.defaultValue,
      value = props.value,
      onBlur = props.onBlur,
      onChange = props.onChange,
      onKeyDown = props.onKeyDown,
      onFocus = props.onFocus,
      formatter = props.formatter,
      parser = props.parser,
      inputRefProp = props.inputRef,
      readOnly = props.readOnly,
      showRightBorder = props.showRightBorder,
      hasFeedback = props.hasFeedback,
      _props$bordered = props.bordered,
      bordered = _props$bordered === void 0 ? true : _props$bordered,
      _props$arrowBordered = props.arrowBordered,
      arrowBordered = _props$arrowBordered === void 0 ? false : _props$arrowBordered,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var isControlled = ('value' in props);
  var finalWidth = width || (mode === 'plus-minus' ? theme.components.InputNumber.plusMinusWidth[size] : theme.components.InputNumber.width[size]);
  var inputRef = (0, _react.useRef)(null);
  var handleInputRef = (0, _useForkRef2.useForkRef)(inputRef, inputRefProp);
  var focus = (0, _react.useCallback)(function () {
    inputRef.current && inputRef.current.focus();
  }, []); // 只有当同时隐藏输入框边框和步进器边框时才真正隐藏步进器边框

  var showArrowBorder = bordered || arrowBordered;

  var _useInputNumber = (0, _useInputNumber2["default"])({
    defaultValue: defaultValue,
    onChange: onChange,
    formatter: formatter,
    parser: parser,
    onKeyDown: onKeyDown,
    onBlur: onBlur,
    onFocus: onFocus,
    value: value,
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave,
    focus: focus,
    step: step,
    max: max,
    min: min,
    precision: precision,
    fixPrecision: fixPrecision,
    disableBlurFormat: disableBlurFormat,
    disabled: disabled
  }, isControlled),
      handleBlur = _useInputNumber.handleBlur,
      handleChange = _useInputNumber.handleChange,
      handleKeyDown = _useInputNumber.handleKeyDown,
      inputValue = _useInputNumber.inputValue,
      arrowDisabled = _useInputNumber.arrowDisabled,
      entered = _useInputNumber.entered,
      handleMouseEnter = _useInputNumber.handleMouseEnter,
      handleMouseLeave = _useInputNumber.handleMouseLeave,
      changeStep = _useInputNumber.changeStep,
      handleFocus = _useInputNumber.handleFocus,
      handleDoubleClick = _useInputNumber.handleDoubleClick,
      handleStepMouseEnter = _useInputNumber.handleStepMouseEnter,
      handleStepMouseLeave = _useInputNumber.handleStepMouseLeave;

  var arrowSuffixNode = (0, _react.useMemo)(function () {
    return !disabled && !readOnly ? /*#__PURE__*/_react["default"].createElement(_ArrowWrapper["default"], {
      changeStep: changeStep,
      arrowDisabled: arrowDisabled,
      size: size,
      iconSize: iconSize,
      showRightBorder: showRightBorder,
      showArrowBorder: showArrowBorder,
      onMouseEnter: handleStepMouseEnter,
      onMouseLeave: handleStepMouseLeave
    }) : suffixNode;
  }, [arrowDisabled, changeStep, disabled, handleStepMouseEnter, handleStepMouseLeave, iconSize, readOnly, showArrowBorder, showRightBorder, size, suffixNode]);
  var AddNode = theme.components.InputNumber.plusIcon || _AddIcon2.AddIcon;
  var MinusNode = theme.components.InputNumber.minusIcon || _MinusIcon2.MinusIcon;
  var handleStepChange = (0, _react.useCallback)(function (direction) {
    if (disabled || arrowDisabled[direction] || readOnly) {
      return;
    }

    changeStep(direction);
  }, [arrowDisabled, changeStep, disabled, readOnly]);
  var minusPrefixNode = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement(_styled.StyledNodeWrapper, {
      theme: theme,
      $type: "prefix",
      size: size,
      $iconSize: iconSize,
      onClick: function onClick() {
        return handleStepChange('down');
      },
      onMouseEnter: handleStepMouseEnter,
      onMouseLeave: handleStepMouseLeave
    }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
      disabled: disabled || readOnly || arrowDisabled.down,
      tabIndex: -1
    }, /*#__PURE__*/_react["default"].createElement(MinusNode, null)));
  }, [arrowDisabled.down, disabled, handleStepChange, handleStepMouseEnter, handleStepMouseLeave, iconSize, readOnly, size, theme]);
  var addSuffixNode = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement(_styled.StyledNodeWrapper, {
      theme: theme,
      $type: "suffix",
      size: size,
      $iconSize: iconSize,
      onClick: function onClick() {
        return handleStepChange('up');
      },
      onMouseEnter: handleStepMouseEnter,
      onMouseLeave: handleStepMouseLeave
    }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
      disabled: disabled || readOnly || arrowDisabled.up,
      tabIndex: -1
    }, /*#__PURE__*/_react["default"].createElement(AddNode, null)));
  }, [arrowDisabled.up, disabled, handleStepChange, handleStepMouseEnter, handleStepMouseLeave, iconSize, readOnly, size, theme]);
  var inputPrefixNode = mode === 'plus-minus' ? minusPrefixNode : prefixNode;
  var inputSuffixNode = mode === 'plus-minus' ? addSuffixNode : entered && !hiddenArrow ? arrowSuffixNode : suffixNode;
  var finalHasFeedback = mode !== 'plus-minus' && hasFeedback;
  return /*#__PURE__*/_react["default"].createElement(InputNumberWrapper, (0, _extends2["default"])({
    theme: theme,
    $entered: entered,
    $hiddenArrow: hiddenArrow,
    $mode: mode,
    value: inputValue,
    ref: ref,
    size: size,
    disabled: disabled,
    onMouseEnter: handleMouseEnter,
    onMouseLeave: handleMouseLeave,
    onBlur: handleBlur,
    prefixNode: inputPrefixNode,
    suffixNode: inputSuffixNode,
    hasFeedback: finalHasFeedback,
    onChange: handleChange,
    onFocus: handleFocus,
    onKeyDown: handleKeyDown,
    inputRef: handleInputRef,
    width: finalWidth,
    readOnly: readOnly,
    bordered: bordered,
    onDoubleClick: handleDoubleClick
  }, other));
});
InputNumber.__MUYA_INPUTNUMBER = true;
var _default = InputNumber;
exports["default"] = _default;