"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _addPx = _interopRequireDefault(require("../utils/addPx"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _mergeStyleItem = _interopRequireDefault(require("../utils/mergeStyleItem"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _useRangeInputNumber2 = _interopRequireDefault(require("./useRangeInputNumber"));

var _InputNumber = _interopRequireDefault(require("./InputNumber"));

var _excluded = ["size", "disabled", "readOnly", "status", "middleNode", "width", "height", "onMouseEnter", "onMouseLeave", "className", "style", "styles", "value", "defaultValue", "placeholder", "leftLimit", "rightLimit", "onChange", "onPressEnter", "onFocus", "onBlur", "inputProps", "bordered", "innerRef"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  inputWrapper: '',
  headInput: '',
  tailInput: '',
  nodeDivider: ''
};
var RangeInputNumber = (0, _memoForwardRef["default"])(function (props, ref) {
  var _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      readOnly = props.readOnly,
      status = props.status,
      _props$middleNode = props.middleNode,
      middleNode = _props$middleNode === void 0 ? '~' : _props$middleNode,
      width = props.width,
      height = props.height,
      onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave,
      className = props.className,
      style = props.style,
      styles = props.styles,
      value = props.value,
      defaultValue = props.defaultValue,
      _props$placeholder = props.placeholder,
      placeholder = _props$placeholder === void 0 ? [] : _props$placeholder,
      _props$leftLimit = props.leftLimit,
      leftLimit = _props$leftLimit === void 0 ? [-Infinity, Infinity] : _props$leftLimit,
      _props$rightLimit = props.rightLimit,
      rightLimit = _props$rightLimit === void 0 ? [-Infinity, Infinity] : _props$rightLimit,
      onChange = props.onChange,
      onPressEnter = props.onPressEnter,
      onFocus = props.onFocus,
      onBlur = props.onBlur,
      inputProps = props.inputProps,
      _props$bordered = props.bordered,
      bordered = _props$bordered === void 0 ? true : _props$bordered,
      innerRef = props.innerRef,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var innerStyles = (0, _useStyles["default"])('range-input-number', defaultStyles, styles);
  var inputWrapperStyleItem = (0, _react.useMemo)(function () {
    return (0, _mergeStyleItem["default"])({
      className: className,
      style: style
    }, innerStyles.inputWrapper);
  }, [className, innerStyles.inputWrapper, style]);

  var _useRangeInputNumber = (0, _useRangeInputNumber2["default"])(props),
      focus = _useRangeInputNumber.focus,
      finalValue = _useRangeInputNumber.finalValue,
      leftInputRef = _useRangeInputNumber.leftInputRef,
      rightInputRef = _useRangeInputNumber.rightInputRef,
      handleFocus = _useRangeInputNumber.handleFocus,
      handleBlur = _useRangeInputNumber.handleBlur,
      handleLeftChange = _useRangeInputNumber.handleLeftChange,
      handleRightChange = _useRangeInputNumber.handleRightChange,
      handleKeyDown = _useRangeInputNumber.handleKeyDown;

  var more = (0, _react.useRef)({
    focus: function focus() {
      var position = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var option = arguments.length > 1 ? arguments[1] : undefined;

      if (position === 1) {
        rightInputRef.current.focus(option);
      } else {
        leftInputRef.current.focus(option);
      }
    },
    blur: function blur() {
      var position = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;

      if (position === 1) {
        rightInputRef.current.blur();
      } else {
        leftInputRef.current.blur();
      }
    }
  });
  var handleRef = (0, _useForkRef2.useForkRef)(ref, innerRef, more.current);

  var _finalValue = (0, _slicedToArray2["default"])(finalValue, 2),
      leftValue = _finalValue[0],
      rightValue = _finalValue[1];

  var inputWidth = width !== undefined ? width : theme.components.InputNumber.rangeInputNumberWidth[size];
  var inputHeight = height !== undefined ? height : theme.components.Input.inputHeight[size];
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledRangeInputNumberWrapper, (0, _extends2["default"])({
    theme: theme,
    disabled: disabled,
    focus: focus,
    $bordered: bordered,
    $width: (0, _addPx["default"])(inputWidth),
    $height: (0, _addPx["default"])(inputHeight),
    size: size,
    hasError: status === 'error',
    ref: handleRef
  }, inputWrapperStyleItem, other), /*#__PURE__*/_react["default"].createElement(_InputNumber["default"], (0, _extends2["default"])({
    width: "45%",
    height: "100%"
  }, inputProps, innerStyles.headInput, {
    value: leftValue,
    disabled: disabled,
    onKeyDown: handleKeyDown,
    placeholder: placeholder[0],
    size: size,
    inputRef: leftInputRef,
    readOnly: readOnly,
    bordered: false,
    showRightBorder: true,
    arrowBordered: bordered,
    onChange: handleLeftChange,
    onFocus: handleFocus,
    onBlur: handleBlur,
    min: leftLimit[0],
    max: leftLimit[1]
  })), /*#__PURE__*/_react["default"].createElement(_styled.StyledMiddleNode, (0, _extends2["default"])({}, innerStyles.nodeDivider, {
    theme: theme,
    $size: size,
    $disabled: disabled
  }), middleNode), /*#__PURE__*/_react["default"].createElement(_InputNumber["default"], (0, _extends2["default"])({
    width: "45%",
    height: "100%"
  }, inputProps, innerStyles.tailInput, {
    value: rightValue,
    disabled: disabled,
    onKeyDown: handleKeyDown,
    size: size,
    placeholder: placeholder[1],
    inputRef: rightInputRef,
    readOnly: readOnly,
    bordered: false,
    arrowBordered: bordered,
    onFocus: handleFocus,
    onBlur: handleBlur,
    onChange: handleRightChange,
    min: rightLimit[0],
    max: rightLimit[1]
  })));
});
RangeInputNumber.__MUYA_RANGEINPUTNUMBER = true;
var _default = RangeInputNumber;
exports["default"] = _default;