"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _decimal = _interopRequireWildcard(require("./decimal"));

var _utils = require("./utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var handleNumber = function handleNumber(props) {
  var min = props.min,
      max = props.max,
      precision = props.precision,
      fixPrecision = props.fixPrecision;

  var toNumber = function toNumber(value) {
    var val = (0, _decimal.toFixed)(String(value), '.', precision);
    return fixPrecision ? val : (0, _decimal["default"])(val).toString();
  };

  var getValidValue = function getValidValue(data) {
    if (!(0, _utils.isValidProps)(data)) return '';
    var val = (0, _decimal["default"])(data);

    if (val.isNaN() || data === '') {
      return '';
    }

    if (min !== -Infinity && val.lessEquals((0, _decimal["default"])(min))) {
      val = (0, _decimal["default"])(min);
    }

    if (max !== Infinity && (0, _decimal["default"])(max).lessEquals(val)) {
      val = (0, _decimal["default"])(max);
    }

    if (fixPrecision && (0, _utils.isValidProps)(precision) && precision >= 0) {
      return (0, _decimal.toFixed)(val.toString(), '.', precision);
    }

    return val.toString();
  };

  return {
    toNumber: toNumber,
    getValidValue: getValidValue
  };
};

var _default = handleNumber;
exports["default"] = _default;