"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledUpArrow = exports.StyledRangeInputNumberWrapper = exports.StyledNodeWrapper = exports.StyledMiddleNode = exports.StyledDownArrow = exports.StyledArrowSuffixNodeWrapper = void 0;
exports.makeWrapperStyle = makeWrapperStyle;
exports.styledArrowWrapper = styledArrowWrapper;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledArrowSuffixNodeWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledArrowSuffixNodeWrapper"
})(["", ""], function (props) {
  var theme = props.theme,
      $needRightBorder = props.$needRightBorder,
      $bordered = props.$bordered;
  var InputNumberToken = theme.components.InputNumber;
  var borderStyle = $bordered && (0, _styledComponents.css)(["border-left:", ";border-right:", ";"], InputNumberToken.arrowSuffixNodeWrapperBorder, $needRightBorder && InputNumberToken.arrowSuffixNodeWrapperBorder);
  return (0, _styledComponents.css)(["width:20px;display:flex;flex-direction:column;", " text-align:center;height:100%;"], borderStyle);
});

exports.StyledArrowSuffixNodeWrapper = StyledArrowSuffixNodeWrapper;

function styledArrowWrapper(props) {
  var theme = props.theme,
      size = props.size,
      $entered = props.$entered,
      $iconSize = props.$iconSize,
      $bordered = props.$bordered;
  var _theme$colors$pattern = theme.colors.pattern.icon,
      hover = _theme$colors$pattern.hover,
      normal = _theme$colors$pattern.normal;
  var InputNumberToken = theme.components.InputNumber;
  return (0, _styledComponents.css)(["color:", ";display:flex;justify-content:center;align-items:center;padding:", ";flex:", ";flex-basis:auto;width:100%;&:hover{color:", ";height:100%;}&:active{color:", ";height:100%;background-color:", ";}&:not(:last-child){", "}& > svg{position:relative;width:", "px;height:", "px;}"], normal, InputNumberToken.iconMargin, !$entered ? 1 : 0, hover, hover, InputNumberToken.arrowClickBgColor, $bordered && (0, _styledComponents.css)(["border-bottom:", ";"], InputNumberToken.arrowSuffixNodeWrapperBorder), !$iconSize ? InputNumberToken.arrowIconSize[size] : $iconSize, !$iconSize ? InputNumberToken.arrowIconSize[size] : $iconSize);
}

function makeWrapperStyle(props) {
  var theme = props.theme,
      size = props.size,
      disabled = props.disabled,
      focus = props.focus,
      $width = props.$width,
      $height = props.$height,
      $bordered = props.$bordered,
      hasError = props.hasError;
  var colorsPattern = theme.colors.pattern,
      _theme$transition$pat = theme.transition.pattern,
      easing = _theme$transition$pat.easing,
      duration = _theme$transition$pat.duration,
      token = theme.components.Input; // 错误样式

  var errorStyle = (0, _styledComponents.css)(["border-color:", ";box-shadow:", ";"], colorsPattern.feature.error, token.errorFocusShadow); // 聚焦样式

  var focusStyle = (0, _styledComponents.css)(["border-color:", ";box-shadow:", ";"], token.borderColor.focused, token.focusShadow); // 禁用样式

  var disabledStyle = (0, _styledComponents.css)(["background:", ";cursor:not-allowed;input,svg{cursor:not-allowed;}"], colorsPattern.background.disabled);
  var widthStyle = $width && (0, _styledComponents.css)(["width:", ";"], $width);
  var heightStyle = $height && (0, _styledComponents.css)(["height:", ";"], $height);
  var borderStyle = $bordered && (0, _styledComponents.css)(["border:1px solid ", ";"], token.borderColor.normal);
  return (0, _styledComponents.css)(["display:inline-flex;position:relative;box-sizing:border-box;justify-content:space-between;align-items:center;border-radius:", ";transition:border ", "ms ", ",width ", "ms ", ";vertical-align:middle;background-color:", ";&:hover{border-color:", ";}", " ", " ", " ", " ", " ", ""], token.borderRadius[size], duration.status, easing.status, duration.status, easing.status, token.bgColor, !(focus || disabled || hasError) && token.borderColor.hover, borderStyle, widthStyle, heightStyle, focus && focusStyle, hasError && errorStyle, disabled && disabledStyle);
}

var StyledUpArrow = _styledComponents["default"].div.withConfig({
  displayName: "StyledUpArrow"
})(["", ""], function (props) {
  var $arrowDisabled = props.$arrowDisabled,
      theme = props.theme;
  return (0, _styledComponents.css)(["", " ", ""], styledArrowWrapper, $arrowDisabled.up && (0, _styledComponents.css)(["cursor:not-allowed;background-color:", ";"], theme.colors.pattern.background.disabled));
});

exports.StyledUpArrow = StyledUpArrow;

var StyledDownArrow = _styledComponents["default"].div.withConfig({
  displayName: "StyledDownArrow"
})(["", ""], function (props) {
  var $arrowDisabled = props.$arrowDisabled,
      theme = props.theme;
  return (0, _styledComponents.css)(["", " ", ""], styledArrowWrapper, $arrowDisabled.down && (0, _styledComponents.css)(["cursor:not-allowed;background-color:", ";"], theme.colors.pattern.background.disabled));
});

exports.StyledDownArrow = StyledDownArrow;

var StyledRangeInputNumberWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledRangeInputNumberWrapper"
})(["", ""], function () {
  return (0, _styledComponents.css)(["", ""], makeWrapperStyle);
});

exports.StyledRangeInputNumberWrapper = StyledRangeInputNumberWrapper;

var StyledMiddleNode = _styledComponents["default"].div.withConfig({
  displayName: "StyledMiddleNode"
})(["", ""], function (props) {
  var theme = props.theme,
      $disabled = props.$disabled,
      $size = props.$size;
  var typography = theme.typography,
      token = theme.components.Input;
  var disabledStyle = $disabled && (0, _styledComponents.css)(["color:", ";"], theme.colors.pattern.text.disabled);
  var fontLevel = token.fontLevel[$size];
  return (0, _styledComponents.css)(["padding:4px;font-size:", ";", ";"], typography.spec.fontSize[fontLevel] + 'px', disabledStyle);
}); // 加减图标按钮样式


exports.StyledMiddleNode = StyledMiddleNode;

var StyledNodeWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledNodeWrapper"
})(["", ""], function (props) {
  var theme = props.theme,
      size = props.size,
      $type = props.$type,
      $iconSize = props.$iconSize;
  var typography = theme.typography,
      _theme$components = theme.components,
      token = _theme$components.Input,
      InputNumberToken = _theme$components.InputNumber;
  var fontLevel = token.fontLevel[size];
  var borderStyle = $type === 'prefix' ? (0, _styledComponents.css)(["border-right:", ";"], InputNumberToken.arrowSuffixNodeWrapperBorder) : (0, _styledComponents.css)(["border-left:", ";"], InputNumberToken.arrowSuffixNodeWrapperBorder);
  return (0, _styledComponents.css)(["display:flex;justify-content:center;align-items:center;width:20px;height:100%;font-size:", ";", " & svg{position:relative;width:", "px;height:", "px;}"], typography.spec.fontSize[fontLevel] + 'px', borderStyle, !$iconSize ? InputNumberToken.plusIconSize[size] : $iconSize, !$iconSize ? InputNumberToken.plusIconSize[size] : $iconSize);
});

exports.StyledNodeWrapper = StyledNodeWrapper;