"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = require("../utils/useTheme");

var _LayoutContent = _interopRequireDefault(require("./LayoutContent"));

var _LayoutContext = require("./LayoutContext");

var _LayoutFooter = _interopRequireDefault(require("./LayoutFooter"));

var _LayoutHeader = _interopRequireDefault(require("./LayoutHeader"));

var _LayoutSider = _interopRequireDefault(require("./LayoutSider"));

var _LayoutSplitter = _interopRequireDefault(require("./LayoutSplitter"));

var _styled = require("./styled");

var _excluded = ["width", "height", "background"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Layout = (0, _memoForwardRef["default"])(function (props, ref) {
  var width = props.width,
      height = props.height,
      background = props.background,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      hasSider = _useState2[0],
      setHasSider = _useState2[1];

  var theme = (0, _useTheme.useTheme)();
  return /*#__PURE__*/_react["default"].createElement(_LayoutContext.LayoutContext.Provider, {
    value: {
      siderHook: {
        hasSider: hasSider,
        addSider: function addSider(hasSider) {
          setHasSider(hasSider);
        }
      }
    }
  }, /*#__PURE__*/_react["default"].createElement(_styled.StyledLayout, (0, _extends2["default"])({
    ref: ref,
    theme: theme,
    $hasSider: hasSider,
    $width: width,
    $height: height,
    $background: background
  }, restProps)));
});
Layout.Header = _LayoutHeader["default"];
Layout.Footer = _LayoutFooter["default"];
Layout.Content = _LayoutContent["default"];
Layout.Sider = _LayoutSider["default"];
Layout.Splitter = _LayoutSplitter["default"];
var _default = Layout;
exports["default"] = _default;