"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _SpeedLeftIcon2 = require("@muya-ui/theme-light/lib/icons/SpeedLeftIcon");

var _SpeedIcon2 = require("@muya-ui/theme-light/lib/icons/SpeedIcon");

var _useEventCallback2 = require("@muya-ui/utils/lib/hooks/useEventCallback");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _LayoutContext = require("./LayoutContext");

var _styled = require("./styled");

var _LayoutSiderContext = _interopRequireDefault(require("./LayoutSiderContext"));

var _excluded = ["width", "height", "background", "collapsed", "defaultCollapsed", "collapsedWidth", "collapsible", "reverseArrow", "trigger", "onCollapse", "children"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var LayoutSider = (0, _memoForwardRef["default"])(function (props, ref) {
  var theme = (0, _useTheme["default"])();
  var width = props.width,
      height = props.height,
      background = props.background,
      collapsed = props.collapsed,
      _props$defaultCollaps = props.defaultCollapsed,
      defaultCollapsed = _props$defaultCollaps === void 0 ? false : _props$defaultCollaps,
      _props$collapsedWidth = props.collapsedWidth,
      collapsedWidth = _props$collapsedWidth === void 0 ? theme.components.Menu.wrapper.inlineCollapsedWidth : _props$collapsedWidth,
      _props$collapsible = props.collapsible,
      collapsible = _props$collapsible === void 0 ? false : _props$collapsible,
      _props$reverseArrow = props.reverseArrow,
      reverseArrow = _props$reverseArrow === void 0 ? false : _props$reverseArrow,
      trigger = props.trigger,
      onCollapse = props.onCollapse,
      children = props.children,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var isControlled = ('collapsed' in props);

  var _useState = (0, _react.useState)(isControlled ? collapsed : defaultCollapsed),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      collapsedState = _useState2[0],
      setCollapsedState = _useState2[1];

  var _useLayoutContext = (0, _LayoutContext.useLayoutContext)(),
      siderHook = _useLayoutContext.siderHook;

  var handleCollapse = (0, _useEventCallback2.useEventCallback)(function () {
    if (!isControlled) {
      setCollapsedState(!collapsedState);
    }

    if (onCollapse) {
      onCollapse(!collapsedState);
    }
  });
  var triggerNode = (0, _react.useMemo)(function () {
    if (collapsible) {
      if (trigger) {
        return trigger;
      } else {
        return /*#__PURE__*/_react["default"].createElement(_styled.StyledSiderCollapseTrigger, {
          onClick: handleCollapse
        }, reverseArrow && !collapsedState || !reverseArrow && collapsedState ? /*#__PURE__*/_react["default"].createElement(_SpeedIcon2.SpeedIcon, null) : /*#__PURE__*/_react["default"].createElement(_SpeedLeftIcon2.SpeedLeftIcon, null));
      }
    }

    return null;
  }, [collapsedState, collapsible, handleCollapse, reverseArrow, trigger]);
  (0, _react.useEffect)(function () {
    siderHook.addSider(true);
  }, [siderHook]);

  if (isControlled && collapsed !== collapsedState) {
    setCollapsedState(collapsed);
  }

  return /*#__PURE__*/_react["default"].createElement(_LayoutSiderContext["default"].Provider, {
    value: {
      siderCollapsed: collapsedState
    }
  }, /*#__PURE__*/_react["default"].createElement(_styled.StyledLayoutSider, (0, _extends2["default"])({
    ref: ref,
    theme: theme,
    $width: width,
    $height: height,
    $background: background,
    $reverseArrow: reverseArrow,
    $collapsed: !!collapsedState,
    $collapsedWidth: collapsedWidth
  }, restProps), children, triggerNode));
});
var _default = LayoutSider;
exports["default"] = _default;