"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _styled = require("./styled");

var _useLayoutSplitter2 = _interopRequireDefault(require("./useLayoutSplitter"));

var _useTheme = require("../utils/useTheme");

var _excluded = ["children", "direction", "draggable", "miniSizes", "initialSizes", "gutterColor", "styles", "renderGutterDragger", "onGutterMouseDown", "onGutterMouseUp"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Gutter = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var styles = props.styles,
      direction = props.direction,
      onMouseDown = props.onMouseDown,
      draggable = props.draggable,
      gutterDragger = props.gutterDragger,
      gutterColor = props.gutterColor;
  var theme = (0, _useTheme.useTheme)();
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledGutterContainer, (0, _extends2["default"])({
    ref: ref,
    theme: theme,
    $direction: direction,
    $draggable: draggable,
    $gutterColor: gutterColor,
    onMouseDown: onMouseDown
  }, styles.gutter), gutterDragger || /*#__PURE__*/_react["default"].createElement(_styled.StyledGutterDragger, styles.dragger));
});

var defaultStyles = {
  content: '',
  gutter: '',
  dragger: ''
};
var LayoutSplitter = (0, _memoForwardRef["default"])(function (props, ref) {
  var children = props.children,
      _props$direction = props.direction,
      direction = _props$direction === void 0 ? 'horizontal' : _props$direction,
      _props$draggable = props.draggable,
      draggable = _props$draggable === void 0 ? true : _props$draggable,
      miniSizes = props.miniSizes,
      initialSizes = props.initialSizes,
      gutterColor = props.gutterColor,
      styles = props.styles,
      renderGutterDragger = props.renderGutterDragger,
      onGutterMouseDown = props.onGutterMouseDown,
      onGutterMouseUp = props.onGutterMouseUp,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var containerRef = (0, _react.useRef)(null);
  var handleRef = (0, _useForkRef2.useForkRef)(containerRef, ref);

  var _useLayoutSplitter = (0, _useLayoutSplitter2["default"])(props),
      childRefs = _useLayoutSplitter.childRefs,
      gutterRefs = _useLayoutSplitter.gutterRefs,
      addRef = _useLayoutSplitter.addRef,
      setSizes = _useLayoutSplitter.setSizes,
      handleMouseDown = _useLayoutSplitter.handleMouseDown;

  _react["default"].useImperativeHandle(ref, function () {
    if (containerRef.current) {
      containerRef.current.setSizes = setSizes;
    }

    return containerRef.current;
  });

  var innerStyles = (0, _useStyles["default"])('layout-splitter', defaultStyles, styles);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledLayoutSplitterContainer, (0, _extends2["default"])({
    ref: handleRef,
    $direction: direction
  }, restProps), children && children.map(function (c, idx) {
    var isSplitter = c.type.__MUYA_LAYOUT_SPLITTER;
    var gutterDragger = renderGutterDragger && renderGutterDragger({
      index: idx,
      setSizes: setSizes
    });
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
      key: idx
    }, /*#__PURE__*/_react["default"].createElement(_styled.StyledLayoutSplitterContent, (0, _extends2["default"])({
      ref: function ref(el) {
        addRef(childRefs, el);
      }
    }, innerStyles.content), isSplitter ? /*#__PURE__*/_react["default"].cloneElement(c, {
      draggable: draggable
    }) : c), idx < children.length - 1 && /*#__PURE__*/_react["default"].createElement(Gutter, {
      ref: function ref(el) {
        addRef(gutterRefs, el);
      },
      draggable: draggable,
      styles: innerStyles,
      direction: direction,
      gutterColor: gutterColor,
      gutterDragger: gutterDragger,
      onMouseDown: function onMouseDown(e) {
        return handleMouseDown(idx, e);
      }
    }));
  }));
});
LayoutSplitter.__MUYA_LAYOUT_SPLITTER = true;
var _default = LayoutSplitter;
exports["default"] = _default;