"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledSiderCollapseTrigger = exports.StyledLayoutSplitterContent = exports.StyledLayoutSplitterContainer = exports.StyledLayoutSider = exports.StyledLayoutHeader = exports.StyledLayoutFooter = exports.StyledLayoutContent = exports.StyledLayout = exports.StyledGutterDragger = exports.StyledGutterContainer = void 0;

var _IconButton = require("../IconButton");

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _addPx = _interopRequireDefault(require("../utils/addPx"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledLayout = _styledComponents["default"].div.withConfig({
  displayName: "StyledLayout"
})(["", ""], function (props) {
  var $hasSider = props.$hasSider,
      $width = props.$width,
      $height = props.$height,
      $background = props.$background,
      theme = props.theme;
  var $direction = $hasSider ? 'row' : 'column';
  return (0, _styledComponents.css)(["box-sizing:border-box;display:flex;flex:auto;flex-direction:", ";", ";", ";background:", ";"], $direction, $width && "width: ".concat((0, _addPx["default"])($width)), $height && "height: ".concat((0, _addPx["default"])($height)), $background || theme.components.Layout.background);
});

exports.StyledLayout = StyledLayout;

var StyledLayoutHeader = _styledComponents["default"].div.withConfig({
  displayName: "StyledLayoutHeader"
})(["", ""], function (props) {
  var theme = props.theme,
      $height = props.$height,
      $background = props.$background;
  var layoutToken = theme.components.Layout;
  var height = (0, _addPx["default"])($height ? $height : layoutToken.header.height);
  return (0, _styledComponents.css)(["box-sizing:border-box;flex:0 0 auto;height:", ";background:", ";"], height, $background || theme.components.Layout.header.background);
});

exports.StyledLayoutHeader = StyledLayoutHeader;

var StyledLayoutFooter = _styledComponents["default"].div.withConfig({
  displayName: "StyledLayoutFooter"
})(["", ""], function (props) {
  var theme = props.theme,
      $height = props.$height,
      $background = props.$background;
  var layoutToken = theme.components.Layout;
  var height = (0, _addPx["default"])($height ? $height : layoutToken.footer.height);
  return (0, _styledComponents.css)(["box-sizing:border-box;flex:0 0 auto;height:", ";background:", ";"], height, $background || theme.components.Layout.footer.background);
});

exports.StyledLayoutFooter = StyledLayoutFooter;

var StyledLayoutContent = _styledComponents["default"].div.withConfig({
  displayName: "StyledLayoutContent"
})(["", ""], function (props) {
  var $height = props.$height,
      $width = props.$width,
      $background = props.$background,
      theme = props.theme;
  return (0, _styledComponents.css)(["box-sizing:border-box;flex:auto;", ";", ";background:", ";"], $width && "width: ".concat((0, _addPx["default"])($width)), $height && "height: ".concat((0, _addPx["default"])($height)), $background || theme.components.Layout.content.background);
});

exports.StyledLayoutContent = StyledLayoutContent;
var StyledSiderCollapseTrigger = (0, _styledComponents["default"])(_IconButton.IconButton).withConfig({
  displayName: "StyledSiderCollapseTrigger"
})([""]);
exports.StyledSiderCollapseTrigger = StyledSiderCollapseTrigger;

var StyledLayoutSider = _styledComponents["default"].div.withConfig({
  displayName: "StyledLayoutSider"
})(["", ""], function (props) {
  var theme = props.theme,
      $height = props.$height,
      $width = props.$width,
      $background = props.$background,
      $reverseArrow = props.$reverseArrow,
      $collapsed = props.$collapsed,
      $collapsedWidth = props.$collapsedWidth;
  var layoutToken = theme.components.Layout;
  var width = (0, _addPx["default"])($collapsed ? $collapsedWidth : $width ? $width : layoutToken.sider.width);
  var triggerPositionCss;

  if ($collapsed) {
    triggerPositionCss = (0, _styledComponents.css)(["bottom:12px;left:50%;transform:translateX(-50%);"]);
  } else if ($reverseArrow) {
    triggerPositionCss = (0, _styledComponents.css)(["left:12px;bottom:12px;"]);
  } else {
    triggerPositionCss = (0, _styledComponents.css)(["right:12px;bottom:12px;"]);
  }

  return (0, _styledComponents.css)(["position:relative;box-sizing:border-box;flex:0 0 auto;width:", ";", ";background:", ";transition:width ", "ms ", ";", "{position:absolute;", ";transition:all ", "ms ", ";}"], width, $height && "height: ".concat((0, _addPx["default"])($height)), $background || layoutToken.sider.background, theme.transition.pattern.duration.status, theme.transition.pattern.easing.status, StyledSiderCollapseTrigger, triggerPositionCss, theme.transition.pattern.duration.status, theme.transition.pattern.easing.status);
});

exports.StyledLayoutSider = StyledLayoutSider;

var StyledLayoutSplitterContainer = _styledComponents["default"].div.withConfig({
  displayName: "StyledLayoutSplitterContainer"
})(["height:100%;width:100%;display:flex;overflow:hidden;", ""], function (props) {
  var $direction = props.$direction;
  var isHorizontal = $direction === 'horizontal';
  return (0, _styledComponents.css)(["flex-direction:", ";& > ", " > *{", ";}"], isHorizontal ? 'row' : 'column', StyledLayoutSplitterContent, isHorizontal ? 'width: auto' : 'height: 100%');
});

exports.StyledLayoutSplitterContainer = StyledLayoutSplitterContainer;

var StyledLayoutSplitterContent = _styledComponents["default"].div.withConfig({
  displayName: "StyledLayoutSplitterContent"
})(["overflow:hidden;"]);

exports.StyledLayoutSplitterContent = StyledLayoutSplitterContent;

var StyledGutterContainer = _styledComponents["default"].div.withConfig({
  displayName: "StyledGutterContainer"
})(["position:relative;z-index:1;", " ", ""], function (props) {
  var $direction = props.$direction,
      $gutterColor = props.$gutterColor;
  var gutterCss;

  if ($gutterColor) {
    gutterCss = (0, _styledComponents.css)(["background:", ";"], $gutterColor);
  }

  if ($direction === 'horizontal') {
    return (0, _styledComponents.css)(["height:100%;width:1px;", ";&::before{content:'';width:15px;transform:translateX(-7px);display:block;background:transparent;height:100%;}&:hover{cursor:col-resize;}"], gutterCss);
  } else {
    return (0, _styledComponents.css)(["width:100%;height:1px;", ";&::before{content:'';height:15px;transform:translateY(-7px);display:block;background:transparent;width:100%;}&:hover{cursor:row-resize;}"], gutterCss);
  }
}, function (props) {
  var $draggable = props.$draggable,
      $direction = props.$direction,
      theme = props.theme;

  if ($draggable) {
    var bgCss = (0, _styledComponents.css)(["background:", ";&:hover{background:", ";}"], theme.colors.pattern.icon.normal, theme.colors.pattern.icon.hover);
    return (0, _styledComponents.css)(["", "{display:block;", ";}"], StyledGutterDragger, $direction === 'vertical' ? (0, _styledComponents.css)(["&:before{top:-4px;left:50%;transform:translateX(-50%);width:16px;height:3px;", ";}&:after{top:2px;left:50%;transform:translateX(-50%);width:16px;height:3px;", ";}"], bgCss, bgCss) : (0, _styledComponents.css)(["&:before{left:-4px;top:50%;transform:translateY(-50%);width:3px;height:16px;", ";}&:after{left:2px;top:50%;transform:translateY(-50%);width:3px;height:16px;", ";}"], bgCss, bgCss));
  }
});

exports.StyledGutterContainer = StyledGutterContainer;

var StyledGutterDragger = _styledComponents["default"].div.withConfig({
  displayName: "StyledGutterDragger"
})(["display:none;&:before{position:absolute;display:block;content:'';}&:after{position:absolute;display:block;content:'';}"]);

exports.StyledGutterDragger = StyledGutterDragger;