"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.lightTagCss = void 0;

var _styledComponents = require("styled-components");

var _utils = require("../Tag/utils");

var lightTagCss = function lightTagCss(originalProps) {
  var props = (0, _utils.mergeProps)(originalProps);
  var token = props.theme.components.Tag;
  var _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      type = props.type,
      _props$hoverable = props.hoverable,
      hoverable = _props$hoverable === void 0 ? true : _props$hoverable;
  var bgSchema = type === 'mask' ? token.maskBg.light : token.lightBg[type];
  var colorSchema = type === 'mask' ? token.maskColor.light : token.lightColor[type];
  return (0, _styledComponents.css)(["background:", ";color:", ";", ""], bgSchema.normal, colorSchema.normal, !disabled && hoverable ? (0, _styledComponents.css)(["&:hover{background:", ";color:", ";}"], bgSchema.hover, colorSchema.normal) : '');
};

exports.lightTagCss = lightTagCss;