"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.LocaleProvider = void 0;

var _devWarning2 = require("@muya-ui/utils/lib/utils/devWarning");

var _dayjs = _interopRequireDefault(require("dayjs"));

var _react = _interopRequireDefault(require("react"));

var _Dialog = _interopRequireDefault(require("../Dialog"));

var _LocaleContext = _interopRequireDefault(require("./LocaleContext"));

var _en_US = _interopRequireDefault(require("./resource/en_US"));

var LocaleProvider = function LocaleProvider(props) {
  var children = props.children,
      locale = props.locale;

  if (!locale) {
    (0, _devWarning2.devWarning)("[LocaleProvider]: invalid locale value [".concat(locale, "], give a fallback value: en_US"));
    locale = _en_US["default"];
  }

  _dayjs["default"].locale(locale.dayjsLocaleKey);

  _Dialog["default"].config({
    locale: locale
  });

  return /*#__PURE__*/_react["default"].createElement(_LocaleContext["default"].Provider, {
    value: locale
  }, children);
};

exports.LocaleProvider = LocaleProvider;
var _default = LocaleProvider;
exports["default"] = _default;