"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _MoreIcon2 = require("@muya-ui/theme-light/lib/icons/MoreIcon");

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _omit2 = _interopRequireDefault(require("lodash/omit"));

var _react = _interopRequireWildcard(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _const = require("./const");

var _MenuContext = _interopRequireDefault(require("./MenuContext"));

var _MenuDivider = _interopRequireDefault(require("./MenuDivider"));

var _MenuItem = _interopRequireDefault(require("./MenuItem"));

var _MenuItemGroup = _interopRequireDefault(require("./MenuItemGroup"));

var _styled = require("./styled");

var _SubMenu = _interopRequireDefault(require("./SubMenu"));

var _useMenu = require("./useMenu");

var _useMenuBase2 = require("./useMenuBase");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  wrapper: '',
  menu: '',
  menuScrollWrapper: ''
};
var Menu = (0, _memoForwardRef["default"])(function (props, ref) {
  var width = props.width,
      height = props.height,
      children = props.children,
      onScroll = props.onScroll,
      styles = props.styles,
      style = props.style,
      className = props.className,
      menuItemAlign = props.menuItemAlign,
      noSpacing = props.noSpacing,
      onClick = props.onClick,
      _props$collapseOverfl = props.collapseOverflowMenu,
      collapseOverflowMenu = _props$collapseOverfl === void 0 ? true : _props$collapseOverfl;
  var theme = (0, _useTheme["default"])();
  var rootMenuRef = (0, _react.useRef)(null);
  var handleRef = (0, _useForkRef2.useForkRef)(rootMenuRef, ref);
  var contextValue = (0, _useMenu.useMenu)(props, rootMenuRef);
  var inlineMode = contextValue.inlineMode,
      verticalMode = contextValue.verticalMode,
      horizontalMode = contextValue.horizontalMode,
      size = contextValue.size,
      mode = contextValue.mode,
      inlineCollapsed = contextValue.inlineCollapsed,
      rootMenuScrollable = contextValue.rootMenuScrollable,
      hideRootMenuSpacing = contextValue.hideRootMenuSpacing,
      maxItemCountPerPage = contextValue.maxItemCountPerPage,
      autoItemCountPerPage = contextValue.autoItemCountPerPage,
      handleItemSelect = contextValue.handleItemSelect,
      handleItemDeselect = contextValue.handleItemDeselect,
      handleMenuScrollRef = contextValue.handleMenuScrollRef;
  var finalHandleRef = (0, _useForkRef2.useForkRef)(handleMenuScrollRef, handleRef);

  var _useMenuBase = (0, _useMenuBase2.useMenuBase)({
    mode: mode,
    level: 1,
    eventKey: _const.rootMenuKey,
    parentIsRootMenu: true,
    parentMenuOpen: true,
    hasScrollBar: rootMenuScrollable,
    menuHasIcon: false,
    children: children,
    onItemSelect: handleItemSelect,
    onItemDeselect: handleItemDeselect,
    onClick: onClick
  }),
      elements = _useMenuBase.elements,
      renderMenuWidget = _useMenuBase.renderMenuWidget;

  var menuStyles = (0, _react.useMemo)(function () {
    if (styles) {
      var wrapper = styles.wrapper,
          menu = styles.menu,
          menuScrollWrapper = styles.menuScrollWrapper;
      return {
        wrapper: wrapper,
        menu: menu,
        menuScrollWrapper: menuScrollWrapper
      };
    }
  }, [styles]);
  var innerStyles = (0, _useStyles["default"])('menu', defaultStyles, menuStyles);
  var domProps = (0, _omit2["default"])(props, _const.allMenuProp);
  var menuItems = (0, _react.useMemo)(function () {
    // 如果当前是收起状态，但是元素超过了高度。
    if (collapseOverflowMenu && inlineCollapsed && rootMenuRef.current) {
      var containerHeight = rootMenuRef.current.offsetHeight;
      var showCount = 0;
      var contentHeight = 0;
      var _theme$components$Men = theme.components.Menu,
          _height = _theme$components$Men.height,
          marginVertical = _theme$components$Men.item.marginVertical,
          paddingVertical = _theme$components$Men.divider.paddingVertical;
      elements.forEach(function (el) {
        if (el.type && el.type.displayName === 'MenuItemGroup') {
          contentHeight += el.props.children.length * (_height + 2 * marginVertical);
        } else if (el.type && el.type.displayName === 'MenuDivider') {
          contentHeight += 2 * paddingVertical + 1;
        } else {
          contentHeight += _height + 2 * marginVertical;
        }

        if (contentHeight <= containerHeight) {
          showCount++;
        }
      });

      if (containerHeight < contentHeight) {
        // 将超出范围的元素收起来
        return elements.slice(0, showCount - 1).concat([/*#__PURE__*/_react["default"].createElement(_SubMenu["default"], {
          icon: /*#__PURE__*/_react["default"].createElement(_MoreIcon2.MoreIcon, null),
          key: "more"
        }, elements.slice(showCount - 1))]);
      }
    }

    return elements; // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [collapseOverflowMenu, elements, inlineCollapsed, theme.components.Menu, rootMenuRef.current]);
  return /*#__PURE__*/_react["default"].createElement(_MenuContext["default"].Provider, {
    value: contextValue
  }, /*#__PURE__*/_react["default"].createElement(_styled.StyledMenuWrapper, (0, _extends2["default"])({}, domProps, {
    ref: finalHandleRef,
    theme: theme,
    $width: width,
    $height: height,
    $inlineMode: inlineMode,
    $verticalMode: verticalMode,
    $inlineCollapsed: inlineCollapsed,
    className: [innerStyles.wrapper.className, className].join(' ').trim(),
    style: (0, _extends2["default"])({}, innerStyles.wrapper.style, style),
    onScroll: onScroll
  }), /*#__PURE__*/_react["default"].createElement(_styled.StyledMenu, (0, _extends2["default"])({
    theme: theme,
    $size: size,
    $inlineMode: inlineMode,
    $horizontalMode: horizontalMode,
    $inlineCollapsed: inlineCollapsed,
    $sub: false,
    $hideRootMenuSpacing: hideRootMenuSpacing,
    $menuItemAlign: menuItemAlign,
    $noSpacing: noSpacing,
    $hasScrollBar: rootMenuScrollable,
    $maxItemCountPerPage: maxItemCountPerPage,
    $autoItemCountPerPage: autoItemCountPerPage
  }, innerStyles.menu), /*#__PURE__*/_react["default"].createElement(_styled.StyledMenuScrollWrapper, innerStyles.menuScrollWrapper, menuItems.map(renderMenuWidget)))));
});
Menu.Divider = _MenuDivider["default"];
Menu.Item = _MenuItem["default"];
Menu.Group = _MenuItemGroup["default"];
Menu.SubMenu = _SubMenu["default"];
var _default = Menu;
exports["default"] = _default;