"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _omit2 = _interopRequireDefault(require("lodash/omit"));

var _react = _interopRequireWildcard(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _const = require("./const");

var _MenuContext = require("./MenuContext");

var _styled = require("./styled");

var _useMenuItem2 = require("./useMenuItem");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  item: '',
  itemContent: '',
  itemText: ''
};
var MenuItem = (0, _memoForwardRef["default"])(function (props, ref) {
  var context = (0, _MenuContext.useMenuContext)();
  var itemRef = (0, _react.useRef)(null);
  var handleRef = (0, _useForkRef2.useForkRef)(itemRef, ref);
  var disabled = props.disabled,
      menuHasIcon = props.menuHasIcon,
      level = props.level,
      className = props.className,
      style = props.style,
      icon = props.icon,
      selectedIcon = props.selectedIcon,
      children = props.children,
      styles = props.styles;
  var theme = (0, _useTheme["default"])();
  var tooltip = theme.components.Menu.tooltip;

  var _useMenuItem = (0, _useMenuItem2.useMenuItem)(props, context, itemRef),
      isSelected = _useMenuItem.isSelected,
      showChildren = _useMenuItem.showChildren,
      attrs = _useMenuItem.attrs,
      handleClick = _useMenuItem.handleClick;

  var menuStyles = context.styles,
      inlineMode = context.inlineMode,
      horizontalMode = context.horizontalMode,
      itemIcon = context.itemIcon,
      inlineCollapsed = context.inlineCollapsed,
      renderMenuItemChild = context.renderMenuItemChild;
  var itemStyles = (0, _react.useMemo)(function () {
    var itemStyles = (0, _extends2["default"])({}, menuStyles, styles);
    var item = itemStyles.item,
        itemContent = itemStyles.itemContent,
        itemText = itemStyles.itemText;
    return {
      item: item,
      itemContent: itemContent,
      itemText: itemText
    };
  }, [menuStyles, styles]);
  var innerStyles = (0, _useStyles["default"])('menu', defaultStyles, itemStyles);
  var finalStyle = (0, _react.useMemo)(function () {
    return (0, _extends2["default"])({}, innerStyles.item.style, style);
  }, [innerStyles.item.style, style]);
  var domProps = (0, _omit2["default"])(props, _const.allMenuItemProp);
  var iconNode = (0, _react.useMemo)(function () {
    var finalIcon = icon || itemIcon;

    if (isSelected && selectedIcon) {
      finalIcon = selectedIcon;
    }

    if (typeof finalIcon === 'function') {
      return finalIcon(props);
    } else {
      return finalIcon;
    }
  }, [icon, isSelected, itemIcon, props, selectedIcon]);
  var childrenNode = (0, _react.useMemo)(function () {
    if (renderMenuItemChild) {
      return renderMenuItemChild((0, _extends2["default"])({}, props, {
        selected: isSelected
      }));
    } else {
      return children;
    }
  }, [children, isSelected, props, renderMenuItemChild]);
  var itemNode = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement(_styled.StyledMenuItem, (0, _extends2["default"])({
      ref: handleRef
    }, domProps, attrs, {
      theme: theme,
      $menuHasIcon: menuHasIcon,
      $isSelected: isSelected,
      $disabled: disabled,
      $level: level,
      $inlineMode: inlineMode,
      $horizontalMode: horizontalMode,
      $inlineCollapsed: inlineCollapsed,
      className: [innerStyles.item.className, className].join(' ').trim(),
      style: finalStyle,
      onClick: handleClick
    }), /*#__PURE__*/_react["default"].createElement(_styled.StyledMenuItemContent, innerStyles.itemContent, iconNode, /*#__PURE__*/_react["default"].createElement(_styled.StyledMenuItemText, innerStyles.itemText, childrenNode)));
  }, [attrs, childrenNode, className, disabled, domProps, finalStyle, handleClick, handleRef, horizontalMode, iconNode, inlineCollapsed, inlineMode, innerStyles.item.className, innerStyles.itemContent, innerStyles.itemText, isSelected, level, menuHasIcon, theme]);

  if (showChildren) {
    return itemNode;
  } else {
    return /*#__PURE__*/_react["default"].createElement(_styled.StyledMenuItemTooltip, {
      title: children,
      offset: tooltip.offset,
      size: tooltip.size,
      placement: "right"
    }, itemNode);
  }
});
MenuItem.displayName = 'MenuItem';
var _default = MenuItem;
exports["default"] = _default;