"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _omit2 = _interopRequireDefault(require("lodash/omit"));

var _react = _interopRequireWildcard(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _const = require("./const");

var _MenuContext = require("./MenuContext");

var _styled = require("./styled");

var _useMenuBase2 = require("./useMenuBase");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  group: '',
  groupLabel: ''
};
var MenuItemGroup = (0, _memoForwardRef["default"])(function (props, ref) {
  var _props$title = props.title,
      title = _props$title === void 0 ? '' : _props$title,
      children = props.children,
      eventKey = props.eventKey,
      parentIsRootMenu = props.parentIsRootMenu,
      parentMenuOpen = props.parentMenuOpen,
      parentMenuScrollable = props.parentMenuScrollable,
      menuHasIcon = props.menuHasIcon,
      level = props.level,
      style = props.style,
      styles = props.styles,
      className = props.className,
      onClick = props.onClick,
      onItemSelect = props.onItemSelect,
      onItemDeselect = props.onItemDeselect;
  var theme = (0, _useTheme["default"])();

  var _ref = (0, _MenuContext.useMenuContext)(),
      menuStyles = _ref.styles,
      inlineMode = _ref.inlineMode,
      inlineCollapsed = _ref.inlineCollapsed,
      mode = _ref.mode,
      autoScrollToSelection = _ref.autoScrollToSelection;

  var _useMenuBase = (0, _useMenuBase2.useMenuBase)({
    mode: mode,
    level: level,
    eventKey: "".concat(eventKey, "_menu_group"),
    parentIsRootMenu: parentIsRootMenu,
    parentMenuOpen: parentMenuOpen,
    hasScrollBar: parentMenuScrollable,
    menuHasIcon: false,
    children: children,
    onClick: onClick,
    onItemSelect: onItemSelect,
    onItemDeselect: onItemDeselect,
    autoScrollToSelection: autoScrollToSelection
  }),
      elements = _useMenuBase.elements,
      renderMenuWidget = _useMenuBase.renderMenuWidget;

  var groupStyles = (0, _react.useMemo)(function () {
    var groupStyles = (0, _extends2["default"])({}, menuStyles, styles);
    var group = groupStyles.group,
        groupLabel = groupStyles.groupLabel;
    return {
      group: group,
      groupLabel: groupLabel
    };
  }, [menuStyles, styles]);
  var innerStyles = (0, _useStyles["default"])('menu', defaultStyles, groupStyles);
  var finalStyle = (0, _react.useMemo)(function () {
    return (0, _extends2["default"])({}, innerStyles.group.style, style);
  }, [innerStyles.group.style, style]);
  var showLabel = !inlineCollapsed || inlineCollapsed && level > 1;
  var domProps = (0, _omit2["default"])(props, _const.allMenuGroupProp);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledMenuItemGroup, (0, _extends2["default"])({
    ref: ref,
    theme: theme,
    $level: level,
    $menuHasIcon: menuHasIcon,
    $inlineMode: inlineMode,
    $inlineCollapsed: inlineCollapsed,
    className: [innerStyles.group.className, className].join(' ').trim(),
    style: finalStyle
  }, domProps), showLabel && /*#__PURE__*/_react["default"].createElement(_styled.StyledMenuItemGroupLabel, innerStyles.groupLabel, title), elements.map(renderMenuWidget));
});
MenuItemGroup.displayName = 'MenuItemGroup';
var _default = MenuItemGroup;
exports["default"] = _default;