"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _FoldIcon2 = require("@muya-ui/theme-light/lib/icons/FoldIcon");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _omit2 = _interopRequireDefault(require("lodash/omit"));

var _react = _interopRequireWildcard(require("react"));

var _Animation = _interopRequireDefault(require("../Animation"));

var _ExpandIcon = _interopRequireDefault(require("../ExpandIcon"));

var _ExpandWrapper = _interopRequireDefault(require("../styled/components/ExpandWrapper"));

var _Trigger = _interopRequireDefault(require("../Trigger"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _const = require("./const");

var _MenuContext = require("./MenuContext");

var _styled = require("./styled");

var _useMenuBase2 = require("./useMenuBase");

var _useSubMenu2 = require("./useSubMenu");

var _utils = require("./utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  menu: '',
  subMenu: '',
  subMenuTitle: '',
  menuScrollWrapper: ''
};
var SubMenu = (0, _memoForwardRef["default"])(function (props, ref) {
  var eventKey = props.eventKey,
      title = props.title,
      disabled = props.disabled,
      level = props.level,
      icon = props.icon,
      selectedIcon = props.selectedIcon,
      menuHasIcon = props.menuHasIcon,
      children = props.children,
      className = props.className,
      style = props.style,
      _props$popperProps = props.popperProps,
      popperProps = _props$popperProps === void 0 ? {} : _props$popperProps,
      _props$flip = props.flip,
      flip = _props$flip === void 0 ? true : _props$flip,
      arrowPointAtCenter = props.arrowPointAtCenter,
      parentIsRootMenu = props.parentIsRootMenu,
      parentMenuScrollable = props.parentMenuScrollable,
      triggerId = props.triggerId,
      styles = props.styles;
  var titleRef = (0, _react.useRef)(null);
  var theme = (0, _useTheme["default"])();
  var context = (0, _MenuContext.useMenuContext)();
  var getPopupContainer = context.getPopupContainer,
      inlineMode = context.inlineMode,
      expandIcon = context.expandIcon,
      subMenuIcon = context.subMenuIcon,
      triggerSubMenuAction = context.triggerSubMenuAction,
      triggerDisableOpenOnExiting = context.triggerDisableOpenOnExiting,
      TransitionComponent = context.TransitionComponent,
      menuStyles = context.styles,
      forceSubMenuRender = context.forceSubMenuRender,
      inlineCollapsed = context.inlineCollapsed,
      horizontalMode = context.horizontalMode,
      verticalMode = context.verticalMode,
      maxItemCountPerPage = context.maxItemCountPerPage,
      autoItemCountPerPage = context.autoItemCountPerPage,
      size = context.size,
      hideRootMenuSpacing = context.hideRootMenuSpacing,
      autoScrollToSelection = context.autoScrollToSelection,
      mode = context.mode;

  var _useSubMenu = (0, _useSubMenu2.useSubMenu)(props, context, titleRef),
      isOpen = _useSubMenu.isOpen,
      _menuId = _useSubMenu._menuId,
      placement = _useSubMenu.placement,
      appear = _useSubMenu.appear,
      hasScrollBar = _useSubMenu.hasScrollBar,
      handleMenuScrollRef = _useSubMenu.handleMenuScrollRef,
      handleTitleMouseEnter = _useSubMenu.handleTitleMouseEnter,
      handleTitleMouseLeave = _useSubMenu.handleTitleMouseLeave,
      handleTitleClick = _useSubMenu.handleTitleClick,
      handleVisibleChange = _useSubMenu.handleVisibleChange,
      handleSubMenuClick = _useSubMenu.handleSubMenuClick,
      handleItemSelect = _useSubMenu.handleItemSelect,
      handleItemDeselect = _useSubMenu.handleItemDeselect,
      isSelected = _useSubMenu.isSelected,
      menuWidth = _useSubMenu.menuWidth;

  var finalIcon = (0, _react.useMemo)(function () {
    if (isSelected && selectedIcon) {
      return selectedIcon;
    }

    return icon || subMenuIcon;
  }, [icon, isSelected, selectedIcon, subMenuIcon]);

  var _useMenuBase = (0, _useMenuBase2.useMenuBase)({
    mode: mode,
    level: level + 1,
    eventKey: "".concat(eventKey, "_submenu"),
    parentIsRootMenu: false,
    parentMenuOpen: isOpen,
    menuHasIcon: !!finalIcon,
    children: children,
    hasScrollBar: hasScrollBar,
    autoScrollToSelection: autoScrollToSelection,
    onClick: handleSubMenuClick,
    onItemSelect: handleItemSelect,
    onItemDeselect: handleItemDeselect
  }),
      elements = _useMenuBase.elements,
      renderMenuWidget = _useMenuBase.renderMenuWidget;

  var subMenuStyles = (0, _react.useMemo)(function () {
    var subMenuStyles = (0, _extends2["default"])({}, menuStyles, styles);
    var menu = subMenuStyles.menu,
        subMenu = subMenuStyles.subMenu,
        subMenuTitle = subMenuStyles.subMenuTitle,
        menuScrollWrapper = subMenuStyles.menuScrollWrapper;
    return {
      menu: menu,
      subMenu: subMenu,
      subMenuTitle: subMenuTitle,
      menuScrollWrapper: menuScrollWrapper
    };
  }, [menuStyles, styles]);
  var offset = (0, _react.useMemo)(function () {
    if (parentMenuScrollable && mode !== 'vertical-right') {
      return theme.components.Menu.subMenu.offsetHasScrollBar;
    } else {
      return theme.components.Menu.subMenu.offset;
    }
  }, [mode, parentMenuScrollable, theme.components.Menu.subMenu.offset, theme.components.Menu.subMenu.offsetHasScrollBar]);
  var innerStyles = (0, _useStyles["default"])('menu', defaultStyles, subMenuStyles);
  var finalStyle = (0, _react.useMemo)(function () {
    return (0, _extends2["default"])({}, innerStyles.subMenu.style, style);
  }, [innerStyles.subMenu.style, style]);
  var container = parentIsRootMenu && !hideRootMenuSpacing || !titleRef.current ? getPopupContainer : titleRef.current.parentNode;
  var domProps = (0, _omit2["default"])(props, _const.allSubMenuProp);
  var showTitle = !inlineCollapsed || inlineCollapsed && level > 1;
  var ariaOwns = (0, _react.useMemo)(function () {
    var ariaOwns = {};

    if (isOpen) {
      ariaOwns = {
        '': _menuId
      };
    }

    return ariaOwns;
  }, [_menuId, isOpen]);
  var finalPopperProps = (0, _react.useMemo)(function () {
    var finalPopperProps = (0, _extends2["default"])({}, popperProps, {
      lazyMount: !forceSubMenuRender
    });

    if (hasScrollBar) {
      finalPopperProps.modifiers = (0, _extends2["default"])({}, finalPopperProps.modifiers, {
        preventOverflow: {
          boundariesElement: 'viewport',
          padding: theme.components.Menu.subMenu.preventOverflowPadding / 2
        }
      });
    }

    if (parentMenuScrollable) {
      finalPopperProps.modifiers = (0, _extends2["default"])({}, finalPopperProps.modifiers, {
        applyStyle: {
          fn: _utils.applyStyle
        }
      });
    }

    return finalPopperProps;
  }, [forceSubMenuRender, hasScrollBar, parentMenuScrollable, popperProps, theme.components.Menu.subMenu.preventOverflowPadding]); // 渲染 children

  var childrenNode = (0, _react.useMemo)(function () {
    var style;

    if (horizontalMode) {
      style = {
        width: menuWidth
      };
    }

    if (inlineMode && !inlineCollapsed) {
      return /*#__PURE__*/_react["default"].createElement(_Animation["default"].Collapse, {
        appear: appear,
        easing: "linear",
        timeout: theme.transition.pattern.duration.status,
        "in": isOpen
      }, /*#__PURE__*/_react["default"].createElement(_styled.StyledMenu, (0, _extends2["default"])({
        theme: theme,
        $size: size,
        $inlineMode: inlineMode,
        $horizontalMode: horizontalMode,
        $inlineCollapsed: inlineCollapsed,
        $sub: true,
        $hideRootMenuSpacing: hideRootMenuSpacing
      }, innerStyles.menu), /*#__PURE__*/_react["default"].createElement(_styled.StyledMenuScrollWrapper, (0, _extends2["default"])({
        ref: handleMenuScrollRef
      }, innerStyles.menuScrollWrapper), elements.map(renderMenuWidget))));
    }

    return /*#__PURE__*/_react["default"].createElement(_styled.StyledMenu, {
      theme: theme,
      $size: size,
      $inlineMode: inlineMode,
      $horizontalMode: horizontalMode,
      $inlineCollapsed: inlineCollapsed,
      $sub: true,
      $hasScrollBar: hasScrollBar,
      $hideRootMenuSpacing: hideRootMenuSpacing,
      $maxItemCountPerPage: maxItemCountPerPage,
      $autoItemCountPerPage: autoItemCountPerPage,
      className: innerStyles.menu.className,
      style: (0, _extends2["default"])({}, innerStyles.menu.style, style)
    }, /*#__PURE__*/_react["default"].createElement(_styled.StyledMenuScrollWrapper, (0, _extends2["default"])({
      ref: handleMenuScrollRef
    }, innerStyles.menuScrollWrapper), elements.map(renderMenuWidget)));
  }, [appear, autoItemCountPerPage, elements, handleMenuScrollRef, hasScrollBar, hideRootMenuSpacing, horizontalMode, inlineCollapsed, inlineMode, innerStyles.menu, innerStyles.menuScrollWrapper, isOpen, maxItemCountPerPage, menuWidth, renderMenuWidget, size, theme]);
  var iconNode = (0, _react.useMemo)(function () {
    if (typeof finalIcon === 'function') {
      return finalIcon(props);
    } else {
      return finalIcon;
    }
  }, [finalIcon, props]);
  var expandIconNode = (0, _react.useMemo)(function () {
    if (_react["default"].Children.count(children) > 0 && showTitle) {
      var DefaultExpandIcon = theme.components.Menu.expandIcon || _FoldIcon2.FoldIcon;
      var token = theme.components.Menu,
          lineHeight = theme.typography.spec.lineHeight;
      var rotateProps; // 垂直菜单箭头方向调整

      if (verticalMode || inlineCollapsed && level > 1) {
        rotateProps = {
          $rotate: 270,
          $expandRotate: 270
        };
      }

      return /*#__PURE__*/_react["default"].createElement(_ExpandWrapper["default"], (0, _extends2["default"])({
        theme: theme,
        $expanded: isOpen,
        $lineHeight: horizontalMode ? lineHeight[token.fontLevel] : 0
      }, rotateProps), /*#__PURE__*/_react["default"].createElement(_ExpandIcon["default"], {
        icon: expandIcon,
        DefaultIcon: DefaultExpandIcon,
        disabled: disabled
      }));
    }
  }, [children, disabled, expandIcon, horizontalMode, inlineCollapsed, isOpen, level, showTitle, theme, verticalMode]);
  var titleNode = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement(_styled.StyledSubMenuTitleWrapper, (0, _extends2["default"])({
      ref: titleRef,
      "aria-expanded": isOpen,
      "aria-haspopup": "true",
      onClick: handleTitleClick,
      onMouseEnter: handleTitleMouseEnter,
      onMouseLeave: handleTitleMouseLeave
    }, ariaOwns, {
      title: typeof title === 'string' ? title : undefined
    }), /*#__PURE__*/_react["default"].createElement(_styled.StyledSubMenuTitle, (0, _extends2["default"])({}, innerStyles.subMenuTitle, {
      theme: theme,
      $selected: isSelected
    }), /*#__PURE__*/_react["default"].createElement(_styled.StyledSubMenuTitleAndIconWrapper, null, iconNode, showTitle && title), expandIconNode));
  }, [ariaOwns, expandIconNode, handleTitleClick, handleTitleMouseEnter, handleTitleMouseLeave, iconNode, innerStyles.subMenuTitle, isOpen, isSelected, showTitle, theme, title]);
  var inlineMenu = (0, _react.useMemo)(function () {
    if (inlineMode && !inlineCollapsed) {
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, titleNode, childrenNode);
    }
  }, [childrenNode, inlineCollapsed, inlineMode, titleNode]);
  var verticalOrInlineCollapseMenu = (0, _react.useMemo)(function () {
    if (!inlineMode || inlineCollapsed) {
      return /*#__PURE__*/_react["default"].createElement(_Trigger["default"], {
        hideArrow: true,
        disabled: disabled,
        triggerAction: triggerSubMenuAction,
        disableOpenOnExiting: triggerDisableOpenOnExiting,
        TransitionComponent: TransitionComponent,
        placement: placement,
        open: isOpen,
        offset: offset,
        popup: childrenNode,
        flip: flip,
        triggerId: triggerId,
        arrowPointAtCenter: arrowPointAtCenter,
        popperProps: finalPopperProps,
        container: container,
        onVisibleChange: handleVisibleChange
      }, titleNode);
    }
  }, [TransitionComponent, arrowPointAtCenter, childrenNode, container, disabled, finalPopperProps, flip, handleVisibleChange, inlineCollapsed, inlineMode, isOpen, offset, placement, titleNode, triggerDisableOpenOnExiting, triggerId, triggerSubMenuAction]);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledSubMenu, (0, _extends2["default"])({
    ref: ref,
    role: "menuitem"
  }, domProps, {
    className: [innerStyles.subMenu.className, className].join(' ').trim(),
    style: finalStyle,
    theme: theme,
    $disabled: disabled,
    $level: level,
    $menuHasIcon: menuHasIcon,
    $inlineMode: inlineMode,
    $inlineCollapsed: inlineCollapsed,
    $selected: isSelected,
    $horizontalMode: horizontalMode,
    $isOpen: isOpen
  }), inlineMenu, verticalOrInlineCollapseMenu);
});
SubMenu.displayName = 'SubMenu';
var _default = SubMenu;
exports["default"] = _default;