"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledSubMenuTitleWrapper = exports.StyledSubMenuTitleAndIconWrapper = exports.StyledSubMenuTitle = exports.StyledSubMenu = exports.StyledMenuWrapper = exports.StyledMenuScrollWrapper = exports.StyledMenuItemTooltip = exports.StyledMenuItemText = exports.StyledMenuItemGroupLabel = exports.StyledMenuItemGroup = exports.StyledMenuItemContent = exports.StyledMenuItem = exports.StyledMenuDivider = exports.StyledMenu = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _StyledSvg3 = require("@muya-ui/icon-base/lib/StyledSvg");

var _SvgIcon = require("@muya-ui/theme-light/lib/components/SvgIcon");

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _styled = require("../ScrollView/styled");

var _ExpandWrapper = _interopRequireDefault(require("../styled/components/ExpandWrapper"));

var _ellipsis = _interopRequireDefault(require("../styled/mixins/ellipsis"));

var _item = require("../styled/mixins/item");

var _Tooltip = _interopRequireDefault(require("../Tooltip"));

var _addPx = _interopRequireDefault(require("../utils/addPx"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var itemStatusStyle = function itemStatusStyle(status) {
  var $disabled = status.$disabled,
      $selected = status.$selected,
      $itemToken = status.$itemToken;
  return (0, _styledComponents.css)(["", " ", " ", ""], !$disabled && !$selected && (0, _item.itemNormalStyle)($itemToken), $selected && (0, _item.itemSelectedStyle)($itemToken), $disabled && (0, _item.itemDisabledStyle)($itemToken));
};

var StyledMenuItemTooltip = (0, _styledComponents["default"])(_Tooltip["default"]).withConfig({
  displayName: "StyledMenuItemTooltip"
})(["a{color:inherit;text-decoration:none;}"]); // menu

/* stylelint-disable selector-type-case, selector-type-no-unknown */

exports.StyledMenuItemTooltip = StyledMenuItemTooltip;

var menuCss = function menuCss(props) {
  var _props$theme = props.theme,
      _props$theme$transiti = _props$theme.transition.pattern,
      easing = _props$theme$transiti.easing,
      duration = _props$theme$transiti.duration,
      colorsPattern = _props$theme.colors.pattern,
      shadows = _props$theme.shadows,
      _props$theme$typograp = _props$theme.typography.spec,
      fontSize = _props$theme$typograp.fontSize,
      lineHeight = _props$theme$typograp.lineHeight,
      _props$theme$componen = _props$theme.components,
      token = _props$theme$componen.Menu,
      expandIconToken = _props$theme$componen.ExpandIcon,
      $size = props.$size,
      $inlineMode = props.$inlineMode,
      $horizontalMode = props.$horizontalMode,
      $inlineCollapsed = props.$inlineCollapsed,
      $sub = props.$sub,
      $noSpacing = props.$noSpacing,
      $hideRootMenuSpacing = props.$hideRootMenuSpacing,
      $menuItemAlign = props.$menuItemAlign,
      $hasScrollBar = props.$hasScrollBar,
      $maxItemCountPerPage = props.$maxItemCountPerPage,
      $autoItemCountPerPage = props.$autoItemCountPerPage;
  var modeStyle;
  var spacingStyle;
  var alignStyle;

  if ($noSpacing || (!$inlineMode || $inlineCollapsed) && ($sub || $hideRootMenuSpacing)) {
    spacingStyle = (0, _styledComponents.css)(["", " ", ",", ",", " ", ",", " ", " ", "{margin:0;padding:0 ", "px;}"], StyledMenuItem, StyledMenuItemContent, StyledSubMenuTitle, StyledMenuItemGroup, StyledMenuItemGroupLabel, StyledMenuItemGroup, StyledMenuItem, StyledMenuItemContent, token.item.verticalPaddingHorizontal);
  }
  /**
   * 1. 放在 dropdown 中的一级
   * 2. 弹出的子菜单
   */


  if ((!$inlineMode || $inlineCollapsed) && ($sub || $hideRootMenuSpacing)) {
    modeStyle = (0, _styledComponents.css)(["box-shadow:", ";min-width:", "px;padding:", "px 0;background:", ";border-radius:", ";", ";", "{", ";", "}", "{margin-top:", "px;", "{height:", "px;line-height:", "px;}}", " ", ",", "{height:", "px;line-height:", "px;font-size:", "px;}", ",", "{font-size:", "px;}"], shadows.pattern.popper.normal, token.subMenu.verticalMinWidth, token.subMenu.verticalPaddingVertical, colorsPattern.background.higher, token.verticalBorderRadius, $hasScrollBar && "padding-right: ".concat(token.subMenu.scrollBarPadding, "px"), StyledMenuScrollWrapper, $autoItemCountPerPage ? "max-height: calc(100vh - ".concat(token.subMenu.preventOverflowPadding, "px)") : "max-height: ".concat($maxItemCountPerPage * token.verticalHeight[$size], "px"), $hasScrollBar && (0, _styledComponents.css)(["padding-right:", "px;", ";"], token.subMenu.scrollBarPadding, (0, _styled.scrollBarStyle)(props)), StyledMenuItemGroup, token.group.vericalMarginTop, StyledMenuItemGroupLabel, token.group.verticalHeight, token.group.verticalHeight, StyledMenuItem, StyledMenuItemContent, StyledSubMenuTitle, token.verticalHeight[$size], token.verticalHeight[$size], fontSize[token.verticalFontLevel[$size]], _StyledSvg3.StyledSvg, _SvgIcon.StyledSvg, fontSize[token.verticalIconFontLevel[$size]]);
    /**
     * 水平的一级菜单
     */
  } else if ($horizontalMode && !$sub) {
    modeStyle = (0, _styledComponents.css)(["white-space:nowrap;border-bottom:1px solid ", ";", " ", ",", ",", " ", ",", " ", " ", "{margin:0;padding:0 ", "px;}", "{position:relative;top:1px;margin-top:-1px;overflow-x:auto;}"], colorsPattern.border.normal, StyledMenuItem, StyledMenuItemContent, StyledSubMenuTitle, StyledMenuItemGroup, StyledMenuItemGroupLabel, StyledMenuItemGroup, StyledMenuItem, StyledMenuItemContent, token.item.horizontalPaddingHorizontal, StyledMenuScrollWrapper);
  } else if ($inlineMode) {
    modeStyle = (0, _styledComponents.css)(["", "{border-radius:", ";}"], StyledMenuItemContent, token.item.inlineBorderRadius[$size]);
  }

  if ($menuItemAlign) {
    alignStyle = (0, _styledComponents.css)(["", "{text-align:", ";}"], StyledMenuItemContent, $menuItemAlign);
  }

  return (0, _styledComponents.css)(["position:relative;box-sizing:border-box;width:100%;font-size:", "px;line-height:", "px;font-variant:tabular-nums;font-feature-settings:'tnum';padding:0;color:", ";background:", ";outline:none;transition:all ", "ms ", ";zoom:1;", ",", "{margin-right:", "px;font-size:", "px;color:", ";transition:color ", "ms ", ";}", " ", " ", " ", " ", ",", " ", "{margin-right:0;font-size:", "px;}"], fontSize[token.fontLevel], lineHeight[token.fontLevel], colorsPattern.text.text, token.background, duration.status, easing.status, _StyledSvg3.StyledSvg, _SvgIcon.StyledSvg, token.iconMarginRight, fontSize[token.iconFontLevel], token.iconColor, duration.status, easing.status, modeStyle, spacingStyle, alignStyle, _ExpandWrapper["default"], _StyledSvg3.StyledSvg, _ExpandWrapper["default"], _SvgIcon.StyledSvg, expandIconToken.size);
};
/* stylelint-enable */


var StyledMenu = _styledComponents["default"].div.withConfig({
  displayName: "StyledMenu"
})(["", ";"], menuCss);

exports.StyledMenu = StyledMenu;

var StyledMenuScrollWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledMenuScrollWrapper"
})(["overflow-x:hidden;overflow-y:auto;"]);

exports.StyledMenuScrollWrapper = StyledMenuScrollWrapper;

var subMenuTitleCss = function subMenuTitleCss(props) {
  var _props$theme2 = props.theme,
      token = _props$theme2.components.Menu,
      fontSize = _props$theme2.typography.spec.fontSize,
      _props$theme2$transit = _props$theme2.transition.pattern,
      easing = _props$theme2$transit.easing,
      duration = _props$theme2$transit.duration,
      $selected = props.$selected;
  return (0, _styledComponents.css)(["position:relative;display:flex;box-sizing:border-box;justify-content:space-between;align-items:center;height:", "px;line-height:", "px;margin:", "px ", "px;padding:0 ", "px;font-size:", "px;transition:all ", "ms ", ";cursor:pointer;", "{display:block;margin-right:", "px;", ";}", ""], token.height, token.height, token.item.marginVertical, token.item.marginHorizontal, token.item.paddingHorizontal, fontSize[token.fontLevel], duration.status, easing.status, StyledSubMenuTitleAndIconWrapper, token.iconMarginRight, _ellipsis["default"], $selected && (0, _styledComponents.css)(["", ",", "{color:", ";}"], _StyledSvg3.StyledSvg, _SvgIcon.StyledSvg, token.highlightIconColor));
};

var StyledSubMenuTitle = _styledComponents["default"].div.withConfig({
  displayName: "StyledSubMenuTitle"
})(["", ""], subMenuTitleCss);

exports.StyledSubMenuTitle = StyledSubMenuTitle;

var StyledSubMenuTitleAndIconWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledSubMenuTitleAndIconWrapper"
})(["& >:not(:only-child){vertical-align:middle;}"]);

exports.StyledSubMenuTitleAndIconWrapper = StyledSubMenuTitleAndIconWrapper;

var StyledSubMenuTitleWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledSubMenuTitleWrapper"
})(["", ";"], _ellipsis["default"]); // submenu
// eslint-disable-next-line complexity


exports.StyledSubMenuTitleWrapper = StyledSubMenuTitleWrapper;

var subMenuCss = function subMenuCss(props) {
  var $disabled = props.$disabled,
      $menuHasIcon = props.$menuHasIcon,
      $level = props.$level,
      $inlineMode = props.$inlineMode,
      $horizontalMode = props.$horizontalMode,
      $inlineCollapsed = props.$inlineCollapsed,
      $selected = props.$selected,
      $isOpen = props.$isOpen,
      _props$theme3 = props.theme,
      colorsPattern = _props$theme3.colors.pattern,
      lineHeight = _props$theme3.typography.spec.lineHeight,
      _props$theme3$transit = _props$theme3.transition.pattern,
      easing = _props$theme3$transit.easing,
      duration = _props$theme3$transit.duration,
      token = _props$theme3.components.Menu;
  var $subMenuToken = token.subMenu;
  var disabledStyle;

  if ($disabled) {
    disabledStyle = (0, _styledComponents.css)(["color:", ";cursor:not-allowed;> a{color:", ";pointer-events:none;}"], colorsPattern.text.disabled, colorsPattern.text.disabled);
  }

  var indentStyle;

  if ($level > 1 && $inlineMode && !$inlineCollapsed) {
    indentStyle = (0, _styledComponents.css)(["padding-left:", "px;"], $menuHasIcon ? token.subMenu.indentWithIcon : token.subMenu.indent);
  }

  var inlineCollapsedStyle;

  if ($level === 1 && $inlineCollapsed) {
    inlineCollapsedStyle = (0, _styledComponents.css)(["", "{margin-left:0;margin-right:0;}", "{margin-right:0;}", ",", "{margin-right:0;}"], StyledSubMenuTitle, StyledSubMenuTitleAndIconWrapper, _StyledSvg3.StyledSvg, _SvgIcon.StyledSvg);
  }

  var horizontalStyle;

  if ($horizontalMode && $level === 1) {
    $subMenuToken = (0, _extends2["default"])({}, $subMenuToken, {
      background: $subMenuToken.horizontalBackground,
      color: $subMenuToken.horizontalColor
    });
    horizontalStyle = (0, _styledComponents.css)(["position:relative;display:inline-block;vertical-align:bottom;border-bottom:2px solid transparent;", " ", " & > ", "{& > ", "{align-items:flex-start;line-height:", "px;", " ", "}}"], ($selected || $isOpen) && (0, _styledComponents.css)(["border-bottom:2px solid ", ";"], colorsPattern.text.highlight), !$disabled && (0, _styledComponents.css)(["&:hover{border-bottom:2px solid ", ";}"], colorsPattern.text.highlight), StyledSubMenuTitleWrapper, StyledSubMenuTitle, lineHeight[token.fontLevel], !$disabled && (0, _styledComponents.css)(["&:hover ", ",&:hover ", "{color:", ";transition:color ", "ms ", ";}"], _StyledSvg3.StyledSvg, _SvgIcon.StyledSvg, token.highlightIconColor, duration.status, easing.status), !$disabled && $isOpen && (0, _styledComponents.css)(["", ",", "{color:", ";}"], _StyledSvg3.StyledSvg, _SvgIcon.StyledSvg, token.highlightIconColor));
  }

  var titleStatusStyle;

  if ((!$inlineMode || $inlineCollapsed) && $isOpen) {
    titleStatusStyle = (0, _styledComponents.css)(["& > ", "{& > ", "{color:", ";background-color:", ";}}"], StyledSubMenuTitleWrapper, StyledSubMenuTitle, $subMenuToken.color.hover, $subMenuToken.background.hover);
  }

  return (0, _styledComponents.css)(["position:relative;transition:all ", "ms ", ";& > ", "{& > ", "{", ";}}", ";", ";", ";", ";", ";"], duration.status, easing.status, StyledSubMenuTitleWrapper, StyledSubMenuTitle, itemStatusStyle({
    $disabled: $disabled,
    $selected: $selected,
    $itemToken: $subMenuToken
  }), !$disabled && !$selected && titleStatusStyle, indentStyle, disabledStyle, inlineCollapsedStyle, horizontalStyle);
};

var StyledSubMenu = _styledComponents["default"].div.withConfig({
  displayName: "StyledSubMenu"
})(["", ""], subMenuCss);

exports.StyledSubMenu = StyledSubMenu;

var StyledMenuItemContent = _styledComponents["default"].div.withConfig({
  displayName: "StyledMenuItemContent"
})(["& >:not(:only-child){vertical-align:middle;}"]);

exports.StyledMenuItemContent = StyledMenuItemContent;

var StyledMenuItemText = _styledComponents["default"].span.withConfig({
  displayName: "StyledMenuItemText"
})(["opacity:1;"]); // menuitem


exports.StyledMenuItemText = StyledMenuItemText;

var menuItemCss = function menuItemCss(props) {
  var $isSelected = props.$isSelected,
      $disabled = props.$disabled,
      $menuHasIcon = props.$menuHasIcon,
      $inlineMode = props.$inlineMode,
      $horizontalMode = props.$horizontalMode,
      $inlineCollapsed = props.$inlineCollapsed,
      $level = props.$level,
      _props$theme4 = props.theme,
      _props$theme4$transit = _props$theme4.transition.pattern,
      duration = _props$theme4$transit.duration,
      easing = _props$theme4$transit.easing,
      colorsPattern = _props$theme4.colors.pattern,
      _props$theme4$typogra = _props$theme4.typography.spec,
      fontSize = _props$theme4$typogra.fontSize,
      lineHeight = _props$theme4$typogra.lineHeight,
      token = _props$theme4.components.Menu;
  var $itemToken = token.item;
  var indentStyle;

  if ($level > 1 && $inlineMode && !$inlineCollapsed) {
    indentStyle = (0, _styledComponents.css)(["padding-left:", "px;"], $menuHasIcon ? $itemToken.indentWithIcon : $itemToken.indent);
  }

  var inlineCollapsedStyle;

  if ($level === 1 && $inlineCollapsed) {
    inlineCollapsedStyle = (0, _styledComponents.css)(["margin-left:0;margin-right:0;", ",", "{margin-right:0;}", "{display:inline-block;max-width:0;opacity:0;line-height:0;}"], _StyledSvg3.StyledSvg, _SvgIcon.StyledSvg, StyledMenuItemText);
  }

  var horizontalStyle;

  if ($level === 1 && $horizontalMode) {
    $itemToken = (0, _extends2["default"])({}, $itemToken, {
      background: $itemToken.horizontalBackground,
      color: $itemToken.horizontalColor
    });
    horizontalStyle = (0, _styledComponents.css)(["position:relative;display:inline-block;vertical-align:bottom;border-bottom:2px solid transparent;", " ", "{line-height:", "px;}", ""], $isSelected && (0, _styledComponents.css)(["border-bottom:2px solid ", ";"], colorsPattern.text.highlight), StyledMenuItemContent, lineHeight[token.fontLevel], !$disabled && (0, _styledComponents.css)(["&:hover{border-bottom:2px solid ", ";}", "{&:hover ", ",&:hover ", "{color:", ";transition:color ", "ms ", ";}}"], colorsPattern.text.highlight, StyledMenuItemContent, _StyledSvg3.StyledSvg, _SvgIcon.StyledSvg, token.highlightIconColor, duration.status, easing.status));
  }

  return (0, _styledComponents.css)(["position:relative;display:flex;", "{box-sizing:border-box;flex:1;height:", "px;line-height:", "px;margin:", "px ", "px;padding:0 ", "px;font-size:", "px;transition:all ", "ms ", ";cursor:pointer;", ";", ";", ";", " ", ";}", "{transition:opacity ", "ms ", ",width ", "ms ", ";&:only-child a{display:block;}}", ";a{color:inherit;text-decoration:none;", ";&::before{position:absolute;top:0;right:0;bottom:0;left:0;background-color:transparent;content:'';}}"], StyledMenuItemContent, token.height, token.height, token.item.marginVertical, token.item.marginHorizontal, token.item.paddingHorizontal, fontSize[token.fontLevel], duration.status, easing.status, _ellipsis["default"], indentStyle, inlineCollapsedStyle, $isSelected && (0, _styledComponents.css)(["", ",", "{color:", ";}"], _StyledSvg3.StyledSvg, _SvgIcon.StyledSvg, token.highlightIconColor), itemStatusStyle({
    $disabled: $disabled,
    $selected: $isSelected,
    $itemToken: $itemToken
  }), StyledMenuItemText, duration.status, easing.status, duration.status, easing.status, horizontalStyle, _ellipsis["default"]);
};

var StyledMenuItem = _styledComponents["default"].div.withConfig({
  displayName: "StyledMenuItem"
})(["", ";"], menuItemCss);

exports.StyledMenuItem = StyledMenuItem;

var StyledMenuItemGroup = _styledComponents["default"].div.withConfig({
  displayName: "StyledMenuItemGroup"
})(["", ""], function (props) {
  var $menuHasIcon = props.$menuHasIcon,
      $level = props.$level,
      $inlineMode = props.$inlineMode,
      $inlineCollapsed = props.$inlineCollapsed,
      _props$theme5 = props.theme,
      _props$theme5$typogra = _props$theme5.typography.spec,
      fontSize = _props$theme5$typogra.fontSize,
      lineHeight = _props$theme5$typogra.lineHeight,
      token = _props$theme5.components.Menu;
  var groupToken = token.group;
  var indentStyle;

  if ($level > 1 && $inlineMode && !$inlineCollapsed) {
    indentStyle = (0, _styledComponents.css)(["padding-left:", "px;"], $menuHasIcon ? groupToken.indentWithIcon : groupToken.indent);
  }

  return (0, _styledComponents.css)(["", ";", "{display:block;box-sizing:border-box;font-size:", "px;line-height:", "px;height:", "px;background:", ";color:", ";padding:", "px ", "px 0;", ";}& > ", " ", "{padding-left:", "px;}"], indentStyle, StyledMenuItemGroupLabel, fontSize[groupToken.fontLevel], lineHeight[groupToken.fontLevel], groupToken.height, groupToken.background, groupToken.color, groupToken.paddingTop, groupToken.paddingHorizontal, _ellipsis["default"], StyledMenuItem, StyledMenuItemContent, groupToken.paddingHorizontal);
});

exports.StyledMenuItemGroup = StyledMenuItemGroup;

var StyledMenuItemGroupLabel = _styledComponents["default"].div.withConfig({
  displayName: "StyledMenuItemGroupLabel"
})(["user-select:none;"]);

exports.StyledMenuItemGroupLabel = StyledMenuItemGroupLabel;

var StyledMenuDivider = _styledComponents["default"].div.withConfig({
  displayName: "StyledMenuDivider"
})(["height:1px;"]);

exports.StyledMenuDivider = StyledMenuDivider;

var StyledMenuWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledMenuWrapper"
})(["", ""], function (props) {
  var $width = props.$width,
      $height = props.$height,
      $inlineMode = props.$inlineMode,
      $verticalMode = props.$verticalMode,
      $inlineCollapsed = props.$inlineCollapsed,
      _props$theme6 = props.theme,
      colors = _props$theme6.colors,
      shadows = _props$theme6.shadows,
      _props$theme6$transit = _props$theme6.transition.pattern,
      easing = _props$theme6$transit.easing,
      duration = _props$theme6$transit.duration,
      _props$theme6$compone = _props$theme6.components.Menu,
      wrapperToken = _props$theme6$compone.wrapper,
      dividerToken = _props$theme6$compone.divider;
  return (0, _styledComponents.css)(["height:100%;background:", ";border-radius:", ";padding:0;overflow:auto;transition:all ", "ms ", ";", ";", ";", ";", ";", ";", " ", "{background:", ";margin:", "px ", "px;}"], wrapperToken.background, wrapperToken.borderRadius, duration.status, easing.status, $inlineMode && "width: 100%", $width && "width: ".concat((0, _addPx["default"])($width)), $height && "height: ".concat((0, _addPx["default"])($height)), $verticalMode && "box-shadow: ".concat(shadows.pattern.popper.normal), $inlineCollapsed && "width: ".concat(wrapperToken.inlineCollapsedWidth, "px"), (0, _styled.scrollBarStyle)((0, _extends2["default"])({}, props, {
    hidden: $inlineCollapsed
  })), StyledMenuDivider, colors.pattern.background.divider, dividerToken.paddingVertical, $inlineMode ? dividerToken.inlinePaddingHorizontal : dividerToken.paddingHorizontal);
});

exports.StyledMenuWrapper = StyledMenuWrapper;