"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _useEffectOnce2 = require("@muya-ui/utils/lib/hooks/useEffectOnce");

var _CloseIcon2 = require("@muya-ui/theme-light/lib/icons/CloseIcon");

var _ReloadIcon2 = require("@muya-ui/theme-light/lib/icons/ReloadIcon");

var _ReminderIcon2 = require("@muya-ui/theme-light/lib/icons/ReminderIcon");

var _SuccessIcon2 = require("@muya-ui/theme-light/lib/icons/SuccessIcon");

var _ClearIcon2 = require("@muya-ui/theme-light/lib/icons/ClearIcon");

var _InformIcon2 = require("@muya-ui/theme-light/lib/icons/InformIcon");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _Spin = _interopRequireDefault(require("../Spin"));

var _Typography = _interopRequireDefault(require("../Typography"));

var _Title = require("../Typography/Title");

var _forkHandler = _interopRequireDefault(require("../utils/forkHandler"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _withTheme = require("../utils/withTheme");

var _excluded = ["item", "state", "timeout", "onClose", "enterFrom", "expireQueue", "hoverStop", "onMouseEnter", "onMouseLeave", "className", "style"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledItem = _styledComponents["default"].div.withConfig({
  displayName: "StyledItem"
})(["", ""], function (props) {
  var theme = props.theme;
  var colors = theme.colors;
  var token = theme.components.Notification.notification;
  var itemMarginBottom = token.itemMarginBottom,
      borderRadius = token.borderRadius,
      width = token.width,
      minHeight = token.minHeight,
      shadow = token.shadow;
  return (0, _styledComponents.css)(["display:flex;flex-direction:column;background:", ";box-shadow:", ";border-radius:", ";margin-bottom:", "px;width:", "px;min-height:", "px;pointer-events:all;"], colors.pattern.background.higher, shadow, borderRadius, itemMarginBottom, width, minHeight);
});

var BaseNode = _styledComponents["default"].div.withConfig({
  displayName: "BaseNode"
})([""]);

var StyledContent = _styledComponents["default"].div.withConfig({
  displayName: "StyledContent"
})(["", ""], function (props) {
  var theme = props.theme;
  var token = theme.components.Notification.notification;
  var contentStyle = token.contentStyle;
  return (0, _styledComponents.css)(["width:100%;position:relative;box-sizing:border-box;padding:", ";"], contentStyle.plainPadding);
});

var StyledActions = _styledComponents["default"].div.withConfig({
  displayName: "StyledActions"
})(["", ""], function (props) {
  var theme = props.theme;
  var token = theme.components.Notification.notification.actionsStyle;
  return (0, _styledComponents.css)(["padding:", ";"], token.padding);
});

var StyledIcon = _styledComponents["default"].div.withConfig({
  displayName: "StyledIcon"
})(["", ""], function (props) {
  var theme = props.theme;
  var token = theme.components.Notification.notification;
  var iconStyle = token.iconStyle;
  return (0, _styledComponents.css)(["position:absolute;font-size:", "px;line-height:1;top:", "px;left:", "px;"], iconStyle.size, iconStyle.top, iconStyle.left);
});

var StyledClose = (0, _styledComponents["default"])(_IconButton["default"]).withConfig({
  displayName: "StyledClose"
})([""]);
var defaultStyles = {
  self: '',
  close: '',
  container: '',
  icon: '',
  title: '',
  content: '',
  contentWrapper: ''
};
var NotificationItemWithoutStyle = (0, _memoForwardRef["default"])(function (props, ref) {
  var item = props.item,
      state = props.state,
      timeout = props.timeout,
      onClose = props.onClose,
      enterFrom = props.enterFrom,
      expireQueue = props.expireQueue,
      hoverStop = props.hoverStop,
      onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave,
      className = props.className,
      _props$style = props.style,
      style = _props$style === void 0 ? {} : _props$style,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var innerStyles = (0, _useStyles["default"])('notification-item', defaultStyles, item.styles);
  var token = theme.components.Notification;
  var iconNode;

  if (item.icon) {
    iconNode = /*#__PURE__*/_react["default"].createElement(StyledIcon, (0, _extends2["default"])({}, innerStyles.icon, {
      theme: theme
    }), item.icon);
  } else if (item.type && item.type !== 'loading') {
    var tokenIcon = (0, _extends2["default"])({
      info: _InformIcon2.InformIcon,
      error: _ClearIcon2.ClearIcon,
      success: _SuccessIcon2.SuccessIcon,
      warning: _ReminderIcon2.ReminderIcon,
      loading: _ReloadIcon2.ReloadIcon
    }, token.icon);
    var Icon = tokenIcon[item.type];
    var bgColor = token.iconBgColor[item.type];
    iconNode = /*#__PURE__*/_react["default"].createElement(StyledIcon, (0, _extends2["default"])({}, innerStyles.icon, {
      theme: theme
    }), /*#__PURE__*/_react["default"].createElement(Icon, {
      bgColor: bgColor
    }));
  } else if (item.type && item.type === 'loading') {
    iconNode = /*#__PURE__*/_react["default"].createElement(StyledIcon, (0, _extends2["default"])({}, innerStyles.icon, {
      theme: theme
    }), /*#__PURE__*/_react["default"].createElement(_Spin["default"], null));
  }

  var titleNode;

  if (typeof item.title === 'string') {
    titleNode = /*#__PURE__*/_react["default"].createElement(_Typography["default"].Title, (0, _extends2["default"])({}, innerStyles.title, {
      level: token.notification.titleLevel,
      ellipsis: true
    }), item.title);
  } else {
    titleNode = item.title;
  }

  var contentNode;

  if (typeof item.content === 'string') {
    contentNode = /*#__PURE__*/_react["default"].createElement(_Typography["default"].Text, innerStyles.content, item.content);
  } else {
    contentNode = item.content;
  }

  var CloseIcon = token.notification.closeBtn || _CloseIcon2.CloseIcon;
  var notFixed = (0, _react.useRef)(!item.fixed);
  var handleMouseEnter = (0, _forkHandler["default"])(function () {
    if (hoverStop && notFixed.current) {
      expireQueue.fixedItem(item.id);
    }
  }, onMouseEnter);
  var handleMouseLeave = (0, _forkHandler["default"])(function () {
    if (hoverStop && notFixed.current) {
      expireQueue.unFixedItem(item.id);
      expireQueue.tick();
    }
  }, onMouseLeave);
  var containerProps = (0, _extends2["default"])({
    style: (0, _extends2["default"])({}, innerStyles.self.style, style),
    className: [className, innerStyles.self.className].join(' ')
  }, otherProps);
  (0, _useEffectOnce2.useEffectOnce)(function () {
    return function () {
      if (item.onClose) {
        item.onClose();
      }
    };
  });
  return /*#__PURE__*/_react["default"].createElement(BaseNode, (0, _extends2["default"])({
    onMouseEnter: handleMouseEnter,
    onMouseLeave: handleMouseLeave,
    ref: ref
  }, containerProps), /*#__PURE__*/_react["default"].createElement(StyledItem, (0, _extends2["default"])({}, innerStyles.container, {
    theme: theme
  }), /*#__PURE__*/_react["default"].createElement(StyledContent, (0, _extends2["default"])({
    theme: theme
  }, innerStyles.contentWrapper), iconNode, titleNode, contentNode, /*#__PURE__*/_react["default"].createElement(StyledClose, (0, _extends2["default"])({
    theme: theme
  }, innerStyles.close, {
    onClick: onClose
  }), /*#__PURE__*/_react["default"].createElement(CloseIcon, null))), item.actions && /*#__PURE__*/_react["default"].createElement(StyledActions, null, item.actions)));
});
var NotificationItem = (0, _styledComponents["default"])(NotificationItemWithoutStyle).withConfig({
  displayName: "NotificationItem"
})(["", ""], function (props) {
  var theme = props.theme,
      item = props.item,
      state = props.state,
      timeout = props.timeout,
      _props$enterFrom = props.enterFrom,
      enterFrom = _props$enterFrom === void 0 ? 'right' : _props$enterFrom;
  var colors = theme.colors,
      transition = theme.transition;
  var containerTop = theme.components.Notification.containerTop;
  var token = theme.components.Notification.notification;
  var contentStyle = token.contentStyle,
      lineMaxChar = token.lineMaxChar;
  var maxHeight = item.maxHeight || 120;
  var hasIcon = item.type || item.icon;

  if (typeof item.content === 'string' && item.content.length > 40) {
    var lineNum = Math.ceil(item.content.length / lineMaxChar);
    maxHeight = token.minHeight + lineNum * contentStyle.lineHeight;
  }

  var left = containerTop + token.width;
  left = enterFrom === 'right' ? left : -left;
  var transitionMap = {
    entering: '',
    entered: (0, _styledComponents.css)(["max-height:", "px;transform:translate(0,0);transition-timing-function:", ";opacity:1;"], maxHeight, transition.pattern.easing.enter),
    exiting: (0, _styledComponents.css)(["max-height:0;opacity:0;transform:translate(0,0);transition-timing-function:", ";"], transition.pattern.easing.leave),
    exited: '',
    unmounted: ''
  };
  var transformCSS = transitionMap[state] || (0, _styledComponents.css)(["max-height:0;opacity:0;transform:translate(0,0);"]);
  return (0, _styledComponents.css)(["transition:all ", "ms ", ";pointer-events:all;display:flex;align-items:center;justify-content:center;", " ", " & ", "{margin-bottom:", "px;}& ", "{color:", ";}& ", "{position:absolute;font-size:", "px;top:", "px;right:", "px;}"], timeout, token.easing, transformCSS, hasIcon && (0, _styledComponents.css)(["& ", "{padding:", ";}"], StyledContent, contentStyle.iconPadding), _Title.StyledTitle, token.titleMarginBottom, StyledIcon, colors.pattern.feature[item.type || 'success'], StyledClose, token.closeStyle.size, token.closeStyle.top, token.closeStyle.right);
});

var _default = (0, _withTheme.withThemeForStyled)(NotificationItem);

exports["default"] = _default;