"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _reactTransitionGroup = require("react-transition-group");

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Portal = _interopRequireDefault(require("../Portal"));

var _withTheme = require("../utils/withTheme");

var _useNotificationList = _interopRequireDefault(require("./useNotificationList"));

var _excluded = ["onMouseEnter", "onMouseLeave", "position", "expireQueue", "hoverStop", "fullScreen", "children", "container"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var BaseNode = _styledComponents["default"].div.withConfig({
  displayName: "BaseNode"
})([""]);

var NotificationListWithoutStyle = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave,
      position = props.position,
      expireQueue = props.expireQueue,
      hoverStop = props.hoverStop,
      fullScreen = props.fullScreen,
      children = props.children,
      container = props.container,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var containerRef = (0, _react.useRef)(null);
  var handleRef = (0, _useForkRef2.useForkRef)(containerRef, ref);

  var _useExpireQueue = (0, _useNotificationList["default"])({
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave,
    position: position,
    expireQueue: expireQueue,
    hoverStop: hoverStop,
    fullScreen: fullScreen
  }, containerRef),
      items = _useExpireQueue.items,
      handleMouseEnter = _useExpireQueue.handleMouseEnter,
      handleMouseLeave = _useExpireQueue.handleMouseLeave;

  var poolTimeout = expireQueue.setting.timeout;
  return /*#__PURE__*/_react["default"].createElement(_Portal["default"], {
    container: container
  }, /*#__PURE__*/_react["default"].createElement(BaseNode, (0, _extends2["default"])({
    ref: handleRef,
    onMouseEnter: handleMouseEnter,
    onMouseLeave: handleMouseLeave
  }, otherProps), /*#__PURE__*/_react["default"].createElement(_reactTransitionGroup.TransitionGroup, null, items.map(function (item) {
    return /*#__PURE__*/_react["default"].createElement(_reactTransitionGroup.Transition, {
      key: item.id,
      timeout: {
        enter: 10,
        exit: poolTimeout
      }
    }, function (state) {
      return children(state, item);
    });
  }))));
});

var NotificationList = (0, _styledComponents["default"])(NotificationListWithoutStyle).withConfig({
  displayName: "NotificationList"
})(["", ""], function (props) {
  var theme = props.theme,
      position = props.position;
  var _theme$components$Not = theme.components.Notification,
      containerCenterTop = _theme$components$Not.containerCenterTop,
      containerTop = _theme$components$Not.containerTop,
      containerBottom = _theme$components$Not.containerBottom;
  var positionCss;

  if (position === 'top-center') {
    positionCss = (0, _styledComponents.css)(["top:", "px;left:0;right:0;width:100%;flex-direction:column;"], containerCenterTop);
  } else if (position === 'top-left') {
    positionCss = (0, _styledComponents.css)(["top:", "px;left:", "px;flex-direction:column;"], containerTop, containerTop);
  } else if (position === 'top-right') {
    positionCss = (0, _styledComponents.css)(["top:", "px;right:", "px;flex-direction:column;"], containerTop, containerTop);
  } else if (position === 'bottom-left') {
    positionCss = (0, _styledComponents.css)(["bottom:", "px;left:", "px;flex-direction:column-reverse;"], containerBottom, containerTop);
  } else if (position === 'bottom-right') {
    positionCss = (0, _styledComponents.css)(["bottom:", "px;right:", "px;flex-direction:column-reverse;"], containerBottom, containerTop);
  }

  return (0, _styledComponents.css)(["position:fixed;pointer-events:none;z-index:", ";", ""], theme.zIndex.pattern.toast, positionCss);
});

var _default = (0, _withTheme.withThemeForStyled)(NotificationList);

exports["default"] = _default;