"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _theme = require("@muya-ui/theme-light/lib/theme");

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _styledComponents = require("styled-components");

var _ExpireQueue = _interopRequireDefault(require("./ExpireQueue"));

var _NotificationItem = _interopRequireDefault(require("./NotificationItem"));

var _NotificationList = _interopRequireDefault(require("./NotificationList"));

var notification = {
  _expQueue: new _ExpireQueue["default"](),
  _autoInit: function _autoInit() {
    if (this._init) {
      return;
    }

    this._init = true;
    var opt = this._opt || {};
    var doc = window.document;
    this._mountEl = opt.container || doc.body;
    var containerElement = doc.createElement('div');

    this._mountEl.appendChild(containerElement);

    this._container = containerElement;
    var theme = opt.theme || _theme.muyaThemeLight;
    var poolSettings = opt.setting || theme.components.Notification.notification.queueSetting;
    var expireQueue = new _ExpireQueue["default"]();
    this._expQueue = expireQueue;
    expireQueue.reset(poolSettings);
    var position = opt.position || 'top-right';
    this._position = position;

    var children = /*#__PURE__*/_react["default"].createElement(_styledComponents.ThemeProvider, {
      theme: theme
    }, /*#__PURE__*/_react["default"].createElement(_NotificationList["default"], {
      fullScreen: true,
      className: "".concat(theme.prefix, "-notification-list"),
      position: position,
      expireQueue: expireQueue,
      container: containerElement
    }, function (state, item) {
      var enterFrom = (0, _includes2["default"])(position, 'left') ? 'left' : 'right';
      return /*#__PURE__*/_react["default"].createElement(_NotificationItem["default"], {
        item: item,
        enterFrom: enterFrom,
        state: state,
        expireQueue: expireQueue,
        hoverStop: true,
        timeout: expireQueue.setting.timeout,
        onClose: function onClose() {
          return expireQueue.remove(item.id);
        }
      });
    }));

    if (opt.styleSheet) {
      _reactDom["default"].render( /*#__PURE__*/_react["default"].createElement(_styledComponents.StyleSheetManager, {
        target: opt.styleSheet
      }, children), containerElement);
    } else {
      _reactDom["default"].render(children, containerElement);
    }
  },
  destroy: function destroy() {
    if (this._container) {
      _reactDom["default"].unmountComponentAtNode(this._container);

      if (this._mountEl) {
        this._mountEl.removeChild(this._container);
      }

      this._container = undefined;
    }

    this._init = false;
  },
  config: function config(opt) {
    this.destroy();
    this._opt = opt;

    this._autoInit();
  },
  _unshiftWithType: function _unshiftWithType(type, item) {
    item.type = type;
    return this.add(item);
  },
  success: function success(item) {
    return this._unshiftWithType('success', item);
  },
  error: function error(item) {
    return this._unshiftWithType('error', item);
  },
  info: function info(item) {
    return this._unshiftWithType('info', item);
  },
  warning: function warning(item) {
    return this._unshiftWithType('warning', item);
  },
  loading: function loading(item) {
    return this._unshiftWithType('loading', item);
  },
  close: function close(id) {
    this._expQueue.remove(id);
  },
  add: function add(item) {
    var opt = this._opt || {};
    var position = opt.position || 'top-right';

    if (position.includes('bottom')) {
      return this._expQueue.unshift(item);
    }

    return this._expQueue.push(item);
  }
}; // 保证第一次进入的时候动画效果

notification.config({});
var _default = notification;
exports["default"] = _default;