"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useNotificationList;

var _useAfterEffect2 = require("@muya-ui/utils/lib/hooks/useAfterEffect");

var _useEffectOnce2 = require("@muya-ui/utils/lib/hooks/useEffectOnce");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _react = require("react");

var _forkHandler = _interopRequireDefault(require("../utils/forkHandler"));

function useNotificationList(props, containerRef) {
  var onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave,
      position = props.position,
      expireQueue = props.expireQueue,
      hoverStop = props.hoverStop,
      fullScreen = props.fullScreen;
  var poolTimeout = expireQueue.setting.timeout;

  var _useState = (0, _react.useState)(expireQueue.items),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      items = _useState2[0],
      setItems = _useState2[1];

  var update = function update() {
    var newItems = expireQueue.items;
    setItems(newItems);

    if (newItems.length) {
      expireQueue.tick();
    }
  };

  (0, _useEffectOnce2.useEffectOnce)(function () {
    expireQueue.on('update', update);
    update();
    return function () {
      expireQueue.removeListener('update', update);
    };
  });
  var lastMax = (0, _react.useRef)(expireQueue.setting.max);
  (0, _useAfterEffect2.useAfterEffect)(function () {
    if (containerRef.current && fullScreen) {
      var _containerRef$current = containerRef.current.getBoundingClientRect(),
          top = _containerRef$current.top,
          bottom = _containerRef$current.bottom;

      if (top < 0 || bottom > window.innerHeight) {
        if ((0, _includes2["default"])(position, 'top')) {
          expireQueue.shift();
        } else {
          expireQueue.pop();
        }

        lastMax.current = expireQueue.setting.max;
        expireQueue.reset({
          max: expireQueue.length
        });
      } else {
        expireQueue.reset({
          max: lastMax.current
        });
      }
    }
  }, poolTimeout);
  var handleMouseEnter = (0, _forkHandler["default"])(function () {
    if (hoverStop) {
      expireQueue.stop();
    }
  }, onMouseEnter);
  var handleMouseLeave = (0, _forkHandler["default"])(function () {
    if (hoverStop) {
      expireQueue.tick();
    }
  }, onMouseLeave);
  return {
    items: items,
    handleMouseEnter: handleMouseEnter,
    handleMouseLeave: handleMouseLeave,
    setItems: setItems
  };
}