"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _useLocale = _interopRequireDefault(require("../Locale/useLocale"));

var _Select = _interopRequireWildcard(require("../Select"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _PaginationPagerButton = _interopRequireDefault(require("./PaginationPagerButton"));

var _PaginationPagerEllipsis = _interopRequireDefault(require("./PaginationPagerEllipsis"));

var _styled = require("./styled");

var _usePagination2 = _interopRequireDefault(require("./usePagination"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  wrapper: '',
  input: '',
  numberItem: '',
  simpleNumberItem: '',
  simpleArrow: '',
  jumpText: ''
};
var Pagination = (0, _memoForwardRef["default"])(function (props, ref) {
  var locale = (0, _useLocale["default"])();
  var theme = (0, _useTheme["default"])();
  var _theme$components$Pag = theme.components.Pagination,
      inputWidth = _theme$components$Pag.inputWidth,
      simpleSizeMap = _theme$components$Pag.simpleSizeMap;
  var itemRender = props.itemRender,
      _props$showTotal = props.showTotal,
      showTotal = _props$showTotal === void 0 ? false : _props$showTotal,
      _props$totalRecords = props.totalRecords,
      totalRecords = _props$totalRecords === void 0 ? 0 : _props$totalRecords,
      align = props.align,
      hideOnSinglePage = props.hideOnSinglePage;

  var _usePagination = (0, _usePagination2["default"])(props),
      finalCurrent = _usePagination.finalCurrent,
      simpleQuickJumperValue = _usePagination.simpleQuickJumperValue,
      quickJumperValue = _usePagination.quickJumperValue,
      pageAmount = _usePagination.pageAmount,
      visiblePieces = _usePagination.visiblePieces,
      prevIsDisabled = _usePagination.prevIsDisabled,
      nextIsDisabled = _usePagination.nextIsDisabled,
      finalPageSize = _usePagination.finalPageSize,
      handleQuickJumperInputPressEnter = _usePagination.handleQuickJumperInputPressEnter,
      handleQuickJumperInputBlur = _usePagination.handleQuickJumperInputBlur,
      handleQuickJumperInputChange = _usePagination.handleQuickJumperInputChange,
      handleSimpleQuickJumperInputBlur = _usePagination.handleSimpleQuickJumperInputBlur,
      handleSimpleQuickJumperInputChange = _usePagination.handleSimpleQuickJumperInputChange,
      handleSimpleQuickJumperInputFocus = _usePagination.handleSimpleQuickJumperInputFocus,
      handlePrev = _usePagination.handlePrev,
      handleNext = _usePagination.handleNext,
      handlePageSizeChange = _usePagination.handlePageSizeChange,
      restProps = _usePagination.restProps,
      size = _usePagination.size,
      showQuickJumper = _usePagination.showQuickJumper,
      showPageSizeChanger = _usePagination.showPageSizeChanger,
      pageSizeOptions = _usePagination.pageSizeOptions,
      isDarkBackground = _usePagination.isDarkBackground,
      simple = _usePagination.simple,
      styles = _usePagination.styles;

  var innerStyles = (0, _useStyles["default"])('pagination', defaultStyles, styles);

  var simpleNode = _react["default"].useMemo(function () {
    if (!simple) {
      return;
    }

    var currentPageNode;

    if (showQuickJumper) {
      currentPageNode = /*#__PURE__*/_react["default"].createElement(_styled.PaginationInput, (0, _extends2["default"])({
        theme: theme,
        width: inputWidth[simpleSizeMap[size]],
        size: simpleSizeMap[size],
        value: simpleQuickJumperValue,
        onChange: handleSimpleQuickJumperInputChange,
        onPressEnter: handleQuickJumperInputPressEnter,
        onBlur: handleSimpleQuickJumperInputBlur,
        onFocus: handleSimpleQuickJumperInputFocus
      }, innerStyles.input));
    } else {
      currentPageNode = /*#__PURE__*/_react["default"].createElement(_styled.StyledSimpleActivePage, {
        theme: theme
      }, finalCurrent);
    }

    return /*#__PURE__*/_react["default"].createElement(_styled.StyledSimplePageNum, (0, _extends2["default"])({
      size: size,
      theme: theme
    }, innerStyles.simpleNumberItem), currentPageNode, /*#__PURE__*/_react["default"].createElement(_styled.StyledSimplePageSplit, null, "/"), /*#__PURE__*/_react["default"].createElement(_styled.StyledSimplePageText, null, pageAmount));
  }, [finalCurrent, handleQuickJumperInputPressEnter, handleSimpleQuickJumperInputBlur, handleSimpleQuickJumperInputChange, handleSimpleQuickJumperInputFocus, innerStyles.input, innerStyles.simpleNumberItem, inputWidth, pageAmount, showQuickJumper, simple, simpleQuickJumperValue, simpleSizeMap, size, theme]);

  var normalNode = _react["default"].useMemo(function () {
    if (simple) {
      return;
    }

    return visiblePieces.map(function (visiblePiece, index) {
      var key = "".concat(visiblePiece.type, "-").concat(index);

      if (visiblePiece.type === 'ellipsis') {
        return /*#__PURE__*/_react["default"].createElement(_PaginationPagerEllipsis["default"], (0, _extends2["default"])({
          onClick: visiblePiece.onClick,
          size: size,
          isDarkBackground: isDarkBackground
        }, innerStyles.numberItem, {
          type: visiblePiece["goto"],
          key: key,
          itemRender: itemRender,
          page: visiblePiece.page
        }));
      }

      var node = /*#__PURE__*/_react["default"].createElement(_styled.StyledPaginationText, null, visiblePiece.pageNumber);

      var children = itemRender ? itemRender(Number(visiblePiece.pageNumber), 'page', node) : node;
      return /*#__PURE__*/_react["default"].createElement(_styled.StyledPageNumber, (0, _extends2["default"])({
        key: key,
        onClick: visiblePiece.onClick,
        isActive: visiblePiece.pageNumber === finalCurrent,
        theme: theme,
        size: size,
        isDarkBackground: isDarkBackground
      }, innerStyles.numberItem), children);
    });
  }, [finalCurrent, innerStyles.numberItem, isDarkBackground, itemRender, simple, size, theme, visiblePieces]);

  var pagerStyleItem = simple ? innerStyles.simpleArrow : innerStyles.numberItem;
  var basePagerProps = (0, _extends2["default"])({
    simple: simple,
    size: size,
    isDarkBackground: isDarkBackground,
    itemRender: itemRender,
    finalCurrent: finalCurrent
  }, pagerStyleItem);

  var normalQuickJumperNode = _react["default"].useMemo(function () {
    if (simple || !showQuickJumper) {
      return;
    }

    return /*#__PURE__*/_react["default"].createElement(_styled.StyledPaginationJump, {
      theme: theme,
      size: size
    }, /*#__PURE__*/_react["default"].createElement(_styled.StyledPaginationJumpText, (0, _extends2["default"])({
      theme: theme,
      size: size
    }, innerStyles.jumpText), locale['Pagination.jumpTo']), /*#__PURE__*/_react["default"].createElement(_styled.PaginationInput, (0, _extends2["default"])({
      theme: theme,
      width: inputWidth[size],
      size: size,
      value: quickJumperValue,
      onChange: handleQuickJumperInputChange,
      onPressEnter: handleQuickJumperInputPressEnter,
      onBlur: handleQuickJumperInputBlur
    }, innerStyles.input)), /*#__PURE__*/_react["default"].createElement(_styled.StyledPaginationJumpText, (0, _extends2["default"])({
      theme: theme,
      size: size
    }, innerStyles.jumpText), locale['Pagination.page']));
  }, [handleQuickJumperInputBlur, handleQuickJumperInputChange, handleQuickJumperInputPressEnter, innerStyles.input, innerStyles.jumpText, inputWidth, locale, quickJumperValue, showQuickJumper, simple, size, theme]);

  var pageSizeNode = _react["default"].useMemo(function () {
    if (simple || !showPageSizeChanger) {
      return;
    }

    return /*#__PURE__*/_react["default"].createElement(_styled.StyledPaginationJump, {
      theme: theme,
      size: size
    }, /*#__PURE__*/_react["default"].createElement(_Select["default"], {
      value: finalPageSize,
      size: size,
      onChange: handlePageSizeChange,
      autoResize: true
    }, pageSizeOptions.map(function (item) {
      return /*#__PURE__*/_react["default"].createElement(_Select.Option, {
        value: item,
        key: item.toString()
      }, "".concat(item, " ").concat(locale['Pagination.pageSizeChangerSuffix']));
    })));
  }, [finalPageSize, handlePageSizeChange, locale, pageSizeOptions, showPageSizeChanger, simple, size, theme]);

  var paginationTotalNode = _react["default"].useMemo(function () {
    if (!showTotal) return null;
    var totalNode = typeof showTotal === 'function' ? showTotal(totalRecords) : locale['Pagination.totalText'].replace(/{{total}}/, String(totalRecords));
    return /*#__PURE__*/_react["default"].createElement(_styled.StyledPaginationTotalText, {
      theme: theme,
      size: size
    }, totalNode);
  }, [locale, showTotal, size, theme, totalRecords]); // 如果只有一页，且没有开启pageSize切换器


  if (pageAmount === 1 && hideOnSinglePage && !pageSizeNode) return null;
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledPaginationWrap, (0, _extends2["default"])({
    ref: ref,
    theme: theme,
    $align: align
  }, innerStyles.wrapper, restProps), paginationTotalNode, /*#__PURE__*/_react["default"].createElement(_PaginationPagerButton["default"], (0, _extends2["default"])({
    onClick: handlePrev,
    type: "prev",
    disabled: prevIsDisabled
  }, basePagerProps)), simpleNode, normalNode, /*#__PURE__*/_react["default"].createElement(_PaginationPagerButton["default"], (0, _extends2["default"])({
    onClick: handleNext,
    type: "next",
    disabled: nextIsDisabled
  }, basePagerProps)), pageSizeNode, normalQuickJumperNode);
});
var _default = Pagination;
exports["default"] = _default;