"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _GuildRightIcon2 = require("@muya-ui/theme-light/lib/icons/GuildRightIcon");

var _GuildLeftIcon2 = require("@muya-ui/theme-light/lib/icons/GuildLeftIcon");

var _react = _interopRequireDefault(require("react"));

var _useLocale = _interopRequireDefault(require("../Locale/useLocale"));

var _Tooltip = _interopRequireDefault(require("../Tooltip"));

var _addPx = _interopRequireDefault(require("../utils/addPx"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _excluded = ["type", "itemRender", "finalCurrent"];
var pagerIconStyle = {
  verticalAlign: 'middle'
};

var _default = /*#__PURE__*/_react["default"].memo(function (props) {
  var theme = (0, _useTheme["default"])();
  var locale = (0, _useLocale["default"])();
  var _theme$components$Pag = theme.components.Pagination,
      _theme$components$Pag2 = _theme$components$Pag.PageForwardIcon,
      PageForwardIcon = _theme$components$Pag2 === void 0 ? _GuildLeftIcon2.GuildLeftIcon : _theme$components$Pag2,
      _theme$components$Pag3 = _theme$components$Pag.PageBackwardIcon,
      PageBackwardIcon = _theme$components$Pag3 === void 0 ? _GuildRightIcon2.GuildRightIcon : _theme$components$Pag3,
      tooltipDelay = _theme$components$Pag.tooltipDelay,
      pageIconSize = _theme$components$Pag.pageIconSize;
  var type = props.type,
      itemRender = props.itemRender,
      finalCurrent = props.finalCurrent,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var Icon = type === 'next' ? PageBackwardIcon : PageForwardIcon;
  var title = type === 'next' ? locale['Pagination.nextPage'] : locale['Pagination.prevPage'];
  var page = type === 'prev' ? finalCurrent - 1 : finalCurrent + 1;

  var iconNode = /*#__PURE__*/_react["default"].createElement(Icon, {
    fontSize: (0, _addPx["default"])(pageIconSize),
    style: pagerIconStyle
  });

  var children = itemRender ? itemRender(page, type, iconNode) : iconNode;
  return /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], {
    title: title,
    placement: "top",
    enterDelay: tooltipDelay
  }, /*#__PURE__*/_react["default"].createElement(_styled.StyledPageArrow, (0, _extends2["default"])({
    theme: theme,
    itemRender: itemRender
  }, other), children));
});

exports["default"] = _default;