"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _SpeedIcon2 = require("@muya-ui/theme-light/lib/icons/SpeedIcon");

var _SpeedLeftIcon2 = require("@muya-ui/theme-light/lib/icons/SpeedLeftIcon");

var _MoreIcon2 = require("@muya-ui/theme-light/lib/icons/MoreIcon");

var _react = _interopRequireDefault(require("react"));

var _useLocale = _interopRequireDefault(require("../Locale/useLocale"));

var _Tooltip = _interopRequireDefault(require("../Tooltip"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _excluded = ["type", "itemRender", "page"];

var _default = /*#__PURE__*/_react["default"].memo(function (props) {
  var theme = (0, _useTheme["default"])();
  var locale = (0, _useLocale["default"])();
  var _theme$components$Pag = theme.components.Pagination,
      _theme$components$Pag2 = _theme$components$Pag.MoreIcon,
      MoreIcon = _theme$components$Pag2 === void 0 ? _MoreIcon2.MoreIcon : _theme$components$Pag2,
      _theme$components$Pag3 = _theme$components$Pag.FastBackwardIcon,
      FastBackwardIcon = _theme$components$Pag3 === void 0 ? _SpeedLeftIcon2.SpeedLeftIcon : _theme$components$Pag3,
      _theme$components$Pag4 = _theme$components$Pag.FastForwardIcon,
      FastForwardIcon = _theme$components$Pag4 === void 0 ? _SpeedIcon2.SpeedIcon : _theme$components$Pag4,
      tooltipDelay = _theme$components$Pag.tooltipDelay;
  var type = props.type,
      itemRender = props.itemRender,
      page = props.page,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var Icon = type === 'next' ? FastForwardIcon : FastBackwardIcon;
  var title = type === 'next' ? locale['Pagination.next5'] : locale['Pagination.prev5'];

  var iconNode = /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_styled.StyledMoreIcon, {
    theme: theme
  }, /*#__PURE__*/_react["default"].createElement(MoreIcon, null)), /*#__PURE__*/_react["default"].createElement(_styled.StyledJumpIcon, {
    theme: theme
  }, /*#__PURE__*/_react["default"].createElement(Icon, null)));

  var itemType = "jump-".concat(type);
  var children = itemRender ? itemRender(page, itemType, iconNode) : iconNode;
  return /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], {
    title: title,
    placement: "top",
    enterDelay: tooltipDelay
  }, /*#__PURE__*/_react["default"].createElement(_styled.StyledPaginationEllipsis, (0, _extends2["default"])({
    theme: theme
  }, other), children));
});

exports["default"] = _default;