"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledSimplePageText = exports.StyledSimplePageSplit = exports.StyledSimplePageNum = exports.StyledSimpleActivePage = exports.StyledPaginationWrap = exports.StyledPaginationTotalText = exports.StyledPaginationText = exports.StyledPaginationJumpText = exports.StyledPaginationJump = exports.StyledPaginationEllipsis = exports.StyledPageNumber = exports.StyledPageArrow = exports.StyledMoreIcon = exports.StyledJumpIcon = exports.PaginationInput = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Input = _interopRequireDefault(require("../Input"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledPaginationWrap = _styledComponents["default"].ul.withConfig({
  displayName: "StyledPaginationWrap"
})(["list-style:none;margin:0;padding:10px 0;", ";"], function (props) {
  return props.$align && "text-align: ".concat(props.$align);
});

exports.StyledPaginationWrap = StyledPaginationWrap;

var StyledMoreIcon = _styledComponents["default"].span.withConfig({
  displayName: "StyledMoreIcon"
})(["position:absolute;top:0;right:0;bottom:0;left:0;margin:auto;opacity:1;", ""], function (props) {
  var _props$theme = props.theme,
      numberColor = _props$theme.components.Pagination.numberColor,
      _props$theme$transiti = _props$theme.transition.pattern,
      duration = _props$theme$transiti.duration,
      easing = _props$theme$transiti.easing;
  return (0, _styledComponents.css)(["color:", ";transition:all ", "ms ", ";"], numberColor.normal, duration.status, easing.status);
});

exports.StyledMoreIcon = StyledMoreIcon;

var StyledJumpIcon = _styledComponents["default"].span.withConfig({
  displayName: "StyledJumpIcon"
})(["position:absolute;top:0;right:0;bottom:0;left:0;margin:auto;opacity:0;", ""], function (props) {
  var _props$theme$transiti2 = props.theme.transition.pattern,
      duration = _props$theme$transiti2.duration,
      easing = _props$theme$transiti2.easing;
  return (0, _styledComponents.css)(["transition:all ", "ms ", ";"], duration.status, easing.status);
}); // 公共 item


exports.StyledJumpIcon = StyledJumpIcon;

var paginationItemBaseCss = function paginationItemBaseCss(props) {
  var inputFontSize = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : -1;
  var _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      simple = props.simple,
      _props$theme2 = props.theme,
      fontSize = _props$theme2.typography.spec.fontSize,
      _props$theme2$compone = _props$theme2.components.Pagination,
      numberFontLevel = _props$theme2$compone.numberFontLevel,
      itemHeight = _props$theme2$compone.itemHeight,
      itemLineHeight = _props$theme2$compone.itemLineHeight,
      itemMargin = _props$theme2$compone.itemMargin,
      borderRadius = _props$theme2$compone.borderRadius,
      _props$theme2$transit = _props$theme2.transition.pattern,
      duration = _props$theme2$transit.duration,
      easing = _props$theme2$transit.easing;
  var fontLevel = numberFontLevel[size];
  var mainCSS;

  if (simple) {
    mainCSS = (0, _styledComponents.css)(["transition:all ", "ms ", ";height:", "px;min-width:", "px;line-height:", "px;"], duration.status, easing.status, itemHeight[size], itemHeight[size], itemLineHeight[size]);
  } else {
    mainCSS = (0, _styledComponents.css)(["transition:background-color ", "ms ", ",color ", "ms ", ",border ", "ms ", ";height:", "px;min-width:", "px;line-height:", "px;margin:", "px ", "px ", "px 0;"], duration.status, easing.status, duration.status, easing.status, duration.status, easing.status, itemHeight[size], itemHeight[size], itemLineHeight[size], itemMargin[size], itemMargin[size], itemMargin[size]);
  }

  var innerFontSize = fontSize[fontLevel];

  if (inputFontSize > -1) {
    innerFontSize = inputFontSize;
  }

  return (0, _styledComponents.css)(["display:inline-block;text-align:center;vertical-align:middle;user-select:none;border-radius:", ";cursor:pointer;font-size:", "px;", ""], borderRadius[size], innerFontSize, mainCSS);
};

var StyledPageNumber = _styledComponents["default"].li.withConfig({
  displayName: "StyledPageNumber"
})(["", ""], function (props) {
  var size = props.size,
      isActive = props.isActive,
      isDarkBackground = props.isDarkBackground,
      _props$theme3 = props.theme,
      _props$theme3$compone = _props$theme3.components.Pagination,
      border = _props$theme3$compone.border,
      background = _props$theme3$compone.background,
      numberColor = _props$theme3$compone.numberColor,
      itemPadding = _props$theme3$compone.itemPadding,
      itemFontWeight = _props$theme3$compone.itemFontWeight,
      _props$theme3$transit = _props$theme3.transition.pattern,
      duration = _props$theme3$transit.duration,
      easing = _props$theme3$transit.easing;
  var bgColor = isDarkBackground ? background.darkBg : background.whiteBg;
  return (0, _styledComponents.css)(["", " background-color:", ";border:", ";font-weight:", ";", "{padding:0 ", "px;transition:background-color ", "ms ", ",color ", "ms ", ";color:", ";}&:hover{background-color:", ";border:", ";", "{color:", ";}}&:active{background-color:", ";border:", ";}"], paginationItemBaseCss(props), isActive ? background.current : bgColor, isActive ? border.current : border.normal, isActive ? itemFontWeight.selected : itemFontWeight.normal, StyledPaginationText, itemPadding[size], duration.status, easing.status, duration.status, easing.status, isActive ? numberColor.current : numberColor.normal, background.hover, border.hover, StyledPaginationText, numberColor.hover, background.clicked, border.clicked);
}); // @TODO: 居中对齐方式修改
// 两侧箭头


exports.StyledPageNumber = StyledPageNumber;

var StyledPageArrow = _styledComponents["default"].li.withConfig({
  displayName: "StyledPageArrow"
})(["", " ", " &::after{display:inline-block;content:'';height:100%;vertical-align:middle;}"], function (props) {
  return paginationItemBaseCss(props, props.itemRender ? -1 : 0);
}, function (props) {
  var disabled = props.disabled,
      simple = props.simple,
      isDarkBackground = props.isDarkBackground,
      _props$theme$componen = props.theme.components.Pagination,
      arrowColor = _props$theme$componen.arrowColor,
      border = _props$theme$componen.border,
      background = _props$theme$componen.background;
  var bgColor = isDarkBackground ? background.darkBg : background.whiteBg;

  if (simple) {
    return (0, _styledComponents.css)(["color:", ";cursor:", ";&:hover{color:", ";}"], disabled ? arrowColor.disabled : arrowColor.normal, disabled ? 'not-allowed' : 'pointer', disabled ? arrowColor.disabled : arrowColor.simpleHover);
  }

  return (0, _styledComponents.css)(["background-color:", ";border:", ";color:", ";cursor:", ";&:hover{background-color:", ";color:", ";border:", ";}&:active{background-color:", ";border:", ";}"], bgColor, border.normal, disabled ? arrowColor.disabled : arrowColor.normal, disabled ? 'not-allowed' : 'pointer', disabled ? bgColor : background.hover, disabled ? arrowColor.disabled : arrowColor.hover, disabled ? border.disabled : border.hover, disabled ? bgColor : background.clicked, disabled ? border.disabled : border.hover);
});

exports.StyledPageArrow = StyledPageArrow;

var StyledPaginationEllipsis = _styledComponents["default"].li.withConfig({
  displayName: "StyledPaginationEllipsis"
})(["", " ", ""], paginationItemBaseCss, function (props) {
  var moreColor = props.theme.components.Pagination.moreColor;
  return (0, _styledComponents.css)(["position:relative;&:hover{", "{opacity:0;}", "{color:", ";opacity:1;}}&:active{", "{color:", ";}}"], StyledMoreIcon, StyledJumpIcon, moreColor.hover, StyledJumpIcon, moreColor.clicked);
});

exports.StyledPaginationEllipsis = StyledPaginationEllipsis;

var StyledPaginationText = _styledComponents["default"].a.withConfig({
  displayName: "StyledPaginationText"
})(["display:block;"]);

exports.StyledPaginationText = StyledPaginationText;

var StyledPaginationJump = _styledComponents["default"].li.withConfig({
  displayName: "StyledPaginationJump"
})(["display:inline-block;vertical-align:middle;", ""], function (props) {
  var size = props.size,
      _props$theme$componen2 = props.theme.components.Pagination,
      itemHeight = _props$theme$componen2.itemHeight,
      itemMargin = _props$theme$componen2.itemMargin;
  return (0, _styledComponents.css)(["height:", "px;margin:", "px ", "px ", "px 0;"], itemHeight[size], itemMargin[size], itemMargin[size], itemMargin[size]);
});

exports.StyledPaginationJump = StyledPaginationJump;

var StyledPaginationJumpText = _styledComponents["default"].span.withConfig({
  displayName: "StyledPaginationJumpText"
})(["user-select:none;", ""], function (props) {
  var size = props.size,
      _props$theme4 = props.theme,
      fontSize = _props$theme4.typography.spec.fontSize,
      _props$theme4$compone = _props$theme4.components.Pagination,
      jumpFontLevel = _props$theme4$compone.jumpFontLevel,
      itemPadding = _props$theme4$compone.itemPadding,
      itemMargin = _props$theme4$compone.itemMargin,
      numberColor = _props$theme4$compone.numberColor,
      totalPadding = _props$theme4$compone.totalPadding;
  var fontLevel = jumpFontLevel[size];
  return (0, _styledComponents.css)(["padding-left:", "px;padding-right:", "px;font-size:", "px;color:", ";&:last-child{padding-left:", "px;}"], totalPadding[size] - itemMargin[size], itemPadding[size], fontSize[fontLevel], numberColor.normal, itemPadding[size]);
});

exports.StyledPaginationJumpText = StyledPaginationJumpText;

var StyledPaginationTotalText = _styledComponents["default"].span.withConfig({
  displayName: "StyledPaginationTotalText"
})(["user-select:none;", ""], function (props) {
  var size = props.size,
      _props$theme5 = props.theme,
      fontSize = _props$theme5.typography.spec.fontSize,
      _props$theme5$compone = _props$theme5.components.Pagination,
      jumpFontLevel = _props$theme5$compone.jumpFontLevel,
      numberColor = _props$theme5$compone.numberColor,
      totalPadding = _props$theme5$compone.totalPadding,
      itemMargin = _props$theme5$compone.itemMargin,
      itemLineHeight = _props$theme5$compone.itemLineHeight;
  var fontLevel = jumpFontLevel[size];
  return (0, _styledComponents.css)(["display:inline-block;line-height:", "px;padding-right:", "px;font-size:", "px;color:", ";margin:", "px 0;"], itemLineHeight[size], totalPadding[size], fontSize[fontLevel], numberColor.normal, itemMargin[size]);
});

exports.StyledPaginationTotalText = StyledPaginationTotalText;
var PaginationInput = (0, _styledComponents["default"])(_Input["default"]).withConfig({
  displayName: "PaginationInput"
})(["", ""], function (props) {
  var size = props.size,
      _props$theme6 = props.theme,
      fontSize = _props$theme6.typography.spec.fontSize,
      _props$theme6$compone = _props$theme6.components.Pagination,
      numberFontLevel = _props$theme6$compone.numberFontLevel,
      inputFontWeight = _props$theme6$compone.inputFontWeight;
  var fontLevel = numberFontLevel[size];
  return (0, _styledComponents.css)(["&&{padding:0;}& input{font-weight:", ";text-align:center;font-size:", "px;}"], inputFontWeight, fontSize[fontLevel]);
});
exports.PaginationInput = PaginationInput;

var StyledSimplePageSplit = _styledComponents["default"].span.withConfig({
  displayName: "StyledSimplePageSplit"
})(["margin:0 10px;vertical-align:middle;"]);

exports.StyledSimplePageSplit = StyledSimplePageSplit;

var StyledSimplePageText = _styledComponents["default"].span.withConfig({
  displayName: "StyledSimplePageText"
})(["vertical-align:middle;"]);

exports.StyledSimplePageText = StyledSimplePageText;

var StyledSimplePageNum = _styledComponents["default"].li.withConfig({
  displayName: "StyledSimplePageNum"
})(["display:inline-block;text-align:center;vertical-align:middle;user-select:none;", ";"], function (props) {
  var size = props.size,
      _props$theme7 = props.theme,
      fontSize = _props$theme7.typography.spec.fontSize,
      _props$theme7$compone = _props$theme7.components.Pagination,
      numberFontLevel = _props$theme7$compone.numberFontLevel,
      numberColor = _props$theme7$compone.numberColor;
  var fontLevel = numberFontLevel[size];
  return (0, _styledComponents.css)(["font-size:", "px;color:", ";"], fontSize[fontLevel], numberColor.normal);
});

exports.StyledSimplePageNum = StyledSimplePageNum;
var StyledSimpleActivePage = (0, _styledComponents["default"])(StyledSimplePageText).withConfig({
  displayName: "StyledSimpleActivePage"
})(["", ";"], function (props) {
  var fontWeight = props.theme.typography.spec.fontWeight;
  return (0, _styledComponents.css)(["font-weight:", ";"], fontWeight.semibold);
});
exports.StyledSimpleActivePage = StyledSimpleActivePage;