"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = usePagination;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = require("react");

var _utils = require("./utils");

var _excluded = ["size", "defaultCurrent", "current", "totalRecords", "midSideWidth", "showQuickJumper", "isDarkBackground", "simple", "onChange", "styles", "pageSize", "defaultPageSize", "showPageSizeChanger", "pageSizeOptions", "onPageSizeChange"];
// 快速前进步数
var FAST_STEP_SIZE = 5; // 至少展示 1-5 五个

var MIN_NUMBER_WIDTH = 5;
var defaultPageSizeOptions = [10, 20, 50, 100];

function usePagination(props) {
  var currentIsControlled = ('current' in props);
  var pageSizeIsControlled = ('pageSize' in props);
  var _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      _props$defaultCurrent = props.defaultCurrent,
      defaultCurrent = _props$defaultCurrent === void 0 ? 1 : _props$defaultCurrent,
      _props$current = props.current,
      current = _props$current === void 0 ? -1 : _props$current,
      _props$totalRecords = props.totalRecords,
      totalRecords = _props$totalRecords === void 0 ? 0 : _props$totalRecords,
      _props$midSideWidth = props.midSideWidth,
      midSideWidth = _props$midSideWidth === void 0 ? 2 : _props$midSideWidth,
      _props$showQuickJumpe = props.showQuickJumper,
      showQuickJumper = _props$showQuickJumpe === void 0 ? false : _props$showQuickJumpe,
      _props$isDarkBackgrou = props.isDarkBackground,
      isDarkBackground = _props$isDarkBackgrou === void 0 ? false : _props$isDarkBackgrou,
      _props$simple = props.simple,
      simple = _props$simple === void 0 ? false : _props$simple,
      onChange = props.onChange,
      styles = props.styles,
      _props$pageSize = props.pageSize,
      pageSize = _props$pageSize === void 0 ? -1 : _props$pageSize,
      _props$defaultPageSiz = props.defaultPageSize,
      defaultPageSize = _props$defaultPageSiz === void 0 ? 10 : _props$defaultPageSiz,
      _props$showPageSizeCh = props.showPageSizeChanger,
      showPageSizeChanger = _props$showPageSizeCh === void 0 ? false : _props$showPageSizeCh,
      pageSizeOptions = props.pageSizeOptions,
      onPageSizeChange = props.onPageSizeChange,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var currentFromProps = current > 0 ? current : defaultCurrent;
  var pageSizeFromProps = pageSize > 0 ? pageSize : defaultPageSize;

  var _useState = (0, _react.useState)(pageSizeFromProps),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      statePageSize = _useState2[0],
      setStatePageSize = _useState2[1];

  var finalPageSize = pageSizeIsControlled ? pageSizeFromProps : statePageSize;
  var pageAmount = (0, _utils.calculatePage)(totalRecords, finalPageSize); // 总页数

  var memoPageSizeOptions = (0, _react.useMemo)(function () {
    if (pageSizeOptions && pageSizeOptions.length) {
      return pageSizeOptions;
    }

    return defaultPageSizeOptions;
  }, [pageSizeOptions]);
  currentFromProps = (0, _utils.getValidPageValue)(currentFromProps, pageAmount);

  var _useState3 = (0, _react.useState)(currentFromProps),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      stateCurrent = _useState4[0],
      setStateCurrent = _useState4[1];

  var finalCurrent = currentIsControlled ? currentFromProps : stateCurrent;
  var isFirst = finalCurrent === 1;
  var isLast = finalCurrent === pageAmount;
  var hasPrevious = pageAmount > 1 && finalCurrent > 1;
  var hasNext = finalCurrent < pageAmount;
  var prevIsDisabled = finalCurrent === 1;
  var nextIsDisabled = finalCurrent === pageAmount;
  var finalCurrentStr = String(finalCurrent); // 快捷跳转的 input 的值

  var _useState5 = (0, _react.useState)(''),
      _useState6 = (0, _slicedToArray2["default"])(_useState5, 2),
      quickJumperValue = _useState6[0],
      setQuickJumperInputValue = _useState6[1]; // 快捷跳转的 input 的值


  var _useState7 = (0, _react.useState)(finalCurrentStr),
      _useState8 = (0, _slicedToArray2["default"])(_useState7, 2),
      simpleQuickJumperValue = _useState8[0],
      setSimpleQuickJumperInputValue = _useState8[1];

  var _useState9 = (0, _react.useState)(false),
      _useState10 = (0, _slicedToArray2["default"])(_useState9, 2),
      simpleQuickJumperFocus = _useState10[0],
      setSimpleQuickJumperFocus = _useState10[1];

  var finalSimpleQuickJumperValue = simpleQuickJumperFocus ? simpleQuickJumperValue : finalCurrentStr;
  var updateCurrent = (0, _react.useCallback)(function (pageNumber) {
    var newPageNum = (0, _utils.getValidPageValue)(pageNumber, pageAmount);
    if (pageNumber === finalCurrent) return;
    setStateCurrent(newPageNum);

    if (simple) {
      setSimpleQuickJumperInputValue(String(newPageNum));
    }

    if (onChange && newPageNum !== finalCurrent) {
      onChange(newPageNum);
    }
  }, [finalCurrent, onChange, pageAmount, simple]);
  var handlePageSizeChange = (0, _react.useCallback)(function (newPageSize) {
    setStatePageSize(newPageSize);

    if (onPageSizeChange) {
      onPageSizeChange(newPageSize);
    }
  }, [onPageSizeChange]);
  var handlePrev = (0, _react.useCallback)(function () {
    updateCurrent(finalCurrent - 1);
  }, [finalCurrent, updateCurrent]);
  var handleNext = (0, _react.useCallback)(function () {
    updateCurrent(finalCurrent + 1);
  }, [finalCurrent, updateCurrent]);
  var handleQuickJumperInputPressEnter = (0, _react.useCallback)(function (e) {
    var target = e.target;
    target.blur();
  }, []);
  var handleQuickJumperInputBlur = (0, _react.useCallback)(function () {
    // 空不进行任何处理
    if (quickJumperValue === '') {
      return;
    }

    var pageNumber = parseInt(quickJumperValue, 10);

    if (!isNaN(pageNumber)) {
      updateCurrent(pageNumber);
    }

    setQuickJumperInputValue('');
  }, [quickJumperValue, updateCurrent]);
  var handleQuickJumperInputChange = (0, _react.useCallback)(function (e) {
    setQuickJumperInputValue(e.target.value);
  }, []);
  var handleSimpleQuickJumperInputChange = (0, _react.useCallback)(function (e) {
    setSimpleQuickJumperInputValue(e.target.value);
  }, []);
  var handleSimpleQuickJumperInputFocus = (0, _react.useCallback)(function (e) {
    setSimpleQuickJumperInputValue(finalCurrentStr);
    setSimpleQuickJumperFocus(true);
  }, [finalCurrentStr]);
  var handleSimpleQuickJumperInputBlur = (0, _react.useCallback)(function () {
    var pageNumber = parseInt(simpleQuickJumperValue, 10);
    setSimpleQuickJumperFocus(false);

    if (isNaN(pageNumber)) {
      setSimpleQuickJumperInputValue(finalCurrentStr); // 这里 return 可以少操作一下 current ， focus 还会设置值
      // 不 return 也没事

      return;
    }

    updateCurrent(pageNumber);
  }, [finalCurrentStr, simpleQuickJumperValue, updateCurrent]);
  var visiblePieces = (0, _react.useMemo)(function () {
    return (0, _utils.computeVisiblePieces)(finalCurrent, pageAmount, midSideWidth, MIN_NUMBER_WIDTH).map(function (item) {
      var itemOnClick;
      var page;

      if (item.type === 'ellipsis' && item["goto"] === 'next') {
        page = finalCurrent + FAST_STEP_SIZE;

        itemOnClick = function itemOnClick() {
          return updateCurrent(page);
        };
      } else if (item.type === 'ellipsis') {
        page = finalCurrent - FAST_STEP_SIZE;

        itemOnClick = function itemOnClick() {
          return updateCurrent(page);
        };
      } else {
        page = item.pageNumber;

        itemOnClick = function itemOnClick() {
          return updateCurrent(page);
        };
      }

      return (0, _extends2["default"])({}, item, {
        page: page,
        onClick: itemOnClick
      });
    });
  }, [finalCurrent, updateCurrent, midSideWidth, pageAmount]);
  return {
    finalCurrent: finalCurrent,
    simpleQuickJumperValue: finalSimpleQuickJumperValue,
    quickJumperValue: quickJumperValue,
    finalPageSize: finalPageSize,
    pageAmount: pageAmount,
    showPageSizeChanger: showPageSizeChanger,
    isFirst: isFirst,
    isLast: isLast,
    hasPrevious: hasPrevious,
    hasNext: hasNext,
    visiblePieces: visiblePieces,
    prevIsDisabled: prevIsDisabled,
    nextIsDisabled: nextIsDisabled,
    updateCurrent: updateCurrent,
    // 事件处理
    handleQuickJumperInputPressEnter: handleQuickJumperInputPressEnter,
    handleQuickJumperInputBlur: handleQuickJumperInputBlur,
    handleQuickJumperInputChange: handleQuickJumperInputChange,
    handleSimpleQuickJumperInputBlur: handleSimpleQuickJumperInputBlur,
    handleSimpleQuickJumperInputChange: handleSimpleQuickJumperInputChange,
    handleSimpleQuickJumperInputFocus: handleSimpleQuickJumperInputFocus,
    handlePrev: handlePrev,
    handleNext: handleNext,
    handlePageSizeChange: handlePageSizeChange,
    // 传回去，渲染用
    restProps: restProps,
    size: size,
    showQuickJumper: showQuickJumper,
    isDarkBackground: isDarkBackground,
    pageSizeOptions: memoPageSizeOptions,
    simple: simple,
    styles: styles
  };
}