"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _ClearIcon2 = require("@muya-ui/theme-light/lib/icons/ClearIcon");

var _ReminderIcon2 = require("@muya-ui/theme-light/lib/icons/ReminderIcon");

var _InformIcon2 = require("@muya-ui/theme-light/lib/icons/InformIcon");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _Button = _interopRequireDefault(require("../Button"));

var _PopoverCard = _interopRequireDefault(require("../PopoverCard"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _excluded = ["defaultOpen", "open", "onVisibleChange", "title", "content", "actions", "style", "className", "onCancel", "onConfirm", "cancelText", "confirmText", "cancelButtonType", "confirmButtonType", "cancelButtonProps", "confirmButtonProps", "useInlineButton", "type", "icon"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _default = (0, _memoForwardRef["default"])(function (props, ref) {
  var defaultOpen = props.defaultOpen,
      openProp = props.open,
      onVisibleChange = props.onVisibleChange,
      title = props.title,
      content = props.content,
      actions = props.actions,
      style = props.style,
      className = props.className,
      onCancel = props.onCancel,
      onConfirm = props.onConfirm,
      cancelText = props.cancelText,
      confirmText = props.confirmText,
      cancelButtonType = props.cancelButtonType,
      _props$confirmButtonT = props.confirmButtonType,
      confirmButtonTypeProp = _props$confirmButtonT === void 0 ? 'primary' : _props$confirmButtonT,
      cancelButtonProps = props.cancelButtonProps,
      confirmButtonProps = props.confirmButtonProps,
      useInlineButton = props.useInlineButton,
      type = props.type,
      icon = props.icon,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var icons = (0, _extends2["default"])({
    info: _InformIcon2.InformIcon,
    warning: _ReminderIcon2.ReminderIcon,
    error: _ClearIcon2.ClearIcon
  }, theme.components.Popconfirm.icons);
  var _theme$components$Pop = theme.components.Popconfirm,
      paddingLeftWithType = _theme$components$Pop.paddingLeftWithType,
      width = _theme$components$Pop.width;

  var _useState = (0, _react.useState)(defaultOpen),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      innerOpen = _useState2[0],
      setInnerOpen = _useState2[1];

  var isControlled = ('open' in props);
  var open = isControlled ? openProp : innerOpen;
  var handleVisibleChange = (0, _react.useCallback)(function (visible) {
    if (!isControlled) {
      setInnerOpen(visible);
    }

    if (onVisibleChange) {
      onVisibleChange(visible);
    }
  }, [isControlled, onVisibleChange]);
  var handleConfirm = (0, _react.useCallback)(function (e) {
    // 非受控模式，点击确认关闭确认框
    if (!isControlled) {
      setInnerOpen(false);
    }

    if (onConfirm) {
      onConfirm(e);
    }
  }, [isControlled, onConfirm]);
  var handleCancel = (0, _react.useCallback)(function (e) {
    // 非受控模式，点击确认关闭确认框
    if (!isControlled) {
      setInnerOpen(false);
    }

    if (onCancel) {
      onCancel(e);
    }
  }, [isControlled, onCancel]); // 确认按钮类型

  var confirmButtonType = (0, _react.useMemo)(function () {
    if (type === 'error') {
      return 'danger';
    }

    return confirmButtonTypeProp;
  }, [confirmButtonTypeProp, type]); // 确认图标

  var innerIcon = (0, _react.useMemo)(function () {
    if (icon) {
      return icon;
    }

    if (type) {
      var IconComp = icons[type];
      return /*#__PURE__*/_react["default"].createElement(IconComp, null);
    }
  }, [icon, icons, type]);
  var cancelButton = (0, _react.useMemo)(function () {
    return useInlineButton ? /*#__PURE__*/_react["default"].createElement(_styled.StyledInlineButton, (0, _extends2["default"])({
      key: "cancel",
      size: "s",
      type: cancelButtonType,
      onClick: handleCancel
    }, cancelButtonProps), cancelText) : /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
      key: "cancel",
      size: "s",
      plain: true,
      type: cancelButtonType,
      onClick: handleCancel
    }, cancelButtonProps), cancelText);
  }, [cancelButtonProps, cancelButtonType, cancelText, handleCancel, useInlineButton]);
  var confirmButton = (0, _react.useMemo)(function () {
    return useInlineButton ? /*#__PURE__*/_react["default"].createElement(_styled.StyledInlineButton, (0, _extends2["default"])({
      key: "confirm",
      size: "s",
      onClick: handleConfirm,
      type: confirmButtonType
    }, confirmButtonProps), confirmText) : /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
      key: "confirm",
      size: "s",
      onClick: handleConfirm,
      type: confirmButtonType
    }, confirmButtonProps), confirmText);
  }, [confirmButtonProps, confirmButtonType, confirmText, handleConfirm, useInlineButton]);
  var innerActions = (0, _react.useMemo)(function () {
    return [cancelText ? cancelButton : null, confirmText ? confirmButton : null];
  }, [cancelButton, cancelText, confirmButton, confirmText]);
  var innerTitle = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement(_styled.StyledTitleWrapper, null, /*#__PURE__*/_react["default"].createElement(_styled.StyledIconWrapper, {
      theme: theme,
      $type: type
    }, innerIcon), title);
  }, [innerIcon, theme, title, type]);
  var innerStyle = (0, _react.useMemo)(function () {
    return (0, _extends2["default"])({
      width: width,
      paddingLeft: type ? "".concat(paddingLeftWithType, "px") : undefined
    }, style);
  }, [paddingLeftWithType, style, type, width]);
  return /*#__PURE__*/_react["default"].createElement(_PopoverCard["default"], (0, _extends2["default"])({
    ref: ref,
    open: open,
    title: type ? innerTitle : title,
    content: content,
    actions: actions ? actions : innerActions,
    style: innerStyle,
    className: className,
    onVisibleChange: handleVisibleChange
  }, other));
});

exports["default"] = _default;