"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _Trigger = _interopRequireDefault(require("../Trigger"));

var _Typography = _interopRequireDefault(require("../Typography"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _excluded = ["className", "style", "title", "content", "actions", "arrowStyle", "styles", "disableTypography"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _default = (0, _memoForwardRef["default"])(function (props, ref) {
  var className = props.className,
      style = props.style,
      title = props.title,
      content = props.content,
      actions = props.actions,
      _props$arrowStyle = props.arrowStyle,
      arrowStyle = _props$arrowStyle === void 0 ? {} : _props$arrowStyle,
      styles = props.styles,
      _props$disableTypogra = props.disableTypography,
      disableTypography = _props$disableTypogra === void 0 ? false : _props$disableTypogra,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var defaultStyles = (0, _react.useMemo)(function () {
    return {
      wrapper: '',
      actionsWrapper: '',
      titleWrapper: '',
      contentWrapper: ''
    };
  }, []);
  var innerStyles = (0, _useStyles["default"])('popovercard', defaultStyles, styles);
  var theme = (0, _useTheme["default"])();
  var popup = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement(_styled.StyledCardWrapper, {
      theme: theme,
      className: [innerStyles.wrapper.className, className].join(' ').trim(),
      style: (0, _extends2["default"])({}, innerStyles.wrapper.style, style)
    }, /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, title && /*#__PURE__*/_react["default"].createElement(_styled.StyledTitleWrapper, (0, _extends2["default"])({}, innerStyles.titleWrapper, {
      theme: theme
    }), /*#__PURE__*/_react["default"].createElement(_Typography["default"].Title, {
      level: theme.components.PopoverCard.title.level
    }, title)), content && !disableTypography ? /*#__PURE__*/_react["default"].createElement(_Typography["default"].Text, (0, _extends2["default"])({}, innerStyles.contentWrapper, {
      color: "assistant"
    }), content) : content, actions && /*#__PURE__*/_react["default"].createElement(_styled.StyledActionsWrapper, (0, _extends2["default"])({}, innerStyles.actionsWrapper, {
      theme: theme
    }), actions)));
  }, [actions, className, content, disableTypography, innerStyles.actionsWrapper, innerStyles.contentWrapper, innerStyles.titleWrapper, innerStyles.wrapper.className, innerStyles.wrapper.style, style, theme, title]);
  return /*#__PURE__*/_react["default"].createElement(_Trigger["default"], (0, _extends2["default"])({
    ref: ref,
    popup: popup,
    arrowStyle: (0, _extends2["default"])({
      color: theme.colors.pattern.background.higher
    }, arrowStyle)
  }, other));
});

exports["default"] = _default;