"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
exports.flipPlacement = flipPlacement;

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _popper = _interopRequireDefault(require("popper.js"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Portal = _interopRequireDefault(require("../Portal"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _excluded = ["anchorEl", "children", "container", "disablePortal", "keepMounted", "lazyMount", "modifiers", "open", "placement", "popperOptions", "popperRef", "transition", "transitionProps", "zIndex"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function flipPlacement(placement) {
  var direction = typeof window !== 'undefined' && document.body.getAttribute('dir') || 'ltr';

  if (direction !== 'rtl') {
    return placement;
  }

  switch (placement) {
    case 'bottom-end':
      return 'bottom-start';

    case 'bottom-start':
      return 'bottom-end';

    case 'top-end':
      return 'top-start';

    case 'top-start':
      return 'top-end';

    default:
      return placement;
  }
}

function getAnchorEl(anchorEl) {
  return typeof anchorEl === 'function' ? anchorEl() : anchorEl;
}

var useEnhancedEffect = typeof window !== 'undefined' ? _react["default"].useLayoutEffect : _react["default"].useEffect;
var defaultPopperOptions = {};

var StyledPopper = _styledComponents["default"].div.withConfig({
  displayName: "StyledPopper"
})(["position:absolute;left:0;top:0;z-index:", ";", ""], function (props) {
  return props.$zIndex;
}, function (props) {
  return props.$shouldHide && (0, _styledComponents.css)(["width:0px;height:0px;overflow:hidden;visibility:hidden;"]);
});
/**
 * Poppers rely on the 3rd party library [Popper.js](https://github.com/FezVrasta/popper.js) for positioning.
 */


var Popper = /*#__PURE__*/_react["default"].forwardRef(function Popper(props, ref) {
  var anchorEl = props.anchorEl,
      children = props.children,
      container = props.container,
      _props$disablePortal = props.disablePortal,
      disablePortal = _props$disablePortal === void 0 ? false : _props$disablePortal,
      _props$keepMounted = props.keepMounted,
      keepMounted = _props$keepMounted === void 0 ? true : _props$keepMounted,
      _props$lazyMount = props.lazyMount,
      lazyMount = _props$lazyMount === void 0 ? true : _props$lazyMount,
      modifiers = props.modifiers,
      open = props.open,
      _props$placement = props.placement,
      placementProps = _props$placement === void 0 ? 'bottom' : _props$placement,
      _props$popperOptions = props.popperOptions,
      popperOptions = _props$popperOptions === void 0 ? defaultPopperOptions : _props$popperOptions,
      popperRefProp = props.popperRef,
      _props$transition = props.transition,
      transition = _props$transition === void 0 ? false : _props$transition,
      transitionProps = props.transitionProps,
      zIndex = props.zIndex,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var tooltipRef = (0, _react.useRef)(null);
  var ownRef = (0, _useForkRef2.useForkRef)(tooltipRef, ref);
  var popperRef = (0, _react.useRef)(null);
  var handlePopperRef = (0, _useForkRef2.useForkRef)(popperRef, popperRefProp);
  var handlePopperRefRef = (0, _react.useRef)(null);
  var firstMountRef = (0, _react.useRef)(false);
  var theme = (0, _useTheme["default"])();
  useEnhancedEffect(function () {
    handlePopperRefRef.current = handlePopperRef;
  }, [handlePopperRef]);

  _react["default"].useImperativeHandle(popperRefProp, function () {
    return popperRef.current;
  }, []);

  var _useState = (0, _react.useState)(!open),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      exited = _useState2[0],
      setExited = _useState2[1];

  var _useState3 = (0, _react.useState)(),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      placement = _useState4[0],
      setPlacement = _useState4[1];

  var handlePopperUpdate = (0, _react.useCallback)(function (data) {
    if (data.placement !== placement) {
      setPlacement(data.placement);
    }
  }, [placement]);
  var handleOpen = (0, _react.useCallback)(function () {
    var popperNode = tooltipRef.current;

    if (!popperNode || !anchorEl || !open) {
      return;
    }

    if (popperRef.current) {
      popperRef.current.destroy();

      if (handlePopperRefRef.current) {
        handlePopperRefRef.current(null);
      }
    }

    var popperReferenceElement = getAnchorEl(anchorEl);

    if (popperReferenceElement) {
      var popper = new _popper["default"](popperReferenceElement, popperNode, (0, _extends2["default"])({
        placement: flipPlacement(placementProps),
        positionFixed: true
      }, popperOptions, {
        modifiers: (0, _extends2["default"])({
          preventOverflow: {
            // boundariesElement: disablePortal ? 'scrollParent' : 'window',
            enabled: false
          },
          hide: {
            enabled: false
          }
        }, modifiers, popperOptions.modifiers),
        // We could have been using a custom modifier like react-popper is doing.
        // But it seems this is the best public API for this use case.
        onCreate: function onCreate(data) {
          handlePopperUpdate(data);
          popperOptions.onCreate && popperOptions.onCreate(data);
        },
        onUpdate: function onUpdate(data) {
          handlePopperUpdate(data);
          popperOptions.onUpdate && popperOptions.onUpdate(data);
        }
      }));

      if (handlePopperRefRef.current) {
        handlePopperRefRef.current(popper);
      }
    }
  }, [anchorEl, handlePopperUpdate, modifiers, open, placementProps, popperOptions]);
  var handleRef = (0, _react.useCallback)(function (node) {
    (0, _useForkRef2.setRef)(ownRef, node);
    handleOpen();
  }, [ownRef, handleOpen]);

  var handleEnter = function handleEnter(node, isAppearing) {
    setExited(false);

    if (transitionProps && transitionProps.onEnter) {
      transitionProps.onEnter(node, isAppearing);
    }
  };

  var handleClose = function handleClose() {
    if (!popperRef.current) {
      return;
    }

    popperRef.current.destroy();

    if (handlePopperRefRef.current) {
      handlePopperRefRef.current(null);
    }
  };

  var handleExited = function handleExited(node) {
    setExited(true);
    handleClose();

    if (transitionProps && transitionProps.onExited) {
      transitionProps.onExited(node);
    }
  };

  (0, _react.useEffect)(function () {
    if (popperRef.current) {
      popperRef.current.update();
    }
  });
  (0, _react.useEffect)(function () {
    // Let's update the popper position.
    handleOpen();
  }, [handleOpen]);
  (0, _react.useEffect)(function () {
    return function () {
      handleClose();
    }; // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  (0, _react.useEffect)(function () {
    if (!open && !transition) {
      // Otherwise handleExited will call this.
      handleClose();
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [open, transition]);
  /**
   * Popper 关闭的情况下有两种情况是不需要渲染的：
   * 1. 第一次渲染 Popper 且开启了 lazyMount 的情况下，用于预防提前渲染无用的节点
   * 2. keepMounted 为 false，且未开启动画或者已经退出的情况下
   * 需要保持内部组件状态的话需要将 keepMounted 设为 true
   */

  if (!open && (lazyMount && !firstMountRef.current || !keepMounted && (!transition || exited))) {
    return null;
  }

  var childProps = {
    placement: placement || flipPlacement(placementProps)
  };

  if (transition) {
    childProps.transitionProps = (0, _extends2["default"])({}, transitionProps, {
      "in": open,
      onEnter: handleEnter,
      onExited: handleExited
    });
  } // 如果是第一次渲染菜单，那么将 ref 设为 true


  if (!firstMountRef.current) {
    firstMountRef.current = true;
  }

  var shouldHide = transition ? exited : !open;
  var finalZIndex = zIndex || zIndex === 0 ? zIndex : theme.zIndex.pattern.popper;
  return /*#__PURE__*/_react["default"].createElement(_Portal["default"], {
    disablePortal: disablePortal,
    container: container
  }, /*#__PURE__*/_react["default"].createElement(StyledPopper, (0, _extends2["default"])({
    ref: handleRef,
    role: "tooltip",
    $zIndex: finalZIndex,
    $shouldHide: shouldHide
  }, other), typeof children === 'function' ? children(childProps) : children));
});

var _default = Popper;
exports["default"] = _default;