"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _utils = require("./utils");

var useEnhancedEffect = typeof window !== 'undefined' ? _react["default"].useLayoutEffect : _react["default"].useEffect;
/**
 * Portals provide a first-class way to render children into a DOM node
 * that exists outside the DOM hierarchy of the parent component.
 */

var Portal = (0, _memoForwardRef["default"])(function Portal(props, ref) {
  var children = props.children,
      container = props.container,
      _props$disablePortal = props.disablePortal,
      disablePortal = _props$disablePortal === void 0 ? false : _props$disablePortal,
      onRendered = props.onRendered;

  var _React$useState = _react["default"].useState(null),
      _React$useState2 = (0, _slicedToArray2["default"])(_React$useState, 2),
      mountNode = _React$useState2[0],
      setMountNode = _React$useState2[1];

  var childRef = _react["default"].useRef(null);

  var handleRef = (0, _useForkRef2.useForkRef)(children.ref, childRef);
  useEnhancedEffect(function () {
    if (!disablePortal) {
      setMountNode((0, _utils.getPortalContainer)(container));
    }
  }, [container, disablePortal]);

  _react["default"].useImperativeHandle(ref, function () {
    return mountNode || childRef.current;
  }, [mountNode]);

  useEnhancedEffect(function () {
    if (onRendered && mountNode) {
      onRendered();
    }
  }, [mountNode, onRendered]);

  if (disablePortal) {
    _react["default"].Children.only(children);

    return /*#__PURE__*/_react["default"].cloneElement(children, {
      ref: handleRef
    });
  }

  return mountNode ? /*#__PURE__*/_reactDom["default"].createPortal(children, mountNode) : mountNode;
});
var _default = Portal;
exports["default"] = _default;