"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _useRadio2 = _interopRequireDefault(require("./useRadio"));

var _mergeStyleItem = _interopRequireDefault(require("../utils/mergeStyleItem"));

var _excluded = ["autoFocus", "disabled", "defaultChecked", "ellipsis", "width", "checked", "children", "size", "onChange", "onMouseEnter", "onMouseLeave", "styles", "inputRef", "className", "style", "checkedIcon", "unCheckedIcon"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  wrapper: '',
  inputRadio: '',
  innerRadio: '',
  text: ''
};
var Radio = (0, _memoForwardRef["default"])(function (props, ref) {
  var _props$autoFocus = props.autoFocus,
      autoFocus = _props$autoFocus === void 0 ? false : _props$autoFocus,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      _props$defaultChecked = props.defaultChecked,
      defaultChecked = _props$defaultChecked === void 0 ? false : _props$defaultChecked,
      _props$ellipsis = props.ellipsis,
      ellipsis = _props$ellipsis === void 0 ? false : _props$ellipsis,
      width = props.width,
      checked = props.checked,
      children = props.children,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      onChange = props.onChange,
      onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave,
      styles = props.styles,
      inputRef = props.inputRef,
      className = props.className,
      style = props.style,
      checkedIcon = props.checkedIcon,
      unCheckedIcon = props.unCheckedIcon,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var _theme$components$Rad = theme.components.Radio,
      iconSize = _theme$components$Rad.iconSize,
      CheckedIcon = _theme$components$Rad.CheckedIcon,
      UnCheckedIcon = _theme$components$Rad.UnCheckedIcon;
  var innerStyles = (0, _useStyles["default"])('radio', defaultStyles, styles);
  var wrapperStyleItem = (0, _react.useMemo)(function () {
    return (0, _mergeStyleItem["default"])({
      className: className,
      style: style
    }, innerStyles.wrapper);
  }, [className, innerStyles.wrapper, style]);

  var _useRadio = (0, _useRadio2["default"])(props, 'checked' in props),
      checkedState = _useRadio.checkedState,
      handleInputChange = _useRadio.handleInputChange,
      handleClick = _useRadio.handleClick,
      handleInputClick = _useRadio.handleInputClick,
      handleCustomClick = _useRadio.handleCustomClick;

  var checkedNode = (0, _react.useMemo)(function () {
    return checkedIcon || (CheckedIcon ? /*#__PURE__*/_react["default"].createElement(CheckedIcon, {
      fontSize: iconSize[size]
    }) : null);
  }, [CheckedIcon, checkedIcon, iconSize, size]);
  var unCheckedNode = (0, _react.useMemo)(function () {
    return unCheckedIcon || (UnCheckedIcon ? /*#__PURE__*/_react["default"].createElement(UnCheckedIcon, {
      fontSize: iconSize[size]
    }) : null);
  }, [UnCheckedIcon, iconSize, size, unCheckedIcon]);
  return checkedNode && unCheckedNode ? /*#__PURE__*/_react["default"].createElement(_styled.StyledInlineButton, (0, _extends2["default"])({
    theme: theme,
    $ellipsis: ellipsis,
    $checked: checkedState
  }, wrapperStyleItem, {
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave,
    onClick: handleCustomClick,
    disabled: disabled
  }), checkedState ? checkedNode : unCheckedNode, /*#__PURE__*/_react["default"].createElement(_styled.StyledRadioText, (0, _extends2["default"])({}, innerStyles.text, {
    theme: theme,
    $size: size
  }), children)) : /*#__PURE__*/_react["default"].createElement(_styled.StyledRadioLabel, (0, _extends2["default"])({
    ref: ref,
    theme: theme,
    $disabled: disabled,
    $width: width,
    $ellipsis: ellipsis,
    $checked: checkedState
  }, wrapperStyleItem, {
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave,
    onClick: handleClick
  }), /*#__PURE__*/_react["default"].createElement(_styled.StyledRadioIcon, null, /*#__PURE__*/_react["default"].createElement(_styled.StyledRadioInput, (0, _extends2["default"])({}, restProps, innerStyles.inputRadio, {
    ref: inputRef,
    type: "radio",
    autoFocus: autoFocus,
    checked: checkedState,
    onClick: handleInputClick,
    onChange: handleInputChange,
    disabled: disabled
  })), /*#__PURE__*/_react["default"].createElement(_styled.StyledRadioInner, (0, _extends2["default"])({}, innerStyles.innerRadio, {
    theme: theme,
    $checked: checkedState,
    $size: size
  }))), children ? /*#__PURE__*/_react["default"].createElement(_styled.StyledRadioText, (0, _extends2["default"])({}, innerStyles.text, {
    theme: theme,
    $size: size
  }), children) : null);
});
Radio.useRadio = _useRadio2["default"];
Radio.__MUYA_RADIO = true;
var _default = Radio;
exports["default"] = _default;