"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _Radio = _interopRequireDefault(require("./Radio"));

var _styled = require("./styled");

var _useRadioGroup2 = _interopRequireDefault(require("./useRadioGroup"));

var _excluded = ["value", "disabled", "onChange", "children", "ellipsis", "width"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var RadioGroup = (0, _memoForwardRef["default"])(function (props, ref) {
  var _useRadioGroup = (0, _useRadioGroup2["default"])(props),
      opts = _useRadioGroup.opts,
      valueState = _useRadioGroup.valueState,
      handleChange = _useRadioGroup.handleChange,
      handleClick = _useRadioGroup.handleClick,
      children = _useRadioGroup.children,
      renderRadio = _useRadioGroup.renderRadio,
      radioEllipsis = _useRadioGroup.radioEllipsis,
      radioWidth = _useRadioGroup.radioWidth,
      restProps = _useRadioGroup.restProps;

  var theme = (0, _useTheme["default"])();
  var radioList = (0, _react.useMemo)(function () {
    if (opts && opts.length) {
      return opts.map(function (option, optIndex) {
        var label = option.label,
            value = option.value,
            disabled = option.disabled,
            ellipsis = option.ellipsis,
            width = option.width;

        var radioNode = /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
          key: String(value),
          value: value,
          size: props.size,
          styles: props.styles,
          ellipsis: ellipsis === undefined ? radioEllipsis : ellipsis,
          width: width || radioWidth,
          disabled: props.disabled || disabled,
          checked: valueState === value,
          onChange: handleChange.bind(null, option),
          onClick: handleClick.bind(null, option)
        }, label);

        return renderRadio(radioNode, option, optIndex);
      });
    }

    return _react["default"].Children.map(children, function (child, childIndex) {
      if (! /*#__PURE__*/_react["default"].isValidElement(child)) {
        return null;
      }

      var _child$props = child.props,
          value = _child$props.value,
          disabled = _child$props.disabled,
          onChange = _child$props.onChange,
          label = _child$props.children,
          ellipsis = _child$props.ellipsis,
          width = _child$props.width,
          otherChildProps = (0, _objectWithoutProperties2["default"])(_child$props, _excluded);
      var option = {
        value: value,
        disabled: disabled,
        onChange: onChange,
        label: label
      };

      var radioNode = /*#__PURE__*/_react["default"].cloneElement(child, (0, _extends2["default"])({}, otherChildProps, {
        children: label,
        value: value,
        ellipsis: ellipsis === undefined ? radioEllipsis : ellipsis,
        width: width || radioWidth,
        checked: valueState === value,
        disabled: props.disabled || disabled,
        styles: props.styles,
        size: props.size,
        onChange: handleChange.bind(null, option),
        onClick: handleClick.bind(null, option)
      }));

      return renderRadio(radioNode, option, childIndex);
    });
  }, [opts, children, props.size, props.styles, props.disabled, radioEllipsis, radioWidth, valueState, handleChange, handleClick, renderRadio]);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledRadioGroup, (0, _extends2["default"])({
    ref: ref,
    theme: theme
  }, restProps), radioList);
});
RadioGroup.useRadioGroup = _useRadioGroup2["default"];
var _default = RadioGroup;
exports["default"] = _default;