"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledRadioText = exports.StyledRadioLabel = exports.StyledRadioInput = exports.StyledRadioInner = exports.StyledRadioIcon = exports.StyledRadioGroup = exports.StyledInlineButton = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _InlineButton = _interopRequireDefault(require("../InlineButton"));

var _ellipsis = require("../styled/mixins/ellipsis");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledRadioInput = _styledComponents["default"].input.withConfig({
  displayName: "StyledRadioInput"
})(["box-sizing:border-box;touch-action:manipulation;position:absolute;z-index:1;cursor:pointer;opacity:0;left:0;top:0;bottom:0;right:0;"]);

exports.StyledRadioInput = StyledRadioInput;

var StyledRadioIcon = _styledComponents["default"].span.withConfig({
  displayName: "StyledRadioIcon"
})(["position:relative;display:inline-block;line-height:1;white-space:nowrap;vertical-align:middle;outline:none;cursor:pointer;"]);

exports.StyledRadioIcon = StyledRadioIcon;

var radioInnerCSS = function radioInnerCSS(props) {
  var _props$theme = props.theme,
      token = _props$theme.components.Radio,
      _props$theme$transiti = _props$theme.transition.spec,
      duration = _props$theme$transiti.duration,
      easing = _props$theme$transiti.easing,
      $size = props.$size,
      $checked = props.$checked;
  var iconSize = token.iconSize[$size];
  var checkedCenterSize = token.checkedCenterSize[$size];
  return (0, _styledComponents.css)(["transition:all ", "ms ", ";width:", "px;height:", "px;border-width:1px;border-color:", ";background-color:", ";&::after{content:'';width:", "px;height:", "px;background:", ";transform:", ";position:absolute;border-radius:50%;top:", "px;left:", "px;transition:all ", "ms ", ";}"], duration.normal, easing.easeInOut, iconSize, iconSize, $checked ? token.borderColor.checked : token.borderColor.unChecked, $checked ? token.iconColor.checked : token.iconColor.unChecked, checkedCenterSize, checkedCenterSize, token.checkedCenterBg, $checked ? 'scale(1)' : 'scale(0)', (iconSize - checkedCenterSize) / 2, (iconSize - checkedCenterSize) / 2, duration.normal, easing.easeInOut);
};

var StyledRadioInner = _styledComponents["default"].span.withConfig({
  displayName: "StyledRadioInner"
})(["display:block;box-sizing:border-box;border-radius:50%;border-style:solid;", ""], radioInnerCSS);

exports.StyledRadioInner = StyledRadioInner;

var textSizeCSS = function textSizeCSS(props) {
  var _props$theme2 = props.theme,
      colors = _props$theme2.colors,
      _props$theme2$typogra = _props$theme2.typography.spec,
      fontSize = _props$theme2$typogra.fontSize,
      lineHeight = _props$theme2$typogra.lineHeight,
      textIcon = _props$theme2.spacing.pattern.textIcon,
      token = _props$theme2.components.Radio,
      $size = props.$size;
  var fontLevel = token.fontLevel[$size];
  return (0, _styledComponents.css)(["color:", ";font-size:", "px;line-height:", "px;padding-left:", "px;padding-right:", "px;"], colors.pattern.text.title, fontSize[fontLevel], lineHeight[fontLevel], textIcon[fontLevel], textIcon[fontLevel]);
};

var StyledRadioText = _styledComponents["default"].span.withConfig({
  displayName: "StyledRadioText"
})(["vertical-align:middle;", ""], textSizeCSS); // 状态的样式


exports.StyledRadioText = StyledRadioText;

var radioStatusCSS = function radioStatusCSS(props) {
  var _props$theme3 = props.theme,
      opacity = _props$theme3.opacity,
      token = _props$theme3.components.Radio,
      $disabled = props.$disabled,
      $checked = props.$checked,
      $width = props.$width,
      $ellipsis = props.$ellipsis;
  var interactive = !$disabled;
  var interactiveCSS;

  if (!interactive) {
    interactiveCSS = (0, _styledComponents.css)(["opacity:", ";cursor:not-allowed;", ",", "{cursor:not-allowed;}"], opacity.pattern.disabled, StyledRadioInput, StyledRadioIcon);
  } else {
    interactiveCSS = (0, _styledComponents.css)(["&:focus,&:hover{", "{border-color:", ";background-color:", ";}}&:active{", "{border-color:", ";background-color:", ";}}"], StyledRadioInner, $checked ? token.borderColor.checkedHover : token.borderColor.hover, $checked ? token.iconColor.checkedHover : token.iconColor.hover, StyledRadioInner, $checked ? token.borderColor.checkedClick : token.borderColor.click, $checked ? token.borderColor.checkedClick : token.iconColor.click);
  }

  return (0, _styledComponents.css)(["", " ", ""], (0, _ellipsis.ellipsisWithWidth)($ellipsis, $width), interactiveCSS);
};

var StyledRadioLabel = _styledComponents["default"].label.withConfig({
  displayName: "StyledRadioLabel"
})(["box-sizing:border-box;user-select:none;display:inline-block;white-space:nowrap;cursor:pointer;", ""], radioStatusCSS);

exports.StyledRadioLabel = StyledRadioLabel;

var StyledRadioGroup = _styledComponents["default"].div.withConfig({
  displayName: "StyledRadioGroup"
})(["display:inline-block;", "{margin-right:", "px;}"], StyledRadioLabel, function (props) {
  return props.theme.components.Radio.marginRightInGroup;
});

exports.StyledRadioGroup = StyledRadioGroup;
var StyledInlineButton = (0, _styledComponents["default"])(_InlineButton["default"]).withConfig({
  displayName: "StyledInlineButton"
})(["", ""], function (props) {
  var _props$theme4 = props.theme,
      opacity = _props$theme4.opacity,
      token = _props$theme4.components.Radio,
      disabled = props.disabled,
      $checked = props.$checked;
  var interactive = !disabled;
  var interactiveCSS;

  if (!interactive) {
    interactiveCSS = (0, _styledComponents.css)(["opacity:", ";cursor:not-allowed;", ",", "{cursor:not-allowed;}"], opacity.pattern.disabled, StyledRadioInput, StyledRadioIcon);
  } else {
    interactiveCSS = (0, _styledComponents.css)(["color:", ";&:focus,&:hover{svg{color:", ";}}&:active{svg{color:", ";}}"], $checked ? token.iconColor.checked : token.borderColor.unChecked, $checked ? token.iconColor.checkedHover : token.borderColor.hover, $checked ? token.iconColor.checkedClick : token.borderColor.click);
  }

  return (0, _styledComponents.css)(["", ""], interactiveCSS);
});
exports.StyledInlineButton = StyledInlineButton;