"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
exports.useRadio = useRadio;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = require("react");

function useRadio(props, isControlled) {
  var checked = props.checked,
      _props$defaultChecked = props.defaultChecked,
      defaultChecked = _props$defaultChecked === void 0 ? false : _props$defaultChecked,
      disabled = props.disabled,
      onChange = props.onChange,
      onClick = props.onClick;

  var _useState = (0, _react.useState)(isControlled ? !!checked : defaultChecked),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      checkedState = _useState2[0],
      setCheckedState = _useState2[1];

  var handleInputChange = (0, _react.useCallback)(function (e) {
    if (disabled) {
      return;
    }

    var value = e.target.checked;

    if (!isControlled) {
      setCheckedState(value);
    }

    if (onChange) {
      onChange(e);
    }
  }, [disabled, isControlled, onChange]);
  var handleInputClick = (0, _react.useCallback)(function (e) {
    e.preventDefault();
    e.stopPropagation();

    if (e.nativeEvent) {
      e.nativeEvent.stopImmediatePropagation();
    }
  }, []);
  var handleClick = (0, _react.useCallback)(function (e) {
    if (disabled) {
      return;
    } // if (!isControlled) {
    //   setCheckedState(!checkedState);
    // }


    if (onClick) {
      onClick(e);
    }
  }, [disabled, onClick]);

  if (isControlled && checkedState !== !!checked) {
    setCheckedState(!!checked);
  }

  var handleCustomClick = (0, _react.useCallback)(function (e) {
    if (disabled) {
      return;
    }

    if (!isControlled) {
      setCheckedState(!checkedState);
    }

    if (onClick) {
      onClick(e);
    }

    if (onChange) {
      var v = {
        target: {
          checked: !checkedState
        }
      };
      onChange(v);
    }
  }, [checkedState, disabled, isControlled, onChange, onClick]);
  return {
    checkedState: checkedState,
    handleInputChange: handleInputChange,
    handleInputClick: handleInputClick,
    handleClick: handleClick,
    setCheckedState: setCheckedState,
    handleCustomClick: handleCustomClick
  };
}

var _default = useRadio;
exports["default"] = _default;