"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
exports.useRadioGroup = useRadioGroup;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = require("react");

var _excluded = ["defaultValue", "value", "options", "onChange", "children", "radioEllipsis", "radioWidth", "renderRadio"];

var defaultRenderRadio = function defaultRenderRadio(radioNode) {
  return radioNode;
};

function useRadioGroup(props) {
  var _props$defaultValue = props.defaultValue,
      defaultValue = _props$defaultValue === void 0 ? null : _props$defaultValue,
      valueProp = props.value,
      options = props.options,
      onChange = props.onChange,
      children = props.children,
      radioEllipsis = props.radioEllipsis,
      radioWidth = props.radioWidth,
      _props$renderRadio = props.renderRadio,
      renderRadio = _props$renderRadio === void 0 ? defaultRenderRadio : _props$renderRadio,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var isControlled = ('value' in props);

  var _useState = (0, _react.useState)(defaultValue),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      innerValue = _useState2[0],
      setInnerValue = _useState2[1];

  var valueState = isControlled ? valueProp : innerValue;
  var opts = (0, _react.useMemo)(function () {
    if (options && options.length) {
      return options.map(function (option) {
        if (typeof option === 'string') {
          return {
            label: option,
            value: option
          };
        }

        return option;
      });
    }

    return [];
  }, [options]);
  var handleChange = (0, _react.useCallback)(function (option, e) {
    setInnerValue(option.value);

    if (option.onChange) {
      option.onChange(e);
    }

    if (onChange && option.value !== valueState) {
      onChange(option.value);
    }
  }, [onChange, valueState]);
  var handleClick = (0, _react.useCallback)(function (option, e) {
    e.preventDefault();
    setInnerValue(option.value);

    if (option.onClick) {
      option.onClick(e);
    }

    if (onChange && option.value !== valueState) {
      onChange(option.value);
    }
  }, [onChange, valueState]);
  return {
    opts: opts,
    valueState: valueState,
    restProps: restProps,
    children: children,
    radioEllipsis: radioEllipsis,
    radioWidth: radioWidth,
    handleChange: handleChange,
    handleClick: handleClick,
    renderRadio: renderRadio
  };
}

var _default = useRadioGroup;
exports["default"] = _default;