"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _ClockIcon2 = require("@muya-ui/theme-light/lib/icons/ClockIcon");

var _react = _interopRequireWildcard(require("react"));

var _PopPanel = require("../styled/components/PopPanel");

var _Trigger = _interopRequireDefault(require("../Trigger"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _RangeDateTimeCalendar = _interopRequireDefault(require("./RangeDateTimeCalendar"));

var _styled = require("./styled");

var _useRangeDateTimePicker = _interopRequireDefault(require("./useRangeDateTimePicker"));

var _SuffixIcon = require("../styled/components/SuffixIcon");

var _Locale = require("../Locale");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  popPanel: ''
};
var RangeDateTimePicker = (0, _memoForwardRef["default"])(function (props, ref) {
  var theme = (0, _useTheme["default"])();
  var locale = (0, _Locale.useLocale)();

  var _useRangeDateTimePick = (0, _useRangeDateTimePicker["default"])(props),
      focusState = _useRangeDateTimePick.focusState,
      finalUIState = _useRangeDateTimePick.finalUIState,
      calendarDate = _useRangeDateTimePick.calendarDate,
      finalValue = _useRangeDateTimePick.finalValue,
      otherProps = _useRangeDateTimePick.otherProps,
      finalTimeFormat = _useRangeDateTimePick.finalTimeFormat,
      handleStartFocus = _useRangeDateTimePick.handleStartFocus,
      handleEndFocus = _useRangeDateTimePick.handleEndFocus,
      handleCalendarChange = _useRangeDateTimePick.handleCalendarChange,
      handleClickAway = _useRangeDateTimePick.handleClickAway,
      handleStartClear = _useRangeDateTimePick.handleStartClear,
      handleEndClear = _useRangeDateTimePick.handleEndClear,
      handleConfirm = _useRangeDateTimePick.handleConfirm,
      handleCalendarUIChange = _useRangeDateTimePick.handleCalendarUIChange,
      styles = _useRangeDateTimePick.styles,
      disabled = _useRangeDateTimePick.disabled,
      readOnly = _useRangeDateTimePick.readOnly,
      allowClear = _useRangeDateTimePick.allowClear,
      calendarStyles = _useRangeDateTimePick.calendarStyles,
      disableTimeAfter = _useRangeDateTimePick.disableTimeAfter,
      disableTimeBefore = _useRangeDateTimePick.disableTimeBefore,
      placeholder = _useRangeDateTimePick.placeholder,
      defaultTime = _useRangeDateTimePick.defaultTime,
      container = _useRangeDateTimePick.container,
      inputReadOnly = _useRangeDateTimePick.inputReadOnly,
      todayDate = _useRangeDateTimePick.todayDate,
      disableDate = _useRangeDateTimePick.disableDate,
      options = _useRangeDateTimePick.options,
      hideItemOutside = _useRangeDateTimePick.hideItemOutside,
      renderDecadeItem = _useRangeDateTimePick.renderDecadeItem,
      renderMonthItem = _useRangeDateTimePick.renderMonthItem,
      renderYearItem = _useRangeDateTimePick.renderYearItem,
      renderMonthLabel = _useRangeDateTimePick.renderMonthLabel,
      timeRowNum = _useRangeDateTimePick.timeRowNum,
      hourStep = _useRangeDateTimePick.hourStep,
      minuteStep = _useRangeDateTimePick.minuteStep,
      secondStep = _useRangeDateTimePick.secondStep,
      disabledHours = _useRangeDateTimePick.disabledHours,
      disabledMinutes = _useRangeDateTimePick.disabledMinutes,
      disabledSeconds = _useRangeDateTimePick.disabledSeconds,
      hideDisabledOptions = _useRangeDateTimePick.hideDisabledOptions,
      placement = _useRangeDateTimePick.placement,
      popperProps = _useRangeDateTimePick.popperProps,
      arrowPointAtCenter = _useRangeDateTimePick.arrowPointAtCenter,
      triggerId = _useRangeDateTimePick.triggerId,
      flip = _useRangeDateTimePick.flip; // input 的 styles 直接传个 input


  var inputStyles = (0, _react.useMemo)(function () {
    if (!styles) {
      return;
    }

    var inputWrapper = styles.inputWrapper,
        input = styles.input,
        nodeDivider = styles.nodeDivider,
        nodeWrapper = styles.nodeWrapper,
        clearWrapper = styles.clearWrapper,
        statusWrapper = styles.statusWrapper;
    return {
      inputWrapper: inputWrapper,
      input: input,
      nodeDivider: nodeDivider,
      nodeWrapper: nodeWrapper,
      clearWrapper: clearWrapper,
      statusWrapper: statusWrapper
    };
  }, [styles]);
  var currentStyles = (0, _react.useMemo)(function () {
    if (!styles) {
      return;
    }

    var popPanel = styles.popPanel;
    return {
      popPanel: popPanel
    };
  }, [styles]);
  var innerStyles = (0, _useStyles["default"])('datetime-picker', defaultStyles, currentStyles);
  var InputIcon = theme.components.TimePicker.inputIcon || _ClockIcon2.ClockIcon;
  var innerSuffixNode = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement(_SuffixIcon.StyledSuffixIcon, {
      theme: theme
    }, /*#__PURE__*/_react["default"].createElement(InputIcon, null));
  }, [theme]);

  var realNode = /*#__PURE__*/_react["default"].createElement(_styled.StyledRangeInput, {
    ref: ref
  }, /*#__PURE__*/_react["default"].createElement(_styled.StyledInput, (0, _extends2["default"])({
    $focus: focusState === 'start',
    value: finalValue[0],
    suffixNode: innerSuffixNode,
    clearReplace: true,
    focusWhenClear: false,
    theme: theme,
    styles: inputStyles,
    disabled: disabled,
    allowClear: allowClear,
    onFocus: handleStartFocus,
    onClear: handleStartClear,
    readOnly: readOnly || inputReadOnly,
    placeholder: placeholder[0]
  }, otherProps, {
    hasFeedback: false
  })), /*#__PURE__*/_react["default"].createElement(_styled.StyledMiddleNode, {
    theme: theme,
    $size: otherProps.size
  }, locale['RangeDateTimePicker.middleText']), /*#__PURE__*/_react["default"].createElement(_styled.StyledInput, (0, _extends2["default"])({
    $focus: focusState === 'end',
    value: finalValue[1],
    suffixNode: innerSuffixNode,
    clearReplace: true,
    focusWhenClear: false,
    theme: theme,
    styles: inputStyles,
    disabled: disabled,
    allowClear: allowClear,
    onFocus: handleEndFocus,
    onClear: handleEndClear,
    readOnly: readOnly || inputReadOnly,
    placeholder: placeholder[1]
  }, otherProps, {
    hasFeedback: false
  })));

  if (disabled || readOnly) {
    return realNode;
  }

  var calendarProps = {
    timeRowNum: timeRowNum,
    styles: calendarStyles,
    options: options,
    todayDate: todayDate,
    allowClear: allowClear,
    disableDate: disableDate,
    timeFormat: finalTimeFormat,
    defaultTime: defaultTime,
    disableTimeAfter: disableTimeAfter,
    disableTimeBefore: disableTimeBefore,
    hideItemOutside: hideItemOutside,
    renderDecadeItem: renderDecadeItem,
    renderMonthItem: renderMonthItem,
    renderYearItem: renderYearItem,
    renderMonthLabel: renderMonthLabel,
    // ---- timepicker panel props
    hourStep: hourStep,
    minuteStep: minuteStep,
    secondStep: secondStep,
    disabledHours: disabledHours,
    disabledMinutes: disabledMinutes,
    disabledSeconds: disabledSeconds,
    hideDisabledOptions: hideDisabledOptions
  };

  var calendarNode = /*#__PURE__*/_react["default"].createElement(_PopPanel.StyledPopPanel, (0, _extends2["default"])({}, innerStyles.popPanel, {
    theme: theme
  }), /*#__PURE__*/_react["default"].createElement(_RangeDateTimeCalendar["default"], (0, _extends2["default"])({
    viewDate: finalUIState.viewDate,
    viewType: finalUIState.viewType,
    range: calendarDate.range,
    start: calendarDate.start,
    end: calendarDate.end,
    onChange: handleCalendarChange,
    onConfirm: handleConfirm,
    onUIChange: handleCalendarUIChange,
    status: focusState
  }, calendarProps)));

  var triggerProps = {
    placement: placement,
    popperProps: popperProps,
    arrowPointAtCenter: arrowPointAtCenter,
    triggerId: triggerId,
    flip: flip,
    hideArrow: true,
    container: container
  };
  return /*#__PURE__*/_react["default"].createElement(_Trigger["default"], (0, _extends2["default"])({
    popup: calendarNode,
    triggerAction: "click",
    open: finalUIState.popupOpen,
    onClickAway: handleClickAway
  }, triggerProps), realNode);
});
RangeDateTimePicker.__MUYA_RANGEDATETIMEPICKER = true;
var _default = RangeDateTimePicker;
exports["default"] = _default;