"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _StarsIcon2 = require("@muya-ui/theme-light/lib/icons/StarsIcon");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _mergeStyleItem = _interopRequireDefault(require("../utils/mergeStyleItem"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _styled = require("./styled");

var _useRate2 = _interopRequireDefault(require("./useRate"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _Tooltip = require("../Tooltip");

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _excluded = ["finalIndex", "styles", "icon", "finalInfos", "showInfo", "showResult", "showTooltip", "readOnly", "style", "count", "color", "selectSingle", "handleChange", "handleMouseLeave", "handleMouseEnter"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  wrapper: '',
  item: ''
};
var Rate = (0, _memoForwardRef["default"])(function (props, ref) {
  var _useRate = (0, _useRate2["default"])(props),
      finalIndex = _useRate.finalIndex,
      styles = _useRate.styles,
      _useRate$icon = _useRate.icon,
      icon = _useRate$icon === void 0 ? /*#__PURE__*/_react["default"].createElement(_StarsIcon2.StarsIcon, null) : _useRate$icon,
      finalInfos = _useRate.finalInfos,
      showInfo = _useRate.showInfo,
      showResult = _useRate.showResult,
      showTooltip = _useRate.showTooltip,
      readOnly = _useRate.readOnly,
      style = _useRate.style,
      _useRate$count = _useRate.count,
      count = _useRate$count === void 0 ? 5 : _useRate$count,
      color = _useRate.color,
      selectSingle = _useRate.selectSingle,
      handleChange = _useRate.handleChange,
      handleMouseLeave = _useRate.handleMouseLeave,
      handleMouseEnter = _useRate.handleMouseEnter,
      other = (0, _objectWithoutProperties2["default"])(_useRate, _excluded);

  var theme = (0, _useTheme["default"])();
  var innerStyles = (0, _useStyles["default"])('rate', defaultStyles, styles);
  var wrapperStyleItem = (0, _mergeStyleItem["default"])({
    style: style
  }, innerStyles.wrapper);
  var finalShowInfo = !showTooltip && showInfo;
  var items = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, finalInfos.map(function (text, index) {
      var content = /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, typeof icon === 'function' ? icon({
        index: index
      }) : icon, finalShowInfo && /*#__PURE__*/_react["default"].createElement(_styled.StyledItemTextInner, {
        theme: theme
      }, text));

      return /*#__PURE__*/_react["default"].createElement(_styled.StyledItem, {
        theme: theme,
        onClick: function onClick() {
          return handleChange(index);
        },
        onMouseEnter: function onMouseEnter() {
          return handleMouseEnter(index);
        },
        key: index,
        $color: color,
        style: style,
        $readOnly: readOnly,
        $active: selectSingle ? finalIndex === index : finalIndex >= index
      }, showTooltip ? /*#__PURE__*/_react["default"].createElement(_Tooltip.Tooltip, {
        title: text
      }, /*#__PURE__*/_react["default"].createElement("span", null, content)) : content);
    }), showResult && /*#__PURE__*/_react["default"].createElement(_styled.StyledItemText, {
      theme: theme
    }, finalInfos[finalIndex] || "".concat(finalIndex + 1, "\u5206")));
  }, [color, finalIndex, finalInfos, finalShowInfo, handleChange, handleMouseEnter, icon, readOnly, selectSingle, showResult, showTooltip, style, theme]);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledWrapper, (0, _extends2["default"])({
    ref: ref
  }, wrapperStyleItem, other, {
    onMouseLeave: handleMouseLeave
  }), items);
});
Rate.__MUYA_RATE = true;
var _default = Rate;
exports["default"] = _default;