"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledWrapper = exports.StyledItemTextInner = exports.StyledItemText = exports.StyledItem = void 0;
exports.makeTextStyle = makeTextStyle;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledWrapper"
})(["display:flex;align-items:center;"]);

exports.StyledWrapper = StyledWrapper;

var StyledItem = _styledComponents["default"].span.withConfig({
  displayName: "StyledItem"
})(["", ""], function (props) {
  var $readOnly = props.$readOnly,
      $color = props.$color,
      $active = props.$active,
      _props$theme = props.theme,
      transition = _props$theme.transition,
      token = _props$theme.components.Rate;
  var colorStyle = $active ? (0, _styledComponents.css)(["color:", ";"], $color || token.color) : (0, _styledComponents.css)(["color:", ";"], token.bgColor);
  var hoverStyle = !$readOnly && (0, _styledComponents.css)(["&:hover svg{transform:scale(1.16);transform-origin:center;transition:all ", ";}"], transition.spec.duration.fast);
  var cursorStyle = !$readOnly && (0, _styledComponents.css)(["cursor:pointer;"]);
  var fontSize = $readOnly ? token.displaySize : token.size;
  var marginRight = $readOnly ? token.displayMarginRight : token.marginRight;
  return (0, _styledComponents.css)(["font-size:", "px;text-align:center;", ";", ";&:not(:last-child){margin-right:", "px;}", ""], fontSize, colorStyle, cursorStyle, marginRight, hoverStyle);
});

exports.StyledItem = StyledItem;

function makeTextStyle(props) {
  var _props$theme2 = props.theme,
      fontSize = _props$theme2.typography.spec.fontSize,
      token = _props$theme2.components.Rate;
  return (0, _styledComponents.css)(["font-size:", "px;line-height:normal;color:", ";"], fontSize.s1, token.textColor);
}

var StyledItemText = _styledComponents["default"].span.withConfig({
  displayName: "StyledItemText"
})(["", ";"], makeTextStyle);

exports.StyledItemText = StyledItemText;

var StyledItemTextInner = _styledComponents["default"].div.withConfig({
  displayName: "StyledItemTextInner"
})(["", ";padding-top:", "px;"], makeTextStyle, function (_ref) {
  var theme = _ref.theme;
  return theme.components.Rate.textPadding;
});

exports.StyledItemTextInner = StyledItemTextInner;