"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useRate;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useEventCallback2 = require("@muya-ui/utils/lib/hooks/useEventCallback");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = require("react");

var _excluded = ["value", "defaultValue", "count", "infos", "onChange", "onHoverChange", "readOnly"];

function useRate(props) {
  var valueFromProps = props.value,
      defaultValue = props.defaultValue,
      _props$count = props.count,
      count = _props$count === void 0 ? 5 : _props$count,
      _props$infos = props.infos,
      infos = _props$infos === void 0 ? [] : _props$infos,
      onChange = props.onChange,
      onHoverChange = props.onHoverChange,
      readOnly = props.readOnly,
      rest = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var isControlled = ('value' in props);

  var _useState = (0, _react.useState)(defaultValue || 0),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  var _useState3 = (0, _react.useState)(0),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      hoverValue = _useState4[0],
      setHoverValue = _useState4[1];

  var _useState5 = (0, _react.useState)(false),
      _useState6 = (0, _slicedToArray2["default"])(_useState5, 2),
      isHover = _useState6[0],
      setIsHover = _useState6[1];

  var handleChange = (0, _useEventCallback2.useEventCallback)(function (value) {
    if (readOnly) return;
    setValue(value + 1);
    if (onChange) onChange(value + 1);
  });
  var handleMouseEnter = (0, _useEventCallback2.useEventCallback)(function (index) {
    if (readOnly) return;
    setIsHover(true);
    setHoverValue(index + 1);
    if (onHoverChange) onHoverChange(index + 1);
  });
  var handleMouseLeave = (0, _useEventCallback2.useEventCallback)(function () {
    if (readOnly) return;
    setHoverValue(-1);
    setIsHover(false);
  });
  var finalValue = isHover ? hoverValue : isControlled ? valueFromProps : value;
  var finalInfos = (0, _react.useMemo)(function () {
    return Array(count).fill(1).map(function (item, index) {
      return infos[index] || "".concat(index + 1, "\u5206");
    });
  }, [infos, count]);
  return (0, _extends2["default"])({
    finalIndex: (finalValue || 0) - 1,
    readOnly: readOnly,
    handleChange: handleChange,
    handleMouseEnter: handleMouseEnter,
    handleMouseLeave: handleMouseLeave,
    finalInfos: finalInfos,
    count: count
  }, rest);
}