"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Icons = exports.ExceptionStatus = void 0;

var _ClearIcon2 = require("@muya-ui/theme-light/lib/icons/ClearIcon");

var _ReminderIcon2 = require("@muya-ui/theme-light/lib/icons/ReminderIcon");

var _InformIcon2 = require("@muya-ui/theme-light/lib/icons/InformIcon");

var _SuccessIcon2 = require("@muya-ui/theme-light/lib/icons/SuccessIcon");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _react = _interopRequireWildcard(require("react"));

var _Img = require("../Img");

var _useLocale = _interopRequireDefault(require("../Locale/useLocale"));

var _Typography = _interopRequireDefault(require("../Typography"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _excluded = ["title", "subTitle", "icon", "type", "iconSize", "vertical", "extra", "reason", "styles", "imgProps"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Icons = ['success', 'error', 'info', 'warning'];
exports.Icons = Icons;
var ExceptionStatus = ['forbidden', 'empty', 'emptySmall'];
exports.ExceptionStatus = ExceptionStatus;
var defaultStyles = {
  content: '',
  icon: '',
  title: '',
  subTitle: '',
  reason: '',
  extra: ''
};
var Result = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var theme = (0, _useTheme["default"])();
  var token = theme.components.Result;
  var title = props.title,
      subTitle = props.subTitle,
      icon = props.icon,
      _props$type = props.type,
      type = _props$type === void 0 ? 'info' : _props$type,
      _props$iconSize = props.iconSize,
      iconSize = _props$iconSize === void 0 ? token.defaultIconSize : _props$iconSize,
      _props$vertical = props.vertical,
      vertical = _props$vertical === void 0 ? true : _props$vertical,
      extra = props.extra,
      reason = props.reason,
      styles = props.styles,
      imgProps = props.imgProps,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var local = (0, _useLocale["default"])();
  var innerStyles = (0, _useStyles["default"])('result', defaultStyles, styles);
  var iconNode;
  var isStatusIcon = (0, _includes2["default"])(ExceptionStatus, type);
  var typeIcon = (0, _extends2["default"])({
    success: _SuccessIcon2.SuccessIcon,
    info: _InformIcon2.InformIcon,
    warning: _ReminderIcon2.ReminderIcon,
    error: _ClearIcon2.ClearIcon,
    forbidden: '//qhstaticssl.kujiale.com/newt/100759/image/svgxml/1573020737658/62EC08BDA2CDEA69697790DCB6240015.svg',
    empty: '//qhstaticssl.kujiale.com/newt/100759/image/svgxml/1573020737659/28AD5A0CE2237E2987B3D751C4C5BA83.svg',
    emptySmall: '//qhstaticssl.kujiale.com/newt/100759/image/svgxml/1573020737281/D8307EB1E1C8C21BCE88D2D55B980DE5.svg'
  }, theme.components.Result.typeIcon);

  if (isStatusIcon) {
    var _icon = typeIcon[type];
    var _token$typeIconSize = token.typeIconSize[type],
        width = _token$typeIconSize.width,
        height = _token$typeIconSize.height;
    iconNode = /*#__PURE__*/_react["default"].createElement(_styled.StyledIcon, (0, _extends2["default"])({}, innerStyles.icon, {
      theme: theme,
      $vertical: vertical,
      $type: type,
      $iconSize: height
    }), /*#__PURE__*/_react["default"].createElement("img", {
      src: _icon,
      width: width,
      alt: ""
    }));
  } else {
    if ( /*#__PURE__*/_react["default"].isValidElement(icon)) {
      iconNode = icon;
    } else {
      var Icon = typeIcon[type];
      var iconBgColor = token.typeBg[type];
      iconNode = /*#__PURE__*/_react["default"].createElement(_styled.StyledIcon, (0, _extends2["default"])({}, innerStyles.icon, {
        theme: theme,
        $vertical: vertical,
        $type: type,
        $iconSize: iconSize
      }), typeof icon === 'string' ? /*#__PURE__*/_react["default"].createElement(_Img.ImgImg, (0, _extends2["default"])({
        src: icon,
        width: iconSize
      }, imgProps)) : /*#__PURE__*/_react["default"].createElement(Icon, {
        bgColor: iconBgColor,
        fontSize: iconSize
      }));
    }
  }

  var renderTitle = title;
  var renderSubTitle = subTitle;

  if (type === 'forbidden') {
    renderTitle = renderTitle || '403';
    renderSubTitle = renderSubTitle || local['Result.forbiddenSubTitle'];
  }

  if ((0, _includes2["default"])(type, 'empty')) {
    renderSubTitle = renderSubTitle || local['Result.emptyText'];
  }

  return /*#__PURE__*/_react["default"].createElement(_styled.StyledResult, (0, _extends2["default"])({
    ref: ref,
    theme: theme,
    $vertical: vertical
  }, otherProps), iconNode, /*#__PURE__*/_react["default"].createElement("div", innerStyles.content, renderTitle ? /*#__PURE__*/_react["default"].createElement(_styled.StyleTitle, (0, _extends2["default"])({}, innerStyles.title, {
    theme: theme,
    $vertical: vertical
  }), /*#__PURE__*/_react["default"].createElement(_Typography["default"].Title, {
    strong: true,
    level: token.defaultTitleLevel
  }, renderTitle)) : null, renderSubTitle ? /*#__PURE__*/_react["default"].createElement(_styled.StyleSubTitle, (0, _extends2["default"])({}, innerStyles.subTitle, {
    theme: theme,
    $title: renderTitle
  }), /*#__PURE__*/_react["default"].createElement(_Typography["default"].Paragraph, {
    fontSize: token.defaultSubTitleFontLevel,
    color: "assistant"
  }, renderSubTitle)) : null, reason ? /*#__PURE__*/_react["default"].createElement(_styled.StyleReason, (0, _extends2["default"])({}, innerStyles.reason, {
    theme: theme
  }), reason) : null, extra ? /*#__PURE__*/_react["default"].createElement(_styled.StyleButton, (0, _extends2["default"])({}, innerStyles.extra, {
    theme: theme
  }), extra) : null));
});
var _default = Result;
exports["default"] = _default;