"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledResult = exports.StyledIcon = exports.StyleTitle = exports.StyleSubTitle = exports.StyleReason = exports.StyleButton = void 0;

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Title = require("../Typography/Title");

var _Result = require("./Result");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledResult = _styledComponents["default"].div.withConfig({
  displayName: "StyledResult"
})(["", ""], function (props) {
  var $vertical = props.$vertical;

  if ($vertical) {
    return (0, _styledComponents.css)(["text-align:center;"]);
  } else {
    return (0, _styledComponents.css)(["display:flex;justify-content:center;"]);
  }
});

exports.StyledResult = StyledResult;

var StyledIcon = _styledComponents["default"].div.withConfig({
  displayName: "StyledIcon"
})(["", ""], function (props) {
  var theme = props.theme,
      $vertical = props.$vertical,
      $type = props.$type,
      $iconSize = props.$iconSize;
  var marginRight = $vertical ? 0 : theme.components.Result.iconMarginRight;

  if ((0, _includes2["default"])(_Result.Icons, $type)) {
    return (0, _styledComponents.css)(["margin-right:", "px;color:", ";height:", "px;"], marginRight, theme.colors.pattern.feature[$type], $iconSize);
  } else {
    return (0, _styledComponents.css)(["margin-right:", "px;height:", "px;"], marginRight, $iconSize);
  }
});

exports.StyledIcon = StyledIcon;

var StyleTitle = _styledComponents["default"].div.withConfig({
  displayName: "StyleTitle"
})(["", ""], function (props) {
  var theme = props.theme,
      $vertical = props.$vertical;
  var top = $vertical ? theme.components.Result.titleMarginTop : 0;
  return (0, _styledComponents.css)(["margin-top:", "px;", "{margin-bottom:0;}"], top, _Title.StyledTitle);
});

exports.StyleTitle = StyleTitle;

var StyleSubTitle = _styledComponents["default"].div.withConfig({
  displayName: "StyleSubTitle"
})(["", ""], function (props) {
  var _props$theme$componen = props.theme.components.Result,
      titleMarginTop = _props$theme$componen.titleMarginTop,
      useTitleMarginTopWhenNoTitle = _props$theme$componen.useTitleMarginTopWhenNoTitle,
      subTitleMarginTop = _props$theme$componen.subTitleMarginTop;
  return (0, _styledComponents.css)(["margin-top:", "px;"], !props.$title && useTitleMarginTopWhenNoTitle ? titleMarginTop : subTitleMarginTop);
});

exports.StyleSubTitle = StyleSubTitle;

var StyleReason = _styledComponents["default"].div.withConfig({
  displayName: "StyleReason"
})(["", ""], function (props) {
  var token = props.theme.components.Result;
  return (0, _styledComponents.css)(["margin-top:", "px;margin-bottom:", "px;"], token.reasonMarginTop, token.reasonMarginBottom);
});

exports.StyleReason = StyleReason;

var StyleButton = _styledComponents["default"].div.withConfig({
  displayName: "StyleButton"
})(["", ""], function (props) {
  var theme = props.theme;
  return (0, _styledComponents.css)(["margin-top:", "px;"], theme.components.Result.buttonMarginTop);
});

exports.StyleButton = StyleButton;