"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _base = require("../styled/base");

var _addPx = _interopRequireDefault(require("../utils/addPx"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _withTheme = require("../utils/withTheme");

var _styled = require("./styled");

var _excluded = ["scrollX", "scrollY", "width", "height", "maxWidth", "maxHeight", "size", "children", "styles", "onScroll", "contentRef"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  content: ''
};
var ScrollViewPure = (0, _memoForwardRef["default"])(function (props, ref) {
  var scrollX = props.scrollX,
      scrollY = props.scrollY,
      width = props.width,
      height = props.height,
      maxWidth = props.maxWidth,
      maxHeight = props.maxHeight,
      size = props.size,
      children = props.children,
      styles = props.styles,
      onScroll = props.onScroll,
      contentRef = props.contentRef,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var innerStyles = (0, _useStyles["default"])('scroll-view', defaultStyles, styles);
  return /*#__PURE__*/_react["default"].createElement(_base.BaseDiv, (0, _extends2["default"])({}, restProps, {
    ref: ref
  }), /*#__PURE__*/_react["default"].createElement(_styled.StyledScrollViewContent, (0, _extends2["default"])({
    ref: contentRef,
    onScroll: onScroll
  }, innerStyles.content), children));
});
var ScrollView = (0, _styledComponents["default"])(ScrollViewPure).withConfig({
  displayName: "ScrollView"
})(["", ""], function (props) {
  var width = props.width,
      height = props.height,
      maxWidth = props.maxWidth,
      maxHeight = props.maxHeight,
      scrollX = props.scrollX,
      _props$scrollY = props.scrollY,
      scrollY = _props$scrollY === void 0 ? true : _props$scrollY,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      theme = props.theme;
  var token = theme.components.ScrollView;
  return (0, _styledComponents.css)(["", ";", ";", ";", ";", ";", ";", "{height:100%;", ";", ";", ";", ";", "}"], width && "width: ".concat((0, _addPx["default"])(width)), height && "height: ".concat((0, _addPx["default"])(height)), maxWidth && "max-width: ".concat((0, _addPx["default"])(maxWidth)), maxHeight && "max-height: ".concat((0, _addPx["default"])(maxHeight)), scrollX && "padding-bottom: ".concat((0, _addPx["default"])(token.padding)), scrollY && "padding-right: ".concat((0, _addPx["default"])(token.padding)), _styled.StyledScrollViewContent, maxWidth && "max-width: ".concat((0, _addPx["default"])(maxWidth)), maxHeight && "max-height: ".concat((0, _addPx["default"])(maxHeight)), scrollX && (0, _styled.scrollXStyle)(token.padding), scrollY && (0, _styled.scrollYStyle)(token.padding), (0, _styled.scrollBarStyle)({
    size: size,
    theme: theme
  }));
});

var _default = (0, _withTheme.withThemeForStyled)(ScrollView);

exports["default"] = _default;