"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.scrollYStyle = exports.scrollXStyle = exports.scrollBarStyle = exports.StyledScrollViewContent = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _addPx = _interopRequireDefault(require("../utils/addPx"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var scrollXStyle = function scrollXStyle(padding) {
  return (0, _styledComponents.css)(["overflow-x:auto;padding-bottom:", ";"], (0, _addPx["default"])(padding));
};

exports.scrollXStyle = scrollXStyle;

var scrollYStyle = function scrollYStyle(padding) {
  return (0, _styledComponents.css)(["overflow-y:auto;padding-right:", ";"], (0, _addPx["default"])(padding));
};

exports.scrollYStyle = scrollYStyle;

var scrollBarStyle = function scrollBarStyle(props) {
  var theme = props.theme,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      hidden = props.hidden,
      hideEndButton = props.hideEndButton;
  var token = theme.components.ScrollView.scrollBar;
  var finalSize = hidden ? 0 : token.size[size];
  return (0, _styledComponents.css)(["&::-webkit-scrollbar{width:", "px;height:", "px;}&::-webkit-scrollbar-thumb{border-radius:", ";background-color:", ";&:hover{background-color:", ";}}&::-webkit-scrollbar-corner{background-color:transparent;}", ""], finalSize, finalSize, token.borderRadius, token.background, token.hoverBackground, hideEndButton && (0, _styledComponents.css)(["&::-webkit-scrollbar-button:vertical:end:decrement{display:block;width:", "px;height:", "px;background-color:transparent;}"], finalSize, finalSize));
};

exports.scrollBarStyle = scrollBarStyle;

var StyledScrollViewContent = _styledComponents["default"].div.withConfig({
  displayName: "StyledScrollViewContent"
})([""]);

exports.StyledScrollViewContent = StyledScrollViewContent;