"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _FoldIcon2 = require("@muya-ui/theme-light/lib/icons/FoldIcon");

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _omit2 = _interopRequireDefault(require("lodash/omit"));

var _endsWith2 = _interopRequireDefault(require("lodash/endsWith"));

var _react = _interopRequireWildcard(require("react"));

var _ExpandIcon = _interopRequireDefault(require("../ExpandIcon"));

var _Input = _interopRequireWildcard(require("../Input"));

var _styled = require("../Input/styled");

var _ExpandWrapper = _interopRequireDefault(require("../styled/components/ExpandWrapper"));

var _addPx = _interopRequireDefault(require("../utils/addPx"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _mergeStyleItem = _interopRequireDefault(require("../utils/mergeStyleItem"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _const = require("./const");

var _styled2 = require("./styled");

var _useSelectInput2 = _interopRequireDefault(require("./useSelectInput"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  inputWrapper: '',
  input: ''
};
var SelectInput = (0, _memoForwardRef["default"])(function (props, ref) {
  var id = props.id,
      disabled = props.disabled,
      allowClear = props.allowClear,
      readOnly = props.readOnly,
      placeholder = props.placeholder,
      status = props.status,
      maxVerticalTagCount = props.maxVerticalTagCount,
      maxTagWidth = props.maxTagWidth,
      maxTagTextLength = props.maxTagTextLength,
      showSearch = props.showSearch,
      expandIcon = props.expandIcon,
      inputValue = props.inputValue,
      popupVisible = props.popupVisible,
      showMenu = props.showMenu,
      value = props.value,
      isMultiple = props.isMultiple,
      hasValue = props.hasValue,
      mode = props.mode,
      width = props.width,
      hideExpandIcon = props.hideExpandIcon,
      getInputElement = props.getInputElement,
      styles = props.styles,
      style = props.style,
      inputRef = props.inputRef,
      className = props.className,
      onClear = props.onClear,
      prefixNode = props.prefixNode,
      suffixNode = props.suffixNode,
      _props$clearReplace = props.clearReplace,
      clearReplace = _props$clearReplace === void 0 ? true : _props$clearReplace,
      autoResize = props.autoResize,
      bordered = props.bordered,
      size = props.size,
      combobox = props.combobox,
      renderTag = props.renderTag;
  var theme = (0, _useTheme["default"])();
  var token = theme.components.Select;
  var innerInputRef = (0, _react.useRef)(null);
  var sizerRef = (0, _react.useRef)(null);
  var handleRef = (0, _useForkRef2.useForkRef)(innerInputRef, inputRef);

  var _useSelectInput = (0, _useSelectInput2["default"])(props, innerInputRef, sizerRef),
      disabledValue = _useSelectInput.disabledValue,
      readOnlyValue = _useSelectInput.readOnlyValue,
      getDefaultModeLabel = _useSelectInput.getDefaultModeLabel,
      labelByValue = _useSelectInput.labelByValue,
      handleAddTag = _useSelectInput.handleAddTag,
      handleRemoveTag = _useSelectInput.handleRemoveTag,
      handleInput = _useSelectInput.handleInput,
      handleInputFocus = _useSelectInput.handleInputFocus,
      handleInputBlur = _useSelectInput.handleInputBlur,
      handleInputKeyDown = _useSelectInput.handleInputKeyDown,
      handleInputPaste = _useSelectInput.handleInputPaste;

  var realVisible = popupVisible && showMenu;
  var finalAllowClear = allowClear && !disabled && !readOnly;
  var selectInputStyles = (0, _react.useMemo)(function () {
    var selectInputStyles = {};

    if (styles) {
      var inputWrapper = styles.inputWrapper,
          input = styles.input;
      selectInputStyles = {
        inputWrapper: inputWrapper,
        input: input
      };
    }

    return selectInputStyles;
  }, [styles]);
  var innerStyles = (0, _useStyles["default"])('select', defaultStyles, selectInputStyles);
  var wrapperStyleItem = (0, _react.useMemo)(function () {
    return (0, _mergeStyleItem["default"])({
      className: className,
      style: style
    }, innerStyles.inputWrapper);
  }, [className, innerStyles.inputWrapper, style]);
  var inputRestProps = (0, _omit2["default"])(props, _const.allSelectInputProps);
  var finalSuffixNode = (0, _react.useMemo)(function () {
    var finalSuffixNode = [];

    if (suffixNode) {
      finalSuffixNode.push(suffixNode);
    }

    if (!hideExpandIcon) {
      var DefaultExpandIcon = token.expandIcon || _FoldIcon2.FoldIcon;
      finalSuffixNode.push( /*#__PURE__*/_react["default"].createElement(_ExpandWrapper["default"], {
        key: "expand-icon",
        theme: theme,
        $expanded: realVisible
      }, /*#__PURE__*/_react["default"].createElement(_ExpandIcon["default"], {
        icon: expandIcon,
        DefaultIcon: DefaultExpandIcon,
        disabled: disabled
      })));
    }

    return finalSuffixNode;
  }, [disabled, expandIcon, hideExpandIcon, realVisible, suffixNode, theme, token.expandIcon]);

  var renderSingleModeNode = function renderSingleModeNode() {
    var inputProps = (0, _extends2["default"])({}, inputRestProps, innerStyles.input, {
      allowClear: finalAllowClear,
      disabled: disabled,
      readOnly: readOnly,
      width: typeof width === 'string' && (0, _endsWith2["default"])(width, '%') ? '100%' : width,
      placeholder: placeholder,
      value: inputValue,
      inputRef: handleRef,
      prefixNode: prefixNode,
      suffixNode: finalSuffixNode,
      clearReplace: clearReplace,
      onKeyDown: handleInputKeyDown,
      onInput: handleInput,
      onFocus: handleInputFocus,
      onBlur: handleInputBlur,
      onClear: onClear
    });
    var label = getDefaultModeLabel(combobox); // 非搜索模式那么不可输入

    if (!showSearch || !popupVisible && !combobox) {
      inputProps.readOnly = true;
    }

    if (typeof label === 'string' || typeof label === 'number') {
      if (!realVisible && !combobox || combobox && !popupVisible && label) {
        inputProps.value = String(label);
      }

      if (!inputValue && label) {
        inputProps.placeholder = String(label);
      }
    } else {
      inputProps.replacedInputNode = /*#__PURE__*/_react["default"].createElement(_styled2.StyledLabelWrapper, null, label);
    }

    if (inputProps.value) {
      inputProps.title = inputProps.value;
    }

    var inputElement = /*#__PURE__*/_react["default"].createElement(_Input["default"], {
      type: "text"
    });

    if (getInputElement) {
      inputElement = getInputElement();
    }

    var input = /*#__PURE__*/(0, _react.cloneElement)(inputElement, (0, _extends2["default"])({
      ref: ref
    }, inputProps));

    if (!autoResize) {
      return input;
    }

    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, input, /*#__PURE__*/_react["default"].createElement(_styled2.StyledSelectInputSizer, {
      ref: sizerRef,
      theme: theme,
      $size: size
    }, label || placeholder));
  }; // 渲染 input 和 tag


  var renderMultipleModeNode = function renderMultipleModeNode() {
    return /*#__PURE__*/_react["default"].createElement(_Input.TagsInput, (0, _extends2["default"])({}, inputRestProps, innerStyles.input, {
      ref: ref,
      inputRef: handleRef,
      suffixNode: finalSuffixNode,
      width: typeof width === 'string' && (0, _endsWith2["default"])(width, '%') ? '100%' : width,
      disabled: disabled,
      readOnly: readOnly,
      inputReadOnly: !showSearch,
      value: value,
      styles: selectInputStyles,
      inputValue: inputValue,
      disabledValue: disabledValue,
      readOnlyValue: readOnlyValue,
      placeholder: hasValue ? '' : placeholder,
      allowAdd: mode === 'tags',
      allowClear: finalAllowClear,
      getTagText: labelByValue,
      maxTagTextLength: maxTagTextLength,
      maxVerticalTagCount: maxVerticalTagCount,
      maxTagWidth: maxTagWidth,
      scrollTopAfterEffect: !popupVisible,
      onAddTag: handleAddTag,
      onRemoveTag: handleRemoveTag,
      onInputKeyDown: handleInputKeyDown,
      onInput: handleInput,
      onFocus: handleInputFocus,
      onBlur: handleInputBlur,
      onClear: onClear,
      renderTag: renderTag,
      onPaste: handleInputPaste
    }));
  };

  var renderInput = function renderInput() {
    if (isMultiple) {
      return renderMultipleModeNode();
    } else {
      return renderSingleModeNode();
    }
  };

  return /*#__PURE__*/_react["default"].createElement(_styled.StyledPopperInputWrapper, (0, _extends2["default"])({
    id: id,
    role: "combobox",
    key: "selection",
    $pointer: !isMultiple && !showSearch && !disabled || readOnly,
    $popupVisible: realVisible,
    $width: (0, _addPx["default"])(width),
    $status: status,
    $bordered: bordered,
    theme: theme
  }, wrapperStyleItem), renderInput());
});
var _default = SelectInput;
exports["default"] = _default;