"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _excluded = ["loading", "active", "type", "children", "rows", "styles"];
var defaultStyles = {
  cardContent: '',
  cardTitle: '',
  cardDesc: '',
  paragraphTitle: '',
  paragraph: '',
  treeHead: '',
  treeSquare: '',
  treeContent: '',
  treeChild: '',
  navigationHead: '',
  navigationSquare: '',
  navigationNode: ''
};

var Skeleton = /*#__PURE__*/_react["default"].memo(function Skeleton(props) {
  var theme = (0, _useTheme["default"])();
  var _props$loading = props.loading,
      loading = _props$loading === void 0 ? true : _props$loading,
      _props$active = props.active,
      active = _props$active === void 0 ? true : _props$active,
      _props$type = props.type,
      type = _props$type === void 0 ? 'block' : _props$type,
      children = props.children,
      _props$rows = props.rows,
      rows = _props$rows === void 0 ? 6 : _props$rows,
      styles = props.styles,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var innerStyles = (0, _useStyles["default"])('skeleton', defaultStyles, styles);
  var rowArray = (0, _toConsumableArray2["default"])(Array(rows));

  if (!loading) {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, children);
  }

  if (type === 'card') {
    return /*#__PURE__*/_react["default"].createElement(_styled.StyledCardWrapper, other, /*#__PURE__*/_react["default"].createElement(_styled.StyledCardContent, (0, _extends2["default"])({}, innerStyles.cardContent, {
      active: active,
      theme: theme
    })), /*#__PURE__*/_react["default"].createElement(_styled.StyledCardTitle, (0, _extends2["default"])({}, innerStyles.cardTitle, {
      active: active,
      theme: theme
    })), /*#__PURE__*/_react["default"].createElement(_styled.StyledCardDesc, (0, _extends2["default"])({}, innerStyles.cardDesc, {
      active: active,
      theme: theme
    })));
  }

  if (type === 'paragraph') {
    return /*#__PURE__*/_react["default"].createElement(_styled.StyledParagraphWrapper, other, /*#__PURE__*/_react["default"].createElement(_styled.StyledParagraphTitle, (0, _extends2["default"])({}, innerStyles.paragraphTitle, {
      theme: theme,
      active: active
    })), rowArray.map(function (_v, index) {
      return /*#__PURE__*/_react["default"].createElement(_styled.StyledParagraph, (0, _extends2["default"])({}, innerStyles.paragraph, {
        key: index,
        theme: theme,
        active: active
      }));
    }));
  }

  if (type === 'tree') {
    return /*#__PURE__*/_react["default"].createElement(_styled.StyledTreeWrapper, (0, _extends2["default"])({
      theme: theme
    }, other), /*#__PURE__*/_react["default"].createElement(_styled.StyledTreeHead, (0, _extends2["default"])({}, innerStyles.treeHead, {
      theme: theme
    }), /*#__PURE__*/_react["default"].createElement(_styled.StyledTreeSquare, (0, _extends2["default"])({}, innerStyles.treeSquare, {
      theme: theme,
      active: active
    })), /*#__PURE__*/_react["default"].createElement(_styled.StyledTreeContent, (0, _extends2["default"])({}, innerStyles.treeContent, {
      theme: theme,
      active: active
    }))), rowArray.map(function (_v, index) {
      return /*#__PURE__*/_react["default"].createElement(_styled.StyledTreeChild, (0, _extends2["default"])({}, innerStyles.treeChild, {
        key: index,
        theme: theme
      }), /*#__PURE__*/_react["default"].createElement(_styled.StyledTreeSquare, (0, _extends2["default"])({}, innerStyles.treeSquare, {
        theme: theme,
        active: active
      })), /*#__PURE__*/_react["default"].createElement(_styled.StyledTreeContent, (0, _extends2["default"])({}, innerStyles.treeContent, {
        theme: theme,
        active: active
      })));
    }));
  }

  if (type === 'navigation') {
    return /*#__PURE__*/_react["default"].createElement(_styled.StyledNavigationWrapper, (0, _extends2["default"])({}, other, {
      theme: theme
    }), /*#__PURE__*/_react["default"].createElement(_styled.StyledNavigationHead, (0, _extends2["default"])({}, innerStyles.navigationHead, {
      theme: theme
    }), /*#__PURE__*/_react["default"].createElement(_styled.StyledNavigationSquare, (0, _extends2["default"])({}, innerStyles.navigationSquare, {
      theme: theme,
      active: active
    })), /*#__PURE__*/_react["default"].createElement(_styled.StyledNavigationNode, (0, _extends2["default"])({}, innerStyles.navigationNode, {
      theme: theme,
      active: active
    }))), rowArray.map(function (_v, index) {
      return /*#__PURE__*/_react["default"].createElement(_styled.StyledNavigationNode, (0, _extends2["default"])({}, innerStyles.navigationNode, {
        key: index,
        theme: theme,
        active: active
      }));
    }));
  }

  return /*#__PURE__*/_react["default"].createElement(_styled.StyledBlock, (0, _extends2["default"])({
    theme: theme,
    active: active
  }, other));
});

var _default = Skeleton;
exports["default"] = _default;