"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledTreeWrapper = exports.StyledTreeSquare = exports.StyledTreeNode = exports.StyledTreeHead = exports.StyledTreeContent = exports.StyledTreeChild = exports.StyledParagraphWrapper = exports.StyledParagraphTitle = exports.StyledParagraph = exports.StyledNavigationWrapper = exports.StyledNavigationSquare = exports.StyledNavigationNode = exports.StyledNavigationHead = exports.StyledCardWrapper = exports.StyledCardTitle = exports.StyledCardDesc = exports.StyledCardContent = exports.StyledBlock = exports.StyledBaseSkeletonItem = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _skeleton = require("../styled/mixins/skeleton");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledBaseSkeletonItem = _styledComponents["default"].div.withConfig({
  displayName: "StyledBaseSkeletonItem"
})(["", ";"], function (props) {
  var theme = props.theme;
  var activeStyle = props.active ? (0, _skeleton.skeletonActiveCss)({
    theme: theme
  }) : (0, _skeleton.skeletonNormalCss)({
    theme: theme
  });
  return (0, _styledComponents.css)(["", ""], activeStyle);
}); // block


exports.StyledBaseSkeletonItem = StyledBaseSkeletonItem;
var StyledBlock = (0, _styledComponents["default"])(StyledBaseSkeletonItem).withConfig({
  displayName: "StyledBlock"
})(["width:100%;height:100%;"]); // card

exports.StyledBlock = StyledBlock;

var StyledCardWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledCardWrapper"
})(["display:inline-flex;flex-flow:column nowrap;align-items:flex-start;"]);

exports.StyledCardWrapper = StyledCardWrapper;
var StyledCardTitle = (0, _styledComponents["default"])(StyledBaseSkeletonItem).withConfig({
  displayName: "StyledCardTitle"
})(["width:", ";height:", "px;margin-top:", "px;"], function (props) {
  return props.theme.components.Skeleton.card.titleWidth;
}, function (props) {
  return props.theme.components.Skeleton.card.titleHeight;
}, function (props) {
  return props.theme.spacing.spec.s5;
});
exports.StyledCardTitle = StyledCardTitle;
var StyledCardDesc = (0, _styledComponents["default"])(StyledBaseSkeletonItem).withConfig({
  displayName: "StyledCardDesc"
})(["width:", ";height:", "px;margin-top:", "px;"], function (props) {
  return props.theme.components.Skeleton.card.descWidth;
}, function (props) {
  return props.theme.components.Skeleton.card.descHeight;
}, function (props) {
  return props.theme.spacing.spec.s5;
});
exports.StyledCardDesc = StyledCardDesc;
var StyledCardContent = (0, _styledComponents["default"])(StyledBaseSkeletonItem).withConfig({
  displayName: "StyledCardContent"
})(["flex:1;align-self:stretch;"]); // paragraph

exports.StyledCardContent = StyledCardContent;

var StyledParagraphWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledParagraphWrapper"
})(["display:flex;flex-flow:column nowrap;align-items:flex-start;"]);

exports.StyledParagraphWrapper = StyledParagraphWrapper;
var StyledParagraphTitle = (0, _styledComponents["default"])(StyledBaseSkeletonItem).withConfig({
  displayName: "StyledParagraphTitle"
})(["height:", "px;margin-bottom:", "px;width:", "px;"], function (props) {
  return props.theme.components.Skeleton.paragraph.height;
}, function (props) {
  return props.theme.components.Skeleton.paragraph.titleMarginBottom;
}, function (props) {
  return props.theme.components.Skeleton.paragraph.titleWidth;
});
exports.StyledParagraphTitle = StyledParagraphTitle;
var StyledParagraph = (0, _styledComponents["default"])(StyledBaseSkeletonItem).withConfig({
  displayName: "StyledParagraph"
})(["height:", "px;margin-top:", "px;width:100%;"], function (props) {
  return props.theme.components.Skeleton.paragraph.height;
}, function (props) {
  return props.theme.components.Skeleton.paragraph.marginTop;
}); // tree

exports.StyledParagraph = StyledParagraph;
var StyledTreeSquare = (0, _styledComponents["default"])(StyledBaseSkeletonItem).withConfig({
  displayName: "StyledTreeSquare"
})(["height:", "px;width:", "px;margin-right:", "px;"], function (props) {
  return props.theme.components.Skeleton.tree.squareSize;
}, function (props) {
  return props.theme.components.Skeleton.tree.squareSize;
}, function (props) {
  return props.theme.components.Skeleton.tree.squareMarginRight;
});
exports.StyledTreeSquare = StyledTreeSquare;
var StyledTreeContent = (0, _styledComponents["default"])(StyledBaseSkeletonItem).withConfig({
  displayName: "StyledTreeContent"
})(["flex:1;height:", "px;"], function (props) {
  return props.theme.components.Skeleton.tree.contentHeight;
});
exports.StyledTreeContent = StyledTreeContent;

var StyledTreeNode = _styledComponents["default"].div.withConfig({
  displayName: "StyledTreeNode"
})(["display:flex;align-items:center;"]);

exports.StyledTreeNode = StyledTreeNode;
var StyledTreeHead = (0, _styledComponents["default"])(StyledTreeNode).withConfig({
  displayName: "StyledTreeHead"
})(["margin-right:", ";"], function (props) {
  var _props$theme$componen = props.theme.components.Skeleton.tree,
      squareSize = _props$theme$componen.squareSize,
      squareMarginRight = _props$theme$componen.squareMarginRight;
  return "".concat(squareMarginRight + squareSize, "px");
});
exports.StyledTreeHead = StyledTreeHead;
var StyledTreeChild = (0, _styledComponents["default"])(StyledTreeNode).withConfig({
  displayName: "StyledTreeChild"
})(["margin-left:", ";margin-top:", "px;&:nth-child(2n){", "{transform:scaleX(0.5);transform-origin:left center;}}"], function (props) {
  var _props$theme$componen2 = props.theme.components.Skeleton.tree,
      squareSize = _props$theme$componen2.squareSize,
      squareMarginRight = _props$theme$componen2.squareMarginRight;
  return "".concat(squareMarginRight + squareSize, "px");
}, function (props) {
  return props.theme.components.Skeleton.tree.treeNodeMarginTop;
}, StyledTreeContent);
exports.StyledTreeChild = StyledTreeChild;

var StyledTreeWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledTreeWrapper"
})(["display:flex;flex-flow:column nowrap;& + &{margin-top:", "px;}"], function (props) {
  return props.theme.components.Skeleton.navigation.navigationNodeMarginTop;
}); // navigation


exports.StyledTreeWrapper = StyledTreeWrapper;
var StyledNavigationSquare = (0, _styledComponents["default"])(StyledBaseSkeletonItem).withConfig({
  displayName: "StyledNavigationSquare"
})(["height:", "px;width:", "px;margin-right:", "px;"], function (props) {
  return props.theme.components.Skeleton.navigation.squareSize;
}, function (props) {
  return props.theme.components.Skeleton.navigation.squareSize;
}, function (props) {
  return props.theme.components.Skeleton.navigation.squareMarginRight;
});
exports.StyledNavigationSquare = StyledNavigationSquare;
var StyledNavigationNode = (0, _styledComponents["default"])(StyledBaseSkeletonItem).withConfig({
  displayName: "StyledNavigationNode"
})(["height:", "px;margin-top:", "px;transform-origin:left center;"], function (props) {
  return props.theme.components.Skeleton.navigation.contentHeight;
}, function (props) {
  return props.theme.components.Skeleton.navigation.navigationNodeMarginTop;
});
exports.StyledNavigationNode = StyledNavigationNode;

var StyledNavigationWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledNavigationWrapper"
})(["display:flex;flex-flow:column nowrap;", ""], function (props) {
  var navigationNodeScaleList = props.theme.components.Skeleton.navigation.navigationNodeScaleList;
  return navigationNodeScaleList.map(function (v, i) {
    return (0, _styledComponents.css)(["& > ", ":nth-of-type(", "n+", "){transform:", ";}"], StyledNavigationNode, navigationNodeScaleList.length, i + 2, "scaleX(".concat(v, ")"));
  });
});

exports.StyledNavigationWrapper = StyledNavigationWrapper;

var StyledNavigationHead = _styledComponents["default"].div.withConfig({
  displayName: "StyledNavigationHead"
})(["display:flex;align-items:center;margin-bottom:", "px;", "{margin:0;transform:", ";flex:1;}"], function (props) {
  return props.theme.components.Skeleton.navigation.navigationHeadMarginBottom;
}, StyledNavigationNode, function (props) {
  return "scaleX(".concat(props.theme.components.Skeleton.navigation.navigationHeadScale, ")");
});

exports.StyledNavigationHead = StyledNavigationHead;