"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.RangeSlider = void 0;
exports.useSlider = useSlider;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _BaseSlider = _interopRequireDefault(require("./BaseSlider"));

var _excluded = ["value", "defaultValue", "onChange", "onAfterChange", "min"];

function useSlider(props) {
  var onChange = props.onChange,
      onAfterChange = props.onAfterChange;

  var handleChange = _react["default"].useCallback(function (val) {
    onChange && onChange(val[1]);
  }, [onChange]);

  var handleAfterChange = _react["default"].useCallback(function (val) {
    onAfterChange && onAfterChange(val[1]);
  }, [onAfterChange]);

  return {
    handleChange: handleChange,
    handleAfterChange: handleAfterChange
  };
}

var Slider = (0, _memoForwardRef["default"])(function (props, ref) {
  var value = props.value,
      defaultValue = props.defaultValue,
      onChange = props.onChange,
      onAfterChange = props.onAfterChange,
      _props$min = props.min,
      min = _props$min === void 0 ? 0 : _props$min,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var restProps = {};

  if ('value' in props) {
    restProps['value'] = [min, props.value || min];
  }

  if ('defaultValue' in props) {
    restProps['defaultValue'] = [min, props.defaultValue || min];
  }

  var _useSlider = useSlider(props),
      handleChange = _useSlider.handleChange,
      handleAfterChange = _useSlider.handleAfterChange;

  return /*#__PURE__*/_react["default"].createElement(_BaseSlider["default"], (0, _extends2["default"])({
    ref: ref,
    hideStart: true,
    onChange: handleChange,
    onAfterChange: handleAfterChange,
    min: min
  }, otherProps, restProps));
});
var RangeSlider = (0, _memoForwardRef["default"])(function (props, ref) {
  return /*#__PURE__*/_react["default"].createElement(_BaseSlider["default"], (0, _extends2["default"])({}, props, {
    ref: ref
  }));
});
exports.RangeSlider = RangeSlider;
var _default = Slider;
exports["default"] = _default;