"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledRoot = exports.StyledRange = exports.StyledMarksRow = exports.StyledMarkPoint = exports.StyledMarkLabel = exports.StyledLabelNode = exports.StyledCircle = exports.StyledBaseRootTrack = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _InlineButton = _interopRequireDefault(require("../InlineButton"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function cursorCss(props) {
  if (props.$disabled) {
    return (0, _styledComponents.css)(["cursor:not-allowed;"]);
  }

  if (props.$moving) {
    return (0, _styledComponents.css)(["cursor:grabbing;"]);
  }

  if (props.$disableClick) {
    return;
  }

  return (0, _styledComponents.css)(["cursor:pointer;"]);
}

var StyledRoot = _styledComponents["default"].div.withConfig({
  displayName: "StyledRoot"
})(["position:relative;box-sizing:border-box;", " ", ""], cursorCss, function (props) {
  var _props$theme = props.theme,
      token = _props$theme.components.Slider,
      opacity = _props$theme.opacity;
  var hoverCss;

  if (!props.$disabled) {
    hoverCss = (0, _styledComponents.css)(["&:hover ", "{background-color:", ";}"], StyledBaseRootTrackInner, token.trackHoverBgColor);
  }

  if (props.$vertical) {
    return (0, _styledComponents.css)(["display:flex;padding:0 ", "px;", ";"], token.rootPadding, hoverCss);
  }

  return (0, _styledComponents.css)(["padding:", "px 0;", ";", ";"], token.rootPadding, props.$disabled && "opacity: ".concat(opacity.pattern.disabled), hoverCss);
});

exports.StyledRoot = StyledRoot;

var StyledRange = _styledComponents["default"].div.withConfig({
  displayName: "StyledRange"
})(["position:absolute;", " ", ""], cursorCss, function (props) {
  var _props$theme2 = props.theme,
      token = _props$theme2.components.Slider,
      borderRadius = _props$theme2.size.spec.borderRadius;
  var directionCss;

  if (props.$vertical) {
    directionCss = (0, _styledComponents.css)(["width:100%;"]);
  } else {
    directionCss = (0, _styledComponents.css)(["height:100%;"]);
  }

  return (0, _styledComponents.css)(["border-radius:", ";background-color:", ";z-index:1;", ""], borderRadius.s5, token.trackActiveBgColor, directionCss);
}); // 放 marks


exports.StyledRange = StyledRange;

var StyledMarkPointInner = _styledComponents["default"].div.withConfig({
  displayName: "StyledMarkPointInner"
})(["position:absolute;box-sizing:border-box;", " ", ""], cursorCss, function (props) {
  var _props$theme3 = props.theme,
      token = _props$theme3.components.Slider,
      borderRadius = _props$theme3.size.spec.borderRadius;
  var directionCss;

  if (props.$vertical) {
    directionCss = (0, _styledComponents.css)(["left:50%;"]);
  } else {
    directionCss = (0, _styledComponents.css)(["top:50%;"]);
  }

  var bgColor = token.markPointColor;
  var borderColor = token.markPointBorderColor;

  if (props.$include) {
    borderColor = token.includeMarkPointBorderColor;
    bgColor = token.includeMarkPointColor;
  }

  return (0, _styledComponents.css)(["z-index:2;height:", "px;width:", "px;display:flex;align-items:center;justify-content:center;transform:translate(-50%,-50%);", " &::before{content:'';display:block;box-sizing:border-box;height:", "px;width:", "px;border:", "px solid ", ";border-radius:", ";background-color:", ";}&:hover{&::before{border-color:", ";}}"], token.circleSize, token.circleSize, directionCss, token.markPointSize, token.markPointSize, token.markPointBorderSize, borderColor, borderRadius.s5, bgColor, token.includeMarkPointColor);
});

var StyledMarkPoint = /*#__PURE__*/_react["default"].memo(StyledMarkPointInner);

exports.StyledMarkPoint = StyledMarkPoint;

var StyledMarksRowInner = _styledComponents["default"].div.withConfig({
  displayName: "StyledMarksRowInner"
})(["position:relative;", ""], function (props) {
  var token = props.theme.components.Slider;

  if (props.$vertical) {
    return (0, _styledComponents.css)(["height:100%;flex:1;margin-left:", "px;"], token.markRowGutter);
  }

  return (0, _styledComponents.css)(["width:100%;margin-top:", "px;height:20px;"], token.markRowGutter);
});

var StyledMarksRow = /*#__PURE__*/_react["default"].memo(StyledMarksRowInner);

exports.StyledMarksRow = StyledMarksRow;
var StyledLabelNode = (0, _styledComponents["default"])(_InlineButton["default"]).withConfig({
  displayName: "StyledLabelNode"
})(["", ""], function (props) {
  return (0, _styledComponents.css)(["font-size:", "px;line-height:", "px;"], props.theme.components.Slider.labelNodeFontSize, props.theme.components.Slider.labelNodeLineHeight);
});
exports.StyledLabelNode = StyledLabelNode;

var StyledMarkLabelInner = _styledComponents["default"].div.withConfig({
  displayName: "StyledMarkLabelInner"
})(["position:absolute;transform:translate(-50%,0);", " ", ""], cursorCss, function (props) {
  if (props.$vertical) {
    return (0, _styledComponents.css)(["left:0;transform:translate(0,-50%);"]);
  }

  return (0, _styledComponents.css)(["transform:translate(-50%,0);top:0;"]);
});

var StyledMarkLabel = /*#__PURE__*/_react["default"].memo(StyledMarkLabelInner);

exports.StyledMarkLabel = StyledMarkLabel;

var StyledCircleInner = _styledComponents["default"].div.withConfig({
  displayName: "StyledCircleInner"
})(["position:absolute;z-index:3;box-sizing:content-box;", " ", ""], cursorCss, function (props) {
  var token = props.theme.components.Slider;
  var borderColor = token.circleBorderColor;
  var hoverCss;
  var activeCss = (0, _styledComponents.css)(["width:", "px;height:", "px;box-shadow:", ";&::before{border-color:", ";}"], token.circleActiveSize, token.circleActiveSize, token.circleActiveBoxShadow, token.circleBorderHoverColor);

  if (!props.$disabled && !props.$moving) {
    hoverCss = (0, _styledComponents.css)(["&:hover{cursor:grab;", "}"], activeCss);
  } else if (!props.$disabled && props.$moving) {
    hoverCss = (0, _styledComponents.css)(["cursor:grabbing;padding:", "px;background-color:", ";", ""], token.circleActiveBorderSize, token.circleActiveBorderColor, activeCss);
  }

  var directionCss;

  if (props.$vertical) {
    directionCss = (0, _styledComponents.css)(["left:50%;transform:translate(-50%,-50%);"]);
  } else {
    directionCss = (0, _styledComponents.css)(["transform:translate(-50%,-50%);top:50%;"]);
  }

  return (0, _styledComponents.css)(["width:", "px;height:", "px;border-radius:50%;box-shadow:", ";&::before{content:'';height:100%;width:100%;display:block;box-sizing:border-box;border-radius:50%;background-color:", ";border:", "px solid ", ";}", " ", ""], token.circleSize, token.circleSize, token.circleBoxShadow, token.circleColor, token.circleBorderWidth, borderColor, hoverCss, directionCss);
});

var StyledCircle = /*#__PURE__*/_react["default"].memo(StyledCircleInner); // 基础轨道


exports.StyledCircle = StyledCircle;

var StyledBaseRootTrackInner = _styledComponents["default"].div.withConfig({
  displayName: "StyledBaseRootTrackInner"
})(["position:relative;box-sizing:border-box;user-select:none;", " ", ""], cursorCss, function (props) {
  var _props$theme4 = props.theme,
      token = _props$theme4.components.Slider,
      borderRadius = _props$theme4.size.spec.borderRadius;
  var directionCss;

  if (props.$vertical) {
    directionCss = (0, _styledComponents.css)(["width:", "px;height:100%;"], token.trackHeight);
  } else {
    directionCss = (0, _styledComponents.css)(["width:100%;height:", "px;"], token.trackHeight);
  }

  return (0, _styledComponents.css)(["background-color:", ";border-radius:", ";", ""], token.trackBgColor, borderRadius.s5, directionCss);
});

var StyledBaseRootTrack = /*#__PURE__*/_react["default"].memo(StyledBaseRootTrackInner);

exports.StyledBaseRootTrack = StyledBaseRootTrack;