"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _mergeStyleItem = _interopRequireDefault(require("../utils/mergeStyleItem"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _excluded = ["direction", "spacing", "block", "styles", "children", "style", "className"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledWrapper"
})(["", ""], function (props) {
  var $direction = props.$direction,
      $block = props.$block;
  var directionStyle = $direction === 'horizontal' ? (0, _styledComponents.css)(["align-items:center;"]) : (0, _styledComponents.css)(["flex-direction:column;"]);
  var displayStyle = $block ? (0, _styledComponents.css)(["display:flex;"]) : (0, _styledComponents.css)(["display:inline-flex;"]);
  return (0, _styledComponents.css)(["", " ", ""], displayStyle, directionStyle);
});

var StyledItem = _styledComponents["default"].div.withConfig({
  displayName: "StyledItem"
})(["", ""], function (props) {
  var $direction = props.$direction,
      $spacing = props.$spacing;
  if (!$spacing) return;
  var marginStyle = $direction === 'horizontal' ? (0, _styledComponents.css)(["margin-right:", "px;"], $spacing) : (0, _styledComponents.css)(["margin-bottom:", "px;"], $spacing);
  return (0, _styledComponents.css)(["", ""], marginStyle);
});

var defaultStyles = {
  wrapper: '',
  item: ''
};

var _default = /*#__PURE__*/_react["default"].memo( /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var _props$direction = props.direction,
      direction = _props$direction === void 0 ? 'horizontal' : _props$direction,
      _props$spacing = props.spacing,
      spacing = _props$spacing === void 0 ? 's4' : _props$spacing,
      _props$block = props.block,
      block = _props$block === void 0 ? false : _props$block,
      styles = props.styles,
      children = props.children,
      style = props.style,
      className = props.className,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var innerStyles = (0, _useStyles["default"])('space', defaultStyles, styles);
  var wrapperStyleItem = (0, _mergeStyleItem["default"])({
    style: style,
    className: className
  }, innerStyles.wrapper);

  var isValidNode = function isValidNode(node) {
    return node !== null && node !== undefined && typeof node !== 'boolean';
  };

  var validChildren = _react["default"].Children.toArray(children).filter(function (child) {
    return isValidNode(child);
  });

  var count = validChildren.length;
  var items = (0, _react.useMemo)(function () {
    return _react.Children.map(validChildren, function (child, index) {
      var spacingNumber = typeof spacing === 'number' ? spacing : theme.spacing.spec[spacing];
      return /*#__PURE__*/_react["default"].createElement(StyledItem, (0, _extends2["default"])({
        $direction: direction,
        $spacing: index === count - 1 ? undefined : spacingNumber
      }, innerStyles.item), child);
    });
  }, [count, direction, innerStyles.item, spacing, theme.spacing.spec, validChildren]);

  if (count === 0) {
    return null;
  }

  return /*#__PURE__*/_react["default"].createElement(StyledWrapper, (0, _extends2["default"])({
    ref: ref,
    $direction: direction,
    $block: block
  }, wrapperStyleItem, other), items);
}));

exports["default"] = _default;