"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _utils = require("@muya-ui/theme-light/lib/utils");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useForkRef = require("@muya-ui/utils/lib/hooks/useForkRef");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _InlineButton = _interopRequireDefault(require("../InlineButton"));

var _Dialog = _interopRequireDefault(require("../Dialog"));

var _utils2 = require("../Portal/utils");

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _SpinIcon = _interopRequireDefault(require("./SpinIcon"));

var _styled = require("./styled");

var _excluded = ["fullscreen", "spinning", "container", "dialogProps", "size", "desc", "cancelText", "onCancel", "direction", "children", "color", "fontSize", "styles"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _default = (0, _memoForwardRef["default"])(function (props, ref) {
  var fullscreen = props.fullscreen,
      _props$spinning = props.spinning,
      spinning = _props$spinning === void 0 ? true : _props$spinning,
      container = props.container,
      _props$dialogProps = props.dialogProps,
      dialogProps = _props$dialogProps === void 0 ? {} : _props$dialogProps,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      desc = props.desc,
      cancelText = props.cancelText,
      onCancel = props.onCancel,
      _props$direction = props.direction,
      direction = _props$direction === void 0 ? 'column' : _props$direction,
      children = props.children,
      color = props.color,
      fontSize = props.fontSize,
      styles = props.styles,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var innerStyles = (0, _useStyles["default"])('spin', {
    desc: '',
    button: ''
  }, styles);
  var colors = theme.colors,
      token = theme.components.Spin;
  var mainColor = color || colors.spec.brand;

  var _useState = (0, _react.useState)(null),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      innerContainer = _useState2[0],
      setInnerContainer = _useState2[1];

  var handleRef = function handleRef(node) {
    (0, _useForkRef.setRef)(children.ref, node);
    setInnerContainer(node);
  };

  var content = /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, desc && /*#__PURE__*/_react["default"].createElement(_styled.StyledDescWrapper, (0, _extends2["default"])({}, innerStyles.desc, {
    size: size,
    theme: theme,
    cancelText: cancelText
  }), desc), cancelText && /*#__PURE__*/_react["default"].createElement(_InlineButton["default"], (0, _extends2["default"])({}, innerStyles.button, {
    size: size,
    type: "primary",
    onClick: onCancel
  }), cancelText));

  var Icon = /*#__PURE__*/_react["default"].createElement(_styled.StyledSpinContent, {
    theme: theme,
    direction: direction
  }, /*#__PURE__*/_react["default"].createElement(_styled.StyledIconWrapper, {
    size: !desc && !cancelText ? undefined : size,
    theme: theme
  }, /*#__PURE__*/_react["default"].createElement(_SpinIcon["default"], (0, _extends2["default"])({
    ref: ref,
    fontSize: fontSize,
    color: mainColor
  }, other))), direction === 'column' ? /*#__PURE__*/_react["default"].createElement("span", null, content) : content); // 传入container or children，开启区域加载功能


  var isBlockLoading = !!children || !!container; // fullscreen为true，开启全屏加载功能

  var isFullscreenLoading = fullscreen;
  (0, _react.useEffect)(function () {
    var finalContainer = container ? (0, _utils2.getPortalContainer)(container) : innerContainer; // 全屏模式不会使用finalContainer，因此无需设置样式

    if (!isFullscreenLoading && finalContainer) {
      var _window$getComputedSt = window.getComputedStyle(finalContainer),
          position = _window$getComputedSt.position; // position未设置 或者 position为static，组件为其设置默认的position，使区域加载生效


      if (!position || position === 'static') {
        finalContainer.style.position = 'relative';
      }
    }
  }, [container, innerContainer, isFullscreenLoading]); // 区域加载 / 全屏加载，使用Dialog.Base

  if (isFullscreenLoading || isBlockLoading) {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, children && /*#__PURE__*/(0, _react.cloneElement)(children, {
      ref: handleRef
    }), /*#__PURE__*/_react["default"].createElement(_Dialog["default"].Base, (0, _extends2["default"])({
      open: spinning,
      container: isFullscreenLoading ? undefined : container || innerContainer,
      disableEscapeKeyDown: true,
      disableMaskClick: true,
      disableSize: true
    }, dialogProps, {
      style: (0, _extends2["default"])({
        background: _utils.colorUtils.transparentize(token.maskOpacity, colors.pattern.background.higher)
      }, dialogProps.style),
      dialogContainerProps: (0, _extends2["default"])({
        style: {
          background: 'transparent',
          boxShadow: 'none',
          top: '50%'
        }
      }, dialogProps.dialogContainerProps)
    }), Icon));
  }

  if (!spinning) {
    return null;
  }

  return Icon;
});

exports["default"] = _default;