"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledSpinContent = exports.StyledIconWrapper = exports.StyledDescWrapper = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _InlineButton = _interopRequireDefault(require("../InlineButton"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledSpinContent = _styledComponents["default"].span.withConfig({
  displayName: "StyledSpinContent"
})(["display:inline-flex;flex-flow:", " nowrap;align-items:center;", "{vertical-align:unset;}"], function (props) {
  return props.direction || 'row';
}, _InlineButton["default"]);

exports.StyledSpinContent = StyledSpinContent;

var StyledIconWrapper = _styledComponents["default"].span.withConfig({
  displayName: "StyledIconWrapper"
})(["", ""], function (props) {
  var size = props.size,
      theme = props.theme;
  var token = theme.components.Spin.icon;

  if (size) {
    return (0, _styledComponents.css)(["font-size:", "px;padding:", ";"], token.fontSize[size], token.padding[size]);
  }
});

exports.StyledIconWrapper = StyledIconWrapper;

var StyledDescWrapper = _styledComponents["default"].span.withConfig({
  displayName: "StyledDescWrapper"
})(["", " ", ""], function (props) {
  var size = props.size,
      theme = props.theme;
  var token = theme.components.Spin.desc;

  if (size) {
    return (0, _styledComponents.css)(["color:", ";font-size:", "px;padding-right:", "px;"], theme.colors.pattern.text.text, token.fontSize[size], token.paddingRight[size]);
  }
}, function (props) {
  if (!props.cancelText) {
    return (0, _styledComponents.css)(["padding-right:0;"]);
  }
});

exports.StyledDescWrapper = StyledDescWrapper;