"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _Swipe = require("../Swipe");

var _styled = require("./styled");

var _excluded = ["theme", "children"];
var ScrollContainer = (0, _memoForwardRef["default"])(function (props, ref) {
  var theme = props.theme,
      children = props.children,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);

  var _useSwipe = (0, _Swipe.useSwipe)(),
      stepIndex = _useSwipe.stepIndex,
      hasNext = _useSwipe.hasNext,
      hasPrev = _useSwipe.hasPrev,
      onNext = _useSwipe.onNext,
      onPrev = _useSwipe.onPrev,
      onStepsChange = _useSwipe.onStepsChange,
      transitionStatus = _useSwipe.transitionStatus;

  return /*#__PURE__*/_react["default"].createElement(_styled.StyledScrollStepsWarpper, (0, _extends2["default"])({
    theme: theme,
    ref: ref
  }, otherProps), /*#__PURE__*/_react["default"].createElement(_styled.StyledScrollStepsBtn, {
    arrow: "left",
    onClick: onPrev,
    disabled: !hasPrev
  }), /*#__PURE__*/_react["default"].createElement(_Swipe.Swipe, {
    stepIndex: stepIndex,
    itemIndex: -1,
    onStepsChange: onStepsChange,
    transitionStatus: transitionStatus
  }, props.children), /*#__PURE__*/_react["default"].createElement(_styled.StyledScrollStepsBtn, {
    arrow: "right",
    onClick: onNext,
    disabled: !hasNext
  }));
});
var _default = ScrollContainer;
exports["default"] = _default;