"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _CloseIcon2 = require("@muya-ui/theme-light/lib/icons/CloseIcon");

var _SelectIcon2 = require("@muya-ui/theme-light/lib/icons/SelectIcon");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _EllipsisContent = _interopRequireDefault(require("../EllipsisContent"));

var _Typography = _interopRequireDefault(require("../Typography"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _excluded = ["onStepClick", "stepNumber", "status", "title", "description", "styles", "size", "icon"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  content: '',
  circle: '',
  title: '',
  progressLine: '',
  descriptionWrapper: '',
  text: ''
};
var ellipsisCfg = {
  rows: 2
};

var _default = (0, _memoForwardRef["default"])(function (props, ref) {
  var onStepClick = props.onStepClick,
      _props$stepNumber = props.stepNumber,
      stepNumber = _props$stepNumber === void 0 ? 0 : _props$stepNumber,
      status = props.status,
      title = props.title,
      description = props.description,
      styles = props.styles,
      size = props.size,
      icon = props.icon,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var _theme$components$Ste = theme.components.Steps,
      _theme$components$Ste2 = _theme$components$Ste.finishIcon,
      FinishIcon = _theme$components$Ste2 === void 0 ? _SelectIcon2.SelectIcon : _theme$components$Ste2,
      _theme$components$Ste3 = _theme$components$Ste.errorIcon,
      ErrorIcon = _theme$components$Ste3 === void 0 ? _CloseIcon2.CloseIcon : _theme$components$Ste3;
  var innerStyles = (0, _useStyles["default"])('step', defaultStyles, styles);
  var innerIcon;

  if (status === 'finish') {
    innerIcon = /*#__PURE__*/_react["default"].createElement(FinishIcon, null);
  } else if (status === 'error') {
    innerIcon = /*#__PURE__*/_react["default"].createElement(ErrorIcon, null);
  } else {
    innerIcon = stepNumber + 1;
  }

  if (icon) {
    innerIcon = icon;
  }

  var handleClick = (0, _react.useMemo)(function () {
    return onStepClick ? function () {
      onStepClick(stepNumber);
    } : undefined;
  }, [onStepClick, stepNumber]);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledStepWrapper, (0, _extends2["default"])({
    ref: ref,
    theme: theme
  }, other), /*#__PURE__*/_react["default"].createElement(_styled.StyledVerticalProgressLineContainer, {
    theme: theme,
    size: size
  }, /*#__PURE__*/_react["default"].createElement(_styled.StyledVerticalProgressLine, (0, _extends2["default"])({}, innerStyles.progressLine, {
    theme: theme,
    status: status,
    size: size
  }))), /*#__PURE__*/_react["default"].createElement(_styled.StyledStepContent, (0, _extends2["default"])({}, innerStyles.content, {
    onClick: handleClick,
    theme: theme,
    status: status,
    size: size
  }), /*#__PURE__*/_react["default"].createElement(_styled.StyledCircleContainer, null, /*#__PURE__*/_react["default"].createElement(_styled.StyledCircle, (0, _extends2["default"])({}, innerStyles.circle, {
    theme: theme,
    size: size,
    $bordered: !icon
  }), innerIcon)), /*#__PURE__*/_react["default"].createElement(_styled.StyledTitleContainer, innerStyles.title, /*#__PURE__*/_react["default"].createElement(_EllipsisContent["default"], {
    ellipsis: ellipsisCfg,
    enableTitle: true
  }, title)), /*#__PURE__*/_react["default"].createElement(_styled.StyledHorizontalProgressLineContainer, null, /*#__PURE__*/_react["default"].createElement(_styled.StyledHorizontalProgressLine, (0, _extends2["default"])({}, innerStyles.progressLine, {
    theme: theme,
    status: status
  })))), /*#__PURE__*/_react["default"].createElement(_styled.StyledDescriptionWrapper, (0, _extends2["default"])({}, innerStyles.descriptionWrapper, {
    theme: theme,
    size: size
  }), /*#__PURE__*/_react["default"].createElement(_Typography["default"].Text, (0, _extends2["default"])({
    type: status === 'error' ? 'error' : undefined
  }, innerStyles.text, {
    color: "assistant"
  }), description)));
});

exports["default"] = _default;