"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _Step = _interopRequireDefault(require("./Step"));

var _styled = require("./styled");

var _ScrollContainer = _interopRequireDefault(require("./ScrollContainer"));

var _excluded = ["onChange", "current", "children", "status", "size", "swipe", "direction"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Steps = (0, _memoForwardRef["default"])(function (props, ref) {
  var onChange = props.onChange,
      _props$current = props.current,
      current = _props$current === void 0 ? 0 : _props$current,
      children = props.children,
      currentStatus = props.status,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      _props$swipe = props.swipe,
      swipe = _props$swipe === void 0 ? false : _props$swipe,
      _props$direction = props.direction,
      direction = _props$direction === void 0 ? 'horizontal' : _props$direction,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var Container = direction === 'horizontal' && swipe ? _ScrollContainer["default"] : _styled.StyledStepsWrapper;
  var onStepClick = (0, _react.useCallback)(function (next) {
    if (onChange && current !== next) {
      onChange(next);
    }
  }, [current, onChange]);
  return /*#__PURE__*/_react["default"].createElement(Container, (0, _extends2["default"])({
    direction: direction,
    size: size,
    theme: theme,
    ref: ref
  }, other), _react.Children.map(children, function (child, index) {
    // 默认等待中
    var status = 'wait';

    if (index === current) {
      // 进行中
      status = currentStatus || 'process';
    }

    if (index < current) {
      // 已完成
      status = 'finish';
    }

    var childProps = (0, _extends2["default"])({
      status: status,
      stepNumber: index
    }, child.props, {
      size: size,
      onStepClick: onChange && onStepClick
    });
    return /*#__PURE__*/(0, _react.cloneElement)(child, childProps);
  }));
});
Steps.Step = _Step["default"];
var _default = Steps;
exports["default"] = _default;