"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledVerticalProgressLineContainer = exports.StyledVerticalProgressLine = exports.StyledTitleContainer = exports.StyledStepsWrapper = exports.StyledStepWrapper = exports.StyledStepContent = exports.StyledScrollStepsWarpper = exports.StyledScrollStepsBtn = exports.StyledHorizontalProgressLineContainer = exports.StyledHorizontalProgressLine = exports.StyledDescriptionWrapper = exports.StyledCircleContainer = exports.StyledCircle = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _PagerButton = _interopRequireDefault(require("../Carousel/PagerButton"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledCircleContainer = _styledComponents["default"].div.withConfig({
  displayName: "StyledCircleContainer"
})([""]);

exports.StyledCircleContainer = StyledCircleContainer;

var StyledTitleContainer = _styledComponents["default"].div.withConfig({
  displayName: "StyledTitleContainer"
})([""]);

exports.StyledTitleContainer = StyledTitleContainer;

var StyledHorizontalProgressLineContainer = _styledComponents["default"].div.withConfig({
  displayName: "StyledHorizontalProgressLineContainer"
})([""]);

exports.StyledHorizontalProgressLineContainer = StyledHorizontalProgressLineContainer;

var StyledVerticalProgressLineContainer = _styledComponents["default"].div.withConfig({
  displayName: "StyledVerticalProgressLineContainer"
})(["width:1px;height:100%;transform:translateX(-50%);position:absolute;box-sizing:border-box;", ";"], function (props) {
  var theme = props.theme,
      size = props.size;
  var token = theme.components.Steps.progressLine.vertical;
  return (0, _styledComponents.css)(["left:", "px;padding:", "px 0 0 0;"], token.left[size], token.top[size]);
});

exports.StyledVerticalProgressLineContainer = StyledVerticalProgressLineContainer;

function makeStepContentStyle(props) {
  var status = props.status,
      onClick = props.onClick,
      theme = props.theme,
      size = props.size;
  var _theme$components$Ste = theme.components.Steps.content,
      color = _theme$components$Ste.color,
      background = _theme$components$Ste.background,
      fontSize = _theme$components$Ste.fontSize,
      lineHeight = _theme$components$Ste.lineHeight,
      fontWeight = _theme$components$Ste.fontWeight;
  var _theme$components$Ste2 = theme.components.Steps.circle,
      tokenSize = _theme$components$Ste2.size,
      marginRight = _theme$components$Ste2.marginRight;
  var titleToken = theme.components.Steps.title;
  var lineToken = theme.components.Steps.progressLine;
  var titleColor = titleToken.color[status];
  var finalColor = color[status];
  var finalBgColor = background[status];
  var hasBg = finalBgColor !== 'transparent' && finalBgColor !== theme.colors.spec.light;
  var colorStyle = status !== 'wait' && (0, _styledComponents.css)(["color:", ";& ", "{border-color:", ";background:", ";}& ", "{color:", ";}"], finalColor, StyledCircle, hasBg ? finalBgColor : finalColor, finalBgColor, StyledTitleContainer, titleColor);
  /**
   * 可点击状态
   * 1. 传入了onChange事件
   * 2. 当前不处于process状态
   * 3. 当前不处于error状态
   */

  var canClick = onClick && status !== 'process' && status !== 'error';
  var canClickStyle = canClick && (0, _styledComponents.css)(["&:hover{color:", ";", "{border-color:", ";background:", ";}", "{color:", ";}}&:active{color:", ";", "{border-color:", ";background:", ";}", "{color:", ";}}cursor:pointer;"], color.hover, StyledCircle, hasBg ? background.hover : color.hover, background.hover, StyledTitleContainer, titleToken.color.hover, color.clicked, StyledCircle, hasBg ? background.clicked : color.clicked, background.clicked, StyledTitleContainer, titleToken.color.clicked); // 为解决 title 字数过多导致样式变形添加的样式

  /* stylelint-disable selector-type-case, selector-type-no-unknown */

  var balanceStyle = (0, _styledComponents.css)(["", ",", ",", "{min-height:", "px;display:flex;align-items:center;}", "{flex:1;}", "{max-width:calc( 100% - ", "px - ", "px - ", "px );}"], StyledCircleContainer, StyledTitleContainer, StyledHorizontalProgressLineContainer, tokenSize[size], StyledHorizontalProgressLineContainer, StyledTitleContainer, tokenSize[size], lineToken.minWidth, marginRight[size]);
  /* stylelint-enable */

  return (0, _styledComponents.css)(["display:flex;align-items:flex-start;position:relative;color:", ";font-size:", "px;line-height:", "px;font-weight:", ";cursor:default;", "{padding-right:", "px;}", " ", " ", " & > *{", "}"], color.wait, fontSize[size], lineHeight[size], fontWeight, StyledTitleContainer, titleToken.marginRight[size], colorStyle, canClickStyle, balanceStyle, function (props) {
    var transition = props.theme.transition;
    return (0, _styledComponents.css)(["transition:all ", " ", "ms;"], transition.pattern.easing.status, transition.pattern.duration.status);
  });
}

var StyledHorizontalProgressLine = _styledComponents["default"].div.withConfig({
  displayName: "StyledHorizontalProgressLine"
})(["flex:1;height:1px;transform:translateY(-50%);background-color:", ";"], function (props) {
  var status = props.status,
      theme = props.theme;
  var token = theme.components.Steps.progressLine;
  return status === 'finish' ? token.finishBgColor : token.bgColor;
});

exports.StyledHorizontalProgressLine = StyledHorizontalProgressLine;

var StyledVerticalProgressLine = _styledComponents["default"].div.withConfig({
  displayName: "StyledVerticalProgressLine"
})(["width:100%;height:100%;background-color:", ";"], function (props) {
  var status = props.status,
      theme = props.theme;
  var token = theme.components.Steps.progressLine;
  return status === 'finish' ? token.finishBgColor : token.bgColor;
});

exports.StyledVerticalProgressLine = StyledVerticalProgressLine;

var StyledStepWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledStepWrapper"
})(["overflow:hidden;flex:1;margin-right:", "px;&:last-child{flex:none;", "{max-width:none;}", "{display:none;}", "{display:none;}}"], function (props) {
  return props.theme.spacing.spec.s4;
}, StyledTitleContainer, StyledHorizontalProgressLineContainer, StyledVerticalProgressLineContainer);

exports.StyledStepWrapper = StyledStepWrapper;

var StyledCircle = _styledComponents["default"].span.withConfig({
  displayName: "StyledCircle"
})(["display:flex;justify-content:center;align-items:center;box-sizing:border-box;border-radius:50%;user-select:none;", ""], function (props) {
  var theme = props.theme,
      size = props.size,
      _props$$bordered = props.$bordered,
      $bordered = _props$$bordered === void 0 ? true : _props$$bordered;
  var borderStyle = $bordered && (0, _styledComponents.css)(["border:1px solid ", ";"], theme.colors.pattern.background.divider);
  var token = theme.components.Steps.circle;
  return (0, _styledComponents.css)(["margin-right:", "px;width:", "px;height:", "px;", ""], token.marginRight[size], token.size[size], token.size[size], borderStyle);
});

exports.StyledCircle = StyledCircle;

var StyledStepContent = _styledComponents["default"].div.withConfig({
  displayName: "StyledStepContent"
})(["", ""], makeStepContentStyle);

exports.StyledStepContent = StyledStepContent;

var StyledDescriptionWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledDescriptionWrapper"
})(["", ""], function (props) {
  var token = props.theme.components.Steps.description;
  var size = props.size;
  return (0, _styledComponents.css)(["margin-left:", "px;padding-left:", "px;margin-top:", "px;overflow:hidden;word-break:break-all;"], token.marginLeft[size], token.paddingLeft[size], token.marginTop[size]);
});

exports.StyledDescriptionWrapper = StyledDescriptionWrapper;

var StyledStepsWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledStepsWrapper"
})(["display:flex;width:100%;margin:0;padding:0;font-size:0;", ""], function (_ref) {
  var direction = _ref.direction,
      theme = _ref.theme;
  var token = theme.components.Steps;

  if (direction === 'vertical') {
    return (0, _styledComponents.css)(["flex-direction:column;", "{display:block;position:relative;padding-bottom:", "px;margin-bottom:", "px;}", "{display:none;}"], StyledStepWrapper, token.content.verticalPaddingBottom, token.content.verticalMarginBottom, StyledHorizontalProgressLineContainer);
  } else {
    return (0, _styledComponents.css)(["", "{display:none;}", "{max-width:", "px;}"], StyledVerticalProgressLineContainer, StyledDescriptionWrapper, token.description.maxWidth);
  }
});

exports.StyledStepsWrapper = StyledStepsWrapper;

var StyledScrollStepsWarpper = _styledComponents["default"].div.withConfig({
  displayName: "StyledScrollStepsWarpper"
})(["display:flex;", "{width:", ";display:block;flex:none;}", "{display:none;}"], StyledStepWrapper, function (_ref2) {
  var size = _ref2.size,
      theme = _ref2.theme;
  return theme.components.Steps.content.width[size];
}, StyledVerticalProgressLineContainer);

exports.StyledScrollStepsWarpper = StyledScrollStepsWarpper;
var StyledScrollStepsBtn = (0, _styledComponents["default"])(_PagerButton["default"]).withConfig({
  displayName: "StyledScrollStepsBtn"
})(["", ""], function (_ref3) {
  var theme = _ref3.theme,
      disabled = _ref3.disabled,
      arrow = _ref3.arrow;
  var token = theme.components.Steps;
  var btnToken = token.btn;
  var disabledStyle;
  var positionStyle;

  if (arrow === 'left') {
    positionStyle = (0, _styledComponents.css)(["left:0;margin-right:", "px;"], token.content.btnSpacing);
  } else {
    positionStyle = (0, _styledComponents.css)(["right:0;margin-left:", "px;"], token.content.btnSpacing);
  }

  if (disabled) {
    disabledStyle = (0, _styledComponents.css)(["opacity:theme.opacity.pattern.disabled;"]);
  } else {
    disabledStyle = (0, _styledComponents.css)(["&:hover{border:1px solid ", ";box-shadow:", ";}"], btnToken.borderColor.hover, btnToken.boxShadow.hover);
  }

  return (0, _styledComponents.css)(["width:", ";height:", ";z-index:2;background:", ";border:1px solid ", ";box-shadow:", ";border-radius:", ";color:", ";transition:all ", " ", "ms;", ";", ";"], btnToken.width, btnToken.height, btnToken.background, btnToken.borderColor.normal, btnToken.boxShadow.normal, btnToken.radius, btnToken.color, theme.transition.pattern.easing.status, theme.transition.pattern.duration.status, disabledStyle, positionStyle);
});
exports.StyledScrollStepsBtn = StyledScrollStepsBtn;