"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _styled = require("./styled");

var _useSticky2 = _interopRequireDefault(require("./useSticky"));

var _excluded = ["children", "styles", "target", "onStatusChange"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  sticky: ''
};

var _default = (0, _memoForwardRef["default"])(function (props, ref) {
  var children = props.children,
      styles = props.styles,
      target = props.target,
      onStatusChange = props.onStatusChange,
      others = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var innerStyles = (0, _useStyles["default"])('sticky', defaultStyles, styles);
  var divEl = (0, _react.useRef)(null);
  var handleRef = (0, _useForkRef2.useForkRef)(ref, divEl);

  var _useSticky = (0, _useSticky2["default"])(props, divEl),
      style = _useSticky.style,
      fixed = _useSticky.fixed;

  var height = divEl.current && divEl.current.offsetHeight || 0;
  var innerStyle = fixed ? style : {};
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledContainer, (0, _extends2["default"])({
    $height: fixed ? height : null,
    ref: handleRef
  }, others), /*#__PURE__*/_react["default"].createElement(_styled.StyledSticky, (0, _extends2["default"])({
    $fixed: fixed
  }, innerStyles.sticky, {
    style: (0, _extends2["default"])({}, innerStyles.sticky.style, innerStyle)
  }), children));
});

exports["default"] = _default;