"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _SwipeContainer = _interopRequireDefault(require("./SwipeContainer"));

var _SwipePanel = _interopRequireDefault(require("./SwipePanel"));

var _useInnerLoopSwipe2 = _interopRequireDefault(require("./useInnerLoopSwipe"));

var _useLoopSwipe = _interopRequireDefault(require("./useLoopSwipe"));

var _excluded = ["direction", "stepIndex", "itemIndex", "equalNum", "gutter", "duration", "onStepsChange", "children", "styles", "defaultIndex", "enableDiffChildren", "onTransitionEnd", "transitionStatus"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  panel: ''
};
var Swipe = (0, _memoForwardRef["default"])(function (props, ref) {
  var _props$direction = props.direction,
      direction = _props$direction === void 0 ? 'horizontal' : _props$direction,
      stepIndex = props.stepIndex,
      itemIndex = props.itemIndex,
      equalNum = props.equalNum,
      gutter = props.gutter,
      duration = props.duration,
      onStepsChange = props.onStepsChange,
      children = props.children,
      styles = props.styles,
      defaultIndex = props.defaultIndex,
      enableDiffChildren = props.enableDiffChildren,
      onTransitionEnd = props.onTransitionEnd,
      propsTransitionStatus = props.transitionStatus,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var innerStyles = (0, _useStyles["default"])('swipe', defaultStyles, styles);
  var containerRef = (0, _react.useRef)(null);
  var handleRef = (0, _useForkRef2.useForkRef)(containerRef, ref);

  var _useInnerLoopSwipe = (0, _useInnerLoopSwipe2["default"])(props, containerRef),
      resultChildren = _useInnerLoopSwipe.nodes,
      panelStyle = _useInnerLoopSwipe.panelStyle,
      transitionStatus = _useInnerLoopSwipe.transitionStatus,
      finalDuration = _useInnerLoopSwipe.finalDuration;

  var innerPanelStyle = (0, _react.useMemo)(function () {
    if (innerStyles.panel.style) {
      return (0, _extends2["default"])({}, innerStyles.panel.style, panelStyle);
    }

    return panelStyle;
  }, [innerStyles.panel.style, panelStyle]);
  return /*#__PURE__*/_react["default"].createElement(_SwipeContainer["default"], (0, _extends2["default"])({
    $direction: direction
  }, otherProps, {
    ref: handleRef
  }), /*#__PURE__*/_react["default"].createElement(_SwipePanel["default"], {
    className: innerStyles.panel.className,
    $duration: finalDuration,
    $transition: propsTransitionStatus || transitionStatus,
    style: innerPanelStyle,
    $direction: direction,
    onTransitionEnd: onTransitionEnd
  }, resultChildren));
});
Swipe.useLoopSwipe = _useLoopSwipe["default"];
var _default = Swipe;
exports["default"] = _default;