"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _ImgPoolContext = _interopRequireDefault(require("../Img/ImgPoolContext"));

var _forkHandler = _interopRequireDefault(require("../utils/forkHandler"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _excluded = ["onTransitionEnd"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var BaseNode = _styledComponents["default"].div.withConfig({
  displayName: "BaseNode"
})(["position:relative;", ""], function (props) {
  var theme = props.theme,
      $direction = props.$direction,
      _props$$transition = props.$transition,
      $transition = _props$$transition === void 0 ? 'on' : _props$$transition,
      propDuration = props.$duration;
  var easing = theme.transition.spec.easing;
  var panelCss;

  if ($direction === 'horizontal') {
    panelCss = (0, _styledComponents.css)(["display:flex;width:100000px;height:100%;"]);
  }

  var transitionCss;

  if ($transition === 'on') {
    transitionCss = (0, _styledComponents.css)(["transition:transform ", "ms ", ";"], propDuration, easing.easeInOut);
  }

  return (0, _styledComponents.css)(["", " ", ""], transitionCss, panelCss);
});

var _default = (0, _memoForwardRef["default"])(function (props, ref) {
  var onTransitionEnd = props.onTransitionEnd,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var pool = (0, _react.useContext)(_ImgPoolContext["default"]);
  var handleTransitionEnd = (0, _react.useMemo)(function () {
    return (0, _forkHandler["default"])(function () {
      pool.throttleCheck({
        type: 'scroll'
      });
    }, onTransitionEnd);
  }, [onTransitionEnd, pool]);
  return /*#__PURE__*/_react["default"].createElement(BaseNode, (0, _extends2["default"])({
    theme: theme
  }, otherProps, {
    onTransitionEnd: handleTransitionEnd,
    ref: ref
  }));
});

exports["default"] = _default;