"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useInnerSwipe;

var _useForceUpdate2 = require("@muya-ui/utils/lib/hooks/useForceUpdate");

var _react = require("react");

var _generateSwipeManager = _interopRequireWildcard(require("./generateSwipeManager"));

var _useBaseSwipe2 = _interopRequireDefault(require("./useBaseSwipe"));

var _utils = require("./utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function useInnerSwipe(props, containerRef) {
  var defaultIndex = props.defaultIndex,
      _props$itemIndex = props.itemIndex,
      itemIndex = _props$itemIndex === void 0 ? -1 : _props$itemIndex,
      _props$direction = props.direction,
      direction = _props$direction === void 0 ? 'horizontal' : _props$direction,
      _props$stepIndex = props.stepIndex,
      stepIndex = _props$stepIndex === void 0 ? -1 : _props$stepIndex,
      _props$offset = props.offset,
      offset = _props$offset === void 0 ? -1 : _props$offset,
      equalNum = props.equalNum,
      gutter = props.gutter,
      onStepsChange = props.onStepsChange,
      children = props.children,
      transitionStatus = props.transitionStatus,
      enableDiffChildren = props.enableDiffChildren;
  var swipeManager = (0, _react.useRef)();
  var isH = direction === 'horizontal';
  var forceUpdate = (0, _useForceUpdate2.useForceUpdate)();
  var isForceUpdate = (0, _react.useRef)(false);

  var endRectChange = function endRectChange() {
    if (swipeManager.current && onStepsChange) {
      onStepsChange(swipeManager.current);
    }

    isForceUpdate.current = true;
    forceUpdate();
  };

  var handleRectChange = function handleRectChange(itemRects, containerRect) {
    if (equalNum && equalNum >= itemRects.length || // 当单个超出容器是有问题的，这种情况暂不处理
    itemRects.length <= 1) {
      swipeManager.current = (0, _generateSwipeManager.generateDisabledSwipeManager)();
      endRectChange();
      return;
    }

    var panelSize = (0, _utils.calculateSize)(itemRects, isH);
    var containerSize = isH ? containerRect.width : containerRect.height;

    if (panelSize <= containerSize) {
      swipeManager.current = (0, _generateSwipeManager.generateDisabledSwipeManager)();
      endRectChange();
      return;
    }

    swipeManager.current = (0, _generateSwipeManager["default"])({
      items: itemRects,
      containerSize: containerSize,
      direction: direction,
      stepIndex: stepIndex,
      itemIndex: itemIndex,
      defaultIndex: defaultIndex
    });
    endRectChange();
  };

  var _useBaseSwipe = (0, _useBaseSwipe2["default"])({
    children: children,
    direction: direction,
    equalNum: equalNum,
    gutter: gutter,
    onRectChange: handleRectChange,
    containerRef: containerRef,
    enableDiffChildren: enableDiffChildren
  }),
      nodes = _useBaseSwipe.nodes,
      finalDuration = _useBaseSwipe.finalDuration;

  var finalOffset = 0;
  var innerTransitionStatus = transitionStatus || 'on';

  if (offset >= 0) {
    finalOffset = offset;
    innerTransitionStatus = transitionStatus || 'off';
  } else if (swipeManager.current && itemIndex >= 0) {
    finalOffset = swipeManager.current.getItemOffset(itemIndex);
  } else if (swipeManager.current && stepIndex >= 0) {
    finalOffset = swipeManager.current.getStepOffset(stepIndex);
  }

  if (isForceUpdate.current) {
    innerTransitionStatus = 'off';
  }

  var position = isH ? "".concat(-finalOffset, "px, 0") : "0, ".concat(-finalOffset, "px");
  var translateCSS = (0, _react.useMemo)(function () {
    return {
      transform: "translate(".concat(position, ")")
    };
  }, [position]);
  isForceUpdate.current = false;
  return {
    finalDuration: finalDuration,
    panelStyle: translateCSS,
    nodes: nodes,
    transitionStatus: innerTransitionStatus,
    // 只是为了测试而返回的一些操作
    handleRectChange: handleRectChange,
    finalOffset: finalOffset
  };
}