"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useLoopSwipe;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useEventCallback2 = require("@muya-ui/utils/lib/hooks/useEventCallback");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = require("react");

var _shallowEqual = require("shallow-equal");

function useLoopSwipe() {
  var _useState = (0, _react.useState)({
    itemIndex: 0,
    stepIndex: 0,
    stepSize: 0,
    itemSize: 0,
    loop: false,
    transitionStatus: 'off'
  }),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      state = _useState2[0],
      setState = _useState2[1];

  var swipeManager = (0, _react.useRef)();

  var updateState = function updateState() {
    var manager = swipeManager.current;
    var index = manager.index,
        size = manager.size,
        realItemIndex = manager.realItemIndex,
        itemSize = manager.itemSize,
        realItemSize = manager.realItemSize;
    setState({
      loop: itemSize > realItemSize,
      stepIndex: index,
      stepSize: size,
      itemIndex: realItemIndex,
      itemSize: realItemSize
    });
  };

  var firstStepsChange = (0, _react.useRef)(true);
  var onStepsChange = (0, _useEventCallback2.useEventCallback)(function (manager) {
    swipeManager.current = manager;
    var index = manager.index,
        size = manager.size,
        realItemIndex = manager.realItemIndex,
        itemSize = manager.itemSize,
        realItemSize = manager.realItemSize;
    var newState = {
      stepIndex: firstStepsChange.current ? index : state.stepIndex,
      stepSize: size,
      itemIndex: firstStepsChange.current ? realItemIndex : state.itemIndex,
      itemSize: realItemSize,
      loop: itemSize > realItemSize,
      transitionStatus: 'off'
    };
    firstStepsChange.current = false; // 步长发生了变化，极限情况处理一下

    if (newState.stepIndex !== undefined && newState.stepIndex >= manager.size) {
      newState.stepIndex = manager.size - 1;
    }

    if (!(0, _shallowEqual.shallowEqualObjects)(state, newState)) {
      setState(newState);
    }
  });
  var onPrev = (0, _useEventCallback2.useEventCallback)(function () {
    var manager = swipeManager.current;

    if (manager) {
      manager.prev();
      updateState();
    }
  });
  var onNext = (0, _useEventCallback2.useEventCallback)(function () {
    var manager = swipeManager.current;

    if (manager) {
      manager.next();
      updateState();
    }
  });
  var onGoTo = (0, _useEventCallback2.useEventCallback)(function (stepIndex) {
    var manager = swipeManager.current;

    if (manager && manager.hasStep(stepIndex)) {
      manager.goTo(stepIndex);
      updateState();
    }
  });
  var onItemPrev = (0, _useEventCallback2.useEventCallback)(function () {
    var manager = swipeManager.current;

    if (manager) {
      manager.prevItem();
      updateState();
    }
  });
  var onItemNext = (0, _useEventCallback2.useEventCallback)(function () {
    var manager = swipeManager.current;

    if (manager) {
      manager.nextItem();
      updateState();
    }
  });
  var onItemGoTo = (0, _useEventCallback2.useEventCallback)(function (itemIndex) {
    var manager = swipeManager.current;

    if (manager && manager.hasItem(itemIndex)) {
      manager.goToItem(itemIndex);
      updateState();
    }
  });
  return (0, _extends2["default"])({}, state, {
    manager: swipeManager.current,
    onStepsChange: onStepsChange,
    onNext: onNext,
    onPrev: onPrev,
    onGoTo: onGoTo,
    onItemNext: onItemNext,
    onItemPrev: onItemPrev,
    onItemGoTo: onItemGoTo
  });
}