"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useEffectOnce2 = require("@muya-ui/utils/lib/hooks/useEffectOnce");

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _Spin = _interopRequireDefault(require("../Spin"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _styled = require("./styled");

var _useSwitch2 = _interopRequireDefault(require("./useSwitch"));

var _excluded = ["autoFocus", "disabled", "checked", "defaultChecked", "checkedChildren", "unCheckedChildren", "loading", "loadingIcon", "onChange", "styles", "size", "tabIndex"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  loadingWrapper: '',
  childrenWrapper: ''
};
var Switch = (0, _memoForwardRef["default"])(function (props, ref) {
  var autoFocus = props.autoFocus,
      disabled = props.disabled,
      checked = props.checked,
      _props$defaultChecked = props.defaultChecked,
      defaultChecked = _props$defaultChecked === void 0 ? false : _props$defaultChecked,
      checkedChildren = props.checkedChildren,
      unCheckedChildren = props.unCheckedChildren,
      _props$loading = props.loading,
      loading = _props$loading === void 0 ? false : _props$loading,
      loadingIcon = props.loadingIcon,
      onChange = props.onChange,
      styles = props.styles,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      _props$tabIndex = props.tabIndex,
      tabIndex = _props$tabIndex === void 0 ? 0 : _props$tabIndex,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var token = theme.components.Switch;
  var innerStyles = (0, _useStyles["default"])('switch', defaultStyles, styles);
  var nodeRef = (0, _react.useRef)(null);
  var handleRef = (0, _useForkRef2.useForkRef)(ref, nodeRef);

  var _useSwitch = (0, _useSwitch2["default"])(props, nodeRef),
      checkedState = _useSwitch.checkedState,
      setCheckedState = _useSwitch.setCheckedState,
      onKeyDown = _useSwitch.onKeyDown,
      onClick = _useSwitch.onClick,
      onMouseUp = _useSwitch.onMouseUp,
      focus = _useSwitch.focus;

  (0, _useEffectOnce2.useEffectOnce)(function () {
    if (autoFocus && !disabled) {
      focus();
    }
  });

  if ('checked' in props && checkedState !== checked) {
    setCheckedState(checked);
  }

  var loadingNode = (0, _react.useMemo)(function () {
    return loadingIcon || /*#__PURE__*/_react["default"].createElement(_Spin["default"], {
      color: checkedState ? token.background.checked : token.background.unChecked
    });
  }, [checkedState, loadingIcon, token.background.checked, token.background.unChecked]);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledSwitch, (0, _extends2["default"])({}, restProps, {
    ref: handleRef,
    role: "switch",
    theme: theme,
    size: size,
    checked: checkedState,
    disabled: disabled || loading,
    "aria-checked": checked,
    onClick: onClick,
    onMouseUp: onMouseUp,
    onKeyDown: onKeyDown
  }), loading && /*#__PURE__*/_react["default"].createElement(_styled.StyledLoadingIconWrapper, innerStyles.loadingWrapper, loadingNode), /*#__PURE__*/_react["default"].createElement(_styled.StyledSwitchChildrenWrapper, innerStyles.childrenWrapper, checkedState ? checkedChildren : unCheckedChildren));
});
Switch.__MUYA_SWITCH = true;
var _default = Switch;
exports["default"] = _default;