"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.switchCss = exports.StyledSwitchChildrenWrapper = exports.StyledSwitch = exports.StyledLoadingIconWrapper = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledSwitchChildrenWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledSwitchChildrenWrapper"
})(["display:block;"]);

exports.StyledSwitchChildrenWrapper = StyledSwitchChildrenWrapper;

var StyledLoadingIconWrapper = _styledComponents["default"].span.withConfig({
  displayName: "StyledLoadingIconWrapper"
})(["z-index:1;font-size:12px;background:transparent;"]);

exports.StyledLoadingIconWrapper = StyledLoadingIconWrapper;

var switchCss = function switchCss(props) {
  var size = props.size,
      _props$theme = props.theme,
      colorsPattern = _props$theme.colors.pattern,
      opacityPattern = _props$theme.opacity.pattern,
      _props$theme$transiti = _props$theme.transition.pattern,
      duration = _props$theme$transiti.duration,
      easing = _props$theme$transiti.easing,
      token = _props$theme.components.Switch,
      checked = props.checked,
      disabled = props.disabled;
  var iconFontSize = token.height[size] - 12;
  return (0, _styledComponents.css)(["position:relative;display:inline-block;box-sizing:border-box;height:", "px;line-height:", "px;min-width:", "px;background-color:", ";border-radius:999rem;vertical-align:middle;border:2px solid transparent;opacity:", ";cursor:", ";user-select:none;transition:all ", "ms ", ";outline:none;width:fit-content;&:active{box-shadow:", ";}&::after,", "{position:absolute;top:0;left:0;width:", "px;height:", "px;background-color:", ";border-radius:50%;transition:all ", "ms ", ";content:' ';cursor:", ";", "}", "{text-align:center;font-size:", "px;", "}", "{margin-left:", "px;margin-right:", "px;color:", ";font-size:", "px;}"], token.height[size], token.height[size] - 4, token.minWidth[size], checked ? token.background.checked : token.background.unChecked, disabled ? opacityPattern.disabled : 1, disabled ? 'not-allowed' : 'pointer', duration.status, easing.status, token.activeBoxShadow, StyledLoadingIconWrapper, token.height[size] - 4, token.height[size] - 4, token.circleBackground, duration.status, easing.status, disabled ? 'not-allowed' : 'pointer', checked && (0, _styledComponents.css)(["left:100%;transform:translateX(-100%);"]), StyledLoadingIconWrapper, iconFontSize, iconFontSize < 12 && (0, _styledComponents.css)(["svg{vertical-align:unset;}"]), StyledSwitchChildrenWrapper, checked ? token.childrenMarginLeft.checked : token.childrenMarginLeft.unChecked, checked ? token.childrenMarginRight.checked : token.childrenMarginRight.unChecked, colorsPattern.icon.inverse, token.fontSize[size]);
};

exports.switchCss = switchCss;

var StyledSwitch = _styledComponents["default"].div.withConfig({
  displayName: "StyledSwitch"
})(["", ";"], switchCss);

exports.StyledSwitch = StyledSwitch;