"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useEventCallback2 = require("@muya-ui/utils/lib/hooks/useEventCallback");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _FilterIcon2 = require("@muya-ui/theme-light/lib/icons/FilterIcon");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireWildcard(require("react"));

var _Button = _interopRequireDefault(require("../Button"));

var _Checkbox = require("../Checkbox");

var _useLocale = _interopRequireDefault(require("../Locale/useLocale"));

var _PopoverCard = _interopRequireDefault(require("../PopoverCard"));

var _Radio = require("../Radio");

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _excluded = ["column", "activeColumnKey", "size", "filterColumnData", "onVisibleChange", "onClickAway", "onFilterColumnKeyChange", "onFilterColumnDataChange", "onFilterColumnListChange"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _default = /*#__PURE__*/_react["default"].memo( /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var column = props.column,
      activeColumnKey = props.activeColumnKey,
      _props$size = props.size,
      size = _props$size === void 0 ? 'l' : _props$size,
      filterColumnData = props.filterColumnData,
      onVisibleChange = props.onVisibleChange,
      onClickAway = props.onClickAway,
      onFilterColumnKeyChange = props.onFilterColumnKeyChange,
      onFilterColumnDataChange = props.onFilterColumnDataChange,
      onFilterColumnListChange = props.onFilterColumnListChange,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var locale = (0, _useLocale["default"])();
  var theme = (0, _useTheme["default"])();
  var token = theme.components.Table;
  var _token$filterIcon = token.filterIcon,
      FilterIconToken = _token$filterIcon === void 0 ? _FilterIcon2.FilterIcon : _token$filterIcon,
      filterData = token.filterData;
  var _column$filterMultipl = column.filterMultiple,
      filterMultiple = _column$filterMultipl === void 0 ? true : _column$filterMultipl,
      filters = column.filters,
      _column$filterIconHig = column.filterIconHighlight,
      filterIconHighlight = _column$filterIconHig === void 0 ? false : _column$filterIconHig,
      filterVisible = column.filterVisible,
      renderFilterActions = column.renderFilterActions,
      renderFilterContent = column.renderFilterContent,
      onFilterVisibleChange = column.onFilterVisibleChange,
      onFilterEntered = column.onFilterEntered,
      onFilterExited = column.onFilterExited,
      filterPopperProps = column.filterPopperProps;
  var hasSorter = !!column.sorter;
  var buttonSize = filterData[size].buttonSize;

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      open = _useState2[0],
      setOpen = _useState2[1];

  var isControlled = ('filterVisible' in column);
  var finalOpen = (0, _react.useMemo)(function () {
    if (column.key !== activeColumnKey) {
      return false;
    }

    if (isControlled) {
      return filterVisible;
    }

    return open;
  }, [activeColumnKey, column.key, filterVisible, isControlled, open]); // 只有当前列激活时，才同步

  var _useState3 = (0, _react.useState)(filterColumnData.selectedFilterValues),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      selectedFilterValues = _useState4[0],
      setSelectedFilterValues = _useState4[1];

  var handleVisibleChange = (0, _react.useCallback)(function (v) {
    setOpen(v);

    if (onVisibleChange) {
      onVisibleChange(v);
    }

    if (onFilterVisibleChange) {
      onFilterVisibleChange(v);
    }
  }, [onFilterVisibleChange, onVisibleChange]);
  var handleConfirm = (0, _useEventCallback2.useEventCallback)(function () {
    setOpen(false);
    onFilterColumnDataChange((0, _extends2["default"])({}, filterColumnData, {
      selectedFilterValues: selectedFilterValues
    }));
    onFilterVisibleChange && onFilterVisibleChange(false);
  }, [onFilterColumnDataChange, onFilterVisibleChange]);
  var handleReset = (0, _useEventCallback2.useEventCallback)(function () {
    setOpen(false);
    setSelectedFilterValues([]);
    onFilterColumnDataChange((0, _extends2["default"])({}, filterColumnData, {
      selectedFilterValues: []
    }));
    onFilterVisibleChange && onFilterVisibleChange(false);
  }, [onFilterColumnDataChange, onFilterVisibleChange]); // 点击其他区域关闭，相当于点击保存

  var handleClickAway = (0, _useEventCallback2.useEventCallback)(function (e) {
    if (finalOpen) {
      onFilterColumnDataChange((0, _extends2["default"])({}, filterColumnData, {
        selectedFilterValues: selectedFilterValues
      }));
    }

    onClickAway && onClickAway(e);
  }, [finalOpen, onClickAway, onFilterColumnDataChange]);
  var handleFilterChange = (0, _react.useCallback)(function (value) {
    if (Array.isArray(value)) {
      setSelectedFilterValues(value);
    } else {
      setSelectedFilterValues([value]);
    }
  }, []);
  var handleFilterColumnListChange = (0, _react.useCallback)(function (outerFilterColumnList) {
    if (!outerFilterColumnList) {
      onFilterColumnDataChange((0, _extends2["default"])({}, filterColumnData, {
        selectedFilterValues: selectedFilterValues
      }));
    } else {
      onFilterColumnListChange(outerFilterColumnList);
    }
  }, [filterColumnData, onFilterColumnDataChange, onFilterColumnListChange, selectedFilterValues]);
  var handleFilterIconClick = (0, _react.useCallback)(function (e) {
    e.stopPropagation();
    setSelectedFilterValues(filterColumnData.selectedFilterValues);
    onFilterColumnKeyChange(column);
  }, [column, filterColumnData.selectedFilterValues, onFilterColumnKeyChange]);
  var handleEntered = (0, _react.useCallback)(function () {
    if (onFilterEntered) {
      onFilterEntered();
    }
  }, [onFilterEntered]);
  var handleExited = (0, _react.useCallback)(function () {
    if (onFilterExited) {
      onFilterExited();
    }
  }, [onFilterExited]);
  var transitionProps = (0, _react.useMemo)(function () {
    return {
      onEntered: handleEntered,
      onExited: handleExited
    };
  }, [handleEntered, handleExited]);
  var highlightStyle = (0, _react.useMemo)(function () {
    if ((0, _get2["default"])(filterColumnData, 'selectedFilterValues', []).length || filterIconHighlight) {
      return {
        color: theme.colors.spec.brand
      };
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [filterColumnData.selectedFilterValues, filterIconHighlight, theme.colors.spec.brand]);
  var filterIcon = (0, _react.useMemo)(function () {
    if (hasSorter) {
      return /*#__PURE__*/_react["default"].createElement(_styled.StyledFilterWrapper, {
        onClick: handleFilterIconClick
      }, /*#__PURE__*/_react["default"].createElement(_styled.StyledFilter, {
        style: highlightStyle
      }, column.filterIcon || /*#__PURE__*/_react["default"].createElement(FilterIconToken, null)));
    }

    return /*#__PURE__*/_react["default"].createElement(_styled.StyledFilter, {
      style: highlightStyle,
      onClick: handleFilterIconClick
    }, column.filterIcon || /*#__PURE__*/_react["default"].createElement(FilterIconToken, null));
  }, [column.filterIcon, handleFilterIconClick, hasSorter, highlightStyle]);
  var filterActions = (0, _react.useMemo)(function () {
    if (renderFilterActions) {
      return renderFilterActions({
        confirm: handleConfirm,
        reset: handleReset,
        selectedFilterValues: selectedFilterValues,
        setSelectedFilterValues: setSelectedFilterValues,
        setFilterColumnKey: onFilterColumnKeyChange,
        syncFilterColumnsList: handleFilterColumnListChange
      });
    }

    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      size: buttonSize,
      plain: true,
      onClick: handleReset,
      key: "reset"
    }, locale['Table.filterResetText']), /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      size: buttonSize,
      onClick: handleConfirm,
      key: "confirm",
      type: "primary"
    }, locale['Table.filterConfirmText']));
  }, [renderFilterActions, buttonSize, handleReset, locale, handleConfirm, selectedFilterValues, onFilterColumnKeyChange, handleFilterColumnListChange]);
  var filterContent = (0, _react.useMemo)(function () {
    if (renderFilterContent) {
      return renderFilterContent({
        confirm: handleConfirm,
        reset: handleReset,
        selectedFilterValues: selectedFilterValues,
        setSelectedFilterValues: setSelectedFilterValues,
        setFilterColumnKey: onFilterColumnKeyChange,
        syncFilterColumnsList: handleFilterColumnListChange
      });
    }

    if (!filters) return null;
    if (!filters.length) return null;
    var options = filters.map(function (f) {
      return {
        value: f.value,
        label: f.text
      };
    });

    if (filterMultiple) {
      return /*#__PURE__*/_react["default"].createElement(_Checkbox.CheckboxGroup, {
        size: buttonSize,
        options: options,
        value: selectedFilterValues,
        onChange: handleFilterChange,
        renderCheckbox: function renderCheckbox(node, option) {
          return /*#__PURE__*/_react["default"].createElement(_styled.StyledFilterItem, {
            theme: theme,
            key: option.value
          }, node);
        }
      });
    }

    return /*#__PURE__*/_react["default"].createElement(_Radio.RadioGroup, {
      size: buttonSize,
      options: options,
      value: selectedFilterValues[0],
      onChange: handleFilterChange,
      renderRadio: function renderRadio(node, option) {
        return /*#__PURE__*/_react["default"].createElement(_styled.StyledFilterItem, {
          theme: theme,
          key: option.value
        }, node);
      }
    });
  }, [renderFilterContent, filters, filterMultiple, buttonSize, selectedFilterValues, handleFilterChange, handleConfirm, handleReset, onFilterColumnKeyChange, handleFilterColumnListChange, theme]);
  return /*#__PURE__*/_react["default"].createElement(_PopoverCard["default"], (0, _extends2["default"])({
    placement: "bottom",
    triggerAction: "click"
  }, other, {
    transitionProps: transitionProps,
    onVisibleChange: handleVisibleChange,
    onClickAway: handleClickAway,
    content: filterContent,
    actions: filterActions,
    open: finalOpen,
    ref: ref,
    popperProps: filterPopperProps
  }), filterIcon);
}));

exports["default"] = _default;