"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Table;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _FoldIcon2 = require("@muya-ui/theme-light/lib/icons/FoldIcon");

var _UnfoldIcon2 = require("@muya-ui/theme-light/lib/icons/UnfoldIcon");

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _find2 = _interopRequireDefault(require("lodash/find"));

var _react = _interopRequireWildcard(require("react"));

var _EllipsisContent = _interopRequireDefault(require("../EllipsisContent"));

var _useLocale = _interopRequireDefault(require("../Locale/useLocale"));

var _Result = _interopRequireDefault(require("../Result"));

var _Spin = _interopRequireDefault(require("../Spin"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _ColGroup = _interopRequireDefault(require("./ColGroup"));

var _FilterPopoverCard = _interopRequireDefault(require("./FilterPopoverCard"));

var _styled = require("./styled");

var _useTable2 = _interopRequireDefault(require("./useTable"));

var _utils = require("./utils");

var _excluded = ["position"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  spinWrapper: '',
  wrapper: '',
  paginationWrapper: ''
};

function Table(props) {
  var locale = (0, _useLocale["default"])();
  var theme = (0, _useTheme["default"])();
  var headerRef = (0, _react.useRef)(null);
  var onRow = props.onRow,
      onCell = props.onCell,
      onHeaderRow = props.onHeaderRow,
      onHeaderCell = props.onHeaderCell,
      _props$bordered = props.bordered,
      bordered = _props$bordered === void 0 ? false : _props$bordered,
      _props$stripe = props.stripe,
      stripe = _props$stripe === void 0 ? false : _props$stripe,
      _props$size = props.size,
      size = _props$size === void 0 ? 'l' : _props$size,
      emptyText = props.emptyText,
      _props$defaultSortDir = props.defaultSortDirections,
      defaultSortDirections = _props$defaultSortDir === void 0 ? ['ascend', 'descend'] : _props$defaultSortDir,
      _props$ellipsis = props.ellipsis,
      ellipsisProp = _props$ellipsis === void 0 ? false : _props$ellipsis,
      rowSelection = props.rowSelection,
      _props$components = props.components,
      components = _props$components === void 0 ? {} : _props$components,
      _props$expandable = props.expandable,
      expandable = _props$expandable === void 0 ? {} : _props$expandable,
      _props$scrollBarSize = props.scrollBarSize,
      scrollBarSize = _props$scrollBarSize === void 0 ? 'l' : _props$scrollBarSize,
      fixedHeader = props.fixedHeader,
      fixedFooter = props.fixedFooter,
      style = props.style,
      className = props.className,
      styles = props.styles,
      _props$emptyHeight = props.emptyHeight,
      emptyHeight = _props$emptyHeight === void 0 ? 'auto' : _props$emptyHeight,
      wrapRef = props.wrapRef,
      paginationProps = props.pagination,
      _props$renderMode = props.renderMode,
      renderMode = _props$renderMode === void 0 ? 'single' : _props$renderMode;
  var _expandable$style = expandable.style,
      expandableStyle = _expandable$style === void 0 ? {} : _expandable$style,
      expandedRowRender = expandable.expandedRowRender,
      _expandable$expandedR = expandable.expandedRowBackgroundColor,
      expandedRowBackgroundColor = _expandable$expandedR === void 0 ? theme.components.Table.trBackground.stripe : _expandable$expandedR,
      _expandable$indentSiz = expandable.indentSize,
      indentSize = _expandable$indentSiz === void 0 ? theme.components.Table.expandIndent : _expandable$indentSiz,
      _expandable$childrenC = expandable.childrenColumnName,
      childrenColumnName = _expandable$childrenC === void 0 ? 'children' : _expandable$childrenC;
  var token = theme.components.Table;
  var _token$upArrowIcon = token.upArrowIcon,
      UpArrowIconToken = _token$upArrowIcon === void 0 ? _UnfoldIcon2.UnfoldIcon : _token$upArrowIcon,
      _token$bottomArrowIco = token.bottomArrowIcon,
      BottomArrowIconToken = _token$bottomArrowIco === void 0 ? _FoldIcon2.FoldIcon : _token$bottomArrowIco;

  var _ref = (0, _typeof2["default"])(paginationProps) === 'object' ? paginationProps : {},
      _ref$position = _ref.position,
      position = _ref$position === void 0 ? 'bottomRight' : _ref$position,
      restPaginationProps = (0, _objectWithoutProperties2["default"])(_ref, _excluded);

  var innerStyles = (0, _useStyles["default"])('table', defaultStyles, styles);
  var ComponentTable = components.Table;
  var ComponentHeader = components.Header; // 组件形式引入自定义 Body

  var ComponentBody;

  var componentBodyRef = _react["default"].useRef(null);

  var componentBodyProps = {}; // 函数形式自定义 Body

  var bodyHandle;

  if (components.Body) {
    if ( /*#__PURE__*/_react["default"].isValidElement(components.Body)) {
      ComponentBody = components.Body;
    } else if (typeof components.Body === 'function') {
      bodyHandle = components.Body;
    } else if ((0, _typeof2["default"])(components.Body) === 'object' && components.Body.component) {
      ComponentBody = components.Body.component;

      if (components.Body.ref) {
        componentBodyRef = components.Body.ref;
      }

      if (components.Body.props) {
        componentBodyProps = components.Body.props;
      }
    }
  }

  var TableEl = ComponentTable || 'table';
  var HeaderEl = ComponentHeader || 'thead';
  var BodyEl = ComponentBody || 'tbody';
  var HeaderRowEl = components.HeaderRow || 'tr';
  var HeaderCellEl = components.HeaderCell || 'th';

  var tableMode = _react["default"].useMemo(function () {
    return components.Header || components.Body || renderMode === 'double' ? 'double' : 'single';
  }, [components.Body, components.Header, renderMode]);

  var _useTable = (0, _useTable2["default"])(props, headerRef, componentBodyRef, tableMode),
      showLeftColumnsShadow = _useTable.showLeftColumnsShadow,
      showRightColumnsShadow = _useTable.showRightColumnsShadow,
      tableState = _useTable.tableState,
      expandedRowKeys = _useTable.expandedRowKeys,
      paginationState = _useTable.paginationState,
      container = _useTable.container,
      getRowKey = _useTable.getRowKey,
      columns = _useTable.columns,
      dataSource = _useTable.dataSource,
      allExpandableRowKeys = _useTable.allExpandableRowKeys,
      tableLayout = _useTable.tableLayout,
      tableProps = _useTable.tableProps,
      spinProps = _useTable.spinProps,
      handleSort = _useTable.handleSort,
      handleFilterColumnKeyChange = _useTable.handleFilterColumnKeyChange,
      handleFilterColumnDataChange = _useTable.handleFilterColumnDataChange,
      handleFilterColumnListChange = _useTable.handleFilterColumnListChange,
      handleExpandRow = _useTable.handleExpandRow,
      handleTableSpinWrapperRef = _useTable.handleTableSpinWrapperRef,
      handleTableWrapperScroll = _useTable.handleTableWrapperScroll,
      handlePageChange = _useTable.handlePageChange,
      handlePageSizeChange = _useTable.handlePageSizeChange,
      tableWrapperRef = _useTable.tableWrapperRef,
      headerArr = _useTable.headerArr,
      renderColumns = _useTable.renderColumns,
      handleDoubleTableWrapperScroll = _useTable.handleDoubleTableWrapperScroll,
      doubleTableHeaderWrapperRef = _useTable.doubleTableHeaderWrapperRef;

  var forkedWrapRef = (0, _useForkRef2.useForkRef)(tableWrapperRef, wrapRef); // Render headers

  var headers = (0, _react.useMemo)(function () {
    var headerRowProps = onHeaderRow && onHeaderRow();
    var trList = headerArr.map(function (_columns) {
      var thList = _columns.map(function (c, cIndex) {
        var _c$sortDirections = c.sortDirections,
            sortDirections = _c$sortDirections === void 0 ? defaultSortDirections : _c$sortDirections,
            renderFilterContent = c.renderFilterContent,
            sorter = c.sorter,
            _c$filters = c.filters,
            filters = _c$filters === void 0 ? [] : _c$filters,
            key = c.key,
            title = c.title,
            children = c.children,
            _c$align = c.align,
            align = _c$align === void 0 ? 'left' : _c$align;
        var hasSorter = (0, _utils.getHasSort)(sorter, children);
        var hasFilter = (0, _utils.getHasFilter)(filters, renderFilterContent, children);
        var hasAction = hasSorter || hasFilter;
        var isSortColumn = key === tableState.sortColumnKey;
        var filterColumnData = (0, _find2["default"])(tableState.filterColumnList || [], function (fc) {
          return fc.key === c.key;
        }) || {
          key: key,
          filterValues: filters.map(function (f) {
            return f.value;
          }),
          selectedFilterValues: []
        };
        var outerHeaderCellProps = onHeaderCell ? onHeaderCell(c, cIndex) : {};
        var headerCellProps = (0, _extends2["default"])({}, outerHeaderCellProps, {
          style: (0, _extends2["default"])({
            textAlign: align
          }, outerHeaderCellProps.style)
        });

        if (key === 'selection-column') {
          headerCellProps.style.lineHeight = 0;
        } // 无操作，直接返回th元素


        if (!hasAction) {
          return /*#__PURE__*/_react["default"].createElement(HeaderCellEl, (0, _extends2["default"])({
            rowSpan: c.rowspan || 1,
            colSpan: c.colspan || 1,
            key: key
          }, headerCellProps), title);
        } else {
          // 有排序 or 筛选的情况
          var sortIcons = /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, (0, _includes2["default"])(sortDirections, 'ascend') && /*#__PURE__*/_react["default"].createElement(_styled.StyledSortUpArrow, null, /*#__PURE__*/_react["default"].createElement(UpArrowIconToken, null)), (0, _includes2["default"])(sortDirections, 'descend') && /*#__PURE__*/_react["default"].createElement(_styled.StyledSortBottomArrow, null, /*#__PURE__*/_react["default"].createElement(BottomArrowIconToken, null)));

          var filterPopoverCard = /*#__PURE__*/_react["default"].createElement(_FilterPopoverCard["default"], {
            column: c,
            activeColumnKey: tableState.filterColumnKey,
            filterColumnData: filterColumnData,
            onFilterColumnKeyChange: handleFilterColumnKeyChange,
            onFilterColumnDataChange: handleFilterColumnDataChange,
            onFilterColumnListChange: handleFilterColumnListChange
          });

          return /*#__PURE__*/_react["default"].createElement(_styled.StyledHeader, (0, _extends2["default"])({
            key: key,
            as: HeaderCellEl,
            theme: theme,
            $sortOrder: tableState.sortOrder,
            $isSortColumn: isSortColumn,
            $fixedHeader: fixedHeader,
            rowSpan: c.rowspan || 1,
            colSpan: c.colspan || 1,
            onClick: function onClick() {
              return handleSort(c);
            }
          }, headerCellProps), /*#__PURE__*/_react["default"].createElement(_styled.StyledHeaderContent, {
            $align: align
          }, title, /*#__PURE__*/_react["default"].createElement(_styled.StyledHeaderIconWrapper, null, hasSorter ? sortIcons : hasFilter ? filterPopoverCard : null)), hasSorter && hasFilter ? filterPopoverCard : null);
        }
      });

      return /*#__PURE__*/_react["default"].createElement(HeaderRowEl, (0, _extends2["default"])({}, headerRowProps, {
        key: _columns[0].key
      }), thList);
    });
    return trList;
  }, [onHeaderRow, headerArr, defaultSortDirections, tableState.sortColumnKey, tableState.filterColumnList, tableState.filterColumnKey, tableState.sortOrder, onHeaderCell, handleFilterColumnKeyChange, handleFilterColumnDataChange, handleFilterColumnListChange, HeaderCellEl, theme, fixedHeader, handleSort]);
  var rows = (0, _react.useMemo)(function () {
    // 空状态
    if (!dataSource.length) {
      var emptyResult = emptyText;

      if (!emptyText) {
        emptyResult = /*#__PURE__*/_react["default"].createElement(_Result["default"], {
          subTitle: locale['Table.emptyText'],
          type: "emptySmall"
        });
      } else if (typeof emptyText === 'string') {
        emptyResult = /*#__PURE__*/_react["default"].createElement(_Result["default"], {
          subTitle: emptyText,
          type: "emptySmall"
        });
      }

      return /*#__PURE__*/_react["default"].createElement(_styled.StyledEmptyTr, null, /*#__PURE__*/_react["default"].createElement("td", {
        colSpan: renderColumns.length,
        style: {
          textAlign: 'center',
          height: emptyHeight
        }
      }, emptyResult));
    }

    var renderRows = function renderRows(dataSource) {
      var indent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      return dataSource.map(function (d, rIndex) {
        var rowProps = onRow && onRow(d, rIndex);
        var bodyRowKey = getRowKey(d, rIndex);
        var BodyRow = components.BodyRow,
            BodyCell = components.BodyCell;
        var bodyRowProps = {
          rowKey: bodyRowKey,
          rowIndex: rIndex,
          data: d,
          rowProps: rowProps
        };
        var currentRowExpanded = (0, _includes2["default"])(expandedRowKeys, bodyRowKey); // 当前行展开状态

        var currentRowExpandable = (0, _includes2["default"])(allExpandableRowKeys, bodyRowKey); // 当前行是否可展开

        var rowChildren = d[childrenColumnName];
        var cells = renderColumns.map(function (c, cIndex) {
          var render = c.render,
              dataIndex = c.dataIndex,
              key = c.key,
              _c$ellipsis = c.ellipsis,
              ellipsis = _c$ellipsis === void 0 ? ellipsisProp : _c$ellipsis,
              _c$ellipsisTooltip = c.ellipsisTooltip,
              ellipsisTooltip = _c$ellipsisTooltip === void 0 ? true : _c$ellipsisTooltip,
              ellipsisTitle = c.ellipsisTitle,
              renderEllipsisContent = c.renderEllipsisContent,
              _c$align2 = c.align,
              align = _c$align2 === void 0 ? 'left' : _c$align2;
          var outerCellProps = onCell ? onCell(d, rIndex, c, cIndex) : {};
          var text = dataIndex ? d[dataIndex] : '';
          var rawContent = render ? render(d, cIndex, rIndex) : text; // 如果render返回的是对象形式，覆盖列合并等内容

          if (rawContent && rawContent.children) {
            var _ref2 = rawContent,
                children = _ref2.children,
                _props = _ref2.props;
            rawContent = children; // 如果render中制定了Cell相关的属性和onCell的属性合并一下子，render中的值优先级更高

            outerCellProps = (0, _extends2["default"])({}, outerCellProps, _props);
          }

          var cellProps = (0, _extends2["default"])({}, outerCellProps, {
            style: (0, _extends2["default"])({
              textAlign: align
            }, outerCellProps.style)
          });

          if (key === 'selection-column') {
            cellProps.style.lineHeight = 0;
          }

          var bodyCellProps = (0, _extends2["default"])({}, bodyRowProps, {
            columnKey: key,
            columnIndex: cIndex,
            column: c,
            cellProps: cellProps
          });

          var ellipsisContent = /*#__PURE__*/_react["default"].createElement(_EllipsisContent["default"], {
            ellipsis: ellipsis,
            enableTooltip: ellipsisTooltip,
            enableTitle: ellipsisTitle,
            customContent: renderEllipsisContent ? renderEllipsisContent(d, cIndex, rIndex) : undefined
          }, rawContent);

          var cellContent = ellipsis ? ellipsisContent : rawContent;

          if (cIndex === (rowSelection ? 1 : 0) && // 第一列
          !!allExpandableRowKeys.length // 存在可展开的行
          ) {
            cellContent = /*#__PURE__*/_react["default"].createElement(_styled.StyledExpandCell, null, indent ? /*#__PURE__*/_react["default"].createElement("div", {
              style: {
                width: indent,
                height: 1,
                display: 'inline-block'
              }
            }) : null, /*#__PURE__*/_react["default"].createElement(_styled.StyledExpandButton, {
              type: "normal",
              size: size,
              plain: true,
              theme: theme,
              $expanded: currentRowExpanded,
              $expandable: currentRowExpandable,
              onClick: function onClick() {
                return handleExpandRow(d, rIndex);
              }
            }), cellContent);
          } // 当 colSpan 或 rowSpan 为 0 则表示该单元格隐藏，方便调用单元格合并


          var showCell = bodyCellProps.cellProps.colSpan !== 0 && bodyCellProps.cellProps.rowSpan !== 0;

          if (BodyCell) {
            return showCell ? /*#__PURE__*/_react["default"].createElement(BodyCell, (0, _extends2["default"])({
              key: key
            }, bodyCellProps), cellContent) : null;
          }

          return showCell ? /*#__PURE__*/_react["default"].createElement("td", (0, _extends2["default"])({
            key: key
          }, cellProps), cellContent) : null;
        });
        var expandedRowNode = null;

        if (rowChildren && currentRowExpanded && currentRowExpandable) {
          expandedRowNode = renderRows(rowChildren, indent + indentSize);
        }

        if (expandedRowRender && currentRowExpandable) {
          expandedRowNode = /*#__PURE__*/_react["default"].createElement(_styled.StyledExpandedTr, {
            $expanded: currentRowExpanded
          }, /*#__PURE__*/_react["default"].createElement("td", {
            colSpan: renderColumns.length,
            style: expandableStyle
          }, expandedRowRender(d, rIndex, currentRowExpanded)));
        }

        if (BodyRow) {
          return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
            key: bodyRowKey
          }, /*#__PURE__*/_react["default"].createElement(BodyRow, bodyRowProps, cells), expandedRowNode);
        }

        return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
          key: bodyRowKey
        }, /*#__PURE__*/_react["default"].createElement(_styled.StyledBodyRowTr, (0, _extends2["default"])({}, rowProps, {
          $rowIndex: rIndex,
          $stripe: stripe,
          theme: theme
        }), cells), expandedRowNode);
      });
    };

    return renderRows(dataSource);
  }, [dataSource, emptyText, renderColumns, emptyHeight, locale, onRow, getRowKey, components, expandedRowKeys, allExpandableRowKeys, childrenColumnName, expandedRowRender, stripe, theme, ellipsisProp, onCell, rowSelection, size, handleExpandRow, indentSize, expandableStyle]);
  var footer = (0, _react.useMemo)(function () {
    // 有数据并且Column定义了footer的情况下，渲染表尾
    if (renderColumns.some(function (c) {
      return c.footer;
    }) && dataSource.length) {
      return /*#__PURE__*/_react["default"].createElement("tfoot", null, /*#__PURE__*/_react["default"].createElement("tr", null, renderColumns.map(function (c) {
        return /*#__PURE__*/_react["default"].createElement("td", {
          key: c.key
        }, c.footer);
      })));
    }

    return null;
  }, [dataSource.length, renderColumns]);

  var completeTableEl = function completeTableEl(children) {
    return /*#__PURE__*/_react["default"].createElement(_styled.StyledTable, {
      as: TableEl,
      theme: theme,
      bordered: bordered,
      stripe: stripe,
      size: size,
      tableLayout: tableLayout,
      $expandedRowBackgroundColor: expandedRowBackgroundColor,
      $columns: columns
    }, /*#__PURE__*/_react["default"].createElement(_ColGroup["default"], {
      renderColumns: renderColumns
    }), children);
  };

  var singleTable = /*#__PURE__*/_react["default"].createElement(_styled.StyledTableWrapper, (0, _extends2["default"])({
    $showLeftColumnsShadow: showLeftColumnsShadow,
    $showRightColumnsShadow: showRightColumnsShadow,
    $scrollBarSize: scrollBarSize,
    $expandedRowBackgroundColor: expandedRowBackgroundColor,
    $columns: columns,
    $fixedHeader: fixedHeader,
    $fixedFooter: fixedFooter,
    $bordered: bordered,
    $stripe: stripe,
    theme: theme,
    ref: forkedWrapRef,
    onScroll: handleTableWrapperScroll,
    className: [innerStyles.wrapper.className, className].join(' ').trim(),
    style: (0, _extends2["default"])({}, innerStyles.wrapper.style, style)
  }, tableProps), completeTableEl( /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(HeaderEl, {
    ref: headerRef
  }, headers), /*#__PURE__*/_react["default"].createElement(BodyEl, null, rows), footer)));

  var doubleTable = /*#__PURE__*/_react["default"].createElement(_styled.StyledDoubleTableContainer, {
    style: (0, _extends2["default"])({
      display: 'flex',
      flexDirection: 'column'
    }, innerStyles.wrapper.style, style),
    className: [innerStyles.wrapper.className, className].join(' ').trim()
  }, /*#__PURE__*/_react["default"].createElement(_styled.StyledDoubleTableWrapper, (0, _extends2["default"])({
    $showLeftColumnsShadow: showLeftColumnsShadow,
    $showRightColumnsShadow: showRightColumnsShadow,
    $scrollBarSize: scrollBarSize,
    $expandedRowBackgroundColor: expandedRowBackgroundColor,
    $columns: columns,
    $fixedHeader: fixedHeader,
    $bordered: bordered,
    $stripe: stripe,
    $hiddenScrollBar: true,
    theme: theme,
    onScroll: ComponentHeader ? function () {} : handleDoubleTableWrapperScroll,
    ref: doubleTableHeaderWrapperRef,
    style: {
      borderBottom: 'none'
    }
  }, tableProps), ComponentHeader ? /*#__PURE__*/_react["default"].createElement(ComponentHeader, {
    onScroll: handleDoubleTableWrapperScroll
  }, /*#__PURE__*/_react["default"].createElement(_ColGroup["default"], {
    renderColumns: renderColumns
  })) : completeTableEl( /*#__PURE__*/_react["default"].createElement("thead", {
    ref: headerRef
  }, headers))), /*#__PURE__*/_react["default"].createElement(_styled.StyledDoubleTableWrapper, (0, _extends2["default"])({
    $showLeftColumnsShadow: showLeftColumnsShadow,
    $showRightColumnsShadow: showRightColumnsShadow,
    $scrollBarSize: scrollBarSize,
    $expandedRowBackgroundColor: expandedRowBackgroundColor,
    $columns: columns,
    $fixedFooter: fixedFooter,
    $bordered: bordered,
    $stripe: stripe,
    theme: theme // 当body被外部handle时，onScroll也传递到外部手动调用
    ,
    onScroll: !ComponentBody && !bodyHandle ? handleDoubleTableWrapperScroll : function () {},
    style: {
      flex: 1
    },
    ref: forkedWrapRef
  }, tableProps), ComponentBody && /*#__PURE__*/_react["default"].createElement(ComponentBody, (0, _extends2["default"])({
    ref: componentBodyRef,
    onScroll: handleDoubleTableWrapperScroll,
    dataSource: dataSource,
    columns: columns
  }, componentBodyProps), function (customChildren) {
    return completeTableEl( /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, customChildren, footer));
  }), bodyHandle && bodyHandle({
    setChildren: function setChildren(customChildren) {
      return completeTableEl( /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, customChildren, footer));
    },
    ref: componentBodyRef,
    onScroll: handleDoubleTableWrapperScroll
  }), !ComponentBody && !bodyHandle && completeTableEl( /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("tbody", null, rows), footer))));

  var pagination = (0, _react.useMemo)(function () {
    return paginationProps ? /*#__PURE__*/_react["default"].createElement(_styled.StyledPagination, (0, _extends2["default"])({}, innerStyles.paginationWrapper, restPaginationProps, paginationState, {
      theme: theme,
      $position: position,
      onChange: handlePageChange,
      onPageSizeChange: handlePageSizeChange
    })) : null;
  }, [handlePageChange, handlePageSizeChange, innerStyles.paginationWrapper, paginationProps, paginationState, position, restPaginationProps, theme]);
  var spinNode = (0, _react.useMemo)(function () {
    return container && /*#__PURE__*/_react["default"].createElement(_Spin["default"], spinProps);
  }, [container, spinProps]);
  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    ref: handleTableSpinWrapperRef
  }, innerStyles.spinWrapper), (0, _includes2["default"])(position, 'top') && pagination, tableMode === 'double' ? doubleTable : singleTable, spinNode, (0, _includes2["default"])(position, 'bottom') && pagination);
}