"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledTableWrapper = exports.StyledTable = exports.StyledSortUpArrow = exports.StyledSortBottomArrow = exports.StyledPagination = exports.StyledHeaderIconWrapper = exports.StyledHeaderContent = exports.StyledHeader = exports.StyledFilterWrapper = exports.StyledFilterItem = exports.StyledFilter = exports.StyledExpandedTr = exports.StyledExpandCell = exports.StyledExpandButton = exports.StyledEmptyTr = exports.StyledDoubleTableWrapper = exports.StyledDoubleTableContainer = exports.StyledBodyRowTr = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _flatten2 = _interopRequireDefault(require("lodash/flatten"));

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Button = _interopRequireDefault(require("../Button"));

var _Pagination = _interopRequireDefault(require("../Pagination"));

var _styled = require("../ScrollView/styled");

var _addPx = _interopRequireDefault(require("../utils/addPx"));

var _utils = require("./utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var alignMap = {
  left: 'flex-start',
  center: 'center',
  right: 'flex-end'
}; // 内容区域容器，包含图标和文字

var StyledHeaderContent = _styledComponents["default"].div.withConfig({
  displayName: "StyledHeaderContent"
})(["", ""], function (_ref) {
  var $align = _ref.$align;
  return (0, _styledComponents.css)(["justify-content:", ";"], alignMap[$align]);
}); // 内容右侧，图标的容器


exports.StyledHeaderContent = StyledHeaderContent;

var StyledHeaderIconWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledHeaderIconWrapper"
})([""]); // 排序功能的上下箭头图标


exports.StyledHeaderIconWrapper = StyledHeaderIconWrapper;

var StyledSortUpArrow = _styledComponents["default"].i.withConfig({
  displayName: "StyledSortUpArrow"
})([""]);

exports.StyledSortUpArrow = StyledSortUpArrow;

var StyledSortBottomArrow = _styledComponents["default"].i.withConfig({
  displayName: "StyledSortBottomArrow"
})([""]); // 排序面板内容


exports.StyledSortBottomArrow = StyledSortBottomArrow;

var StyledFilterItem = _styledComponents["default"].div.withConfig({
  displayName: "StyledFilterItem"
})(["display:flex;align-items:center;margin-bottom:", "px;&:last-child{margin-bottom:0;}"], function (props) {
  return props.theme.spacing.spec.s6;
}); // 筛选功能的图标


exports.StyledFilterItem = StyledFilterItem;

var StyledFilter = _styledComponents["default"].i.withConfig({
  displayName: "StyledFilter"
})([""]); // 筛选功能最外层容器


exports.StyledFilter = StyledFilter;

var StyledFilterWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledFilterWrapper"
})([""]); // tbody row


exports.StyledFilterWrapper = StyledFilterWrapper;

var StyledBodyRowTr = _styledComponents["default"].tr.withConfig({
  displayName: "StyledBodyRowTr"
})(["", ""], function (props) {
  var theme = props.theme,
      $rowIndex = props.$rowIndex,
      $stripe = props.$stripe;

  if ($rowIndex % 2 !== 0 && $stripe) {
    return (0, _styledComponents.css)(["& td:after{background:", ";}"], theme.components.Table.trBackground.stripe);
  }
}); // 空状态tr容器


exports.StyledBodyRowTr = StyledBodyRowTr;

var StyledEmptyTr = _styledComponents["default"].tr.withConfig({
  displayName: "StyledEmptyTr"
})([""]); // 行展开的tr


exports.StyledEmptyTr = StyledEmptyTr;

var StyledExpandedTr = _styledComponents["default"].tr.withConfig({
  displayName: "StyledExpandedTr"
})(["", ""], function (props) {
  if (!props.$expanded) {
    return (0, _styledComponents.css)(["display:none;"]);
  }
});

exports.StyledExpandedTr = StyledExpandedTr;

var StyledExpandCell = _styledComponents["default"].div.withConfig({
  displayName: "StyledExpandCell"
})(["display:flex;justify-content:flex-start;align-items:center;"]); // 行展开的按钮


exports.StyledExpandCell = StyledExpandCell;
var StyledExpandButton = (0, _styledComponents["default"])(_Button["default"]).withConfig({
  displayName: "StyledExpandButton"
})(["", ""], function (props) {
  var $expanded = props.$expanded,
      _props$$expandable = props.$expandable,
      $expandable = _props$$expandable === void 0 ? true : _props$$expandable,
      theme = props.theme,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size;
  var expandStyle = !$expanded && (0, _styledComponents.css)(["&::before{transform:translateY(-50%) rotate(-180deg);}&::after{transform:translateX(-50%) rotate(0deg);}"]);
  var expandableStyle = !$expandable && (0, _styledComponents.css)(["opacity:0;"]); // 必须为偶数，否则内部加号图标会乱

  var fontSize = theme.components.Button.fontSize[size];

  if (fontSize % 2 !== 0) {
    fontSize += 1;
  }

  return (0, _styledComponents.css)(["width:", "px;height:", "px;padding:0;outline:none;transition:all 0.3s;user-select:none;margin-right:", "px;flex-shrink:0;&::before,&::after{position:absolute;background:currentColor;transition:transform 0.3s ease-out;content:'';}&::before{top:50%;right:3px;left:3px;height:1px;transform:translateY(-50%);}&::after{top:3px;bottom:3px;left:50%;width:1px;transform:translateX(-50%) rotate(90deg);}", " ", ""], fontSize, fontSize, theme.components.Table.expandIndent, expandStyle, expandableStyle);
}); // 带样式的表头th

exports.StyledExpandButton = StyledExpandButton;

var StyledHeader = _styledComponents["default"].th.withConfig({
  displayName: "StyledHeader"
})(["", ""], function (props) {
  var $isSortColumn = props.$isSortColumn,
      $sortOrder = props.$sortOrder,
      $fixedHeader = props.$fixedHeader,
      theme = props.theme;
  var token = theme.components.Table,
      colors = theme.colors,
      typography = theme.typography,
      spacing = theme.spacing,
      zIndex = theme.zIndex,
      _theme$transition$pat = theme.transition.pattern,
      easing = _theme$transition$pat.easing,
      duration = _theme$transition$pat.duration;
  return (0, _styledComponents.css)(["position:", ";transition:background-color ", " ", "ms;user-select:none;cursor:pointer;background:", ";&:hover{", ",", "{", ",", "{color:", ";}}background:", ";}", ",", "{", ",", "{font-size:", "px;color:", ";}}", "{display:flex;align-items:center;width:100%;height:100%;box-sizing:border-box;", "{display:flex;flex-flow:column nowrap;margin-left:", "px;}", ",", "{&,svg{display:block;width:", "px;height:", "px;}", "}", "{margin-bottom:-1px;", "}", "{margin-top:-1px;", "}}", "{position:absolute;right:0;top:0;display:flex;align-items:center;justify-content:center;height:100%;padding:0 ", "px;margin-left:", "px;z-index:", ";}"], $fixedHeader ? 'sticky' : 'relative', easing.status, duration.status, token.headOrFooterBackground, StyledHeaderContent, StyledFilterWrapper, StyledHeaderIconWrapper, StyledFilter, colors.pattern.text.assistant, token.headOrFooterHoverBackground, StyledHeaderContent, StyledFilterWrapper, StyledHeaderIconWrapper, StyledFilter, typography.spec.fontSize.s1, colors.pattern.icon.normal, StyledHeaderContent, StyledHeaderIconWrapper, spacing.spec.s1, StyledSortUpArrow, StyledSortBottomArrow, token.arrowSize, token.arrowSize, !!$sortOrder && $isSortColumn && (0, _styledComponents.css)(["color:", ";"], colors.pattern.text.assistant), StyledSortUpArrow, $sortOrder === 'ascend' && $isSortColumn && (0, _styledComponents.css)(["color:", ";"], colors.spec.brand), StyledSortBottomArrow, function (props) {
    return $sortOrder === 'descend' && $isSortColumn && (0, _styledComponents.css)(["color:", ";"], colors.spec.brand);
  }, StyledFilterWrapper, spacing.spec.s4, spacing.spec.s4, zIndex.spec.s1);
}); // 单元格样式


exports.StyledHeader = StyledHeader;

function makeCellStyle(props) {
  var size = props.size,
      theme = props.theme;
  var _theme$components$Tab = theme.components.Table.sizeData[size],
      headerPaddingLevels = _theme$components$Tab.headerPaddingLevels,
      cellPaddingLevels = _theme$components$Tab.cellPaddingLevels,
      fontLevel = _theme$components$Tab.fontLevel;
  var headerPadding = headerPaddingLevels.map(function (l) {
    return "".concat(theme.spacing.spec[l], "px ");
  });
  var cellPadding = cellPaddingLevels.map(function (l) {
    return "".concat(theme.spacing.spec[l], "px ");
  });
  return (0, _styledComponents.css)(["th,td{margin:0;box-sizing:border-box;}line-height:", "px;font-size:", "px;thead{th{padding:", ";}", "{padding:0;}", "{padding:", ";}}tfoot td{padding:", ";}tbody td{padding:", ";}"], theme.typography.spec.lineHeight[fontLevel], theme.typography.spec.fontSize[fontLevel], headerPadding, StyledHeader, StyledHeaderContent, headerPadding, headerPadding, cellPadding);
}

var StyledTableWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledTableWrapper"
})(["position:relative;overflow:auto;", ""], function (props) {
  var _props$theme = props.theme,
      border = _props$theme.colors.pattern.border,
      token = _props$theme.components.Table;
  var fixedColumns = props.$columns.map(function (c, index) {
    return (0, _extends2["default"])({}, c, {
      index: index
    });
  }).filter(function (c) {
    return !!c.fixed && 'width' in c;
  });
  var leftFixedColumns = fixedColumns.filter(function (c) {
    return c.fixed === 'left';
  });
  var rightFixedColumns = fixedColumns.filter(function (c) {
    return c.fixed === 'right';
  });

  var getFixedColumnStyles = function getFixedColumnStyles(columns, direction) {
    var styleList = [];
    var depth = (0, _utils.setParentAndGetDepth)(columns);
    columns.reduce( // acc 为 [ 前面节点宽度, 当前的 childIndex 列表 ]
    function (acc, c, i) {
      var lastList = acc[1];
      var childList = (0, _utils.getChildIndexes)(lastList, c, direction, depth); // childList 的各个 length 的集合

      var childIndexes = childList.map(function (v) {
        return v.length;
      });
      var lastChildList = childList.map(function (v) {
        return v.slice(-1)[0];
      });
      var width = acc[0];
      var boxShadowStyle;
      var showLeftShadow = props.$showLeftColumnsShadow;
      var showRightShadow = props.$showRightColumnsShadow;

      if (direction === 'left' && showLeftShadow && lastChildList.includes(c) && i === columns.length - 1) {
        boxShadowStyle = (0, _styledComponents.css)(["border-right:none;&:before{content:'';right:0;left:unset;top:0;bottom:0;position:absolute;width:6px;z-index:-1;box-shadow:", ";}"], token.leftFixedColumnBoxShadow);
      }

      if (direction === 'right' && showRightShadow && lastChildList.includes(c) && i === columns.length - 1) {
        boxShadowStyle = (0, _styledComponents.css)(["&:before{content:'';left:0;right:unset;top:0;bottom:0;position:absolute;width:6px;box-shadow:", ";}"], token.rightFixedColumnBoxShadow);
      }

      styleList.push((0, _styledComponents.css)(["", ""], childIndexes.map(function (child, idx) {
        var headerFootStyles = [];

        for (var _i = 0, j = 0; _i < child; _i++) {
          // 数组中之前已经出现的节点，认为这个节点的 DOM 结构在另一个 tr 中，所以要改变 nth-child 的量
          // 例如 getChildIndexes 注释案例中第二，第三节点中的 “1”
          if ((0, _flatten2["default"])(childList.slice(0, idx)).includes(childList[idx][_i])) {
            continue;
          }

          headerFootStyles.push((0, _styledComponents.css)(["& thead tr:nth-child(", ") th:", "(", "),& tfoot tr:nth-child(", ") td:", "(", "){position:sticky;", ":", ";z-index:", ";", ";}"], idx + 1, direction === 'left' ? 'nth-child' : 'nth-last-child', j + 1, idx + 1, direction === 'left' ? 'nth-child' : 'nth-last-child', j + 1, direction, (0, _addPx["default"])(childList[idx].slice(0, _i).map(function (v) {
            return Number(v.width);
          }).reduce(function (b, p) {
            return b + p;
          }, 0)), token.fixedZIndex + 1, _i === child - 1 ? boxShadowStyle : ''));
          j++;
        }

        return headerFootStyles;
      })));
      var bodyLen = childIndexes.slice(-1)[0];

      for (var _i2 = 0; _i2 < bodyLen; _i2++) {
        styleList.push((0, _styledComponents.css)(["& tbody tr td:", "(", "){position:sticky;", ":", ";z-index:", ";", ";}"], direction === 'left' ? 'nth-child' : 'nth-last-child', _i2 + 1, direction, (0, _addPx["default"])(childList.slice(-1)[0].slice(0, _i2).map(function (v) {
          return Number(v.width);
        }).reduce(function (b, p) {
          return b + p;
        }, 0)), token.fixedZIndex, _i2 === bodyLen - 1 ? boxShadowStyle : ''));
      }

      return [width + (typeof c.width === 'number' ? c.width : parseInt(c.width, 10)), childList];
    }, [0, []]);
    return styleList;
  };

  return (0, _styledComponents.css)(["", " ", " &,& *{", "}", "}", " ", "}", "}"], getFixedColumnStyles(leftFixedColumns, 'left'), getFixedColumnStyles(rightFixedColumns.reverse(), 'right'), (0, _styled.scrollBarStyle)({
    size: props.$scrollBarSize,
    theme: props.theme
  }), props.$bordered && (0, _styledComponents.css)(["border-left:1px solid ", ";& th,td{border:1px solid ", ";border-top:none;border-left:none;position:relative;&:before{content:'';position:absolute;left:0;width:100%;}&:before{top:-1px;}&::after{content:'';position:absolute;bottom:0;}}& thead > tr:nth-child(1) > th{border-top:1px solid ", ";}& tr:last-child td{border-bottom:none;}"], border.normal, border.normal, border.normal),
  /* 开启斑马纹且 bordered: false 时不存在底线 */
  (!props.$stripe || props.$bordered) && (0, _styledComponents.css)(["border-bottom:1px solid ", ";"], border.normal), props.$fixedHeader && (0, _styledComponents.css)(["& thead th{position:sticky;top:0;z-index:", ";}"], token.fixedZIndex), props.$fixedFooter && (0, _styledComponents.css)(["& tfoot td{position:sticky;bottom:0;z-index:", ";}"], token.fixedZIndex));
});

exports.StyledTableWrapper = StyledTableWrapper;

var StyledTable = _styledComponents["default"].table.withConfig({
  displayName: "StyledTable"
})(["", ""], function (props) {
  var $expandedRowBackgroundColor = props.$expandedRowBackgroundColor,
      theme = props.theme;
  var border = theme.colors.pattern.border,
      token = theme.components.Table;
  return (0, _styledComponents.css)(["text-align:left;width:100%;background-color:", ";color:", ";border-radius:", " ", " 0 0;border-spacing:0;table-layout:", ";", " thead{tr:first-child{& th:first-child{border-top-left-radius:", ";}& th:last-child{border-top-right-radius:", ";}}tr th{background:", ";font-weight:", ";color:", ";overflow-wrap:break-word;}}tbody{tr{& > td{position:relative;z-index:1;background:", ";overflow-wrap:break-word;&:after{content:' ';position:absolute;z-index:-1;left:0;right:0;top:0;bottom:0;}}&:hover > td:after{background:", ";}", " ", "}", "{background:", ";&:hover{background:", ";}}", "{& > td{background:", ";&:hover{background:", ";}&:hover:after{background:", ";}}}}tfoot{tr td{background:", ";font-weight:", ";overflow-wrap:break-word;}}"], token.tableBackground, token.color, token.borderRadius, token.borderRadius, props.tableLayout, makeCellStyle, token.borderRadius, token.borderRadius, token.headOrFooterBackground, token.headOrFooterFontWeight, token.headOrFooterColor, token.trBackground.normal, token.trBackground.hover, !props.stripe && !props.bordered && (0, _styledComponents.css)(["& > td{border-bottom:1px solid ", ";}&:last-child > td{border-bottom:none;}"], border.normal), props.stripe && !props.bordered && (0, _styledComponents.css)(["& > td{border-top:1px solid transparent;}&:last-child > td{border-bottom:1px solid transparent;}&:hover{& > td,& + tr > td{border-top-color:", ";}&:last-child > td{border-bottom-color:", ";}}"], border.normal, border.normal), StyledEmptyTr, token.trBackground.normal, token.trBackground.normal, StyledExpandedTr, $expandedRowBackgroundColor, $expandedRowBackgroundColor, $expandedRowBackgroundColor, token.headOrFooterBackground, token.headOrFooterFontWeight);
});

exports.StyledTable = StyledTable;
var StyledPagination = (0, _styledComponents["default"])(_Pagination["default"]).withConfig({
  displayName: "StyledPagination"
})(["", ""], function (props) {
  var _props$$position = props.$position,
      $position = _props$$position === void 0 ? 'bottomRight' : _props$$position,
      _props$size2 = props.size,
      size = _props$size2 === void 0 ? 'm' : _props$size2,
      Table = props.theme.components.Table;

  var getJustifyContent = function getJustifyContent() {
    if ((0, _includes2["default"])($position, 'Left')) {
      return (0, _styledComponents.css)(["justify-content:flex-start;"]);
    }

    if ((0, _includes2["default"])($position, 'Center')) {
      return (0, _styledComponents.css)(["justify-content:center;"]);
    }

    if ((0, _includes2["default"])($position, 'Right')) {
      return (0, _styledComponents.css)(["justify-content:flex-end;"]);
    }
  };

  var marginStyle = (0, _includes2["default"])($position, 'top') ? (0, _styledComponents.css)(["margin-bottom:", "px;"], Table.paginationMargin[size]) : (0, _styledComponents.css)(["margin-top:", "px;"], Table.paginationMargin[size]);
  return (0, _styledComponents.css)(["display:flex;flex-wrap:wrap;", ";", ";"], getJustifyContent(), marginStyle);
});
exports.StyledPagination = StyledPagination;
var StyledDoubleTableWrapper = (0, _styledComponents["default"])(StyledTableWrapper).withConfig({
  displayName: "StyledDoubleTableWrapper"
})(["", ""], function (props) {
  var theme = props.theme,
      _props$$scrollBarSize = props.$scrollBarSize,
      $scrollBarSize = _props$$scrollBarSize === void 0 ? 'm' : _props$$scrollBarSize;
  var scrollBarToken = theme.components.ScrollView.scrollBar;
  var hiddenScrollBarStyle;

  if (props.$hiddenScrollBar) {
    hiddenScrollBarStyle = (0, _styledComponents.css)(["padding-right:", "px;&::-webkit-scrollbar{width:0;height:0;}"], scrollBarToken.size[$scrollBarSize]);
  }

  return (0, _styledComponents.css)(["", ""], hiddenScrollBarStyle);
});
exports.StyledDoubleTableWrapper = StyledDoubleTableWrapper;

var StyledDoubleTableContainer = _styledComponents["default"].div.withConfig({
  displayName: "StyledDoubleTableContainer"
})(["display:flex;flex-direction:column;"]);

exports.StyledDoubleTableContainer = StyledDoubleTableContainer;