"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _styled = require("./styled");

var _TabsContainer = _interopRequireDefault(require("./TabsContainer"));

var _useTabsBase2 = _interopRequireDefault(require("./useTabsBase"));

var _const = require("./const");

var _excluded = ["type", "index", "size", "disabled", "busy", "onChange", "styles", "swipe", "tabBarExtraContent", "lineIndicatorMode", "children", "enableDiffChildren", "equalNum", "gutter", "duration", "enableBadge", "vertical"];
var CapsuleTabs = (0, _memoForwardRef["default"])(function (props, ref) {
  var type = props.type,
      _props$index = props.index,
      index = _props$index === void 0 ? 0 : _props$index,
      size = props.size,
      disabled = props.disabled,
      busy = props.busy,
      onChange = props.onChange,
      styles = props.styles,
      swipe = props.swipe,
      tabBarExtraContent = props.tabBarExtraContent,
      lineIndicatorMode = props.lineIndicatorMode,
      children = props.children,
      enableDiffChildren = props.enableDiffChildren,
      equalNum = props.equalNum,
      gutter = props.gutter,
      duration = props.duration,
      enableBadge = props.enableBadge,
      vertical = props.vertical,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var innerStyles = (0, _useStyles["default"])('tabs', _const.defaultStyles, styles);
  var swipeProps = {
    enableDiffChildren: enableDiffChildren,
    equalNum: equalNum,
    gutter: gutter,
    duration: duration
  };

  var _useTabsBase = (0, _useTabsBase2["default"])(props),
      resultChildren = _useTabsBase.children;

  return /*#__PURE__*/_react["default"].createElement(_styled.BaseNode, (0, _extends2["default"])({}, otherProps, {
    ref: ref
  }), /*#__PURE__*/_react["default"].createElement(_styled.BaseNode, null, /*#__PURE__*/_react["default"].createElement(_TabsContainer["default"], (0, _extends2["default"])({}, innerStyles.container, swipeProps, {
    swipe: swipe,
    size: size,
    type: "capsule",
    enableBadge: enableBadge,
    vertical: vertical
  }), resultChildren), tabBarExtraContent && !vertical ? /*#__PURE__*/_react["default"].createElement(_styled.ExtraContentWrapper, innerStyles.extraContentWrapper, tabBarExtraContent) : null));
});
var _default = CapsuleTabs;
exports["default"] = _default;