"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _withTheme = require("../utils/withTheme");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var oppositionPosMap = {
  left: 'right',
  right: 'left',
  top: 'bottom',
  bottom: 'top'
};

function tabIndicatorCss(props) {
  var theme = props.theme,
      _props$$offset = props.$offset,
      $offset = _props$$offset === void 0 ? 0 : _props$$offset,
      _props$$size = props.$size,
      $size = _props$$size === void 0 ? 0 : _props$$size,
      _props$$transition = props.$transition,
      $transition = _props$$transition === void 0 ? 'off' : _props$$transition,
      _props$$hide = props.$hide,
      $hide = _props$$hide === void 0 ? false : _props$$hide,
      $vertical = props.$vertical,
      $tabPosition = props.$tabPosition;
  var token = theme.components.Tabs;
  var indicator = token.indicator;
  var _theme$transition$pat = theme.transition.pattern,
      duration = _theme$transition$pat.duration,
      easing = _theme$transition$pat.easing;
  var transitionCss;

  if ($transition === 'on') {
    transitionCss = (0, _styledComponents.css)(["transition:all ", "ms ", ";"], duration.status, easing.status);
  }

  var indicatorCss;

  if (!$hide) {
    indicatorCss = (0, _styledComponents.css)(["", ":0;", ":0;z-index:2;&::before{content:'';display:block;position:absolute;background:", ";", ":", "px;", ":", "px;", ":", "px;", ":0;", "}"], oppositionPosMap[$tabPosition], $vertical ? 'top' : 'left', indicator.activeColor, $vertical ? 'width' : 'height', indicator.activeHeight, $vertical ? 'height' : 'width', $size, $vertical ? 'top' : 'left', $offset, oppositionPosMap[$tabPosition], transitionCss);
  }

  return (0, _styledComponents.css)(["width:", ";height:", ";background:", ";", ""], $vertical ? "".concat(indicator.bgHeight, "px") : '100%', $vertical ? '100%' : "".concat(indicator.bgHeight, "px"), indicator.bgColor, indicatorCss);
}

var LineIndicator = _styledComponents["default"].div.withConfig({
  displayName: "LineIndicator"
})(["position:absolute;", ""], tabIndicatorCss);

var _default = (0, _withTheme.withThemeForStyled)(LineIndicator);

exports["default"] = _default;