"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _LineIndicator = _interopRequireDefault(require("./LineIndicator"));

var _styled = require("./styled");

var _TabsContainer = _interopRequireDefault(require("./TabsContainer"));

var _useLineTabs2 = _interopRequireDefault(require("./useLineTabs"));

var _const = require("./const");

var _excluded = ["type", "index", "size", "disabled", "busy", "onChange", "styles", "swipe", "children", "height", "tabBarExtraContent", "lineIndicatorMode", "enableDiffChildren", "equalNum", "gutter", "duration", "enableBadge", "vertical", "tabPosition"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var LineTabs = (0, _memoForwardRef["default"])(function (props, ref) {
  var type = props.type,
      index = props.index,
      size = props.size,
      disabled = props.disabled,
      busy = props.busy,
      onChange = props.onChange,
      styles = props.styles,
      swipe = props.swipe,
      children = props.children,
      height = props.height,
      tabBarExtraContent = props.tabBarExtraContent,
      _props$lineIndicatorM = props.lineIndicatorMode,
      lineIndicatorMode = _props$lineIndicatorM === void 0 ? 'default' : _props$lineIndicatorM,
      enableDiffChildren = props.enableDiffChildren,
      equalNum = props.equalNum,
      gutter = props.gutter,
      duration = props.duration,
      enableBadge = props.enableBadge,
      vertical = props.vertical,
      tabPosition = props.tabPosition,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var innerStyles = (0, _useStyles["default"])('tabs', _const.defaultStyles, styles);
  var containerRef = (0, _react.useRef)(null);
  var handleRef = (0, _useForkRef2.useForkRef)(containerRef, ref);
  var swipeProps = {
    enableDiffChildren: enableDiffChildren,
    equalNum: equalNum,
    gutter: gutter,
    duration: duration
  };

  var _useLineTabs = (0, _useLineTabs2["default"])(props, containerRef),
      selectedIndex = _useLineTabs.selectedIndex,
      resultChildren = _useLineTabs.children,
      indicatorState = _useLineTabs.indicatorState,
      onContainerChange = _useLineTabs.onContainerChange,
      hideContainerIndicator = _useLineTabs.hideContainerIndicator;

  return /*#__PURE__*/_react["default"].createElement(_styled.BaseNode, (0, _extends2["default"])({}, otherProps, {
    ref: handleRef
  }), /*#__PURE__*/_react["default"].createElement(_TabsContainer["default"], (0, _extends2["default"])({}, innerStyles.container, swipeProps, {
    size: size,
    type: "line",
    swipe: swipe,
    height: height,
    selectedIndex: selectedIndex,
    onChange: onContainerChange,
    enableBadge: enableBadge,
    vertical: vertical
  }), resultChildren), tabBarExtraContent ? /*#__PURE__*/_react["default"].createElement(_styled.ExtraContentWrapper, innerStyles.extraContentWrapper, tabBarExtraContent) : null, /*#__PURE__*/_react["default"].createElement(_LineIndicator["default"], (0, _extends2["default"])({}, innerStyles.indicator, {
    $hide: hideContainerIndicator,
    $offset: indicatorState.offset,
    $size: indicatorState.size,
    $transition: indicatorState.transition,
    $vertical: vertical,
    $tabPosition: tabPosition
  })));
});
var _default = LineTabs;
exports["default"] = _default;