"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Button = require("../Button");

var _addPx = _interopRequireDefault(require("../utils/addPx"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _withTheme = require("../utils/withTheme");

var _Tooltip = _interopRequireDefault(require("../Tooltip"));

var _Badge = _interopRequireDefault(require("../Badge"));

var _excluded = ["index", "selected", "type", "divider", "buttonType", "size", "htmlType", "disabled", "busy", "component", "prefixNode", "suffixNode", "onClick", "loading", "textFine", "fontWeight", "width", "constant", "href", "target", "rel", "showIndicator", "styles", "children", "tooltipProps", "badgeProps"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var InnerButton = (0, _styledComponents["default"])(_Button.InlineButton).withConfig({
  displayName: "InnerButton"
})([""]);
InnerButton.__MUYA_BUTTON = true;

var BaseNode = _styledComponents["default"].div.withConfig({
  displayName: "BaseNode"
})([""]);

var defaultStyles = {
  item: ''
};
var TabPure = (0, _memoForwardRef["default"])(function (props, ref) {
  var index = props.index,
      selected = props.selected,
      type = props.type,
      divider = props.divider,
      buttonTypeProp = props.buttonType,
      size = props.size,
      htmlType = props.htmlType,
      disabled = props.disabled,
      busy = props.busy,
      asProp = props.component,
      prefixNode = props.prefixNode,
      suffixNode = props.suffixNode,
      onClick = props.onClick,
      loading = props.loading,
      textFine = props.textFine,
      fontWeight = props.fontWeight,
      width = props.width,
      constant = props.constant,
      href = props.href,
      target = props.target,
      rel = props.rel,
      showIndicator = props.showIndicator,
      styles = props.styles,
      children = props.children,
      tooltipProps = props.tooltipProps,
      badgeProps = props.badgeProps,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var innerStyles = (0, _useStyles["default"])('tab', defaultStyles, styles);
  var buttonType = (0, _react.useMemo)(function () {
    if (selected) {
      return 'primary';
    }

    if (buttonTypeProp) {
      return buttonTypeProp;
    }

    if (type === 'card') {
      return 'normal';
    }

    return 'strong';
  }, [buttonTypeProp, selected, type]);
  var buttonProps = (0, _extends2["default"])({
    type: buttonType,
    size: size,
    htmlType: htmlType,
    disabled: disabled,
    onClick: onClick,
    busy: busy,
    fontWeight: selected ? 'normal' : 'lighter',
    component: asProp,
    prefixNode: prefixNode,
    suffixNode: suffixNode,
    loading: loading,
    width: width,
    constant: constant,
    href: href,
    target: target,
    rel: rel,
    styles: styles
  }, innerStyles.item);

  var innerButtonNode = /*#__PURE__*/_react["default"].createElement(InnerButton, buttonProps, children);

  if (badgeProps) {
    innerButtonNode = /*#__PURE__*/_react["default"].createElement(_Badge["default"], badgeProps, innerButtonNode);
  }

  if (tooltipProps) {
    if (disabled) {
      buttonProps.component = 'span';
    }

    innerButtonNode = /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], tooltipProps, innerButtonNode);
  }

  return /*#__PURE__*/_react["default"].createElement(BaseNode, (0, _extends2["default"])({}, otherProps, {
    ref: ref
  }), innerButtonNode);
});

function lineTabCss(props) {
  var theme = props.theme,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      selected = props.selected,
      _props$showIndicator = props.showIndicator,
      showIndicator = _props$showIndicator === void 0 ? false : _props$showIndicator,
      tabPosition = props.tabPosition;
  var token = theme.components.Tabs;
  var height = token.height[size];
  var padding = token.padding[size];
  var paddingCss;

  if (padding) {
    paddingCss = (0, _styledComponents.css)(["padding:", ";"], padding);
  }

  var selectedCss;

  if (selected && showIndicator) {
    selectedCss = (0, _styledComponents.css)(["&::before{content:'';display:block;position:absolute;bottom:0;height:", "px;background:", ";width:100%;}"], token.indicator.activeHeight, token.indicator.activeColor);
  }

  return (0, _styledComponents.css)(["& ", "{min-height:", ";", "}position:relative;", ":", "px;", ""], InnerButton, (0, _addPx["default"])(height), paddingCss, tabPosition === 'right' ? 'margin-left' : 'margin-right', token.marginRight[size], selectedCss);
}

function cardTabCss(props) {
  var theme = props.theme,
      _props$size2 = props.size,
      size = _props$size2 === void 0 ? 'm' : _props$size2,
      selected = props.selected,
      disabled = props.disabled,
      busy = props.busy,
      _props$divider = props.divider,
      divider = _props$divider === void 0 ? 'on' : _props$divider;
  var colors = theme.colors;
  var card = theme.components.Tabs.card;
  var height = card.height[size];
  var hasMargin = card.marginRight > 0;
  var interactive = !(busy || disabled);
  var statusCss;

  if (selected) {
    statusCss = (0, _styledComponents.css)(["border-color:", ";border-bottom:1px solid transparent;border-top-left-radius:", ";border-top-right-radius:", ";background-color:", ";z-index:1;"], colors.pattern.border.normal, card.borderRadius, card.borderRadius, card.bgSelectedColor);
  } else {
    statusCss = (0, _styledComponents.css)(["background-color:", ";border-bottom-color:", ";", " ", ""], card.bgColor, colors.pattern.border.normal, hasMargin && (0, _styledComponents.css)(["border-color:", ";border-bottom:1px solid transparent;border-top-left-radius:", ";border-top-right-radius:", ";"], colors.pattern.border.normal, card.borderRadius, card.borderRadius), interactive && (0, _styledComponents.css)(["&:hover{background-color:", ";", "{color:", ";}}"], card.bgHoverColor, InnerButton, card.hoverColor));
  }

  var orderCss;
  var padding = card.padding[size];

  if (divider === 'on') {
    var dividerSize = card.dividerSize[size];
    orderCss = (0, _styledComponents.css)(["&::before{content:'';display:block;position:absolute;top:", "px;right:-1px;height:", "px;width:1px;background:", ";}"], (height - dividerSize) / 2, dividerSize, colors.pattern.border.normal);
  }

  return (0, _styledComponents.css)(["position:relative;border:1px solid transparent;margin-right:", "px;& ", "{height:", "px;padding:0 ", "px;line-height:1;}", " ", " &:first-child{border-top-left-radius:", ";}&:last-child{border-top-right-radius:", ";margin-right:0;}"], card.marginRight, InnerButton, height, padding, statusCss, orderCss, card.borderRadius, card.borderRadius);
}

function capsuleTabCss(props) {
  var theme = props.theme,
      _props$size3 = props.size,
      size = _props$size3 === void 0 ? 'm' : _props$size3,
      selected = props.selected,
      disabled = props.disabled,
      busy = props.busy,
      tabPosition = props.tabPosition;
  var token = theme.components.Tabs;
  var interactive = !(busy || disabled);
  var height = token.height[size];
  var borderRadius = token.capsule.inlineBtnRadius || token.capsule.radius;
  var clickColor = token.capsule.clickColor;
  var inlineBtnCss = (0, _styledComponents.css)(["background-color:", ";min-height:", ";border-radius:", ";padding:0 ", ";", ""], token.capsule.btnBgColor.normal, (0, _addPx["default"])(height), borderRadius[size], token.capsule.btnPadding[size], function () {
    if (!selected) {
      return (0, _styledComponents.css)(["background:", ";", ""], token.capsule.btnBgColor.normal, interactive && (0, _styledComponents.css)(["color:", ";&:hover{background:", ";}&:active{", " background:", ";}"], token.capsule.color, token.capsule.btnBgColor.hover, !!clickColor && (0, _styledComponents.css)(["color:", ";"], token.capsule.clickColor), token.capsule.btnBgColor.click));
    } else {
      return (0, _styledComponents.css)(["", " background:", ";"], !!clickColor && (0, _styledComponents.css)(["color:", ";"], token.capsule.clickColor), token.capsule.btnBgColor.click);
    }
  });
  return (0, _styledComponents.css)(["& ", "{", "}position:relative;&:not(:last-child){", ":", ";}"], InnerButton, inlineBtnCss, tabPosition === 'top' || tabPosition === 'bottom' ? 'margin-right' : 'margin-bottom', token.capsule.bgPadding[size]);
}

var Tab = (0, _styledComponents["default"])(TabPure).withConfig({
  displayName: "Tab"
})(["box-sizing:border-box;", ""], function (props) {
  if (props.type === 'card') {
    return cardTabCss(props);
  } else if (props.type === 'capsule') {
    return capsuleTabCss(props);
  } else {
    return lineTabCss(props);
  }
});

var _default = (0, _withTheme.withThemeForStyled)(Tab);

exports["default"] = _default;