"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _RightIcon2 = require("@muya-ui/theme-light/lib/icons/RightIcon");

var _LeftIcon2 = require("@muya-ui/theme-light/lib/icons/LeftIcon");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _ImgPoolContext = _interopRequireDefault(require("../Img/ImgPoolContext"));

var _Swipe = _interopRequireDefault(require("../Swipe"));

var _addPx = _interopRequireDefault(require("../utils/addPx"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _withTheme = require("../utils/withTheme");

var _useTabsContainer2 = _interopRequireDefault(require("./useTabsContainer"));

var _excluded = ["type", "size", "htmlType", "disabled", "busy", "component", "children", "prefixNode", "suffixNode", "onClick"],
    _excluded2 = ["children", "onChange", "height", "size", "type", "swipe", "selectedIndex", "enableDiffChildren", "equalNum", "gutter", "duration"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var InnerButton = (0, _styledComponents["default"])(_IconButton["default"]).withConfig({
  displayName: "InnerButton"
})([""]);
var StyledSwipe = (0, _styledComponents["default"])(_Swipe["default"]).withConfig({
  displayName: "StyledSwipe"
})(["z-index:1;"]);

var BaseNode = _styledComponents["default"].div.withConfig({
  displayName: "BaseNode"
})([""]);

var ButtonContainerPure = (0, _memoForwardRef["default"])(function (props, ref) {
  var type = props.type,
      size = props.size,
      htmlType = props.htmlType,
      disabled = props.disabled,
      busy = props.busy,
      asProp = props.component,
      children = props.children,
      prefixNode = props.prefixNode,
      suffixNode = props.suffixNode,
      onClick = props.onClick,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  return /*#__PURE__*/_react["default"].createElement(BaseNode, (0, _extends2["default"])({}, otherProps, {
    ref: ref
  }), /*#__PURE__*/_react["default"].createElement(InnerButton, {
    onClick: onClick,
    busy: busy
  }, children));
});
var ButtonContainer = (0, _styledComponents["default"])(ButtonContainerPure).withConfig({
  displayName: "ButtonContainer"
})(["", ""], function (props) {
  var theme = props.theme,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      type = props.type;
  var token = theme.components.Tabs;
  var height = type === 'line' ? token.height[size] : token.card.height[size];
  var padding = token.padding[size];
  var paddingCss;

  if (type === 'line' && padding) {
    paddingCss = (0, _styledComponents.css)(["padding:", ";"], padding);
  }

  return (0, _styledComponents.css)(["& ", "{width:", "px;min-height:", ";align-items:center;justify-content:center;", "}"], InnerButton, height, (0, _addPx["default"])(height), paddingCss);
});
var TabsContainerPure = (0, _memoForwardRef["default"])(function (props, ref) {
  var children = props.children,
      onChange = props.onChange,
      height = props.height,
      _props$size2 = props.size,
      size = _props$size2 === void 0 ? 'm' : _props$size2,
      type = props.type,
      swipe = props.swipe,
      selectedIndex = props.selectedIndex,
      enableDiffChildren = props.enableDiffChildren,
      equalNum = props.equalNum,
      gutter = props.gutter,
      duration = props.duration,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded2);

  var _useTabsContainer = (0, _useTabsContainer2["default"])({
    swipe: !!swipe,
    selectedIndex: selectedIndex,
    onChange: onChange
  }),
      onPrev = _useTabsContainer.onPrev,
      onNext = _useTabsContainer.onNext,
      onStepsChange = _useTabsContainer.onStepsChange,
      hasNext = _useTabsContainer.hasNext,
      hasPrev = _useTabsContainer.hasPrev,
      stepIndex = _useTabsContainer.stepIndex,
      onTransitionEnd = _useTabsContainer.onTransitionEnd;

  var theme = (0, _useTheme["default"])();
  var imgPool = (0, _react.useContext)(_ImgPoolContext["default"]);
  var swipable = hasNext || hasPrev;
  var token = theme.components.Tabs;
  var tokenIcon = (0, _extends2["default"])({
    prev: _LeftIcon2.LeftIcon,
    next: _RightIcon2.RightIcon
  }, token.icon);
  var PrevIcon = tokenIcon.prev;
  var NextIcon = tokenIcon.next;
  var iconSize = token.iconSize[size];
  var iconStyle = {
    width: iconSize,
    height: iconSize
  };
  var offSwipe = !swipe;
  var prevBtn = swipable && !offSwipe ? /*#__PURE__*/_react["default"].createElement(ButtonContainer, {
    size: size,
    theme: theme,
    type: type,
    onClick: onPrev,
    busy: !hasPrev
  }, /*#__PURE__*/_react["default"].createElement(PrevIcon, {
    style: iconStyle
  })) : null;
  var nextBtn = swipable && !offSwipe ? /*#__PURE__*/_react["default"].createElement(ButtonContainer, {
    size: size,
    theme: theme,
    type: type,
    onClick: onNext,
    busy: !hasNext
  }, /*#__PURE__*/_react["default"].createElement(NextIcon, {
    style: iconStyle
  })) : null;
  var innerChildren = children;

  if (!offSwipe) {
    var swipeProps = {
      enableDiffChildren: enableDiffChildren,
      equalNum: equalNum,
      gutter: gutter,
      duration: duration
    };
    innerChildren = /*#__PURE__*/_react["default"].createElement(StyledSwipe, (0, _extends2["default"])({}, swipeProps, {
      onTransitionEnd: onTransitionEnd,
      onStepsChange: onStepsChange,
      stepIndex: stepIndex
    }), children);
  }
  /**
   * 左右箭头是计算得到的，因此容器尺寸可能会出现变化，如果 swipable 变为了 true，那么需要出发一次 resize，使得 swipe 重新计算尺寸
   */


  (0, _react.useEffect)(function () {
    if (swipe && swipable) {
      imgPool.throttleCheck({
        type: 'resize'
      });
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [swipable]);
  return /*#__PURE__*/_react["default"].createElement(BaseNode, (0, _extends2["default"])({}, otherProps, {
    ref: ref
  }), prevBtn, innerChildren, nextBtn);
}); // margin 和 padding 使 badge 不会被 overflow 裁掉

var TabsContainer = (0, _styledComponents["default"])(TabsContainerPure).withConfig({
  displayName: "TabsContainer"
})(["display:flex;flex-wrap:nowrap;white-space:nowrap;align-items:center;flex:1;overflow:hidden;z-index:1;", ""], function (props) {
  var height = props.height,
      _props$type = props.type,
      type = _props$type === void 0 ? 'line' : _props$type,
      theme = props.theme,
      _props$size3 = props.size,
      size = _props$size3 === void 0 ? 'm' : _props$size3,
      enableBadge = props.enableBadge,
      vertical = props.vertical;
  var components = theme.components;
  var token = components.Tabs;
  var calcCss;
  var barCss;
  var badgePatchCss;
  var verticalCss;

  if (height) {
    calcCss = (0, _styledComponents.css)(["height:", "px;align-items:center;"], height);
  }

  if (type === 'capsule') {
    barCss = (0, _styledComponents.css)(["background:", ";padding:", ";border-radius:", ";"], token.capsule.bgColor, token.capsule.bgPadding[size], token.capsule.radius[size]);
  }

  if (enableBadge) {
    badgePatchCss = (0, _styledComponents.css)(["padding-top:20px;margin-top:-20px;"]);
  }

  if (vertical) {
    verticalCss = (0, _styledComponents.css)(["flex-direction:column;"]);
  }

  return (0, _styledComponents.css)(["", " ", " ", " ", ""], verticalCss, badgePatchCss, calcCss, barCss);
});

var _default = (0, _withTheme.withThemeForStyled)(TabsContainer);

exports["default"] = _default;