"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _CloseIcon2 = require("@muya-ui/theme-light/lib/icons/CloseIcon");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Animation = _interopRequireDefault(require("../Animation"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useAdjustMiniFont = _interopRequireDefault(require("../utils/useAdjustMiniFont"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _withTheme = require("../utils/withTheme");

var _styled = require("./styled");

var _excluded = ["visible", "closable", "children", "color", "shape", "size", "bordered", "colorInverse", "disabled", "borderColor", "maxWidth", "styles", "onClick", "onClose"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var BaseNode = _styledComponents["default"].span.withConfig({
  displayName: "BaseNode"
})([""]);

var defaultStyles = {
  childrenWrapper: '',
  closeIcon: ''
};
var PureTag = (0, _memoForwardRef["default"])(function (props, ref) {
  var _props$visible = props.visible,
      visible = _props$visible === void 0 ? true : _props$visible,
      closable = props.closable,
      children = props.children,
      color = props.color,
      shape = props.shape,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      bordered = props.bordered,
      colorInverse = props.colorInverse,
      disabled = props.disabled,
      borderColor = props.borderColor,
      maxWidth = props.maxWidth,
      styles = props.styles,
      onClick = props.onClick,
      onClose = props.onClose,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var token = theme.components.Tag;
  var isVisibleControlled = ('visible' in props);
  var fontSize = token.fontSize[size];
  var textRef = (0, _react.useRef)(null);
  var _theme$components$Tag = theme.components.Tag.closeIcon,
      CloseIcon = _theme$components$Tag === void 0 ? _CloseIcon2.CloseIcon : _theme$components$Tag;

  var _useState = (0, _react.useState)(visible),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      visibleState = _useState2[0],
      setVisibleState = _useState2[1];

  (0, _useAdjustMiniFont["default"])(textRef, fontSize);
  var innerStyles = (0, _useStyles["default"])('tag', defaultStyles, styles);
  var handleClick = (0, _react.useCallback)(function (e) {
    if (!disabled) {
      if (onClick) {
        onClick(e);
      }
    } else {
      e.preventDefault();
    }
  }, [disabled, onClick]);
  var handleCloseIconClick = (0, _react.useCallback)(function (e) {
    e.stopPropagation();

    if (!disabled) {
      /* istanbul ignore else */
      if (onClose) {
        onClose(e);
      }

      if (e.defaultPrevented) {
        return;
      }
      /* istanbul ignore else */


      if (!isVisibleControlled) {
        setVisibleState(false);
      }
    } else {
      e.preventDefault();
    }
  }, [disabled, isVisibleControlled, onClose]);
  var handleEntered = (0, _react.useCallback)(function (node) {
    /* istanbul ignore next */
    if (node && node.style) {
      node.style.display = '';
    }
  }, []);
  var handleExited = (0, _react.useCallback)(function (node) {
    /* istanbul ignore next */
    if (node && node.style) {
      node.style.display = 'none';
    }
  }, []);

  if (isVisibleControlled && visible !== visibleState) {
    setVisibleState(visible);
  }

  var TagNode = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement(BaseNode, (0, _extends2["default"])({
      ref: ref,
      onClick: handleClick
    }, restProps), /*#__PURE__*/_react["default"].createElement(_styled.StyledTagText, (0, _extends2["default"])({
      ref: textRef
    }, innerStyles.childrenWrapper), children), closable && /*#__PURE__*/_react["default"].createElement(_styled.StyledCloseIcon, (0, _extends2["default"])({}, innerStyles.closeIcon, {
      theme: theme,
      $size: size,
      $color: color,
      $colorInverse: colorInverse
    }), /*#__PURE__*/_react["default"].createElement(CloseIcon, {
      onClick: handleCloseIconClick
    })));
  }, [children, closable, color, colorInverse, handleClick, handleCloseIconClick, innerStyles.childrenWrapper, innerStyles.closeIcon, ref, restProps, size, theme]);

  if (disabled) {
    return TagNode;
  }

  return /*#__PURE__*/_react["default"].createElement(_Animation["default"].Fade, {
    "in": visibleState,
    onEntered: handleEntered,
    onExited: handleExited
  }, TagNode);
});
var Tag = (0, _styledComponents["default"])(PureTag).withConfig({
  displayName: "Tag"
})(["", ";"], _styled.tagCss);

var _default = (0, _withTheme.withThemeForStyled)(Tag);

exports["default"] = _default;