"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tagCss = exports.StyledTagText = exports.StyledCloseIcon = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _ellipsis = _interopRequireDefault(require("../styled/mixins/ellipsis"));

var _utils = require("./utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/* stylelint-disable no-descending-specificity */
var StyledTagText = _styledComponents["default"].span.withConfig({
  displayName: "StyledTagText"
})([""]); // eslint-disable-next-line complexity


exports.StyledTagText = StyledTagText;

var tagCss = function tagCss(originalProps) {
  var props = (0, _utils.mergeProps)(originalProps);
  var _props$theme = props.theme,
      colorsPattern = _props$theme.colors.pattern,
      transitionPattern = _props$theme.transition.pattern,
      token = _props$theme.components.Tag,
      opacityPattern = _props$theme.opacity.pattern;
  var _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      borderColor = props.borderColor,
      _props$bordered = props.bordered,
      bordered = _props$bordered === void 0 ? token.defaultBordered : _props$bordered,
      _props$closable = props.closable,
      closable = _props$closable === void 0 ? false : _props$closable,
      _props$shape = props.shape,
      shape = _props$shape === void 0 ? token.defaultShape : _props$shape,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      color = props.color,
      _props$colorInverse = props.colorInverse,
      colorInverse = _props$colorInverse === void 0 ? true : _props$colorInverse,
      maxWidth = props.maxWidth,
      _props$hoverable = props.hoverable,
      hoverable = _props$hoverable === void 0 ? true : _props$hoverable,
      type = props.type;
  var clickable = 'onClick' in props || 'onChange' in props;
  var fontSize = token.fontSize[size];
  var lineHeight = token.lineHeight[size];
  var inverseColor = color ? colorInverse : type !== 'normal';
  var colorSchema = type === 'mask' ? token.maskBg.base : token.typeColor[type];
  var borderStyle;
  var disabledStyle;
  var hoverStyle;
  var maskStyle;

  if (bordered) {
    borderStyle = (0, _styledComponents.css)(["border:1px solid ", ";"], borderColor || colorsPattern.border.normal);
  }

  if (disabled) {
    disabledStyle = (0, _styledComponents.css)(["cursor:default;opacity:", ";"], opacityPattern.disabled);
  } else if (hoverable) {
    hoverStyle = (0, _styledComponents.css)(["&:hover{color:", ";background-color:", ";opacity:", ";}a:hover{color:", ";}"], inverseColor ? token.color.inverse : token.color.plain, color || colorSchema.hover, inverseColor ? token.inverseHoverOpacity : 1, token.color.hover);
  }

  if (type === 'mask') {
    var maskHoverStyle = (0, _styledComponents.css)(["&:hover{color:", ";background-color:", ";}"], token.maskColor.base.hover, token.maskBg.base.hover);

    var _disabledStyle = (0, _styledComponents.css)(["opacity:", ";"], opacityPattern.disabled);

    maskStyle = (0, _styledComponents.css)(["color:", ";background-color:", ";", ";", ";"], token.maskColor.base.normal, token.maskBg.base.normal, !disabled && hoverable ? maskHoverStyle : '', disabled ? _disabledStyle : '');
  }

  return (0, _styledComponents.css)(["box-sizing:border-box;display:inline-flex;align-items:center;max-width:", ";color:", ";background-color:", ";transition:all ", "ms ", ";padding:0 ", "px;margin-right:", "px;font-size:", "px;line-height:", "px;height:", "px;white-space:nowrap;border-radius:", ";cursor:", ";vertical-align:middle;", "{", ";}", ";", ";", ";", ";"], maxWidth ? "".concat(maxWidth, "px") : 'none', inverseColor ? token.color.inverse : token.color.plain, color || colorSchema.normal, transitionPattern.duration.status, transitionPattern.easing.status, token.paddingHorizontal[shape][size], token.marginRight, fontSize, lineHeight, token.height[size], shape === 'rect' && token.rectBorderRadius ? token.rectBorderRadius[size] : token.borderRadius[shape], clickable ? 'pointer' : 'default', StyledTagText, _ellipsis["default"], borderStyle, !closable && hoverStyle, disabledStyle, maskStyle);
};

exports.tagCss = tagCss;

var closeIconCss = function closeIconCss(props) {
  var $size = props.$size,
      $color = props.$color,
      $colorInverse = props.$colorInverse,
      _props$theme2 = props.theme,
      colorsPattern = _props$theme2.colors.pattern,
      transitionPattern = _props$theme2.transition.pattern,
      token = _props$theme2.components.Tag;
  var inverseColor = !!$color && $colorInverse;
  var colorCss = (0, _styledComponents.css)(["color:", ";&:hover{color:", ";}&:active{color:", ";}"], colorsPattern.icon.normal, colorsPattern.icon.hover, colorsPattern.icon.click);

  if (inverseColor) {
    colorCss = (0, _styledComponents.css)(["color:", ";"], colorsPattern.icon.inverse);
  }

  return (0, _styledComponents.css)(["margin-left:", "px;cursor:pointer;transition:all ", "ms ", ";flex-shrink:0;display:inline-flex;width:", "px;height:", "px;", ";svg{width:", "px;height:", "px;}"], token.iconSpacing[$size], transitionPattern.duration.status, transitionPattern.easing.status, token.iconSize[$size], token.iconSize[$size], colorCss, token.iconSize[$size], token.iconSize[$size]);
};

var StyledCloseIcon = _styledComponents["default"].span.withConfig({
  displayName: "StyledCloseIcon"
})(["", ";"], closeIconCss);

exports.StyledCloseIcon = StyledCloseIcon;