"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mergeProps = mergeProps;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

/**
 * Tag重构后新增props type，与之前的部分props不兼容，进行合并处理
 *
 * @export
 * @param {IAllTagProps} props
 * @return {IAllTagProps}
 */
function mergeProps(props) {
  // 如果传入了 type 就无视 color、border props
  if (props.type) {
    return (0, _extends2["default"])({}, props, {
      color: undefined,
      bordered: undefined,
      borderColor: undefined
    });
  } else {
    return (0, _extends2["default"])({}, props, {
      type: 'normal'
    });
  }
}