"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _ClockIcon2 = require("@muya-ui/theme-light/lib/icons/ClockIcon");

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _PopPanel = require("../styled/components/PopPanel");

var _SuffixIcon = require("../styled/components/SuffixIcon");

var _Trigger = _interopRequireDefault(require("../Trigger"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _TimePickerPanel = _interopRequireDefault(require("./TimePickerPanel"));

var _useTimePicker2 = _interopRequireDefault(require("./useTimePicker"));

var _excluded = ["value", "defaultValue", "format", "onChange", "allowClear", "options", "styles", "defaultScrollBehavior", "hourStep", "minuteStep", "secondStep", "disabledHours", "disabledMinutes", "disabledSeconds", "hideDisabledOptions", "disableTimeAfter", "disableTimeBefore", "disabled", "onFocus", "onClear", "onPressEnter", "inputRef", "readOnly", "inputReadOnly", "popperProps", "flip", "arrowPointAtCenter", "placement", "triggerId"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var triggerActions = ['click'];
var defaultStyles = {
  popPanel: '',
  footer: '',
  panel: ''
};
var TimePicker = (0, _memoForwardRef["default"])(function (props, ref) {
  var value = props.value,
      defaultValue = props.defaultValue,
      format = props.format,
      onChange = props.onChange,
      _props$allowClear = props.allowClear,
      allowClear = _props$allowClear === void 0 ? true : _props$allowClear,
      options = props.options,
      styles = props.styles,
      defaultScrollBehavior = props.defaultScrollBehavior,
      hourStep = props.hourStep,
      minuteStep = props.minuteStep,
      secondStep = props.secondStep,
      disabledHours = props.disabledHours,
      disabledMinutes = props.disabledMinutes,
      disabledSeconds = props.disabledSeconds,
      hideDisabledOptions = props.hideDisabledOptions,
      disableTimeAfter = props.disableTimeAfter,
      disableTimeBefore = props.disableTimeBefore,
      disabled = props.disabled,
      onFocus = props.onFocus,
      onClear = props.onClear,
      onPressEnter = props.onPressEnter,
      inputRef = props.inputRef,
      readOnly = props.readOnly,
      inputReadOnly = props.inputReadOnly,
      popperProps = props.popperProps,
      flip = props.flip,
      arrowPointAtCenter = props.arrowPointAtCenter,
      placement = props.placement,
      triggerId = props.triggerId,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var innerInputRef = (0, _react.useRef)(null);
  var handleInputRef = (0, _useForkRef2.useForkRef)(innerInputRef, inputRef);
  var InputIcon = theme.components.TimePicker.inputIcon || _ClockIcon2.ClockIcon;
  var innerSuffixNode = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement(_SuffixIcon.StyledSuffixIcon, {
      theme: theme
    }, /*#__PURE__*/_react["default"].createElement(InputIcon, null));
  }, [theme]);

  var _useTimePicker = (0, _useTimePicker2["default"])(props, innerInputRef),
      finalPopupOpen = _useTimePicker.finalPopupOpen,
      finalValue = _useTimePicker.finalValue,
      stateDate = _useTimePicker.stateDate,
      finalOptions = _useTimePicker.finalOptions,
      handleClear = _useTimePicker.handleClear,
      handleFocus = _useTimePicker.handleFocus,
      handleInputChange = _useTimePicker.handleInputChange,
      handleClickAway = _useTimePicker.handleClickAway,
      handlePressEnter = _useTimePicker.handlePressEnter,
      handlePanelChange = _useTimePicker.handlePanelChange;

  var inputProps = {
    allowClear: allowClear,
    disabled: disabled,
    theme: theme,
    ref: ref,
    clearReplace: true,
    focusWhenClear: false,
    readOnly: readOnly || inputReadOnly
  };
  var inputStyles = (0, _react.useMemo)(function () {
    if (!styles) {
      return;
    }

    var inputWrapper = styles.inputWrapper,
        input = styles.input,
        nodeDivider = styles.nodeDivider,
        nodeWrapper = styles.nodeWrapper,
        clearWrapper = styles.clearWrapper,
        statusWrapper = styles.statusWrapper;
    return {
      inputWrapper: inputWrapper,
      input: input,
      nodeDivider: nodeDivider,
      nodeWrapper: nodeWrapper,
      clearWrapper: clearWrapper,
      statusWrapper: statusWrapper
    };
  }, [styles]);

  var realNode = /*#__PURE__*/_react["default"].createElement(_styled.StyledInput, (0, _extends2["default"])({
    inputRef: handleInputRef,
    value: finalValue,
    suffixNode: innerSuffixNode,
    onChange: handleInputChange,
    onFocus: handleFocus,
    onClear: handleClear,
    onPressEnter: handlePressEnter,
    styles: inputStyles
  }, inputProps, otherProps));

  var currentStyles = (0, _react.useMemo)(function () {
    if (!styles) {
      return;
    }

    var popPanel = styles.popPanel,
        footer = styles.footer,
        panel = styles.panel;
    return {
      popPanel: popPanel,
      footer: footer,
      panel: panel
    };
  }, [styles]);
  var footerStyles = (0, _react.useMemo)(function () {
    if (!styles) {
      return;
    }

    var footerOption = styles.footerOption;
    return {
      footerOption: footerOption
    };
  }, [styles]);
  var innerStyles = (0, _useStyles["default"])('time-picker', defaultStyles, currentStyles);

  if (disabled || readOnly) {
    return realNode;
  }

  var panelProps = {
    hourStep: hourStep,
    minuteStep: minuteStep,
    secondStep: secondStep,
    disabledHours: disabledHours,
    disabledMinutes: disabledMinutes,
    disabledSeconds: disabledSeconds,
    disableTimeAfter: disableTimeAfter,
    disableTimeBefore: disableTimeBefore,
    hideDisabledOptions: hideDisabledOptions,
    format: format,
    styles: styles,
    defaultScrollBehavior: defaultScrollBehavior
  };

  var panelNode = /*#__PURE__*/_react["default"].createElement(_PopPanel.StyledPopPanel, (0, _extends2["default"])({
    theme: theme
  }, innerStyles.popPanel), /*#__PURE__*/_react["default"].createElement(_TimePickerPanel["default"], (0, _extends2["default"])({}, innerStyles.panel, {
    value: stateDate,
    onChange: handlePanelChange
  }, panelProps)), finalOptions && finalOptions.length && /*#__PURE__*/_react["default"].createElement(_styled.StyledFooter, (0, _extends2["default"])({}, innerStyles.footer, {
    options: finalOptions,
    styles: footerStyles
  })));

  var triggerProps = {
    placement: placement,
    triggerActions: triggerActions,
    popperProps: popperProps,
    arrowPointAtCenter: arrowPointAtCenter,
    triggerId: triggerId,
    flip: flip,
    hideArrow: true
  };
  return /*#__PURE__*/_react["default"].createElement(_Trigger["default"], (0, _extends2["default"])({
    popup: panelNode,
    open: finalPopupOpen,
    onClickAway: handleClickAway
  }, triggerProps), realNode);
});
TimePicker.__MUYA_TIMEPICKER = true;
var _default = TimePicker;
exports["default"] = _default;