"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _padStart2 = _interopRequireDefault(require("lodash/padStart"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _styled = require("../ScrollView/styled");

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _mergeStyleItem = _interopRequireDefault(require("../utils/mergeStyleItem"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _useTimePickerNumberList = _interopRequireDefault(require("./useTimePickerNumberList"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledRow = _styledComponents["default"].div.withConfig({
  displayName: "StyledRow"
})([""]);

var StyledLabel = _styledComponents["default"].div.withConfig({
  displayName: "StyledLabel"
})([""]);

var StyledItem = _styledComponents["default"].div.withConfig({
  displayName: "StyledItem"
})(["", ""], function (_ref) {
  var theme = _ref.theme,
      $disabled = _ref.$disabled,
      _ref$$selected = _ref.$selected,
      $selected = _ref$$selected === void 0 ? false : _ref$$selected;
  var token = theme.components.TimePicker;
  var itemCss;

  if ($disabled) {
    itemCss = (0, _styledComponents.css)(["color:", ";cursor:not-allowed;"], token.itemColor.disabled);
  } else if ($selected) {
    itemCss = (0, _styledComponents.css)(["background-color:", ";color:", ";border-radius:", ";"], token.itemBg.selected, token.itemColor.selected, theme.size.spec.borderRadius.s1);
  } else {
    itemCss = (0, _styledComponents.css)(["color:", ";cursor:pointer;border-radius:", ";&:hover{background-color:", ";}&:active{color:", ";background-color:", ";}"], token.itemColor.normal, theme.size.spec.borderRadius.s1, token.itemBg.hover, token.itemColor.clicked, token.itemBg.clicked);
  }

  return (0, _styledComponents.css)(["height:", "px;width:", "px;line-height:", "px;", ""], token.itemHeight, token.itemWidth, token.itemHeight, itemCss);
});

var StyledScrollContainer = _styledComponents["default"].div.withConfig({
  displayName: "StyledScrollContainer"
})([""]);

var BaseNode = _styledComponents["default"].div.withConfig({
  displayName: "BaseNode"
})(["", ""], function (_ref2) {
  var theme = _ref2.theme,
      $number = _ref2.$number;
  var token = theme.components.TimePicker;
  var pattern = theme.colors.pattern;
  var scrollHeight = token.rowHeight * $number;
  var scrollPaddingBottom = token.rowHeight * ($number - 1);
  return (0, _styledComponents.css)(["text-align:center;user-select:none;flex:1;font-size:", "px;", "{height:", "px;line-height:", "px;color:", ";}", "{height:", "px;display:flex;justify-content:center;align-items:center;}", "{box-sizing:border-box;height:", "px;overflow-y:auto;padding:0 4px ", "px;", "}"], theme.typography.spec.fontSize.s1, StyledLabel, token.rowHeight, token.rowHeight, pattern.text.secondary, StyledRow, token.rowHeight, StyledScrollContainer, scrollHeight, scrollPaddingBottom, (0, _styled.scrollBarStyle)({
    theme: theme
  }));
});

var defaultStyles = {
  colItem: '',
  colLabel: '',
  colItemBlock: '',
  colItemSelected: '',
  colItemDisabled: ''
};
var TimePickerNumberList = (0, _memoForwardRef["default"])(function (props, ref) {
  var theme = (0, _useTheme["default"])();

  var _useTimePickerNumberL = (0, _useTimePickerNumberList["default"])(props),
      otherProps = _useTimePickerNumberL.otherProps,
      items = _useTimePickerNumberL.items,
      scrollContainerRef = _useTimePickerNumberL.scrollContainerRef,
      rowNum = _useTimePickerNumberL.rowNum;

  var pickStyles = (0, _react.useMemo)(function () {
    if (!props.styles) {
      return;
    }

    var _props$styles = props.styles,
        colLabel = _props$styles.colLabel,
        colItem = _props$styles.colItem,
        colItemBlock = _props$styles.colItemBlock,
        colItemSelected = _props$styles.colItemSelected,
        colItemDisabled = _props$styles.colItemDisabled;
    return {
      colLabel: colLabel,
      colItem: colItem,
      colItemBlock: colItemBlock,
      colItemSelected: colItemSelected,
      colItemDisabled: colItemDisabled
    };
  }, [props.styles]);
  var innerStyles = (0, _useStyles["default"])('time-picker', defaultStyles, pickStyles);
  var nodes = (0, _react.useMemo)(function () {
    return items.map(function (item) {
      var itemText = (0, _padStart2["default"])(item.num.toString(), 2, '0');
      var innerStyleItem = innerStyles.colItemBlock;

      if (item.isSelected) {
        innerStyleItem = (0, _mergeStyleItem["default"])(innerStyles.colItemBlock, innerStyles.colItemSelected);
      } else if (item.disabled) {
        innerStyleItem = (0, _mergeStyleItem["default"])(innerStyles.colItemBlock, innerStyles.colItemDisabled);
      }

      return /*#__PURE__*/_react["default"].createElement(StyledRow, (0, _extends2["default"])({}, innerStyles.colItem, {
        key: item.num,
        ref: item.itemRef
      }), /*#__PURE__*/_react["default"].createElement(StyledItem, (0, _extends2["default"])({}, innerStyleItem, {
        theme: theme,
        $selected: item.isSelected,
        $disabled: item.disabled,
        onClick: item.handleClick
      }), itemText));
    });
  }, [innerStyles.colItem, innerStyles.colItemBlock, innerStyles.colItemDisabled, innerStyles.colItemSelected, items, theme]);
  return /*#__PURE__*/_react["default"].createElement(BaseNode, (0, _extends2["default"])({
    ref: ref,
    theme: theme,
    $number: rowNum
  }, otherProps), /*#__PURE__*/_react["default"].createElement(StyledLabel, innerStyles.colLabel, props.label), /*#__PURE__*/_react["default"].createElement(StyledScrollContainer, {
    ref: scrollContainerRef
  }, nodes));
});
var _default = TimePickerNumberList;
exports["default"] = _default;