"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _useLocale2 = _interopRequireDefault(require("../Locale/useLocale"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _TimePickerNumberList = _interopRequireDefault(require("./TimePickerNumberList"));

var _useTimePickerPanel2 = _interopRequireDefault(require("./useTimePickerPanel"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledPanel = _styledComponents["default"].div.withConfig({
  displayName: "StyledPanel"
})(["", ""], function (props) {
  var token = props.theme.components.TimePicker;
  var pattern = props.theme.colors.pattern;
  return (0, _styledComponents.css)(["width:", "px;display:flex;justify-content:center;background-color:", ";padding:", ";"], token.width, pattern.background.higher, token.panelPadding);
});

var defaultStyles = {
  hourCol: '',
  minuteCol: '',
  secondCol: ''
};
var TimePickerPanel = (0, _memoForwardRef["default"])(function (props, ref) {
  var theme = (0, _useTheme["default"])();

  var _useTimePickerPanel = (0, _useTimePickerPanel2["default"])(props),
      otherProps = _useTimePickerPanel.otherProps,
      selectedHour = _useTimePickerPanel.selectedHour,
      selectedMinute = _useTimePickerPanel.selectedMinute,
      selectedSecond = _useTimePickerPanel.selectedSecond,
      disabledHours = _useTimePickerPanel.disabledHours,
      disabledMinutes = _useTimePickerPanel.disabledMinutes,
      disabledSeconds = _useTimePickerPanel.disabledSeconds,
      hideDisabledOptions = _useTimePickerPanel.hideDisabledOptions,
      showMinute = _useTimePickerPanel.showMinute,
      showSecond = _useTimePickerPanel.showSecond,
      hourStep = _useTimePickerPanel.hourStep,
      minuteStep = _useTimePickerPanel.minuteStep,
      secondStep = _useTimePickerPanel.secondStep,
      rowNum = _useTimePickerPanel.rowNum,
      styles = _useTimePickerPanel.styles,
      defaultScrollBehavior = _useTimePickerPanel.defaultScrollBehavior,
      handleHourChange = _useTimePickerPanel.handleHourChange,
      handleMinuteChange = _useTimePickerPanel.handleMinuteChange,
      handleSecondChange = _useTimePickerPanel.handleSecondChange;

  var pickStyles = (0, _react.useMemo)(function () {
    if (!styles) {
      return;
    }

    var hourCol = styles.hourCol,
        minuteCol = styles.minuteCol,
        secondCol = styles.secondCol;
    return {
      hourCol: hourCol,
      minuteCol: minuteCol,
      secondCol: secondCol
    };
  }, [styles]);
  var innerStyles = (0, _useStyles["default"])('time-picker', defaultStyles, pickStyles);

  var _useLocale = (0, _useLocale2["default"])(),
      hourLabel = _useLocale['TimePicker.hour'],
      minuteLabel = _useLocale['TimePicker.minute'],
      secondLabel = _useLocale['TimePicker.second'];

  return /*#__PURE__*/_react["default"].createElement(StyledPanel, (0, _extends2["default"])({
    ref: ref,
    theme: theme
  }, otherProps), /*#__PURE__*/_react["default"].createElement(_TimePickerNumberList["default"], (0, _extends2["default"])({}, innerStyles.hourCol, {
    label: hourLabel,
    max: 23,
    rowNum: rowNum,
    step: hourStep,
    selected: selectedHour,
    disableNum: disabledHours,
    hideDisabledNum: hideDisabledOptions,
    onChange: handleHourChange,
    styles: styles,
    defaultScrollBehavior: defaultScrollBehavior
  })), showMinute && /*#__PURE__*/_react["default"].createElement(_TimePickerNumberList["default"], (0, _extends2["default"])({}, innerStyles.minuteCol, {
    label: minuteLabel,
    rowNum: rowNum,
    step: minuteStep,
    selected: selectedMinute,
    disableNum: disabledMinutes,
    hideDisabledNum: hideDisabledOptions,
    onChange: handleMinuteChange,
    styles: styles,
    defaultScrollBehavior: defaultScrollBehavior
  })), showSecond && /*#__PURE__*/_react["default"].createElement(_TimePickerNumberList["default"], (0, _extends2["default"])({}, innerStyles.secondCol, {
    label: secondLabel,
    rowNum: rowNum,
    step: secondStep,
    selected: selectedSecond,
    disableNum: disabledSeconds,
    hideDisabledNum: hideDisabledOptions,
    onChange: handleSecondChange,
    styles: styles,
    defaultScrollBehavior: defaultScrollBehavior
  })));
});
var _default = TimePickerPanel;
exports["default"] = _default;