"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.transformConfigType2Time = transformConfigType2Time;
exports.transformStr2Date = transformStr2Date;

var _dayjs = _interopRequireDefault(require("dayjs"));

var dateFormat = 'YYYY-MM-DD';
var numReg = /\d/;

function transformStr2Date(str, baseDate) {
  // 完全一个数字都没有，肯定不合法
  if (!numReg.test(str)) {
    return (0, _dayjs["default"])('');
  }

  var baseStr = '';

  if (baseDate.isValid()) {
    baseStr = baseDate.format(dateFormat);
  } else {
    baseStr = (0, _dayjs["default"])().format(dateFormat);
  }

  var newDate = (0, _dayjs["default"])("".concat(baseStr, " ").concat(str));
  return newDate;
}

function transformConfigType2Time(str, baseDate) {
  var onlyTime = false;
  var date = (0, _dayjs["default"])(str);

  if (!date.isValid() && typeof str === 'string' && str.length > 0) {
    var innerBaseDate = baseDate || (0, _dayjs["default"])();
    date = transformStr2Date(str, innerBaseDate);
    onlyTime = date.isValid();
  }

  return [date, onlyTime];
}