"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _TimelineItem = _interopRequireDefault(require("./TimelineItem"));

var _TimelineContext = _interopRequireDefault(require("./TimelineContext"));

var _mergeStyleItem = _interopRequireDefault(require("../utils/mergeStyleItem"));

var _excluded = ["mode", "children", "styles", "className", "style"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  wrapper: ''
};
var Timeline = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var theme = (0, _useTheme["default"])();
  var _props$mode = props.mode,
      mode = _props$mode === void 0 ? 'left' : _props$mode,
      children = props.children,
      styles = props.styles,
      className = props.className,
      style = props.style,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var timelineStyles = (0, _react.useMemo)(function () {
    if (styles) {
      var wrapper = styles.wrapper;
      return {
        wrapper: wrapper
      };
    }
  }, [styles]);
  var innerStyles = (0, _useStyles["default"])('timeline', defaultStyles, timelineStyles);
  var finalStyles = (0, _mergeStyleItem["default"])({
    className: className,
    style: style
  }, innerStyles.wrapper);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledTimeline, (0, _extends2["default"])({
    ref: ref,
    theme: theme,
    $mode: mode
  }, finalStyles, otherProps), /*#__PURE__*/_react["default"].createElement(_TimelineContext["default"].Provider, {
    value: {
      mode: mode
    }
  }, children));
});
Timeline.Item = _TimelineItem["default"];
var _default = Timeline;
exports["default"] = _default;