"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _react = _interopRequireWildcard(require("react"));

var _styled = require("./styled");

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _TimelineContext = require("./TimelineContext");

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _mergeStyleItem = _interopRequireDefault(require("../utils/mergeStyleItem"));

var _Background = _interopRequireDefault(require("../Background"));

var _excluded = ["color", "dot", "children", "date", "styles", "className", "style", "position"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  item: '',
  content: '',
  date: ''
};
var TimelineItem = (0, _memoForwardRef["default"])(function (props, ref) {
  var color = props.color,
      dot = props.dot,
      children = props.children,
      date = props.date,
      styles = props.styles,
      className = props.className,
      style = props.style,
      _props$position = props.position,
      position = _props$position === void 0 ? 'left' : _props$position,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var context = (0, _TimelineContext.useTimelineContext)();
  var mode = context.mode;
  var timelineStyles = (0, _react.useMemo)(function () {
    if (styles) {
      var item = styles.item,
          content = styles.content,
          _date = styles.date;
      return {
        item: item,
        content: content,
        date: _date
      };
    }
  }, [styles]);
  var innerStyles = (0, _useStyles["default"])('timeline', defaultStyles, timelineStyles);
  var finalStyles = (0, _mergeStyleItem["default"])({
    className: className,
    style: style
  }, innerStyles.item);
  var theme = (0, _useTheme["default"])();
  var token = theme.components.Timeline;
  var dotColor = color || token.dotColor;
  var dotNode = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement(_styled.StyledNodeContainer, {
      theme: theme
    }, dot ? /*#__PURE__*/_react["default"].createElement(_Background["default"], {
      display: "flex",
      height: "fit-content",
      style: {
        zIndex: 1
      }
    }, dot) : /*#__PURE__*/_react["default"].createElement(_styled.StyledDot, {
      theme: theme,
      $color: dotColor,
      $size: token.dotSize
    }), /*#__PURE__*/_react["default"].createElement(_styled.StyledLine, {
      theme: theme
    }));
  }, [dot, dotColor, theme, token.dotSize]);
  var contentNode = (0, _react.useMemo)(function () {
    if (mode === 'right') {
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_styled.StyledContentContainer, {
        theme: theme,
        $position: position,
        $mode: mode
      }, /*#__PURE__*/_react["default"].createElement(_styled.StyledDate, (0, _extends2["default"])({
        theme: theme
      }, innerStyles.date, {
        $position: position
      }), date), /*#__PURE__*/_react["default"].createElement(_styled.StyledContent, (0, _extends2["default"])({
        theme: theme
      }, innerStyles.content, {
        $position: position
      }), children)), dotNode);
    }

    if (mode === 'alternate-left') {
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_styled.StyledDate, (0, _extends2["default"])({
        theme: theme
      }, innerStyles.date, {
        $mode: mode
      }), date), dotNode, /*#__PURE__*/_react["default"].createElement(_styled.StyledContent, (0, _extends2["default"])({
        theme: theme
      }, innerStyles.content, {
        $mode: mode
      }), children));
    }

    if (mode === 'alternate-right') {
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_styled.StyledContent, (0, _extends2["default"])({
        theme: theme
      }, innerStyles.content, {
        $mode: mode
      }), children), dotNode, /*#__PURE__*/_react["default"].createElement(_styled.StyledDate, (0, _extends2["default"])({
        theme: theme
      }, innerStyles.date, {
        $mode: mode
      }), date));
    }

    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, dotNode, /*#__PURE__*/_react["default"].createElement(_styled.StyledContentContainer, {
      theme: theme,
      $position: position,
      $mode: mode
    }, /*#__PURE__*/_react["default"].createElement(_styled.StyledDate, (0, _extends2["default"])({
      theme: theme
    }, innerStyles.date, {
      $position: position
    }), date), /*#__PURE__*/_react["default"].createElement(_styled.StyledContent, (0, _extends2["default"])({
      theme: theme
    }, innerStyles.content, {
      $position: position
    }), children)));
  }, [children, date, dotNode, innerStyles.content, innerStyles.date, mode, position, theme]);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledTimelineItem, (0, _extends2["default"])({
    $mode: mode,
    theme: theme
  }, finalStyles, otherProps), contentNode);
});
var _default = TimelineItem;
exports["default"] = _default;