"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledTimelineItem = exports.StyledTimeline = exports.StyledNodeContainer = exports.StyledLine = exports.StyledDot = exports.StyledDate = exports.StyledContentContainer = exports.StyledContent = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var PositionDirectionEnum;

(function (PositionDirectionEnum) {
  PositionDirectionEnum["left"] = "row";
  PositionDirectionEnum["right"] = "row-reverse";
  PositionDirectionEnum["top"] = "column";
  PositionDirectionEnum["bottom"] = "column-reverse";
})(PositionDirectionEnum || (PositionDirectionEnum = {}));

var ModeAlignEnum;

(function (ModeAlignEnum) {
  ModeAlignEnum["left"] = "flex-start";
  ModeAlignEnum["right"] = "flex-end";
  ModeAlignEnum["alternate"] = "baseline";
  ModeAlignEnum["alternate-left"] = "stretch";
  ModeAlignEnum["alternate-right"] = "stretch";
})(ModeAlignEnum || (ModeAlignEnum = {}));

var StyledTimeline = _styledComponents["default"].div.withConfig({
  displayName: "StyledTimeline"
})(["", ""], function (props) {
  var _props$$mode = props.$mode,
      $mode = _props$$mode === void 0 ? 'left' : _props$$mode,
      _props$theme = props.theme,
      colors = _props$theme.colors,
      typography = _props$theme.typography;
  var alternateStyle = $mode === 'alternate' && (0, _styledComponents.css)(["margin-left:50%;"]);
  return (0, _styledComponents.css)(["display:flex;flex-direction:column;color:", ";font-size:", "px;line-height:", "px;align-items:", ";", ";& a{font-size:", "px;line-height:", "px;}"], colors.spec.neutral1.normal, typography.spec.fontSize.s1, typography.spec.lineHeight.s1, ModeAlignEnum[$mode], alternateStyle, typography.spec.fontSize.s1, typography.spec.lineHeight.s1);
});

exports.StyledTimeline = StyledTimeline;

var StyledNodeContainer = _styledComponents["default"].span.withConfig({
  displayName: "StyledNodeContainer"
})(["", ""], function (props) {
  var token = props.theme.components.Timeline;
  return (0, _styledComponents.css)(["position:relative;display:flex;justify-content:center;width:", "px;flex-shrink:0;"], token.dotSize + token.contentLeftMargin * 2);
});

exports.StyledNodeContainer = StyledNodeContainer;

var StyledDot = _styledComponents["default"].i.withConfig({
  displayName: "StyledDot"
})(["", ""], function (props) {
  var $color = props.$color,
      $size = props.$size,
      typography = props.theme.typography;
  var dotMargin = Math.floor((typography.spec.lineHeight.s1 - $size) / 2);
  return (0, _styledComponents.css)(["display:block;width:", "px;height:", "px;border-radius:50%;background-color:", ";margin-top:", "px;"], $size, $size, $color, dotMargin);
});

exports.StyledDot = StyledDot;

var StyledLine = _styledComponents["default"].span.withConfig({
  displayName: "StyledLine"
})(["", ""], function (props) {
  var _props$theme2 = props.theme,
      colors = _props$theme2.colors,
      typography = _props$theme2.typography,
      token = _props$theme2.components.Timeline;
  var dotMargin = Math.floor((typography.spec.lineHeight.s1 - token.dotSize) / 2);
  return (0, _styledComponents.css)(["position:absolute;top:", "px;display:block;width:", "px;height:calc(100% + ", "px);background-color:", ";"], token.dotSize + dotMargin, token.lineWidth, token.dotSize + dotMargin, colors.pattern.background.divider);
});

exports.StyledLine = StyledLine;

var StyledContentContainer = _styledComponents["default"].div.withConfig({
  displayName: "StyledContentContainer"
})(["", ""], function (props) {
  var _props$$position = props.$position,
      $position = _props$$position === void 0 ? 'left' : _props$$position,
      $mode = props.$mode;
  return (0, _styledComponents.css)(["display:flex;flex-direction:", ";text-align:", ";"], PositionDirectionEnum[$position], $mode);
});

exports.StyledContentContainer = StyledContentContainer;

function makeContentStyle(props) {
  var $position = props.$position,
      _props$$mode2 = props.$mode,
      $mode = _props$$mode2 === void 0 ? 'left' : _props$$mode2,
      token = props.theme.components.Timeline;
  var marginStyle = !$mode.includes('alternate') && ($position === 'left' ? (0, _styledComponents.css)(["&:not(:last-child){margin-right:", "px;}"], token.contentLeftMargin) : $position === 'right' ? (0, _styledComponents.css)(["&:not(:first-child){margin-right:", "px;}"], token.contentLeftMargin) : $position === 'top' ? (0, _styledComponents.css)(["&:not(:last-child){margin-bottom:", "px;}"], token.contentTopMargin) : (0, _styledComponents.css)(["&:not(:first-child){margin-bottom:", "px;}"], token.contentTopMargin));
  var widthStyle = ($mode === 'alternate-left' || $mode === 'alternate-right') && (0, _styledComponents.css)(["width:calc((100% - ", "px) / 2);"], token.dotSize + token.contentLeftMargin * 2);
  return (0, _styledComponents.css)(["", ";", ";"], marginStyle, widthStyle);
}

var StyledContent = _styledComponents["default"].div.withConfig({
  displayName: "StyledContent"
})(["", ""], function (props) {
  var $mode = props.$mode;
  var alignStyle = $mode === 'alternate-right' && (0, _styledComponents.css)(["text-align:right;"]);
  return (0, _styledComponents.css)(["", ";", ";"], makeContentStyle(props), alignStyle);
});

exports.StyledContent = StyledContent;

var StyledDate = _styledComponents["default"].div.withConfig({
  displayName: "StyledDate"
})(["", ""], function (props) {
  var $mode = props.$mode;
  var alignStyle = $mode === 'alternate-left' && (0, _styledComponents.css)(["text-align:right;"]);
  return (0, _styledComponents.css)(["", ";", ";flex-shrink:0;"], makeContentStyle(props), alignStyle);
});

exports.StyledDate = StyledDate;

var StyledTimelineItem = _styledComponents["default"].div.withConfig({
  displayName: "StyledTimelineItem"
})(["", ""], function (props) {
  var $mode = props.$mode,
      token = props.theme.components.Timeline;
  var alternateStyle = $mode === 'alternate' && (0, _styledComponents.css)(["&:nth-child(2n + 1) ", "{text-align:left;}&:nth-child(2n) ", "{transform:translateX(calc(-100% - ", "px));text-align:right;}"], StyledContentContainer, StyledContentContainer, token.dotSize + token.contentLeftMargin * 2);
  return (0, _styledComponents.css)(["position:relative;display:flex;padding:", "px 0;", ";&:last-child{", "{display:none;}}"], token.itemPadding, alternateStyle, StyledLine);
});

exports.StyledTimelineItem = StyledTimelineItem;