"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledTooltipWrapper = void 0;
exports.makeTooltipWrapperStyle = makeTooltipWrapperStyle;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Link = _interopRequireDefault(require("../Link"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function makeTooltipWrapperStyle(props) {
  var $size = props.$size,
      theme = props.theme;
  var _theme$typography$spe = theme.typography.spec,
      fontSize = _theme$typography$spe.fontSize,
      lineHeight = _theme$typography$spe.lineHeight;
  var _theme$components$Too = theme.components.Tooltip,
      color = _theme$components$Too.color,
      fontLevel = _theme$components$Too.fontLevel,
      padding = _theme$components$Too.padding,
      maxWidth = _theme$components$Too.maxWidth,
      boxShadow = _theme$components$Too.boxShadow,
      borderRadius = _theme$components$Too.borderRadius,
      linkColor = _theme$components$Too.linkColor;
  var level = fontLevel[$size];
  return (0, _styledComponents.css)(["color:", ";font-size:", "px;line-height:", "px;padding:", ";border-radius:", ";max-width:", "px;box-sizing:border-box;overflow:hidden;word-wrap:break-word;", " ", "{vertical-align:unset;}", ",a{color:", ";&:hover,&:active{color:", ";}}"], color, fontSize[level], lineHeight[level], padding[$size].map(function (p) {
    return "".concat(p, "px ");
  }), borderRadius[$size], maxWidth, boxShadow && "box-shadow: ".concat(boxShadow, ";"), _Link["default"], _Link["default"], linkColor, linkColor);
}

var StyledTooltipWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledTooltipWrapper"
})(["", ""], makeTooltipWrapperStyle);

exports.StyledTooltipWrapper = StyledTooltipWrapper;