"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _devWarning2 = require("@muya-ui/utils/lib/utils/devWarning");

var _isArray2 = _interopRequireDefault(require("lodash/isArray"));

var _react = _interopRequireWildcard(require("react"));

var _TransferPanel = _interopRequireDefault(require("./TransferPanel"));

var _styled = require("./styled");

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _TransferIcon = _interopRequireDefault(require("./TransferIcon"));

var _useTransfer2 = _interopRequireDefault(require("./useTransfer"));

var _useTransferTree = _interopRequireDefault(require("./useTransferTree"));

var _useStyles = require("../utils/useStyles");

var _Locale = require("../Locale");

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  container: '',
  leftPanel: '',
  rightPanel: '',
  leftHeader: '',
  rightHeader: '',
  leftFoot: '',
  rightFoot: ''
};

var TransferPure = function TransferPure(props, ref) {
  var theme = (0, _useTheme["default"])();
  var children = props.children,
      _props$targetSource = props.targetSource,
      targetSource = _props$targetSource === void 0 ? [] : _props$targetSource,
      defaultTargetSource = props.defaultTargetSource,
      dataSource = props.dataSource,
      transferIcon = props.transferIcon,
      _titles = props.titles,
      _mode = props.mode,
      _props$showSearch = props.showSearch,
      showSearch = _props$showSearch === void 0 ? false : _props$showSearch,
      onSearch = props.onSearch,
      _searchPlaceholder = props.searchPlaceholder,
      filterOption = props.filterOption,
      renderItem = props.renderItem,
      _props$footer = props.footer,
      footer = _props$footer === void 0 ? [] : _props$footer,
      _props$showCount = props.showCount,
      showCount = _props$showCount === void 0 ? true : _props$showCount,
      _props$showSelectAll = props.showSelectAll,
      showSelectAll = _props$showSelectAll === void 0 ? true : _props$showSelectAll,
      onChange = props.onChange,
      styles = props.styles,
      rightItemExtra = props.rightItemExtra,
      searchProps = props.searchProps,
      emptyNode = props.emptyNode,
      onCopyAll = props.onCopyAll,
      _props$headerExtraNod = props.headerExtraNode,
      headerExtraNode = _props$headerExtraNod === void 0 ? [] : _props$headerExtraNod,
      _props$order = props.order,
      order = _props$order === void 0 ? 'DESC' : _props$order,
      _props$panelRef = props.panelRef,
      panelRef = _props$panelRef === void 0 ? [] : _props$panelRef,
      _props$panelOnScroll = props.panelOnScroll,
      panelOnScroll = _props$panelOnScroll === void 0 ? [] : _props$panelOnScroll;
  var locale = (0, _Locale.useLocale)(); // 计算 mode
  // 如果自定义了children默认给copy,否则默认给move

  var mode = _react["default"].useMemo(function () {
    if (_mode) {
      return _mode;
    } else if (children && typeof children === 'function') {
      return 'copy';
    } else {
      return 'move';
    }
  }, [_mode, children]); // 计算titles


  var titles = _react["default"].useMemo(function () {
    if (_titles) {
      if ((0, _isArray2["default"])(_titles) && _titles.length === 2) {
        return _titles;
      } else {
        (0, _devWarning2.devWarning)('[Transer]titles 参数必须传入一个长度为2的数组');
        return [locale['Transer.list1'], locale['Transer.list2']];
      }
    } else {
      return [locale['Transer.list1'], locale['Transer.list2']];
    }
  }, [_titles, locale]); // 计算 searchPlaceholder


  var searchPlaceholder = _react["default"].useMemo(function () {
    var defaultSearchPlaceholder = locale['Transer.search'];

    if (_searchPlaceholder) {
      if ((0, _isArray2["default"])(_searchPlaceholder)) {
        var placeholderArr = _searchPlaceholder.map(function (item) {
          return item || defaultSearchPlaceholder;
        });

        return placeholderArr;
      } else if (typeof _searchPlaceholder === 'string') {
        return [_searchPlaceholder, _searchPlaceholder];
      } else {
        (0, _devWarning2.devWarning)('[Transer]searchPlaceholder 参数必须传入一个数组');
        return [defaultSearchPlaceholder, defaultSearchPlaceholder];
      }
    } else {
      return [defaultSearchPlaceholder, defaultSearchPlaceholder];
    }
  }, [_searchPlaceholder, locale]); // 计算左右emptyNode


  var _React$useMemo = _react["default"].useMemo(function () {
    var leftEmptyNode;
    var rightEmptyNode;

    if (emptyNode && Array.isArray(emptyNode)) {
      leftEmptyNode = emptyNode[0];
      rightEmptyNode = emptyNode[1];
    } else if ('emptyNode' in props) {
      leftEmptyNode = rightEmptyNode = emptyNode;
    }

    return [leftEmptyNode, rightEmptyNode];
  }, [emptyNode, props]),
      _React$useMemo2 = (0, _slicedToArray2["default"])(_React$useMemo, 2),
      leftEmptyNode = _React$useMemo2[0],
      rightEmptyNode = _React$useMemo2[1];

  var isControlled = !!('targetSource' in props);

  var _useTransfer = (0, _useTransfer2["default"])(dataSource, isControlled ? targetSource : defaultTargetSource || [], isControlled, mode, order, onChange),
      leftData = _useTransfer.leftData,
      rightData = _useTransfer.rightData,
      leftAction = _useTransfer.leftAction,
      rightAction = _useTransfer.rightAction,
      _leftActionCopyAll = _useTransfer.leftActionCopyAll;

  var leftActionCopyAll = typeof onCopyAll === 'function' ? onCopyAll : _leftActionCopyAll;
  var getPanelShowSearch = (0, _react.useCallback)(function (dir) {
    return showSearch === true || showSearch === dir;
  }, [showSearch]);
  var leftShowSearch = getPanelShowSearch('left');
  var rightShowSearch = getPanelShowSearch('right');
  var innerStyles = (0, _useStyles.useStyles)('transfer', defaultStyles, styles);
  var container = innerStyles.container,
      leftPanel = innerStyles.leftPanel,
      leftHeader = innerStyles.leftHeader,
      leftFoot = innerStyles.leftFoot,
      rightPanel = innerStyles.rightPanel,
      rightHeader = innerStyles.rightHeader,
      rightFoot = innerStyles.rightFoot;
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledTransfer, (0, _extends2["default"])({
    theme: theme,
    ref: ref
  }, container), /*#__PURE__*/_react["default"].createElement(_TransferPanel["default"], {
    title: titles[0],
    direction: "left",
    items: leftData,
    handleClick: leftAction,
    showSearch: leftShowSearch,
    onSearch: onSearch,
    searchPlaceholder: searchPlaceholder[0],
    filterOption: filterOption,
    renderItem: renderItem,
    footer: footer[0],
    rightItems: rightData,
    mode: mode,
    showCount: showCount,
    showSelectAll: showSelectAll,
    leftActionCopyAll: leftActionCopyAll,
    containerStyles: leftPanel,
    headerStyles: leftHeader,
    footStyles: leftFoot,
    searchProps: searchProps,
    emptyNode: leftEmptyNode,
    headerExtraNode: headerExtraNode[0],
    scrollContainerRef: panelRef[0],
    onScroll: panelOnScroll[0]
  }, children), /*#__PURE__*/_react["default"].createElement(_styled.StyledTransferIconContainer, {
    theme: theme
  }, transferIcon || /*#__PURE__*/_react["default"].createElement(_TransferIcon["default"], {
    mode: mode
  })), /*#__PURE__*/_react["default"].createElement(_TransferPanel["default"], {
    title: titles[1],
    direction: "right",
    items: rightData,
    handleClick: rightAction,
    showSearch: rightShowSearch,
    onSearch: onSearch,
    searchPlaceholder: searchPlaceholder[1],
    filterOption: filterOption,
    renderItem: renderItem,
    footer: footer[1],
    mode: mode,
    showCount: showCount,
    containerStyles: rightPanel,
    headerStyles: rightHeader,
    footStyles: rightFoot,
    rightItemExtra: rightItemExtra,
    searchProps: searchProps,
    emptyNode: rightEmptyNode,
    headerExtraNode: headerExtraNode[1],
    scrollContainerRef: panelRef[1],
    onScroll: panelOnScroll[1]
  }, children));
};

var Transfer = (0, _memoForwardRef["default"])(TransferPure);
Transfer.useTransferTree = _useTransferTree["default"];
Transfer.__MUYA_TRANSFER = true;
var _default = Transfer;
exports["default"] = _default;