"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _SearchIcon2 = require("@muya-ui/theme-light/lib/icons/SearchIcon");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _map2 = _interopRequireDefault(require("lodash/map"));

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _react = _interopRequireWildcard(require("react"));

var _EllipsisContent = _interopRequireDefault(require("../EllipsisContent"));

var _Input = _interopRequireDefault(require("../Input"));

var _Locale = require("../Locale");

var _Result = require("../Result");

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var TransferPanel = function TransferPanel(props) {
  var theme = (0, _useTheme["default"])();
  var children = props.children,
      direction = props.direction,
      mode = props.mode,
      title = props.title,
      _props$items = props.items,
      items = _props$items === void 0 ? [] : _props$items,
      renderItem = props.renderItem,
      handleClick = props.handleClick,
      onSearch = props.onSearch,
      searchPlaceholder = props.searchPlaceholder,
      showSearch = props.showSearch,
      showCount = props.showCount,
      filterOption = props.filterOption,
      rightItems = props.rightItems,
      showSelectAll = props.showSelectAll,
      leftActionCopyAll = props.leftActionCopyAll,
      footer = props.footer,
      containerStyles = props.containerStyles,
      headerStyles = props.headerStyles,
      footStyles = props.footStyles,
      rightItemExtra = props.rightItemExtra,
      searchProps = props.searchProps,
      emptyNode = props.emptyNode,
      headerExtraNode = props.headerExtraNode,
      scrollContainerRef = props.scrollContainerRef,
      onScroll = props.onScroll;

  var _useState = (0, _react.useState)(''),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      searchVal = _useState2[0],
      setSearchVal = _useState2[1];

  var locale = (0, _Locale.useLocale)();

  var _handleClick = (0, _react.useCallback)(function (key, disabled) {
    return disabled ? function () {} : function () {
      return handleClick(key);
    };
  }, [handleClick]);

  var handleSearch = (0, _react.useCallback)(function (e) {
    var val = e.target.value;
    setSearchVal(val);
    typeof onSearch === 'function' && onSearch(direction, val);
  }, [direction, onSearch]);
  var showItems = (0, _react.useMemo)(function () {
    var nextShowItems = items.filter(function (item) {
      return filterOption ? filterOption(searchVal, item) : (0, _includes2["default"])(item.title || '', searchVal);
    });
    return nextShowItems;
  }, [filterOption, items, searchVal]);
  var handleCopyAll = (0, _react.useCallback)(function () {
    typeof leftActionCopyAll === 'function' && leftActionCopyAll(showItems);
  }, [leftActionCopyAll, showItems]);
  var itemRenderer = (0, _react.useCallback)(function (item) {
    return renderItem ? renderItem(item) : item.title;
  }, [renderItem]);
  var itemChecked = (0, _react.useCallback)(function (item) {
    return (0, _includes2["default"])((0, _map2["default"])(rightItems, 'key'), item.key);
  }, [rightItems]);
  var prefixRenderer = (0, _react.useCallback)(function (item) {
    return direction === 'left' && mode === 'copy' ? /*#__PURE__*/_react["default"].createElement(_styled.StyledTransferCheckbox, {
      theme: theme,
      size: "s",
      checked: itemChecked(item),
      onClick: _handleClick(item.key, !!item.disabled)
    }) : null;
  }, [_handleClick, direction, itemChecked, mode, theme]);
  var suffixRender = (0, _react.useMemo)(function () {
    if (direction === 'right' && mode === 'copy') {
      return rightItemExtra || /*#__PURE__*/_react["default"].createElement(_styled.StyledTransferItemExtraIcon, {
        theme: theme
      });
    } else {
      return null;
    }
  }, [direction, mode, rightItemExtra, theme]);
  var itemsRenderer = (0, _react.useMemo)(function () {
    var renderChildren;

    if (children && typeof children === 'function') {
      renderChildren = children({
        direction: direction,
        filteredItems: showItems,
        filteredItemKeys: (0, _map2["default"])(showItems, 'key'),
        onItemSelect: handleClick
      });
    }

    if (renderChildren) {
      return renderChildren;
    } else if (showItems.length) {
      return showItems.map(function (item) {
        return /*#__PURE__*/_react["default"].createElement(_styled.StyledTransferPanelItem, {
          $disabled: !!item.disabled,
          theme: theme,
          key: item.key,
          onClick: _handleClick(item.key, !!item.disabled)
        }, prefixRenderer(item), /*#__PURE__*/_react["default"].createElement(_styled.StyledTransferPanelItemText, {
          theme: theme,
          enableTitle: true
        }, itemRenderer(item)), suffixRender);
      });
    } else if (emptyNode !== undefined) {
      return emptyNode;
    } else {
      var subTitle = locale['Select.noDataText'];
      return /*#__PURE__*/_react["default"].createElement(_styled.StyledEmptyResultContainer, null, /*#__PURE__*/_react["default"].createElement(_Result.Result, {
        subTitle: subTitle,
        type: "emptySmall"
      }));
    }
  }, [_handleClick, children, direction, emptyNode, handleClick, itemRenderer, locale, prefixRenderer, showItems, suffixRender, theme]);
  var searchRenderer = (0, _react.useMemo)(function () {
    return showSearch ? /*#__PURE__*/_react["default"].createElement(_styled.StyledTransferPanelSearch, {
      theme: theme
    }, /*#__PURE__*/_react["default"].createElement(_Input["default"], (0, _extends2["default"])({
      size: "s",
      placeholder: searchPlaceholder,
      suffixNode: /*#__PURE__*/_react["default"].createElement(_SearchIcon2.SearchIcon, null),
      allowClear: true,
      clearReplace: true
    }, searchProps, {
      onChange: handleSearch
    }))) : null;
  }, [handleSearch, searchPlaceholder, searchProps, showSearch, theme]);
  var headerRender = (0, _react.useMemo)(function () {
    var countData;

    if (direction === 'left' && mode === 'copy') {
      var rightKeys = (0, _map2["default"])(rightItems, 'key');
      countData = "".concat(showItems.filter(function (item) {
        return (0, _includes2["default"])(rightKeys, item.key);
      }).length, "/").concat(showItems.length);
    } else {
      countData = "".concat(showItems.length);
    }

    return /*#__PURE__*/_react["default"].createElement(_styled.StyledTransferPanelHeader, (0, _extends2["default"])({
      theme: theme
    }, headerStyles), direction === 'left' && showSelectAll && mode === 'copy' ? /*#__PURE__*/_react["default"].createElement(_styled.StyledTransferCheckbox, {
      size: "s",
      theme: theme,
      checked: rightItems.length === items.length,
      indeterminate: !!(rightItems.length && rightItems.length !== items.length),
      onClick: handleCopyAll
    }) : null, /*#__PURE__*/_react["default"].createElement(_styled.StyledTransferPanelTitle, {
      theme: theme
    }, /*#__PURE__*/_react["default"].createElement(_EllipsisContent["default"], {
      enableTitle: true
    }, title)), showCount ? /*#__PURE__*/_react["default"].createElement(_styled.StyledTransferPanelCount, {
      theme: theme
    }, countData) : null, headerExtraNode || null);
  }, [direction, handleCopyAll, headerExtraNode, headerStyles, items.length, mode, rightItems, showCount, showItems, showSelectAll, theme, title]);
  var footerRender = (0, _react.useMemo)(function () {
    return footer ? /*#__PURE__*/_react["default"].createElement(_styled.StyledTransferPanelFooter, (0, _extends2["default"])({
      theme: theme
    }, footStyles), footer) : null;
  }, [footStyles, footer, theme]);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledTransferPanel, (0, _extends2["default"])({
    theme: theme
  }, containerStyles), headerRender, searchRenderer, /*#__PURE__*/_react["default"].createElement(_styled.StyledTransferPanelList, {
    theme: theme,
    contentRef: scrollContainerRef,
    onScroll: onScroll
  }, itemsRenderer), footerRender);
};

var _default = TransferPanel;
exports["default"] = _default;