"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledTransferPanelTitle = exports.StyledTransferPanelSearch = exports.StyledTransferPanelList = exports.StyledTransferPanelItemText = exports.StyledTransferPanelItem = exports.StyledTransferPanelHeader = exports.StyledTransferPanelFooter = exports.StyledTransferPanelCount = exports.StyledTransferPanel = exports.StyledTransferItemExtraIcon = exports.StyledTransferIconContainer = exports.StyledTransferIcon = exports.StyledTransferCheckbox = exports.StyledTransfer = exports.StyledEmptyResultContainer = void 0;

var _DustbinIcon2 = require("@muya-ui/theme-light/lib/icons/DustbinIcon");

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Checkbox = _interopRequireDefault(require("../Checkbox"));

var _EllipsisContent = require("../EllipsisContent");

var _Typography = _interopRequireDefault(require("../Typography"));

var _ScrollView = _interopRequireDefault(require("../ScrollView"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledTransfer = _styledComponents["default"].div.withConfig({
  displayName: "StyledTransfer"
})(["", ""], function (_ref) {
  var theme = _ref.theme;
  var token = theme.components.Transfer;
  return (0, _styledComponents.css)(["width:", "px;height:", "px;display:flex;> *{height:100%;}"], token.container.width, token.container.height);
});

exports.StyledTransfer = StyledTransfer;

var StyledTransferPanel = _styledComponents["default"].div.withConfig({
  displayName: "StyledTransferPanel"
})(["", ""], function (_ref2) {
  var theme = _ref2.theme;
  var token = theme.components.Transfer.panel;
  return (0, _styledComponents.css)(["background-color:", ";border:1px solid ", ";height:100%;flex:1;display:flex;overflow:hidden;flex-direction:column;"], token.backgroundColor, token.borderColor);
});

exports.StyledTransferPanel = StyledTransferPanel;

var StyledTransferPanelHeader = _styledComponents["default"].div.withConfig({
  displayName: "StyledTransferPanelHeader"
})(["", ""], function (_ref3) {
  var theme = _ref3.theme;
  var token = theme.components.Transfer.panel;
  return (0, _styledComponents.css)(["background-color:", ";padding:", "px ", "px;display:flex;align-items:center;"], token.header.backgroundColor, token.header.paddingTop, token.header.paddingLeft);
});

exports.StyledTransferPanelHeader = StyledTransferPanelHeader;

var StyledTransferPanelTitle = _styledComponents["default"].div.withConfig({
  displayName: "StyledTransferPanelTitle"
})(["", ""], function (_ref4) {
  var theme = _ref4.theme;
  var token = theme.components.Transfer.panel.header.title;
  return (0, _styledComponents.css)(["flex:1;color:", ";font-weight:", ";font-size:", "px;"], token.color, token.weight, token.fontSize);
});

exports.StyledTransferPanelTitle = StyledTransferPanelTitle;
var StyledTransferPanelCount = (0, _styledComponents["default"])(_Typography["default"].Text).withConfig({
  displayName: "StyledTransferPanelCount"
})(["", ""], function (_ref5) {
  var theme = _ref5.theme;
  var token = theme.components.Transfer.panel;
  return (0, _styledComponents.css)(["color:", ";"], token.header.countColor);
});
exports.StyledTransferPanelCount = StyledTransferPanelCount;

var StyledTransferIconContainer = _styledComponents["default"].div.withConfig({
  displayName: "StyledTransferIconContainer"
})(["", ""], function (_ref6) {
  var theme = _ref6.theme;
  var token = theme.components.Transfer;
  return (0, _styledComponents.css)(["width:", "px;display:flex;justify-content:center;align-items:center;"], token.iconContainer.width);
});

exports.StyledTransferIconContainer = StyledTransferIconContainer;

var StyledTransferIcon = _styledComponents["default"].div.withConfig({
  displayName: "StyledTransferIcon"
})(["", ""], function (_ref7) {
  var theme = _ref7.theme;
  var token = theme.components.Transfer;
  return (0, _styledComponents.css)(["font-size:", "px;color:", ";transform:rotate(90deg);"], token.icon.fontSize, token.icon.color);
});

exports.StyledTransferIcon = StyledTransferIcon;
var StyledTransferPanelList = (0, _styledComponents["default"])(_ScrollView["default"]).withConfig({
  displayName: "StyledTransferPanelList"
})(["", ""], function (_ref8) {
  var theme = _ref8.theme;
  return (0, _styledComponents.css)(["flex:1;overflow-y:auto;margin:", "px 0;"], theme.components.Transfer.panel.list.marginTop);
});
exports.StyledTransferPanelList = StyledTransferPanelList;

var StyledTransferPanelItem = _styledComponents["default"].div.withConfig({
  displayName: "StyledTransferPanelItem"
})(["", ""], function (_ref9) {
  var theme = _ref9.theme,
      $disabled = _ref9.$disabled;
  var token = theme.components.Transfer.panel;
  return (0, _styledComponents.css)(["box-sizing:border-box;width:100%;padding:", "px ", "px;line-height:", "px;background-color:", ";display:flex;align-items:center;color:", ";cursor:", ";font-size:", "px;", ""], token.item.paddingTop, token.item.paddingLeft, token.item.lineHeight, token.item.background.normal, $disabled ? token.item.colorDisabled : token.item.color, $disabled ? 'not-allowed' : 'pointer', token.item.fontSize, !$disabled && (0, _styledComponents.css)(["&:hover{background-color:", ";}&:active{background-color:", ";}"], token.item.background.hover, token.item.background.click));
});

exports.StyledTransferPanelItem = StyledTransferPanelItem;
var StyledTransferPanelItemText = (0, _styledComponents["default"])(_EllipsisContent.EllipsisContent).withConfig({
  displayName: "StyledTransferPanelItemText"
})(["", ""], function (_ref10) {
  var theme = _ref10.theme;
  var token = theme.components.Transfer.panel;
  return (0, _styledComponents.css)(["flex:1;font-size:", "px;"], token.item.fontSize);
});
exports.StyledTransferPanelItemText = StyledTransferPanelItemText;

var StyledTransferPanelSearch = _styledComponents["default"].div.withConfig({
  displayName: "StyledTransferPanelSearch"
})(["", ""], function (_ref11) {
  var theme = _ref11.theme;
  var token = theme.components.Transfer.panel.header.search;
  return (0, _styledComponents.css)(["padding:", "px ", "px;display:flex;> *{flex:1;}"], token.paddingTop, token.paddingLeft);
});

exports.StyledTransferPanelSearch = StyledTransferPanelSearch;
var StyledTransferCheckbox = (0, _styledComponents["default"])(_Checkbox["default"]).withConfig({
  displayName: "StyledTransferCheckbox"
})(["", ""], function (_ref12) {
  var theme = _ref12.theme;
  var token = theme.components.Transfer.panel;
  return (0, _styledComponents.css)(["margin-right:", "px;"], token.checkboxMarginRight);
});
exports.StyledTransferCheckbox = StyledTransferCheckbox;
var StyledTransferItemExtraIcon = (0, _styledComponents["default"])(_DustbinIcon2.DustbinIcon).withConfig({
  displayName: "StyledTransferItemExtraIcon"
})(["", ""], function (_ref13) {
  var theme = _ref13.theme;
  var token = theme.components.Transfer.panel.item;
  return (0, _styledComponents.css)(["color:", ";"], token.extraColor);
});
exports.StyledTransferItemExtraIcon = StyledTransferItemExtraIcon;

var StyledTransferPanelFooter = _styledComponents["default"].div.withConfig({
  displayName: "StyledTransferPanelFooter"
})(["", ""], function (_ref14) {
  var theme = _ref14.theme;
  var token = theme.components.Transfer.panel.footer;
  return (0, _styledComponents.css)(["background-color:", ";border-top:1px solid ", ";height:", "px;"], token.backgroundColor, token.borderColor, token.height);
});

exports.StyledTransferPanelFooter = StyledTransferPanelFooter;

var StyledEmptyResultContainer = _styledComponents["default"].div.withConfig({
  displayName: "StyledEmptyResultContainer"
})(["width:100%;height:100%;display:flex;align-items:center;justify-content:center;"]);

exports.StyledEmptyResultContainer = StyledEmptyResultContainer;