"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _xor2 = _interopRequireDefault(require("lodash/xor"));

var _map2 = _interopRequireDefault(require("lodash/map"));

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _find2 = _interopRequireDefault(require("lodash/find"));

var _react = require("react");

function useTransfer(dataSource, targetSource, isController, mode, order, handleChange) {
  var initLeftData = (0, _react.useMemo)(function () {
    return mode === 'move' ? dataSource.filter(function (item) {
      return !(0, _includes2["default"])(targetSource, item.key);
    }) : dataSource;
  }, [dataSource, mode, targetSource]);
  var initRightData = (0, _react.useMemo)(function () {
    return targetSource.map(function (key) {
      return (0, _find2["default"])(dataSource, function (item) {
        return item.key === key;
      });
    });
  }, [dataSource, targetSource]);

  var _useState = (0, _react.useState)(initLeftData),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      _leftData = _useState2[0],
      setLeftData = _useState2[1];

  var _useState3 = (0, _react.useState)(initRightData),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      _rightData = _useState4[0],
      setRightData = _useState4[1];

  var leftData = isController ? initLeftData : _leftData;
  var rightData = isController ? initRightData : _rightData;
  var emitClick = (0, _react.useCallback)(function (transferKey, actionDirection, nextTargetKeys, nextSourceKeys) {
    typeof handleChange === 'function' && handleChange(transferKey, actionDirection, nextTargetKeys, nextSourceKeys);
  }, [handleChange]);
  var getKeys = (0, _react.useCallback)(function (data) {
    return (0, _map2["default"])(data, 'key');
  }, []);
  var dataSourceKeys = (0, _react.useMemo)(function () {
    return getKeys(dataSource);
  }, [dataSource, getKeys]);
  /**
   * 左边点击，左边不变，右边新增
   */

  var leftActionCopy = (0, _react.useCallback)(function (key) {
    var newRightData;

    if ((0, _includes2["default"])(getKeys(rightData), key)) {
      newRightData = rightData.filter(function (item) {
        return item.key !== key;
      });
    } else {
      newRightData = order === 'DESC' ? [(0, _find2["default"])(leftData, function (item) {
        return item.key === key;
      })].concat((0, _toConsumableArray2["default"])(rightData)) : [].concat((0, _toConsumableArray2["default"])(rightData), [(0, _find2["default"])(leftData, function (item) {
        return item.key === key;
      })]);
    }

    setRightData(newRightData);
    emitClick(getKeys(newRightData), dataSourceKeys, 'left', [key]);
  }, [dataSourceKeys, emitClick, getKeys, leftData, order, rightData]);
  /**
   * 左边点击，左边减少，右边新增
   */

  var leftActionMove = (0, _react.useCallback)(function (key) {
    var newRightData = order === 'DESC' ? [(0, _find2["default"])(leftData, function (item) {
      return item.key === key;
    })].concat((0, _toConsumableArray2["default"])(rightData)) : [].concat((0, _toConsumableArray2["default"])(rightData), [(0, _find2["default"])(leftData, function (item) {
      return item.key === key;
    })]);
    var newLeftData = leftData.filter(function (leftItem) {
      return leftItem.key !== key;
    });
    setLeftData(newLeftData);
    setRightData(newRightData);
    emitClick(getKeys(newRightData), getKeys(newLeftData), 'left', [key]);
  }, [emitClick, getKeys, leftData, order, rightData]);
  /**
   * 右边点击，左边不变，右边减少
   */

  var rightActionCopy = (0, _react.useCallback)(function (key) {
    var newRightData = rightData.filter(function (item) {
      return item.key !== key;
    });
    setRightData(newRightData);
    emitClick(getKeys(newRightData), dataSourceKeys, 'right', [key]);
  }, [dataSourceKeys, emitClick, getKeys, rightData]);
  /**
   * 右边点击，左边增加，右边减少
   */

  var rightActionMove = (0, _react.useCallback)(function (key) {
    var newRightData = rightData.filter(function (item) {
      return item.key !== key;
    });
    var newRightKeys = getKeys(newRightData);
    var newLeftData = dataSource.filter(function (item) {
      return !(0, _includes2["default"])(newRightKeys, item.key);
    });
    setRightData(newRightData);
    setLeftData(newLeftData);
    emitClick(getKeys(newRightData), getKeys(newLeftData), 'right', [key]);
  }, [dataSource, emitClick, getKeys, rightData]);
  /**
   * 左边全选，所有不disabled的item都被移到右边
   */

  var leftActionCopyAll = (0, _react.useCallback)(function (filteredItems) {
    // 过滤 disabled 为 true 的数据
    var enabledFilteredItems = filteredItems.filter(function (item) {
      return !item.disabled;
    });
    var rightKeys = getKeys(rightData);
    var filteredKeys = getKeys(enabledFilteredItems);
    var filteredItemsUnChecked = enabledFilteredItems.filter(function (item) {
      return !(0, _includes2["default"])(rightKeys, item.key);
    });
    var newRightData; // 当前已全选

    if (filteredItemsUnChecked.length === 0) {
      newRightData = rightData.filter(function (item) {
        return !(0, _includes2["default"])(filteredKeys, item.key);
      });
    } // 当前未全选
    else {
      newRightData = [].concat((0, _toConsumableArray2["default"])(filteredItemsUnChecked), (0, _toConsumableArray2["default"])(rightData));
    }

    setRightData(newRightData);
    emitClick(getKeys(newRightData), dataSourceKeys, 'left', (0, _xor2["default"])(getKeys(newRightData), rightKeys));
  }, [dataSourceKeys, emitClick, getKeys, rightData]);
  return {
    leftData: leftData,
    rightData: rightData,
    leftAction: mode === 'move' ? leftActionMove : leftActionCopy,
    rightAction: mode === 'move' ? rightActionMove : rightActionCopy,
    leftActionCopyAll: leftActionCopyAll
  };
}

var _default = useTransfer;
exports["default"] = _default;