"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _react = _interopRequireDefault(require("react"));

var _Animation = _interopRequireDefault(require("../Animation"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _TreeNode = _interopRequireDefault(require("./TreeNode"));

var _excluded = ["transitionType", "transitionNodes", "onTransitionEnd", "styles", "lastChildFlags"];
var TransitionTreeNode = (0, _memoForwardRef["default"])(function (props, ref) {
  var transitionType = props.transitionType,
      transitionNodes = props.transitionNodes,
      onTransitionEnd = props.onTransitionEnd,
      styles = props.styles,
      lastChildFlags = props.lastChildFlags,
      restProps = (0, _objectWithoutProperties2["default"])(props, _excluded);

  var _React$useState = _react["default"].useState(true),
      _React$useState2 = (0, _slicedToArray2["default"])(_React$useState, 2),
      visible = _React$useState2[0],
      setVisible = _React$useState2[1];

  var transitionedRef = _react["default"].useRef(false);

  var handleTransitionEnd = function handleTransitionEnd() {
    if (!transitionedRef.current) {
      onTransitionEnd();
    }

    transitionedRef.current = true;
  };

  _react["default"].useEffect(function () {
    if (transitionNodes && transitionType === 'hide' && visible) {
      setVisible(false);
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [visible]);

  _react["default"].useEffect(function () {
    return function () {
      if (transitionNodes) {
        handleTransitionEnd();
      }
    };
  }, // eslint-disable-next-line react-hooks/exhaustive-deps
  []);

  if (!(0, _isEmpty2["default"])(transitionNodes)) {
    return /*#__PURE__*/_react["default"].createElement(_Animation["default"].Collapse, {
      ref: ref,
      "in": visible,
      appear: transitionType === 'show',
      onEntered: handleTransitionEnd,
      onExited: handleTransitionEnd
    }, /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, transitionNodes.map(function (node) {
      var data = node.data;
      var key = data.key;
      return /*#__PURE__*/_react["default"].createElement(_TreeNode["default"], (0, _extends2["default"])({
        styles: styles,
        data: data,
        nodeKey: key,
        key: key,
        lastChildFlags: lastChildFlags
      }, data));
    })));
  }

  return /*#__PURE__*/_react["default"].createElement(_TreeNode["default"], (0, _extends2["default"])({}, restProps, {
    styles: styles,
    lastChildFlags: lastChildFlags
  }));
});
var _default = TransitionTreeNode;
exports["default"] = _default;