"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.notExpandedRotateKeyframes = exports.expandedRotateKeyframes = exports.StyledTreeScrollWrapper = exports.StyledTreeNodeSelectorWrapper = exports.StyledTreeNodeSelector = exports.StyledTreeNodeLabel = exports.StyledTreeNodeContent = exports.StyledTreeNode = exports.StyledTreeIconWrapper = exports.StyledTree = exports.StyledTitle = exports.StyledLine = exports.StyledIndicator = exports.StyledExpandHotZoneLine = exports.StyledChildTree = exports.StyleExpandHotZone = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _styled = require("../Checkbox/styled");

var _styled2 = require("../ScrollView/styled");

var _ellipsis = _interopRequireDefault(require("../styled/mixins/ellipsis"));

var _item = require("../styled/mixins/item");

var _listReset = _interopRequireDefault(require("../styled/mixins/listReset"));

var _Typography = _interopRequireDefault(require("../Typography"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// expand 动画
var expandedRotateKeyframes = (0, _styledComponents.keyframes)(["to{transform:rotate(90deg);}"]);
exports.expandedRotateKeyframes = expandedRotateKeyframes;
var notExpandedRotateKeyframes = (0, _styledComponents.keyframes)(["from{transform:rotate(90deg);}to{transform:rotate(0deg);}"]);
exports.notExpandedRotateKeyframes = notExpandedRotateKeyframes;
var StyledTitle = (0, _styledComponents["default"])(_Typography["default"].Text).withConfig({
  displayName: "StyledTitle"
})([""]);
exports.StyledTitle = StyledTitle;

var StyledTreeIconWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledTreeIconWrapper"
})([""]);

exports.StyledTreeIconWrapper = StyledTreeIconWrapper;

var StyledIndicator = _styledComponents["default"].div.withConfig({
  displayName: "StyledIndicator"
})(["", ""], function (props) {
  var token = props.theme.components.Tree;
  return (0, _styledComponents.css)(["position:absolute;z-index:2;right:0;width:100%;height:1px;background:", ";&::after{content:'';position:absolute;width:5px;height:5px;border-radius:50%;border:1px solid ", ";top:-2px;inset-inline-start:-4px;}"], token.dragOverGapColor, token.dragOverGapColor);
}); // node content


exports.StyledIndicator = StyledIndicator;

var StyledTreeNodeContent = _styledComponents["default"].div.withConfig({
  displayName: "StyledTreeNodeContent"
})(["display:flex;justify-content:flex-start;align-items:center;"]);

exports.StyledTreeNodeContent = StyledTreeNodeContent;

var StyledTreeNodeLabel = _styledComponents["default"].span.withConfig({
  displayName: "StyledTreeNodeLabel"
})(["white-space:nowrap;text-overflow:ellipsis;overflow:hidden;"]);

exports.StyledTreeNodeLabel = StyledTreeNodeLabel;

var StyledChildTree = _styledComponents["default"].ul.withConfig({
  displayName: "StyledChildTree"
})(["", ";"], _listReset["default"]);

exports.StyledChildTree = StyledChildTree;

var StyleExpandHotZone = _styledComponents["default"].div.withConfig({
  displayName: "StyleExpandHotZone"
})([""]);

exports.StyleExpandHotZone = StyleExpandHotZone;

var StyledExpandHotZoneLine = _styledComponents["default"].div.withConfig({
  displayName: "StyledExpandHotZoneLine"
})([""]);

exports.StyledExpandHotZoneLine = StyledExpandHotZoneLine;

var StyledTreeNodeSelectorWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledTreeNodeSelectorWrapper"
})(["display:inline-flex;width:100%;"]);

exports.StyledTreeNodeSelectorWrapper = StyledTreeNodeSelectorWrapper;

var StyledTreeNodeSelector = _styledComponents["default"].div.withConfig({
  displayName: "StyledTreeNodeSelector"
})(["display:inline-flex;justify-content:space-between;width:100%;"]);

exports.StyledTreeNodeSelector = StyledTreeNodeSelector;

var StyledLine = _styledComponents["default"].div.withConfig({
  displayName: "StyledLine"
})(["", ""], function (props) {
  var _props$theme = props.theme,
      colors = _props$theme.colors,
      token = _props$theme.components.Tree,
      $level = props.$level,
      $size = props.$size,
      $isLastChild = props.$isLastChild,
      $contentHeight = props.$contentHeight;
  return (0, _styledComponents.css)(["position:absolute;top:0;bottom:", ";left:", "px;width:", "px;background:", ";content:' ';"], $isLastChild ? "".concat($contentHeight / 2 + 2, "px") : 0, token.lineVertical.firstLevelLeft[$size] + $level * token.childIndent, token.lineSize, colors.pattern.background.divider);
}); // node
// eslint-disable-next-line complexity


exports.StyledLine = StyledLine;

var treeNodeCss = function treeNodeCss(props) {
  var _props$theme2 = props.theme,
      colors = _props$theme2.colors,
      _props$theme2$transit = _props$theme2.transition.pattern,
      duration = _props$theme2$transit.duration,
      easing = _props$theme2$transit.easing,
      token = _props$theme2.components.Tree,
      $size = props.$size,
      $dragNodeHighlight = props.$dragNodeHighlight,
      $dragOver = props.$dragOver,
      $dragOverGapTop = props.$dragOverGapTop,
      $dragOverGapBottom = props.$dragOverGapBottom,
      $dropLevelOffset = props.$dropLevelOffset,
      $isLeaf = props.$isLeaf,
      $level = props.$level,
      $selected = props.$selected,
      $disabled = props.$disabled,
      $showLine = props.$showLine,
      $virtual = props.$virtual,
      $lineBottom = props.$lineBottom;
  return (0, _styledComponents.css)(["position:relative;display:flex;flex-direction:column;", ";& > ", "{margin:", ";height:", "px;line-height:", "px;padding-left:", "px;padding-right:", "px;cursor:pointer;z-index:1;transition:background-color ", "ms ", ",color ", "ms ", ";", " ", ";& ", "{", " ", "}", " ", " ", " ", " ", " &:hover ", "{background:transparent;}}", "{font-size:", "px;margin-right:", "px;}", "{top:0;}", "{margin-right:", "px;}", "{position:relative;display:inline-flex;justify-content:center;align-items:center;flex-shrink:0;line-height:", "px;width:", "px;height:", "px;margin:0 ", "px;cursor:pointer;}", " ", " ", "{font-size:", "px;line-height:", "px;color:inherit;white-space:nowrap;}& > ", "{padding-left:", "px;}"], $virtual && $level > 0 && "padding-left: ".concat(token.childIndent * $level + token.firstNodePaddingLeft[$size], "px"), StyledTreeNodeContent, token.contentMargin, token.nodeHeight[$size], token.lineHeight[$size], $level === 0 ? token.firstNodePaddingLeft[$size] : 0, token.contentPaddingRight[$size], duration.status, easing.status, duration.status, easing.status, (0, _item.itemNormalStyle)(token), $level === 0 && "color: ".concat(token.rootLevelColor), StyledIndicator, $dragOverGapTop && (0, _styledComponents.css)(["top:-1px;left:", "px;"], $virtual && $level > 0 ? token.childIndent * ($level - $dropLevelOffset) + token.firstNodePaddingLeft[$size] + 10 : $level === 0 ? token.firstNodePaddingLeft[$size] + 10 : 10), $dragOverGapBottom && (0, _styledComponents.css)(["bottom:0px;left:", "px;"], $virtual && $level > 0 ? token.childIndent * ($level - $dropLevelOffset) + token.firstNodePaddingLeft[$size] + 10 : $level === 0 ? token.firstNodePaddingLeft[$size] + 10 : 10), $dragOver && (0, _styledComponents.css)(["background:", ";"], token.dragOverBgColor), $dragNodeHighlight && (0, _styledComponents.css)(["opacity:", ";"], token.dragNodeHighlightOpacity), $selected && (0, _styledComponents.css)(["", " ", "{background:transparent;}"], (0, _item.itemSelectedStyle)(token), StyledExpandHotZoneLine), $disabled && (0, _item.itemDisabledStyle)(token), $isLeaf && $level !== 0 && (0, _styledComponents.css)(["margin-left:0;"]), StyledExpandHotZoneLine, StyledTreeIconWrapper, token.iconFontSize[$size], token.iconWrapperMarginRight, _styled.StyledCheckboxSpan, _styled.StyledCheckboxLabel, token.checkboxMarginRight, StyleExpandHotZone, token.nodeHeight[$size], token.expandIconWrapperWidth, token.nodeHeight[$size], token.expandIconWrapperMargin, $showLine && !$virtual && !$isLeaf && (0, _styledComponents.css)(["&::before{position:absolute;top:", "px;bottom:", "px;left:", "px;width:", "px;background:", ";content:' ';}"], token.lineVertical.top, $lineBottom || token.lineVertical.bottom[$size], $level === 0 ? token.lineVertical.firstLevelLeft[$size] : token.lineVertical.otherLevelLeft[$size], token.lineSize, colors.pattern.background.divider), $showLine && $level > 0 && (0, _styledComponents.css)(["", "{position:relative;width:100%;height:", "px;background:", ";left:", "px;}", "::before{position:absolute;top:", "px;left:", "px;height:", "px;width:", "px;background:", ";content:' ';}"], StyledExpandHotZoneLine, token.lineSize, colors.pattern.background.divider, token.lineHorizontal.left, StyleExpandHotZone, token.lineHorizontal.beforeTop[$size], token.lineHorizontal.beforeLeft[$size], token.lineSize, token.lineHorizontal.beforeWidth, colors.pattern.background.divider), StyledTitle, token.fontSize[$size], token.lineHeight[$size], StyledChildTree, $level === 0 ? token.childIndent + token.firstNodePaddingLeft[$size] : token.childIndent);
}; // tree


var StyledTreeNode = _styledComponents["default"].li.withConfig({
  displayName: "StyledTreeNode"
})(["", ";", ";"], _listReset["default"], treeNodeCss);

exports.StyledTreeNode = StyledTreeNode;
var notScrollableCss = (0, _styledComponents.css)(["overflow:hidden;", "{", ";", "{", ";}", "{overflow:hidden;}}"], StyledTreeNodeSelectorWrapper, _ellipsis["default"], StyledTitle, _ellipsis["default"], StyledTreeNodeSelector);

var treeCss = function treeCss(props) {
  var _props$theme3 = props.theme,
      colorsPattern = _props$theme3.colors.pattern,
      token = _props$theme3.components.Tree,
      $size = props.$size,
      $scrollable = props.$scrollable;
  return (0, _styledComponents.css)(["box-sizing:border-box;font-size:", "px;color:", ";font-variant:tabular-nums;font-feature-settings:'tnum';", ";"], token.fontSize[$size], colorsPattern.text.text, !$scrollable && notScrollableCss);
};

var StyledTree = _styledComponents["default"].ul.withConfig({
  displayName: "StyledTree"
})(["", ";", ";", ";padding:3px 0;"], _listReset["default"], treeCss, _styled2.scrollBarStyle);

exports.StyledTree = StyledTree;

var StyledTreeScrollWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledTreeScrollWrapper"
})(["box-sizing:border-box;overflow:auto;", ";"], _styled2.scrollBarStyle);

exports.StyledTreeScrollWrapper = StyledTreeScrollWrapper;