"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _SelectIcon2 = require("@muya-ui/theme-light/lib/icons/SelectIcon");

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _react = _interopRequireWildcard(require("react"));

var _Result = _interopRequireDefault(require("../Result"));

var _Tree = _interopRequireDefault(require("../Tree"));

var _styled = require("../Tree/styled");

var _Trigger = _interopRequireDefault(require("../Trigger"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled2 = require("./styled");

var _TreeSelectInput = _interopRequireDefault(require("./TreeSelectInput"));

var _useTreeSelect2 = _interopRequireDefault(require("./useTreeSelect"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  inputWrapper: '',
  popup: '',
  scrollContainer: ''
};

var TreeSelect = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      treeCheckable = props.treeCheckable,
      selectedIcon = props.selectedIcon,
      treeRenderNodeContent = props.treeRenderNodeContent,
      notFoundContent = props.notFoundContent,
      styles = props.styles,
      inputRef = props.inputRef,
      popupWidth = props.popupWidth;
  var theme = (0, _useTheme["default"])();
  var token = theme.components.TreeSelect;
  var innerInputRef = (0, _react.useRef)(null);
  var handleInputRef = (0, _useForkRef2.useForkRef)(innerInputRef, inputRef);
  var nodeRef = (0, _react.useRef)(null);
  var handleRef = (0, _useForkRef2.useForkRef)(ref, nodeRef);

  var _useTreeSelect = (0, _useTreeSelect2["default"])(props, nodeRef, innerInputRef),
      getTriggerProps = _useTreeSelect.getTriggerProps,
      getInputProps = _useTreeSelect.getInputProps,
      getTreeProps = _useTreeSelect.getTreeProps,
      treeWidthRef = _useTreeSelect.treeWidthRef,
      showEmptyView = _useTreeSelect.showEmptyView,
      noResultText = _useTreeSelect.noResultText,
      showSearch = _useTreeSelect.showSearch,
      inputValue = _useTreeSelect.inputValue;

  var innerStyles = (0, _useStyles["default"])('tree-select', defaultStyles, styles);

  var renderNodeContent = function renderNodeContent(props) {
    if (typeof treeRenderNodeContent === 'function') {
      return treeRenderNodeContent((0, _extends2["default"])({}, props, {
        inputValue: inputValue
      }));
    } else {
      var titleNode = props.title; // 搜索模式下文本高亮，title 为对象类型时无法匹配文本，因此忽略高亮

      if (showSearch && (0, _typeof2["default"])(props.title) !== 'object') {
        var title = "".concat(props.title) || '';
        var index = title.indexOf(inputValue);
        var beforeStr = title.substr(0, index);
        var afterStr = title.substr(index + inputValue.length);
        titleNode = index > -1 ? /*#__PURE__*/_react["default"].createElement("span", null, beforeStr, /*#__PURE__*/_react["default"].createElement("span", {
          style: {
            color: theme.colors.pattern.text.highlight
          }
        }, inputValue), afterStr) : /*#__PURE__*/_react["default"].createElement("span", null, title);
      }

      if (treeCheckable) {
        return /*#__PURE__*/_react["default"].createElement(_styled.StyledTreeNodeLabel, null, titleNode);
      } else {
        var SelectedIcon = token.selectedIcon || _SelectIcon2.SelectIcon;

        var selectedIconNode = selectedIcon || /*#__PURE__*/_react["default"].createElement(SelectedIcon, {
          style: {
            flexShrink: 0,
            marginLeft: token.selectedIconMarginLeft,
            color: token.selectedIconColor
          }
        });

        return /*#__PURE__*/_react["default"].createElement(_styled2.StyledTreeNodeLabelWithIcon, null, /*#__PURE__*/_react["default"].createElement(_styled.StyledTreeNodeLabel, null, titleNode), props.selected && selectedIconNode);
      }
    }
  };

  var tree = /*#__PURE__*/_react["default"].createElement(_styled2.StyledTreePopup, (0, _extends2["default"])({
    theme: theme,
    $width: popupWidth || treeWidthRef.current,
    $showEmptyView: showEmptyView
  }, innerStyles.popup), showEmptyView ? notFoundContent || /*#__PURE__*/_react["default"].createElement(_Result["default"], {
    subTitle: noResultText,
    type: "emptySmall"
  }) : /*#__PURE__*/_react["default"].createElement(_Tree["default"], (0, _extends2["default"])({}, getTreeProps(), {
    renderNodeContent: renderNodeContent
  })));

  return /*#__PURE__*/_react["default"].createElement(_Trigger["default"], (0, _extends2["default"])({}, getTriggerProps(), {
    popup: tree,
    offset: token.offset[size]
  }), /*#__PURE__*/_react["default"].createElement(_TreeSelectInput["default"], (0, _extends2["default"])({
    ref: handleRef,
    inputRef: handleInputRef,
    wrapperStyleItem: innerStyles.inputWrapper
  }, getInputProps())));
});

TreeSelect.__MUYA_TREESELECT = true;
var _default = TreeSelect;
exports["default"] = _default;