"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _FoldIcon2 = require("@muya-ui/theme-light/lib/icons/FoldIcon");

var _omit2 = _interopRequireDefault(require("lodash/omit"));

var _endsWith2 = _interopRequireDefault(require("lodash/endsWith"));

var _react = _interopRequireWildcard(require("react"));

var _ExpandIcon = _interopRequireDefault(require("../ExpandIcon"));

var _Input = _interopRequireWildcard(require("../Input"));

var _styled = require("../Input/styled");

var _ExpandWrapper = _interopRequireDefault(require("../styled/components/ExpandWrapper"));

var _addPx = _interopRequireDefault(require("../utils/addPx"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _const = require("./const");

var _useTreeSelectInput2 = _interopRequireDefault(require("./useTreeSelectInput"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var TreeSelectInput = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var id = props.id,
      disabled = props.disabled,
      readOnly = props.readOnly,
      placeholder = props.placeholder,
      showSearch = props.showSearch,
      expandIcon = props.expandIcon,
      hideExpandIcon = props.hideExpandIcon,
      inputValue = props.inputValue,
      popupVisible = props.popupVisible,
      value = props.value,
      disabledValue = props.disabledValue,
      multiple = props.multiple,
      hasValue = props.hasValue,
      width = props.width,
      backfill = props.backfill,
      inputRef = props.inputRef,
      onClear = props.onClear,
      prefixNode = props.prefixNode,
      suffixNode = props.suffixNode,
      maxVerticalTagCount = props.maxVerticalTagCount,
      maxTagWidth = props.maxTagWidth,
      maxTagTextLength = props.maxTagTextLength,
      wrapperStyleItem = props.wrapperStyleItem,
      status = props.status,
      renderTag = props.renderTag,
      filterTag = props.filterTag,
      _props$clearReplace = props.clearReplace,
      clearReplace = _props$clearReplace === void 0 ? true : _props$clearReplace;
  var theme = (0, _useTheme["default"])();
  var token = theme.components.Select;

  var _useTreeSelectInput = (0, _useTreeSelectInput2["default"])(props),
      getInputLabel = _useTreeSelectInput.getInputLabel,
      getTagText = _useTreeSelectInput.getTagText,
      handleRemoveTag = _useTreeSelectInput.handleRemoveTag,
      handleInput = _useTreeSelectInput.handleInput;

  var inputRestProps = (0, _omit2["default"])(props, _const.allTreeSelectInputProps);
  var finalSuffixNode = (0, _react.useMemo)(function () {
    var finalSuffixNode = [];

    if (suffixNode) {
      finalSuffixNode.push(suffixNode);
    }

    if (!hideExpandIcon) {
      var DefaultExpandIcon = token.expandIcon || _FoldIcon2.FoldIcon;
      finalSuffixNode.push( /*#__PURE__*/_react["default"].createElement(_ExpandWrapper["default"], {
        key: "expand-icon",
        theme: theme,
        $expanded: popupVisible
      }, /*#__PURE__*/_react["default"].createElement(_ExpandIcon["default"], {
        icon: expandIcon,
        DefaultIcon: DefaultExpandIcon,
        disabled: disabled
      })));
    }

    return finalSuffixNode;
  }, [disabled, expandIcon, hideExpandIcon, popupVisible, suffixNode, theme, token.expandIcon]);

  var renderSingleModeNode = function renderSingleModeNode() {
    var inputProps = (0, _extends2["default"])({}, inputRestProps, {
      disabled: disabled,
      readOnly: readOnly,
      width: typeof width === 'string' && (0, _endsWith2["default"])(width, '%') ? '100%' : width,
      placeholder: placeholder,
      prefixNode: prefixNode,
      value: inputValue,
      inputRef: inputRef,
      suffixNode: finalSuffixNode,
      clearReplace: clearReplace,
      onInput: handleInput,
      onClear: onClear
    });
    var label = getInputLabel();

    if (showSearch && popupVisible) {
      if (!backfill) {
        inputProps.placeholder = "".concat(label) || placeholder;
      }
    } else {
      inputProps.value = "".concat(label);
      inputProps.readOnly = true;
    }

    var inputElement = /*#__PURE__*/_react["default"].createElement(_Input["default"], {
      type: "text"
    });

    return /*#__PURE__*/(0, _react.cloneElement)(inputElement, (0, _extends2["default"])({
      ref: ref
    }, inputProps));
  }; // 渲染 input 和 tag


  var renderMultipleModeNode = function renderMultipleModeNode() {
    return /*#__PURE__*/_react["default"].createElement(_Input.TagsInput, (0, _extends2["default"])({}, inputRestProps, {
      ref: ref,
      inputRef: inputRef,
      suffixNode: finalSuffixNode,
      width: typeof width === 'string' && (0, _endsWith2["default"])(width, '%') ? '100%' : width,
      disabled: disabled,
      readOnly: readOnly,
      inputReadOnly: !showSearch,
      value: filterTag ? value.filter(filterTag) : value,
      disabledValue: disabledValue,
      inputValue: inputValue,
      placeholder: hasValue ? '' : placeholder,
      getTagText: getTagText,
      scrollTopAfterEffect: !popupVisible,
      maxTagTextLength: maxTagTextLength,
      maxVerticalTagCount: maxVerticalTagCount,
      maxTagWidth: maxTagWidth,
      onRemoveTag: handleRemoveTag,
      onInput: handleInput,
      onClear: onClear,
      renderTag: renderTag
    }));
  };

  var renderInput = function renderInput() {
    if (multiple) {
      return renderMultipleModeNode();
    } else {
      return renderSingleModeNode();
    }
  };

  return /*#__PURE__*/_react["default"].createElement(_styled.StyledPopperInputWrapper, (0, _extends2["default"])({
    id: id,
    role: "combobox",
    key: "selection",
    $pointer: !multiple && !showSearch && !disabled && !readOnly,
    $popupVisible: popupVisible,
    $width: (0, _addPx["default"])(width),
    $status: status,
    theme: theme
  }, wrapperStyleItem), renderInput());
});

var _default = TreeSelectInput;
exports["default"] = _default;