"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useTreeSelectInput;

function useTreeSelectInput(props) {
  var value = props.value,
      treeKeyEntities = props.treeKeyEntities,
      showSearch = props.showSearch,
      onInput = props.onInput,
      onInputChange = props.onInputChange,
      onSearch = props.onSearch,
      onDeselect = props.onDeselect;

  var getInputLabel = function getInputLabel() {
    var selectNodeKey = value[0];
    var nodeEntity = treeKeyEntities[selectNodeKey];

    if (nodeEntity) {
      return "".concat(nodeEntity.node.title);
    }

    return '';
  };

  var getTagText = function getTagText(value) {
    var key = value;

    if (treeKeyEntities[key]) {
      return treeKeyEntities[key].node.title;
    }

    return '';
  }; // tag event


  var handleRemoveTag = function handleRemoveTag(value, index, e) {
    onDeselect(value, e);
  }; // input event


  var handleInput = function handleInput(e) {
    var newInputValue = e.target.value;
    onInputChange(newInputValue);

    if (showSearch && onSearch) {
      onSearch(newInputValue);
    }

    if (onInput) {
      onInput(e);
    }
  };

  return {
    getInputLabel: getInputLabel,
    getTagText: getTagText,
    handleRemoveTag: handleRemoveTag,
    handleInput: handleInput
  };
}