"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useEventCallback2 = require("@muya-ui/utils/lib/hooks/useEventCallback");

var _useForkRef2 = require("@muya-ui/utils/lib/hooks/useForkRef");

var _useMountedRef2 = require("@muya-ui/utils/lib/hooks/useMountedRef");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _isBoolean2 = _interopRequireDefault(require("lodash/isBoolean"));

var _events = require("events");

var _react = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _Animation = _interopRequireDefault(require("../Animation"));

var _Popper = _interopRequireDefault(require("../Popper"));

var _Arrow = require("../styled/components/Arrow");

var _getSlideDirection = _interopRequireDefault(require("../utils/getSlideDirection"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _styled = require("./styled");

var _excluded = ["triggerId", "children", "triggerActions", "triggerAction", "enterDelay", "leaveDelay", "onVisibleChange", "onClickAway", "open", "defaultOpen", "outsideCloseable", "insideCloseable", "placement", "popperProps", "TransitionComponent", "transitionProps", "container", "popup", "offset", "hideArrow", "arrowStyle", "onEscapeKeyDown", "popperNodeRef", "escapeKeyCloseable", "arrowAdaptive", "arrowPointAtCenter", "flip", "disableOpenOnExiting", "zIndex"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var ctx = new _events.EventEmitter();
ctx.setMaxListeners(30);
document.addEventListener('click', function (e) {
  ctx.emit('click_away', e);
});
var Trigger = (0, _memoForwardRef["default"])(function (props, ref) {
  var triggerId = props.triggerId,
      children = props.children,
      triggerActions = props.triggerActions,
      triggerAction = props.triggerAction,
      _props$enterDelay = props.enterDelay,
      enterDelay = _props$enterDelay === void 0 ? 0 : _props$enterDelay,
      _props$leaveDelay = props.leaveDelay,
      leaveDelay = _props$leaveDelay === void 0 ? 0 : _props$leaveDelay,
      onVisibleChange = props.onVisibleChange,
      onClickAway = props.onClickAway,
      _props$open = props.open,
      openProp = _props$open === void 0 ? false : _props$open,
      _props$defaultOpen = props.defaultOpen,
      defaultOpen = _props$defaultOpen === void 0 ? false : _props$defaultOpen,
      _props$outsideCloseab = props.outsideCloseable,
      outsideCloseable = _props$outsideCloseab === void 0 ? true : _props$outsideCloseab,
      _props$insideCloseabl = props.insideCloseable,
      insideCloseable = _props$insideCloseabl === void 0 ? true : _props$insideCloseabl,
      _props$placement = props.placement,
      placement = _props$placement === void 0 ? 'bottom' : _props$placement,
      _props$popperProps = props.popperProps,
      popperProps = _props$popperProps === void 0 ? {} : _props$popperProps,
      _props$TransitionComp = props.TransitionComponent,
      TransitionComponent = _props$TransitionComp === void 0 ? _Animation["default"].Slide : _props$TransitionComp,
      transitionProps = props.transitionProps,
      container = props.container,
      popup = props.popup,
      offset = props.offset,
      _props$hideArrow = props.hideArrow,
      hideArrow = _props$hideArrow === void 0 ? false : _props$hideArrow,
      _props$arrowStyle = props.arrowStyle,
      arrowStyle = _props$arrowStyle === void 0 ? {} : _props$arrowStyle,
      onEscapeKeyDown = props.onEscapeKeyDown,
      popperNodeRef = props.popperNodeRef,
      _props$escapeKeyClose = props.escapeKeyCloseable,
      escapeKeyCloseable = _props$escapeKeyClose === void 0 ? true : _props$escapeKeyClose,
      _props$arrowAdaptive = props.arrowAdaptive,
      arrowAdaptive = _props$arrowAdaptive === void 0 ? false : _props$arrowAdaptive,
      _props$arrowPointAtCe = props.arrowPointAtCenter,
      arrowPointAtCenter = _props$arrowPointAtCe === void 0 ? false : _props$arrowPointAtCe,
      _props$flip = props.flip,
      flip = _props$flip === void 0 ? true : _props$flip,
      _props$disableOpenOnE = props.disableOpenOnExiting,
      disableOpenOnExiting = _props$disableOpenOnE === void 0 ? false : _props$disableOpenOnE,
      zIndex = props.zIndex,
      rest = (0, _objectWithoutProperties2["default"])(props, _excluded);

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      childIsFocusVisible = _useState2[0],
      setChildIsFocusVisible = _useState2[1];

  var _useState3 = (0, _react.useState)(defaultOpen),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      openState = _useState4[0],
      setOpenState = _useState4[1];

  var _useState5 = (0, _react.useState)(),
      _useState6 = (0, _slicedToArray2["default"])(_useState5, 2),
      childNode = _useState6[0],
      setChildNode = _useState6[1];

  var _React$useState = _react["default"].useState(null),
      _React$useState2 = (0, _slicedToArray2["default"])(_React$useState, 2),
      arrowRef = _React$useState2[0],
      setArrowRef = _React$useState2[1];

  var _useState7 = (0, _react.useState)(placement),
      _useState8 = (0, _slicedToArray2["default"])(_useState7, 2),
      realPlacement = _useState8[0],
      setRealPlacement = _useState8[1];

  var _useState9 = (0, _react.useState)(function () {
    return (0, _getSlideDirection["default"])(placement);
  }),
      _useState10 = (0, _slicedToArray2["default"])(_useState9, 2),
      direction = _useState10[0],
      setDirection = _useState10[1];

  var _useState11 = (0, _react.useState)(false),
      _useState12 = (0, _slicedToArray2["default"])(_useState11, 2),
      exiting = _useState12[0],
      setExiting = _useState12[1];

  var enterTimer = (0, _react.useRef)();
  var leaveTimer = (0, _react.useRef)();
  var mountedRef = (0, _useMountedRef2.useMountedRef)(); // 优先级：triggerActions > triggerAction > 默认值：['hover']

  var finalTriggerActions = (0, _react.useMemo)(function () {
    if (triggerActions) {
      return triggerActions;
    } else if (triggerAction) {
      return [triggerAction];
    }

    return ['hover'];
  }, [triggerAction, triggerActions]); // 处理子节点的ref

  var handleOwnRef = _react["default"].useCallback(function (instance) {
    // eslint-disable-next-line react/no-find-dom-node
    setChildNode(_reactDom["default"].findDOMNode(instance));
  }, []);

  var handleChildrenRef = (0, _useForkRef2.useForkRef)(children.ref, handleOwnRef);
  var handleRef = (0, _useForkRef2.useForkRef)(handleChildrenRef, ref); // 处理popper弹出层节点的ref

  var popperRef = (0, _react.useRef)(null);
  var handlePopperRef = (0, _useForkRef2.useForkRef)(popperRef, popperNodeRef);
  var other = rest; // other会全量透传给children，类型无法确定，因此为any

  var isControlled = ('open' in props);
  var open = isControlled ? openProp : openState;
  var getContainer = (0, _react.useCallback)(function () {
    if (typeof container === 'function') {
      return container(childNode);
    } else {
      return container;
    }
  }, [childNode, container]);
  var handleAnimationExit = (0, _useEventCallback2.useEventCallback)(function (node) {
    setExiting(true);

    if (transitionProps && transitionProps.onExit) {
      transitionProps.onExit(node);
    }
  });
  var handleAnimationExited = (0, _useEventCallback2.useEventCallback)(function (node) {
    setExiting(false);

    if (transitionProps && transitionProps.onExited) {
      transitionProps.onExited(node);
    }
  });
  var finalTransitionProps = (0, _react.useMemo)(function () {
    return (0, _extends2["default"])({}, transitionProps, {
      onExit: handleAnimationExit,
      onExited: handleAnimationExited
    });
  }, [handleAnimationExit, handleAnimationExited, transitionProps]);
  var handleOpen = (0, _useEventCallback2.useEventCallback)(function () {
    if (disableOpenOnExiting && exiting) return;

    if (!isControlled) {
      setOpenState(true);
    }

    if (onVisibleChange && !open) {
      onVisibleChange(true);
    }
  });
  var handleClose = (0, _useEventCallback2.useEventCallback)(function () {
    if (!isControlled) {
      setOpenState(false);
    }

    if (onVisibleChange && open) {
      onVisibleChange(false);
    }
  });
  var handleEnter = (0, _useEventCallback2.useEventCallback)(function (e) {
    var childrenProps = children.props;

    if (e.type === 'mouseenter') {
      if (childrenProps.onMouseEnter) {
        childrenProps.onMouseEnter(e);
      }

      if (other.onMouseEnter) {
        other.onMouseEnter(e);
      }
    }

    clearTimeout(enterTimer.current);
    clearTimeout(leaveTimer.current);
    e.persist();
    enterTimer.current = setTimeout(function () {
      handleOpen();
    }, enterDelay);
  }, []);
  var handleBlur = (0, _useEventCallback2.useEventCallback)(function () {
    if (childIsFocusVisible) {
      setChildIsFocusVisible(false);
    }
  }, []);
  var handleFocus = (0, _useEventCallback2.useEventCallback)(function (e) {
    // Workaround for https://github.com/facebook/react/issues/7769
    // The autoFocus of React might trigger the event before the componentDidMount.
    // We need to account for this eventuality.

    /* istanbul ignore if */
    if (!childNode) {
      setChildNode(e.currentTarget);
    }

    setChildIsFocusVisible(true);
    handleEnter(e);
    var childrenProps = children.props;

    if (childrenProps.onFocus) {
      childrenProps.onFocus(e);
    }

    if (other.onFocus) {
      other.onFocus(e);
    }
  }, []);
  var handleLeave = (0, _useEventCallback2.useEventCallback)(function (e) {
    var childrenProps = children.props;

    if (e.type === 'blur') {
      if (childrenProps.onBlur) {
        childrenProps.onBlur(e);
      }

      if (other.onBlur) {
        other.onBlur(e);
      }

      handleBlur();
    }

    if (e.type === 'mouseleave') {
      if (childrenProps.onMouseLeave) {
        childrenProps.onMouseLeave(e);
      }

      if (other.onMouseLeave) {
        other.onMouseLeave(e);
      }
    }

    clearTimeout(enterTimer.current);
    clearTimeout(leaveTimer.current);
    e.persist();
    leaveTimer.current = setTimeout(function () {
      handleClose();
    }, leaveDelay);
  }, []);
  var handleClick = (0, _useEventCallback2.useEventCallback)(function (e) {
    var childrenProps = children.props;

    if (childrenProps.onClick) {
      childrenProps.onClick(e);
    }

    if (other.onClick) {
      other.onClick(e);
    }

    if (open) {
      if (insideCloseable) {
        handleClose();
      }
    } else {
      handleOpen();
    }
  }, []);
  var handleKeyDown = (0, _useEventCallback2.useEventCallback)(function (event) {
    event.stopPropagation(); // 按下ESC键触发的回调

    if (event.key === 'Escape') {
      onEscapeKeyDown && onEscapeKeyDown(event);

      if (escapeKeyCloseable) {
        // childNode should blur
        childNode && childNode.blur(); // hide trigger

        handleClose();
      }
    }

    if (children.props.onKeyDown) {
      children.props.onKeyDown(event);
    }

    if (other.onKeyDown) {
      other.onKeyDown(event);
    }
  }, []);
  var handleContextMenu = (0, _useEventCallback2.useEventCallback)(function (e) {
    e.preventDefault();
  });
  var handleMouseUp = (0, _useEventCallback2.useEventCallback)(function (e) {
    // 右键点击
    if (e.button === 2) {
      var _childrenProps = children.props;

      if (_childrenProps.onClick) {
        _childrenProps.onClick(e);
      }

      if (other.onClick) {
        other.onClick(e);
      }

      if (open) {
        if (insideCloseable) {
          handleClose();
        }
      } else {
        handleOpen();
      }
    }
  });
  var onPopperCreate = (0, _react.useCallback)(function (data) {
    if (data.placement !== realPlacement) {
      setRealPlacement(data.placement);
      setDirection((0, _getSlideDirection["default"])(data.placement));
    }

    if (popperProps.popperOptions && popperProps.popperOptions.onCreate) {
      popperProps.popperOptions.onCreate(data);
    }
  }, [popperProps.popperOptions, realPlacement]);

  var handleClickAway = _react["default"].useCallback(function (event) {
    // Ignore events that have been `event.preventDefault()` marked.

    /* istanbul ignore if */
    if (event.defaultPrevented) {
      return;
    } // IE 11 support, which trigger the handleClickAway even after the unbind

    /* istanbul ignore if */


    if (!mountedRef.current) {
      return;
    }
    /* istanbul ignore if */


    if (!childNode) {
      return;
    }

    var doc = childNode && childNode.ownerDocument || document;

    if (doc.documentElement && doc.documentElement.contains(event.target) && !childNode.contains(event.target) && // 子节点不包含event.target
    !(popperRef.current && popperRef.current.contains(event.target)) // Popper节点不包含event.target
    ) {
      onClickAway && onClickAway(event);

      if (outsideCloseable) {
        handleClose();
      }
    }
  }, [childNode, handleClose, mountedRef, onClickAway, outsideCloseable]);

  _react["default"].useEffect(function () {
    if (finalTriggerActions.indexOf('click') > -1 || finalTriggerActions.indexOf('contextMenu') > -1) {
      /**
       * FIXME: 原生的 addEventListener，在 rerender 时表现不正常，暂时用此写法
       */
      ctx.on('click_away', handleClickAway); // document.addEventListener('click', handleClickAway);

      return function () {
        ctx.removeListener('click_away', handleClickAway); // document.removeEventListener('click', handleClickAway);
      };
    }
  }, [finalTriggerActions, handleClickAway]);

  _react["default"].useEffect(function () {
    return function () {
      clearTimeout(enterTimer.current);
      clearTimeout(leaveTimer.current);
    };
  }, []);

  var childrenProps = (0, _extends2["default"])({
    'aria-describedby': open ? triggerId : null
  }, other, children.props);
  var interactiveWrapperListeners = {};

  if (!other.disabled) {
    if (finalTriggerActions.indexOf('hover') > -1) {
      childrenProps.onMouseEnter = handleEnter;
      childrenProps.onMouseLeave = handleLeave;
      interactiveWrapperListeners.onMouseEnter = handleEnter;
      interactiveWrapperListeners.onMouseLeave = handleLeave;
    }

    if (finalTriggerActions.indexOf('focus') > -1) {
      childrenProps.onFocus = handleFocus;
      childrenProps.onBlur = handleLeave;
      childrenProps.onKeyDown = handleKeyDown;
      interactiveWrapperListeners.onFocus = childrenProps.onFocus;
      interactiveWrapperListeners.onBlur = childrenProps.onBlur;
    }

    if (finalTriggerActions.indexOf('click') > -1) {
      childrenProps.onClick = handleClick;
      childrenProps.onKeyDown = handleKeyDown;
    }

    if (finalTriggerActions.indexOf('contextMenu') > -1) {
      childrenProps.onContextMenu = handleContextMenu;
      childrenProps.onMouseUp = handleMouseUp;
      childrenProps.onKeyDown = handleKeyDown;
    }
  } // Fix Tooltip won't hide at disabled button
  // mouse events don't trigger at disabled button in Chrome


  var getDisabledCompatibleChildren = function getDisabledCompatibleChildren(element) {
    // Muya Button用span包裹会导致样式问题，直接使用span类型的Button即可
    if (element.type.__MUYA_BUTTON && element.props.disabled) {
      return /*#__PURE__*/_react["default"].cloneElement(element, (0, _extends2["default"])({
        ref: handleRef,
        component: 'span'
      }, childrenProps));
    }

    if ((element.type === 'button' || element.type.__MUYA_SWITCH === true || element.type.__MUYA_RADIO === true || element.type.__MUYA_CHECKBOX === true) && element.props.disabled) {
      var displayStyle = element.props.style && element.props.style.display ? element.props.style.display : 'inline-block';

      var child = /*#__PURE__*/_react["default"].cloneElement(element, {
        style: (0, _extends2["default"])({}, element.props.style, {
          pointerEvents: 'none'
        })
      });

      var spanStyle = {
        display: displayStyle,
        cursor: 'not-allowed'
      };
      return /*#__PURE__*/_react["default"].createElement('span', (0, _extends2["default"])({
        ref: handleRef
      }, childrenProps, {
        style: spanStyle // children: child,

      }), child);
    }

    return /*#__PURE__*/_react["default"].cloneElement(element, (0, _extends2["default"])({
      ref: handleRef
    }, childrenProps));
  }; // arrowPointAtCenter逻辑


  var offsetEnable = false;
  var flipSetting = (0, _react.useMemo)(function () {
    return (0, _isBoolean2["default"])(flip) ? {
      enabled: flip
    } : flip;
  }, [flip]);
  var offsetValue = 0;
  var mainPlacement = placement.split('-')[0];
  var subPlacement = placement.split('-')[1];

  if (subPlacement && childNode) {
    var arrowMargin = arrowStyle.margin || _styled.defaultArrowMargin;
    var arrowWidth = arrowStyle.width || _styled.defaultArrowWidth;

    var _childNode$getBoundin = childNode.getBoundingClientRect(),
        width = _childNode$getBoundin.width,
        height = _childNode$getBoundin.height;

    var elementHalf = (mainPlacement === 'top' || mainPlacement === 'bottom' ? width : height) / 2;
    var arrowHalf = arrowWidth / 2;
    var rawOffsetValue = elementHalf - arrowHalf - arrowMargin; // 偏移量

    var autoCenter = rawOffsetValue <= 0; // 元素宽度过小时，箭头自动居中

    if ((arrowPointAtCenter || autoCenter) && !hideArrow) {
      flipSetting.enabled = false; // Popper.js中若要开启offset，需要先关闭flip

      offsetEnable = true;
      offsetValue = subPlacement === 'start' ? rawOffsetValue : -rawOffsetValue;
    }
  }

  var modifiers = (0, _react.useMemo)(function () {
    return (0, _extends2["default"])({
      flip: flipSetting,
      offset: {
        enabled: offsetEnable,
        offset: offsetValue
      },
      arrow: {
        enabled: arrowAdaptive && !hideArrow && Boolean(arrowRef),
        element: arrowRef
      }
    }, popperProps.modifiers);
  }, [arrowAdaptive, arrowRef, flipSetting, hideArrow, offsetEnable, offsetValue, popperProps.modifiers]);
  var popperOptions = (0, _react.useMemo)(function () {
    return (0, _extends2["default"])({}, popperProps.popperOptions, {
      onCreate: onPopperCreate
    });
  }, [onPopperCreate, popperProps.popperOptions]);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, getDisabledCompatibleChildren(children), /*#__PURE__*/_react["default"].createElement(_Popper["default"], (0, _extends2["default"])({
    ref: handlePopperRef,
    placement: placement,
    anchorEl: childNode,
    open: childNode ? open : false,
    id: childrenProps['aria-describedby'],
    container: getContainer,
    transition: true,
    transitionProps: finalTransitionProps
  }, interactiveWrapperListeners, popperProps, {
    modifiers: modifiers,
    popperOptions: popperOptions,
    zIndex: zIndex
  }), function (_ref) {
    var transitionProps = _ref.transitionProps;
    return /*#__PURE__*/_react["default"].createElement(TransitionComponent, (0, _extends2["default"])({
      direction: direction
    }, transitionProps), /*#__PURE__*/_react["default"].createElement(_styled.StyledTriggerWrapper, {
      placement: realPlacement,
      offset: offset,
      hideArrow: hideArrow,
      arrowStyle: arrowStyle
    }, popup, !hideArrow && /*#__PURE__*/_react["default"].createElement(_Arrow.StyledArrow, {
      ref: setArrowRef,
      placement: realPlacement,
      arrowStyle: arrowStyle
    })));
  }));
});
var _default = Trigger;
exports["default"] = _default;