"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultOffset = exports.defaultArrowWidth = exports.defaultArrowMargin = exports.defaultArrowHeight = exports.StyledTriggerWrapper = void 0;
exports.makeTriggerWrapperStyle = makeTriggerWrapperStyle;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultArrowWidth = 12;
exports.defaultArrowWidth = defaultArrowWidth;
var defaultArrowHeight = 6;
exports.defaultArrowHeight = defaultArrowHeight;
var defaultOffset = 6;
exports.defaultOffset = defaultOffset;
var defaultArrowMargin = 16;
exports.defaultArrowMargin = defaultArrowMargin;

function makeTriggerWrapperStyle(props) {
  var _props$placement = props.placement,
      placement = _props$placement === void 0 ? 'top' : _props$placement,
      _props$offset = props.offset,
      offset = _props$offset === void 0 ? defaultOffset : _props$offset,
      _props$arrowStyle = props.arrowStyle,
      arrowStyle = _props$arrowStyle === void 0 ? {} : _props$arrowStyle,
      hideArrow = props.hideArrow;
  var mainPlacement = placement.split('-')[0];
  var arrowHeight = arrowStyle.height || defaultArrowHeight;
  var margin = hideArrow ? offset : offset + arrowHeight;
  var placementStyles = {
    top: (0, _styledComponents.css)(["margin-bottom:", "px;"], margin),
    right: (0, _styledComponents.css)(["margin-left:", "px;"], margin),
    bottom: (0, _styledComponents.css)(["margin-top:", "px;"], margin),
    left: (0, _styledComponents.css)(["margin-right:", "px;"], margin)
  };
  return (0, _styledComponents.css)(["position:relative;", ""], placementStyles[mainPlacement]);
}

var StyledTriggerWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledTriggerWrapper"
})(["", ""], makeTriggerWrapperStyle);

exports.StyledTriggerWrapper = StyledTriggerWrapper;