"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _withTheme = require("../utils/withTheme");

var _mixin = require("./mixin");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Text = _styledComponents["default"].span.withConfig({
  displayName: "Text"
})(["", ""], function (props) {
  var ellipsis = props.ellipsis,
      type = props.type,
      strong = props.strong,
      color = props.color,
      theme = props.theme;
  var colors = theme.colors,
      typography = theme.typography,
      token = theme.components.Typography;

  var _getFontStyle = (0, _mixin.getFontStyle)(props, theme),
      lineHeight = _getFontStyle.lineHeight,
      fontSize = _getFontStyle.fontSize;

  return (0, _styledComponents.css)(["", ";color:", ";font-weight:", ";font-size:", ";line-height:", ";", ""], ellipsis && 'display: inline-block', type ? colors.pattern.feature[type] : colors.pattern.text[color || token.defaultTextType], strong && typography.spec.fontWeight.semibold, fontSize, lineHeight, _mixin.baseStyle);
});

var _default = (0, _withTheme.withThemeForStyled)(Text);

exports["default"] = _default;