"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.StyledTitle = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _mixin = require("./mixin");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledTitle = _styledComponents["default"].div.withConfig({
  displayName: "StyledTitle"
})(["", ""], function (props) {
  var _props$theme = props.theme,
      colors = _props$theme.colors,
      typography = _props$theme.typography,
      token = _props$theme.components.Typography,
      color = props.color,
      level = props.level,
      marginBottom = props.marginBottom,
      marginTop = props.marginTop;
  var fontLevel = token.titleFontLevelMap["h".concat(level)];
  return (0, _styledComponents.css)(["", " color:", ";font-weight:", ";font-size:", "px;line-height:", "px;", " & + &{", "}"], _mixin.baseStyle, colors.pattern.text[color || token.defaultTitleType], typography.spec.fontWeight.semibold, typography.spec.fontSize[fontLevel], typography.spec.lineHeight[fontLevel], typeof marginBottom === 'undefined' && "margin-bottom: ".concat(token.titleMarginBottom, ";"), typeof marginTop === 'undefined' && "margin-top: ".concat(token.titleMarginTop, ";"));
});

exports.StyledTitle = StyledTitle;

var _default = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var _props$level = props.level,
      level = _props$level === void 0 ? 1 : _props$level;
  var asProp = "h".concat(level);
  var theme = (0, _useTheme["default"])();
  return /*#__PURE__*/_react["default"].createElement(StyledTitle, (0, _extends2["default"])({
    theme: theme,
    as: asProp
  }, props, {
    level: level,
    ref: ref
  }));
});

exports["default"] = _default;