"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getFontStyle = exports.baseStyle = void 0;

var _styledComponents = require("styled-components");

var _ellipsis = require("../styled/mixins/ellipsis");

var _addPx = _interopRequireDefault(require("../utils/addPx"));

var baseStyle = (0, _styledComponents.css)(["box-sizing:border-box;margin:0;", ""], function (props) {
  var deleteProp = props["delete"],
      underline = props.underline,
      ellipsis = props.ellipsis,
      marginTop = props.marginTop,
      marginBottom = props.marginBottom,
      vertialAlign = props.vertialAlign;
  return (0, _styledComponents.css)(["", ";", ";", ";", ";", ";", ""], deleteProp && 'text-decoration: line-through', underline && 'text-decoration: underline', marginTop && "margin-top: ".concat((0, _addPx["default"])(marginTop)), marginBottom && "margin-bottom: ".concat((0, _addPx["default"])(marginBottom)), vertialAlign && "vertical-align: ".concat(vertialAlign), ellipsis && (0, _ellipsis.makeEllipsisStyle)(ellipsis));
});
exports.baseStyle = baseStyle;

var getFontStyle = function getFontStyle(props, theme) {
  var lineHeightProp = props.lineHeight,
      fontSizeProp = props.fontSize;
  var typography = theme.typography,
      token = theme.components.Typography;
  var fontSize;
  var lineHeight;

  if (typeof fontSizeProp === 'number') {
    fontSize = "".concat(fontSizeProp, "px");
  } else {
    fontSize = "".concat(typography.spec.fontSize[fontSizeProp || token.defaultFontLevel], "px");
  }

  if (lineHeightProp) {
    lineHeight = lineHeightProp;
  } else if (typeof fontSizeProp === 'number') {
    lineHeight = typography.spec.global.lineHeight;
  } else {
    lineHeight = "".concat(typography.spec.lineHeight[fontSizeProp || token.defaultFontLevel], "px");
  }

  return {
    fontSize: fontSize,
    lineHeight: lineHeight
  };
};

exports.getFontStyle = getFontStyle;