"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _UploadCard = _interopRequireDefault(require("./UploadCard"));

var _UploadResult = _interopRequireDefault(require("./UploadResult"));

var _useUpload = _interopRequireDefault(require("./useUpload"));

var _excluded = ["children", "render"];
var Upload = (0, _memoForwardRef["default"])(function (props, ref) {
  var children = props.children,
      render = props.render,
      uploadOption = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var state = (0, _useUpload["default"])(uploadOption);

  _react["default"].useImperativeHandle(ref, function () {
    return {
      open: state.open
    };
  });

  if (render) {
    return render(state);
  }

  if (children) {
    return children(state);
  }

  return null;
});
Upload.Result = _UploadResult["default"];
Upload.Card = _UploadCard["default"];
Upload.useUpload = _useUpload["default"];
var _default = Upload;
exports["default"] = _default;