"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _Typography = _interopRequireDefault(require("../Typography"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _excluded = ["title", "subtitle", "icon", "children", "size", "disabled", "isDragActive", "width", "height", "styles"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  titleWrapper: '',
  iconWrapper: '',
  subtitleWrapper: ''
};

var _default = (0, _memoForwardRef["default"])(function (props, ref) {
  var title = props.title,
      subtitle = props.subtitle,
      icon = props.icon,
      children = props.children,
      _props$size = props.size,
      size = _props$size === void 0 ? 'm' : _props$size,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      _props$isDragActive = props.isDragActive,
      isDragActive = _props$isDragActive === void 0 ? false : _props$isDragActive,
      width = props.width,
      height = props.height,
      styles = props.styles,
      other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var innerStyles = (0, _useStyles["default"])('upload-card', defaultStyles, styles);
  var token = theme.components.Upload.card;
  var innerChildren = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_styled.StyledUploadCardIcon, innerStyles.iconWrapper, icon), title && /*#__PURE__*/_react["default"].createElement(_Typography["default"].Text, (0, _extends2["default"])({
      fontSize: token.titleFontLevel,
      color: "assistant",
      marginTop: token.titleMarginTop
    }, innerStyles.titleWrapper), title), subtitle && /*#__PURE__*/_react["default"].createElement(_Typography["default"].Text, (0, _extends2["default"])({
      fontSize: token.subTitleFontLevel,
      color: "secondary",
      marginTop: token.subTitleMarginTop
    }, innerStyles.subtitleWrapper), subtitle));
  }, [icon, innerStyles.iconWrapper, innerStyles.subtitleWrapper, innerStyles.titleWrapper, subtitle, title, token.subTitleFontLevel, token.subTitleMarginTop, token.titleFontLevel, token.titleMarginTop]);
  return /*#__PURE__*/_react["default"].createElement(_styled.StyledUploadCard, (0, _extends2["default"])({
    ref: ref,
    theme: theme,
    $disabled: disabled,
    $isDragActive: isDragActive,
    $width: width,
    $height: height,
    $size: size
  }, other), innerChildren, children);
});

exports["default"] = _default;