"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledUploadResult = exports.StyledUploadCardIcon = exports.StyledUploadCard = exports.StyledRetryButton = exports.StyledResultCloseIconWrapper = exports.StyledProgress = exports.StyledPictureCloseIconWrapper = exports.StyledImgWrapper = exports.StyledFilenameWrapper = exports.StyledErrorWrapper = exports.StyledContentWrapper = exports.StyledButton = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _Img = _interopRequireDefault(require("../Img"));

var _InlineButton = _interopRequireDefault(require("../InlineButton"));

var _Progress = _interopRequireDefault(require("../Progress"));

var _addPx = _interopRequireDefault(require("../utils/addPx"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledImgWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledImgWrapper"
})([""]);

exports.StyledImgWrapper = StyledImgWrapper;

var StyledContentWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledContentWrapper"
})(["display:flex;flex-flow:column nowrap;flex:1;overflow:hidden;"]);

exports.StyledContentWrapper = StyledContentWrapper;

var StyledFilenameWrapper = _styledComponents["default"].span.withConfig({
  displayName: "StyledFilenameWrapper"
})(["overflow:hidden;text-overflow:ellipsis;white-space:nowrap;padding-right:", ";"], function (props) {
  return "".concat(props.theme.components.Upload.card.titlePaddingRight, "px");
});

exports.StyledFilenameWrapper = StyledFilenameWrapper;
var StyledProgress = (0, _styledComponents["default"])(_Progress["default"]).withConfig({
  displayName: "StyledProgress"
})([""]);
exports.StyledProgress = StyledProgress;
var StyledButton = (0, _styledComponents["default"])(_InlineButton["default"]).withConfig({
  displayName: "StyledButton"
})(["&&{display:flex;align-items:center;justify-content:flex-start;width:100%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;opacity:1;cursor:", ";}"], function (props) {
  return props.href ? 'pointer' : 'default';
});
exports.StyledButton = StyledButton;
var StyledResultCloseIconWrapper = (0, _styledComponents["default"])(_IconButton["default"]).withConfig({
  displayName: "StyledResultCloseIconWrapper"
})([""]);
exports.StyledResultCloseIconWrapper = StyledResultCloseIconWrapper;
var StyledRetryButton = (0, _styledComponents["default"])(_InlineButton["default"]).withConfig({
  displayName: "StyledRetryButton"
})([""]);
exports.StyledRetryButton = StyledRetryButton;

var StyledErrorWrapper = _styledComponents["default"].span.withConfig({
  displayName: "StyledErrorWrapper"
})(["display:flex;"]);

exports.StyledErrorWrapper = StyledErrorWrapper;

var StyledPictureCloseIconWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledPictureCloseIconWrapper"
})(["display:flex;justify-content:center;align-items:center;position:absolute;right:-10px;top:-10px;width:20px;height:20px;font-size:12px;border-radius:50%;z-index:1;color:", ";background:", ";cursor:pointer;&:hover{background:", ";}"], function (props) {
  return props.theme.colors.spec.light;
}, function (props) {
  return props.theme.colors.spec.neutral1.normal;
}, function (props) {
  return props.theme.colors.spec.neutral2.normal;
});

exports.StyledPictureCloseIconWrapper = StyledPictureCloseIconWrapper;

var StyledUploadResult = _styledComponents["default"].div.withConfig({
  displayName: "StyledUploadResult"
})(["", ""], function (props) {
  var _props$$type = props.$type,
      $type = _props$$type === void 0 ? 'picture-card' : _props$$type,
      theme = props.theme,
      _props$$size = props.$size,
      $size = _props$$size === void 0 ? 'm' : _props$$size,
      $status = props.$status,
      $url = props.$url;
  var token = theme.components.Upload;
  var _theme$components$Upl = theme.components.Upload,
      pictureWidth = _theme$components$Upl.pictureWidth,
      shadow = _theme$components$Upl.shadow,
      result = _theme$components$Upl.result,
      progress = _theme$components$Upl.progress,
      card = _theme$components$Upl.card,
      retryButton = _theme$components$Upl.retryButton,
      marginTop = _theme$components$Upl.marginTop;
  var _theme$colors = theme.colors,
      colorsSpec = _theme$colors.spec,
      colorsPattern = _theme$colors.pattern;
  var pictureStyle;
  var cardStyle;
  var pictureCardStyle;

  if ($type === 'picture') {
    pictureStyle = (0, _styledComponents.css)(["display:inline-flex;width:", "px;height:", "px;flex-flow:column nowrap;justify-content:center;align-items:center;box-sizing:border-box;outline:none;border:1px solid ", ";font-size:", "px;", " ", " ", "{text-align:center;margin-top:0;}", "{margin-left:0;margin-top:", "px;}"], pictureWidth[$size], pictureWidth[$size], colorsPattern.border.normal, theme.typography.spec.fontSize.s3, $status === 'error' && (0, _styledComponents.css)(["border-color:", ";"], colorsPattern.feature.error), $status === 'uploading' && (0, _styledComponents.css)(["&:hover{background:", ";}"], colorsSpec.neutral10.normal), StyledErrorWrapper, StyledRetryButton, retryButton.marginInTypePicture[$size]);
  } else if ($type === 'card') {
    cardStyle = (0, _styledComponents.css)(["flex-flow:column nowrap;justify-content:center;width:", "px;padding:", "px ", "px;&:hover{background:", ";}&:active{background:", ";}"], result.size[$size].width, result.cardPaddingHorizontal, result.cardPaddingVertial, $url ? card.hasUrlBackground.hover : card.background.hover, $url ? card.hasUrlBackground.clicked : card.background.clicked);
  } else if ($type === 'picture-card') {
    pictureCardStyle = (0, _styledComponents.css)(["align-items:center;width:", "px;height:", "px;background:", ";padding:", "px;padding-right:", "px;box-shadow:", ";&:hover{box-shadow:", ";}", "{width:", "px;margin-right:", "px;}", "{top:", "px;}"], result.size[$size].width, result.size[$size].height, theme.colors.spec.light, theme.spacing.spec.s4, theme.spacing.spec.s6, shadow.normal, shadow.hover, StyledImgWrapper, result.size[$size].imgWidth, theme.spacing.spec.s6, StyledResultCloseIconWrapper, token.result.closeIconSpacing[$size]);
  }

  return (0, _styledComponents.css)(["position:relative;display:flex;box-sizing:border-box;border-radius:", ";", "{width:100%;border-radius:", ";&:hover{opacity:", ";}}", "{position:absolute;font-size:", "px;right:", "px;}", "{margin-left:", "px;}", "{height:", "px;margin-top:", "px;}", "{margin-top:", "px;}", ";", ";", ";"], token.borderRadius, _Img["default"], token.img.borderRadius, token.img.hoverOpacity, StyledResultCloseIconWrapper, token.result.closeIconSize[$size], $type === 'card' ? 0 : token.result.closeIconSpacing[$size], StyledRetryButton, retryButton.marginInOtherType, StyledProgress, progress.height, marginTop[$size], StyledErrorWrapper, $status === 'error' ? marginTop[$size] : 0, pictureStyle, cardStyle, pictureCardStyle);
});

exports.StyledUploadResult = StyledUploadResult;
var StyledUploadCardIcon = (0, _styledComponents["default"])(_IconButton["default"]).withConfig({
  displayName: "StyledUploadCardIcon"
})([""]);
exports.StyledUploadCardIcon = StyledUploadCardIcon;

var StyledUploadCard = _styledComponents["default"].div.withConfig({
  displayName: "StyledUploadCard"
})(["", ""], function (props) {
  var _props$theme = props.theme,
      borderRadius = _props$theme.size.spec.borderRadius,
      _props$theme$colors$p = _props$theme.colors.pattern,
      text = _props$theme$colors$p.text,
      border = _props$theme$colors$p.border,
      background = _props$theme$colors$p.background,
      $disabled = props.$disabled,
      $isDragActive = props.$isDragActive,
      $width = props.$width,
      $height = props.$height,
      $size = props.$size;
  var _props$theme$componen = props.theme.components.Upload,
      token = _props$theme$componen.card,
      marginTop = _props$theme$componen.marginTop,
      progress = _props$theme$componen.progress;
  var disabledStyle = (0, _styledComponents.css)(["& > *{color:", ";}user-select:none;background:", ";cursor:not-allowed;"], text.disabled, background.disabled);
  var interactiveStyle = (0, _styledComponents.css)(["&:hover{background:", ";}", ";&:active{background:", ";}"], token.background.hover, $isDragActive && "background: ".concat(token.background.hover), token.background.clicked);
  return (0, _styledComponents.css)(["display:inline-flex;flex-flow:column nowrap;align-items:center;justify-content:center;box-sizing:border-box;outline:none;cursor:pointer;border:1px solid ", ";border-radius:", ";", ";width:", ";height:", ";", "{font-size:", "px;line-height:1;}", "{height:", "px;margin-top:", "px;}"], border.normal, borderRadius.s2, $disabled ? disabledStyle : interactiveStyle, (0, _addPx["default"])($width ? $width : token.size[$size]), (0, _addPx["default"])($height ? $height : token.size[$size]), StyledUploadCardIcon, token.iconFontLevel, StyledProgress, progress.height, marginTop[$size]);
});

exports.StyledUploadCard = StyledUploadCard;