"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.IMG_TYPES = void 0;
exports.isImgFile = isImgFile;
exports.multiRunUpload = multiRunUpload;

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var IMG_TYPES = ['image/apng', 'image/bmp', 'image/gif', 'image/x-icon', 'image/jpeg', 'image/png', 'image/svg+xml', 'image/tiff', 'image/webp'];
/**
 * 判断一个文件对象是否为img标签支持的图片文件
 *
 * @param {File} file
 * @returns
 */

exports.IMG_TYPES = IMG_TYPES;

function isImgFile(file) {
  if (!file || !file.type) {
    return false;
  }

  var fileType = file.type.toLowerCase();

  if ((0, _includes2["default"])(IMG_TYPES, fileType)) {
    return true;
  } else {
    return false;
  }
}
/**
 * 该函数实现了对列表中等待状态的文件进行上传的功能
 * @param files
 * @param fn
 * @param num
 * @returns
 */


function multiRunUpload(files, fn, num) {
  var i = num;
  var running = 0;
  var result = [];
  return new Promise(function (resolve, reject) {
    var done = function done(res) {
      running -= 1;
      result.push(res);

      if (files.length) {
        running += 1;
        var file = files.shift();
        fn(file.originFile, file).then(done)["catch"](function (e) {
          return reject(e);
        });
      } else if (running === 0) {
        resolve(result);
      }
    };

    while (i > 0 && files.length) {
      i -= 1;
      running += 1;
      var file = files.shift();
      fn(file.originFile, file).then(done)["catch"](function (e) {
        return reject(e);
      });
    }
  });
}