"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _CalendarFooter = _interopRequireDefault(require("../Calendar/CalendarFooter"));

var _CalendarHead = _interopRequireDefault(require("../Calendar/CalendarHead"));

var _CalendarPanel = _interopRequireDefault(require("../Calendar/CalendarPanel"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _useWeekCalendar2 = _interopRequireDefault(require("./useWeekCalendar"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Root = _styledComponents["default"].div.withConfig({
  displayName: "Root"
})(["width:", "px;background-color:", ";"], function (props) {
  return props.theme.components.Calendar.defaultWidth;
}, function (props) {
  return props.theme.colors.pattern.background.higher;
});

var defaultStyles = {
  head: '',
  panel: '',
  footer: ''
};
var WeekCalendar = (0, _memoForwardRef["default"])(function (props, ref) {
  var theme = (0, _useTheme["default"])();

  var _useWeekCalendar = (0, _useWeekCalendar2["default"])(props),
      finalUIState = _useWeekCalendar.finalUIState,
      finalSelectedWeek = _useWeekCalendar.finalSelectedWeek,
      stateHoveredWeek = _useWeekCalendar.stateHoveredWeek,
      finalOptions = _useWeekCalendar.finalOptions,
      finalTodayDate = _useWeekCalendar.finalTodayDate,
      otherProps = _useWeekCalendar.otherProps,
      handleItemClick = _useWeekCalendar.handleItemClick,
      handlePrevMonth = _useWeekCalendar.handlePrevMonth,
      handleNextMonth = _useWeekCalendar.handleNextMonth,
      handlePrevYear = _useWeekCalendar.handlePrevYear,
      handleNextYear = _useWeekCalendar.handleNextYear,
      handleSwitch = _useWeekCalendar.handleSwitch,
      handleItemHover = _useWeekCalendar.handleItemHover,
      handleLeavePanel = _useWeekCalendar.handleLeavePanel,
      styles = _useWeekCalendar.styles,
      disableWeek = _useWeekCalendar.disableWeek,
      hideItemOutside = _useWeekCalendar.hideItemOutside,
      renderDecadeItem = _useWeekCalendar.renderDecadeItem,
      renderMonthItem = _useWeekCalendar.renderMonthItem,
      renderYearItem = _useWeekCalendar.renderYearItem,
      renderMonthLabel = _useWeekCalendar.renderMonthLabel;

  var pickStyles = (0, _react.useMemo)(function () {
    if (styles) {
      var head = styles.head,
          panel = styles.panel,
          footer = styles.footer;
      return {
        head: head,
        panel: panel,
        footer: footer
      };
    }
  }, [styles]);
  var innerStyles = (0, _useStyles["default"])('calendar', defaultStyles, pickStyles); // CalendarFooter 本身就 memo了，单个节点不需要 memo 了

  var footerNode;

  if (finalOptions && finalOptions.length) {
    footerNode = /*#__PURE__*/_react["default"].createElement(_CalendarFooter["default"], (0, _extends2["default"])({}, innerStyles.footer, {
      styles: styles,
      options: finalOptions
    }));
  } // 本就是解构了传给 pure component，所以不需要 memo


  var panelProps = {
    styles: styles,
    todayDate: finalTodayDate,
    isWeek: true,
    disableWeek: disableWeek,
    hideItemOutside: hideItemOutside,
    renderDecadeItem: renderDecadeItem,
    renderMonthItem: renderMonthItem,
    renderYearItem: renderYearItem,
    renderMonthLabel: renderMonthLabel
  };
  return /*#__PURE__*/_react["default"].createElement(Root, (0, _extends2["default"])({}, otherProps, {
    theme: theme,
    ref: ref
  }), /*#__PURE__*/_react["default"].createElement(_CalendarHead["default"], (0, _extends2["default"])({}, innerStyles.head, {
    styles: styles,
    viewType: finalUIState.viewType,
    viewDate: finalUIState.viewDate,
    onPrevMonth: handlePrevMonth,
    onNextMonth: handleNextMonth,
    onPrevYear: handlePrevYear,
    onNextYear: handleNextYear,
    onSwitch: handleSwitch
  })), /*#__PURE__*/_react["default"].createElement(_CalendarPanel["default"], (0, _extends2["default"])({}, innerStyles.panel, {
    viewType: finalUIState.viewType,
    viewDate: finalUIState.viewDate,
    hoveredWeek: stateHoveredWeek,
    selectedWeek: finalSelectedWeek,
    onItemClick: handleItemClick,
    onItemHover: handleItemHover,
    panelBlockProps: {
      onMouseLeave: handleLeavePanel
    }
  }, panelProps)), footerNode);
});
var _default = WeekCalendar;
exports["default"] = _default;