"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _usePickerBase2 = _interopRequireDefault(require("../DatePicker/usePickerBase"));

var _PopPanel = require("../styled/components/PopPanel");

var _Trigger = _interopRequireDefault(require("../Trigger"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _styled = require("./styled");

var _useWeekPicker2 = _interopRequireDefault(require("./useWeekPicker"));

var _WeekCalendar = _interopRequireDefault(require("./WeekCalendar"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultStyles = {
  popPanel: ''
};
var WeekPicker = (0, _memoForwardRef["default"])(function (props, ref) {
  var theme = (0, _useTheme["default"])();

  var _useWeekPicker = (0, _useWeekPicker2["default"])(props),
      finalUIState = _useWeekPicker.finalUIState,
      finalSelectedWeek = _useWeekPicker.finalSelectedWeek,
      finalValue = _useWeekPicker.finalValue,
      otherProps = _useWeekPicker.otherProps,
      handleFocus = _useWeekPicker.handleFocus,
      handleCalendarChange = _useWeekPicker.handleCalendarChange,
      handleCalendarUIChange = _useWeekPicker.handleCalendarUIChange,
      handleClickAway = _useWeekPicker.handleClickAway,
      handleClear = _useWeekPicker.handleClear,
      styles = _useWeekPicker.styles,
      disabled = _useWeekPicker.disabled,
      options = _useWeekPicker.options,
      todayDate = _useWeekPicker.todayDate,
      disableWeek = _useWeekPicker.disableWeek,
      allowClear = _useWeekPicker.allowClear,
      container = _useWeekPicker.container,
      renderDecadeItem = _useWeekPicker.renderDecadeItem,
      renderMonthItem = _useWeekPicker.renderMonthItem,
      renderYearItem = _useWeekPicker.renderYearItem,
      renderMonthLabel = _useWeekPicker.renderMonthLabel,
      onSelect = _useWeekPicker.onSelect,
      calendarStyles = _useWeekPicker.calendarStyles,
      placement = _useWeekPicker.placement,
      popperProps = _useWeekPicker.popperProps,
      arrowPointAtCenter = _useWeekPicker.arrowPointAtCenter,
      triggerId = _useWeekPicker.triggerId,
      flip = _useWeekPicker.flip; // input 的 styles 直接传个 input


  var inputStyles = (0, _react.useMemo)(function () {
    if (!styles) {
      return;
    }

    var inputWrapper = styles.inputWrapper,
        input = styles.input,
        nodeDivider = styles.nodeDivider,
        nodeWrapper = styles.nodeWrapper,
        clearWrapper = styles.clearWrapper,
        statusWrapper = styles.statusWrapper;
    return {
      inputWrapper: inputWrapper,
      input: input,
      nodeDivider: nodeDivider,
      nodeWrapper: nodeWrapper,
      clearWrapper: clearWrapper,
      statusWrapper: statusWrapper
    };
  }, [styles]);
  var currentStyles = (0, _react.useMemo)(function () {
    if (!styles) {
      return;
    }

    var popPanel = styles.popPanel;
    return {
      popPanel: popPanel
    };
  }, [styles]);
  var innerStyles = (0, _useStyles["default"])('week-picker', defaultStyles, currentStyles);

  var _usePickerBase = (0, _usePickerBase2["default"])(),
      innerSuffixNode = _usePickerBase.suffixNode;

  var realNode = /*#__PURE__*/_react["default"].createElement(_styled.StyledInput, (0, _extends2["default"])({
    ref: ref,
    value: finalValue,
    suffixNode: innerSuffixNode,
    clearReplace: true,
    focusWhenClear: false,
    theme: theme,
    styles: inputStyles,
    disabled: disabled,
    allowClear: allowClear,
    onFocus: handleFocus,
    onClear: handleClear,
    readOnly: true
  }, otherProps));

  if (disabled) {
    return realNode;
  }

  var calendarProps = {
    styles: calendarStyles,
    disableWeek: disableWeek,
    options: options,
    todayDate: todayDate,
    onSelect: onSelect,
    allowClear: allowClear,
    renderDecadeItem: renderDecadeItem,
    renderMonthItem: renderMonthItem,
    renderYearItem: renderYearItem,
    renderMonthLabel: renderMonthLabel
  };

  var calendarNode = /*#__PURE__*/_react["default"].createElement(_PopPanel.StyledPopPanel, (0, _extends2["default"])({}, innerStyles.popPanel, {
    theme: theme
  }), /*#__PURE__*/_react["default"].createElement(_WeekCalendar["default"], (0, _extends2["default"])({
    viewDate: finalUIState.viewDate,
    viewType: finalUIState.viewType,
    selectedWeek: finalSelectedWeek,
    onChange: handleCalendarChange,
    onUIChange: handleCalendarUIChange
  }, calendarProps)));

  var triggerProps = {
    placement: placement,
    popperProps: popperProps,
    arrowPointAtCenter: arrowPointAtCenter,
    triggerId: triggerId,
    flip: flip,
    hideArrow: true,
    container: container
  };
  return /*#__PURE__*/_react["default"].createElement(_Trigger["default"], (0, _extends2["default"])({
    popup: calendarNode,
    triggerAction: "click",
    open: finalUIState.popupOpen,
    onClickAway: handleClickAway
  }, triggerProps), realNode);
});
WeekPicker.__MUYA_WEEKPICKER = true;
var _default = WeekPicker;
exports["default"] = _default;