"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formatWeek = formatWeek;
exports.getViewDateByWeek = getViewDateByWeek;
exports.isSameWeek = isSameWeek;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _dayjs = _interopRequireDefault(require("dayjs"));

var _utils = require("../Calendar/utils");

function formatWeek(inputWeek) {
  if (!inputWeek) {
    return;
  }

  if (Array.isArray(inputWeek)) {
    var range = (0, _utils.getRangeInOrder)(inputWeek);

    if (!range) {
      return;
    }

    return [range[0].startOf('w'), range[0].endOf('w')];
  }

  var innerDate = (0, _dayjs["default"])(inputWeek);

  if (!innerDate.isValid()) {
    return;
  }

  return [innerDate.startOf('w'), innerDate.endOf('w')];
}

function getViewDateByWeek(_ref) {
  var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
      weekStart = _ref2[0],
      weekEnd = _ref2[1];

  if ((0, _utils.isSame)(weekStart, weekEnd, 'month')) {
    return weekStart;
  } // 都按 8点算吧


  var weekStartEndOfMonth = weekStart.endOf('month').hour(8);
  var weekEndStartOfMonth = weekEnd.startOf('month').hour(8);
  var startRemain = weekStartEndOfMonth.unix() - weekStart.unix();
  var endRemain = weekEnd.unix() - weekEndStartOfMonth.unix();
  return startRemain > endRemain ? weekStart : weekEnd;
}

function isSameWeek(weekA, weekB) {
  if (!weekA || !weekB) {
    return false;
  }

  return weekA[0].isSame(weekB[0], 'd');
}