"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultArrowWidth = exports.defaultArrowMargin = exports.defaultArrowHeight = exports.StyledArrow = void 0;
exports.makeArrowStyle = makeArrowStyle;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _excluded = ["width", "color", "height", "margin"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultArrowWidth = 12;
exports.defaultArrowWidth = defaultArrowWidth;
var defaultArrowHeight = 6;
exports.defaultArrowHeight = defaultArrowHeight;
var defaultArrowMargin = 16;
exports.defaultArrowMargin = defaultArrowMargin;

var StyledArrow = _styledComponents["default"].div.withConfig({
  displayName: "StyledArrow"
})(["", ""], makeArrowStyle);

exports.StyledArrow = StyledArrow;

function makeArrowStyle(props) {
  var _css;

  var _props$placement = props.placement,
      placement = _props$placement === void 0 ? 'top' : _props$placement,
      _props$arrowStyle = props.arrowStyle,
      arrowStyle = _props$arrowStyle === void 0 ? {} : _props$arrowStyle;
  var width = arrowStyle.width,
      color = arrowStyle.color,
      height = arrowStyle.height,
      margin = arrowStyle.margin,
      otherStyle = (0, _objectWithoutProperties2["default"])(arrowStyle, _excluded);
  var mainPlacement = placement.split('-')[0];
  var subPlacement = placement.split('-')[1];
  var arrowColor = color || '#fff';
  var arrowWidth = width || defaultArrowWidth;
  var arrowHeight = height || defaultArrowHeight;
  var arrowMargin = margin || defaultArrowMargin;
  var arrowMarginStyle;
  var arrowSizeStyle;

  if (mainPlacement === 'bottom' || mainPlacement === 'top') {
    arrowSizeStyle = (0, _styledComponents.css)(["border-width:", "px ", "px;"], arrowHeight, arrowWidth / 2);

    if (subPlacement === 'start') {
      // top-start or bottom-start 靠左
      arrowMarginStyle = (0, _styledComponents.css)(["left:", "px;"], arrowMargin);
    } else if (subPlacement === 'end') {
      // top-end or bottom-end 靠右
      arrowMarginStyle = (0, _styledComponents.css)(["right:", "px;"], arrowMargin);
    } else {
      // 第二个位置不传，默认相对于Trigger内容居中
      arrowMarginStyle = (0, _styledComponents.css)(["left:50%;transform:translateX(-50%);"]);
    }
  } else {
    arrowSizeStyle = (0, _styledComponents.css)(["border-width:", "px ", "px;"], arrowWidth / 2, arrowHeight);

    if (subPlacement === 'start') {
      // left-start or right-start 靠左
      arrowMarginStyle = (0, _styledComponents.css)(["top:", "px;"], arrowMargin);
    } else if (subPlacement === 'end') {
      // left-end or right-end 靠右
      arrowMarginStyle = (0, _styledComponents.css)(["bottom:", "px;"], arrowMargin);
    } else {
      // 第二个位置不传，默认相对于Trigger内容居中
      arrowMarginStyle = (0, _styledComponents.css)(["top:50%;transform:translateY(-50%);"]);
    }
  }

  return (0, _styledComponents.css)(["position:absolute;width:0;height:0;border-style:solid;border-color:transparent;", ";", " ", " ", ""], (_css = {}, (0, _defineProperty2["default"])(_css, mainPlacement, '100%'), (0, _defineProperty2["default"])(_css, "border-".concat(mainPlacement, "-color"), arrowColor), _css), arrowMarginStyle, arrowSizeStyle, otherStyle);
}