"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ellipsisLeftStyle = exports["default"] = void 0;
exports.ellipsisWithWidth = ellipsisWithWidth;
exports.makeEllipsisStyle = makeEllipsisStyle;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _styledComponents = require("styled-components");

var _addPx = _interopRequireDefault(require("../../utils/addPx"));

function makeEllipsisStyle(ellipsis) {
  if (!ellipsis) return;

  if ((0, _typeof2["default"])(ellipsis) === 'object') {
    return (0, _styledComponents.css)(["display:-webkit-box;-webkit-line-clamp:", ";-webkit-box-orient:vertical;overflow:hidden;overflow-wrap:break-word;"], ellipsis.rows || 3);
  }

  if (ellipsis) {
    return (0, _styledComponents.css)(["overflow:hidden;white-space:nowrap;text-overflow:ellipsis;"]);
  }
}

var ellipsisStyle = makeEllipsisStyle(true);
var ellipsisLeftStyle = (0, _styledComponents.css)(["", ";text-align:left;direction:rtl;"], ellipsisStyle);
exports.ellipsisLeftStyle = ellipsisLeftStyle;

function ellipsisWithWidth(ellipsis, width) {
  return (0, _styledComponents.css)(["", " ", ""], width && (0, _styledComponents.css)(["width:", ";"], (0, _addPx["default"])(width)), ellipsis && ellipsisStyle);
}

var _default = ellipsisStyle;
exports["default"] = _default;