"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _useEffectOnce2 = require("@muya-ui/utils/lib/hooks/useEffectOnce");

var _ReloadIcon2 = require("@muya-ui/theme-light/lib/icons/ReloadIcon");

var _ReminderIcon2 = require("@muya-ui/theme-light/lib/icons/ReminderIcon");

var _SuccessIcon2 = require("@muya-ui/theme-light/lib/icons/SuccessIcon");

var _ClearIcon2 = require("@muya-ui/theme-light/lib/icons/ClearIcon");

var _InformIcon2 = require("@muya-ui/theme-light/lib/icons/InformIcon");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Spin = _interopRequireDefault(require("../Spin"));

var _memoForwardRef = _interopRequireDefault(require("../utils/memoForwardRef"));

var _useStyles = _interopRequireDefault(require("../utils/useStyles"));

var _useTheme = _interopRequireDefault(require("../utils/useTheme"));

var _withTheme = require("../utils/withTheme");

var _excluded = ["item", "timeout", "state", "className", "style"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StyledToastItem = _styledComponents["default"].div.withConfig({
  displayName: "StyledToastItem"
})(["", ""], function (props) {
  var theme = props.theme;
  var colors = theme.colors,
      size = theme.size;
  var _theme$components$Not = theme.components.Notification.toast,
      itemMarginBottom = _theme$components$Not.itemMarginBottom,
      shadow = _theme$components$Not.shadow,
      borderRadius = _theme$components$Not.borderRadius;
  return (0, _styledComponents.css)(["display:flex;background:", ";box-shadow:", ";border-radius:", ";pointer-events:all;margin-bottom:", "px;"], colors.pattern.background.higher, shadow, borderRadius || size.spec.borderRadius.s2, itemMarginBottom);
});

var StyledContent = _styledComponents["default"].div.withConfig({
  displayName: "StyledContent"
})(["", ""], function (props) {
  var theme = props.theme;
  var colors = theme.colors;
  var contentStyle = theme.components.Notification.toast.contentStyle;
  return (0, _styledComponents.css)(["box-sizing:border-box;color:", ";padding:", ";max-width:", "px;min-width:", "px;line-height:", "px;font-size:", "px;"], contentStyle.color || colors.pattern.text.text, contentStyle.padding, contentStyle.maxWidth, contentStyle.minWidth, contentStyle.lineHeight, contentStyle.fontSize);
});

var StyledIcon = _styledComponents["default"].div.withConfig({
  displayName: "StyledIcon"
})(["box-sizing:border-box;", ""], function (props) {
  var theme = props.theme;
  var iconStyle = theme.components.Notification.toast.iconStyle;
  return (0, _styledComponents.css)(["padding:", ";font-size:", "px;line-height:", "px;width:", "px;"], iconStyle.padding, iconStyle.size, iconStyle.size, iconStyle.width);
});

var BaseNode = _styledComponents["default"].div.withConfig({
  displayName: "BaseNode"
})([""]);

var ToastItemWithoutStyle = (0, _memoForwardRef["default"])(function (props, ref) {
  var item = props.item,
      timeout = props.timeout,
      state = props.state,
      className = props.className,
      _props$style = props.style,
      style = _props$style === void 0 ? {} : _props$style,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var theme = (0, _useTheme["default"])();
  var innerStyles = (0, _useStyles["default"])('toast-item', {
    self: '',
    container: '',
    icon: '',
    content: ''
  }, item.styles);
  var iconNode;

  if (item.icon) {
    iconNode = item.icon;
  } else if (item.type !== 'loading') {
    var token = theme.components.Notification;
    var tokenIcon = (0, _extends2["default"])({
      info: _InformIcon2.InformIcon,
      error: _ClearIcon2.ClearIcon,
      success: _SuccessIcon2.SuccessIcon,
      warning: _ReminderIcon2.ReminderIcon,
      loading: _ReloadIcon2.ReloadIcon
    }, token.icon);
    var Icon = tokenIcon[item.type];
    var bgColor = token.iconBgColor[item.type];
    iconNode = /*#__PURE__*/_react["default"].createElement(StyledIcon, (0, _extends2["default"])({}, innerStyles.icon, {
      theme: theme
    }), /*#__PURE__*/_react["default"].createElement(Icon, {
      bgColor: bgColor
    }));
  } else {
    iconNode = /*#__PURE__*/_react["default"].createElement(StyledIcon, (0, _extends2["default"])({}, innerStyles.icon, {
      theme: theme
    }), /*#__PURE__*/_react["default"].createElement(_Spin["default"], null));
  }

  var contentNode;

  if (typeof item.content === 'string' || item.enableContentWrapper) {
    contentNode = /*#__PURE__*/_react["default"].createElement(StyledContent, (0, _extends2["default"])({}, innerStyles.content, {
      theme: theme
    }), item.content);
  } else {
    contentNode = item.content;
  }

  var containerProps = (0, _extends2["default"])({
    style: (0, _extends2["default"])({}, innerStyles.self.style, style),
    className: [className, innerStyles.self.className].join(' ')
  }, otherProps);
  (0, _useEffectOnce2.useEffectOnce)(function () {
    return function () {
      if (item.onClose) {
        item.onClose();
      }
    };
  });
  return /*#__PURE__*/_react["default"].createElement(BaseNode, (0, _extends2["default"])({
    ref: ref
  }, containerProps), /*#__PURE__*/_react["default"].createElement(StyledToastItem, (0, _extends2["default"])({
    theme: theme
  }, innerStyles.container), iconNode, contentNode));
});
var ToastItem = (0, _styledComponents["default"])(ToastItemWithoutStyle).withConfig({
  displayName: "ToastItem"
})(["", ""], function (props) {
  var theme = props.theme,
      item = props.item,
      state = props.state,
      timeout = props.timeout;
  var colors = theme.colors,
      transition = theme.transition;
  var _theme$components$Not2 = theme.components.Notification.toast,
      lineMaxChar = _theme$components$Not2.lineMaxChar,
      contentStyle = _theme$components$Not2.contentStyle,
      minHeight = _theme$components$Not2.minHeight;
  var maxHeight = item.maxHeight || minHeight;

  if (typeof item.content === 'string' && item.content.length > lineMaxChar) {
    var lineNum = Math.ceil(item.content.length / lineMaxChar);
    maxHeight = minHeight + lineNum * contentStyle.lineHeight;
  }

  var transitionMap = {
    entering: '',
    entered: (0, _styledComponents.css)(["max-height:", "px;opacity:1;"], maxHeight),
    exiting: (0, _styledComponents.css)(["max-height:0;opacity:0;transition-timing-function:", ";"], transition.pattern.easing.leave),
    exited: '',
    unmounted: ''
  };
  var transformCSS = transitionMap[state] || (0, _styledComponents.css)(["max-height:0;opacity:0;"]);
  return (0, _styledComponents.css)(["transition:all ", "ms ", ";pointer-events:none;display:flex;align-items:center;justify-content:center;", " & ", "{color:", ";}"], timeout, transition.pattern.easing.enter, transformCSS, StyledIcon, colors.pattern.feature[item.type]);
});

var _default = (0, _withTheme.withThemeForStyled)(ToastItem);

exports["default"] = _default;