"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.arrayAdd = arrayAdd;
exports.arrayDel = arrayDel;
exports.arraySpliceWithFn = arraySpliceWithFn;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _isArray2 = _interopRequireDefault(require("lodash/isArray"));

function arrayDel(list, value) {
  var clone = list.slice();
  var index = clone.indexOf(value);

  if (index >= 0) {
    clone.splice(index, 1);
  }

  return clone;
}

function arrayAdd(list, value) {
  var clone = list.slice();

  if (clone.indexOf(value) === -1) {
    clone.push(value);
  }

  return clone;
}
/**
 * splice一个数组，通过传入fn对删除的item进行操作，并将返回值插入该数组
 *
 * @param {T[]} list 数据源数组
 * @param {number} start
 * @param {number} end
 * @param {((items: T[]) => T | T[])} fn 对删除掉的数据进行操作的函数
 * @returns 和 Array.prototype.splice 相同
 */


function arraySpliceWithFn(list, start, end, fn) {
  var len = list.length;
  var delList = list.slice(start, len - end);
  var delListWithFn = fn(delList);
  var overResultArr;

  if ((0, _isArray2["default"])(delListWithFn)) {
    overResultArr = delListWithFn;
  } else {
    overResultArr = [delListWithFn];
  }

  var spliceResult = list.splice.apply(list, [start, len - start - end].concat((0, _toConsumableArray2["default"])(overResultArr)));
  return spliceResult;
}