"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = mergeBooleanFns;

/**
 * 合并布尔函数
 * @param fnA
 * @param fnB
 */
function mergeBooleanFns(fnA, fnB) {
  if (fnA && fnB) {
    var newFn = function newFn() {
      if (fnA.apply(void 0, arguments)) {
        return true;
      }

      return fnB.apply(void 0, arguments);
    };

    return newFn;
  }

  return fnA || fnB;
}