"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = mergeBooleanHocFns;

var _mergeBooleanFns = _interopRequireDefault(require("./mergeBooleanFns"));

/**
 * 合并返回布尔函数的函数
 * @param fnA
 * @param fnB
 */
function mergeBooleanHocFns(fnA, fnB) {
  if (fnA && fnB) {
    var newFn = function newFn() {
      var innerFnA = fnA.apply(void 0, arguments);
      var innerFnB = fnB.apply(void 0, arguments);
      return (0, _mergeBooleanFns["default"])(innerFnA, innerFnB);
    };

    return newFn;
  }

  return fnA || fnB;
}