"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = mergeStyleItem;

var _mergeStyle = _interopRequireDefault(require("./mergeStyle"));

/**
 * 合并 style item
 * @param inputItem 输入的 { className, style } 都不是必选的
 * @param defaultItem 默认的 styleItem 一般是由 useStyles 产生的
 */
function mergeStyleItem(inputItem, defaultItem) {
  var className = defaultItem.className;

  if (inputItem.className) {
    className = "".concat(inputItem.className, " ").concat(className);
  }

  return {
    className: className,
    style: (0, _mergeStyle["default"])(defaultItem.style, inputItem.style)
  };
}