"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = transformStyles;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _kebabCase2 = _interopRequireDefault(require("lodash/kebabCase"));

function transformStyles(themePrefix, componentName, map) {
  var keys = Object.keys(map);
  var resultMap = {};
  keys.forEach(function (key) {
    var classes = ["muya-".concat(componentName, "-").concat((0, _kebabCase2["default"])(key)), "".concat(themePrefix, "-").concat(componentName, "-").concat((0, _kebabCase2["default"])(key))];
    var config = map[key];
    var style;

    if (config && typeof config === 'string') {
      classes.push(config);
    } else if (config && (0, _typeof2["default"])(config) === 'object') {
      style = config;
    }

    resultMap[key] = {
      className: classes.join(' '),
      style: style
    };
  });
  return resultMap;
}