"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
exports.useAdjustMiniFont = useAdjustMiniFont;

var _react = require("react");

var _addPx = _interopRequireDefault(require("./addPx"));

function useAdjustMiniFont(textRef, fontSize) {
  var minFontSize = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 12;
  (0, _react.useEffect)(function () {
    if (fontSize < minFontSize) {
      if (textRef && textRef.current) {
        var _getComputedStyle = getComputedStyle(textRef.current),
            _getComputedStyle$wid = _getComputedStyle.width,
            width = _getComputedStyle$wid === void 0 ? '0px' : _getComputedStyle$wid;

        textRef.current.style.transform = "scale(".concat(fontSize / minFontSize, ")");
        textRef.current.style.webkitTransform = "scale(".concat(fontSize / minFontSize, ")");
        textRef.current.style.marginRight = (0, _addPx["default"])(parseInt(width, fontSize) * (1 - fontSize / minFontSize) / -2);
        textRef.current.style.marginLeft = (0, _addPx["default"])(parseInt(width, fontSize) * (1 - fontSize / minFontSize) / -2);
      }
    } else {
      if (textRef && textRef.current) {
        textRef.current.style.transform = '';
        textRef.current.style.webkitTransform = '';
        textRef.current.style.marginRight = (0, _addPx["default"])(0);
        textRef.current.style.marginLeft = (0, _addPx["default"])(0);
      }
    }
  }, [fontSize, minFontSize, textRef]);
}

var _default = useAdjustMiniFont;
exports["default"] = _default;