"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
exports.useEllipsis = useEllipsis;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = require("react");

function useEllipsis(ref, contentCopyRef, multiline, children) {
  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      isEllipsis = _useState2[0],
      setIsEllipsis = _useState2[1];

  (0, _react.useEffect)(function () {
    if (!ref.current) return;

    if (multiline) {
      var _ref$current = ref.current,
          clientHeight = _ref$current.clientHeight,
          scrollHeight = _ref$current.scrollHeight;

      if (clientHeight < scrollHeight && !isEllipsis) {
        setIsEllipsis(true);
      } else if (clientHeight >= scrollHeight && isEllipsis) {
        setIsEllipsis(false);
      }
    } else if (contentCopyRef.current) {
      if (ref.current.clientWidth < contentCopyRef.current.clientWidth && !isEllipsis) {
        setIsEllipsis(true);
      } else if (ref.current.clientWidth >= contentCopyRef.current.clientWidth && isEllipsis) {
        setIsEllipsis(false);
      }
    }
  }, [isEllipsis, children, ref, multiline, contentCopyRef]);
  return isEllipsis;
}

var _default = useEllipsis;
exports["default"] = _default;