"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = require("react");

var _resizeObserverPolyfill = _interopRequireDefault(require("resize-observer-polyfill"));

/* eslint-disable @typescript-eslint/unified-signatures */
function useSize() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  var hasPassedInElement = args.length === 1;
  var arg = (0, _react.useRef)(args[0]);
  arg.current = args[0];
  var element = (0, _react.useRef)();

  var _useState = (0, _react.useState)(function () {
    var initDOM = typeof arg.current === 'function' ? arg.current() : arg.current;
    return {
      width: (initDOM || {
        clientWidth: 0
      }).clientWidth,
      height: (initDOM || {
        clientHeight: 0
      }).clientHeight
    };
  }),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      state = _useState2[0],
      setState = _useState2[1];

  (0, _react.useLayoutEffect)(function () {
    var passedInElement = typeof arg.current === 'function' ? arg.current() : arg.current;
    var targetElement = hasPassedInElement ? passedInElement : element.current;

    if (!targetElement) {
      return function () {};
    }

    var resizeObserver = new _resizeObserverPolyfill["default"](function (entries) {
      entries.forEach(function (entry) {
        setState({
          width: entry.target.clientWidth,
          height: entry.target.clientHeight
        });
      });
    });
    resizeObserver.observe(targetElement);
    return function () {
      resizeObserver.disconnect();
    };
  }, [hasPassedInElement]);

  if (hasPassedInElement) {
    return [state];
  }

  return [state, element];
}

var _default = useSize;
exports["default"] = _default;