"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
exports.useStyles = useStyles;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = require("react");

var _transformStyles = _interopRequireDefault(require("./transformStyles"));

var _useTheme = _interopRequireDefault(require("./useTheme"));

/**
 * 生成样式覆盖的配置
 * @param componentName 组件名
 * @param defaultStyles 默认配置
 * @param styles prop 输入，可以不填
 */
function useStyles(componentName, defaultStyles, styles) {
  var theme = (0, _useTheme["default"])();
  var newStyles = (0, _react.useMemo)(function () {
    return (0, _transformStyles["default"])(theme.prefix, componentName, styles ? (0, _extends2["default"])({}, defaultStyles, styles) : defaultStyles);
  }, [componentName, defaultStyles, styles, theme.prefix]);
  return newStyles;
}

var _default = useStyles;
exports["default"] = _default;