"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = require("react");

var _useSize3 = _interopRequireDefault(require("./useSize"));

/* eslint-disable @typescript-eslint/no-object-literal-type-assertion */
var _default = function _default(list, options) {
  var _useSize = (0, _useSize3["default"])(),
      _useSize2 = (0, _slicedToArray2["default"])(_useSize, 2),
      size = _useSize2[0],
      containerRef = _useSize2[1];

  var _useState = (0, _react.useState)({
    start: 0,
    end: 10
  }),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      state = _useState2[0],
      setState = _useState2[1];

  var itemHeight = options.itemHeight,
      _options$overscan = options.overscan,
      overscan = _options$overscan === void 0 ? 5 : _options$overscan;

  if (!itemHeight) {
    console.warn('please enter a valid itemHeight');
  }

  var getViewCapacity = (0, _react.useCallback)(function (containerHeight) {
    return Math.ceil(containerHeight / itemHeight);
  }, [itemHeight]);
  var getOffset = (0, _react.useCallback)(function (scrollTop) {
    return Math.floor(scrollTop / itemHeight) + 1;
  }, [itemHeight]);
  var calculateRange = (0, _react.useCallback)(function () {
    var element = containerRef.current;

    if (element) {
      var offset = getOffset(element.scrollTop);
      var viewCapacity = getViewCapacity(element.clientHeight);
      var from = offset - overscan;
      var to = offset + viewCapacity + overscan;
      setState({
        start: from < 0 ? 0 : from,
        end: to > list.length ? list.length : to
      });
    }
  }, [containerRef, getOffset, getViewCapacity, list.length, overscan]);
  (0, _react.useEffect)(function () {
    calculateRange();
  }, [size.width, size.height, calculateRange]);
  var totalHeight = (0, _react.useMemo)(function () {
    return list.length * itemHeight;
  }, [itemHeight, list]);
  var getDistanceTop = (0, _react.useCallback)(function (index) {
    var height = index * itemHeight;
    return height;
  }, [itemHeight]);
  var scrollTo = (0, _react.useCallback)(function (index) {
    if (containerRef.current) {
      containerRef.current.scrollTop = getDistanceTop(index);
      calculateRange();
    }
  }, [calculateRange, containerRef, getDistanceTop]);
  var handleRef = (0, _react.useCallback)(function (ele) {
    containerRef.current = ele;
  }, [containerRef]);
  var onScroll = (0, _react.useCallback)(function (e) {
    calculateRange();
  }, [calculateRange]);
  var containerProps = (0, _react.useMemo)(function () {
    return {
      ref: handleRef,
      onScroll: onScroll,
      style: {
        overflowY: 'auto'
      }
    };
  }, [handleRef, onScroll]);
  var wrapperProps = (0, _react.useMemo)(function () {
    return {
      style: {
        boxSizing: 'border-box',
        width: '100%',
        height: totalHeight,
        paddingTop: getDistanceTop(state.start)
      }
    };
  }, [getDistanceTop, state.start, totalHeight]);
  var virtualList = (0, _react.useMemo)(function () {
    // 没滚动的时候完整返回
    if (containerRef.current && containerRef.current.clientHeight >= totalHeight) {
      return list.map(function (ele, index) {
        return {
          data: ele,
          index: index + state.start
        };
      });
    }

    return list.slice(state.start, state.end).map(function (ele, index) {
      return {
        data: ele,
        index: index + state.start
      };
    });
  }, [containerRef, list, state.end, state.start, totalHeight]);
  return {
    list: virtualList,
    scrollTo: scrollTo,
    containerProps: containerProps,
    wrapperProps: wrapperProps
  };
};

exports["default"] = _default;