"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withThemeForStyled = exports.withTheme = exports["default"] = void 0;

var _theme = require("@muya-ui/theme-light/lib/theme");

var _styledComponents = require("styled-components");

var withTheme = function withTheme(comp) {
  // add default theme to defaultProps
  if (!comp.defaultProps) {
    comp.defaultProps = {};
  }

  comp.defaultProps.theme = _theme.muyaThemeLight; // 非styled-component组件需要withTheme包裹，使其获得从ThemeContext拿主题的能力

  return (0, _styledComponents.withTheme)(comp);
};

exports.withTheme = withTheme;

var withThemeForStyled = function withThemeForStyled(comp) {
  // add default theme to defaultProps
  if (!comp.defaultProps) {
    comp.defaultProps = {};
  }

  comp.defaultProps.theme = _theme.muyaThemeLight; // 非styled-component组件需要withTheme包裹，使其获得从ThemeContext拿主题的能力

  return comp;
};

exports.withThemeForStyled = withThemeForStyled;
var _default = withTheme;
exports["default"] = _default;