import { IBackgroundColor } from '@muya-ui/theme-light';
import React from 'react';
import { IMuyaPureComponent } from '../types';
export interface IBackgroundPureProps {
    /**
     * 支持通用背景的几种模式
     * @default 'global'
     * @typeText "disabled" | "divider" | "higher" | "block" | "selectedBlock" | "global" | "mask"
     */
    type?: keyof IBackgroundColor;
    /**
     * 节点设置
     * @default 'div'
     */
    component?: 'div' | 'span';
    /** css display */
    display?: 'block' | 'flex' | 'inline-block' | 'inline-flex' | React.CSSProperties['display'];
    /**
     * 设置具体的背景色，酌情使用
     */
    backgroundColor?: string;
    /**
     * 圆角
     */
    borderRadius?: string | number;
    /**
     * 文字颜色，酌情使用
     */
    color?: string;
    /** 宽 */
    width?: string | number;
    /** 高 */
    height?: string | number;
}
export declare type IBackgroundProps = IBackgroundPureProps & React.HTMLAttributes<HTMLDivElement | HTMLSpanElement>;
/**
 * @dts[only]
 */
export declare const Background: IMuyaPureComponent<IBackgroundProps, HTMLDivElement | HTMLSpanElement>;
