import dayjs, { ConfigType, Dayjs, OpUnitType } from 'dayjs';
import { ICalendarFooterOption } from './innerTypes';
import { ICalendarItemNormalStatus, ICalendarItemStatus, ICalendarOption, ICalendarSelectType, ICalendarType } from '.';
/**
 * 将选择类型转换为展示类型
 * @param selectType 选择类型
 */
export declare function transformType(selectType: ICalendarSelectType): ICalendarType;
export declare function getDateType(viewType: ICalendarType): OpUnitType;
export declare function getSelectDateType(selectType: ICalendarSelectType): OpUnitType;
export declare function getDaysOfMonth(date: Dayjs): dayjs.Dayjs[];
export declare function getMonthsOfYear(date: Dayjs): dayjs.Dayjs[];
/**
 * 获取对应时间的十年，加上首位的两年
 * @param date 日期
 */
export declare function getDecadeYears(date: Dayjs): dayjs.Dayjs[];
/**
 * 获取对应时间的十年，加上首位的两年
 * @param date 日期
 */
export declare function getDecade(date: Dayjs): dayjs.Dayjs[];
export declare function moveOne(date: Dayjs, type: ICalendarType, num?: 1 | -1): dayjs.Dayjs;
export declare function isSame(dateA: Dayjs, dateB: Dayjs, type: ICalendarType): boolean;
/**
 * 把用户输入转换成一个有序日期区间
 * @param range 日期区间
 */
export declare function getRangeInOrder(range?: ConfigType[]): [Dayjs, Dayjs] | undefined;
export declare function inRange(date: Dayjs, range: Dayjs[]): boolean;
export declare function getRangeViewType(selectType: ICalendarSelectType, viewType?: ICalendarType[]): [ICalendarType, ICalendarType];
export declare function getRangeViewDate(viewType: [ICalendarType, ICalendarType], viewDate?: ConfigType[], num?: 1 | -1): [Dayjs, Dayjs];
export declare function transformItemStatus(status: ICalendarItemNormalStatus, disabled: boolean): ICalendarItemStatus;
export declare function formatStartEnd(date: Dayjs, isEnd?: boolean, selectType?: ICalendarSelectType): dayjs.Dayjs;
export declare function formatCalendarOptions(options?: ICalendarOption[], handleItemClick?: (date: Dayjs) => void, onError?: (option: ICalendarOption) => void): ICalendarFooterOption[] | undefined;
