import React from 'react';
import { ISizeSpecBaseProps, IThemedBaseProps } from '../types';
/**
 * styled components props
 */
export interface IStyledCascaderMenuProps extends IThemedBaseProps, ISizeSpecBaseProps {
    /**
     * 配置的菜单宽度
     */
    menuWidth?: number;
}
export interface IStyledCascaderMenuItemProps extends IThemedBaseProps, ISizeSpecBaseProps {
    $disabled: boolean;
    $selected: boolean;
    $multiple: boolean;
    onClick: (e: React.MouseEvent) => void;
    onMouseEnter?: (e: React.MouseEvent) => void;
    onMouseLeave?: (e: React.MouseEvent) => void;
}
export interface IStyledCascaderMenuItemWrapperProps extends IThemedBaseProps {
    /**
     * 菜单是否反向
     */
    menuReverse: boolean;
    /**
     * 纯渲染 panel
     */
    $pure: boolean;
}
export interface IStyledCascaderMenuBorderBoxProps extends IThemedBaseProps {
    /**
     * 是否有滚动条
     */
    hasScrollBar: boolean;
    /**
     * 菜单是否反向
     */
    menuReverse: boolean;
}
export declare const StyledCascaderMenuItem: import("styled-components").StyledComponent<"li", import("styled-components").DefaultTheme, IStyledCascaderMenuItemProps, never>;
export declare const StyledCascaderMenuItemContent: import("styled-components").StyledComponent<"div", import("styled-components").DefaultTheme, {}, never>;
export declare const StyledCascaderMenu: import("styled-components").StyledComponent<"ul", import("styled-components").DefaultTheme, IStyledCascaderMenuProps, never>;
export declare const StyledCascaderMenuBorderBox: import("styled-components").StyledComponent<"div", import("styled-components").DefaultTheme, IStyledCascaderMenuBorderBoxProps, never>;
export declare const StyledCascaderPanel: import("styled-components").StyledComponent<"div", import("styled-components").DefaultTheme, IStyledCascaderMenuItemWrapperProps, never>;
export declare const StyledNotFoundContent: import("styled-components").StyledComponent<"div", import("styled-components").DefaultTheme, {}, never>;
