import React from 'react';
import { ITriggerProps } from '../Trigger';
import { ICascaderInputProps, ICascaderOptionType, ICascaderProps, IFilledFieldNamesType } from './types';
export default function useCascader(props: ICascaderProps, nodeRef: React.RefObject<HTMLDivElement>, inputRef: React.RefObject<HTMLInputElement>, menuRef: React.RefObject<HTMLDivElement>, firstSelectedItemRef: React.RefObject<HTMLDivElement>): {
    panelProps: {
        menusWidth: number | number[] | undefined;
        placement: import("./types").ICascaderPlacement;
        menuReverse: boolean;
        size: import("../../../muya-theme-light/types").IComponentSizeSpec;
        options: ICascaderOptionType[];
        renderOption: ((label: ICascaderOptionType, level?: number | undefined) => React.ReactNode) | undefined;
        activeValue: React.ReactText[];
        onSelect: (...args: any[]) => any;
        onDeselect: (targetOptions: ICascaderOptionType[], menuIndex: number, e: React.MouseEvent<Element, MouseEvent> | React.KeyboardEvent<Element> | React.ChangeEvent<Element>) => void;
        expandTrigger: import("./types").ICascaderExpandTrigger;
        fieldNames: IFilledFieldNamesType;
        visible: boolean;
        expandIcon: React.ReactNode;
        loadingIcon: React.ReactNode;
        styles: Partial<Record<import("./types").ICascaderStyleKeys, string | React.CSSProperties>> | undefined;
        multiple: boolean;
        checkedKeys: {
            checked: import("./types").ICascaderDataEntity[];
            halfChecked: import("./types").ICascaderDataEntity[];
        };
        loadingKeys: React.ReactText[];
        loadedKeys: React.ReactText[];
        onLoad: (...args: any[]) => any;
        virtual: boolean;
        onMenuScroll: ((e: React.UIEvent<Element>, menuLevel: number, activeOptions: ICascaderOptionType[]) => void) | undefined;
    };
    triggerProps: Pick<ITriggerProps, "id" | "disabled" | "placement" | "leaveDelay" | "onClickAway" | "triggerId" | "popperProps" | "flip" | "arrowAdaptive" | "arrowPointAtCenter" | "zIndex" | "enterDelay" | "triggerActions" | "triggerAction" | "defaultOpen" | "open" | "arrowStyle" | "hideArrow" | "offset" | "TransitionComponent" | "transitionProps" | "container" | "outsideCloseable" | "insideCloseable" | "escapeKeyCloseable" | "onVisibleChange" | "onEscapeKeyDown" | "popperNodeRef" | "disableOpenOnExiting">;
    inputProps: ICascaderInputProps;
    searchResultProps: {
        searchValue: string;
        activeKey: string;
        fieldNames: IFilledFieldNamesType;
        filterFieldName: string;
        firstSelectedOption: ICascaderOptionType | undefined;
        menuWidth: number;
        filterOptions: ICascaderOptionType[];
        optionSelectedIndex: (option: ICascaderOptionType) => number;
        handleOptionClick: (option: ICascaderOptionType, e: React.MouseEvent<Element, MouseEvent>) => void;
        handleOptionMouseEnter: (...args: any[]) => any;
    };
};
