import React from 'react';
import { ICascaderDataEntity, ICascaderDisplayRender, ICascaderOptionType, ICascaderValueType, IFilledFieldNamesType } from './types';
/**
 * 默认的展示规则
 */
export declare const defaultDisplayRender: ICascaderDisplayRender;
export declare function getLeafValues(value: ICascaderValueType[] | ICascaderValueType[][], multiple: boolean): React.ReactText[] | React.ReactText[][];
export declare const getValueStateFromProps: (value: React.ReactText[] | React.ReactText[][], multiple: boolean, controlLeaf: boolean, keyEntities: Record<React.ReactText, ICascaderDataEntity>, keyPosMap: Record<React.ReactText, string[]>) => React.ReactText[] | React.ReactText[][];
/**
 * 从 value 获取激活态的 value
 */
export declare const getActiveStateFromValue: (value: React.ReactText[] | React.ReactText[][], multiple: boolean) => React.ReactText[];
/**
 * 遍历 options
 */
export declare function traverseOptions(options: ICascaderOptionType[], fieldNames: IFilledFieldNamesType, callback: (data: {
    node: ICascaderOptionType;
    index: number;
    key: ICascaderValueType;
    keyPath: ICascaderValueType[];
    pos: string;
    parentPos: string;
    level: number;
}) => void): void;
/**
 * 遍历 options 生成 key 和 pos 的索引结构
 */
export declare function getEntityDataFromOptions(options: ICascaderOptionType[], fieldNames: IFilledFieldNamesType): {
    posEntities: Record<string, ICascaderDataEntity>;
    keyEntities: Record<React.ReactText, ICascaderDataEntity>;
    keyPathEntities: Record<React.ReactText, ICascaderDataEntity>;
    keyPosMap: Record<React.ReactText, string[]>;
};
/**
 * 根据之前的选中状态计算选中或者取消选中部分 key 后新的状态
 * @param keyList 需要改变的 key 列表
 * @param checked 改变为 true 还是 false
 * @param keyEntities key 索引的 option 数据
 * @param checkStatus 之前的选中状态
 */
export declare const calcCheckedKeys: (keyList: {
    key: string | number | React.ReactText[];
    pos: string;
}[], checked: boolean, checkStrictly: boolean, keyEntities: Record<React.ReactText, ICascaderDataEntity>, checkStatus?: {
    checked?: ICascaderDataEntity[] | undefined;
    halfChecked?: ICascaderDataEntity[] | undefined;
}) => {
    checked: ICascaderDataEntity[];
    halfChecked: ICascaderDataEntity[];
};
export declare const diffValue: (newValue: React.ReactText[] | React.ReactText[][], oldValue: React.ReactText[] | React.ReactText[][], multiple: boolean, controlLeaf: boolean) => boolean;
export declare function findOption(options: ICascaderOptionType[], value: ICascaderValueType, fieldNames: IFilledFieldNamesType): ICascaderOptionType | undefined;
export declare function getPlaceholder(value: string | string[], defaultPlaceholder?: string): string | undefined;
export declare function highlightKeyword(str: string, keyword: string): (string | (string | JSX.Element)[])[];
export declare function defaultFilterOption(inputValue: string, path: ICascaderOptionType[], names: IFilledFieldNamesType): boolean;
export declare function defaultRenderFilteredOption(inputValue: string, path: ICascaderOptionType[], names: IFilledFieldNamesType): any[];
export declare function defaultSortFilteredOption(a: ICascaderOptionType[], b: ICascaderOptionType[], inputValue: string, names: IFilledFieldNamesType): number;
export declare function flattenTree(props: {
    options: ICascaderOptionType[];
    changeOnSelect: boolean;
    ancestor?: ICascaderOptionType[];
    names: IFilledFieldNamesType;
}): ICascaderOptionType[][];
export declare function getActiveKeyFromValue(valueState: ICascaderValueType[] | ICascaderValueType[][]): any;
export declare function calValueEntity(value: ICascaderValueType[] | ICascaderValueType[][], keyPathEntities: Record<ICascaderValueType, ICascaderDataEntity>): ICascaderDataEntity[];
