import { ITheme } from '@muya-ui/theme-light';
import { ReactNode } from 'react';
import { StyledComponent } from 'styled-components';
import { ITagBaseProps } from '../Tag';
import { IMuyaPureComponent, ISizeSpecBaseProps, Omit } from '../types';
export interface ICheckableTagPureProps extends ISizeSpecBaseProps, Omit<ITagBaseProps, 'type'> {
    /**
     * 是否选中
     * @default false
     */
    checked?: boolean;
    /**
     * 选中状态改变的回调
     */
    onChange?: (checked: boolean) => void;
    /**
     * 子节点
     */
    children: ReactNode;
    /**
     *  未选中状态时的样式，传入 true 为文字标签
     *  @default false
     */
    inline?: boolean;
    /**
     *  选中时的样式，一般 normal 用于单选，light 用于多选
     *  @default 'normal'
     */
    activeStyle?: 'normal' | 'light';
}
export declare type ICheckableTagProps = ICheckableTagPureProps & Omit<React.HTMLAttributes<HTMLSpanElement>, 'onChange'>;
/**
 * @dts[only]
 */
export declare const CheckableTag: StyledComponent<IMuyaPureComponent<ICheckableTagProps, HTMLDivElement>, ITheme, ICheckableTagProps>;
