import { IBreakpoint } from '@muya-ui/theme-light';
import { IColProps, IColSize } from '.';
export declare type IResponsiveProp = 'order' | 'span' | 'offset' | 'pull' | 'push';
export declare const getPropFromBreakpoint: (breakpointData: number | IColSize, prop: IResponsiveProp) => number | undefined;
export declare const getBreakpointProp: (props: IColProps, prop: IResponsiveProp) => {
    xs: number | undefined;
    sm: number | undefined;
    md: number | undefined;
    lg: number | undefined;
    xl: number | undefined;
};
/**
 * 获取响应式属性的最终值
 * @param prop 直接从 props 中读取的属性
 * @param propFromBreakpointProp 从 xs、sm、md、lg、xl 中解析出来的属性
 * @param breakpoint 当前的断点
 * @param breakpointKeys 断点的 key
 */
export declare const getResponsiveProp: (prop: Record<IBreakpoint, number | undefined>, breakpoint: IBreakpoint) => number | undefined;
