import { CSSProperties } from 'react';
export declare function rotateIsOdd(rotate: number): boolean;
export declare function getImgStyle(size: [number, number], rotate: number, img?: HTMLImageElement): CSSProperties;
/**
 * 判断两个区间是否有重叠，有重叠返回 A -> B 的偏移量
 * @param rangeA
 * @param rangeB
 */
export declare function getRangeOffset(rangeA: [number, number], rangeB: [number, number]): number;
declare type ITranslateRect = Pick<ClientRect, 'top' | 'left' | 'bottom' | 'right'>;
export declare function getNewTranslate(maskRect: ITranslateRect, imgRect: ITranslateRect, translate: [number, number]): [number, number] | undefined;
declare type ICropRect = Pick<ClientRect, 'top' | 'left' | 'width' | 'height'>;
/**
 * 创建原图旋转后的 canvas
 * @param img 图片实例
 * @param imgRect 图片的位置信息
 * @param rotate 旋转
 * @param ratio 缩放比例
 */
export declare function createSourceImg(img: HTMLImageElement, imgRect: ICropRect, rotate: number, ratio?: number): HTMLCanvasElement;
/**
 * 生成剪裁后的 canvas
 * @param img 图片实例
 * @param imgRect 图片的位置信息
 * @param maskRect 遮罩的位置
 * @param rotate 旋转
 * @param ratio 缩放比例
 */
export declare function cropImg(img: HTMLImageElement, imgRect: ICropRect, maskRect: ICropRect, rotate: number, ratio?: number): HTMLCanvasElement;
export {};
