export declare function getValidPageValue(value: number, pageAmount: number): number;
interface IPaginationPiece {
    type: 'page-number' | 'ellipsis';
    pageNumber?: number;
    goto?: 'prev' | 'next';
}
/**
 * 计算分页大小
 * @param totalRecords 总记录数
 * @param pageSize 分页大小
 */
export declare function calculatePage(totalRecords: number, pageSize: number): number;
/**
 * 计算分页的分段
 * @param activePage 当前页面
 * @param totalRecords 总记录数
 * @param pageSize 页面梳理
 * @param midSideWidth 分段的宽度
 * @param minNumberWidth 最少显示几个
 */
export declare function computeVisiblePieces(currentPage: number, pageAmount: number, midSideWidth: number, minNumberWidth: number): IPaginationPiece[];
export {};
