import { CSSProperties, ReactElement, RefObject } from 'react';
import { ISwipeCloneResult } from './innerTypes';
export declare function rectSizeEqual(rectA?: Pick<ClientRect, 'width' | 'height'>, rectB?: Pick<ClientRect, 'width' | 'height'>): boolean;
export declare function transformItems(items: RefObject<HTMLDivElement>[]): (ClientRect | DOMRect)[];
/**
 * 根据一个个 bounding rect 来计算，要覆盖掉 size 需要多少个 rect
 * @param rects 输入的矩形数组
 * @param isH 水平还是垂直
 * @param size 要覆盖到的区间
 */
export declare function calculateCloneNum(rects: ClientRect[], isH: boolean, size: number): number | undefined;
export declare function calculateSize(items: ClientRect[], isH: boolean): number;
export declare function cloneChildren(children: ReactElement[], containerStyle?: CSSProperties, cloneNum?: number): ISwipeCloneResult;
/**
 * 根据容器节点来设置子容器的样式，只有设置的了等分的时候需要
 * @param isH
 * @param containerRect
 * @param equalNum
 * @param gutter
 */
export declare function getChildStyle(isH: boolean, containerRect?: Pick<ClientRect, 'width' | 'height'>, equalNum?: number, gutter?: number): CSSProperties;
