/// <reference types="react" />
import { IThemedBaseProps } from '../types';
import { ITagPureProps, ITagType } from '.';
/**
 * Tag重构后新增props type，与之前的部分props不兼容，进行合并处理
 *
 * @export
 * @param {IAllTagProps} props
 * @return {IAllTagProps}
 */
export declare function mergeProps(props: ITagPureProps & IThemedBaseProps): {
    color: undefined;
    bordered: undefined;
    borderColor: undefined;
    colorInverse?: boolean | undefined;
    closable?: boolean | undefined;
    hoverable?: boolean | undefined;
    visible?: boolean | undefined;
    onClose?: ((event: import("react").MouseEvent<Element, MouseEvent>) => void) | undefined;
    size?: "s" | "m" | "l" | "xl" | undefined;
    maxWidth?: number | undefined;
    shape?: "circle" | "rect" | undefined;
    disabled?: boolean | undefined;
    children: import("react").ReactNode;
    type?: "mask" | "warning" | "success" | "normal" | "primary" | "danger" | undefined;
    styles?: Partial<Record<import("./types").ITagStyleKeys, string | import("react").CSSProperties>> | undefined;
    theme: import("../../../muya-theme-light/types").ITheme;
} | {
    type: ITagType;
    color?: string | undefined;
    colorInverse?: boolean | undefined;
    closable?: boolean | undefined;
    hoverable?: boolean | undefined;
    visible?: boolean | undefined;
    onClose?: ((event: import("react").MouseEvent<Element, MouseEvent>) => void) | undefined;
    size?: "s" | "m" | "l" | "xl" | undefined;
    maxWidth?: number | undefined;
    shape?: "circle" | "rect" | undefined;
    disabled?: boolean | undefined;
    bordered?: boolean | undefined;
    borderColor?: string | undefined;
    children: import("react").ReactNode;
    styles?: Partial<Record<import("./types").ITagStyleKeys, string | import("react").CSSProperties>> | undefined;
    theme: import("../../../muya-theme-light/types").ITheme;
};
