export declare function arrayDel<T>(list: T[], value: T): T[];
export declare function arrayAdd<T>(list: T[], value: T): T[];
/**
 * splice一个数组，通过传入fn对删除的item进行操作，并将返回值插入该数组
 *
 * @param {T[]} list 数据源数组
 * @param {number} start
 * @param {number} end
 * @param {((items: T[]) => T | T[])} fn 对删除掉的数据进行操作的函数
 * @returns 和 Array.prototype.splice 相同
 */
export declare function arraySpliceWithFn<T>(list: T[], start: number, end: number, fn: (items: T[]) => any | any[]): T[];
