declare type IEndType = 'complete' | 'canceled';
export interface IScrollIntoViewAlignment {
    /** 0 to 1, default 0.5 (center) */
    top?: number;
    /** 0 to 1, default 0.5 (center) */
    left?: number;
    /** pixels to offset top alignment */
    topOffset?: number;
    /** pixels to offset left alignment */
    leftOffset?: number;
}
export interface IScrollIntoViewSettings {
    /**
     * 滚动时间
     */
    time: number;
    /**
     * 滚动的缓动函数
     */
    ease: (value: number) => number;
    /**
     * 校验目标是否合法
     */
    validTarget: (target: HTMLElement, parentsScrolled: number) => boolean;
    /**
     * 校验是否可滚动
     */
    isScrollable: (element: HTMLElement) => boolean;
    /**
     * 滚动对齐方式
     */
    align?: IScrollIntoViewAlignment;
    /**
     * 只滚动第一级的父容器
     **/
    onlyFirstScrollableParent?: boolean;
    /**
     * 控制平滑滚动或者直接滚动
     **/
    behavior: 'auto' | 'smooth';
    /**
     * 指定父节点
     **/
    parentNode?: HTMLElement;
}
export declare const isScrollable: (element: HTMLElement) => boolean;
export declare const findFirstScrollableParent: (targetNode: any, scrollable?: (element: HTMLElement) => boolean) => any;
export default function scrollIntoView(target: HTMLElement, settings?: Partial<IScrollIntoViewSettings>, cb?: (endType: IEndType) => void): void;
export {};
